c
c     color model translations  (HSB and RGB)
c
      subroutine initcol()
      common /ceps/ eps,eps2
      eps=0.00001
      eps2=2*eps
      return
      end

      subroutine HSVtoRGB(h,s,v,r,g,b)  ! HSV=HSB
      real h,s,v,r,g,b
      real m0
      common /ceps/ eps,eps2
      integer iverify
      r=-1
      g=-1
      b=-1
      if(iverify(v).eq.0) then
         return
      end if
      if(iverify(s).eq.0) then
         return
      end if

      if(v.le.eps2) then
         r=0
         g=0
         b=0
         return
      end if
      m0=(1-s)*v
      if(abs(v-m0).le.eps2) then
         r=v
         g=v
         b=v
         return
      end if
      call HueToRGB(m0,v,h,r,g,b)
      return
      end

      subroutine HueToRGB(m0,m2,h,r,g,b)
      real m0,m2,h,r,g,b
      call HueToRGB1(m0,m2,h,r,g,b)
      return
      end

      subroutine HueToRGB1(m0,m2,h,r,g,b)
      real m0,m2,h,r,g,b
      real mu,md,f
      integer n
      if(h.lt.0) then
         h=h+360
      end if
      n=h/60
      f=(h-n*60)/60
      n=mod(n,6)
      mu=m0+(m2-m0)*f
      md=m2-(m2-m0)*f
      if(n.eq.0) then
         r=m2
         g=mu
         b=m0
      else if(n.eq.1) then
         r=md
         g=m2
         b=m0
      else if(n.eq.2) then
         r=m0
         g=m2
         b=mu
      else if(n.eq.3) then
         r=m0
         g=md
         b=m2
      else if(n.eq.4) then
         r=mu
         g=m0
         b=m2
      else if(n.eq.5) then
         r=m2
         g=m0
         b=md
      end if
      return
      end

      subroutine HueToRGB2(m0,m2,v,h,r,g,b)
      real m0,m2,h,r,g,b
      real f,m1
      integer n
      if(h.lt.0) then
         h=h+360
      else if(h.gt.360) then
         h=h-360
      end if
      n=h/60
      if(h.lt.60) then
         f=h
      else if(h.lt.180) then
         f=h-120
      else if(h.lt.300) then
         f=h-240
      else
         f=h-360
      end if
      n=mod(n,6)
      m1=m0+abs(f/60)*(m2-m0)
      if(n.eq.0) then
         r=m2
         g=m1
         b=m0
      else if(n.eq.1) then
         r=m1
         g=m2
         b=m0
      else if(n.eq.2) then
         r=m0
         g=m2
         b=m1
      else if(n.eq.3) then
         r=m0
         g=m1
         b=m2
      else if(n.eq.4) then
         r=m1
         g=m0
         b=m2
      else if(n.eq.5) then
         r=m2
         g=m0
         b=m1
      end if
      return
      end

      subroutine HueToRGB3(m0,m2,h,r,g,b)
      real m0,m2,h,r,g,b
      real m1,f
      integer n
      if(h.lt.0) then
         h=h+360
      else if(h.gt.360) then
         h=h-360
      end if
      n=h/60
      if(h.lt.60) then
         f=h
      else if(h.lt.180) then
         f=h-120
      else if(h.lt.300) then
         f=h-240
      else
         f=h-360
      end if
      m1=m0+(m2-m0)*sqrt(abs(f/60))
      if(n.eq.0) then
         r=m2
         g=m1
         b=m0
      else if(n.eq.1) then
         r=m1
         g=m2
         b=m0
      else if(n.eq.2) then
         r=m0
         g=m2
         b=m1
      else if(n.eq.3) then
         r=m0
         g=m1
         b=m2
      else if(n.eq.4) then
         r=m1
         g=m0
         b=m2
      else if(n.eq.5) then
         r=m2
         g=m0
         b=m1
      end if
      return
      end

      subroutine RGBtoHSV(r,g,b,h,s,v)  ! HSV=HSB
      real r,g,b,h,s,v
      real m0,m2
      common /ceps/ eps,eps2
      h=0
      s=-1
      v=-1
      m0=minimum(r,g,b)
      m2=maximum(r,g,b)
      if(m2.le.eps2) then
         s=0
         v=0
         return
      end if
      v=m2
      s=(m2-m0)
      if(s.le.eps2) then
         s=0
      else
         s=s/m2
      end if
      if(s.le.eps2) then
         s=0
         return
      end if
      h=RGBtoHue(r,g,b)
      return
      end

      function RGBtoHue(r,g,b)
      real f,m0,m1,m2
      integer n
      common /ceps/ eps,eps2
      m2=maximum(r,g,b)
      m0=minimum(r,g,b)
      if(abs(m2-m0).le.eps) then
         RGBtoHue=0
         return
      end if
      m1=center(r,g,b)
      if(abs(r-m2).le.eps) then
         if(abs(b-m0).le.eps) then
            n=0
         else
            n=5
         end if
         go to 200
      end if
      if(abs(g-m2).le.eps) then
         if((b-m0).le.eps) then
            n=1
         else
            n=2
         end if
         go to 200
      end if
      if(abs(r-m0).le.eps) then
         n=3
      else
         n=4
      end if
      go to 200
 200  continue
      if(n.ne.1) then
         f=m1-m0
      else
         f=m2-m1
      end if
      f=f/(m2-m0)
      RGBtoHue=60*(n+f)
      return
      end

      real function minimum(r,g,b)
      real r,g,b
      real m
      common /ceps/ eps,eps2
      if(r.le.g) then
         m=r
      else
         m=g
      end if
      if(b.lt.m) then
         m=b
      end if
      minimum=m
      return
      end

      real function maximum(r,g,b)
      real r,g,b
      real m
      if(r.gt.g) then
         m=r
      else
         m=g
      end if
      if(b.gt.m) then
         m=b
      end if
      maximum=m
      return
      end

      real function center(r,g,b)
      real m
      if(f.lt.g.and.r.lt.b) then
         if(g.lt.b) then
            m=g
         else
            m=b
         end if
         go to 200
      end if
      if(g.lt.r.and.g.lt.b) then
         if(r.lt.b) then
            m=g
         else
            m=b
         end if
         go to 200
      end if
      if(r.lt.g) then
         m=r
      else
         m=g
      end if
      go to 200
 200  continue
      center=m
      return
      end 

      integer function iverify(v)
      real v
      common /ceps/ eps,eps2
      iverify=0
      if(v.le.-eps) then
         return
      end if
      if(v.gt.1+eps) then
         return
      end if
      if(v.le.eps) then
         v=0
      else if(v.gt.1-eps) then
         v=1
      end if
      iverify=1
      return
      end

      

