      subroutine ctoph(h)
      integer h(*)
      integer hd(6)
      character brv
c     transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then        ! primitive lattice
         return
      else if(brv.eq.'f') then   ! face centered lattice
         call ftoph(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then   ! body centered lattice
         call itoph(h,hd)
         call vcpyi(hd,h,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptoch(h)
      integer h(*)
      integer hd(6)
      character brv
c     transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then       ! primitive lattice
         return
      else if(brv.eq.'f') then  ! face centered lattice
         call ptofh(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then  ! body centered lattice
         call ptoih(h,hd)
         call vcpyi(hd,h,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ctopx(x)
      real x(*)
      real xd(6)
      character brv
c     transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then      ! primitive lattice
         return
      else if(brv.eq.'f') then ! face centered lattice
         call ftopx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then ! body centered lattice
         call itopx(x,xd)
         call vcpyr(xd,x,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptocx(x)
      real x(*)
      real xd(6)
      character brv
c     transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then      ! primitive lattice
         return
      else if(brv.eq.'f') then ! face centered lattice
         call ptofx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then ! body centered lattice
         call ptoix(x,xd)
         call vcpyr(xd,x,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ftopsmop(r,t)  ! for symmetry operators
      integer r(6,*)  ! rotation operator
      real t(*)       ! non primitive translation
      integer qm1(6,6)
      integer qm2(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in itopx
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
      call ctopsmop(qm1,qm2,r,t)
      return
      end

      subroutine ptofsmop(r,t)  ! for symmetry operators
      integer r(6,*)  ! rotation operator
      real t(*)       ! non primitive translation
      integer qm1(6,6)
      integer qm2(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in itopx
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
      call ctopsmop(qm2,qm1,r,t)
      return
      end

      subroutine ptofx(x,y)   ! for coordinates
      real x(*),y(*)
      integer qm1(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in ftopx
      data qm1 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm1(i,j)*x(j)/2
         end do
      end do
      return
      end

      subroutine ftopx(x,y)   ! for coordinates
      real x(*),y(*)
      integer qm2(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm2 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm2(i,j)*x(j)
         end do
      end do
      return
      end

      subroutine ptofh(x,y)   ! for indices
      integer x(*),y(*)
      integer qm1(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm1(j,i)
         end do
      end do
      return
      end

      subroutine ftoph(x,y)  ! for indices
      integer x(*),y(*)
      integer qm2(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm of Eq (6.6) (or qm in ftopx)
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm2(j,i)
         end do
         if(mod(y(i),2).ne.0) call quit('nonallowd reflections')
         y(i)=y(i)/2
      end do
      return
      end

      subroutine itopsmop(r,t)  ! for symmetry operators
      integer r(6,*)  ! rotation operator
      real t(*)       ! non primitive translation
      integer qm1(6,6)
      integer qm2(6,6)
      real td(6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in itopx
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
      call ctopsmop(qm1,qm2,r,t)
      return
      end

      subroutine ptoismop(r,t)  ! for symmetry operators
      integer r(6,*)  ! rotation operator
      real t(*)       ! non primitive translation
      integer qm1(6,6)
      integer qm2(6,6)
      real td(6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in itopx
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
      call ctopsmop(qm2,qm1,r,t)
      return
      end

      subroutine ctopsmop(qm1,qm2,r,t)
      integer r(6,*)  ! rotation operator
      real t(*)       ! non primitive translation
      integer qm1(6,6)
      integer qm2(6,6)
      integer qm3(6,6)
      real td(6)
c      call wtmtrxif('qm1',qm1,6,'(6i3)')
c      call wtmtrxif('qm2',qm2,6,'(6i3)')
c      call wtmtrxif('r  ',r,6,'(6i3)')
      call mtmpli6(r,qm2,qm3)
c      call wtmtrxif('qm3',qm3,6,'(6i3)')
      call mtmpli6(qm1,qm3,r)
c      call wtmtrxif('r  ',r,6,'(6i3)')
      call mtmplirmno(qm1,t,td,6,6,1)
      call vcpyr(td,t,6)
c      call wtvctrrf('t  ',t,6,'(6f10.5)')
      do i=1,6
         do j=1,6
            r(i,j)=r(i,j)/2
         end do
      end do
      call vscaler(t,0.5,t,6)
c      call wtmtrxif('r  ',r,6,'(6i3)')
c      call wtvctrrf('t  ',t,6,'(6f10.5)')
      return
      end

      subroutine ptoix(x,y)  ! for coordinates
      real x(*),y(*)
      integer qm1(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm1 / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from primitive to body-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm1(j,i)*x(j)/2
         end do
      end do
      return
      end

      subroutine itopx(x,y)  ! for coordinates
      real x(*),y(*)
      integer qm2(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in itopx
      data qm2 / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from body-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm2(j,i)*x(j)
         end do
      end do
      return
      end

      subroutine ptoih(x,y)   ! for indices
      integer x(*),y(*)
      integer qm(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm of Eq (6.6) (or qm in ftopx)
      data qm / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(i,j)
         end do
      end do
      return
      end

      subroutine itoph(x,y)  ! for indices
      integer x(*),y(*)
      integer qm(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(i,j)
         end do
         if(mod(y(i),2).ne.0) call quit('nonallowd reflections')
         y(i)=y(i)/2
      end do
      return
      end

      subroutine setsmh(isys)   ! set symilarity transformation matrix
      integer s0(6,6),t0(6,6),s1(6,6),t1(6,6),s2(6,6),t2(6,6)
      integer s3(6,6),t3(6,6)
      integer s,t
      common /csmtrh/ s(6,6),t(6,6)
*************icosahedral f or i*************
      data s0/ 1, 1, 1, 1, 1, 1,
     *         1, 1, 1,-1,-1, 1,
     *         1, 1, 1, 1,-1,-1,
     *         1,-1, 1, 1, 1,-1,
     *         1,-1,-1, 1, 1, 1,
     *         1, 1,-1,-1, 1, 1/
      data t0/-1, 1, 1, 1, 1, 1,
     *         1,-1, 1,-1,-1, 1,
     *         1, 1,-1, 1,-1,-1,
     *         1,-1, 1,-1, 1,-1,
     *         1,-1,-1, 1,-1, 1,
     *         1, 1,-1,-1, 1,-1/
***************decagonal*********************
      data s1/ 0, 0,-1,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1,-1, 0, 0, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t1/-1, 0,-1,-1, 0, 0,
     *         1, 0, 1, 0, 0, 0,
     *         0, 1, 0, 1, 0, 0,
     *        -1,-1, 0,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************octagonal*********************
      data s2/ 1, 1, 0,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t2/-1, 1, 0,-1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *         0, 1,-1, 1, 0, 0,
     *        -1, 0, 1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************dodecagonal*********************
      data s3/ 1, 0, 0,-1, 0, 0,
     *         1, 1, 0, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *         0, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t3/ 0, 1, -1, 1, 0, 0,
     *         0, 0, 1, -1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *        -1, 1,-1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      data s3/ 2, 1, 0,-1, 0, 0,
c     *         2, 2, 1, 0, 0, 0,
c     *         0, 1, 2, 2, 0, 0,
c     *        -1, 0, 1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
c      data t3/ 2,-1, 0, 1, 0, 0,
c     *        -2, 2,-1, 0, 0, 0,
c     *         0,-1, 2,-2, 0, 0,
c     *         1, 0,-1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
      if(isys.le.2) then
         call mcpyi(s0,s)
         call mcpyi(t0,t)
      else if(isys.eq.3) then
         call mcpyi(s1,s)
         call mcpyi(t1,t)
      else if(isys.eq.4) then
         call mcpyi(s2,s)
         call mcpyi(t2,t)
      else if(isys.eq.5) then
         call mcpyi(s3,s)
         call mcpyi(t3,t)
      end if
      return
      end

      subroutine setsmx(isys)
      real s,t
      common /csmtrx/ s(6,6),t(6,6)
      real s0(6,6),t0(6,6),s1(6,6),t1(6,6),s2(6,6),t2(6,6)
      real s3(6,6),t3(6,6)
*************icosahedral f or i*************
      data s0/ 1, 1, 1, 1, 1, 1,
     *         1, 1, 1,-1,-1, 1,
     *         1, 1, 1, 1,-1,-1,
     *         1,-1, 1, 1, 1,-1,
     *         1,-1,-1, 1, 1, 1,
     *         1, 1,-1,-1, 1, 1/
      data t0/-1, 1, 1, 1, 1, 1,
     *         1,-1, 1,-1,-1, 1,
     *         1, 1,-1, 1,-1,-1,
     *         1,-1, 1,-1, 1,-1,
     *         1,-1,-1, 1,-1, 1,
     *         1, 1,-1,-1, 1,-1/
***************decagonal*********************
      data s1/ 0, 0,-1,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1,-1, 0, 0, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t1/-1, 0,-1,-1, 0, 0,
     *         1, 0, 1, 0, 0, 0,
     *         0, 1, 0, 1, 0, 0,
     *        -1,-1, 0,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************octagonal*********************
      data s2/ 1, 1, 0,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t2/-1, 1, 0,-1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *         0, 1,-1, 1, 0, 0,
     *        -1, 0, 1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************dodecagonal*********************
      data s3/ 1, 0, 0,-1, 0, 0,
     *         1, 1, 0, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *         0, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t3/ 0, 1, -1, 1, 0, 0,
     *         0, 0, 1, -1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *        -1, 1,-1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      data s3/ 2, 1, 0,-1, 0, 0,
c     *         2, 2, 1, 0, 0, 0,
c     *         0, 1, 2, 2, 0, 0,
c     *        -1, 0, 1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
c      data t3/ 2,-1, 0, 1, 0, 0,
c     *        -2, 2,-1, 0, 0, 0,
c     *         0,-1, 2,-2, 0, 0,
c     *         1, 0,-1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
      if(isys.le.2) then
         call mcpy(s0,s)
         call mcpy(t0,t)
      else if(isys.eq.3) then
         call mcpy(s1,s)
         call mcpy(t1,t)
      else if(isys.eq.4) then
         call mcpy(s2,s)
         call mcpy(t2,t)
      else if(isys.eq.5) then
         call mcpy(s3,s)
         call mcpy(t3,t)
      end if
      return
      end

      subroutine smtrh(h,hd,ind)
      integer h(*),hd(*)
      integer s,t,ht(6)
      common /csmtrh/ s(6,6),t(6,6)
      call getsys(isys)
      if(ind.eq.0) then
         call vcpyi(h,hd,6)
         return
      end if
c     similarity transformation for decagonal and icosahedral
      call vcpyi(h,ht,6)
      if(ind.gt.0) then
c        ext ==> tau  int ==> tau**-1
         do n=1,ind
            do i=1,6
               hd(i)=0
               do j=1,6
                  hd(i)=hd(i)+s(i,j)*ht(j)
               end do
            end do
            if(n.ne.ind) call vcpyi(hd,ht,6)
         end do
c     only for icosahedral cases
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**ind
            end do
         end if
         return
      else if(ind.lt.0) then
c        ext ==> tau**-1  int ==> tau
          do n=1,-ind
             do i=1,6
                hd(i)=0
                do j=1,6
                   hd(i)=hd(i)+t(i,j)*ht(j)
                end do
             end do
             if(n.ne.-ind) call vcpyi(hd,ht,6)
          end do
c     only for icosahedral cases
          if(isys.le.2) then
             do j=1,6
                hd(j)=hd(j)/2**abs(ind)
             end do
          end if
          return
      end if
      end

      subroutine smtrx(h,hd,ind)
      real h(*),hd(*)
      real s,t,ht(6)
      common /csmtrx/ s(6,6),t(6,6)
      call getsys(isys)
      if(ind.eq.0) then
         call vcpyr(h,hd,6)
         return
      end if
c        similarity transformation for decagonal and icosahedral
      call vcpyr(h,ht,6)
      if(ind.gt.0) then
c        ext ==> tau  int ==> tau**-1
         do n=1,ind
            do i=1,6
               hd(i)=0
               do j=1,6
                  hd(i)=hd(i)+ht(j)*s(j,i)
               end do
            end do
            if(n.ne.ind) call vcpyr(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**ind
            end do
         end if
         return
      else if(ind.lt.0) then
c     ext ==> tau**-1  int ==> tau
         do n=1,-ind
            do i=1,6
               hd(i)=0
               do j=1,6
                  hd(i)=hd(i)+ht(j)*t(j,i)
               end do
            end do
            if(n.ne.-ind) call vcpyr(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**abs(ind)
            end do
         end if
         return
      end if
      end
