      subroutine geticent(icentd)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      icentd=icent
      return
      end

      subroutine setitt(hmax)
      integer hmax(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer itt
      common /sym1/ itt(6,48,3)  ! for mem etc.
      do js=1,3
         do i=1,nsymo
            do j=1,6
               itt(j,i,1)=tt(j,i,1)*hmax(j)+sign(0.0001,tt(j,i,1))
               itt(j,i,1)=mod(itt(j,i,1),hmax(j))
            end do
         end do
      end do
      return
      end
      
      function ihslct(ih)
      integer ih(*)
      integer os(3)
      integer h4,hd
      common /islct/ hd(6),h4(3,40),nslct
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied

      ihslct=1

      if(nslct.eq.0) return
      do ia=1,nslct
         do n=1,nsymo
            do ic=0,icent
               call gethr(ih,hd,n,ic) ! sublattice 1
               call isatel(hd,os)
               do j=1,nde
                  if(abs(os(j)-h4(j,ia)).gt.0) go to 144
               end do
               return
 144           continue
               do j=1,nde
                  if(abs(os(j)+h4(j,ia)).gt.0) go to 141
               end do
               return
 141           continue
            end do
         end do
      end do
      ihslct=0
      return
      end

      subroutine isatel(h,os)
c     order of satellite reflection
      integer h(*),os(*)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /cdim/ idm,nde,ied
      os(1)=abs(h(4))
      os(2)=abs(h(5))
      os(3)=abs(h(6))
      do isub=2,nsub
         do jd=4,idm
            j=zmtrx(jd,isub)
            if(abs(h(j)).lt.os(jd-3)) then
               os(jd-3)=abs(h(j))
            end if
         end do
      end do
      return
      end

      subroutine geticnt(icnt)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      icnt=icent
      return
      end

      subroutine getnsymo(nsymod)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      nsymod=nsymo
      return
      end

      function iextnct(h)
      integer h(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      common /cctr/ ctr(6,0:48),nctr
      complex pi2
      integer hr(6)
      complex ff
      data pi2/(0.,6.28318)/
      data eps /0.01/
c     extinction due to centering translations
      if(nctr.gt. 0) then
         do i=1,nctr
            ff=cexp(pi2*vinpir(h,ctr(1,i),idm))
            if(abs(ff-1.0).gt.eps) then
               iextnct = 1
               return
            end if
         end do
      end if
c     extinction due to screw axes or glide planes
      do i=2,nsymo
         do j=0,icent
            call gethr(h,hr,i,j)
            if(icomp(h,hr).eq.1) then
               ff=cexp(pi2*vinpir(h,tt(1,i,1),idm))
               if(abs(ff-1.0).gt.eps) then
                  iextnct = 1
                  return
               end if
            end if
         end do
      end do

      iextnct = 0
      return
      end

      subroutine symosub(nsub,iw)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /cdim/ idm,nde,ied
      do n=2,nsub
c     symmetry operators for the n-th subsystem
         do ns=1,nsymo
            call getzrz(n,rr(1,1,ns,1),rr(1,1,ns,n))
            call getzx(n,tt(1,ns,1),tt(1,ns,n))
         end do
         if(iw.eq.1) then
            write(6,*) 'substructure',n
            call wtsymo(rr(1,1,1,n),tt(1,1,n),nsymo,idm)
         end if
      end do
      return
      end

      subroutine rdsymo(na)
      common /cwflag/ iwflag(6)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /cdim/ idm,nde,ied
      dimension imps(48)
      integer rg(6,6,5)
      real tg(6,5)
      character(80) dummy
      character(30) coord
      character(80) str
      call getinp(inpu)
      call getout(iout)
      call getnsub(nsub)
c     initialozation
      call freadi('ndm=',1,nde,1)
c     call freadi('ied=',1,ied,0)
      ied=0
      call freadi('nsymo=',1,nsymo,0)
      call freadi('icent=',1,icent,0)
      call freadi('ige=',1,ige,0)
      call freadi('nctr=',1,nctr,0)

      call setndm(nde)
      if(iwflag(3).eq.1) then
         write(iout,210) nde,nsymo,icent,ige,nctr
 210     format('ndm=',i2,2x,'nsymo=',i3,2x,'icent=',
     *        i2,2x,'ige=',i2,2x,'nctr=',i2)
      end if
      call rdkvec(nde,ied)
      do k=1,6
         ctr(k,0)=0
      end do
      idm=3+nde+ied
      call setidm(idm)
      if(nctr.gt.0) then
c     read(inpu,*) 'centring translation'
         call freadc('centering translation',0,dummy,1)
         do k=1,nctr
            read(inpu,'(a)') coord
c           write(6,*) 'coord:',coord
            call decod1(coord,ctr(1,1),k)
         end do
      end if
c     read(inpu,*) 'symmetry operator'
      call freadc('symmetry operator',0,dummy,1)
      write(6,*) 'before nsymo loop'
      do k=1,nsymo
         read(inpu,'(a)') coord
         call decode(coord,rr,tt,k)
      end do
      write(6,*) 'after nsymo loop'
c*****call getri(re,ri,nsymo,y,nde)
      if(iwflag(3).eq.1) then
         if(nctr.gt.0) then
            call wtctr(ctr,nctr,idm)
         end if
         if(icent.eq.1) then
            write(iout,2022)
         else
            write(iout,2021)
         end if
         if(ige.eq.1) then
            write(iout,201) 'generating elements'
         end if
         write(iout,*)
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
         call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
         call ordr(rr,imps,nsymo,idm)
         do i=1,nsymo
            do j=1,idm
               tg(j,i)=tt(j,i,1)
               do  k=1,idm
                  rg(j,k,i)=rr(j,k,i,1)
               end do
            end do
         end do
         impt=1
         do i=1,6
            tt(i,1,1)=0.0
            do j=1,6
               rr(i,j,1,1)=0.0
               rr(i,i,1,1)=1.0
            end do
         end do
         do ns=1,nsymo
            imp=imps(ns)
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
               end do
            end do
            impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,*)
            call wtsymo(rr,tt,nsymo,idm)
         end if
      end if
 81   continue
      do n=2,nsub
         write(6,*) 'substructure',n
c     symmetry operators for the i-th subsystem
         do ns=1,nsymo
            call getzrz(n,rr(1,1,ns,1),rr(1,1,ns,n))
            call getzx(n,tt(1,ns,1),tt(1,ns,n))
         end do
         call wtsymo(rr(1,1,1,n),tt(1,1,n),nsymo,idm)
      end do
      return
 100  format(7i3)
 101  format(9i3,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(a)
 2021 format('symmetry operation',10x,'noncentrosymmetric')
 2022 format('symmetry operation',10x,'centrosymmetric')
 206  format('generating elements')
 207  format('symmetry operators generated by generating elements')
 208  format(i3,10x,24i3)
 209  format('atom',9x,'symmetry operator to be skipped =1')
 230  format(7i5)
      end

      subroutine rdkvec(nde,ied)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cctr/ ctr(6,0:48),nctr
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3,3),hj(500,3,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cwflag/ iwflag(6)
      character(2) fmt(2)
      data fmt/'in','  '/
      call getout(iout)
      call getnsub(nsub)
      do i=1,3
         ilm(i)=1
         ilc(i)=1
         icorc(i)=0
         do j=1,3
            do k=1,nsub
               y(j,i,k)=0.0
            end do
         end do
      end do

      if(nde.ge.1) then
         do nd=1,nde
            call freadrv('k=',3,y(1,nd,1),1)
c            call freadi('icorc=',1,icorc(nd),0)
c            call freadi('ilm=',1,ilm(nd),0)
         end do
      end if
      if(iwflag(3).eq.1.and.nde.ge.1) then
         write(iout,205)
      end if
      do nd=1,nde
         if(icorc(nd).eq.1) then
            ii=1                        ! incommensurate
         else if(icorc(nd).eq.0) then
            ii=2                        ! commensurate
         end if
         if(iwflag(3).eq.1) then
            write(iout,204) nd,(y(j,nd,1),j=1,3),icorc(nd),ilm(nd),
     *           fmt(ii)
         end if
      end do

      return
 204  format('wavevector k',i1,3x,3f9.6,3x,'icorc=',i3,2x
     *     ,'ilm=',i3,2x,a2,'commensurate')
 205  format('basic wavevectors')
 211  format('periods along a,b,c axes' ,3i5)
      end

      subroutine getrsts(r,t,ns,ik)
      integer r(6,6)
      real t(6)
      include "remos.inc"
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      call mcpyi(rs(1,1,ns,ik),r,6)
      call vcpyr(ts(1,ns,ik),t,6)
      return
      end

      subroutine getnss(nssd)
      integer nssd(*)
      include "remos.inc"
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      call vcpyi(nss,nssd,natom)
      return
      end

      integer function getnssik(ik)
      include "remos.inc"
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      getnssik=nss(ik)
      return
      end

      subroutine wtsitesy()
      include "remos.inc"
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      integer d1,d2
      call getna(na)
      call getidm(idm)
      d1=idm-3
      d2=3
      do n=1,na
         write(6,'(a,i3)') 'site symmetry operator for atom',n
         call wtsmop(rs(1,1,1,n),ts(1,1,n),nss(n),d1,d2)
      end do
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs,isub) 
      real mpl(*),x(6,*)
      integer isk(0:48,*),irs(0:48,*),isub(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      real rx(6)
      real rxs(6,48)
      integer rcomp
      integer rs
      real ts
      include "remos.inc"
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      real td(6)

      do 50 jk=1,na
c        write(6,*) 'x=',(x(j,jk),j=1,3)
         is=isub(jk)
c     write(6,'(a,i3)') 'isub=',is
         nsym=0
         nrx=1
         isk(nrx,jk)=1
         call savex(x(1,jk),rxs(1,nrx))
         do ic=0,icent
            do ns=1,nsymo
               call getrxjs(x(1,jk),rx,ns,ic,is)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx),is,td).eq.1) go to 120
               end do
               nrx=nrx+1        ! equivalent positions
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,jk)=ns
               else
                  isk(nrx,jk)=ns+nsymo
               end if
 120           continue
               if(rcomp(rx,x(1,jk),is,td).eq.1) then ! site symmetry op.
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,jk)=ns
                  else
                     irs(nsym,jk)=ns+nsymo
                  end if
                  if(ic.eq.0) then
                     do i=1,6
                        do j=1,6
                           rs(i,j,nsym,jk)=rr(i,j,ns,is)
                        end do
                     end do
                     do i=1,6
                        ts(i,nsym,jk)=tt(i,ns,is)+td(i)
                     end do
                  else
                     do i=1,6
                        do j=1,6
                           rs(i,j,nsym,jk)=-rr(i,j,ns,is)
                        end do
                     end do
                     do i=1,6
                        ts(i,nsym,jk)=-tt(i,ns,is)-td(i)
                     end do
                  end if
c     write(6,*) 'rs0=',((rs(i,j,nsym,jk),j=1,3),i=1,3)
               end if
            end do
         end do
c     write(6,*) 'after the symmetry operation loop'
         isk(0,jk)=nrx
         irs(0,jk)=nsym
         nss(jk)=nsym
         mpl(jk)=1
         if(icent.eq.1) then
c     compress symmetry element > nsymo
            n=0
            do 200 j=1,isk(0,jk)
               if(isk(j,jk).gt.nsymo) go to 201
               n=n+1
 200        continue
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,jk): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(jk)=float(isk(0,jk))/(float(n)*2)
            isk(0,jk)=n
         end if
 50   continue
      write(6,*) 'site symmetry group'
      do jk=1,na
         write(6,'(a,i3,a,(20i3))') 'atom',jk,'  ',
     *        (irs(j,jk),j=1,irs(0,jk))
      end do

      write(6,*) 'multiplicity  equivalent position'
      do jk=1,na
         write(6,'(a,i3,f5.1,(48i3))') 'atom',jk,mpl(jk),
     *        (isk(j,jk),j=1,isk(0,jk))
      end do
      
      return
      end

      subroutine sitesy0(na,mpl,x,isk,irs,isub) 
      real mpl(*),x(6,*)
      integer isk(0:48,*),irs(0:48,*),isub(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      real rx(6)
      real rxs(6,48)
      integer rcomp

      do 50 jk=1,na
         is=isub(jk)
         nsym=0
         nrx=1
         isk(nrx,jk)=1
         call savex(x(1,jk),rxs(1,nrx))
         do 130 ic=0,icent
            do ns=1,nsymo
               call getrxjs(x(1,jk),rx,ns,ic,is)
               do 110 irx=1,nrx
                  if(rcomp0(rx,rxs(1,irx),is).eq.1) go to 120
 110           continue
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,jk)=ns
               else
                  isk(nrx,jk)=ns+nsymo
               end if
 120           continue
               if(rcomp0(rx,x(1,jk),is).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,jk)=ns
                  else
                     irs(nsym,jk)=ns+nsymo
                  end if
               end if
            end do
 130     continue
         isk(0,jk)=nrx
         irs(0,jk)=nsym
         mpl(jk)=1
         if(icent.eq.1) then
c     compress symmetry element > nsymo
            n=0
            do 200 j=1,isk(0,jk)
               if(isk(j,jk).gt.nsymo) go to 201
               n=n+1
 200        continue
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,jk): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(jk)=float(isk(0,jk))/(float(n)*2)
            isk(0,jk)=n
         end if
 50   continue
      write(6,*) 'site symmetry group'
      do 55 jk=1,na
         write(6,'(a,i3,a,(48i3))') 'atom',jk,'  ',
     *        (irs(j,jk),j=1,irs(0,jk))
 55   continue
      write(6,*) 'multiplicity  equivalent position'
      do 56 jk=1,na
         write(6,'(a,i3,f5.1,(48i3))') 'atom',jk,mpl(jk),
     *        (isk(j,jk),j=1,isk(0,jk))
 56   continue
      return
      end

      integer function rcomp(x,rx,is,td)
      real x(*),rx(*),td(*)
      common /cdim/ idm,nde,ied
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real tt(6)
      data eps/0.00001/
      rcomp=0
      do j=0,nctr
         call getzx(is,ctr(1,j),tt)
         do i=1,3
            xx=abs(x(i)-rx(i)-tt(i))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.eps) go to 110
         end do
         do i=1,6
            td(i)=tt(i)
         end do
                                ! write(6,*) 'td=',(td(i),i=1,6)
         rcomp=1
         return
 110     continue
      end do
      return
      end

      integer function rcomp0(x,rx,is)
      real x(*),rx(*)
      common /cdim/ idm,nde,ied
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real tt(6)
      data eps/0.00001/
      rcomp0=0
      do 110 j=0,nctr
         call getzx(is,ctr(1,j),tt)
         do i=1,3
            xx=abs(x(i)-rx(i)-tt(i))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.eps) go to 110
         end do
         rcomp0=1
         return
 110  continue
      return
      end

      subroutine getrxi(x,rx,ns,ic)
      integer x(*),rx(*)
      call getrxjsi(x,rx,ns,ic,1)
      return
      end

      subroutine getrx(x,rx,ns,ic)
      real x(*),rx(*)
      call getrxjs(x,rx,ns,ic,1)
      return
      end

c     before using this call setitt(hmax)
      subroutine getrxjsi(x,rx,ns,ic,is)
      integer x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer itt
      common /sym1/ itt(6,48,3)  ! for mem etc.
      common /cdim/ idm,nde,ied
      do i=1,idm
         rx(i)=0
         do j=1,idm
            rx(i)=rx(i)+rr(i,j,ns,is)*x(j)
         end do
         rx(i)=rx(i)+itt(i,ns,is)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      call reduci(rx)           ! reduce grid points into the unit cell
      return
      end

      subroutine getrxjs(x,rx,ns,ic,is)
      real x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      do i=1,idm
         rx(i)=0
         do j=1,idm
            rx(i)=rx(i)+rr(i,j,ns,is)*x(j)
         end do
         rx(i)=rx(i)+tt(i,ns,is)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      return
      end

      subroutine getrx0(x,rx,rr,tt,ns,ic,is)
      real x(*),rx(*)
      integer rr(6,6,*)
      real tt(6,*)
      common /cdim/ idm,nde,ied
      do i=1,idm
         rx(i)=0
         do j=1,idm
            rx(i)=rx(i)+rr(i,j,ns)*x(j)
         end do
         rx(i)=rx(i)+tt(i,ns)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      return
      end

      subroutine gethr(h,hr,ns,ic)      
      integer h(*),hr(*)
      js=1
      call gethrjs(h,hr,ns,ic,js)
      return
      end

      subroutine gethrjs(h,hr,ns,ic,js)
      integer h(*),hr(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      js=1
      do i=1,idm
         hr(i)=0
         do j=1,idm
            hr(i)=hr(i)+h(j)*rr(j,i,ns,js)
         end do
         if(ic.eq.1) then
            hr(i)=-hr(i)
         end if
      end do
      do i=idm+1,6
         hr(i)=0
      end do
      return
      end

      subroutine getyl(hr,yl,js)
      integer hr(*)
      real yl(*)
      common /kwave/ y(3,3,3),vc(3)
      do j=1,3
         yl(j)=hr(j)+hr(4)*y(j,1,js)+hr(5)*y(j,2,js)+
     *        hr(6)*y(j,3,js)
      end do
      return
      end

      subroutine getvc(vcd)
      real vcd(*)
      common /kwave/ y(3,3,3),vc(3)
      do i=1,3
         vcd(i)=vc(i)
      end do
      return
      end

      subroutine gety(yd,isub)
      real yd(3,3)
      common /kwave/ y(3,3,3),vc(3)
      call mcpy3(y(1,1,isub),yd)
      return
      end
      
      function getyt(jh,ns,ic)  ! for first subsystem
      integer jh(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied      
      getyt=0
      if(ic.eq.0) then
         do i=1,idm
            getyt=getyt+jh(i)*tt(i,ns,1)
         end do
      else
         do i=1,idm
            getyt=getyt-jh(i)*tt(i,ns,1)
         end do
      end if
      getyt=mod(getyt,1.0)
c      write(6,*) 'ns,ic,getyt',ns,ic,getyt
c      call wtvctrif('jh',jh,idm,'(3i3)')
c      call wtvctrrf('tt',tt(1,ns,1),idm,'(3f10.4)')
      return
      end 

      subroutine gethrt(h,hr,ns)  ! for twin
      integer h(*),hr(*)
      integer rrt
      common /symt/ rrt(6,6,48,3),ttt(6,48,3)
      common /cdim/ idm,nde,ied
c     for twin
      do i=1,idm
         hr(i)=0
         do j=1,idm
            hr(i)=hr(i)+h(j)*rrt(j,i,ns,1)
         end do
      end do
      do i=idm+1,6
         hr(i)=0
      end do
c     for nearly-commensurate case
      call getitwn(itwin)
      if(itwin.gt.0) then
         do j=1,6
            hr(j)=hr(j)+ttt(j,ns,1)
         end do
      end if
      return
      end

      subroutine getnsyic(nsy,ic)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      nsy=nsymo
      ic=icent
      return
      end

      subroutine getnsym(nsymod)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      nsymod=nsymo
      return
      end

      subroutine fixedpnt(isub,xf)   ! fixed point for substructure
      real xf(*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      real x(6),rx(6)
      integer getitime

      do i=1,3
         inttime=getitime()
         x(i)=(rand1(inttime)-0.5) ! x,y,z for modulated crystals
      end do
      do i=4,6
         x(i)=0
      end do
      do i=1,6
         xf(i)=0
      end do
      do ns=1,nsymo
         do ic=0,icent
            call getrxjs(x,rx,ns,ic,isub)
            do i=1,6
               xf(i)=xf(i)+rx(i)/nsymo
            end do
         end do
      end do
c     write(6,*) 'isub,xf=',isub,(xf(i),i=1,idm)
      return
      end

      subroutine getnpt(ttd)    ! return nonprimitive translations
      real ttd(6,*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      do i=1,nsymo
         call vcpyr(tt(1,i,1),ttd(1,i),6)
      end do
      return
      end

      subroutine cpyhkl(h1,h2)  ! copy h1 to h2
      integer h1(*),h2(*)
      call getidm(idm)
      do i=1,idm
         h2(i)=h1(i)
      end do
      do i=idm+1,6
         h2(i)=0
      end do
      return
      end

      subroutine ctoph(h)  ! dummy subroutine for compatibility
      integer h(*)
      return
      end

      subroutine ptoch(h)  ! dummy subroutine for compatibility
      integer h(*)
      return
      end

      subroutine setidm(idmd)
      common /cdim/ idm,nde,ied
      idm=idmd
c     write(6,*) 'idm',idm
      return
      end

      subroutine getidm(idmd)
      common /cdim/ idm,nde,ied
      idmd=idm
      return
      end

      function icomp(h,hr)
      integer h(*),hr(*)
      common /cdim/ idm,nde,ied
      do i=1,idm
         if(h(i)-hr(i).ne.0) then
            icomp = 0
            return
         end if
      end do
      icomp = 1
      return
      end

      function iequiv(h,heq,neq) 
      integer h(6),heq(6,*)
c     if h is equivalent to n-th heq return n else 0
c     if h is new add it to heq and increment neq
c     therefore neq gives the multiplicity of an independent reflection
      call getidm(idm)
      iequiv=0
      do n=1,neq
         if(icomp(h,heq(1,n)).eq.1) then
c            call wtvctrif('h  =',h,6,'(6i3)')
c            call wtvctrif('heq=',heq(1,n),6,'(6i3)')
            iequiv=n
            return
         end if
      end do
c     new indices
      neq=neq+1
      if(neq.gt.120) then
         write(6,*) 'neq > 120'
         call exit(1)
      end if
      call cpyhkl(h,heq(1,neq))
      iequiv=0
      return
      end
