c
c
c
c                             fourier map
c
c     (0) inpu
c          input unit for REMOS file
c    ****if inpu=0 then****
c          filename of REMOS file
c    ****else****
c     (01) iwflag :
c     (02) file names 
c         flnm1 :  file name of Fobs (/temp/work1)          (a)
c         flnm2 :  file name parameter file                 (a)
c         flnm3 :  file name of Fcal (/temp/work2)          (a)
c         flnm4 :  file name of work file (/temp/work3)     (a)
c     (03) title
c     (04) a,b,c,cosa,cosb,cosc
c     (05) ndm,nsymo,icent,ige,nctr
c         ndm: dimension of modulation     (0<=ndm<=3)
c               for average structure ndm=0
c         nsymo: number of symmetry operators in modulated structure
c                 (1<=nsymo<=48)
c         icent=0: noncentrosymmetric, =1: centrosymmetric
c           if centrosymmetric take the origin at center of symmetry
c           and give symmetry operators in the factor group, g/i
c           ige=0: give all symmetry opeators, ige=1: give generators,
c           then all elements are created in the program
c         nctr: number of centering translations  (0<=nctr<=48)
c               nctr=0 means primitive lattice
c
c          ********if ndm=0 skip (06)-(08)********
c     (06)  a*,b*,c* components of the wave vector icorc, ilm (*)
c         if incommensurate icorc=1, commensurate icorc=0
c         ilm  number of divisions of gauss integrals in structure
c         factor formula in incommensurate cases     3<=ilm<=100
c          ******caution:  satellite with order greater than****
c          *******ilm/5 is not calculated.  This means that ****
c          *******if second order satellite intensity must be***
c          *******necessary ilm >= 10 is necessary *************
c           =========== repeat (06) ndm times ============
c
c           if all the wave vectors are incommensurate
c                          skip (07)
c **************data for the commensurate structure*********************
c *       if anyone of wave vectors is commensurate,                   *
c *   (07)  ilc   :give period along a,b,c axes
c **********************************************************************
c     (08) nw,nt,ipol
c         nw: no. of fourier terms
c         nt: upper limit of the number of sin and cos functions
c             included in a fourier term
c         ipol=1, differenciation is made in the poler coordinate
c            then give each complex amplitude of modulation waves
c            in order of re and im parts.
c           if(nctr=0) skip (08)

c         ====if(nctr=0) skip (09)
c     (09) 'centering translation'
c           in the format of I.T.
c           1/2,1/2,0,1/2  etc.
c           =========repeat (09) nctr times ========
c    (010) 'symmetry operator'
c           in the format of I.T.    (excluding 0,0,0,0,0,0)
c            for example x,y,z       etc. for ndm=0
c            for example x,y,z,t     etc. for ndm=1
c            for example x,y,z,t,u   etc. for ndm=2
c            for example x,y,z,t,u,v etc. for ndm=3
c         if ige=1 then give the order of the symmetry operator for ior
c           ======== repeat (10) nsymo times ==========
c         ****the first operator must be the identity operator****
c         ****the symmetry operator is used to classify the
c                   satellite reflections    see (36)******
c
c     (40) reflection selection variables ng
c          ng: number of reflection groups
c              =0 all reflections are selected in the refinement
c                 groups to be used in the refinement
c              reflections transformed from the indices specified
c              above by symmetry operators are used in the refinement
c              if(ng>0)   give h3+i (repeat ng times)
c
c     (41) fmin,wg0,sgn,isgn
c          fmin,wg0: see (38)
c          hm(1)-hm(6) mean the upper limits of 'miller' indices,
c          default values: hm(1)-hm(3) 24, hm(4)-hm(6) 10
c          sgn : reflections with  Io >= sgn * sigma(I) 
c                or                Fo >= sgn * sigma(F) are used
c          isgn: 0 sigma(I) 1 sigma(F)
c
c     (42) inp,iorf, format for h1,h2,.. fobs (or iobs) weight(2i2,19a4)
c          inp : 5 standard input 3: other file
c          iorf: 0 intensity 1: structure factor
c          format for h1,h2,.. fobs (or iobs) and weight
c
************end if********

c     (2) lgr: laue group: m3m,m3,4/mmm,4/m,mmm,2/m,-1,6/mmm,6/m,-3/m,-31
c                laue group (number of equivalent positions)
c            m3m(48),m3(24),4/mmm(16),4/m(8),mmm(8),2/m(4),-1(2)
c                   6/mmm(24),6/m(12),-3/m(12),-31(6)
c         when lgr=2/m,(h2>=0 or h2<=0) and (h3>=0 or h3<=0) are assumed
c         when lgr=-1, h3>=0 or h3<=0 is assumed
c
c     (3) jbc,dmgn,itwin
c         jbc: kind of map
c         (  this program only write a plane normal to a*, b* or c*.
c              to write arbitrary plane, give jbc<0 and 
c              specify transformation matrix (9') which defines
c                                   new a*,b*,c* from old ones.)
c              abs(jbc)=1  fourier map                      
c              abs(jbc)=2  fc fourier map                   
c              abs(jbc)=3  difference fourier map           
c              abs(jbc)=4  patterson map                    
c              abs(jbc)=5  fc patterson map                 
c         dmgn: magnification for electron density
c                    (for new indices if jbc<0)

c              **if jbc>0 skip (4)**
c     (4) transformation matrix for miller index itr(6,6) (18i3)
c              which is equivalent to transformation matrix for
c              unit vectors in direct space

c     (5) iax: selection of axes (iax(1)-iax(6))
c          write (electron) density in iax(1)-iax(2) plane
c     (6) xs:starting coordinate  (xs(1)-xs(6))
c           (coordinates of the map origin in the new coordinate system
c            specified at (5))
c     (7) hmw,kmw,iwmlp
c          hmw, kmw: number of points for 1-st and 2-nd axes
c               (these sould be the power of 2: 32,64,128 etc.)
c          iwmlp: 1 output map to lp
c     (8) ax,bx,coscx (length of axes in cm and cos(angle))
c           default ax,bx: a,b,c for iax=1,2,3, d=5 for iax=4
c                coscx: cosc,cosa,cosb for ax,bx=1,2;2,3;3,1
c                coscx: calculated from k1,k2,k3 for ax=a,b,c and bx=d
c     (9) xi:intervals for third to sixth coordinates (xi(1)-xi(4))
c             data for plotter
c     (10) f000,ex1,ex2,icycle
c            f000: fc at the origin
c            ex1,ex2:  1+arctan(ex2(d(x,y)*v/(f000*ex1)-1))/(pi/2)
c            icycle: number of iterations
c          *********     limitting conditions   **********
c          *               hmw*kmw<=256*128              *
c          *               hmw<=512 and kmw<=512         *
c          ***********************************************
c     (11) ldev,iw,ndiv,amgn 
c         iw=1 output calculated x,y coordinates on contour line
c         ndiv: number of divisions   (in each divisions
c                    the same interval is used)   (see (20)) 
c         amgn:  magnification for map, title, and shift
c               default iw=0,ndiv=1,ng=1,amgn=1.
c     (12) nsh: number of sheets
c     (13) ng: number of copys in a sheet
c     (14) hmin,div,lf
c         hmin: minimum hight (density) in the division
c         div : interval of hight
c         lf  : number of contour lines
c            ****** repeat (19) ndiv times *****
c     (15) shftxb,shftyb,shftxa,shftya
c          shftxb,shftyb: shifts before each copy
c          shftxa,shftya: shifts after each copy
c     (16) iwtitl,wts,angl
c         if iwtitl=1, title is written
c         wts size of letter in cm, angle is the angle
c                     from the x axis in degree
c        ******* repeat (15),(16) ns*ng times ******
c
      implicit integer (h)
      real dmgn
      common /const0/ pai2,js,dmgn
      common /cdim/ idm,nde
      character*80 title
      common /ctitle/ title
      common /cjbc/ jbc,xs(6),iax(6)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /cwght/ iwg
      common /kwave/ y(3,3,3),vc(3)
      common /cwflag/ iwflag(6)
      common /ctr/ itr(6,6)
      real xi(4)
      complex ahkl(129*129),bhkl(129*129)
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
      integer wtitl
c     common /name/ shftxb,shftyb,shftxa,shftya,wtitl,wts,angl
      integer hkln
      complex fcal
      parameter (nhm=10000)  ! should be equal to the value in remos.inc
      common /fhkl/ hkln(6,nhm),fobs(nhm),fcal(nhm),wght(nhm),im(20),
     *     is(2),extf(nhm)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real hmin(10),div(10)
      integer lf(10),isk(1,48)
      character*80 flnm0,flnm1,flnm2,flnm3, flnm4,flnm5
      character*5 lgrp(11),lgr
      integer defiwf(6)
      data iwflag/0,1,1,4,2,3/
      data lgrp/'m3m','m3','4/mmm','4/m','mmm','2/m','-1',
     *           '6/mmm','6/m','-3/m','-31'/
      data flnm5 /'scratch'/
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
      data nsub /1/

      call setinp(5)
c     read(5,'(i3)') inpu
      call freadi('inpu=',1,inpu,1)
      write(6,'(1h ,3(a,i3))') 'inpu=',inpu
      if(inpu.eq.0) then
          read(5,'(a)') flnm0
          lfn0=istrln(flnm0)
          write(6,'(1h ,a)') flnm0(1:lfn0)
          inpu=2
          open(unit=inpu,file=flnm0)
      else
          inpu=5
      end if

      call setinp(inpu)
      call setout(6)
      call setskp(1)
      call getinp(inpu)
      call getout(iout)
c (0) read output control flags
c      read(inpu,'(6i1)') (iwflag(i),i=1,6)
      call freadi('iwflag=',6,iwflag,1)
      if(iwflag(1).eq.0) then
           do 9 i=1,6
 9         iwflag(i)=defiwf(i)
      end if
      write(iout,'(1h ,a,6i3)') 'output control flags  ', iwflag
      read(inpu,'(a)') flnm1
      read(inpu,'(a)') flnm2
      read(inpu,'(a)') flnm3
      read(inpu,'(a)') flnm4
      lfn1=istrln(flnm1)
      lfn2=istrln(flnm2)
      lfn3=istrln(flnm3)
      lfn4=istrln(flnm4)
      write(iout,'(1h ,a)') flnm1(1:lfn1)
      write(iout,'(1h ,a)') flnm2(1:lfn2)
      write(iout,'(1h ,a)') flnm3(1:lfn3)
      write(iout,'(1h ,a)') flnm4(1:lfn4)
      open(unit=3,file=flnm1)
      open(unit=4,file=flnm2)

      pai2=6.28318
      call rdlc
      na=1
      call rdsymo(na,isk)
      call getgij(zmtrx,nsub)
      v=gabx(1,1)*gabx(2,2)*gabx(3,3)
      call rdiob0(1)
      call setskp(0)
      call setinp(5)
c      read(5,'(a)') lgr
      call freadc('lgr=',1,lgr,1)
c      write(6,*) 'lgr=',lgr
      iwg=0
      do  i=1,11
         if(lgr.eq.lgrp(i)) then
            iwg=i
         end if
      end do
      if(iwg.eq.0) call quit('lgr is wrong')
c      read(5,103) jbc,dmgn,itwin
      call freadi('jbc=',1,jbc,1)
      call freadr('dmgn=',1,dmgn,0)
      call freadi('itwin=',1,itwin,0)
      call setitwn(itwin)
      if(jbc.eq.0) jbc=1

c     501  continue
      if(dmgn.eq.0.) dmgn=1.
      write(6,228) jbc,dmgn,itwin

      if(jbc.lt.0) read(5,105) ((itr(i,j),j=1,6),i=1,6)
      if(jbc.lt.0) write(6,202) ((itr(i,j),j=1,6),i=1,6)

c      read(5,100) iax
      call freadi('iax=',6,iax,1)
c      read(5,104) xs
      call freadr('xs=',6,xs,1)
c      read(5,101) hmw,kmw,iwmlp
      call freadi('hmw=',1,hmw,1)
      call freadi('kmw=',1,kmw,0)
      call freadi('iwmlp=',1,iwmlp,0)
      write(6,221) iax,xs,hmw,kmw,iwmlp
      lmw=1
      lw=1
c      read(5,111) ax,bx,coscx
      call freadr('ax=',1,ax,1)
      call freadr('bx=',1,bx,0)
      call freadr('coscx=',1,coscx,0)
      write(6,223) ax,bx,coscx
c      read(5,104) xi
      call freadr('xi=',4,xi,1)
      call freadr('f000=',1,f000,1)
      call freadr('ex1=',1,ex1,0)
      call freadr('ex2=',1,ex2,0)
      call freadi('icycle=',1,icycle,0)
      write(6,203) f000,ex1,ex2,icycle
      call rdiob1(1)
c      read(5,110) ldev,iw,ndiv,ng,amgn
      call freadi('ldev=',1,ldev,1)
      call freadi('iw=',1,iw,0)
      call freadi('ndiv=',1,ndiv,0)
      call freadr('amgn=',1,amgn,0)

      write(6,224) ldev,iw,ndiv,amgn
c      read(5,100) nsh
      call freadi('nsh=',1,nsh,1)
      call setnfil(nsh)  ! ****important***
      write(6,*) 'nsh=',nsh

      js=is(1)

c     set default
      if(ax.eq.0.and.bx.eq.0) then
         call getaxbx(ax,bx,coscx)
      end if

      if(ndiv.eq.0) ndiv=1
      call freadi('ng=',1,ng,1)
      if(ng.eq.0) ng=1
      if(amgn.eq.0.) amgn=1.
      write(6,*) 'ng=',ng
c      read(5,113) (hmin(i),div(i),lf(i),i=1,ndiv)
      do 60 i=1,ndiv
          call freadr('hmin=',1,hmin(i),1)
          call freadr('div=',1,div(i),0)
          call freadi('lf=',1,lf(i),0)
          write(6,225) hmin(i),div(i),lf(i)
 60   continue
      ax=ax/float(hmw)
      bx=bx/float(kmw)
      call setxyt(ax,bx,coscx,irl)
      write(6,201)
      hm=hmw/2
      km=kmw/2
      imx=hmw
      jmx=kmw
      jb=2

      do i=1,nsh
         if(i.gt.1) then
            do j=3,6
               xs(j)=xs(j)+xi(j-2)
         end do
         end if
         write(6,'(1h ,a,4f7.3)') 'xs=',(xs(j),j=3,idm)
         call symstf(ahkl,hm,km,jb,f000)
         call ahtobh(ahkl,bhkl,hm,km)
         call mapxy(ahkl,hm,km,v,jb,iwmlp)
         call plots(0.0,0.0,ldev)
         do nc=1,ng
            call newpen(2)
c           read(5,111) shftxb,shftyb,shftxa,shftya
            call freadr('shftxb=',1,shftxb,1)
            call freadr('shftyb=',1,shftyb,0)
            call freadr('shftxa=',1,shftxa,0)
            call freadr('shftya=',1,shftya,0)
            write(6,226) shftxb,shftyb,shftxa,shftya

c           read(5,114) wtitl,wts,angl
            call freadi('iwtitl=',1,wtitl,1)
            call freadr('wts=',1,wts,0)
            call freadr('angl=',1,angl,0)
            write(6,227) wtitl,wts,angl

            wtsd=wts*amgn
            shftxb=shftxb*amgn
            shftyb=shftyb*amgn
            shftxa=shftxa*amgn
            shftya=shftya*amgn
            
            call plot(shftxb,shftyb,-3)
c           call map(hmin,div,lf,ndiv,imx,jmx,amgn,iw,ahkl,hm,km,ldev)
            iw=1  ! write title

            if(imx*jmx.gt.129*129) then
               write(6,*) 'imx,jmx',imx,jmx
               call quit('imx*jmx>129*129 in main program')
            end if
            call map01(hmin,div,lf,ndiv,iw,ahkl,imx,jmx,ldev)
            call plot(shftxa,shftya,-3)
         end do
         call plote('end of plot')
         if(ldev.eq.1) call getzap()
      end do
      call quit(' ')
      stop
 100  format(6i3)
 101  format(4i3)
 102  format(20a4)
 103  format(i6,7i3,f12.6)
 104  format(6f12.6)
 105  format(18i3)
 106  format(6i3)
 107  format(3f10.6,i3)
 110  format(4i3,f12.6)
 111  format(4f12.6)
 112  format(20a4)
 113  format(2f12.6,i3)
 114  format(i3,4f10.4)
 120  format(24i3)
 200  format(1h ,20a4)
 201  format(1h1)
 202  format(1h ,'transformation matrix for miller indices'/(1h ,6i3))
 203  format(1h ,'f000=',f10.6,3x,'ex1=',f10.6,3x,'ex2=',f10.6,3x,
     *      'icycle=',i3)
 220  format(1h ,'nslct=',i3,3x,23i3)
 221  format(1h ,'first to sixth axis in map',6i3
     *      /1h ,'coordinates of origin',6f12.6
     *     /1h ,'hmw=',i3,2x,'kmw=',i3,2x,'iwmlp=',i3)
 222  format(1h ,'number of sheets=',i3,2x,'interval of third to sixth
     *     axis',4f12.6)
 223  format(1h ,'a=',f12.6,2x,'b=',f12.6,2x,'cosc=',f12.6,2x,'sinc=',
     *                                               f12.6)
 224  format(1h ,'ldev=',i3,2x,'iw=',i3,2x,'ndiv=',i3,2x,'amgn=',f12.6)
 225  format(1h ,'hmin=',f12.6,2x,'div=',f12.6,2x,'lf=',i3)
 226  format(1h ,'shftxb=',f12.6,2x,'shftyb=',f12.6,2x,'shftxa=',
     *     f12.6,2x,'shftya=',f12.6)
 227  format(1h ,'wtitl=',i3,2x,'letter size=',f12.6,2x,'angl=',f12.6)
 228  format(1h ,'jbc=',i3,2x,2x,' dmgn=',f12.6,2x,'itwin=',i2)
      end

      function getf000() 

      subroutine symstf(ahkl,hm,km,jb,f000)
      implicit integer (h)
      common /cjbc/ jbc,xs(6),iax(6)
      real dmgn
      common /const0/ pai2,js,dmgn
c      common /atomp2/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      complex fcal
      integer hkln
      parameter (nhm=10000)  ! should be equal to the value in remos.inc
      common /fhkl/ hkln(6,nhm),fobs(nhm),fcal(nhm),wght(nhm),im(20),
     *     is(2),extf(nhm)
      common /ctr/ itr(6,6)
      common /cdim/ idm,nde
      common /islct/ hd(3),h4(3,40),nslct
      integer h(6),hr(6)
      dimension ih(6),ahkl(jb,hm,km,1),ar(4),ai(4)
      complex ahkl
      j=0
      n1=iax(1)
      n2=iax(2)
      n3=iax(3)
      do h1=1,hm
         do h2=1,km
            do i=1,jb
               ahkl(i,h1,h2,1)=(0.0,0.0)
            end do
         end do
      end do
      if(abs(jbc).eq.1.or.abs(jbc).eq.2) then
            ahkl(1,1,1,1)=cmplx(f000,0.0)
      end if
c      ir1=0
c      j=0
      do i=1,js
         j=i
         if(wght(j).eq.0.0) go to 102
c     call ihkln(ih,hkln(j))
          call vcpyi(hkln(1,j),ih,6)
**************
c     write(6,*) ih,fobs(j)
         ac=real(fcal(j))
         bc=aimag(fcal(j))
         fc=sqrt(ac**2+bc**2)
         argr=1.0
         argi=0.0
         if(fc.ne.0.0) argr=ac/fc
         if(fc.ne.0.0) argi=bc/fc
         if(abs(jbc).eq.1.or.abs(jbc).eq.6) then
c     fo fourier
            a=fobs(j)*argr
            b=fobs(j)*argi
         else if(abs(jbc).eq.2) then
c     fc fourier
            a=ac
            b=bc
         else if(abs(jbc).eq.3) then
c     difference fourier
            a=fobs(j)*argr-ac
            b=fobs(j)*argi-bc
         else if(abs(jbc).eq.4) then
c     fo patterson
            a=fobs(j)**2
            b=0.0
         else if(abs(jbc).eq.5) then
c     fc patterson
            a=ac**2+bc**2
            b=0.0
         end if
         am=fam(ih)*2.0
         do ns=1,nsymo
            do k=1,idm
               hr(k)=0
               do l=1,idm
                 hr(k)=hr(k)+ih(l)*rr(l,k,ns,1)
               end do
            end do
            yt=0
            do l=1,idm
               yt=yt+ih(l)*tt(l,ns,1)
            end do
            if(abs(jbc).eq.4.or.abs(jbc).eq.5) yt=0.0
c     axis transformaton
            if(jbc.lt.0) then
               do k=1,idm
                  h(k)=hr(k)
               end do
               do  k=1,idm
                  hr(k)=itr(k,1)*h(1)+itr(k,2)*h(2)+itr(k,3)*h(3)+
     *                 itr(k,4)*h(4)+itr(k,5)*h(5)+itr(k,6)*h(6)
               end do
            end if

            h1=abs(hr(n1))+1
            h2=abs(hr(n2))+1
            h3=1
            if(h1.gt.hm.or.h2.gt.km) go to 20
            arg=0.0
            do k=1,idm
               nn=iax(k)
               arg=arg+hr(nn)*xs(k)
            end do
            arc=(arg+yt)*pai2
            coshx=cos(arc)
            sinhx=sin(arc)
            aa=a*coshx+b*sinhx
            bb=b*coshx-a*sinhx
            do l=1,4
               ar(l)=0.0
               ai(l)=0.0
            end do
            ar(1)=aa
            ar(2)=-aa*isign(1,hr(n1))*isign(1,hr(n2))
c     ar(3)=-aa*isign(1,hr(n1))*isign(1,hr(n3))
c     ar(4)=-aa*isign(1,hr(n2))*isign(1,hr(n3))
            ai(1)=bb*isign(1,hr(n1))
            ai(2)=bb*isign(1,hr(n2))
c     ai(3)=bb*isign(1,hr(n3))
c     ai(4)=-bb*isign(1,hr(n1))*isign(1,hr(n2))*isign(1,hr(n3))
 151        continue
            ahkl(1,h1,h2,h3)=ahkl(1,h1,h2,h3)+cmplx(ar(1),ai(1))*am
            ahkl(2,h1,h2,h3)=ahkl(2,h1,h2,h3)+cmplx(ar(2),ai(2))*am
c     ahkl(3,h1,h2,h3)=ahkl(3,h1,h2,h3)+cmplx(ar(3),ai(3))*am
c     ahkl(4,h1,h2,h3)=ahkl(4,h1,h2,h3)+cmplx(ar(4),ai(4))*am
 20         continue
         end do
 102  continue
      end do
      return
      end

      subroutine mapxy(ahkl,hm,km,v,jb,iwmlp)
      implicit integer (h,x,y,z,p)
      common /cjbc/ jbc,xs(6),iax(6)
      real pai2,dmgn
      common /const0/ pai2,js,dmgn
      character*80 title
      common /ctitle/ title
      real xs,xe,ys,ye,a,b
      complex ahkl
      dimension a(513),b(513),ahkl(jb,hm,km),ia(513)
      character*12 wjob(6)
      data wjob/'fo fourier','fc fourier','dif.fourier','fo patterson',
     *     'fc patterson','prog.check'/
      v2=dmgn/(2*2*v)
      xm=hm*2
      ym=km*2
      do 13 k=1,km
c      do 13 i=1,jb
          do 10 h=1,hm
              hd=h*2-1
c              a(hd)=real(ahkl(i,h,k))
c              a(hd+1)=aimag(ahkl(i,h,k))
              a(hd)=real(ahkl(1,h,k))
              a(hd+1)=aimag(ahkl(1,h,k))
              b(hd)=aimag(ahkl(2,h,k))
              b(hd+1)=real(ahkl(2,h,k))
 10       continue
          a(1)=a(1)*2
          b(1)=b(1)*2
          a(2)=0
          b(2)=0
          call rft(a,xm,-1,icon)
          call rft(b,xm,-1,icon)
c     ******* a:dxkl(1),dxkl(2) : x odd
c     ******* b:dxkl(1),dxkl(2) : x even
          if(icon.eq.30000) go to 800
          do 11 x=1,hm
              xd=x*2-1
c              ahkl(i,x,k)=cmplx(a(xd),a(xd+1))
              ahkl(1,x,k)=cmplx(a(xd),a(xd+1))
              ahkl(2,x,k)=cmplx(b(xd),b(xd+1))
 11       continue
 13   continue
      iw=0
      do 14 x=1,hm
          do 15 k=1,km
              kd=k*2-1
              a(kd)=real(ahkl(1,x,k))*v2
              a(kd+1)=real(ahkl(2,x,k))*v2
              b(kd)=aimag(ahkl(1,x,k))*v2
              b(kd+1)=aimag(ahkl(2,x,k))*v2
 15       continue
          a(1)=a(1)*2
          b(1)=b(1)*2
          a(2)=0
          b(2)=0
c  ******* a:dxkl(1),dxkl(2) : x odd
c  ******* b:dxkl(1),dxkl(2) : x even
          call rft(a,ym,-1,icon)
          call rft(b,ym,-1,icon)
c          a: x odd  y odd and even
c          b: x even y odd and even
          if(icon.eq.30000) go to 800
c         store electron density at (x,y) to complex ahkl(i,x,y)
c         real:x odd
c         imag:x even
c         i=1 :y odd
c         i=2 :y even
          do 16 y=1,km
              yd=y*2-1
              ahkl(1,x,y)=cmplx(a(yd),b(yd))
              ahkl(2,x,y)=cmplx(a(yd+1),b(yd+1))
 16       continue
          ym1=ym+1
          a(ym1)=a(1)
          b(ym1)=b(1)
          iw=iw+1
          if(iwmlp.eq.1) write(93,rec=iw) (a(y),y=1,ym1)
          iw=iw+1
          if(iwmlp.eq.1) write(93,rec=iw) (b(y),y=1,ym1)
 14   continue
      if(iwmlp.ne.1) return
      write(93,rec=iw+1) (real(ahkl(1,1,y)),real(ahkl(2,1,y)),y=1,ym)
     *      ,real(ahkl(1,1,1))
      pm=(ym-2)/32+1
      do 31 page=1,pm
      yps=1+(page-1)*32
      ype=1+page*32
      if(page.eq.pm) ype=ym+1
      xe=xs(1)+1
      ys=xs(2)+float(yps-1)/float(ym)
      ye=xs(2)+float(ype-1)/float(ym)
      i=abs(jbc)
      write(6,203) wjob(i),title,page
      write(6,202) iax(1),xs(1),xe,iax(2),ys,ye,(iax(k),xs(k),k=3,6),
     *                                       dmgn
      xm1=xm+1
      ym1=ym+1
      iw=0
      do 30 x=1,xm1
          iw=iw+1
          read(unit=93,rec=iw) (a(y),y=1,ym1)
          do 32 y=yps,ype
 32       ia(y)=a(y)
 30   write(6,200) (ia(y),y=yps,ype)
 31   write(6,201)
      return
 800  write(6,801)
      return
 200  format(1h ,33i4)
 201  format(1h1)
 202  format(1h ,'coordinates',2x,'x(',i1,')=',f6.3,'-',f6.3,2x,'x(',
     * i1,')=',f6.3,'-',f6.3,2x,4('x(',i1,')=',f6.3,2x),'dmgn=',f9.6)
 203  format(1h ,a,5x,a,5x,' page ',i3)
 204  format(1h ,'h1m=',i3,3x,'h2m=',i3,3x,'h3m=',i3,3x,
     *   'h4m=',i3,3x,'h5m=',i3,3x,'h6m=',i3)
 801  format(1h ,'hmw, kmw, or lmw is invalid')
      end


      function fam(ih)
      common /cwght/ iwg
c      common /atomp2/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      dimension ih(6),q(3)
      data eps/1.0e-3/
      do 30 j=1,3
      q(j)=ih(j)
      do 30 i=1,nde
 30   q(j)=q(j)+y(j,i,1)*ih(3+i)
c 30   q(j)=q(j)+y(i,j)*ih(3+i)
      if(iwg.le.11) then
           do 31 j=1,3
 31        q(j)=abs(q(j))
      end if
      fam=1.0
c         iwg:laue group(number of equivalent positions)
c           1:m3m(48),2:m3(24),3:4/mmm(16),4:4/m(8),5:mmm(8),
c           6:2/m(4),7:-1(2),8:6/mmm(24),9:6/m(12),10:-3/m(12),
c          11:-31(6)
      go to (11,12,13,14,14,15,16,17,18,18,19),iwg
 11   if(abs(q(1)-q(2)).lt.eps.or.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(3)-q(1)).lt.eps.or.abs(q(1)+q(2)).lt.eps.or.
     *   abs(q(2)+q(3)).lt.eps.or.abs(q(3)+q(1)).lt.eps) fam=fam*0.5
 12   if(abs(q(1)-q(2)).lt.eps.and.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(1)+q(2)).lt.eps.and.abs(q(2)-q(3)).lt.eps.or.
     *   abs(q(1)-q(2)).lt.eps.and.abs(q(2)+q(3)).lt.eps.or.
     *   abs(q(1)+q(2)).lt.eps.and.abs(q(2)+q(3)).lt.eps)
     *   fam=fam*0.333333
      go to 14
 13   if(abs(q(1)-q(2)).lt.eps.or.abs(q(1)+q(2)).lt.eps) fam=0.5
 14   if(abs(q(1)).lt.eps) fam=fam*0.5
c    h2>=0 or h2<=0 is assumed in iwg=6
 15   if(abs(q(2)).lt.eps) fam=fam*0.5
c    h3>=0 or h3<=0 is assumed in iwg=7
 16   if(abs(q(3)).lt.eps) fam=fam*0.5
      return
 17   if(abs(q(1)-q(2)).le.eps.or.abs(q(1)+2.0*q(2)).le.eps.or.
     *   abs(2.0*q(1)+q(2)).le.eps) fam=fam*0.5
 18   if(abs(q(1)).le.eps.or.abs(q(2)).le.eps.or.abs(q(1)+q(2)).le.eps)
     *      fam=fam*0.5
 19   if(abs(q(1)).le.eps.and.abs(q(2)).le.eps) fam=fam*0.333333
      if(abs(q(3)).lt.eps) fam=fam*0.5
      return
      end

      subroutine saxis(ih)
      dimension ih(6)
      return
      end

      subroutine ahtobh(ahkl,bhkl,hm,km)
      implicit integer (h)
      complex ahkl(2,hm,km),bhkl(2,hm,km)
      do h=1,hm
         do k=1,km
            do i=1,2
               bhkl(i,h,k)=ahkl(i,h,k)
            end do
         end do
      end do
      return
      end

      subroutine phasng(ahkl,bhkl,hm,km)
      implicit integer (h)
      real iahkl,ibhkl
      complex ahkl(2,hm,km),bhkl(2,hm,km)
      do h=1,hm
         do k=1,km
            do i=1,2
               rahkl=real(ahkl(i,h,k))
               iahkl=aimag(ahkl(i,h,k))
               zahkl=sqrt(rahkl**2+iahkl**2)
               argr=1.0
               argi=0.0
               if(zahkl.ne.0.0) argr=rahkl/zahkl
               if(zahkl.ne.0.0) argi=iahkl/zahkl
               rbhkl=real(bhkl(i,h,k))
               ibhkl=aimag(bhkl(i,h,k))
               zbhkl=sqrt(rbhkl**2+ibhkl**2)
               ahkl(i,h,k)=cmplx(zbhkl*argr,zbhkl*argi)
            end do
         end do
      end do
      return
      end


c     subroutine expand(dr,cr,ex,dmin,dmax,f000,imode)
c      real cr(0:*)
c      real dr(0:*)
c     call expand1(dr,cr,ex,dmin,dmax,f000,imode)  ! from qcmem.f
c      call expand2(dr,cr,ex,dmin,dmax,f000,imode)  ! from mem.f
c      return
c      end

      subroutine expand1(dr,cr,ex,dmin,dmax,f000,imode)  ! from qcmem.f
      real cr(0:*)
      real dr(0:*)
      real*8 sum
      integer getnt
c      write(6,*) 'enter expand'
      eps=f000/1000
      nt=getnt()
      vol=getvol()
      if(imode.eq.2) then
         ddd=sqrt(dmax)
      end if
      sum=0
      dmin=cr(0)
      dmax=cr(0)
      if(imode.eq.1) then
         do i=0,nt-1
            tmp=cr(i)
            ddd=sqrt(tmp)+eps
            dr(i)=tmp*exp(ex*dr(i)/ddd)
            dmin=min(tmp,dmin)
            dmax=max(tmp,dmax)
            sum=sum+dr(i)
         end do
      else if(imode.eq.2) then
         do i=0,nt-1
            tmp=cr(i)
            dr(i)=tmp*exp(ex*dr(i)/ddd)
            dmin=min(tmp,dmin)
            dmax=max(tmp,dmax)
            sum=sum+dr(i)
         end do
      end if
      if(abs(dmin-dmax).lt.eps) then
c        write(6,*) 'f000=',f000,' dmin,dmax,nt',dmin,dmax,nt
c        call quit('|dmin-dmax| < eps ')
      end if
      return
      end

      subroutine expand2(dr,cr,ex,dmin,dmax,f000,imode) ! from mem.f
      real cr(0:*)
      real dr(0:*)
      real*8 sum
      integer getnt
      nt=getnt()
      vol=getvol()
c      write(6,*) 'nt,vol,imode,f000=',nt,vol,imode,f000
      eps=f000/1000
      if(imode.eq.2) ddd=sqrt(dmax)
      sum=0
      dmin=cr(0)
      dmax=cr(0)
      if(imode.eq.1) then
         do i=0,nt-1
            tmp=cr(i)
            ddd=sqrt(tmp)+eps
            dr(i)=tmp*exp(ex*dr(i)/ddd)
            dmin=min(tmp,dmin)
            dmax=max(tmp,dmax)
            sum=sum+dr(i)
         end do
      else if(imode.eq.2) then
         do i=0,nt-1
            tmp=cr(i)
            dr(i)=tmp*exp(ex*dr(i)/ddd)
            dmin=min(tmp,dmin)
            dmax=max(tmp,dmax)
            sum=sum+dr(i)
         end do
      end if
      if(abs(dmin-dmax).lt.eps) then
c         write(6,*) 'dmin,dmax,nt',dmin,dmax,nt
c        write(6,*) 'f000=',f000,' dmin,dmax,nt',dmin,dmax,nt
c         call quit('|dmin-dmax| < eps ')
      end if
      return
      end

      subroutine expand(ahkl,hm,km,f000,v,ex2,dmgn)
      implicit integer (h)
      real iahkl,dmgn
      complex ahkl(2,hm,km)
      fex(x)=1.0+atan(ex2*(x-1))/1.5707  ! function
      avdnst=f000*ex1*dmgn/v
      do h=1,hm
         do k=1,km
            do i=1,2
               rahkl=real(ahkl(i,h,k))
               iahkl=aimag(ahkl(i,h,k))
               rahkl=fex(rahkl/avdnst)
               iahkl=fex(iahkl/avdnst)
               ahkl(i,h,k)=cmplx(rahkl,iahkl)
            end do
         end do
      end do
      return
      end

      subroutine ihkln(ih,hkln)
      integer ih(6),hkln,hm
      common /chkln/ iex(6),hm(6)
      ih(1)=hkln/iex(1)-hm(1)
      do i=2,6
         ih(i)=mod(hkln,iex(i-1))/iex(i)-hm(i)
      end do
      return
      end


      subroutine maphk(ahkl,hm,km,v,jb)
      implicit integer (h,x,y,z,p)
      common /cjbc/ jbc,xs(6),iax(6)
      real dmgn
      common /const0/ pai2,js,dmgn
      character*80 title
      common /ctitle/ title
      real xs,a,b
      character*12 wjob(6)
      complex ahkl
      dimension a(513),b(513),ahkl(jb,hm,km)
      data wjob/'fo fourier','fc fourier','dif.fourier','fo patterson',
     *      'fc patterson','prog.check'/
      xm=hm*2
      ym=km*2
      v2=v/(xm*ym*dmgn)
      do y=1,km
         do x=1,hm
            xd=x*2-1
            a(xd)=real(ahkl(1,x,y))
            a(xd+1)=aimag(ahkl(1,x,y))
            b(xd)=real(ahkl(2,x,y))
            b(xd+1)=aimag(ahkl(2,x,y))
         end do
         call rft(a,xm,1,icon)
         call rft(b,xm,1,icon)
         if(icon.eq.30000) go to 800
         do h=1,hm
            hd=h*2-1
            ahkl(1,h,y)=cmplx(a(hd),a(hd+1))
            ahkl(2,h,y)=cmplx(b(hd),b(hd+1))
         end do
      end do
      iw=0
      do h=1,hm
         do y=1,km
            yd=y*2-1
            a(yd)=real(ahkl(1,h,y))*v2
            a(yd+1)=real(ahkl(2,h,y))*v2
            b(yd)=aimag(ahkl(1,h,y))*v2
            b(yd+1)=aimag(ahkl(2,h,y))*v2
         end do
         call rft(a,ym,1,icon)
         call rft(b,ym,1,icon)
         if(icon.eq.30000) go to 800
         do k=1,km
            kd=k*2-1
            fct=1.0
            if(h.eq.1) fct=fct/2.0
            if(k.eq.1) fct=fct/2.0
            ahkl(1,h,k)=cmplx(a(kd),b(kd))*fct
            ahkl(2,h,k)=cmplx(b(kd+1),a(kd+1))*fct
         end do
      end do
      return
 800  write(6,801)
      return
 801  format(1h ,'hmw, kmw, or lmw is invalid')
      end

      subroutine rdiob0(iwght)
      common /cwflag/ iwflag(6)
      integer hkln
      complex fcal
      parameter (nhm=10000)  ! should be equal to the value in remos.inc
      common /fhkl/ hkln(6,nhm),fobs(nhm),fcal(nhm),wght(nhm),im(20),
     *     is(2),extf(nhm)
      common /cdim/ idm,nde
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer nslct,ih(6),hm
      integer h4,hd
      common /islct/ hd(3),h4(3,40),nslct
      common /filen/ flfobs,flfcal
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4
      common /cjbc/ jbc,xs(6),iax(6)
      character*80 fmt
      common /crdiob/ fmin, wg0,inp,iorf,fmt
      character*26 flfobs,flfcal
      common /chkln/ iex(6),hm(6)
      call getinp(inpu)
      call getout(iout)

c     read(inpu,103) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      call freadi('ng=',1,nslct,1)
      do i=1,nslct
         call freadi('h3+i=',nde,h4(1,i),1)
      end do
      if(iwflag(3).eq.1) then
         write(iout,'(a,i3,a,20i3)') ' ngr=',nslct,' h3+i=',
     *        ((h4(i,j),i=1,nde),j=1,nslct)
      end if
      if(nde.eq.3) go to 211
      j=nde+1
      do k=1,nslct
         do i=j,3
            h4(i,k)=0
         end do
      end do
 211  continue
c     read(inpu,105) fmin,wg0,sgn,isgn
      call freadr('fmin=',1,fmin,1)
      call freadr('wg0=',1,wg0,0)
      call freadr('sgn=',1,sgn,0)
      call freadi('isgn=',1,isgn,0)
      if(iwflag(3).eq.1) then
           write(iout,*) 'fmin=',fmin,' wg0=',wg0,' sgn=',sgn,
     *        ' isgn=',isgn
      end if
c      read(inpu,100) inp,iorf,fmt
      call freadi('inp=',1,inp,1)
      call freadi('iorf=',1,iorf,0)
      call freadc('format=',1,fmt,0)
      if(iwflag(3).eq.1) then
           write(iout,202) inp,iorf,fmt
      end if
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i3)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5)
 201  format(1h ,'fmin=',f12.6,3x,'wg0=',f12.6)
 202  format(1h ,'inp=',i3,3x,'iorf=',i3,3x,'format=',a)
      end

      subroutine rdiob1(iwght)
      common /cwflag/ iwflag(6)
      integer hkln
      complex fcal
      parameter (nhm=10000)  ! should be equal to the value in remos.inc
      common /fhkl/ hkln(6,nhm),fobs(nhm),fcal(nhm),wght(nhm),im(20),
     *     is(2),extf(nhm)
      common /cdim/ idm,nde
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent

      integer nslct,ih(6),hm
      integer h4,hd
      common /islct/ hd(3),h4(3,40),nslct

      common /filen/ flfobs,flfcal
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4
      common /cjbc/ jbc,xs(6),iax(6)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      character*26 flfobs,flfcal
      character*80 fmt
      common /crdiob/ fmin, wg0,inp,iorf,fmt
      common /chkln/ iex(6),hm(6)

      real foind(nhm),woind(nhm)
      real sigmf(nhm)
      integer hind(6,nhm)

      integer imd(0:20),ind(0:20)

      call getinp(inpu)
      call getout(iout)

      write(6,*) 'jbc=',jbc

      i=0
      is(1)=0
      is(2)=0
      sf=0.0
      iw1=0
      if(inp.ne.5) rewind 3

c****** read at least once even if nds=0 ******
      inde=max(1,nds)
c      write(6,*) 'nds,inde=',nds,inde
c*******************************
      write(6,*) 'reflections rejected by extinction rules'
      do 11 inds=1,inde
         ii=0

 10      continue
         ih(4)=0
         ih(5)=0
         ih(6)=0
         if(inp.eq.5) read(inpu,fmt,end=11) (ih(j),j=1,idm),aiobs,wg
         if(inp.ne.5) read(3,fmt,end=11) (ih(j),j=1,idm),aiobs,wg
         if(iwght.eq.1) then
            wg=1.
         end if
         if(ih(1).eq.999) go to 11
         iabsn=0
         if(itwin.eq.0) then
            iext=iextnct(ih)
            if(iext.eq.1) then
               if(idm.eq.3) then
                  write(6,'(3i4,2f10.2)') (ih(j),j=1,idm),aiobs,wg
               else if(idm.eq.4) then
                  write(6,'(4i4,2f10.2)') (ih(j),j=1,idm),aiobs,wg
               else if(idm.eq.5) then
                  write(6,'(5i4,2f10.2)') (ih(j),j=1,idm),aiobs,wg
               else if(idm.eq.6) then
                  write(6,'(6i4,2f10.2)') (ih(j),j=1,idm),aiobs,wg
               end if
               go to 10
            end if
         end if
         if(nslct.gt.0) then
            if(ihslct(ih).eq.1) then
               go to 510
            else
               go to 10
            end if
         end if
 510     continue
         ii=ii+1
         i=i+1
         is(1)=is(1)+1
         im(inds)=ii

         do j=1,6
            hkln(j,i)=ih(j)
         end do
         if(iwght.eq.2) then
            if(iorf.eq.1) then
               fobs(i)=aiobs
               sigmf(i)=wg
            else if(iorf.eq.0) then
               fobs(i)=sqrt(aiobs)
               sigmf(i)=sqrt(aiobs+wg)-sqrt(aiobs)
            else
               call quit('invalid iorf')
            end if
         else
            if(iorf.eq.1) then
               fobs(i)=aiobs
               sigmf(i)=wg
            else if(iorf.eq.0) then
               fobs(i)=sqrt(aiobs)
               sigmf(i)=wg
            end if
         end if
         go to 10
 11   continue

      if(inp.ne.5) then
         close(unit=3)
      end if
      close(unit=91)

      write(6,*) 'number of observed reflections',is(1)

c      write(6,*) 'im=',(im(j),j=1,inde)

      imd(0)=0
      ind(0)=0
      do inds=1,inde
         imd(inds)=im(inds)
      end do

      iweq=0
c      iweq=1
      nfobs=0
      if(itwin.eq.0) then
         k=1
         l=1
         do inds=1,inde
            nfob=imd(inds)
            k=k+imd(inds-1)
            l=l+ind(inds-1)
            write(6,*) 'k,l,nfob=',k,l,nfob
            call average(nfob,hkln(1,k),fobs(k),sigmf(k),sgn,isgn,
     *           nind,hind(1,l),foind(l),woind(l),iweq,iwght)
            ind(inds)=nind
            nfobs = nfobs+nind
         end do
c         write(6,*) 'ind=',(ind(j),j=1,inde)

         is(1)=nfobs
         is(2)=0
         do inds=1,inde
            im(inds)=ind(inds)
         end do
      else
         do inds=1,inde
            nfobs = nfobs+im(inds)
         end do
         is(1)=nfobs
         is(2)=0
      end if

      do i=1,nfobs
         if(itwin.eq.0) then
            call vcpyi(hind(1,i),hkln(1,i),idm)
            fobs(i)=foind(i)
            wght(i)=wghtf(fobs(i),woind(i),iwght,fmin,woind(i),wg0)
         else
            wght(i)=wghtf(fobs(i),sigmf(i),iwght,fmin,sigmf(i),wg0)
         end if
         write(91,*) (hkln(k,i),k=1,6),fobs(i),wght(i)
c         write(6,*) (hkln(k,i),k=1,idm),fobs(i),wght(i)
         if(wght(i).ne.0.0) is(2)=is(2)+1
      end do

      if(iwflag(3).eq.1) then
           write(iout,200) is(1),is(2)
      end if

      idm=3+nde

      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i3)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5)
 201  format(1h ,'fmin=',f12.6,3x,'wg0=',f12.6)
 202  format(1h ,'inp=',i3,3x,'iorf=',i3,3x,'format=',a)
      end

c           call map01(hmin,div,lf,ndiv,iw,ahkl,imx,jmx,ldev)
      subroutine map01(hmin,div,lf,ndiv,iw,xy,ixm,iym,ldev)
      dimension hmin(*),div(*),lf(*)
      real xy(0:ixm,0:iym)
      real a(5000),b(5000)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,ws,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
c     character*80 title, coord, cmap, tmap, hight
      character*80 title,cmap
      common /ctitle/ title
      dimension xb(7),yb(7)
      common /cdim/ idm,nde
      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2,xdiv,ydiv

c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ixm,iym : size of to dimensional array xy (number of points)
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             ixm and iym, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c             call plots(0.0,0.0,ldev)

c         shift before plot
          call plot(shftxb,shftyb,-3)
          call newpen(2)
      np=32
      do 80 i=0,79
          j=80-i
          if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
      cmap='MEM map'

c     plot boundary
      xb(1)=xmin
      yb(1)=ymin
      xb(2)=xmax
      yb(2)=ymin
      xb(3)=xmax
      yb(3)=ymax
      xb(4)=ymin
      yb(4)=ymax
      xb(5)=xmin
      yb(5)=ymin
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
      if(icase.gt.0) then
c         coordinates on a contour line
          ibtm=0
          do 10 nd=1,ndiv
          le=lf(nd)
          do 10 l=1,le
c            al: hight
             al=hmin(nd)+div(nd)*float(l-1)
             fx=(xmax-xmin)/ixm
             fy=(ymax-ymin)/iym
             call contpl(xy(0,0),al,1,ixm+1,1,iym+1,xmin,ymin,fx,fy,
     *            icon)
             if(icon.eq.1) then
                if(ibtm.eq.1) go to 30
             end if
             if(icon.eq.0) then
                if(ibtm.eq.0) ibtm=1
             end if
 10       continue
 30       continue
      end if
      return
      end

c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,xmin,ymin,fx,fy)                      *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl(h,al,is,ie,js,je,xmin,ymin,fx,fy,icon)
      parameter (ndata=20000)
c     real hh(ie,je),p(2,ndata)
      real h(ie,je),p(2,ndata)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
c     yy(t)=edge*sinphi-t

c *** find points to form contour line of height h
      icon=0
      call contpn(h,al,is,ie,js,je)
      if(n.le.0) then
         icon=1
         return
      end if
      if(n.gt.ndata) call quit('n > ndata') 
      im=1 
      in=n 
      ib=1 
c  select first point to start contour line 
   10 continue 
 100  continue
      j=-1
      jb=0
   15 imm=im 
      inn=in
   20 continue
      do 30 i1=imm,inn 
      ib=bndry(i1,is,ie,js,je)
      if(ib.ne.0) goto 40 
   30 continue
      if(jb.eq.1) then
      jb=2
      goto 15
      endif
      i1=imm
   40 continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0 
c  search next (second) point 
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1.and.jb.le.1) then
      jb=1 
      goto 20
      endif
      j=0 
c  evaluate first point coordinate 
      call exchng(i0,im,in,j,fx,fy) 
c  store first point location 
      ist=i0 
   50 continue 
c  evaluate next point coordinate 
      call exchng(i1,im,in,j,fx,fy) 
c  check if terminal point 
      ib=bndry(i1,is,ie,js,je) 
      if(im.gt.in) goto 60 
      if(ib.ne. 0) goto 70 
c  search next point 
      call search(ib,i0,i1,im,in,np) 
      if(np.ne. 0) goto 50 
   60 continue 
c  check if terminal point is connected to first point 
      call search(ib,i0,i1,ist,ist,np) 
      if(np.eq.1) then
      j=-j 
      call exchng(i1,im,in,j,fx,fy)
      endif
   70 continue 

c *** plot found contour line
      do 80 i=1,j
          p(1,i)=x(i)+xmin
          p(2,i)=y(i)+ymin
   80 continue

      call smooth(p,j,x,y,npoint)
      call getcas(icase)
      if(abs(icase).le.8) then
          call abtoxy(x(1),y(1),npoint)
      end if
      if(al.gt.0.0) then
          call clin(x,y,npoint,1,0.1)
      else if(al.eq.0.0) then
          call clin(x,y,npoint,2,0.1)
      else if(al.lt.0.0) then
          call clin(x,y,npoint,3,0.1)
      end if
      if(im.lt.in) goto 10
      end

c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,xmin,ymin,fx,fy)                      *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl0(h,al,is,ie,js,je,xmin,ymin,fx,fy,icon)
      parameter (ndata=20000)
c     real hh(ie,je),p(2,ndata)
      real h(ie,je),p(2,ndata)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
c     yy(t)=edge*sinphi-t

c *** find points to form contour line of height h
      icon=0
      call contpn(h,al,is,ie,js,je)
      if(n.le.0) then
         icon=1
         return
      end if
      if(n.gt.ndata) call quit('n > ndata') 
      im=1 
      in=n 
      ib=1 
c  select first point to start contour line 
   10 continue 
      j=-1
      jb=0
   15 imm=im 
      inn=in
   20 continue
      do 30 i1=imm,inn 
      ib=bndry(i1,is,ie,js,je)
      if(ib.ne.0) goto 40 
   30 continue
      if(jb.eq.1) then
      jb=2
      goto 15
      endif
      i1=imm
   40 continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0 
c  search next (second) point 
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1.and.jb.le.1) then
      jb=1 
      goto 20
      endif
      j=0 
c  evaluate first point coordinate 
      call exchng(i0,im,in,j,fx,fy) 
c  store first point location 
      ist=i0 
   50 continue 
c  evaluate next point coordinate 
      call exchng(i1,im,in,j,fx,fy) 
c  check if terminal point 
      ib=bndry(i1,is,ie,js,je) 
      if(im.gt.in) goto 60 
      if(ib.ne. 0) goto 70 
c  search next point 
      call search(ib,i0,i1,im,in,np) 
      if(np.ne. 0) goto 50 
   60 continue 
c  check if terminal point is connected to first point 
      call search(ib,i0,i1,ist,ist,np) 
      if(np.eq.1) then
      j=-j 
      call exchng(i1,im,in,j,fx,fy)
      endif
   70 continue 

c *** plot found contour line
      do 80 i=1,j
          p(1,i)=x(i)+xmin
          p(2,i)=y(i)+ymin
   80 continue
      call smooth(p,j,x,y,npoint)

      call getcas(icase)
      if(abs(icase).le.8) then
          call abtoxy(x(1),y(1),npoint)
      end if

      if(al.gt.0.0) then
          call clin(x,y,npoint,1,0.1)
      else if(al.eq.0.0) then
          call clin(x,y,npoint,2,0.1)
      else if(al.lt.0.0) then
          call clin(x,y,npoint,3,0.1)
      end if
      if(im.lt.in) goto 10
      end

************************************************************************

c s.contpn: find contour points (max:225x73)
c
c     (a,ia): coordinate data of contour points
c             (x,iy): for y-axes data (m points)
c             (y,ix): for x-axes data (n-m points)
c
      subroutine contpn(hh,h,i1,i2,j1,j2)
      real hh(i2,j2)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     common /origin/i0,j0
*     set the origin (1988.7.1)
      data i0,j0/0,0/

      m=0
      do 10 j=j1-j0,j2-j0
      do 10 i=i1-i0,i2-i0-1
      if((hh(i,j)-h)*(hh(i+1,j)-h).gt.0.) goto 10
      if(hh(i,j).ge.h.and.hh(i+1,j).ge.h) goto 10
      m=m+1
      d=(hh(i,j)-h)/(hh(i,j)-hh(i+1,j))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
*     a(m)=i+i0+d
      a(m)=float(i)+float(i0)+d
      ia(m)=j+j0
c  20 continue
   10 continue
      n=m
      do 40 i=i1-i0,i2-i0
      do 40 j=j1-j0,j2-j0-1
      if((hh(i,j)-h)*(hh(i,j+1)-h).gt.0.) goto 40
      if(hh(i,j).ge.h.and.hh(i,j+1).ge.h) goto 40
      n=n+1
      if(n.gt.ndata*10) goto 90
      d=(hh(i,j)-h)/(hh(i,j)-hh(i,j+1))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
      a(n)=float(j)+float(j0)+d
      ia(n)=i+i0
c  50 continue
   40 continue
*     display(10,1010,line=14) h,i1,i2,j1,j2,m,n
      write(6,1010) h,i1,i2,j1,j2,m,n
 1010 format(' h=',f7.1,' (',2i4,') (',2i4,') m=',i4,' n=',i4)
      return
 90   continue
*     display(10,1020,line=14) h,i1,i2,j1,j2
      write(6,1020) h,i1,i2,j1,j2
 1020 format(' h=',f7.1,' (',2i4,')  (',2i4,') overflow')
      return
      end

************************************************************************

c s.bndry : support contplt routine
c     check if boundary point
      function bndry(i,is,ie,js,je)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      bndry=0
      if(i.le.m) then
      if(ia(i).eq.js) bndry=1
      if(ia(i).eq.je) bndry=-1
      else
      if(ia(i).eq.is) bndry=1
      if(ia(i).eq.ie) bndry=-1
      endif
      return
      end

************************************************************************

c s.exchng : support contplt routine
c     replace data in (a,ia) array for contour plot
c
      subroutine exchng(i,im,in,j,fx,fy)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      if(j.eq.-1) goto 10
      ib=1
      if(j.le.-2) then
      ib=-1
      j=-j
      endif
      j=j+1
      if(i.le.m) then
      x(j)=(a(i)-1.)*fx
      y(j)=(ia(i)-1)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),a(i),float(ia(i)),fx,fy
      else
      x(j)=(ia(i)-1)*fx
      y(j)=(a(i)-1.)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),float(ia(i)),a(i),fx,fy
      endif
      if(ib.eq.-1) return
   10 continue
      if(i.le.m) ib=im
      if(i.gt.m) ib=in
      buf=a(ib)
      a(ib)=a(i)
      a(i)=buf
      ibuf=ia(ib)
      ia(ib)=ia(i)
      ia(i)=ibuf
      i=ib
      if(i.le.m) im=im+1
      if(i.gt.m) in=in-1
      return
      end

************************************************************************

c s.search : support contplt routine
c     search 'next' point
c
      subroutine search(ib,i0,i1,im,in,np)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      dimension ik(3)
      ixy1=a(i1)
      iyx1=ia(i1)
      if(i0.le.0) goto 10
      if(i0.le.m) then
       x0=a(i0)
       ix0=x0
       iy0=ia(i0)
       y0=iy0
      else
       ix0=ia(i0)
       x0=ix0
       y0=a(i0)
       iy0=y0
      endif
      if(i1.le.m) then
       ib=iyx1-iy0
       x1=a(i1)
       y1=iyx1
      else
       ib=iyx1-ix0
       x1=iyx1
       y1=a(i1)
      endif
   10 continue
      if(ib.le.0) ib=-1
      if(ib.gt.0) ib=0
      k=0
      do 20 i=im,in
      if(i.eq.i1) goto 20
      if(i1.le.m.and.i.le.m) goto 20
      if(i1.gt.m.and.i.gt.m) goto 20
      if(ifix(a(i)).ne.iyx1+ib) goto 20
      if(.not.(ia(i).eq.ixy1.or.ia(i).eq.ixy1+1)) goto 20
      k=k+1
      ik(k)=i
   20 continue
      if(ib.eq.0) ib=1
      do 30 i=im,in
      if(i1.le.m.and.i.gt.m) goto 30
      if(i1.gt.m.and.i.le.m) goto 30
      if(ia(i).ne.iyx1+ib) goto 30
      if(ifix(a(i)).ne.ixy1) goto 30
      k=k+1
      ik(k)=i
   30 continue
      np=k
      if(np.eq.0) return
      if(np.eq.1) then
       i0=i1
       i1=ik(1)
       return
      endif
      d1=(x1-x0)**2+(y1-y0)**2
      tmin=10.
      do 40 k=1,np
      i=ik(k)
      if(i.le.m) then
       if(i1.le.m) goto 40
       x2=a(i)
       y2=ia(i)
      else
       if(i1.gt.m) goto 40
       x2=ia(i)
       y2=a(i)
      endif
      d=(x2-x1)**2+(y2-y1)**2
      d2=(x2-x0)**2+(y2-y0)**2
      t=(d1+d-d2)/sqrt(d*d1)
      if(t.ge.tmin) goto 40
       imin=i
       tmin=t
   40 continue
   50 continue
      i0=i1
      i1=imin
      return
      end

      subroutine getcas(ic)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      ic=icase
      return
      end

      subroutine getplt(iplt)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      iplt=iplot
      return
      end

      subroutine smooth(p,n,x,y,npoint)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),x(*),y(*)

      iz=3
      call spline(p,n,iz,rslt,npoint)
      do 10 i=1,npoint
         x(i)=rslt(1,i)
         y(i)=rslt(2,i)
   10 continue
      end

************************************************************************

      subroutine spline(p,n,iz,rslt,npoint)
**    input data
*             p: coordinates of points
*             n: number of data
*            iz: number of interpolated points
**    output data
*          rslt: coordinates of total points
*        npoint: number of total points

      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),pi(is),pe(is)
c      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

*     corrected (iz in the original program = number of interpolated
*     points + 1)
      iz2=iz+1
      ic1=1
      ic2=1
*     pi and pe is not used in the present program because ic1=ic2=1
*     input pi here if ic1=2
*     input pe here if ic2=2
      call endpnt(p,n,ic1,ic2,pi,pe)
      call gauss(p,n)
      call curgen(p,n,iz2,rslt)
      npoint=(n-1)*iz2+1
      end

************************************************************************

      subroutine endpnt(p,n,ic1,ic2,pi,pe)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),pi(is),pe(is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      if (ic1 .eq. 1) then
         a(1,2)=1.0
         a(1,3)=0.5
      else
         a(1,2)=1.0
         a(1,3)=0.0
         do 10 k=1,is
            b(k,1)=pi(k)
            u(k,1)=pi(k)
   10    continue
      end if

      do 30 k=1,n-1
         xd=0.0
         do 20 j=1,is
            xd=xd+(p(j,k+1)-p(j,k))*(p(j,k+1)-p(j,k))
   20    continue
         xl(k)=sqrt(xd)
   30 continue
      if (ic1 .ne. 2) then
         do 40 k=1,is
            b(k,1)=(3.0/(2.0*xl(1)))*(p(k,2)-p(k,1))
   40    continue
      end if
      if (ic2 .eq. 1) then
         a(n,1)=1.0
         a(n,2)=2.0
         do 50 k=1,is
            b(k,n)=(3.0/xl(n-1))*(p(k,n)-p(k,n-1))
   50    continue
      else
         a(n,1)=0.0
         a(n,2)=1.0
         do 60 k=1,is
            b(k,n)=pe(k)
            u(k,n)=pe(k)
   60    continue
      end if
      end

      subroutine map(hmin,div,lf,ndiv,im,jm,amgn,iw,ahkl,ih,ik,ldev)
      dimension hmin(*),div(*),lf(*)
      real a(2000),b(2000)
      dimension ahkl(2,2,ih,ik)
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,wts,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
c     common /name/ shftxb,shftyb,shftxa,shftya,wtitl,wts,angl
      character*80 title, coord, cmap, tmap, hight
      common /ctitle/ title
      dimension ar(500),br(500),xb(7),yb(7)
      common /cdim/ idm,nde
c
c
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv(i): number of ranges
c     im  : number of lattice points along x-axis
c     jm  : number of lattice points along y-axis
c     a,b : work array to store the x,y coordinates on a contour line
c     ahkl(i,j): hight of the function at the lattice point (i,j)
c     ih,jh : size of to dimensional array ahkl
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             im and jm, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c
      np=16
c
      do 80 i=0,79
          j=80-i
          if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
      if(abs(jbc).eq.1) then
          cmap='Fo Fourier  '
      else if(abs(jbc).eq.2) then
          cmap='Fc Fourier  '
      else if(abs(jbc).eq.3) then
          cmap='D-Fourier   '
      else if(abs(jbc).eq.4) then
          cmap='Fo Patterson'
      else if(abs(jbc).eq.5) then
          cmap='Fc Patterson'
      end if
      write(coord,'(a,4f7.3)') 'z=',(xs(j),j=3,idm)

      dlm=2.001
c     bim=float(im-1)
c     ajm=float(jm-1)
      bim=float(im)
      ajm=float(jm)
      wtsd=wts*amgn
c
c     plot boundary
      xb(1)=0.0
      yb(1)=0.0
      xb(2)=bim*amgn
      yb(2)=0.0
      xb(3)=bim*amgn
      yb(3)=ajm*amgn
      xb(4)=0.0
      yb(4)=ajm*amgn
      xb(5)=0.0
      yb(5)=0.0
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0

      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)

c     coordinates on a contour line
c     idv=(im-2)/np+1
c     jdv=(jm-2)/np+1
      idv=(im-1)/np+1
      jdv=(jm-1)/np+1
      idve=mod(im-1,np)+1
      jdve=mod(jm-1,np)+1

      do 10 id=1,idv
      is0=(id-1)*np+1
      if(id.lt.idv) then
          ie0=is0+np
      else
          ie0=is0+idve
      end if
      alinit=-1.0e10
      almax=alinit
      almin=-alinit
      do 10 jd=1,jdv
      js0=(jd-1)*np+1
      if(jd.lt.jdv) then
          je0=js0+np
      else
          je0=js0+jdve
      end if
      do 10 nd=1,ndiv
      le=lf(nd)
      do 10 l=1,le
      al=hmin(nd)+div(nd)*float(l-1)
      is=is0
      ie=ie0
      js=js0
      je=je0
 15   if(ie.ne.ie0) is=ie
      ie=ie0
      m=0
      mf=0
      md=0
 39   continue
          do 36 i=is,ie
          do 34 j=js,je
c
          ix1=(i-1)/2+1
          ix2=i/2+1
          ixd1=mod(i-1,2)+1
          ixd2=mod(i,2)+1
          iy1=(j-1)/2+1
          iy2=j/2+1
          iyd1=mod(j-1,2)+1
          iyd2=mod(j,2)+1
          if(i.eq.im) ix1=1
          if(i.eq.im) ixd1=1
          if(i+1.eq.im) ix2=1
          if(i+1.eq.im) ixd2=1
          if(j.eq.jm) iy1=1
          if(j.eq.jm) iyd1=1
          if(j+1.eq.jm) iy2=1
          if(j+1.eq.jm) iyd2=1
c            hights at cube corner
c         h1:(i,j), h2:(i,j+1), h3:(i+1,j), h4:(i+1,j+1)
                                  h1=ahkl(ixd1,iyd1,ix1,iy1)-al
          if(j.ne.je)             h2=ahkl(ixd1,iyd2,ix1,iy2)-al
          if(i.ne.ie)             h3=ahkl(ixd2,iyd1,ix2,iy1)-al
          if(i.ne.ie.and.j.ne.je) h4=ahkl(ixd2,iyd2,ix2,iy2)-al
          if(h1+al.lt.almin) almin=h1+al
          if(h1+al.gt.almax) almax=h1+al
c           point in the range h1-h2
          if(j.ne.je) then
            if(sign(1.0,h1).ne.sign(1.0,h2)) then
               m=m+1
               if(m.gt.ii) go to 36
               a(m)=float(j-1)+h1/(h1-h2)
               b(m)=float(i-1)
            end if
          end if
c         point in the range h1-h3
          if(i.ne.ie) then
            if(sign(1.0,h1).ne.sign(1.0,h3)) then
                m=m+1
                if(m.gt.ii) go to 36
                a(m)=float(j-1)
                b(m)=float(i-1)+h1/(h1-h3)
            end if
          end if
c         point in the range h1-h4
          if(i.ne.ie.and.j.ne.je) then
              if(sign(1.0,h1).ne.sign(1.0,h4)) then
                   m=m+1
                   if(m.gt.ii) go to 36
                   a(m)=float(j-1)+h1/(h1-h4)
                   b(m)=float(i-1)+h1/(h1-h4)
              end if
          end if
c         point in the range h2-h3
          if(i.ne.ie.and.j.ne.je) then
              if(sign(1.0,h2).ne.sign(1.0,h3)) then
                 m=m+1
                 if(m.gt.ii) go to 36
                 a(m)=float(j  )-h2/(h2-h3)
                 b(m)=float(i-1)+h2/(h2-h3)
               end if
          end if
 34       continue
          md0=md
          mf0=mf
          mf=m
          md=mf-mf0
          iend=i
 36       continue
      if(m.gt.ii) then
c         number of points on a contour line exceeds
c                array size of a and b
          if(iend.eq.im) then
              is=max0(iend-2,1)
              ie=max0(iend-1,1)
              m=mf0-md0
              go to 39
          else
              is=max0(iend-1,1)
              ie=iend
              m=mf0
              go to 39
          end if
      end if
      if(m.gt.1) then
           if(al.gt.almax) then
c              maximum hight
c               almax=al
           end if
      else if(m.le.1) then
           if(al.gt.almin.and.almax.eq.alinit) then
c              minimum hight
c               almin=al
           end if
      end if
      if(mf.le.1) go to 10
c
c       write coordinates on a contour line if necessary
c      if(iw.eq.1) then
c           write(6,202) title
c           write(6,200) al,mf
c           write(6,201) (b(m),a(m),m=1,mf)
c      end if
c
c         find contour line
c     a,b: coordinates on a contour line
c     mf : number of points on the contour line
c
      ais=is-1
      aie=ie-1
      ajs=js-1
      aje=je-1
      i=0
      it=1
 42   n=0
 46   i=i+1
      i1=i+1
c    find nearest point on the contour line
      call fdmin(i1,mf,it,m1,dmin,a,b,ii)
      if(n.eq.0) then
c         starting point is the current point
          is=it
      end if
      if(a(is).eq.ajs.or.b(is).eq.ais.or.a(is).eq.aje.or.
     *     b(is).eq.aie.or.is.ne.i-n) then
c          starting point is on the boundary
           go to 12
      end if
      if(a(m1).ne.ajs.and.b(m1).ne.ais.and.a(m1).ne.aje.and.
     *         b(m1).ne.aie) then
c          found point is on the boundary
           go to 12
      end if
c          else fined a point on the boutndary
      call intch(a(is),b(is),a(m1),b(m1))
      i=is-1
      it=is
      go to 42
 12   continue
c     i1 is replaced by found point         
        call intch(a(i1),b(i1),a(m1),b(m1))
        n=n+1
        it=i1
        if(dmin.lt.dlm.and.i1.ne.mf) go to 46

 41   if(dmin.lt.dlm.and.i1.eq.mf) n=n+1
      if(dmin.lt.dlm.and.i1.eq.mf) i=i+1
      if(n.eq.1) go to 45
c       starting point of a contoue line
      br(1)=b(is)*amgn
      ar(1)=a(is)*amgn
      do 44 k=2,n
      ki=i-n+k
      br(k)=b(ki)*amgn
 44   ar(k)=a(ki)*amgn
c  
      if(a(i).eq.ajs.or.b(i).eq.ais.or.
     *       a(i).eq.aje.or.b(i).eq.aie)  go to 11
      call fdmin(is,is,i,m1,dmin,a,b,ii)
      if(dmin.le.dlm) go to 14
      i2=max0(i-n-1,i-4)
      if(i2.lt.1) go to 11
      call fdmin(1,i2,i ,m1,dmin,a,b,ii)
      if(dmin.gt.dlm) go to 11
 14   continue
      n=n+1
      if(n.gt.500) then
          call quit(' ar(n), br(n), n > 500 stop in map ')
      end if
      br(n)=b(m1)*amgn
      ar(n)=a(m1)*amgn
      it=m1
      if(i.ne.mf) i=i-1
 11   continue
c     plot contour line
      call abtoxy(br,ar,n)
      if(al.gt.0.0) call clin(br,ar,n,1,0.1)
      if(al.eq.0.0) call clin(br,ar,n,2,0.1)
      if(al.lt.0.0) call clin(br,ar,n,3,0.1)
 45   if(i1.ne.mf) go to 42
      if(ie.ne.ie0) go to 15
 10   continue
c     plot title
      write(hight,'(2(a,f7.2))') 'hmin=',almin,' hmax=',almax
      ncoo=istrln(coord)
      nhgh=istrln(hight)
      nmap=14+ncoo
      tmap(1:nmap)=cmap(1:12)//'  '//coord(1:ncoo)
      fct=3.141592/180
      if(wtitl.eq.1) then
          x1=-2*wtsd*sin(fct*angl)
          y1=-2*wtsd*cos(fct*angl)
          x2=-4*wtsd*sin(fct*angl)
          y2=-4*wtsd*cos(fct*angl)
          x3=-6*wtsd*sin(fct*angl)
          y3=-6*wtsd*cos(fct*angl)
           call symbol(x1,y1,wtsd,title,angl,ntitle)
           call symbol(x2,y2,wtsd,tmap,angl,nmap)
           call symbol(x3,y3,wtsd,hight,angl,nhgh)
      end if
      write(6,*) 'maximum density=',almax
      write(6,*) 'minimum density=',almin
      return
 200  format(1h ,6hhight=,f12.6,5x,16hnumber of points,i6)
 201  format((1h ,10(2f6.1,1x)))
 202  format(1h ,a)
      end

      subroutine abtoxy(x,y,n)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      dimension x(*),y(*)
      do 10 i=1,n
          x(i)=x(i)*ax+y(i)*bx*coscx
          y(i)=y(i)*bx*sincx
          if(irl.eq.1) y(i)=-y(i)
 10   continue
      return
      end

c      subroutine axs(amin,amax,bmin,bmax,diva,divb,xx,yy)
      subroutine axs(amin,amax,bmin,bmax,diva,divb)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      dimension xx(3),yy(3),wx(4),wy(4)
c      call plot(xx(1),yy(1),3)
c      call plot(xx(2),yy(2),2)
c      call plot(xx(1),yy(1),3)
c      call plot(xx(3),yy(3),2)
      wx(3)=0.0
      wy(3)=0.0
      wx(4)=1.0
      wy(4)=1.0
      im=(amax-amin)/diva+0.001
      jm=(bmax-bmin)/divb+0.001
      do 60 i=1,im
      wx(1)=amin +diva*float(i)
      wy(1)=bmin
      call abtoxy(ax,ay,1)
      wx(2)=wx(1)
      if(irl.ne.1) wy(2)=wy(1)-0.1
      if(irl.eq.1) wy(2)=wy(1)+0.1
 60   call line(ax,ay,2,1,0,0)
      do 61 j=1,jm
      wx(1)=amin
      wy(1)=bmin +divb*float(j)
      call abtoxy(ax,ay,1)
      wx(2)=wx(1)-0.1
      wy(2)=wy(1)
 61   call line(wx,wy,2,1,0,0)
      return
      end

      subroutine fdmin(i1,i2,i,m1,dmin,a,b,ii)
      dimension a(ii),b(ii)
c       find point nearest to i-th one within i1-12
      m1=i1
      do 10 j=i1,i2
      d=(a(j)-a(i))**2+(b(j)-b(i))**2
      if(j.eq.i1) dmin=d
      if(d.ge.dmin) go to 10
      dmin=d
      m1=j
 10   continue
      return
      end

      subroutine intch(x1,y1,x2,y2)
      x=x1
      y=y1
      x1=x2
      y1=y2
      x2=x
      y2=y
      return
      end

      subroutine clin(a,b,n,ltyp,pitch)
      dimension a(*),b(*),ad(512),bd(512),d1(4)
      if(ltyp.eq.1) then
          a(n+1)=0.0
          b(n+1)=0.0
          a(n+2)=1.0
          b(n+2)=1.0
          call line(a,b,n,1,0,0)
          return
      end if
      if(ltyp.eq.2) then
           d1(1)=pitch/2
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)*5
      else if(ltyp.eq.3) then
           d1(1)=pitch
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)
      end if
      k=0
      is=2
      j=1
      ad(1)=a(1)
      bd(1)=b(1)
      dab=0.0
      dx=0.0
      i=1
      i1=1
 12   continue
      k=k+1
      k=mod(k-1,4)+1
      ad(1)=ad(j)
      bd(1)=bd(j)
      j=1
      dd=-dx
      do 10 i=is,n
          j=j+1
          if(j.gt.500) then
              call quit(' ad(j),bd(j), j>500 in clin ')
          end if
          da=a(i)-a(i-1)
          db=b(i)-b(i-1)
          dab=sqrt(da**2+db**2)
          d=dd+dab
          ad(j)=a(i)
          bd(j)=b(i)
          if(i.eq.n.and.d.lt.d1(k)) go to 11
          if(d.lt.d1(k)) go to 10
          dx=d1(k)-dd
          ad(j)=a(i-1)+da*dx/dab
          bd(j)=b(i-1)+db*dx/dab
          is=i
          if((k.eq.1.or.k.eq.3).and.i.ne.n) go to 12
 11       if((k.eq.1.or.k.eq.3).and.i.eq.n) go to 10
          ad(j+1)=0.0
          bd(j+1)=0.0
          ad(j+2)=1.0
          bd(j+2)=1.0
          call line(ad,bd,j,1,0,0)
          if(i.ne.n) go to 12
 10   dd=d
      return
      end

      subroutine setxyt(a,b,cosc,irld)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      ax=a
      bx=b
      coscx=cosc
      sincx=sqrt(1-coscx**2)
      irl=irld
      return
      end

c      subroutine setitwn(itwind)
c      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
c      itwin=itwind
c      return
c      end

c      subroutine getitwn(itwind)
c      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
c      itwind=itwin
c      return
c      end

      subroutine getaxbx(ax,bx,coxcx)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /cjbc/ jbc,xs(6),iax(6)
      common /kwave/ y(3,3,3),vc(3)
      d=5
      a=sqrt(gab(1,1,1))
      b=sqrt(gab(2,2,1))
      c=sqrt(gab(3,3,1))
      cosa=gab(2,3,1)/(b*c)
      cosb=gab(3,1,1)/(c*a)
      cosc=gab(1,2,1)/(a*b)
      if(iax(1).eq.1) ax=a
      if(iax(1).eq.2) ax=b
      if(iax(1).eq.3) ax=c
      if(iax(1).eq.4) ax=d
      if(iax(2).eq.1) bx=a
      if(iax(2).eq.2) bx=b
      if(iax(2).eq.3) bx=c
      if(iax(2).eq.4) bx=d
c     a*coscx=-y(1,1,1)*d etc.
      if(iax(1).eq.1.and.iax(2).eq.2) coscx=cosc
      if(iax(2).eq.1.and.iax(1).eq.2) coscx=cosc
      if(iax(1).eq.2.and.iax(2).eq.3) coscx=cosa
      if(iax(2).eq.2.and.iax(1).eq.3) coscx=cosa
      if(iax(1).eq.3.and.iax(2).eq.1) coscx=cosb
      if(iax(2).eq.3.and.iax(1).eq.1) coscx=cosb
      if(iax(1).eq.1.and.iax(2).eq.4) coscx=-y(1,1,1)*d/a
      if(iax(1).eq.4.and.iax(2).eq.1) coscx=-y(1,1,1)*d/a
      if(iax(1).eq.2.and.iax(2).eq.4) coscx=-y(2,1,1)*d/b
      if(iax(1).eq.4.and.iax(2).eq.2) coscx=-y(2,1,1)*d/b
      if(iax(1).eq.3.and.iax(2).eq.4) coscx=-y(3,1,1)*d/c
      if(iax(1).eq.4.and.iax(2).eq.3) coscx=-y(3,1,1)*d/c
      return
      end

      subroutine drwln0(xn2,yn2,ix,ivis1,ixdaz,ixdmx)
c     HDDRAW
c     common /const/icymin,icymax,cy0,dh
      parameter (ndmax=1000)
      common /cynmx/ynmax(ndmax),ynmin(ndmax)
c      y2=y
      ixd=ixdaz+ix
      if(ixd.lt.0.or.ixd.gt.ixdmx) return
      if(ixd.ne.ixd1) then
         ynmx=ynmax(ixd)
         ynmn=ynmin(ixd)
      end if
      if(ynmx.lt.ynmn) then
         ynmax(ixd)=yn2
         ynmin(ixd)=yn2
         ivis=1
      else if(yn2.ge.ynmx) then
         ynmax(ixd)=yn2
         ivis=1
      else if(yn2.le.ynmn) then
         ynmin(ixd)=yn2
         ivis=1
      else
         ivis=0
      end if
      if(ivis1.gt.0.and.ivis.gt.0) then
         if(ivis1.gt.0) then
             xna=xn1
             yna=yn1
         else
             xna=xn1
             yna=yn1
         end if
         if(ivis.gt.0) then
             xnb=xn2
             ynb=yn2
         else
             xnb=xn2
             ynb=yn2
         end if
         call draw(xna,yna,xnb,ynb)
c
c         iyc1=int((y1-cy0)/dh)
c         iyc2=int((y2-cy0)/dh)
c         icy=iyc1+icymin
cc
c         ny=iyc2-iyc1
c         dy=dh
c         icdy=1
c         yb=(iyc1+1)*dh+cy0
cc
c         if(ny.lt.0) then
c             ny=-ny
c             dy=-dh
c             icdy=-1
c             yb=iyc1*dh+cy0
c         end if
cc
c         do 200 lt=1,ny
c             r=(yb-y1)/(y2-y1)
c             xnb=r*(xn2-xn1)+xn1
c             ynb=r*(yn2-yn1)+yn1
c             icyt=icy
c             if(icy.lt.icymin) then
c                 icyt=icymin
c             else if(icy.gt.icymax) then
c                 icyt=icymax
c             end if
cc            call setcolor(icyt)
c             call draw(xna,yna,xnb,ynb)
c             xna=xnb
c             yna=ynb
c             yb=yb+dy
c             icy=icy+icdy
c 200     continue
c         icyt=icy
c         if(icy.lt.icymin) then
c            icyt=icymin
c         else if(icy.lt.icymax) then
c            icyt=icymax
c         end if
c         call draw(xna,yna,xn2,yn2)
      end if
      xn1=xn2
      yn1=yn2
      ynmx1=ynmx
      ynmn1=ynmn
c      y1=y2
      ivis1=ivis
      ixd1=ixd
      return
      end

      subroutine drwbox(xmin,xmax,ymin,ymax,divx,divy,shftxb,shftyb)
      real xb(7),yb(7)
      call getamg(amagx,amagy)
      xxa=xmin*amagx
      xxb=xmax*amagx
      yya=ymin*amagy
      yyb=ymax*amagy
      dvx=divx*amagx
      dvy=divy*amagy
      xb(1)=xxa
      yb(1)=yya
      xb(2)=xxb
      yb(2)=yya
      xb(3)=xxb
      yb(3)=yyb
      xb(4)=xxa
      yb(4)=yyb
      xb(5)=xxa
      yb(5)=yya

      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      x1=xb(1)-0.1
      y1=yb(1)-0.1
      x2=xb(3)+0.1
      y2=yb(3)+0.1
      x3=(-0.1+shftxb)/29.7
      y3=(-0.1+shftyb)/29.7
      x4=(xb(3)-xb(1)+0.1+shftxb)/29.7
      y4=(yb(3)-yb(1)+0.1+shftyb)/29.7
c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxy(x3,y3,1)
      call abtoxy(x4,y4,1)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
      call setxy0(1.,1.,0.,0)
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
c     call axs(xmin,xmax,ymin,ymax,divx,divy)
      call axs(xxa,xxb,yya,yyb,dvx,dvy)
      x1=xb(1)
      y1=yb(1)
      x2=xb(3)
      y2=yb(3)
      x3=(shftxb)/29.7
      y3=(shftyb)/29.7
      x4=(xb(3)-xb(1)+shftxb)/29.7
      y4=(yb(3)-yb(1)+shftyb)/29.7
c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxy(x3,y3,1)
      call abtoxy(x4,y4,1)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
c     call setxy0(1.,1.,0.,0)
c     call setxyt(1.,1.,0.,0)
      return
      end

      subroutine sphere(ri1,ri2,xy)
      real ri1,ri2,xy(*)
      call ellipse(0.,360.,0.,ri1,ri2,xy,0)
      return
      end

      subroutine setamg(amgx,amgy)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      amagx=amgx
      amagy=amgy
      return
      end

      subroutine getamg(amgx,amgy)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      amgx=amagx
      amgy=amagy
      return
      end

      subroutine gauss(p,n)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      do 20 j=2,n-1
         a(j,1)=xl(j)
         a(j,2)=2.0*(xl(j)+xl(j-1))
         a(j,3)=xl(j-1)
         do 10 k=1,is
            b(k,j)=(3.0*(xl(j-1)*xl(j-1)*(p(k,j+1)-p(k,j)))
     &      +3.0*xl(j)*xl(j)*(p(k,j)-p(k,j-1)))/(xl(j)*xl(j-1))
   10    continue
   20 continue

      do 50 i=2,n
         d=a(i-1,2)/a(i,1)
         a(i,1)=0.0
         a(i,2)=a(i,2)*d-a(i-1,3)
         a(i,3)=a(i,3)*d
         do 30 k=1,is
            b(k,i)=b(k,i)*d-b(k,i-1)
   30    continue
         q=a(i,2)
         a(i,2)=1.0
         a(i,3)=a(i,3)/q
         do 40 k=1,is
            b(k,i)=b(k,i)/q
   40    continue
   50 continue
      do 70 k=1,is
         u(k,n)=b(k,n)
         do 60 j=1,n-1
            u(k,n-j)=b(k,n-j)-a(n-j,3)*u(k,n+1-j)
   60    continue
   70 continue
      end

************************************************************************

      subroutine curgen(p,n,iz,rslt)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),f(4,is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      i=1
      do 40 j=1,n-1
         do 10 k=1,is
            f(1,k)=p(k,j)
            f(2,k)=u(k,j)
            f(3,k)=(3.0/(xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      -(1.0/xl(j))*(u(k,j+1)+2.0*u(k,j))
            f(4,k)=(-2.0/(xl(j)*xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      +(1.0/(xl(j)*xl(j)))*(u(k,j+1)+u(k,j))
   10    continue
         t=0.0
         do 30 l=1,iz
            do 20 k=1,is
               rslt(k,i)=((f(4,k)*t+f(3,k))*t+f(2,k))*t+f(1,k)
   20       continue
            i=i+1
            t=t+xl(j)/iz
   30    continue
   40 continue
      do 50 k=1,is
         rslt(k,i)=p(k,n)
   50 continue
      end

      subroutine setxy0(a,b,cosc,i)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      ax=a
      bx=b
      coscx=cosc
      sincx=sqrt(1-coscx**2)
      irl=i
      return
      end
