************************************************************************
      subroutine curgen(p,n,iz,rslt)
      include 'map.inc'
      real p(ns,ndata),rslt(ns,ntotal),f(4,ns)
      common /spl1/ a(ndata,3),b(ns,ndata),u(ns,ndata),xl(ndata)

      i=1
      do j=1,n-1
        do k=1,ns
            f(1,k)=p(k,j)
            f(2,k)=u(k,j)
            f(3,k)=(3.0/(xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &           -(1.0/xl(j))*(u(k,j+1)+2.0*u(k,j))
            f(4,k)=(-2.0/(xl(j)*xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &           +(1.0/(xl(j)*xl(j)))*(u(k,j+1)+u(k,j))
         end do
         t=0.0
         do l=1,iz
            do k=1,ns
               rslt(k,i)=((f(4,k)*t+f(3,k))*t+f(2,k))*t+f(1,k)
            end do
            i=i+1
            t=t+xl(j)/iz
         end do
      end do
      do k=1,ns
         rslt(k,i)=p(k,n)
      end do
      end

************************************************************************

c     s.contpn: find contour points (max:225x73)
c     
c     (a,ia): coordinate data of contour points
c     (x,iy): for y-axes data (m points)
c     (y,ix): for x-axes data (n-m points)
c     
      subroutine contpn(hh,h,i1,i2,j1,j2,ix,jx)
c     real hh(i2,j2)
      real hh(ix,jx)
      include 'map.inc'
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *     ia(ndata*10),m,n
*     common /origin/i0,j0
*     set the origin (1988.7.1)
      data i0,j0/0,0/

      m=0
      do j=j1-j0,j2-j0
         do i=i1-i0,i2-i0-1
            if((hh(i,j)-h)*(hh(i+1,j)-h).gt.0.) goto 10
            if(hh(i,j).ge.h.and.hh(i+1,j).ge.h) goto 10
            m=m+1
            d=(hh(i,j)-h)/(hh(i,j)-hh(i+1,j))
            if(d.lt.0.01) d=0.01
            if(d.gt.0.99) d=0.99
*     a(m)=i+i0+d
            a(m)=float(i)+float(i0)+d
            ia(m)=j+j0
c     20 continue
 10         continue
         end do
      end do
      n=m
      do i=i1-i0,i2-i0
         do j=j1-j0,j2-j0-1
            if((hh(i,j)-h)*(hh(i,j+1)-h).gt.0.) goto 40
            if(hh(i,j).ge.h.and.hh(i,j+1).ge.h) goto 40
            n=n+1
            if(n.gt.ndata*10) goto 90
            d=(hh(i,j)-h)/(hh(i,j)-hh(i,j+1))
            if(d.lt.0.01) d=0.01
            if(d.gt.0.99) d=0.99
            a(n)=float(j)+float(j0)+d
            ia(n)=i+i0
 40         continue
         end do
      end do
*     display(10,1010,line=14) h,i1,i2,j1,j2,m,n
      write(6,1010) h,i1,i2,j1,j2,m,n
 1010 format(' h=',f7.1,' (',2i4,') (',2i4,') m=',i6,' n=',i6)
      return
*     90 display(10,1020,line=14) h,i1,i2,j1,j2
 90   write(6,1020) h,i1,i2,j1,j2
 1020 format(' h=',f7.1,' (',2i4,')  (',2i4,') overflow')
      return
      end

************************************************************************

c     s.bndry : support contplt routine
c     check if boundary point
      function bndry(i,is,ie,js,je)
      include 'map.inc'
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *     ia(ndata*10),m,n
      bndry=0
      if(i.le.m) then
         if(ia(i).eq.js) bndry=1
         if(ia(i).eq.je) bndry=-1
      else
         if(ia(i).eq.is) bndry=1
         if(ia(i).eq.ie) bndry=-1
      endif
      return
      end

************************************************************************

c     s.exchng : support contplt routine
c     replace data in (a,ia) array for contour plot
c     
      subroutine exchng(i,im,in,j,fx,fy)
      include 'map.inc'
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *     ia(ndata*10),m,n
      if(j.eq.-1) goto 10

      if(i.eq.0) then
         return
      endif

      ib=1
      if(j.le.-2) then
         ib=-1
         j=-j
      endif
      j=j+1
      if(i.le.m) then
         if(i.le.0.or.j.le.0.or.i.gt.ndata*10) then
            write(6,*) 'i,j,ndata=',i,j,ndata
         end if
         x(j)=(a(i)-1.)*fx
         y(j)=(ia(i)-1)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),a(i),float(ia(i)),fx,fy
      else
         x(j)=(ia(i)-1)*fx
         y(j)=(a(i)-1.)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),float(ia(i)),a(i),fx,fy
      endif
      if(ib.eq.-1) return
 10   continue
      if(i.le.m) ib=im
      if(i.gt.m) ib=in
      if(im.eq.0.or.i.eq.0) then
         write(6,*) 'im,i=',im,i
      end if
      buf=a(ib)
      a(ib)=a(i)
      a(i)=buf
      ibuf=ia(ib)
      ia(ib)=ia(i)
      ia(i)=ibuf
      i=ib
      if(i.le.m) im=im+1
      if(i.gt.m) in=in-1
      return
      end

************************************************************************

c     s.search : support contplt routine
c     search 'next' point
c     
      subroutine search(ib,i0,i1,im,in,np)
      include 'map.inc'
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *     ia(ndata*10),m,n
      dimension ik(3)
      ixy1=a(i1)
      iyx1=ia(i1)
      if(i0.gt.0) then
         if(i0.le.m) then
            x0=a(i0)
            ix0=x0
            iy0=ia(i0)
            y0=iy0
         else
            ix0=ia(i0)
            x0=ix0
            y0=a(i0)
            iy0=y0
         endif

         if(i1.le.m) then
            ib=iyx1-iy0
            x1=a(i1)
            y1=iyx1
         else
            ib=iyx1-ix0
            x1=iyx1
            y1=a(i1)
         endif
      end if

      if(ib.le.0) ib=-1
      if(ib.gt.0) ib=0
      k=0
      do i=im,in
         if(i.eq.i1) goto 20
         if(i1.le.m.and.i.le.m) goto 20
         if(i1.gt.m.and.i.gt.m) goto 20
         if(ifix(a(i)).ne.iyx1+ib) goto 20
         if(.not.(ia(i).eq.ixy1.or.ia(i).eq.ixy1+1)) goto 20
         k=k+1
         ik(k)=i
 20      continue
      end do
      if(ib.eq.0) ib=1
      do i=im,in
         if(i1.le.m.and.i.gt.m) goto 30
         if(i1.gt.m.and.i.le.m) goto 30
         if(ia(i).ne.iyx1+ib) goto 30
         if(ifix(a(i)).ne.ixy1) goto 30
         k=k+1
         ik(k)=i
 30      continue
      end do

      np=k
      if(np.eq.0) then
         return
c     else if(np.eq.1) then
      else if(np.le.3) then   ! modified by A. Yamamoto Dec. 10 (2003)
         i0=i1
         i1=ik(1)
         return
      endif

c     write(6,*) 'np=',np,' i0=',i0
      d1=(x1-x0)**2+(y1-y0)**2
      tmin=10.
      do k=1,np
         i=ik(k)
         if(i.le.m) then
            if(i1.le.m) goto 40
            x2=a(i)
            y2=ia(i)
         else
            if(i1.gt.m) goto 40
            x2=ia(i)
            y2=a(i)
         endif
         d=(x2-x1)**2+(y2-y1)**2
         d2=(x2-x0)**2+(y2-y0)**2
c     t=(d1+d-d2)/sqrt(d*d1)
c     if(t.ge.tmin) goto 40
c     imin=i
c     tmin=t
         if(d1.eq.0) then
            go to 40
         else
            t=(d1+d-d2)/sqrt(d*d1)
            if(t.ge.tmin) goto 40
            imin=i
            tmin=t
         end if
 40      continue
      end do
      i0=i1
      i1=imin
      return
      end

      subroutine abtoxy(x,y,n)
      include 'drwmap.inc'
      dimension x(*),y(*)
      integer getirl
      sincx=sqrt(1.0-coscx**2)
      irl=getirl()
      do i=1,n
         x(i)=x(i)*ax+y(i)*bx*coscx
         y(i)=y(i)*bx*sincx
         if(irl.eq.1) y(i)=-y(i)
      end do
      return
      end

      subroutine abtoxys(x,y)
      include 'drwmap.inc'
      integer getirl
      irl=getirl()
      sincx=sqrt(1.0-coscx**2)
      x=x*ax+y*bx*coscx
      y=y*bx*sincx
      if(irl.eq.1) y=-y
      return
      end

      subroutine xytotp(x,y,n)
      dimension x(*),y(*)
      include 'drwmap.inc'
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      integer getirl
      data pi/3.14159/
      irl=getirl()
      do i=1,n
          xd=x(i)
          yd=y(i)
          x(i)=cos(pi*xd/xmax)*ri1*ax
          y(i)=sin(pi*xd/xmax)*ri2*ax*sin(pi*yd/ymax-pi/2)
          if(irl.eq.1) y(i)=-y(i)
       end do
      return
      end

      subroutine setamg(amgx,amgy)
      include 'drwmap.inc'
      amagx=amgx
      amagy=amgy
      return
      end

      subroutine getamg(amgx,amgy)
      include 'drwmap.inc'
      amgx=amagx
      amgy=amagy
      return
      end

      integer function getirl()
      common /cirl/ irl
      getirl=irl
      return
      end

      subroutine setxy0(a,b,cosc,i)
      include 'drwmap.inc'
      common /cirl/ irl
      ax=a
      bx=b
      coscx=cosc
      sincx=sqrt(1.0-coscx**2)
      irl=i
      return
      end

      subroutine setxyt(a,b,cosc,i)
      include 'drwmap.inc'
      common /cirl/ irl      
      ax=a*amagx
      bx=b*amagy
      coscx=cosc
      sincx=sqrt(1.0-coscx**2)
      irl=i
      return
      end

      subroutine clin(a,b,n,ltyp,pitch)
      dimension a(*),b(*),ad(5002),bd(5002),d1(4)
      if(ltyp.eq.1) then
          a(n+1)=0.0
          b(n+1)=0.0
          a(n+2)=1.0
          b(n+2)=1.0
          call line(a,b,n,1,0,0)
          return
      end if
      if(ltyp.eq.2) then
           d1(1)=pitch/2
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)*5
      else if(ltyp.eq.3) then
           d1(1)=pitch
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)
      end if
      k=0
      is=2
      j=1
      ad(1)=a(1)
      bd(1)=b(1)
      dab=0.0
      dx=0.0
      i=1
      i1=1
 12   continue
      k=k+1
      k=mod(k-1,4)+1
      ad(1)=ad(j)
      bd(1)=bd(j)
      j=1
      dd=-dx
      do i=is,n
          j=j+1
          if(j.gt.5000) then
              call quit(' ad(j),bd(j), j>5000 in clin ')
          end if
          da=a(i)-a(i-1)
          db=b(i)-b(i-1)
          dab=sqrt(da**2+db**2)
          d=dd+dab
          ad(j)=a(i)
          bd(j)=b(i)
          if(i.eq.n.and.d.lt.d1(k)) go to 11
          if(d.lt.d1(k)) go to 10
          dx=d1(k)-dd
          ad(j)=a(i-1)+da*dx/dab
          bd(j)=b(i-1)+db*dx/dab
          is=i
          if((k.eq.1.or.k.eq.3).and.i.ne.n) go to 12
 11       if((k.eq.1.or.k.eq.3).and.i.eq.n) go to 10
          ad(j+1)=0.0
          bd(j+1)=0.0
          ad(j+2)=1.0
          bd(j+2)=1.0
          call line(ad,bd,j,1,0,0)
          if(i.ne.n) go to 12
 10       dd=d
      end do
      return
      end

      subroutine axs(amin,amax,bmin,bmax,diva,divb)
      dimension ax(4),ay(4)
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      offsx=mod(amin,diva)
      offsy=mod(bmin,diva)
      im=(amax-amin+offsx)/diva+0.001
      jm=(bmax-bmin+offsy)/divb+0.001
      do i=0,im
         ax(1)=amin-offsx +diva*float(i)
         ay(1)=bmin
         call abtoxy(ax,ay,1)
         ax(2)=ax(1)
         ay(2)=ay(1)-0.05
         call line(ax,ay,2,1,0,0)
      end do
      do j=0,jm
         ax(1)=amin
         ay(1)=bmin-offsy +divb*float(j)
         call abtoxy(ax,ay,1)
         ax(2)=ax(1)-0.05
         ay(2)=ay(1)
         call line(ax,ay,2,1,0,0)
      end do
      do i=0,im
         ax(1)=amin-offsx +diva*float(i)
         ay(1)=bmax
         call abtoxy(ax,ay,1)
         ax(2)=ax(1)
         ay(2)=ay(1)+0.05
         call line(ax,ay,2,1,0,0)
      end do
      do j=0,jm
         ax(1)=amax
         ay(1)=bmin-offsy +divb*float(j)
         call abtoxy(ax,ay,1)
         ax(2)=ax(1)+0.05
         ay(2)=ay(1)
         call line(ax,ay,2,1,0,0)
      end do
      return
      end

      subroutine sphere(ri1,ri2,xy)
      real ri1,ri2,xy(*)
      call ellipse(0.,360.,0.,ri1,ri2,xy,0)
      return
      end

      subroutine drwln(xw,yw,n)
      real xw(*),yw(*)
      if(n.gt.1) then
         xw(n+1)=0
         yw(n+1)=0
         xw(n+2)=1
         yw(n+2)=1
         call line(xw,yw,n,1,0,0)
      end if
      return
      end

      subroutine smthxy1(cxy,ixm,iym,dxy)
      real cxy(0:ixm,0:iym)
      real dxy(0:ixm,0:iym)
      do i=0,ixm
         i1=max(i-1,0)
         i2=i
         i3=min(i+1,ixm)
         do j=0,iym
            j1=max(j-1,0)
            j2=j
            j3=min(j+1,iym)
            dxy(i,j)=(cxy(i1,j2)+cxy(i2,j2)+cxy(i3,j2)+
     *                cxy(i2,j1)+cxy(i2,j2)+cxy(i2,j3))/6
         end do
      end do
      do i=0,ixm
         do j=0,iym
            cxy(i,j)=dxy(i,j)
         end do
      end do
      return
      end

c     smoothing of 2D map (9 point smoothing)
      subroutine smthxy2(cxy,ixm,iym,dxy)
      real cxy(0:ixm,0:iym)
      real dxy(0:ixm,0:iym)
      a=1
      b=2
      c=3
      do i=0,ixm
         i1=max(i-1,0)
         i2=i
         i3=min(i+1,ixm)
         do j=0,iym
            j1=max(j-1,0)
            j2=j
            j3=min(j+1,iym)
            dxy(i,j)=((cxy(i1,j1)+cxy(i1,j3)+cxy(i3,j1)+cxy(i3,j3))*a
     *           +(cxy(i2,j1)+cxy(i2,j3)+cxy(i1,j2)+cxy(i3,j2))*b+
     *                cxy(i2,j2)*c)/(4*a+4*b+c)
         end do
      end do
      do i=0,ixm
         do j=0,iym
            cxy(i,j)=dxy(i,j)
         end do
      end do
      return
      end

      subroutine smooth(p,n,x,y,npoint)
      include 'map.inc'
      real p(ns,ndata),rslt(ns,ntotal),x(*),y(*)

      iz=3
      call spline(p,n,iz,rslt,npoint)
      do i=1,npoint
         x(i)=rslt(1,i)
         y(i)=rslt(2,i)
      end do
      end

************************************************************************

      subroutine spline(p,n,iz,rslt,npoint)
*     *    input data
*     p: coordinates of points
*     n: number of data
*     iz: number of interpolated points
*     *    output data
*     rslt: coordinates of total points
*     npoint: number of total points

      include 'map.inc'
      real p(ns,ndata),rslt(ns,ntotal),pi(ns),pe(ns)
*     corrected (iz in the original program = number of interpolated
*     points + 1)
      iz2=iz+1
      ic1=1
      ic2=1
*     pi and pe is not used in the present program because ic1=ic2=1
*     input pi here if ic1=2
*     input pe here if ic2=2
      call endpnt(p,n,ic1,ic2,pi,pe)
      call gauss(p,n)
      call curgen(p,n,iz2,rslt)
      npoint=(n-1)*iz2+1
      end

************************************************************************

      subroutine endpnt(p,n,ic1,ic2,pi,pe)
      include 'map.inc'
      real p(ns,ndata),pi(ns),pe(ns)
      common /spl1/ a(ndata,3),b(ns,ndata),u(ns,ndata),xl(ndata)

      if (ic1 .eq. 1) then
         a(1,2)=1.0
         a(1,3)=0.5
      else
         a(1,2)=1.0
         a(1,3)=0.0
         do k=1,ns
            b(k,1)=pi(k)
            u(k,1)=pi(k)
         end do
      end if

      do k=1,n-1
         xd=0.0
         do j=1,ns
            xd=xd+(p(j,k+1)-p(j,k))*(p(j,k+1)-p(j,k))
         end do
         xl(k)=sqrt(xd)
      end do

      if (ic1 .ne. 2) then
         do k=1,ns
            b(k,1)=(3.0/(2.0*xl(1)))*(p(k,2)-p(k,1))
         end do
      end if

      if (ic2 .eq. 1) then
         a(n,1)=1.0
         a(n,2)=2.0
         do k=1,ns
            b(k,n)=(3.0/xl(n-1))*(p(k,n)-p(k,n-1))
         end do
      else
         a(n,1)=0.0
         a(n,2)=1.0
         do k=1,ns
            b(k,n)=pe(k)
            u(k,n)=pe(k)
         end do
      end if
      end

************************************************************************

c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,xmin,ymin,fx,fy)                      *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl(h,ixm,jxm,al,is,ie,js,je,xmin,ymin,fx,fy,icon)
      include 'map.inc'
c     real hh(ie,je),p(2,ndata)
      real h(ixm,jxm),p(2,ndata)
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *     ia(ndata*10),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
c     yy(t)=edge*sinphi-t

c     *** find points to form contour line of height h
      icon=0
      call contpn(h,al,is,ie,js,je,ixm,jxm)
      if(n.le.0) then
         icon=1
         return
      end if
      if(n.gt.ndata) call quit('n > ndata') 
      im=1 
      in=n 
      ib=1 
c     select first point to start contour line 
 10   continue 
      j=-1
      jb=0
 15   imm=im 
      inn=in
 20   continue
      do i1=imm,inn 
         ib=bndry(i1,is,ie,js,je)
         if(ib.ne.0) goto 40 
      end do
      if(jb.eq.1) then
         jb=2
         goto 15
      endif
      i1=imm
 40   continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0 
c     search next (second) point 
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1.and.jb.le.1) then
         jb=1 
         goto 20
      endif

      j=0 
c     evaluate first point coordinate 
      call exchng(i0,im,in,j,fx,fy) 
c     store first point location 
      ist=i0 
 50   continue 
c     evaluate next point coordinate 
      call exchng(i1,im,in,j,fx,fy) 
c     check if terminal point 
      ib=bndry(i1,is,ie,js,je) 
      if(im.gt.in) goto 60 
      if(ib.ne. 0) goto 70 
c     search next point 

      call search(ib,i0,i1,im,in,np) 
      if(np.ne. 0) goto 50 
 60   continue 
c     check if terminal point is connected to first point 
      call search(ib,i0,i1,ist,ist,np) 
      if(np.eq.1) then
         j=-j 
         call exchng(i1,im,in,j,fx,fy)
      endif
 70   continue 

c     *** plot found contour line
      do i=1,j
         p(1,i)=x(i)+xmin
         p(2,i)=y(i)+ymin
      end do
      call smooth(p,j,x,y,npoint)

      call getcas(icase)
      if(abs(icase).le.8.or.icase.ge.17) then
         call abtoxy(x(1),y(1),npoint)
      else if(abs(icase).eq.9) then
         call xytotp(x(1),y(1),npoint)
      else
         call abtoxy(x(1),y(1),npoint)
      end if

      if(al.gt.0.0) then
         call clin(x,y,npoint,1,0.1)
      else if(al.eq.0.0) then
         call clin(x,y,npoint,2,0.1)
      else if(al.lt.0.0) then
         call clin(x,y,npoint,3,0.1)
      end if
      if(im.lt.in) goto 10
      return
      end

      subroutine  normxyz(cr,nt)  ! normalization for getting electron density
      real cr(0:*)
      vol=getvol()
      do i=0,nt-1
         cr(i)=cr(i)/vol
      end do
      return
      end

      subroutine reduceh(h0,hmax,i)
      integer h0(*),hmax(*)
      h0(i)=mod(h0(i),hmax(i))  ! 0 <= h0(i) < hmax(i)
      if(h0(i).lt.0) h0(i)=h0(i)+hmax(i)
      return
      end

      subroutine getdrv1(h0,dr,grd1) ! get first order derivatives at h0
      integer h0(*)
      real dr(0:*),grd1(*)
      integer hmax(6)
      integer h1(6)
      integer getxyztoj
      call getidm(idm)
      call gethmax(hmax)
      i0=getxyztoj(h0)
      dnst0 =dr(i0)       ! density at the origin
      do i=1,idm
         call vcpyi(h0,h1,6)
         h1(i)=h0(i)+1
         call reduceh(h1,hmax,i)
         dnst1=getdxyz(dr,h1) ! density at the nearest neighbour
         grd1(i)=dnst1-dnst0  ! derivative along i-th axis
      end do
      return
      end

      subroutine geth0dx(rd,h0,dx,hmax)
      real rd(*),dx(*)
      integer h0(*),hmax(*)
      real xd(6)
      call getidm(idm)
      do i=1,idm
         xd(i)=rd(i)*hmax(i)    ! 0 <= rd(i) < hmax(i)
         h0(i)=int(xd(i)+0.5)   ! h0(i)-1/2 < rd(i) < h0(i)+1/2
         dx(i)=xd(i)-h0(i)      ! -1/2 < dx(i) < 1/2
         call reduceh(h0,hmax,i)
         if(abs(dx(i)).gt.0.5) call quit('dx > 1/2 or dx < -1/2')
         if(abs(h0(i)).gt.hmax(i)) call quit('h0 > hmax')
      end do
      return
      end
      
      subroutine grad(dr,rx,dnsty)
      real dr(0:*)      ! density on nD grid points
      real rx(*)        ! coordinates for which density is calculated
c     call grad0(dr,rx,dnsty)
      call grad1(dr,rx,dnsty)  ! better
c     call grad2(dr,rx,dnsty)  ! best ?
      return
      end

      function getdxyz(dr,h)
      real dr(0:*)
      integer h(*)
      integer getxyztoj
      i=getxyztoj(h)
      getdxyz =dr(i)       ! density at the origin
      return
      end

      subroutine symmtrz(dgrd2,idm)
      real dgrd2(6,6)
      real sdgrd2(6,6)
c     symmetrize  dgrd2(i,j)
      do i=1,idm
         do j=1,idm
            sdgrd2(i,j)=(dgrd2(i,j)+dgrd2(j,i))/2
         end do
      end do
      call mcpy(sdgrd2,dgrd2)
      return
      end

      subroutine grad2(dr,rx,dnsty)
      real dr(0:*)      ! density on nD grid points
      real rx(*)        ! coordinates for which density is calculated
      integer hmax(6)   ! number of divisions along each axis
      real rd(6)
      integer h0(6),h1(6)
      integer id(6)
      real dx(6)
      real grd1(6),grd2(6) ! first order derivatives
      real dgrd1(6),dgrd2(6,6),sdgrd2(6,6)
      data eps /0.0001/
      integer getxyztoj,getnt
      call gethmax(hmax)
      call getidm(idm)

c     reduce rd in the unit cell
      do i=1,idm
         rd(i)=mod(rx(i),1.)
         if(rd(i).lt.0) rd(i)=rd(i)+1.   ! 0 <= rd(i) < 1 
      end do

c     h0(i) (i=1,idm)  nearest grid point for q(i)
c     dx = rd-h0
      call geth0dx(rd,h0,dx,hmax)
      dnst0=getdxyz(dr,h0)       ! density at the origin

      call getdrv1(h0,dr,grd1)  ! get first order derivatives

c     calculate second order derivatives
      do i=1,idm
         call vcpyi(h0,h1,idm)
         h1(i)=h0(i)-1
         call reduceh(h1,hmax,i)
         call getdrv1(h1,dr,grd2)
         do j=1,idm
            dgrd2(j,i)=grd1(j)-grd2(j) ! second order derivatives
         end do
      end do

      do i=1,idm   ! get average first order derivatives
         dgrd1(i)=(grd1(i)+grd2(i))/2
      end do

      call symmtrz(dgrd2,idm)

      delt1=0
      do i=1,idm
         delt1=delt1+dgrd1(i)*dx(i)  ! Taylor expansion
      end do

      delt2=0
      do i=1,idm
         do j=1,idm
            delt2=delt2+dgrd2(i,j)*dx(i)*dx(j)/2 ! Taylor expansion
         end do
      end do

c     dnsty=dnst0
      dnsty=dnst0+delt1
c     dnsty=dnst0+delt1+delt2

c      write(6,*) 'dnst0,delt1,delt2',dnst0,delt1,delt2
c      if(dnsty.lt.0) then
c         write(6,'(a,18i4)') 'h0,h1=',h0,h1,id
c         write(6,'(a,6f10.4)') 'grd=',grd
c         write(6,'(a,6f10.4)') 'dx=',dx
c         write(6,'(a,3f10.4)') 'dnst0,delt,dnsty=',dnst0,delt,dnsty
c      end if
      return
      end

      subroutine grad1(dr,rx,dnsty)
      real dr(0:*)      ! density on nD grid points
      real rx(*)        ! coordinates for which density is calculated
      integer hmax(6)   ! number of divisions along each axis
      real rd(6)
      integer h0(6),h1(6),h2(6),h3(6),h4(6)
      integer h(6),k(6),l(6),m(6)
      integer id(6)
      real grd0(6),grd1(6),grd2(6),grd3(6),grd4(6),dx(6)
      real dgrd(6,6)
      data eps/0.0001/
      integer getxyztoj
      call gethmax(hmax)
      call getidm(idm)

c      write(6,*) 'hmax=',hmax
c      write(6,*) 'idm=',idm
c      call quit('quit at grad1')

      do i=1,idm
         rd(i)=mod(rx(i),1.)
         if(rd(i).lt.0) rd(i)=rd(i)+1.   ! 0 <= rd(i) < 1
      end do

c     h0(i) (i=1,idm)  nearest grid point for q(i)
      do i=1,idm
         rd(i)=rd(i)*hmax(i)    ! 0 <= rd(i) < hmax(i)
         h0(i)=rd(i)+0.5        ! h0(i)-1/2 < rd(i) < h0(i)+1/2
         dx(i)=rd(i)-h0(i)      ! -1/2 < dx(i) < 1/2
         call reduceh(h0,hmax,i)
         if(abs(dx(i)).gt.0.5) call quit('dx > 1/2')
         if(abs(h0(i)).gt.hmax(i)) call quit('h0 > hmax')
      end do

c     h1(i),h2(i) (i=1,6) second nearest points along idm axes
      do i=1,idm
         if(abs(dx(i)).lt.eps) then
            id(i)=0
         else
            id(i)=1
         end if
         h1(i)=h0(i)+id(i)
         h2(i)=h0(i)-id(i)
         h3(i)=h0(i)+id(i)*2
         h4(i)=h0(i)-id(i)*2
         call reduceh(h1,hmax,i)
         call reduceh(h2,hmax,i)
         call reduceh(h3,hmax,i)
         call reduceh(h4,hmax,i)
      end do
c     write(6,'(a,6i4,6i4,6f8.5)') 'h0,h1,dx',h0,h1,dx
      i0=getxyztoj(h0)
      dnst0 =dr(i0)
      do i=1,idm
         call vcpyi(h0,h,idm)
         call vcpyi(h0,k,idm)
         call vcpyi(h0,l,idm)
         call vcpyi(h0,m,idm)
         h(i)=h1(i)
         k(i)=h2(i)
         l(i)=h3(i)
         m(i)=h4(i)
         dnst1=getdxyz(dr,h)
         dnst2=getdxyz(dr,k)
         dnst3=getdxyz(dr,l)
         dnst4=getdxyz(dr,m)

         grd1(i)= (dnst1-dnst0)
         grd2(i)=-(dnst2-dnst0)
         grd3(i)= (dnst3-dnst1)
         grd4(i)=-(dnst4-dnst2)
      end do

      do i=1,idm
         tmp1=dnst0+grd1(i)*0.5   ! density at i+0.5
         tmp2=dnst0-grd2(i)*0.5   ! density at i-0.5
         tmp3=dnst1+grd3(i)*0.5   ! density at i+1.5
         tmp4=dnst2-grd4(i)*0.5   ! density at i-1.5
         grd0(i)=tmp1-tmp2        ! average gradient at i
         dgrd(i,i)=(tmp3-tmp1)-(tmp2-tmp4)
      end do

      do i=1,idm
         do j=1,idm
            if(j.ne.i) then
               call vcpyi(h0,h,idm)
               call vcpyi(h0,k,idm)
               call vcpyi(h0,l,idm)
               call vcpyi(h0,m,idm)
               h(i)=h1(i)       ! h0(i)+1
               l(i)=h1(i)       ! h0(i)+1
               k(i)=h2(i)       ! h0(i)-1
               m(i)=h2(i)       ! h0(i)-1
               
               l(j)=h1(j)       ! h0(j)+1
               m(j)=h1(j)       ! h0(j)+1

               dnst00 =getdxyz(dr,h)
               dnst01 =getdxyz(dr,l)
               dnst02 =getdxyz(dr,k)
               dnst03 =getdxyz(dr,m)
               
               grd30=dnst01-dnst00
               grd40=dnst03-dnst02
               tmp3 =tmp1+grd30*0.5 ! density at i+0.5, j+0.5
               tmp4 =tmp2+grd40*0.5 ! density at i-0.5, j+0.5
               grdxy1 =(tmp3-tmp4)
                                ! avrage gradient along i-th axis at i,j+0.5
               l(j)=h2(j)       ! h0(j)-1
               m(j)=h2(j)       ! h0(j)-1
               dnst00 =getdxyz(dr,h)
               dnst01 =getdxyz(dr,l)
               dnst02 =getdxyz(dr,k)
               dnst03 =getdxyz(dr,m)
               grd50  =-(dnst01-dnst00)
               grd60  =-(dnst03-dnst02)
               tmp5=tmp1-grd50*0.5 ! density at i+0.5, j-0.5
               tmp6=tmp2-grd60*0.5 ! density at i-0.5, j-0.5
               grdxy2 =(tmp5-tmp6)
                                ! average gradient along i-th axis at i,j-0.5
               dgrd(i,j)=grdxy1-grdxy2 ! change in dgdx along j-th axis
            end if
         end do
      end do

      call symmtrz(dgrd,idm)  ! symmetrized dgrd

      delt1=0
      do i=1,idm
         delt1=delt1+grd0(i)*dx(i)  ! Taylor expansion
      end do

      delt2=0
      do i=1,idm
         do j=1,idm
            delt2=delt2+dgrd(i,j)*dx(i)*dx(j)/2 ! Taylor expansion
         end do
      end do

      dnsty=dnst0+delt1+delt2
c      dnsty=dnst0+delt1
c      dnsty=dnst0

c      write(6,*) 'dnst0,delt1,delt2',dnst0,delt1,delt2
c      if(dnsty.lt.0) then
c         write(6,'(a,18i4)') 'h0,h1=',h0,h1,id
c         write(6,'(a,6f10.4)') 'grd=',grd
c         write(6,'(a,6f10.4)') 'dx=',dx
c         write(6,'(a,3f10.4)') 'dnst0,delt,dnsty=',dnst0,delt,dnsty
c      end if
      return
      end

      subroutine grad0(dr,rx,dnsty)
      real dr(0:*)
      real rx(*)
      integer hmax(6)
      real rd(6)
      integer h0(6),h1(6),id(6)
      real grd(6),dx(6)
c      real grdq(6),dxq(6)
      common /cdim/ idm,nde
      integer getxyztoj
      data eps/0.0001/
      call gethmax(hmax)
      do i=1,idm
         rd(i)=mod(rx(i),1.)
         if(rd(i).lt.0) rd(i)=rd(i)+1.   ! 0 <= rd(i) < 1
      end do
c     h0(i) (i=1,6)  grid point nearest to rd(i)
      do i=1,idm
         if(hmax(i).ne.1) then
            rd(i)=rd(i)*hmax(i) ! 0 <= rd(i) < hmax(i)
            h0(i)=rd(i)+0.5     ! h0(i)-1/2 < rd(i) < h0(i)+1/2
            dx(i)=rd(i)-h0(i)   ! -1/2 < dx(i) < 1/2
         else
            h0(i)=rd(i)
            dx(i)=0
         end if
         h0(i)=mod(h0(i),hmax(i)) ! 0 <= h0(i) < hmax(i)
      end do
c     h1(i) (i=1,6) second nearest points along 6 axes
      do i=1,idm
         if(abs(dx(i)).lt.eps) then
            id(i)=0
         else
            id(i)=sign(1.0,dx(i))   !  id(i)=-1, 0, or 1
         end if
         if(hmax(i).ne.1) then
            h1(i)=h0(i)+id(i)
            h1(i)=mod(h1(i),hmax(i))
         else
            h1(i)=h0(i)
         end if
         if(h1(i).lt.0) h1(i)=h1(i)+hmax(i)  ! 0 <= h1(i) < hmax(i)
      end do
      do i=idm+1,6
         h0(i)=0
         h1(i)=0
         dx(i)=0
      end do
c      write(6,'(a,6i4,6i4,6f8.5)') 'h0,h1,dx',h0,h1,dx
c      ***** following grd are wrong *****
      i=getxyztoj(h0)
      dnst0 =dr(i)
      grd(1)=dr(i)
      grd(2)=dr(i)
      grd(3)=dr(i)
      grd(4)=dr(i)
      grd(5)=dr(i)
      grd(6)=dr(i)
      do i=1,idm
         grd(i)=(grd(i)-dnst0)*id(i)
      end do
      dnsty=dnst0
      do i=1,idm
         dnsty=dnsty+grd(i)*dx(i)
      end do
c      if(dnsty.lt.0) then
c         write(6,'(a,18i4)') 'h0,h1=',h0,h1,id
c         write(6,'(a,6f10.4)') 'grd=',grd
c         write(6,'(a,6f10.4)') 'dx=',dx
c         write(6,'(a,3f10.4)') 'dnst0,delt,dnsty=',dnst0,delt,dnsty
c      end if
      return
      end

      subroutine settitle(titled)
      character(*) titled
      character(80) title
      common /ctitle/ title
      ln=len(titled)
      iln=istrln(titled)
      title(1:iln)=titled(1:iln)
      do i=iln+1,ln
         title(i:i)=' '
      end do
c      write(6,*) 'settitle ln,iln=',ln,iln
c      write(6,*) 'settitle title=',title(1:iln)
      return
      end

      subroutine gettitle(titled)
      character(*) titled
      character(80) title
      common /ctitle/ title
      ln=len(titled)
      iln=istrln(title)
      titled(1:iln)=title(1:iln)
      do i=iln+1,ln
         titled(i:i)=' '
      end do
c      write(6,*) 'gettitle ln,iln=',ln,iln
c      write(6,*) 'gettitle titled=',titled(1:iln)
      return
      end

c           call map01(hmin,div,lf,ndiv,iw,dxy,ixm,iym) ! for crystal
c     2D electron density map for crystals
      subroutine map01(hmin,div,lf,ndiv,iw,xy,ixm,iym)
      dimension hmin(*),div(*),lf(*)
      real xy(0:ixm,0:iym)
      real a(5000),b(5000)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      include 'drwmap.inc'
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
      character(80) wtitle
      common /name/ iwtitl,ws,angl,wtitle
c     character(80) title, coord, cmap, tmap, hight
      character(80) title,cmap
      common /ctitle/ title
      dimension xb(7),yb(7)
      common /cdim/ idm,nde

c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ixm,iym : size of to dimensional array xy (number of points)
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             ixm and iym, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates

c     shift before plot
      call plot(shftxb,shftyb,-3)
      call newpen(2)
      np=32

c     jbc=5
      if(abs(jbc).eq.1) then
          cmap='Fourier map '
      else if(abs(jbc).eq.2) then
          cmap='Fc Fourier map '
      else if(abs(jbc).eq.3) then
          cmap='D-Fourier map '
      else if(abs(jbc).eq.4) then
          cmap='Fo Patterson map '
      else if(abs(jbc).eq.5) then
          cmap='Fc Patterson map '
      end if

c     plot boundary
      xb(1)=xmin
      yb(1)=ymin
      xb(2)=xmax
      yb(2)=ymin
      xb(3)=xmax
      yb(3)=ymax
      xb(4)=ymin
      yb(4)=ymax
      xb(5)=xmin
      yb(5)=ymin
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
c     coordinates on a contour line
      ibtm=0
      do nd=1,ndiv
         le=lf(nd)
         do l=1,le
c     al: hight
            al=hmin(nd)+div(nd)*float(l-1)
            fx=(xmax-xmin)/ixm
            fy=(ymax-ymin)/iym
c     call contpl(xy,al,1,ixm+1,1,iym+1,xmin,ymin,fx,fy,
c     *            icon)
            call contpl(xy,ixm+1,iym+1,al,1,ixm+1,1,iym+1,
     *           xmin,ymin,fx,fy,icon)
            if(icon.eq.1) then
               if(ibtm.eq.1) go to 30
            end if
            if(icon.eq.0) then
               if(ibtm.eq.0) ibtm=1
            end if
         end do
      end do
 30   continue
      return
      end

c     drw a 2D electron density map for quasicrystals
      subroutine map1(hmin,div,lf,ndiv,a,b,ii,iw,xy,ixm,iym,xz)
      dimension hmin(*),div(*),lf(*),a(*),b(*)
      dimension xy(0:ixm,0:iym),xz(0:ixm,0:iym)
      common /cjbc/ jbc,xs(6),iax(6)
      integer wtitl
      character(80) wtitle
      common /name/ wtitl,wts,angl,wtitle
      character(80) title, cmap
c     dimension ar(5000),br(5000)
      common /cdim/ idm,nde
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      include 'map.inc'
      include 'drwmap.inc'
      real rc(3),xb(ixmax),yb(ixmax)
      save shftx1,shfty1
c     character(100) wttitle
      data shftx1 /0./ shfty1/0./
c
c
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     ixm  : number of lattice points along x-axis
c     iym  : number of lattice points along y-axis
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ih,jh : size of to dimensional array xy
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             ixm and iym, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c
c
      call getamg(amagx,amagy)
      jbc=5
      if(abs(jbc).eq.1) then
          cmap='Fourier map '
      else if(abs(jbc).eq.2) then
          cmap='Fc Fourier map '
      else if(abs(jbc).eq.3) then
          cmap='D-Fourier map '
      else if(abs(jbc).eq.4) then
          cmap='Fo Patterson map '
      else if(abs(jbc).eq.5) then
          cmap='Fc Patterson map '
      end if
      dlm=2.1
c     plot boundary
      shftx1=shftx1+shftxb
      shfty1=shfty1+shftyb
      xpos=shftx1+(xmax-xmin)*amagx/2
      ypos=shfty1+(ymax-ymin)*amagy+0.5
      call writetitle(xpos,ypos)
      if(icase.le.3) then
         call getac(al,cl)
         divx=al/2
         divy=bl/2
         call drwbox(xmin,xmax,ymin,ymax,divx,divy,shftx1,shfty1)
      end if
      call getsmt(ismth)
      if(ismth.eq.1) then
         call smthxy1(xy,ixm,iym,xz)
      else if(ismth.eq.2) then
         call smthxy2(xy,ixm,iym,xz)
      else
c         call quit('invalid ismth')
      end if
c     if(icase.gt.0) then
c     coordinates on a contour line
      ibtm=0
      do nd=1,ndiv
         le=lf(nd)
         do l=1,le
c     al: hight
            al=hmin(nd)+div(nd)*float(l-1)
            fx=(xmax-xmin)/ixm
            fy=(ymax-ymin)/iym
            call contpl(xy,ixm+1,iym+1,al,1,ixm+1,1,iym+1,
     *           xmin,ymin,fx,fy,icon)
            if(icon.eq.1) then
               if(ibtm.eq.1) go to 30
            end if
            if(icon.eq.0) then
               if(ibtm.eq.0) ibtm=1
            end if
         end do
      end do
 30   continue
c     end if
      shftx2=shftxa+shftx1
      shfty2=shftya+shfty1
      return
      end

      subroutine writetitle(xpos,ypos)
      character(80) title
      include 'drwmap.inc'
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      call gettitle(title)
      call getamg(amagx,amagy)
      nch=istrln(title)
      ang=0
      write(6,*) 'title=',(title(i:i),i=1,nch)
      call csymbol(xpos,ypos,0.4,title,ang,nch)
      return
      end

      subroutine drwbox(xmin,xmax,ymin,ymax,divx,divy,shftxb,shftyb)
      real xb(7),yb(7)
      call getamg(amagx,amagy)
      xxa=xmin*amagx
      xxb=xmax*amagx
      yya=ymin*amagy
      yyb=ymax*amagy
      dvx=divx*amagx
      dvy=divy*amagy
      xb(1)=xxa
      yb(1)=yya
      xb(2)=xxb
      yb(2)=yya
      xb(3)=xxb
      yb(3)=yyb
      xb(4)=xxa
      yb(4)=yyb
      xb(5)=xxa
      yb(5)=yya

      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      x1=xb(1)-0.1
      y1=yb(1)-0.1
      x2=xb(3)+0.1
      y2=yb(3)+0.1
      x3=(-0.1+shftxb)/29.7
      y3=(-0.1+shftyb)/29.7
      x4=(xb(3)-xb(1)+0.1+shftxb)/29.7
      y4=(yb(3)-yb(1)+0.1+shftyb)/29.7

c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxys(x3,y3)
      call abtoxys(x4,y4)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
      call setxy0(1.,1.,0.,0)
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
c     call axs(xmin,xmax,ymin,ymax,divx,divy)
      call axs(xxa,xxb,yya,yyb,dvx,dvy)
      x1=xb(1)
      y1=yb(1)
      x2=xb(3)
      y2=yb(3)
      x3=(shftxb)/29.7
      y3=(shftyb)/29.7
      x4=(xb(3)-xb(1)+shftxb)/29.7
      y4=(yb(3)-yb(1)+shftyb)/29.7
c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxys(x3,y3)
      call abtoxys(x4,y4)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
c     call setxy0(1.,1.,0.,0)
      call setxyt(1.,1.,0.,0)
      return
      end

      subroutine getargri(br,bi,argr,argi)
      zbhkl=sqrt(br**2+bi**2)
      if(zbhkl.ne.0.0) then 
         argr=br/zbhkl
         argi=bi/zbhkl
      else
         argr=1.0
         argi=0.0
      end if
c     write(6,*) 'argr,argi=',argr,argi
      return
      end

      subroutine phsnga()  ! from qcmem.f
      include 'abcdri.inc'
      real zahkl,zbhkl,rbhkl,ibhkl
      integer hmax(6)
      include "nhmax.inc"
      complex fctmp,fctmp0,cexp

      integer hr(6),hi(6),hd(6)
      character brv
      integer getnt0,getnt,getnctr,getis,getnphase,getjp,gethkltoj
      complex getrefphs
      logical isMem
      data pi2/6.283184/
      return                    ! do not use this

      ntind=getnind()           ! get number of observed independent reflections
      nphas=getnphase()         ! number of fixed phases
      do i=nphas-1,nind-1
         zahkl=sqrt(ar0(i)**2+ai0(i)**2)
         j=hklo1d(i)            ! 1D index for observed reflection
         call getargri(br(j),bi(j),argr,argi) ! get phase from br,bi
         ar0(i)=zahkl*argr
         ai0(i)=zahkl*argi
      end do
      return
      end

      subroutine pahkl(ar,ai,ao,bo,hr,fact)  ! replace ar,ai by ao,bo
      integer hr(*)
      real ar(0:*)
      real ai(0:*)
      integer gethkltoj
      j=gethkltoj(hr)
      ar(j)=ao*fact             ! fo real part
      ai(j)=bo*fact             ! fo imaginary part
      return
      end



