c
c     subroutines for perspective view of a map
c

c     draw perspective map
      subroutine dispfn(xy,nx,nz,xmin,xmax,zmin,zmax,ymin,ymax,
     *     shftx,shfty)
      real xy(0:nx,0:nz)  ! function value defined in a box
      real uvw(3,3)
      common /cmtrx/uvw
      common /const/icymin,icymax,cy0,dh
      include 'ndmax.inc'
      parameter (ndmax1=ndmax+1)
c      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      real ud(3,4)
      real pr(3)
      common /cproj/ iproj,pr, shftz
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
c
c     x : i direction
c     z : j direction
c     y : function value = value of xy(i,j)
c     dh:interval of hight with one color
c     box : 2D area where the function is defined
c
      dh=1
      cy0=0
      icymin=ymin     ! minimum y value
      icymax=ymax     ! maximum y value

      call getamg(amagx,amagy)
c     4 corner vector of the box
      x1(1)=xmin*amagx   ! minimum x coordinate of a box
      x1(2)=0
      x1(3)=zmin*amagy   ! minimum z coordinate of a box
      x2(1)=xmax*amagx   ! maximum x coordinate of a box
      x2(2)=0
      x2(3)=zmin*amagy   ! minimum z coordinate of a box
      x3(1)=xmax*amagx   ! maximum x coordinate of a box
      x3(2)=0
      x3(3)=zmax*amagy   ! maximum z coordinate of a box
      x4(1)=xmin*amagx   ! minimum x coordinate of a box
      x4(2)=0
      x4(3)=zmax*amagy   ! maximum z coordinate of a box

      if(abs(pr(3)).lt.abs(pr(1))) then
          call quit('give abs(pr(2)) > abs(pr(1))')
      end if
c     center coordinates of the box
      do i=1,3
         r(i)=(x1(i)+x2(i)+x3(i)+x4(i))/4
      end do

      vb=x1(3)  ! minimum value of v
      vt=x3(3)  ! maximum value of v
      f(1)=1   ! magnification of u
      f(2)=1   ! magnification of v
      fz=1   ! magnification of w

      xd(1)=0   ! offset of u
      xd(2)=0   ! offset of v
      zd=0

      call setprjmtrx()
c     projection of the center
      call prj(r,ru)

c     projection of the 4 map corners
      call prj(x1,ud(1,1)) 
      call prj(x2,ud(1,2))
      call prj(x3,ud(1,3))
      call prj(x4,ud(1,4))
c     minimum and maximum u coordinates
      call getum(ud,umin,umax)

      x5=(shftx)/29.7
      y5=(shfty)/29.7
      x6=(umax-umin+shftx)/29.7   ! u offset
      y6=(x3(3)-x1(3)+shfty)/29.7 ! v offset

      call setxy0(1.,1.,0.,0)   ! use cartesian coordinates
      call abtoxys(x5,y5)
      call abtoxys(x6,y6)

      call window(umin,x1(3),umax,x3(3)) ! define window
      call viewpt(x5,y5,x6,y6)  ! set view port

c     call drwxline(xy,nx,nz)
c     call drwzline(xy,nx,nz)
      call drwlineij(1,3,xy,nx,nz)
      call drwlineij(3,1,xy,nz,nx)
      return
      end

      subroutine setprjmtrx()
      real pr(3)
      common /cproj/ iproj,pr, shftz
      real uvw(3,3)
      common /cmtrx/uvw
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd

c     define a transformation matrix
c     from x,y,z,1 to u,v,w,1 coordinate system
c     
c     uvw(1,1),uvw(1,2),uvw(1,3),shift1
c     uvw(2,1),uvw(2,2),uvw(2,3),shift2
c     uvw(3,1),uvw(3,2),uvw(3,3),shist3
c         0        0       0       1 
c
c     uvw(3,1),uvw(3,2),uvw(3,3):normalized pr(1),pr(2),pr(3)
c     (direction of projection)

      pn=sqrt(pr(1)**2+pr(2)**2+pr(3)**2)
      uvw(3,1)=pr(1)/pn
      uvw(3,2)=pr(2)/pn
      uvw(3,3)=pr(3)/pn
      if(uvw(3,1).eq.0.and.uvw(3,3).eq.0) then
c     projection parallel to y 
          uvw(1,1)=-uvw(3,2)
          uvw(1,2)=0
          uvw(1,3)=0
          uvw(2,1)=0
          uvw(2,2)=0
          uvw(2,3)=1
          ru(1)=-r(1)*uvw(3,2)
          ru(2)=r(3)
      else 
          ey=sqrt(uvw(3,1)**2+uvw(3,3)**2)
          uvw(1,1)=uvw(3,3)/ey
          uvw(1,2)=0
          uvw(1,3)=-uvw(3,1)/ey
          uvw(2,1)=uvw(3,2)*uvw(1,3)
          uvw(2,2)=ey
          uvw(2,3)=-uvw(3,2)*uvw(1,1)
      end if
      return
      end

c     minimum and maximum u coordinates
      subroutine getum(ud,umin,umax)
      real ud(3,*)
      umin=ud(1,1)
      umax=ud(1,1)
      do i=2,4
         if(ud(1,i).lt.umin) umin=ud(1,i)
         if(ud(1,i).gt.umax) umax=ud(1,i)
      end do
      return
      end

      real function getshftz()
      real pr(3)
      common /cproj/ iproj,pr, shftz
      getshftz=shftz
      return
      end

      subroutine initdrwline(nx,nz)
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
      real uvw(3,3)
      common /cmtrx/uvw
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd
      real dx(3)
      common /cdxdz/ dx,ul,ur
      dx(1)=(x3(1)-x1(1))/nx             ! x step
      dx(3)=(x3(3)-x1(3))/nz             ! z step
      ul=umin
      ur=umax
      return
      end

      subroutine initistat()
      include 'ndmax.inc'
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      do i=0,ndmax
         istat(i)=0
      end do
      return
      end

      subroutine geti123(i1,i2,i3,uvw33,nz)
      if(uvw33.ge.0) then          ! front to back
         i1=0                  ! initial z
         i2=nz                 ! final z 
         i3=1                  ! step
      else
         i1=nz                 ! initial z
         i2=0                  ! final z
         i3=-1                 ! step
      end if
      return
      end

      function getuw(uvw11)
      common /cuminmax/ umin,umax
      if(uvw11.gt.0) then
          getuw=umin
      else
          getuw=umax
      end if
      return
      end

      subroutine drwlineij(ii,jj,xy,nx,nz)
      real xy(0:nx,0:nz)        ! function value at (ix,iz)
c     call drwlineij0(ii,jj,xy,nx,nz)
      call drwlineij1(ii,jj,xy,nx,nz) ! under development
      return
      end

      subroutine drwlineij1(ii,jj,xy,nx,nz)
      real xy(0:nx,0:nz)        ! function value at (ix,iz)
      real x(3)
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
      real uvw(3,3)
      common /cmtrx/uvw
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd
      real dx(3)
      common /cdxdz/ dx,ul,ur
      include 'ndmax.inc'
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      real dxuvw(3)
      real u(3)

      mpl=3
      nxd=nx*mpl
      shftz = getshftz()
      call initdrwline(nx,nz)
      dxi=dx(ii)/mpl
      dxj=dx(jj)
      uw=getuw(uvw(1,ii))
      dxuvw(ii)=uvw(1,ii)*dxi
      dxuvw(jj)=uvw(1,jj)*dxj
      rzx=dxuvw(jj)/dxuvw(ii)
      call prj(x1,u)
      ua=u(1)-ru(1)
      ixda=int((ua-uw)/dxuvw(ii)+0.5)        ! number of points in a line
      ixdmx=abs(int((ur-ul)/dxuvw(ii)+0.5))  ! number of total divisions along u
      if(ixdmx.gt.ndmax) then
         write(6,*) 'ixdmx=',ixdmx,' ndmax=',ndmax
         call quit('ixdmx > ndmax')
      end if
c     initialize minimum and maximum function value at ixd
      call initistat()

      call geti123(i1,i2,i3,uvw(3,jj),nz)
c      write(6,*) 'i1,i2,i3,nz=',i1,i2,i3,nz
c      write(6,*) 'dx(ii),dx(jj)=',dx(ii),dx(jj)
c      write(6,*) 'ii,jj:',ii,jj
      do i=i1,i2,i3            ! change z value from front to back
         x(jj)=x1(jj)+i*dxj-r(jj)
         ioffs=int(ixda+i*rzx+0.5)
         n=0
         do j=0,nxd             ! scan j from minimum to maximum
                                ! x value from the center of the box
            x(ii)=x1(ii)+j*dxi-r(ii)
            modj=mod(j,mpl)
            jd=j/mpl
            if(jd.lt.nx) then
               if(ii.eq.1) then ! ii is 1 or 3
                  x(2)=xy(jd,i)+(xy(jd+1,i)-xy(jd,i))*modj/mpl
               else
                  x(2)=xy(i,jd)+(xy(i,jd+1)-xy(i,jd))*modj/mpl
               end if
            else
               if(ii.eq.1) then
                  x(2)=xy(jd,i)
               else
                  x(2)=xy(i,jd)
               end if
            end if
            x(2)=(x(2)+shftz)/100-r(2) ! y value 
            call drwfragment(n,x,j,ioffs,ixdmx)
         end do
         call drwln(xw,yw,n)
      end do
      return
      end

      subroutine drwlineij0(ii,jj,xy,nx,nz)
      real xy(0:nx,0:nz)        ! function value at (ix,iz)
      real x(3)
      real x1(3),x2(3),x3(3),x4(3),r(3)
      common /cdrwxz/x1,x2,x3,x4,r
      common /cuminmax/ umin,umax
      real uvw(3,3)
      common /cmtrx/uvw
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd
      real dx(3)
      common /cdxdz/ dx,ul,ur
      include 'ndmax.inc'
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      real dxuvw(3)
      real u(3)
      shftz = getshftz()
      call initdrwline(nx,nz)
      uw=getuw(uvw(1,ii))
      dxuvw(ii)=uvw(1,ii)*dx(ii)
      dxuvw(jj)=uvw(1,jj)*dx(jj)
      rzx=dxuvw(jj)/dxuvw(ii)
      call prj(x1,u)
      ua=u(1)-ru(1)
      ixda=int((ua-uw)/dxuvw(ii)+0.5)        ! number of points in a line
      ixdmx=abs(int((ur-ul)/dxuvw(ii)+0.5))  ! number of total divisions along u

      if(ixdmx.gt.ndmax) then
         call quit('ixdmx > ndmax')
      end if
c     initialize minimum and maximum function value at ixd
      call initistat()

      call geti123(i1,i2,i3,uvw(3,jj),nz)
c      write(6,*) 'i1,i2,i3,nz=',i1,i2,i3,nz
c      write(6,*) 'dx(ii),dx(jj)=',dx(ii),dx(jj)
      do i=i1,i2,i3            ! change z value from front to back
         x(jj)=x1(jj)+i*dx(jj)-r(jj)
         ioffs=int(ixda+i*rzx+0.5)
         n=0
         do j=0,nx        ! scan j from minimum to maximum
            x(ii)=x1(ii)+j*dx(ii)-r(ii)       ! x value from the center of the box
            if(ii.eq.1) then
               x(2)=xy(j,i)
            else
               x(2)=xy(i,j)
            end if
            x(2)=(x(2)+shftz)/100-r(2) ! y value 
            call drwfragment(n,x,j,ioffs,ixdmx)
         end do
         call drwln(xw,yw,n)
      end do
      return
      end

      subroutine drwfragment(n,x,iz,ioffs,izdmz)
      real x(3)
      real ru(3),f(3),xd(3)
      common /cdrwline/ ru,f,xd
      include 'ndmax.inc'
      real xw(ndmax+2),yw(ndmax+2)
      common /cxwyw/ xw,yw
      integer ckhide
      real u(3),un(3)
      call prj(x,u)             ! projection x,y,z onto u-v plane
      un(1)=f(1)*(u(1)+ru(1))+xd(1)
      un(2)=f(2)*(u(2)+ru(2))+xd(2)
      ihide=ckhide(un,iz,ioffs,izdmz)
      if(ihide.eq.0) then       ! visible
         n=n+1                  ! number of consecutive line fragments
         if(n.gt.ndmax) then
            write(6,*) 'n,ndmax=',n,ndmax
            call quit('n > ndmax')
         end if
         xw(n)=un(1)            ! store n-th u coordinate
         yw(n)=un(2)            ! store n-th v coordinate
      else
         call drwln(xw,yw,n)    ! drw a poly line and reset n
         n=1                    ! n=0
         xw(1)=un(1)            ! store n-th u coordinate
         yw(1)=un(2)            ! store n-th v coordinate
      end if
      return
      end

      subroutine prj(x,ru)  ! new x and y axis
      real x(3)
      real ru(*)
      real uvw(3,3)
      common /cmtrx/uvw
      ru(1)=uvw(1,1)*x(1)+uvw(1,2)*x(2)+uvw(1,3)*x(3)
      ru(2)=uvw(2,1)*x(1)+uvw(2,2)*x(2)+uvw(2,3)*x(3)
      return
      end

      integer function ckhide(xn,ix,ioffs,ixdmx)
      real xn(*)
      include 'ndmax.inc'
      parameter (ndmax1=ndmax+1)
      common /cynmx/ynmax(0:ndmax),ynmin(0:ndmax),istat(0:ndmax)
c     ixd        : ix-th u value
c     ynmax(ixd) : maximum v value at ixd
c     ynmin(ixd) : minimum v value at ixd
c     ioffs      : offset of u value at z

      ixd=ioffs+ix              ! ix-th u value
      if(ixd.lt.0.or.ixd.gt.ixdmx) then
         ckhide=1               ! set invisible or
         return                 ! ixd out of range
      end if

      if(istat(ixd).eq.0) then
         ynmax(ixd)=xn(2)
         ynmin(ixd)=xn(2)
         ivis=1                 ! visible
      else if(xn(2).ge.ynmax(ixd)) then
         ynmax(ixd)=xn(2)
         ivis=1                 ! visible
      else if(xn(2).le.ynmin(ixd)) then
         ynmin(ixd)=xn(2)
         ivis=1                 ! visible
      else
         ivis=0                 ! invisible
      end if
      istat(ixd)=1
      if(ivis.eq.1) then
         ckhide=0                ! visible
      else
         ckhide=1                ! set invisible
      end if
      return
      end
