      subroutine setqxqy(iax,iqx,iqy)
      integer iax(*)
      common /cqxqy/ iqxd(0:12),iqyd(0:12)
      include 'drwmap.inc'
      integer getjbc
      parameter (tau=1.618034)
      data (iqxd(i),i=0,12) /1,1,1,2,1,2,3,4,5,0,4,5,4/
      data (iqyd(i),i=0,12) /2,2,3,3,4,5,6,5,6,0,5,6,6/
      data pi /3.1415926536/
      call getsys(isys)
      iqx=iax(1)
      iqy=iax(2)
      fact=getfact(isys)
      write(6,*) 'iqx,iqy=',iqx,iqy
      if(getjbc().gt.0) then
         fx=getleng(iqx)*fact
         fy=getleng(iqy)*fact
      else
         fx=getleng0(iqx)*fact
         fy=getleng0(iqy)*fact
      end if
      write(6,*) 'fx,fy=',fx,fy
      call xscale(xmin,xmax,xdiv,fx)
      call xscale(ymin,ymax,ydiv,fy)
      return
      end

      subroutine setqxqyqz(iax,iqx,iqy,iqz)
      integer iax(*)
      common /cqxqy/ iqxd(0:12),iqyd(0:12)
      include 'drwmap.inc'
      integer getjbc
      iqx=iax(1)
      iqy=iax(2)
      iqz=iax(3)
      write(6,*) 'iqx,iqy,iqz=',iqx,iqy,iqz
      call getac(al,cl)
      call getsys(isys)
      fact=getfact(isys)
      if(getjbc().gt.0) then
         fx=getleng(iqx)*fact
         fy=getleng(iqy)*fact
         fz=getleng(iqz)*fact
      else
         fx=getleng0(iqx)*fact
         fy=getleng0(iqy)*fact
         fz=getleng0(iqz)*fact
      end if
      write(6,*) 'fx,fy,fz=',fx,fy,fz
      call xscale(xmin,xmax,xdiv,fx)
      call xscale(ymin,ymax,ydiv,fy)
      call xscale(zmin,zmax,zdiv,fz)
      return
      end
      
      function getleng(i)  ! get length of i-th axis
      common /cjbc/ jbc,xs(6),iax(6),ipers
      common /ctr/ itr(6,6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      real x(6),q(6)
c     do j=1,6
c     x(j)=itr(i,j)
c     end do
c     call getqe0(x,q)
c     getleng=vabs(q,3)
      call getsys(isys)
      if(isys.le.2) then
         getleng=al
      else
         if(i.ne.3) then
            getleng=al
         else
            getleng=cl
         end if
      end if
      return
      end

      function getleng0(i)  ! get length of i-th axis
      common /cjbc/ jbc,xs(6),iax(6),ipers
      common /ctr/ itr(6,6)
      real x(6),q(6)
      do j=1,6
         x(j)=itr(i,j)
      end do
      call getqe00(x,q)
      getleng0=vabs(q,3)
      return
      end

      subroutine xscale(xmin,xmax,xdiv,scl)
      xmin=xmin*scl
      xmax=xmax*scl
      xdiv=xdiv*scl
      return
      end

      subroutine readst1234()  ! read s and t matrices
      real s1(3,3),s2(3,3),s3(3,3),s4(3,3)
      real t1(3,3),t2(3,3),t3(3,3),t4(3,3)
      common /otrfm/ si(6,6),sr(6,6),ti(6,6),tr(6,6)
c     orthogonal transformation matrix s1, s2, s3, s4
      integer getjbc
      call freadrv('s1=',9,s1,1)
      call freadrv('s2=',9,s2,1)
      call freadrv('s3=',9,s3,1)
      call freadrv('s4=',9,s4,1)
      call trnsp3(s1)
      call trnsp3(s2)
      call trnsp3(s3)
      call trnsp3(s4)
      call buildst(s1,s2,s3,s4,sr,si)
      write(6,*) 'transformation matrix for q system'
      call wtmtrxrf('sr',sr,6,'(6f10.5)')
      call wtmtrxrf('si',si,6,'(6f10.5)')
      if(getjbc().eq.-1) then
         return
      end if
      call freadrv('t1=',9,t1,1)
      call freadrv('t2=',9,t2,1)
      call freadrv('t3=',9,t3,1)
      call freadrv('t4=',9,t4,1)
      call trnsp3(t1)
      call trnsp3(t2)
      call trnsp3(t3)
      call trnsp3(t4)
      call buildst(t1,t2,t3,t4,tr,ti)
      call wtmtrxrf('tr',tr,6,'(6f10.5)')
      call wtmtrxrf('ti',ti,6,'(6f10.5)')
      return
      end

      subroutine buildst(s1,s2,s3,s4,sr,si)
      real s1(3,3),s2(3,3),s3(3,3),s4(3,3),sr(6,6),si(6,6)
      real b(6),piv(6)
      integer ipv(6),ind(2*6)
      do i=1,3
         do j=1,3
            si(i,j)=s1(i,j)
            sr(i,j)=s1(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i+3,j+3)=s2(i,j)
            sr(i+3,j+3)=s2(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i,j+3)=s3(i,j)
            sr(i,j+3)=s3(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i+3,j)=s4(i,j)
            sr(i+3,j)=s4(i,j)
         end do
      end do
      call matinv(si,6,6,b,0,det,ipv,ind,piv)
      return
      end

      subroutine setd()
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
      common /cisys/ isys
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      common /cgetd/ det
      save icount
      real*4 sr,ct,c1,c2,c3,c4,s1,s2,s3,s4,su,cu
      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.618034,tav=-tau)
      parameter (sqr2=1.41421, sqr3=1.73205, tqr3=-sqr3)
      parameter (t1=0.70710678, t2=-0.70710678)
      parameter (u1=0.8660254, u2=-u1) 
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *     c2sr, s2sr, ct, c4sr, s1sr, cu,
     *     c2sr, s3sr, ct, c4sr, s4sr, cu,
     *     c1sr, s4sr, ct, c3sr, s2sr, cu,
     *     sr,   0.,   ct, su,   0.,   cu,
     *     c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *     tau, 0.,  1.,  -1,  0.,  tau,
     *     tau, 0., -1.,  -1., 0.,  tav,
     *     0.,  1., tav,   0., tau, 1.,
     *     -1., tau, 0.,  tav, -1., 0.,
     *     0.,  1., tau,   0., tau, -1./
c     for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *     c2, s2, 0., c1, s4, 0.,
     *     c2, s3, 0., c1, s1, 0.,
     *     c1, s4, 0., c2, s3, 0.,
     *     0., 0., 1., 0., 0., 0.,
     *     0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *     t1, t1, 0., t2, t1, 0.,
     *     0., 1., 0., 0.,-1., 0.,
     *     t2, t1, 0., t1, t1, 0.,
     *     0., 0., 1., 0., 0., 0.,
     *     0., 0., 0., 0., 0., 1./
c     for dodecagonal
      data d4/  1., 0., 0., 1., 0., 0.,
     *     u1, 0.5, 0., u2, 0.5, 0.,
     *     0.5, u1, 0., 0.5, u2, 0.,
     *     0., 1.,  0., 0., 1.,  0.,
     *     0., 0.,  1., 0., 0.,  0.,
     *     0., 0.,  0., 0., 0.,  1./
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c     initialize
         do i=1,6
            do j=1,6
               d0(i,j)=d0(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,6
               d1(i,j)=d1(i,j)/sqrt(1+tau**2)/2
            end do
         end do
         do i=1,6
            do j=1,4
               d2(i,j)=d2(i,j)/sqrt(5.)
            end do
         end do
         do i=1,6
            do j=1,4
               d3(i,j)=d3(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,4
               d4(i,j)=d4(i,j)/sqrt(2.)
            end do
         end do
         call trnsp(d0)
         call trnsp(d1)
         call trnsp(d2)
         call trnsp(d3)
         call trnsp(d4)
      end if
      if(isys.eq.0) then
         call setdqmtrx()       ! for semi quasicrystals
      else if(isys.eq.1) then
         call mcpy(d0,dq)       ! pentagonal distortion for icos
      else if(isys.eq.2) then
         call mcpy(d1,dq)       ! cubic distortion for icos
      else if(isys.eq.3) then
         call mcpy(d2,dq)       ! for decagonal
      else if(isys.eq.4) then
         call mcpy(d3,dq)       ! for octagonal
      else if(isys.eq.5) then
         call mcpy(d4,dq)
      else
         call quit('wrong isys')
      end if
      call setdr()
      call wtmtrxrf('dr',dr,6,'(6f8.4)')
      call wtmtrxrf('dq',dq,6,'(6f8.4)')
      return
      end

      subroutine setdr()
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      common /cgetd/ det
      real piv(6),b(6),det
      integer ipv(6),ind(6,2)
      call mcpy(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
      return
      end

      subroutine getdet(det0)
      common /cgetd/ det
      det0=det
      return
      end

      subroutine setdei()
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3)
      common /cphonn/ bmij1(3,3)
      real fij1(3,3),fij2(3,3),fij3(3,3),fij4(3,3),fij5(3,3),fij6(3,3)
      integer q50(6,6),q30(6,10),q20(6,15),q10d0(6),q2d0(6),qmd0(6)
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15),q10d(6),q2d(6),qmd(6)
      real ctoh(6,6),htoc(6,6),ded(6,6)
      dimension ipv(6),ind(6,2),piv(6),b(6)
      real wmij2(3,3),wmij3(3,3),wmij4(3,3)
      save icount
      data icount /0/
c     for pentagonal D5 and decagonal
      data fij1 /0,0,0,0,0,0,0,0,1/
      data fij2 /1,0,0,0,0,0,0,0,0/
      data fij3 /0,0,0,0,1,0,0,0,0/
c     for cubic T and trigonal 
      data fij4 /1,0,0,0,1,0,0,0,1/
      data fij5 /0,0,0,0,0,0,0,0,1/
      data fij6 /1,0,0,0,1,0,0,0,0/
      data ctoh /0.0,     -0.816496, 0.816496, 0., 0., 0.,
     *     0.816496,-0.816496, 0.0,      0., 0., 0.,
     *     0.577350, 0.577350, 0.577350, 0., 0., 0.,
     *     0., 0., 0., 0.0,     -0.816496, 0.816496,
     *     0., 0., 0., 0.816496,-0.816496, 0.0,
     *     0., 0., 0., 0.577350, 0.577350, 0.577350/
      data q50/1,0,0,0,0,0,     ! 1
     *     0,1,0,0,0,0,         ! 2
     *     0,0,1,0,0,0,         ! 3
     *     0,0,0,1,0,0,         ! 4
     *     0,0,0,0,1,0,         ! 5
     *     0,0,0,0,0,1/         ! 6
      data q30/1,1,1,0,0,0,     ! 1
     *     1,0,1,1,0,0,         ! 2
     *     1,0,0,1,1,0,         ! 3
     *     1,0,0,0,1,1,         ! 4
     *     1,1,0,0,0,1,         ! 5  3-fold axis in cubic approximant
     *     0,1,1,0,-1,0,        ! 6
     *     0,0,1,1,0,-1,        ! 7
     *     0,-1,0,1,1,0,        ! 8
     *     0,0,-1,0,1,1,        ! 9
     *     0,1,0,-1,0,1/        ! 10
      data q20/1,1,0,0,0,0,     ! 1
     *     1,0,1,0,0,0,         ! 2
     *     1,0,0,1,0,0,         ! 3
     *     1,0,0,0,1,0,         ! 4  y-axis in cubic approximant
     *     1,0,0,0,0,1,         ! 5
     *     0,1,1,0,0,0,         ! 6  x-axis in cubic approximant
     *     0,0,1,1,0,0,         ! 7
     *     0,0,0,1,1,0,         ! 8
     *     0,0,0,0,1,1,         ! 9
     *     0,1,0,0,0,1,         ! 10
     *     0,1,0,0,-1,0,        ! 11
     *     0,0,1,0,0,-1,        ! 12
     *     0,-1,0,1,0,0,        ! 13
     *     0,0,-1,0,1,0,        ! 14  normal to 3-fold axis in cubic apprx.
     *     0,0,0,-1,0,1/        ! 15  z-axis in cubic approximant
      data q10d0 /0,0,0,0,1,0/
      data q2d0  /1,1,1,1,0,0/
      data qmd0  /1,0,0,-1,0,0/
      icount=icount+1
      if(icount.eq.1) then
         call trnsp(ctoh)
         call mcpy(ctoh,htoc)
         call matinv(htoc,6,6,b,0,det,ipv,ind,piv)
         call getsys(isys)
         do i=1,6
            call getqi0(q50(1,i),q5p(1,i))
            call norml(q5p(1,i),3)
            call norml(q5p(4,i),3)
         end do
         do i=1,10
            call getqi0(q30(1,i),q3p(1,i))
            call norml(q3p(1,i),3)
            call norml(q3p(4,i),3)
         end do
         do i=1,15
            call getqi0(q20(1,i),q2p(1,i))
            call norml(q2p(1,i),3)
            call norml(q2p(4,i),3)
         end do
         call getqi0(q10d0,q10d)
         call norml(q10d(1),3)
         call norml(q10d(4),3)
         call getqi0(qmd0,qmd)
         call norml(qmd(1),3)
         call norml(qmd(4),3)
         call getqi0(q2d0,q2d)
         call norml(q2d(1),3)
         call norml(q2d(4),3)
         if(isys.eq.1) then
c     Y. Ishii, Phys Rev. B39 (1989) 11862
c     D5 distortion
            call mcpy3(fij1,amij1)
            call mcpy3(fij2,amij2)
            call mcpy3(fij3,amij3)
            call mcpy3(fij1,bmij1)
         else if(isys.eq.2) then
c     T distortion  : eps1
            call mcpy3(fij4,amij1)
c     D3 phason distortion : eps2
            call mcpy3(fij5,amij2)
            call mcpy3(fij6,amij3)
c     D3 phonon distortion : eps4
            call mcpy3(fij5,bmij1)
            call getwmij(amij2,wmij2,ctoh,htoc)
            call getwmij(amij3,wmij3,ctoh,htoc)
            call getwmij(bmij1,wmij4,ctoh,htoc)
c     else if(isys.eq.3) then
         else if(isys.ge.3) then
c     orthorhombic phason strain
            call mcpy3(fij1,amij1)
            call mcpy3(fij2,amij2)
            call mcpy3(fij3,amij3)
         end if
         write(6,*) 'amij1='
         write(6,'(3f9.5)') ((amij1(i,j),j=1,3),i=1,3)
         if(isys.eq.2) then
            write(6,*) 'amij2='
            write(6,'(3f9.5)') ((wmij2(i,j),j=1,3),i=1,3)
            write(6,*) 'amij3='
            write(6,'(3f9.5)') ((wmij3(i,j),j=1,3),i=1,3)
            write(6,*) 'bmij1='
            write(6,'(3f9.5)') ((wmij4(i,j),j=1,3),i=1,3)
         else
            write(6,*) 'amij2='
            write(6,'(3f9.5)') ((amij2(i,j),j=1,3),i=1,3)
            write(6,*) 'amij3='
            write(6,'(3f9.5)') ((amij3(i,j),j=1,3),i=1,3)
            write(6,*) 'bmij1='
            write(6,'(3f9.5)') ((bmij1(i,j),j=1,3),i=1,3)
         end if
      end if
      if(isys.ne.2) then
         do i=1,6
            de(i,i)=1
            di(i,i)=1
         end do
         do i=4,6
            do j=1,3
               de(i,j)=eps1*amij1(i-3,j)+eps2*amij2(i-3,j)+
     *              eps3*amij3(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps4*bmij1(i,j)
            end do
         end do
      else if(isys.eq.2) then
         do i=1,6
            de(i,i)=1
         end do
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps4*bmij1(i,j)
            end do
         end do
         call mtmpl(de,ctoh,ded)
         call mtmpl(htoc,ded,de)
         do i=4,6
            do j=1,3
               de(i,j)=de(i,j)+eps1*amij1(i-3,j)
            end do
         end do         
      end if
      call mcpy(de,di)
      call matinv(di,6,6,b,0,det,ipv,ind,piv)
      call wtmtrxrf('deformation matrix de',de,6,'(6f8.4)')
      call wtmtrxrf('deformation matrix di',di,6,'(6f8.4)')
      return
      end

      subroutine getqi00(h,q)
      integer h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+h(j)*dq(j,i)
         end do
      end do
      return
      end

      subroutine getqi0(h,q)
      integer h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      call getqi00(h,q)
      call rltscale(q)
      return
      end

      subroutine getqi(h,q)
      integer h(*)
      real q(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getqi00(h,qd)
c     phason distortion in reciprocal space
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+qd(j)*di(j,i)
         end do
      end do
      call rltscale(q)
      return
      end

      subroutine getqe00(x,q)
      real x(*),q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+dr(i,j)*x(j)
         end do
      end do
      return
      end

      subroutine getqe0(x,q)
      real x(*),q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getqe00(x,q)
      call ltscale(q)
      return
      end

      subroutine ltscale(q)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      do i=1,6
         if(isys.le.2) then
            if(i.le.3) then
               q(i)=q(i)*al
            else
               q(i)=q(i)*al
            end if
         else
            if(i.le.2) then
               q(i)=q(i)*al
            else if(i.eq.3) then
               q(i)=q(i)*cl
            else if(i.le.5) then
               q(i)=q(i)*al
            end if
         end if
      end do
      return
      end

      subroutine deform(qd,q)
      real q(*),qd(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+de(j,i)*qd(j)
         end do
      end do
      return
      end

      subroutine getqe(x,q)
      real x(*),q(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getqe00(x,qd)
      call deform(qd,q)
      call ltscale(q)
      return
      end

      subroutine getxe(q,x)
      real q(*),x(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call vcpyr(q,qd,6)
      call rltscale(qd)
      call getxe00(qd,x)
      return
      end

      subroutine rltscale(q)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      do i=1,6
         if(isys.le.2) then
            if(i.le.3) then
               q(i)=q(i)/al
            else
               q(i)=q(i)/al
            end if
         else
            if(i.le.2) then
               q(i)=q(i)/al
            else if(i.eq.3) then
               q(i)=q(i)/cl
            else if(i.le.5) then
               q(i)=q(i)/al
            end if
         end if
      end do
      return
      end

      subroutine getxe00(q,x)
      real q(*),x(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      do i=1,6
         x(i)=0.
         do j=1,6
            x(i)=x(i)+dq(i,j)*q(j)
         end do
      end do
      return
      end

      subroutine setac(a,c)
      real dr,dq
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      if(isys.le.2) then
         al=a
         cl=a
      else
         al=a
         cl=c
      end if
      return
      end

      subroutine seteps(eps1d,eps2d,eps3d,eps4d)
      real dr,dq
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      eps1=eps1d
      eps2=eps2d
      eps3=eps3d
      eps4=eps4d
      return
      end

      subroutine mtrtns()
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      common /cmtrt/ gab(6,6)
      real dt(6,6)
      call getsys(isys)
      call mcpy(dr,dt)
      call trnsp(dt)
      do i=1,6
         do j=1,6
            gab(i,j)=vinp(dt(1,i),dt(1,j),6)*al**2
         end do
      end do
      if(isys.ge.3) then
         gab(5,5)=gab(5,5)*cl**2/al**2
      end if
      return
      end

      subroutine getqir(h,q)
      real h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      call getsys(isys)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+h(j)*dq(j,i)
         end do
      end do
      call rltscale(q)
      return
      end

      subroutine getac(a,c)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,cl,eps1,eps2,eps3,eps4
      a=al
      c=cl
      return
      end

      subroutine setumtrx(isetting)  ! set 6x3 u matrix
      common /cu1u2/ u1(3,3),u2(3,3)
      common /cuvmtrx/ u(6,3), v(6,3)
      call setu1mtrx(isetting)
      call setu2mtrx()
      do i=1,3
         do j=1,3
            u(i,j)=u1(i,j)
            u(i+3,j)=u2(i,j)
         end do
      end do
      return
      end

      subroutine  setu1mtrx(isetting)
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      common /kwave/ y(3,3,3),vc(3)
      common /cu1u2/ u1(3,3),u2(3,3)
c     calculate
c      integer getisys
c      isys=getisys()
      call getsys(isys)
      sqrtd=sqrt(1.0-cosas**2-cosbs**2-coscs**2+
     *        2.0*cosas*cosbs*coscs)
      if(isetting.eq.3) then
         u1(1,1)=as
         u1(1,2)=0.0
         u1(1,3)=0.0
         u1(2,1)=bs*coscs
         u1(2,2)=bs*sincs
         u1(2,3)=0.0
         u1(3,1)=cs*cosbs
         u1(3,2)=cs*(cosas-cosbs*coscs)/sincs
         u1(3,3)=cs*sqrtd/sincs
      else if(isetting.eq.2) then
         u1(1,1)=as*sqrtd/sinas
         u1(1,2)=as*coscs
         u1(1,3)=as*(cosbs-coscs*cosas)/sinas
         u1(2,1)=0
         u1(2,2)=bs
         u1(2,3)=0
         u1(3,1)=0
         u1(3,2)=cs*cosas
         u1(3,3)=cs*sinas
      else if(iseitting.eq.1) then
         u1(1,1)=as*sinbs
         u1(1,2)=0
         u1(1,3)=as*cosbs
         u1(2,1)=bs*(coscs-cosas*cosbs)/sinbs
         u1(2,2)=bs*sqrtd/sinbs
         u1(2,3)=bs*cosas
         u1(3,1)=0
         u1(3,2)=0
         u1(3,3)=cs
      end if
      return
      end

      subroutine  setu2mtrx()
      common /kwave/ y(3,3,3),vc(3)
      common /cu1u2/ u1(3,3),u2(3,3)
      do i=1,3
         do j=1,3
            u2(i,j)=0
            do k=1,3
               u2(i,j)=u2(i,j)+y(k,i,1)*u1(k,j)
            end do
         end do
      end do
      return
      end

      subroutine readlc()
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      call freadr('a=',1,a,1)
      call freadr('b=',1,b,0)
      call freadr('c=',1,c,0)
      call freadr('cosa=',1,cosa,0)
      call freadr('cosb=',1,cosb,0)
      call freadr('cosc=',1,cosc,0)
      sina=sqrt(1.0-cosa**2)
      sinb=sqrt(1.0-cosb**2)
      sinc=sqrt(1.0-cosc**2)
      return
      end

      subroutine calltcs() ! calculate lattice const in reciprocal space
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      real gabs(3,3),bd(3),piv(3)
      integer ip(3),indx(6)
      gabs(1,1)=a*a
      gabs(2,2)=b*b
      gabs(3,3)=c*c
      gabs(1,2)=a*b*cosc
      gabs(1,3)=a*c*cosb
      gabs(2,3)=b*c*cosa
      gabs(2,1)=gabs(1,2)
      gabs(3,1)=gabs(1,3)
      gabs(3,2)=gabs(2,3)
      call matinv(gabs,3,3,bd,0,det,ip,indx,piv) !  matrix inversion of gabs
      as=sqrt(gabs(1,1))
      bs=sqrt(gabs(2,2))
      cs=sqrt(gabs(3,3))
      cosas=gabs(2,3)/bs/cs
      cosbs=gabs(3,1)/cs/as
      coscs=gabs(1,2)/as/bs
      sinas=sqrt(1.0-cosas**2)
      sinbs=sqrt(1.0-cosbs**2)
      sincs=sqrt(1.0-coscs**2)
      return
      end

      subroutine rdkvctr(ndm)
      common /kwave/ y(3,3,3),vc(3)
      call freadi('ndm=',1,ndm,1)
      do i=1,ndm
         call freadrv('k=',3,y(1,i,1),1)
      end do
      return
      end

      subroutine readVmtrx()
      common /cuvmtrx/ u(6,3), v(6,3)
      call freadi('iseging=',1,iseting,1)
      call freadrv('v=',18,v,0)
      return
      end

      subroutine setdqmtrx()
      common /cuvmtrx/ u(6,3), v(6,3)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *     al,cl,eps1,eps2,eps3,eps4
      do i=1,6
         do j=1,3
            dq(i,j)=u(i,j)
            dq(i,j+3)=v(i,j)
         end do
      end do
      return
      end
