      subroutine getsx0(ik,h,ncmp,nkgrp,kgrp)
      integer h(*)
      integer kgrp(*)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sx10(3,3),sx20(3,3)
      common /cgetsx0/ sx10,sx20
      complex ph
      integer hr(6)
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex cssnph1,cssnph2
      complex pi2
      data pi2/(0.,6.28318)/

      call getndm(ndm)
      do i=1,ncmp
         do j=1,ncmp
            sx10(i,j)=(0.,0.)    ! for ics=1
            sx20(i,j)=(0.,0.)    ! for ics=2
         end do
      end do

c      write(6,*) 'nkgrp=',nkgrp
c      write(6,*) 'kgrp=',(kgrp(i),i=1,nkgrp)

      do nsd=1,nkgrp
         ns=abs(kgrp(nsd))
         if(kgrp(nsd).gt.0) then
            sgn=1
         else
            sgn=-1
         end if
         nsi=iskis(ns,ik)       ! inverse operator of ns
c        write(6,*) 'ns=',ns,' nsi=',nsi

         call gethrs(h,hr,nsi,ik)  ! site symmetry operation
         ph=cexp(-pi2*vinpir(hr(4),ts(4,ns,ik),ndm))/nkgrp
         cs=1
         sn=sgn
         cssnph1=cmplx(cs,0.0)*ph ! for cosine wave
         cssnph2=cmplx(0.0,sn)*ph ! for sine wave
         do i=1,ncmp
            do j=1,ncmp
               sx10(i,j)=sx10(i,j)+rs(i,j,ns,ik)*cssnph1
               sx20(i,j)=sx20(i,j)+rs(i,j,ns,ik)*cssnph2
            end do
         end do   
      end do                    ! ns loop
      
c      write(6,*) 'sx10'
c      call wtcmtrx(sx10,3,ncmp)
c      write(6,*) 'sx20'
c      call wtcmtrx(sx20,3,ncmp)
      return
      end

      subroutine getsb0(ik,h,ncmp,nkgrp,kgrp)
      integer h(*)
      integer kgrp(*)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sb10(9,9),sb20(9,9)
      common /cgetsb0/ sb10,sb20
      complex ph
      integer hr(6)
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex cssnph1,cssnph2
      complex pi2
      data pi2/(0.,6.28318)/

      call getndm(ndm)
      do i=1,ncmp
         do j=1,ncmp
            sb10(i,j)=(0.,0.)    ! for ics=1
            sb20(i,j)=(0.,0.)    ! for ics=2
         end do
      end do
      
      do nsd=1,nkgrp
         ns=abs(kgrp(nsd))
         if(kgrp(nsd).gt.0) then
            sgn=1
         else
            sgn=-1
         end if
         nsi=iskis(ns,ik)       ! inverse operator of ns
         call gethrs(h,hr,nsi,ik)
         ph=cexp(-pi2*vinpir(hr(4),ts(4,ns,ik),ndm))/nkgrp
         cs=1
         sn=sgn
         cssnph1=cmplx(cs,0.0)*ph ! for cosine wave
         cssnph2=cmplx(0.0,sn)*ph ! for sine wave
         do i=1,ncmp
            call jtokl(i,l1,j1) ! 1-9
            do j=1,ncmp
               call jtokl(j,l2,j2)
               sb10(i,j)=sb10(i,j)+
     *              rsymtns(rs(1,1,ns,ik),l1,l2,j1,j2)*
     *              cssnph1
               sb20(i,j)=sb20(i,j)+
     *              rsymtns(rs(1,1,ns,ik),l1,l2,j1,j2)*
     *              cssnph2
            end do
         end do   
      end do                    ! ns loop
      
c      write(6,*) 'sb10'
c      do i=1,ncmp
c         write(6,'(6f10.5)') (sb10(i,j),j=1,ncmp)
c      end do
c      write(6,*) 'sb20'
c      do i=1,ncmp
c         write(6,'(6f10.5)') (sb20(i,j),j=1,ncmp)
c      end do
      return
      end

c           call getsx(ne,ik,h,ncmp,nkstr,kstr)  ! get sx1,sx2
      subroutine getsx(ne,ik,h,ncmp,nkstr,kstr)
      integer h(*)
      integer kstr(6,*)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sx1(3*nksmax,3*nksmax),sx2(3*nksmax,3*nksmax)
      common /cgetsx/ sx1,sx2
      complex ph
      integer iprm(100)    ! permutation of kstar by site symmetry op.
      integer hr(6)
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex cssnph1,cssnph2
      complex pi2
      data pi2/(0.,6.28318)/

      call getndm(ndm)
      do i=1,ncmp*nkstr
         do j=1,ncmp*nkstr
            sx1(i,j)=(0.,0.)    ! for ics=1
            sx2(i,j)=(0.,0.)    ! for ics=2
         end do
      end do
      
      do ns=1,ne
         nsi=iskis(ns,ik)       ! inverse operator of ns
         call permut(nsi,ik,kstr,nkstr,iprm) ! permutation of kstar
         call gethrs(h,hr,nsi,ik)
         ph=cexp(-pi2*vinpir(hr(4),ts(4,ns,ik),ndm))/ne
         do l=1,nkstr
            k=abs(iprm(l))      ! delta_k,l
            cs=1
            sn=sign(1,iprm(l))  ! 1 or -1 for k and -k
            cssnph1=cmplx(cs,0.0)*ph ! for cosine wave
            cssnph2=cmplx(0.0,sn)*ph ! for sine wave
            do i=1,ncmp
               do j=1,ncmp
                  id=i+(k-1)*ncmp
                  jd=j+(l-1)*ncmp
                  sx1(id,jd)=sx1(id,jd)+rs(i,j,ns,ik)*cssnph1
                  sx2(id,jd)=sx2(id,jd)+rs(i,j,ns,ik)*cssnph2
               end do
            end do   
         end do
      end do                    ! ns loop
c      write(6,*) 'sx1'
c      call wtcmtrx(sx1,90,ncmp*nkstr)
c      write(6,*) 'sx2'
c      call wtcmtrx(sx2,90,ncmp*nkstr)
      return
      end
      
      subroutine getsp(ne,ik,h,ncmp,nkstr,kstr)
      integer h(*)
      integer kstr(6,*)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sp1(nksmax,nksmax),sp2(nksmax,nksmax)
      common /cgetsp/ sp1,sp2
      complex ph
      integer iprm(100)    ! permutation of kstar by site symmetry op.
      integer hr(6)
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex cssnph1,cssnph2
      complex pi2
      data pi2/(0.,6.28318)/

      call getndm(ndm)      
      do i=1,nkstr
         do j=1,nkstr
            sp1(i,j)=(0.,0.)    ! for ics=1
            sp2(i,j)=(0.,0.)    ! for ics=2
         end do
      end do
      
      do ns=1,ne
         nsi=iskis(ns,ik)       ! inverse operator of ns
         call permut(nsi,ik,kstr,nkstr,iprm) ! permutation of kstar
         call gethrs(h,hr,nsi,ik)
         ph=cexp(-pi2*vinpir(hr(4),ts(4,ns,ik),ndm))/ne
         
         do l=1,nkstr
            k=abs(iprm(l))      ! delta_k,l
            cs=1
            sn=sign(1,iprm(l))
            cssnph1=cmplx(cs,0.0)*ph
            cssnph2=cmplx(0.0,sn)*ph
            sp1(k,l)=sp1(k,l)+cssnph1
            sp2(k,l)=sp2(k,l)+cssnph2
         end do
      end do                    ! ns loop
      return
      end

      subroutine getsb(ne,ik,h,ncmp,nkstr,kstr)
      integer h(*)
      integer kstr(6,*)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sb1(9*nksmax,9*nksmax),sb2(9*nksmax,9*nksmax)
      common /cgetsb/ sb1,sb2
      complex ph
      integer iprm(100)    ! permutation of kstar by site symmetry op.
      integer hr(6)
      integer rs
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex cssnph1,cssnph2
      complex pi2
      data pi2/(0.,6.28318)/

      call getndm(ndm)
      do i=1,ncmp*nkstr
         do j=1,ncmp*nkstr
            sb1(i,j)=(0.,0.)    ! for ics=1
            sb2(i,j)=(0.,0.)    ! for ics=2
         end do
      end do
      
      do ns=1,ne
         nsi=iskis(ns,ik)       ! inverse operator of ns
         call permut(nsi,ik,kstr,nkstr,iprm) ! permutation of kstar
         call gethrs(h,hr,nsi,ik)
         ph=cexp(-pi2*vinpir(hr(4),ts(4,ns,ik),ndm))/ne
         
         do l=1,nkstr
            k=abs(iprm(l))      ! delta_k,l
            cs=1
            sn=sign(1,iprm(l))
            cssnph1=cmplx(cs,0.0)*ph
            cssnph2=cmplx(0.0,sn)*ph
            do ll=1,ncmp
               call jtokl(ll,l1,j1) ! 1-9
               do jj=1,ncmp
                  call jtokl(jj,l2,j2)
                  i1=ll+(k-1)*ncmp
                  k1=jj+(l-1)*ncmp
                  sb1(i1,k1)=sb1(i1,k1)+
     *                 rsymtns(rs(1,1,ns,ik),l1,l2,j1,j2)*
     *                 cssnph1
                  sb2(i1,k1)=sb2(i1,k1)+
     *                 rsymtns(rs(1,1,ns,ik),l1,l2,j1,j2)*
     *                 cssnph2
               end do
            end do   
         end do
      end do                    ! ns loop
c      write(6,*) 'sb1'
c      call wtcmtrx(sb1,270,ncmp*nkstr)
c      write(6,*) 'sb2'
c      call wtcmtrx(sb2,270,ncmp*nkstr)
      return
      end

c     version currently used
      subroutine splpos1(na,isk,irs,isub,ja,ea,nx,nc,jw) 
      integer isk(0:48,*),irs(0:48,*),isub(*),ja(4,*)
      real ea(*)
      integer nks(100)          ! local nks
      integer n1(100),n2(100),n3(100)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer h(6)
      integer hr(6)
      integer kstr(6,120),kstr0(6,120)
      integer kind(6,120)
      integer rd(20*20*120)
      include "remos.inc"
      common /ciskis/ iskis(0:48,natom)
      complex sx1(3*nksmax,3*nksmax),sx2(3*nksmax,3*nksmax)
      common /cgetsx/ sx1,sx2
      complex sp1(nksmax,nksmax),sp2(nksmax,nksmax)
      common /cgetsp/ sp1,sp2
      complex sb1(9*nksmax,9*nksmax),sb2(9*nksmax,9*nksmax)
      common /cgetsb/ sb1,sb2

      complex sx10(3,3),sx20(3,3)
      common /cgetsx0/ sx10,sx20
      complex sb10(9,9),sb20(9,9)
      common /cgetsb0/ sb10,sb20

      complex x(9*nksmax),y(9*nksmax),ph,cssnph1,cssnph2
      complex ys(9*nksmax,9*nksmax),ys0(9*nksmax,9*nksmax)
      complex ys1(9*nksmax,9*nksmax),ys2(9*nksmax,9*nksmax)
      complex ys3(9*nksmax,9*nksmax),ys00(81)
      integer indx(9*nksmax,9*nksmax)
      common /citfs/ itfs(natom)
      integer sctmdl
      common /jobctl/ sctmdl,itempf,itwin,volr(48)
      integer getijk
      integer rs                ! site symmetry operators
      real ts
      common /csitesy/ rs(6,6,48,natom),ts(6,48,natom),nss(natom)
      complex crd,getcrd
      real rsymtns,rasymtns
      integer korg(100),ksgn(100),korg0(100)
      integer nkgrp,kgrp(48)
      integer iprm(100)         ! permutation of kstar by site symmetry op.
      real sn
      integer irs0(0:48)
      integer getm123

      complex pi2
      data pi2 /(0.,6.28318)/

      call getn123(n1,n2,n3)
      call getnw0(nw0)

c      write(6,*) 'n1,n2,n3,nw0=',(n1(j),n2(j),n3(j),j=1,nw0),nw0
c     kstar : number of kstar vectors
c     3*kstar
c     generate projection operators

*********************not implemented yet********************************
c     if(ja(4,i)>1 chose appropriate independent parameters between them
c     and replace the order so that the independent parameters appear first
c     in ja(1,*),ja(2,*),ja(3,*) and 1xc1 etc
************************************************************************

      write(6,*) 'refinable parameters'
      write(6,*) ' digit after the + or - sign is a factor',
     *     ' multiplied by a parameter'
      write(6,*) '   (t after the + or - sign if any means sqrt(3))'
      write(6,*) ' x,y,z,b,p mean positional, thermal and',
     *     ' occupational parameters'
      write(6,*) ' b1,b2,..b6 are b11, b22, b33, b23, b31, b32'
c     write(6,*) ' u1,u2,..u6 are u11, u22, u33, u23, u31, u32'
      write(6,*) ' c or s means cos or sin term'
      write(6,*) ' digit after c or s means kstar number'
      call setiskis(na)         ! calculate sitesymmetry operators
      call getiskis(iskis,na)   ! its inverse operator
      call getnde(nde)
      call getidm(idm)

      write(6,*) 'nde,idm=',nde,idm

      ndm=abs(nde)

      ii=0                      ! number of independent parameters
      ic=0                      ! number of refinable parameters
c      write(6,*) 'isub=',(isub(j),j=1,na)
      do ik=1,na                ! atom loop
         if(itempf.eq.0) then
            it=0
         else if(itempf.gt.0) then
            it=1
         else if(itempf.lt.0) then
            it=itfs(ik)
         end if
         js=isub(ik)            ! js-th substructure
         if(js.eq.0) then
            call quit('isub invalid in splpos1')
         end if
         ne=nss(ik)             ! number of site symmetry operators
c        write(6,*) 'site symmetry operators'
c        call wtsymo(rs(1,1,1,ik),ts(1,1,ik),ne,idm)
         call zerovi(korg0,100)
         n0=0
         nk0=0
         do nk=1,nw0
            call resetiskp()    ! for counting k-vectors used
c           nks(nk)=0
            m1=n1(nk)
            m2=n2(nk)
            m3=n3(nk)
            call getirs0(irs0)   ! irs for total symmetry
            call getkstr(m1,m2,m3,irs0,js,nkstr0,kstr0) ! get kstr0
 10         continue
            nk0=nk0+1           ! number of representatives of k-stars
            nks(nk0)=0
            call getkgrp(m1,m2,m3,irs(0,ik),js,nkgrp,kgrp)
            call getkstr(m1,m2,m3,irs(0,ik),js,nkstr,kstr) 
c           write(6,*) 'm1,m2,m3=',m1,m2,m3
            do k=1,nkstr
               call wtkstr('kstr in splpos1=',kstr,k)
            end do
c           call getrd(nkstr,kstr,irs(0,ik),ik,rd) ! get rd
            do kd=1,nkstr
               call calkorg(kstr(4,kd),korg(kd),ksgn(kd),js)
                                !   korg(kd) original k number
                                !   ksgn(kd) sign
c              write(6,*) 'korg',korg(kd)
            end do
            call setkorg(korg,ksgn,nkstr)

            if(jw.eq.1) then
               write(6,*) ' '
               write(6,'(a,$))') 'kster '
               do n=1,nkstr
                  write(6,'(1x,i2,a,3i3,a,$)') korg(n),
     *                 ' (',(kstr(k,n)*ksgn(n),k=4,6),')'
               end do
            end if
            n0=n0+nkstr

            m1=kstr(4,1)
            m2=kstr(5,1)
            m3=kstr(6,1)

c            write(6,*) 'm1,m2,m3=',m1,m2,m3
c            if(m1.eq.0.and.m2.eq.0.and.m3.eq.0) then
c               icse=1
c            else
c               icse=2
c            end if

            h(1)=0
            h(2)=0
            h(3)=0
            h(4)=m1
            h(5)=m2
            h(6)=m3
            
            if(nkstr.gt.120) then
               call quit('nkstr > 120')
            end if

            ncmp=3              !  initialization for x,y,z
            call setncmp(ncmp)

            call getsx0(ik,h,ncmp,nkgrp,kgrp)    ! get sx10,sx20
            if(m1.eq.0.and.m2.eq.0.and.m3.eq.0) then
               call getys00(sx10,sx20,3,ncmp,1,nindx0,ys00)
c               write(6,*) 'nindx0=',nindx0
c               do j=1,nindx0
c                  io=(j-1)*ncmp
c                  write(6,'(a,6f10.5)') 'ys00=',(ys00(k+io),k=1,3)
c               end do
            else
               call getys0(sx10,sx20,3,ncmp,1,nindx0,ys00)
c               write(6,*) 'nindx0=',nindx0
c               do j=1,nindx0
c                  io=(j-1)*ncmp
c                  write(6,'(a,6f10.5)') 'ys00=',(ys00(k+io),k=1,3)
c               end do
            end if

            call getsx(ne,ik,h,ncmp,nkstr,kstr)  ! get sx1,sx2
            call getys(ys00,3,nindx0,sx1,sx2,3*nksmax,ncmp,nkstr,
     *           nindx,ys0)
c            call getjax(ik,ys0,ncmp,nkstr,nindx,ja,ea,ii,ic,nks,nk)
            call getjax(ik,ys0,ncmp,nkstr,nindx,ja,ea,ii,ic,nks,nk0)

            ncmp=1              !  initialization for p,b
            call setncmp(ncmp)
            call getsp(ne,ik,h,ncmp,nkstr,kstr)  ! get sp1,sp2

            nindp0=0
            if(m1.eq.0.and.m2.eq.0.and.m3.eq.0) then
               call getys00(sp1,sp2,nksmax,ncmp,nkstr,nindp0,ys0)
            else
               call getys0(sp1,sp2,nksmax,ncmp,nkstr,nindp0,ys0)
            end if

c           call getjap(ik,ys0,ncmp,nkstr,nindp0,ja,ea,ii,ic,nks,nk)
            call getjap(ik,ys0,ncmp,nkstr,nindp0,ja,ea,ii,ic,nks,nk0)
            if(it.eq.0.or.jw.eq.1) then
               call getjab(0,ik,ys0,ncmp,nkstr,nindp0,ja,ea,ii,ic,
     *              nks,nk0)
c     *              nks,nk)

            end if

                                !    anisotropic thermal parameter
            if(itempf.ne.0) then
               nindb=0
               nindb0=0
               ncmp=9           !  initialization for bi/ui
               call setncmp(ncmp)

               call getsb0(ik,h,ncmp,nkgrp,kgrp)  ! get sb10,sb20
               if(m1.eq.0.and.m2.eq.0.and.m3.eq.0) then
                  call getys00(sb10,sb20,9,ncmp,1,nindb0,ys00)
               else
                  call getys0(sb10,sb20,9,ncmp,1,nindb0,ys00)
               end if

               call getsb(ne,ik,h,ncmp,nkstr,kstr)  ! get sb1,sb2
                                ! if(it.eq.1.or.jw.eq.1) then

               call getys(ys00,9,nindb0,sb1,sb2,9*nksmax,ncmp,nkstr,
     *              nindb,ys0)
               call getjab(1,ik,ys0,ncmp,nkstr,nindb,ja,ea,ii,ic,nks,
     *              nk0)
c     *              nk)
c              nks(nk)=nkstr
               nks(nk0)=nkstr
            end if

c           write(6,*) 'nk,nk0',nk,nk0
            if(getm123(m1,m2,m3,nkstr,kstr,nkstr0,kstr0).eq.1) then
               go to 10
            end if
         end do                 ! nw loop
      end do                    ! na loop

      nx=ii
      nc=ic
      return
      end

      subroutine getys(ys00,n1,nind0,s1,s2,n2,ncmp,nkstr,nind,ys0)
      complex ys00(n1,*)
      complex s1(n2,*),s2(n2,*)
      complex ys0(ncmp*nkstr,*)
      include "remos.inc"
      complex y(9*nksmax)
      complex cr,ci
      data cr /(1.,0.)/, ci /(0.,1.)/

c      write(6,'(a,i2)') 'nind0',nind0
c      do i=1,nind0
c         write(6,'(10f6.2)') (ys00(j,i),j=1,n1)
c      end do

c      write(6,*)
c      call wtcmtrx(s1,n2,n2)
c      write(6,*)
c      call wtcmtrx(s2,n2,n2)      

c     ncmp number of independent components
      nind=0            
      do i=1,nind0
         do j=1,ncmp*nkstr
            y(j)=0
            do k=1,n1
c             y(j)=y(j)+s1(j,k)*real(ys00(k,i))   ! for cos
              y(j)=y(j)+s1(j,k)*real(ys00(k,i))+
     *                  s2(j,k)*aimag(ys00(k,i))
            end do
         end do
c         call writey(y,ncmp*nkstr)
         if(nzerovct(y,ncmp*nkstr).eq.1) then
            call ynorm(y,ncmp*nkstr)
            call indy1(y,ys0,nind,ncmp*nkstr)
         end if
      end do
c      do i=1,nind0
c         do j=1,ncmp*nkstr
c            y(j)=0
c            do k=1,n1
c               y(j)=y(j)-s2(j,k)*aimag(ys00(k,i))   ! for sin
c            end do
c         end do
cc         call writey(y,ncmp*nkstr)
c         if(nzerovct(y,ncmp*nkstr).eq.1) then
c            call ynorm(y,ncmp*nkstr)
c            call indy1(y,ys0,nind,ncmp*nkstr)
c         end if
c      end do
      return
      end

      subroutine getys00(s1,s2,n,ncmp,nkstr,nind,ys0)
      complex s1(n,*),s2(n,*)
      complex ys0(ncmp*nkstr,*)
      include "remos.inc"
      complex y(9*nksmax)
      complex cr,ci
      data cr /(1.,0.)/, ci /(0.,1.)/
      
      nind=0            
      do i=1,ncmp          ! for (0,0,0) wave vector
         do j=1,ncmp*nkstr
            y(j)=s1(j,i)   ! for cos
         end do
         if(nzerovct(y,ncmp*nkstr).eq.1) then
            call ynorm(y,ncmp*nkstr)
c            call indy1(y,ys0,nind,ncmp*nkstr)
            call indy(y,ys0,nind,ncmp*nkstr)
         end if
      end do
      return
      end

      subroutine getys0(s1,s2,n,ncmp,nkstr,nind,ys0)
      complex s1(n,*),s2(n,*)
      complex ys0(ncmp*nkstr,*)
      include "remos.inc"
      complex y(9*nksmax)
      complex cr,ci
      data cr /(1.,0.)/, ci /(0.,1.)/
      
      nind=0            
      do i=1,ncmp
         do j=1,ncmp*nkstr
            y(j)=s1(j,i)           ! for cos
         end do
         if(nzerovct(y,ncmp*nkstr).eq.1) then
            call ynorm(y,ncmp*nkstr)
c            call indy1(y,ys0,nind,ncmp*nkstr)
            call indy(y,ys0,nind,ncmp*nkstr)
         end if
      end do
      do i=1,ncmp
         do j=1,ncmp*nkstr
            y(j)=-s2(j,i)             ! for sin
         end do
         if(nzerovct(y,ncmp*nkstr).eq.1) then
            call ynorm(y,ncmp*nkstr)
c            call indy1(y,ys0,nind,ncmp*nkstr)
            call indy(y,ys0,nind,ncmp*nkstr)
         end if
      end do
      return
      end

      subroutine writey(y,n)
      complex y(*)
      write(6,'(20f5.2)') (y(j),j=1,n)
      return
      end

      subroutine wtcmtrx(s1,n,m)
      complex s1(n,*)
      do i=1,m
         write(6,'(20f5.2)') (s1(i,j),j=1,m)
      end do
      return
      end

      subroutine permut(ns,ik,kstr,nkstr,iprm) ! permutation of kstar
      integer kstr(6,*),iprm(*)
      integer h(6),hr(6)
      do i=1,nkstr
         call vcpyi(kstr(1,i),h,6)
         call gethrs(h,hr,ns,ik)
         iprm(i)=knumb(hr,kstr,nkstr)
      end do
      return
      end

      function knumb(hr,kstr,nkstr)
      integer hr(*),kstr(6,*)
      do i=1,nkstr
         if(kcomp(kstr(1,i),hr,1).eq.1) then
            knumb=i
            return
         end if
         if(kcomp(kstr(1,i),hr,-1).eq.1) then
            knumb=-i
            return
         end if
      end do
      call quit('knumb is strange')
      knumb=0
      return
      end

      subroutine symtns(y,nkstr) ! take symmetric tensor components
      complex y(*)
      include "remos.inc"
      complex yd(9*nksmax)
      call vcpyc(y,yd,9*nkstr)
      do i=1,nkstr
         do j=1,3
            ij=j+(i-1)*nkstr
            y(ij)=yd(ij)
         end do
         do j=4,6
            ij=j+(i-1)*nkstr
            y(ij)  =(yd(ij)+yd(ij+3))/2
            y(ij+3)=(yd(ij)+yd(ij+3))/2
         end do            
      end do
      return
      end

      real function rsymtns(rs,i1,i2,j1,j2)
c     transformation of symmetric tensor
      integer rs(6,6)
      rsymtns=float(
     *     rs(i1,i2)*rs(j1,j2)+
     *     rs(i1,j2)*rs(j1,i2)+
     *     rs(j1,i2)*rs(i1,j2)+
     *     rs(j1,j2)*rs(i1,i2))/4.0
c     write(6,*) 'rsymtns=',rsymtns
      return
      end

      real function rasymtns(rs,i1,i2,j1,j2)
c     transformation of anti-symmetric tensor
      integer rs(6,6)
      rasymtns=float(
     *     rs(i1,i2)*rs(j1,j2)-
     *     rs(i1,j2)*rs(j1,i2)-
     *     rs(j1,i2)*rs(i1,j2)+
     *     rs(j1,j2)*rs(i1,i2))/4.0
c     write(6,*) 'rasymtns=',rasymtns
      return
      end

      subroutine setkorg(korgd,ksgnd,nkstr)
      integer korgd(*),ksgnd(*)
      common /ckorg/ korg(100),ksgn(100)
      if(nkstr.gt.100) then
         call quit('nkstr > 100')
      end if
      do n=1,nkstr
         korg(n)=korgd(n)
         ksgn(n)=ksgnd(n)
      end do
      return
      end

      subroutine getkorg(korgd,ksgnd,nkstr)
      integer korgd(*),ksgnd(*)
      common /ckorg/ korg(100),ksgn(100)
      if(nkstr.gt.100) then
         call quit('nkstr > 100')
      end if
      do n=1,nkstr
         korgd(n)=korg(n)
         ksgnd(n)=ksgn(n)
      end do
      return
      end

      subroutine getrd(nkstr,kstr,irs,ik,rd)
      integer rd(nkstr,nkstr,*)
      integer kstr(6,*)
      integer irs(0:48)         ! site symmetry operator for ik atom
      integer hr(6),hs(6)

      call getnsym(nsymo)

      do n=1,irs(0)
c     ns=irs(n)
         do i=1,nkstr
            do j=1,nkstr
               rd(i,j,n)=0
            end do
         end do

         do i=1,nkstr
            call gethrs(kstr(1,i),hr,n,ik)
c     call getjs(js)  ! get subsystem
c     call gethr(kstr(1,i),hr,ns,ic,js)
            do j=1,6
               hs(j)=-hr(j)
            end do
            do j=1,nkstr
               if(icomp(kstr(1,j),hr).eq.1) then
                  rd(i,j,n)=1
                  go to 100
               else if(icomp(kstr(1,j),hs).eq.1) then
                  rd(i,j,n)=-1
                  go to 100
               end if
            end do
            call quit('rd invalid')
 100        continue
         end do

c     write(6,*) 'rd='
c     do i=1,nkstr
c     write(6,'(27i2)') (rd(i,j,n),j=1,nkstr)
c     end do
      end do
      return
      end

      complex function getcrd(rd,nkstr,k,l,ns)
      integer rd(nkstr,nkstr,*)
      getcrd=cmplx(rd(k,l,ns),rd(k,l,ns))

c     if(k.eq.1.and.l.eq.1) then
c     write(6,*) ' '
c     do i=1,nkstr
c     write(6,'(27i2)') (rd(i,j,ns),j=1,nkstr)
c     end do
c     end if
      return
      end

      subroutine snorm(s,n1,nkstr) ! normalization of s
      complex s(n1,*)           ! projection operators
      real smin
      data eps /0.0001/

      smin=0
      do i=1,nkstr
         do j=1,nkstr
            abss1=abs(real(s(i,j)))
            abss2=abs(aimag(s(i,j)))
            if(abss1.gt.eps) then
               if(smin.eq.0) then
                  smin=abss1
               else if(abss1.lt.smin) then
                  smin=abss1
               end if
            end if
            if(abss2.gt.eps) then
               if(smin.eq.0) then
                  smin=abss2
               else if(abss2.lt.smin) then
                  smin=abss2
               end if
            end if
         end do
      end do

      if(smin.lt.eps) then
         return
      end if

      do i=1,nkstr
         do j=1,nkstr
            s(i,j)=s(i,j)/smin
         end do
      end do

c     write(6,*) 'propjection operator'
c     do i=1,nkstr
c     write(6,'(27f4.1)') (s(i,j),j=1,nkstr)
c     end do
c     return
      end

      subroutine indy1(y,ys,nind,n)
      complex y(*),ys(n,*)
      do i=1,nind
         call ynorm(y,n)
         if(icompn(y,ys(1,i),n).eq.1) then
c        if(icompcn(y,ys(1,i),n).eq.1) then
            return
         end if
      end do
      nind=nind+1
      do i=1,n
         ys(i,nind)=y(i)
      end do
c     write(6,'(20f5.2)') (y(i),i=1,n)
      return
      end

      subroutine ynorm(y,nkstr) ! normalization of y
      complex y(*)
      real smin
      data eps /0.001/
      smin=0
      do i=1,nkstr
         abss1=abs(real(y(i)))
         abss2=abs(aimag(y(i)))
         if(abss1.gt.eps) then
            if(smin.eq.0) then
               smin=abss1
            else if(abss1.lt.smin) then
               smin=abss1
            end if
         end if
         if(abss2.gt.eps) then
            if(smin.eq.0) then
               smin=abss2
            else if(abss2.lt.smin) then
               smin=abss2
            end if
         end if
      end do
      
      if(smin.gt.eps) then
c     write(6,*) 'y before normalization',smin
c     write(6,'(18f6.2)') (y(i),i=1,nkstr)
         do i=1,nkstr
            y(i)=y(i)/smin
         end do
c     write(6,'(18f6.2)') 'y ',(y(i),i=1,nkstr)
      end if
      return
      end

      subroutine norm(y,n)      ! normalization of n-dimensional vector y
      real y(*)
      data eps /0.00001/
      absy=0
      do i=1,n
         absy=absy+y(i)**2
      end do
      absy=sqrt(absy)           ! norm of y
      if(absy.gt.eps) then
         do i=1,n
            y(i)=y(i)/absy
         end do
      end if
      return
      end

      subroutine indy0(y,ys,nind,n)
      complex y(*),ys(n,*)
      do i=1,nind
         call ynorm(y,n)
         if(icompcn(y,ys(1,i),n).eq.1) then
            return
         end if
      end do
      nind=nind+1
      do i=1,n
         ys(i,nind)=y(i)
      end do
      return
      end

      subroutine indy(y,ys,nind,n)
      complex y(*),ys(n,*)
      include "remos.inc"
      complex yi(9*nksmax)
      complex sclrpr, cvinp
      data eps /0.00001/
c     y is independent of known ys then addc

      do i=1,nind
         call ynorm(y,n)
c        if(icompcn(y,ys(1,i),n).eq.1) then
          if(icompn(y,ys(1,i),n).eq.1) then
            return
         end if
      end do

c     y is independent of ys
c     orthogonalization

      do i=1,nind
c         sclrpr = cvinp(ys(1,i),y,n)   ! scaler product of y and ys
         sclrpr = vinp(ys(1,i),y,n*2)   ! scaler product of y and ys
         ysnorm = cvnorm(ys(1,i),n)     ! norm of a complex vector
c        write(6,*) sclrpr, ysnorm
c        Schmit orthogonalization
         if(abs(sclrpr).gt.eps) then
            do j=1,n
               y(j)=y(j)-sclrpr*ys(j,i)/(ysnorm**2)
            end do               
         end if
      end do

      if(nzerovct(y,n).eq.1) then
c        normalization of y
         call ynorm(y,n)
         nind=nind+1
         do i=1,n
            ys(i,nind)=y(i)
         end do
c         write(6,*) 'y='
c         write(6,'((18f6.2))') (y(i),i=1,n)
      end if
      return
      end

      complex function cvinp(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      complex x(*),y(*)
      cvinp=(0.,0.)
      do i=1,n
         cvinp=cvinp+conjg(x(i))*y(i)
      end do
      return
      end

      subroutine  cmtrxsum(x,y,z,n,m)
c*****inner product of n-dimensional vactors, x,y
      complex x(n,*),y(n,*),z(n,*)
      do i=1,m
         do j=1,m
            z(i,j)=x(i,j)+y(i,j)
         end do
      end do
      return
      end

      subroutine  cmtrxsub(x,y,z,n,m)
c*****inner product of n-dimensional vactors, x,y
      complex x(n,*),y(n,*),z(n,*)
      do i=1,m
         do j=1,m
            z(i,j)=x(i,j)-y(i,j)
         end do
      end do
      return
      end

      function cvnorm0(y,n)
c******norm of a complex vector
      complex y(*)
      cvnorm0=0
      do i=1,n
         cvnorm0=cvnorm0+real(conjg(y(i))*y(i))
      end do
      cvnorm0=sqrt(cvnorm0)
      return
      end

      function cvnorm(y,n)
c******norm of a complex vector
      complex y(*)
      cvnorm=0
      do i=1,n
         cvnorm=cvnorm+real(y(i))*real(y(i))
      end do
      do i=1,n
         cvnorm=cvnorm+aimag(y(i))*aimag(y(i))
      end do
      cvnorm=sqrt(cvnorm)
      return
      end

      subroutine getkgrp(m1,m2,m3,irs,js,nkgrp,kgrp)
c     symmetry operator which transform k into k or -k      
      integer m1,m2,m3
      integer irs(0:48)
      integer kgrp(48)
      integer h(6),hr(6),hr0(6)

      call getidm(idm)
      call getnsym(nsymo)
c     write(6,*) 'kgrp'
      nkgrp=0
c     write(6,*) 'irs(0)=',irs(0)
      nkgrp=0
      do n=1,irs(0)
         ns=irs(n)    ! n-th site symmetry operators
         h(1)=0
         h(2)=0
         h(3)=0
         h(4)=m1
         h(5)=m2
         h(6)=m3
         call gethr(h,hr,ns,0,js)
         if(icomp(hr,h).eq.1) then
            nkgrp=nkgrp+1
c           kgrp(nkgrp)=ns      ! k to k
            kgrp(nkgrp)=n       ! k to k
         end if
         if(m1.ne.0.or.m2.ne.0.or.m3.ne.0) then
            if(icomp1(hr,h).eq.1) then
               nkgrp=nkgrp+1
c               kgrp(nkgrp)=-ns  ! k to -k
               kgrp(nkgrp)=-n    ! k to -k
            end if
         end if
      end do
c      write(6,'(a,20i3)') 'kgroup',(kgrp(k),k=1,nkgrp)
      return
      end

      subroutine getkstr(m1,m2,m3,irs,js,nkstr,kstr)
      integer m1,m2,m3
      integer irs(0:48)
      integer kstr(6,*)
      integer h(6),hr(6),hr0(6)

      call getidm(idm)
      call getnsym(nsymo)
c      write(6,*) 'kstar'
      nkstr=0
c      write(6,*) 'irs(0)=',irs(0)
      do n=1,irs(0)
         ns=irs(n)             ! n-th site symmetry operator
         if(ns.gt.nsymo) then
            ns=ns-nsymo
         end if
         h(1)=0
         h(2)=0
         h(3)=0
         h(4)=m1
         h(5)=m2
         h(6)=m3
         call gethr(h,hr0,ns,0,js)
         do nk=1,nkstr
            do ic=0,1
               call gethr(hr0,hr,1,ic,js)
               if(icompk(hr,kstr(1,nk)).eq.1) go to 120
            end do
         end do
         nkstr=nkstr+1
         call vcpyi(hr0,kstr(1,nkstr),idm)
         do j=idm+1,6
            kstr(j,nkstr)=0
         end do
c        write(6,*) 'nkstr=',nkstr,(kstr(k,nkstr),k=4,6)
 120     continue
      end do
      return
      end

      subroutine getkind(mmax,nkind,kind,js)
      integer kind(6,*),mmax(*)
      integer h(6),hr(6)
      call getnsym(nsymo)
      call geticnt(icent)
      call getidm(idm)
      nkind=0
      do m3=0,mmax(3)
         do m2=0,mmax(2)
            do m1=0,mmax(1)
               h(1)=0
               h(2)=0
               h(3)=0
               h(4)=m1
               h(5)=m2
               h(6)=m3
               if(nkind.gt.0) then
                  do ns=1,nsymo
                     do ic=0,icent
                        call gethr(h,hr,ns,ic,js)
                        do nk=1,nkind
c                           if(icomp(hr,kind(1,nk)).eq.1) go to 120
                           if(icompk(hr,kind(1,nk)).eq.1) go to 120
                        end do
                     end do
                  end do
               end if
               nkind=nkind+1
               call vcpyi(h,kind(1,nkind),idm)
               do j=idm+1,6
                  kind(j,nkind)=0
               end do
 120           continue
            end do
         end do
      end do
c     do nk=1,nkind
c     write(6,*) 'kind=',(kind(j,nk),j=4,6)
c     end do
      return
      end

      subroutine calkorg(kstr,k,isgn,js)
      integer kstr(*)
c      common /sifrt2/ ifrts(3,100,3),nksts
      common /sifrt2/ ifrts(3,200,3),nksts
      if(js.gt.3) then
         call quit('js > 3')
      end if

      do k=1,nksts
         kd=k*2
         if(kstr(1).eq.ifrts(1,kd,js).and.
     *        kstr(2).eq.ifrts(2,kd,js).and.
     *        kstr(3).eq.ifrts(3,kd,js)) then
            isgn=1
            return
         end if
         if(kstr(1).eq.-ifrts(1,kd,js).and.
     *        kstr(2).eq.-ifrts(2,kd,js).and.
     *        kstr(3).eq.-ifrts(3,kd,js)) then
            isgn=-1
            return
         end if
      end do
      write(6,*)'nksts ',nksts,' js ',js
      write(6,*) 'kstr ',(kstr(j),j=1,3),
     *     'ifrts ',((ifrts(j,kd,js),j=1,3),kd=1,nksts*2)
      call quit('invalid kstr')
      return
      end

      subroutine resetiskp()
      common /cgetm/ iskp(48)
      do i=1,48
         iskp(i)=0
      end do
      return
      end

      integer function getm123(m1,m2,m3,nkstr,kstr,nkstr0,kstr0)
      integer kstr(6,*),kstr0(6,*)
      common /cgetm/ iskp(48)
      integer hr(6)
      getm123=0
      do i=1,nkstr
         do j=1,nkstr0
            do ic=0,1
               call gethr(kstr(1,i),hr,1,ic,1)  ! identity or inversion
               if(icompk(hr,kstr0(1,j)).eq.1) then
                  iskp(j)=1
               end if
            end do
         end do
      end do
      do j=1,nkstr0       ! new k
         if(iskp(j).eq.0) then
            m1=kstr0(4,j)
            m2=kstr0(5,j)
            m3=kstr0(6,j)
            getm123=1
            return
         end if
      end do
      return
      end

      subroutine setnks   ! for total symmetry
      integer n1(100),n2(100),n3(100)
      integer irs(0:48)
      integer kstr(6,100)
      common /ckstr/ nks(100),nkstrt
      call getnw0(nw0)
      call getnsyic(nsy,ic)      
      call getn123(n1,n2,n3)
      do i=1,nsy*(ic+1)
         irs(i)=i
      end do
      irs(0)=nsy*(ic+1)
      call getnsub(nsub)
      do js=1,nsub
         nk=0
         do n=1,nw0
            call getkstr(n1(n),n2(n),n3(n),irs,js,nkstr,kstr)
            nk0=nk
c            write(6,*) 'nkstr in setnks=',nkstr,n1(n),n2(n),n3(n)
            do k=1,nkstr
               do i=1,2         ! for cos and sin
                  nk=nk+1
               end do
               call wtkstr('kstr in setnks=',kstr,k)
            end do
c     write(6,*) 'ifrt2=',(ifrt2(1,nk0+j*2,1),
c     *        ifrt2(2,nk0+j*2,1),ifrt2(3,nk0+j*2,1),j=1,nkstr)
         end do
      end do
      return
      end

      subroutine wtkstr(str,kstr,k)
      character*(*) str
      integer kstr(6,*)
      write(6,'(a,3i3)') str,kstr(4,k),kstr(5,k),kstr(6,k)
      return
      end

      subroutine kstar(nw,ifrt2)  ! for total symmetry
      integer ifrt2(3,nw,*)
      integer n1(100),n2(100),n3(100)
      integer irs(0:48)
      integer kstr(6,100)
      common /ckstr/ nks(100),nkstrt

      call getnw0(nw0)
      call getnsyic(nsy,ic)      
      call getn123(n1,n2,n3)
      do i=1,nsy*(ic+1)
         irs(i)=i
      end do

      irs(0)=nsy*(ic+1)
      call getnsub(nsub)
      do js=1,nsub
         nk=0
         do n=1,nw0
            call getkstr(n1(n),n2(n),n3(n),irs,js,nkstr,kstr)
            nk0=nk
c            write(6,*) 'nkstr in kstar=',nkstr,n1(n),n2(n),n3(n)
            do k=1,nkstr
               do i=1,2         ! for cos and sin
                  nk=nk+1
                  ifrt2(1,nk,js)=kstr(4,k)
                  ifrt2(2,nk,js)=kstr(5,k)
                  ifrt2(3,nk,js)=kstr(6,k)
               end do
               call wtkstr('kstr in kstar=',kstr,k)
            end do
c     write(6,*) 'ifrt2=',(ifrt2(1,nk0+j*2,1),
c     *        ifrt2(2,nk0+j*2,1),ifrt2(3,nk0+j*2,1),j=1,nkstr)
         end do
      end do
      return
      end

      subroutine indprm0(ys0,indp,nindp,n)
c     chose independent parameters
      complex ys0(n,*)
      integer indp(*)
      include "remos.inc"
      integer nzc(9*nksmax),nzs(9*nksmax)
      integer isc(9*nksmax),iss(9*nksmax)
      data eps /0.0001/

      nc=1
      do i=1,n                  ! i-th compoment
         nzc(i)=0
         nzs(i)=0
         do k=1,nindp
            if(abs(real(ys0(i,k))).gt.eps) then
               nzc(i)=nzc(i)+1
            end if
            if(abs(aimag(ys0(i,k))).gt.eps) then
               nzs(i)=nzs(i)+1
            end if
         end do
      end do

c      write(6,*) 'nzc=',(nzc(i),i=1,n)
c      write(6,*) 'nzs=',(nzs(i),i=1,n)

      do i=1,n
         isc(i)=0
         iss(i)=0
      end do

c     if nzc=1 or nzs=1, that is a candidate of indepedent parameters

      do k=1,nindp
c        chose nzc=1 or nzs=1 parameters         
         do i=1,n
            if(nzc(i).eq.1.and.abs(real(ys0(i,k))).gt.eps) then
               indp(k)=i*2-1
               isc(i)=1
               go to 100
            else if(nzs(i).eq.1.and.abs(aimag(ys0(i,k))).gt.eps) 
     *              then
               indp(k)=i*2
               iss(i)=1
               go to 100
            end if
         end do

c        chose independent parameters with nzc=2 or zns=2
c        the following code is not complete

         do i=1,n
            if(isc(i).eq.0) then
               if(abs(real(ys0(i,k))).gt.eps) then
                  indp(k)=i*2-1
                  isc(i)=1
                  go to 100
               end if
            end if
            if(iss(i).eq.0) then
               if(abs(aimag(ys0(i,k))).gt.eps) then
                  indp(k)=i*2
                  iss(i)=1
                  go to 100
               end if
            end if
         end do
 100     continue
      end do
c     write(6,*) 'indpp=',(indp(k),k=1,nindp)
      return
      end

      subroutine indprm1(ys0,indp,nindp,n)
c     chose independent parameters
      complex ys0(n,*)
      integer indp(*)
      include "remos.inc"
      integer nzc(9*nksmax),nzs(9*nksmax)
      integer isc(9*nksmax),iss(9*nksmax)
      data eps /0.0001/
      nc=1
      do k=1,nindp
         do i=1,n               ! i-th compoment
            if(abs(real(ys0(i,k))).gt.eps) then
               indp(k)=i*2-1
               go to 10
            end if
         end do
 10      continue
         do i=1,n               ! i-th compoment
            if(abs(aimag(ys0(i,k))).gt.eps) then
               indp(k)=i*2
               go to 20
            end if
         end do
 20      continue
      end do
c     write(6,*) 'indpp=',(indp(k),k=1,nindp)
      return
      end

      subroutine indprm(ys0,indp,nindp,n)
c     chose independent parameters
      complex ys0(n,*)
      integer indp(*)
      include "remos.inc"
      integer nzc(9*nksmax),nzs(9*nksmax)
      integer isc(9*nksmax),iss(9*nksmax)
      integer nzc2(2,9*nksmax),nzs2(2,9*nksmax)
      data eps /0.0001/

      nc=1
      do i=1,n                  ! i-th compoment
         nzc(i)=0
         nzs(i)=0
         do j=1,2
            nzc2(j,i)=0
            nzs2(j,i)=0
         end do
         do k=1,nindp
            if(abs(real(ys0(i,k))).gt.eps) then
               nzc(i)=nzc(i)+1
               if(nzc(i).eq.1) then
                  nzc2(1,i)=k   
               end if
               if(nzc(i).eq.2) then
                  nzc2(2,i)=k
               end if
            end if
            if(abs(aimag(ys0(i,k))).gt.eps) then
               nzs(i)=nzs(i)+1
               if(nzs(i).eq.1) then
                  nzs2(1,i)=k
               end if
               if(nzs(i).eq.2) then
                  nzs2(2,i)=k
               end if
            end if
         end do
      end do

c      write(6,'(a,(30i2))') 'nzc=',(nzc(i),i=1,n)
c      write(6,'(a,(30i2))') 'nzs=',(nzs(i),i=1,n)
c      write(6,'(a,30i2))') 'nzc2=',((nzc2(j,i),j=1,2),i=1,n)
c      write(6,'(a,30i2))') 'nzs2=',((nzs2(j,i),j=1,2),i=1,n)

      do i=1,n
         isc(i)=0
         iss(i)=0
      end do

c     if nzc=1 or nzs=1, that is a candidate of indepedent parameters

      do k=1,nindp
c        chose nzc=1 or nzs=1 parameters  (independent parameters)
         do i=1,n
            if(nzc(i).eq.1.and.abs(real(ys0(i,k))).gt.eps) then
               indp(k)=i*2-1  ! cosine part
               isc(i)=1       ! set mark
               go to 100
            else if(nzs(i).eq.1.and.abs(aimag(ys0(i,k))).gt.eps) 
     *              then
               indp(k)=i*2    ! sine part
               iss(i)=1       ! set mark
               go to 100
            end if
         end do

c        chose independent parameters with nzc=2 or zns=2
c        the following code is not complete

         do i=1,n                  ! second one
            if(nzc2(2,i).ne.0) then ! a pair
               k1=nzc2(1,i)
               k2=nzc2(2,i)
               if(k.eq.k2.and.abs(real(ys0(i,k1))).gt.eps) then
                  call orthgnlr(ys0(1,k1),ys0(1,k2),i,n)
                  indp(k)=i*2-1 ! cosine part
                  isc(i)=2      ! set mark
                  go to 100
               end if
            end if
            if(nzs2(2,i).ne.0) then ! a pair
               k1=nzs2(1,i)
               k2=nzs2(2,i)
               if(k.eq.k2.and.abs(aimag(ys0(i,k1))).gt.eps) then
                  call orthgnli(ys0(1,k1),ys0(1,k2),i,n)
                  indp(k)=i*2   ! sine part
                  iss(i)=2      ! set mark
                  go to 100
               end if
            end if
         end do

         do i=1,n                   ! second one
            if(nzc2(2,i).ne.0) then ! a pair
               k1=nzc2(1,i)
               k2=nzc2(2,i)
               if(k.eq.k1.and.abs(real(ys0(i,k2))).gt.eps) then
                  call orthgnlr(ys0(1,k2),ys0(1,k1),i,n)
                  indp(k)=i*2-1 ! cosine part
                  isc(i)=2      ! set mark
                  go to 100
               end if
            end if
            if(nzs2(2,i).ne.0) then ! a pair
               k1=nzs2(1,i)
               k2=nzs2(2,i)
               if(k.eq.k1.and.abs(aimag(ys0(i,k2))).gt.eps) then
                  call orthgnli(ys0(1,k2),ys0(1,k1),i,n)
                  indp(k)=i*2   ! sine part
                  iss(i)=2      ! set mark
                  go to 100
               end if
            end if
         end do

         write(6,*) 'failed in determining independent parameters'
 100     continue
      end do
c     write(6,*) 'indpp=',(indp(k),k=1,nindp)
      return
      end

      subroutine indprm2(ys0,indp,nindp,n)
c     chose independent parameters
      complex ys0(n,*)
      integer indp(*)
      include "remos.inc"
      integer nzc(9*nksmax),nzs(9*nksmax)
      integer isc(9*nksmax),iss(9*nksmax)
      data eps /0.0001/

      nc=1
      do i=1,n                  ! i-th compoment
         nzc(i)=0
         nzs(i)=0
         do k=1,nindp
            if(abs(real(ys0(i,k))).gt.eps) then
               nzc(i)=nzc(i)+1
            end if
            if(abs(aimag(ys0(i,k))).gt.eps) then
               nzs(i)=nzs(i)+1
            end if
         end do
      end do

c      write(6,*) 'nzc=',(nzc(i),i=1,n)
c      write(6,*) 'nzs=',(nzs(i),i=1,n)

      do i=1,n
         isc(i)=0
         iss(i)=0
      end do

c     if nzc=1 or nzs=1, that is a candidate of indepedent parameters

      do k=1,nindp
c        chose nzc=1 or nzs=1 parameters         
         do i=1,n
            if(nzc(i).eq.1.and.abs(real(ys0(i,k))).gt.eps) then
               indp(k)=i*2-1
               isc(i)=1
               go to 100
            else if(nzs(i).eq.1.and.abs(aimag(ys0(i,k))).gt.eps) 
     *              then
               indp(k)=i*2
               iss(i)=1
               go to 100
            end if
         end do

c        chose independent parameters with nzc=2 or zns=2
c        the following code is not complete

         do i=1,n
            if(isc(i).eq.0) then
               if(abs(real(ys0(i,k))).gt.eps) then
                  indp(k)=i*2-1
                  isc(i)=1
                  go to 100
               end if
            end if
            if(iss(i).eq.0) then
               if(abs(aimag(ys0(i,k))).gt.eps) then
                  indp(k)=i*2
                  iss(i)=1
                  go to 100
               end if
            end if
         end do
 100     continue
      end do
c     write(6,*) 'indpp=',(indp(k),k=1,nindp)
      return
      end

      subroutine orthgnlr(ys1,ys2,i,n)
c     remove i-th component of ys2
      complex ys1(*),ys2(*)
      data eps /0.00001/
      ys1i=real(ys1(i))
      ys2i=real(ys2(i))
      if(abs(ys2i).gt.eps) then
         do j=1,n
            ys1(j)=ys1(j)-ys1i/ys2i*ys2(j)
         end do
      end if
      call ynorm(ys1,n)
      return
      end

      subroutine orthgnli(ys1,ys2,i,n)
c     remove i-th component of ys2
      complex ys1(*),ys2(*)
      data eps /0.00001/
      ys1i=aimag(ys1(i))
      ys2i=aimag(ys2(i))
      if(abs(ys2i).gt.eps) then
         do j=1,n
            ys1(j)=ys1(j)-ys1i/ys2i*ys2(j)
         end do
      end if
      call ynorm(ys1,n)
      return
      end

      subroutine yssort(ys0,ys1,nindp,n)
      complex ys0(n,*)
      complex ys1(n,*)
      include "remos.inc"
      real nz(9*nksmax)
      integer ns(9*nksmax),st(2*9*nksmax)
      data eps /0.0001/

      do i=1,nindp
         nz(i)=0.0
         do k=1,n
            if(abs(real(ys0(k,i))).gt.eps) then
               nz(i)=nz(i)+1
            end if
            if(abs(aimag(ys0(k,i))).gt.eps) then
               nz(i)=nz(i)+1
            end if
         end do
      end do

c     write(6,*) 'nz=',(nz(ii),ii=1,nindp)
c     do ii=1,nindp
c     write(6,*) 'ys0=',(ys0(k,ii),k=1,n)
c     end do

      call qsort(nz,st,ns,nindp)
c     write(6,*) 'ns=',(ns(k),k=1,nindp)
      do ii=1,nindp
         i=ns(ii)
         do k=1,n
            ys1(k,ii)=ys0(k,i)
         end do
c     write(6,*) 'ys1=',(ys1(k,ii),k=1,n)
      end do
      return
      end

      subroutine yssort0(ys0,ys,nindx0,n) ! for x,y,z
      complex ys0(n,*)
      complex ys(n,*)
      include "remos.inc"
      real nz(9*nksmax)
      integer ns(9*nksmax),st(2*9*nksmax)
      data eps /0.0001/

c     nz(i):location of first non-zero component      
c     n=3*nkstar
      nkstar=n/3
      do i=1,nindx0
         do j1=1,nkstar
            do j2=1,3
               if(abs(real(ys0(j2,i))).gt.eps) then
                  nz(i)=j2+(j1-1)*3
                  go to 100
               end if
            end do
            do j2=1,3
               if(abs(aimag(ys0(j2,i))).gt.eps) then
                  nz(i)=j2+(j1-1)*3+3
                  go to 100
               end if
            end do
         end do
 100     continue
      end do

c     write(6,*) 'nz=',(nz(ii),ii=1,nindx0)
c      do ii=1,nindx0
c         write(6,*) 'ys0=',(ys0(k,ii),k=1,3*nkstar)
c      end do

      call qsort(nz,st,ns,nindx0)

c     write(6,*) 'ns=',(ns(k),k=1,nindx0)
      do ii=1,nindx0
         i=ns(ii)
         do k=1,3*nkstar
            ys(k,ii)=ys0(k,i)
         end do
c     write(6,*) 'ys=',(ys(k,ii),k=1,3*nkstar)
      end do
      return
      end

      subroutine yssort1(ys0,ys,nindp,n) ! for b1-b6/u1-u6
      complex ys0(n,*)
      complex ys(n,*)
      include "remos.inc"
      real nz(9*nksmax)
      integer ns(9*nksmax),st(2*9*nksmax)
      data eps /0.0001/

      call getncmp(ncmp)
c     nz(i):location of first non-zero component      
c     n=6*nkstar or n=kstr
      nkstar=n/ncmp
      do i=1,nindp
         do j1=1,nkstar
            do j2=1,ncmp
               kk=j2+(j1-1)*ncmp
               if(abs(real(ys0(kk,i))).gt.eps) then
                  nz(i)=kk
                  go to 100
               end if
            end do
            do j2=1,ncmp
               kk=j2+(j1-1)*ncmp
               if(abs(aimag(ys0(kk,i))).gt.eps) then
                  nz(i)=kk+6
                  go to 100
               end if
            end do
         end do
 100     continue
      end do

c     write(6,*) 'nz=',(nz(ii),ii=1,nindp)
c     do ii=1,nindp
c     write(6,*) 'ys0=',(ys0(k,ii),k=1,ncmp*nkstar)
c     end do

      call qsort(nz,st,ns,nindp)
c     write(6,*) 'ns=',(ns(k),k=1,nindp)
      do ii=1,nindp
         i=ns(ii)
         do k=1,ncmp*nkstar
            ys(k,ii)=ys0(k,i)
         end do
c     write(6,*) 'ys=',(ys(k,ii),k=1,ncmp*nkstar)
      end do
      return
      end

      function nzerovct(y,n)
      complex y(*)
      data eps /0.0001/
      do i=1,n
         if(abs(y(i)).gt.eps) then
            nzerovct=1
            return
         end if
      end do
      nzerovct=0
      return
      end

      function icompn(z1,z2,n)
      complex z1(*),z2(*)
      include "remos.inc"
      complex z1d(9*nksmax),z2d(9*nksmax),sclpr,cvinp
      real cvnorm1,cvnorm2
      data eps /0.001/

      cvnorm1=cvnorm(z1,n)
      cvnorm2=cvnorm(z2,n)

c     normalized complex vectors
      do i=1,n
         z1d(i)=z1(i)/cvnorm1
         z2d(i)=z2(i)/cvnorm2
      end do

      sclpr=vinp(z1d,z2d,n*2)

c     write(6,*) 'z1d=',(z1d(i),i=1,n)
c     write(6,*) 'z2d=',(z2d(i),i=1,n)
c     write(6,*) 'sclpr=',sclpr,'abs(sclpr)=',abs(sclpr)

      if(abs(sclpr).gt.1-eps) then
                                ! z1 and z2 is parallel or unti-parallel
         icompn=1
         return
      end if 

      do i=1,n 
         if(abs(z1d(i)-z2d(i)).gt.eps) then
            icompn = 0
            return
         end if
      end do
      icompn = 1

      return
      end

      function icompcn(z1,z2,n)
      complex z1(*),z2(*)
      include "remos.inc"
      complex z1d(9*nksmax),z2d(9*nksmax),sclpr,cvinp
      real cvnorm1,cvnorm2
      data eps /0.001/

      cvnorm1=cvnorm0(z1,n)
      cvnorm2=cvnorm0(z2,n)

c     normalized complex vectors
      do i=1,n
         z1d(i)=z1(i)/cvnorm1
         z2d(i)=z2(i)/cvnorm2
      end do

      sclpr=cvinp(z1d,z2d,n)

c      write(6,'(a,10f10.5/(10f10.5))') 'z1d=',(z1d(i),i=1,n)
c      write(6,'(a,10f10.5/(10f10.5))') 'z2d=',(z2d(i),i=1,n)
c      write(6,'(2(a,2f10.5))') 'sclpr=',sclpr,'abs(sclpr)=',abs(sclpr)

      if(abs(sclpr).gt.1-eps) then
                                ! z1 and z2 is parallel or unti-parallel
         icompcn=1
         return
      end if 

      do i=1,n 
         if(abs(z1d(i)-z2d(i)).gt.eps) then
            icompcn = 0
            return
         end if
      end do
      icompcn = 1

      return
      end

      subroutine  getirs0(irs0)
      integer irs0(0:*)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      if(icent.eq.0) then
         irs0(0)=nsymo
      else
         irs0(0)=nsymo*2
      end if
      do i=1,irs0(0)
         irs0(i)=i
      end do
      return
      end
