      subroutine calphsr(br,bi,phsr,phsi)
      absb=sqrt(br**2+bi**2)
      if(absb.ne.0) then
         phsr=br/absb
         phsi=bi/absb
      else
         phsr=1
         phsi=0
      end if
      return
      end

      integer function caliph(phsr,phsi)
      phsd=atan3(phsi,phsr)*180/getpi()
      caliph=phsd+sign(0.0001,phsd)
      return
      end


      subroutine setrwmin(rwmind)
      common /crwmin/ rwmin
      rwmin=rwmind
      return
      end

      function getrwmin()
      common /crwmin/ rwmin
      getrwmin=rwmin
      return
      end

      subroutine wtinitvalue()
      include 'abcdri.inc'
      integer getnind
      nind=getnind()
c      call wtvctrr('br0',br0,nind)
c      call wtvctrr('bi0',bi0,nind)
      call wtvctrr('xr0',xr0,ntx0)      
      dmin=getdmin()
      dmax=getdmax()
      write(6,*) 'dmin=',dmin,' dmax=',dmax
      return
      end

      subroutine initcr0(f000)
c     set initial flat electron density for mem
c     and set its independent part
      include 'abcdri.inc'
      integer getnt
c     write(6,*) 'vol,nt,f000',vol,nt,f000
      nt=getnt()
      call zerovr(br,nt)
      call zerovr(bi,nt)
      vol=getvol()
      br(0)=f000
      call mapxyz()             ! set initial electron density map
      call setxr0()             ! set independent part of electron density br
      call getdmx()             ! get new dmin, dmax
c     call wtinitvalue()        ! for test
      return
      end

      subroutine initcr4(f000)
c     set non flat electron density for mem
c     and set its independent part
      include 'abcdri.inc'
      call initcr00(f000)       ! set electron density for Fourier map
      call getdmx()             ! get dmin dmax
      call nonzerocr(br,f000)   ! get positive electron density map
      call setxr0()             ! set independent part of electron density br
      call getdmx()             ! get new dmin, dmax
c     call wtinitvalue()         ! for test
      return
      end

      subroutine initcr1()
c     set electron density for Fourier map
c     and set its independent part
      include 'abcdri.inc'
c     f000=0                    ! for Fourier  map
      f000=getf0()
      call initcr00(f000)
      call getdmx()             ! get new dmin, dmax
      return
      end

      subroutine initcr00(f000)
c     set electron density for Fourier map
      include 'abcdri.inc'
      call setffromf0(f000)     ! set equivalent br,bi from independent parts
      call mapxyz()             ! get electron density map
      call setxr0()             ! set independent part of electron density br
      return
      end

      subroutine nonzerocr(cr,f000)
      real cr(0:*)
      integer getnt
      dmin=getdmin()            ! get minimum density
      vol=getvol()
      eps=f000/vol/1000         ! new minimum density
      nt=getnt()
      dmin0=(eps-dmin)          ! difference
      br0=0
      do i=0,nt-1
         cr(i)=(cr(i)+dmin0)    ! positive cr
         br0=br0+cr(i)
      end do
      f0e=br0*vol/nt            ! estimated f000
      scl=f000/f0e              ! scale factor
c     write(6,*) 'eps,br0,f000=',eps,br0,f000
      call vscaler(cr,scl,cr,nt) ! scalling so as to be br(0)=f000
      return
      end

      integer function getiplot()
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      getiplot=iplot
      return
      end

      logical function isMem()  ! for mem or memlde return true else false
      integer getiplot
      iplot=getiplot()
!     if(iplot.eq.0.or.abs(iplot).eq.4.or.abs(iplot).eq.5) then
      if(iplot.eq.0.or.abs(iplot).ge.4) then
         isMem=.true.           ! Mem including MemLde
      else
         isMem=.false.
      end if
      return
      end

      logical function isMemLde(rfact) ! for memlde return true else false
      integer getiplot
      rwmin=getrwmin()
c     write(6,*) 'rfact,rwmin=',rfact,rwmin
      iplot=getiplot()
      if(abs(iplot).ge.5.and.rfact.le.rwmin) then
         isMemLde=.true.
      else
         isMemLde=.false.
      end if
      return
      end

      logical function isPatterson()
      integer getiplot
      iplot=getiplot()
      if(abs(iplot).eq.1) then
         isPatterson=.true.
      else
         isPatterson=.false.
      end if
      return
      end

      logical function isFourier()
      integer getiplot
      iplot=getiplot()
      if(abs(iplot).eq.2) then
         isFourier=.true.
      else
         isFourier=.false.
      end if
      return
      end

      logical function isDFourier()
      integer getiplot
      iplot=getiplot()
      if(abs(iplot).eq.3) then
         isDFourier=.true.
      else
         isDFourier=.false.
      end if
      return
      end

      subroutine setimode(ic)      
      common /cnex/ nex1,nex2,ex1,ex2
      common /cimode/ imode
      if(ic.le.nex1) then
         imode=1
      else
         imode=2
      end if
      return
      end

      integer function getimode()      
      common /cimode/ imode
      getimode=imode
      return
      end

      subroutine countn1(ic,n1)
      common /cnex/ nex1,nex2,ex1,ex2
      if(ic.le.nex1) then
         n1=n1+1
      end if
      return
      end

      subroutine countn2(ic,n2)
      common /cnex/ nex1,nex2,ex1,ex2
      if(ic.gt.nex1) then
         n2=n2+1
      end if
      return
      end

      subroutine initex(ic,n1,n2,ex)
      common /cnex/ nex1,nex2,ex1,ex2
      if(ic.le.nex1) then
         if(n1.eq.1) then
            ex=ex1
         end if
      else
         if(n2.eq.1) then
            ex=ex2
         end if
      end if
      return
      end

      subroutine resetc2rf0(c2d,rfact,rwfact)
      common /cisreturn/ ncount,c2d0,rfact0,rwfact0
      c2d0=c2d
      rfact0=rfact
      rwfact0=rwfact
      return
      end
      
      subroutine resetnc()  ! reset ncount for isReturn
      common /cisreturn/ ncount,c2d0,rfact0,rwfact0
      ncount=0
      return
      end

      logical function isReturn(c2d,rfact,rwfact)
      common /cisreturn/ ncount,c2d0,rfact0,rwfact0
      data ncount /-1/
c     write(6,*) 'c2d0,rfact0,rwfact0',c2d0,rfact0,rwfact0
      isReturn=.false.
      if(ncount.eq.-1) then     ! exceptional
         ncount=0
         isReturn=.false.
      else if(rfact.gt.1.or.rwfact.gt.1) then ! exceptional
c     this is necessary for large initial ex to get optimum ex
         isReturn=.true.
         ncount=ncount+1        ! count number of gobacks
      else if(c2d.gt.c2d0.and.rfact.gt.rfact0.and.
     *        rwfact.gt.rwfact0) then
         isReturn=.true.
         ncount=ncount+1
      end if
      if(.not.isReturn) then
         ncount=0               ! reset ncount
         call resetc2rf0(c2d,rfact,rwfact) ! set new rfact etc as old
      end if
      return
      end

      subroutine checkIsFunction()
      logical isMem,isPatterson,isFourier,isDFourier
      if(isMem()) then
         write(6,*) 'Mem map'
      else if(isPatterson()) then
         write(6,*) 'Patterson Map'
      else if(isFourier()) then
         write(6,*) 'Fourier Map'
      else if(isDFourier()) then
         write(6,*) 'Difference Fourier Map'
      end if
      return
      end

      subroutine wtmess(ic,c2d,rfact,rwfact,ex,f0)
      common /cimode/ imode
      if(imode.eq.1) then
         call wtmess1(ic,c2d,rfact,rwfact,ex,f0)
      else
         call wtmess2(ic,c2d,rfact,rwfact,ex,f0)
      end if
      return
      end

      subroutine wtmess1(ic,c2d,rfact,rwfact,ex1,f0)
      character(80) rfform
      dmin=getdmin()
      dmax=getdmax()
      rfform='(a,i3,a,e12.5,2(a,f8.5),a,f6.0,a,f9.5,a,f10.1,a,e10.3)'
      write(6,rfform)
     *     'ic=',ic,' c2=',c2d,' rfact=',rfact,' rwfact=',rwfact,
     *     ' f0=',f0,' dmin=',dmin,' dmax=',dmax,' ex1=',ex1
      return
      end
      
      subroutine wtmess2(ic,c2d,rfact,rwfact,ex2,f0)
      character(80) rfform
      dmin=getdmin()
      dmax=getdmax()
      rfform='(a,i3,a,e12.5,2(a,f8.5),a,f6.0,a,f9.5,a,f10.1,a,e10.3)'
      write(6,rfform)
     *     'ic=',ic,' c2=',c2d,' rfact=',rfact,' rwfact=',rwfact,
     *     ' f0=',f0,' dmin=',dmin,' dmax=',dmax,' ex2=',ex2
      return
      end

      subroutine setari0(ao,bo,sgobs,nind,l)
      real sgobs
      integer nind,l
      include 'abcdri.inc'
      nind=nind+1
      hklo1d(nind)=l   ! 1d index for observed reflection
      ar0(nind)=ao     ! observed structure factor
      ai0(nind)=bo     ! observed structure factor
      sgm0(nind)=sgobs
      return
      end

      subroutine setbeq(ao,bo,l)
      real ao,bo
      integer l
      logical isMem,isFourier,isPatterson,isDFourier
      include 'abcdri.inc'
      if(isMem().or.isFourier().or.isDFourier()) then
         br(l)=ao               ! fo
         bi(l)=bo               ! fo
      else if(isPatterson()) then ! Patterson map
         br(l)=(ao**2+bo**2)
      else
         call quit('invalid iplot')
      end if
      return
      end

      subroutine memloop(f000,c2d,flnm2,rfact,rwfact)
      character(*) flnm2
      include 'abcdri.inc'
      common /cnex/ nex1,nex2,ex1,ex2
      common /cdenmodMem/ ic,n1,n2,ex
      integer getnt,getnind
      logical isGoback,isConverge
      data eps / 0.1e-5/ ! minimum difference in rfact and rwfact
c     mem loop
      nt=getnt()
c     c20=c2d
      j=0
      j1=0
      n1=0
      n2=0

c     get structure factor br,bi from independent part of electron density
      call maphkl()             ! calculate structre factor for all from xr0
c     br,bi : structure factor
c     set calculated structure factor for observed reflections
      call setf0()        ! calculate br0,bi0 from br
      call savenewvalue() ! save br0,bi0,xr0 for restore

      do ic=1,nex1+nex2
         call setimode(ic)
         call countn1(ic,n1)  ! n1 : number of cycles in imode=1
         call countn2(ic,n2)  ! n2 : number of cycles in imode=2
         call initex(ic,n1,n2,ex) ! set initial ex for imode=1 and 2
 600     continue
c     xr0 (electron density for independent grids) should be defined here
c     br0,bi0 (independnet structure factors) should be defined here
c     denmodMem modifies electron density by MEM
c     replace xr0 by modified one and 
c     calculate its structure factors (br0,bi0)
         call denmodMem(f000) 
c     calculate r-factors
         call rfct(c2d,rfact,rwfact,0)
c         write(6,*) 'rfact,rwfact in memloop=',rfact,rwfact
c     choose optimum coefficient ex for fast convergence
         call getNewex(c2d,f000,rfact,rwfact,j,j1,isGoback) ! get new ex
c        write(6,*) 'isGoback',isGoback
         if(isGoback) then
            call restoreoldvalue()  ! restore old br0,bi0,xr0
            go to 600
         else
            call savenewvalue() ! save br0,bi0,xr0 for restore
c     printout r-factors
            call wtmess(ic,c2d,rfact,rwfact,ex,f000)
            if(isConverge(rfact,rwfact,eps,ex)) return
         end if
      end do
      return
      end

      subroutine restoreoldvalue()
      include 'abcdri.inc'
      call vcpyr(xr0_old,xr0,ntx0) ! restore xr0
      call vcpyr(br0_old,br0,ntf0) ! restore br0
      call vcpyr(bi0_old,bi0,ntf0) ! restore br0
      return
      end

      subroutine savenewvalue()
      include 'abcdri.inc'
      call vcpyr(xr0,xr0_old,ntx0) ! save xr0 for restore
      call vcpyr(br0,br0_old,ntf0) ! restore br0
      call vcpyr(bi0,bi0_old,ntf0) ! restore br0
      return
      end

      logical function isConverge(rfact,rwfact,eps,ex)
      common /cisreturn/ ncount,c2d0,rfact0,rwfact0
      isConverge=.false.
c      if(ex.lt.1.0e-10) then
c         isConverge=.true.
c         return                 ! converge
c      end if
      drfact=abs(rfact-rfact0)
      drwfact=abs(rwfact-rwfact0)
      if(ncount.gt.5) then
         if(drfact.lt.eps.and.drwfact.lt.eps) then
            isConverge=.true.
            return              ! converge
         end if
      end if
      return
      end

      subroutine getNewex(c2d,f0,rfact,rwfact,j,j1,isGoback)
      real c2d,f0,rfact,rwfact
      integer j,j1
      logical isGoback
      logical isReturn,isMemLde,isR
      common /cdenmodMem/ ic,n1,n2,ex
      isGoback=.false.
      isR=isReturn(c2d,rfact,rwfact)
c     write(6,*) 'c2d,rfact,rwfact,isReturn=',c2d,rfact,rwfact,isR
c     call quit('stop in getNewex')

      if(isR) then ! goback
         j=0
         call wtmess(ic,c2d,rfact,rwfact,ex,f0)
         if(ex.gt.1.0e-10) then
            j1=j1+1
            if(isMemLde(rfact).and.mod(j1,2).eq.0.and.rwfact.le.rwmin)
     *           then
c     density modification in direct space
               call denmodLdem(f0)
            else
c     ex=ex/3.375
               ex=ex/2.0
            end if
            isGoback=.true.
         else
            return              ! break
         end if
c        isGoback=.true.
      else
         if(j.eq.3) then
c     ex=ex*1.5
            ex=ex*2.0
c           ex=min(1.e-2,ex)
            j1=0
            j=0
         else
            j=j+1
         end if
      end if
      return
      end

      subroutine rfct(c2d,rfact,rwfact,ip)
c     ip write flag   ip=0, +-1
c     integer hmax(6)
      include 'nhmax.inc'
      include 'hklf.inc'
      include 'abcdri.inc'      

      real q(6)
      integer hi(6),hd(6)
      real*8 zsum, zdif,c2,ct
      character brv
      integer getnt,getnind
      character*80 frmt

      call getidm(idm)
      write(frmt,'(a,i1,a)') '(',idm,'i4,4e12.4)'
      call geticent(icent)
      if(is.eq.0) then
         call quit('is=0')
      end if

      isd=0
      zsum=0
      zdif=0
      c2=0
      ct=0

      nind=getnind()
      if(nind.le.0) then
         write(6,*)  'nind in rfct=',nind
         call quit('nind should be positive ')
      end if
      do i=1,nind
         ao=sqrt(ar0(i)**2+ai0(i)**2)
         ac=sqrt(br0(i)**2+bi0(i)**2)
         ph=todeg(atan3(ai0(i),ar0(i))) ! phase angle in degree
c        write(6,*) 'ao,ac=',ao,ac
         if(ao.gt.1.e32.or.ac.gt.1.e32) then
            write(6,*) 'hd,ao,ac=',hd,ao,ac
            call quit(' ')
         end if
         j=hklo1d(i)
         call getitohkl(j,hd)
         zsum=zsum+ao
         zdif=zdif+abs(ao-ac)
         c2=c2+((ar0(i)-br0(i))**2+(ai0(i)-bi0(i))**2)/sgm0(i)**2
         ct=ct+(ar0(i)**2+ai0(i)**2)/sgm0(i)**2
         if(ip.eq.1) then
            write(6,'(6i4,4f9.2)') hd,ao,ac,ph,sgm0(i)
         end if
         if(i.le.10) then  ! for test
c            write(6,*) 'ar,ai,sg,br,bi=',
c     *           ar0(i),ai0(i),sgm0(i),br0(i),bi0(i)
         end if
      end do
c     write(6,*) 'zdif,zsum,dt,ct=',zdif,zsum,c2,ct
c     write(6,*) 'c2,nind=',c2,nind
      c2d=c2/nind
      rfact=zdif/zsum
      rwfact=sqrt(c2/ct)
c     write(6,*) 'rfact,rwfact=',rfact,rwfact
      if(ip.eq.-1) then
         call quit('ip=-1 does not work in this version')
      end if
      return
      end

