      subroutine ctoph(h)
      integer h(*)
      integer hd(6)
      character brv
c     transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ftoph(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then
         call itoph(h,hd)
         call vcpyi(hd,h,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptoch(h)
      integer h(*)
      integer hd(6)
      character brv
c     transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ptofh(h,hd)
         call vcpyi(hd,h,6)
      else if(brv.eq.'i') then
         call ptoih(h,hd)
         call vcpyi(hd,h,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ctopx(x)
      real x(*)
      real xd(6)
      character brv
c     transformation of indices from centered to primitive
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ftopx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then
         call itopx(x,xd)
         call vcpyr(xd,x,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptocx(x)
      real x(*)
      real xd(6)
      character brv
c     transformation of indices from primitive to centered
      call getbrv(brv)
      if(brv.eq.'p') then
         return
      else if(brv.eq.'f') then
         call ptofx(x,xd)
         call vcpyr(xd,x,6)
      else if(brv.eq.'i') then
         call ptoix(x,xd)
         call vcpyr(xd,x,6)
      else
         call quit('invalid brv')
      end if
      return
      end

      subroutine ptofx(x,y)
      real x(*),y(*)
      integer qm(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in ftopx
      data qm / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(i,j)*x(j)/2
         end do
      end do
      return
      end

      subroutine ftopx(x,y)
      real x(*),y(*)
      integer qm(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(i,j)*x(j)
         end do
      end do
      return
      end

      subroutine ptofh(x,y)
      integer x(*),y(*)
      integer qm(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(j,i)
         end do
      end do
      return
      end

      subroutine ftoph(x,y) 
      integer x(*),y(*)
      integer qm(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm of Eq (6.6) (or qm in ftopx)
      data qm / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(j,i)
         end do
         if(mod(y(i),2).ne.0) then
            write(6,*) 'x=',(x(j),j=1,6)
            write(6,*) 'y=',(y(j),j=1,6)
            call quit('nonallowd reflections')
         end if
         y(i)=y(i)/2
      end do
      return
      end

      subroutine ptoix(x,y)
      real x(*),y(*)
      integer qm(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(j,i)*x(j)/2
         end do
      end do
      return
      end

      subroutine itopx(x,y)
      real x(*),y(*)
      integer qm(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm in ftopx
      data qm / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+qm(j,i)*x(j)
         end do
      end do
      return
      end

      subroutine ptoih(x,y)
      integer x(*),y(*)
      integer qm(6,6)
c     qm is a transpose of Eq (6.5) in Acta Cryst. A42, 261
c     and qm/2 is an inverse of qm of Eq (6.6) (or qm in ftopx)
      data qm / 0, 1, 0, -1, 0, 0,
     *     0, 0, 1, 0, 0, -1,
     *     1, 0, 0, 0, 1, 0,
     *     0, 0, 0, 0, -1, 1,
     *     0, 0, 0, 1, -1, 0,
     *     0, 0, 0, 1, 0, 1/
c     coordinate transformation from primitive to face-centerd
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(i,j)
         end do
      end do
      return
      end

      subroutine itoph(x,y)
      integer x(*),y(*)
      integer qm(6,6)
c     qm is equivalent to Eq (6.6) in Acta Cryst. A42, 261
      data qm / 0, 0, 2, 1, 1, -1,
     *     2, 0, 0, -1, 1, 1,
     *     0, 2, 0, 1, -1, 1,
     *     0, 0, 0, -1, 1, 1,
     *     0, 0, 0, -1, -1, 1,
     *     0, 0, 0, 1, -1, 1/
c     coordinate transformation from face-centerd to primitive
      do i=1,6
         y(i)=0
         do j=1,6
            y(i)=y(i)+x(j)*qm(i,j)
         end do
         if(mod(y(i),2).ne.0) then
            write(6,*) 'x=',(x(j),j=1,6)
            write(6,*) 'y=',(y(j),j=1,6)
            call quit('nonallowd reflections')
         end if
         y(i)=y(i)/2
      end do
      return
      end
