c
c     extract files with specified number (set number)
c     and output hkl,fo,fc,phase
c     fc is replaced by fo in the original file because
c     LDM fc is not accurate and if fo in LDM is the unitary
c     structure factor, this fc can be used as fo in the 
c     Fourier synthesis
c
c      this program asks setnumber
c                        dimension
c                        filename of .phs file  (input file)
c                        filename of original hkl fo file (not unitary)
c                        filename of hkl  file (output file)
c
      parameter (nhkl=3000)
      integer hkl(6)
      real fo,fc,phase
      character*80 str,outfile,strn,flnm1,flnm2,flnm3,frmt,frmt1
      character*80 flnmn
      character*10 token(100),token1(100)
      integer hkln(6,nhkl)      ! indices
      real fon(nhkl)            ! extracted fo
      real sgn(nhkl)            ! extracted fc
      real phn(nhkl)            ! extracted phase
      data pi /3.141592/
      write(6,'(a,$)') 'data set number(s) to be extracted?: '
      read(5,'(a)') strn
      l0=istrln(strn)
      write(6,'(a)') strn(1:l0)
      write(6,'(a,$)') 'dimension (3-6)?: '
      read(5,*) idm
      write(6,'(a,$)') '.phs file?: '
      read(5,*) flnm1           ! file name of .phs file
c     write(6,'(a,$)') 'original .hkl file?: '
c     read(5,*) flnm2           ! file name of .hkl file
      write(6,'(a,$)') 'prefix of output .hkl files?: '
      read(5,*) flnm3           ! prefix of output .hkl file
      ln3=istrln(flnm3)
      call gettoken(strn,token1,nds) ! nds : number of data sets
c     write(6,*) 'number of data set chosen:',nds
c     read .hkl file once and count number of reflections
c      nh=0
c     call openfile(2,flnm2,'OLD')
c 30   continue
c      n1=nh+1
c     read(2,*,end=31) (hkln(k,n1),k=1,idm),fon(n1),sgn(n1)
                                ! read original hkl fo file
c      nh=nh+1                   ! read nh lines
c      go to 30
c 31   continue      
c      close(2)

c      if(hkln(1,nh).eq.999) then
c         nh=nh-1
c      end if

      do nset=1,nds
         call openfile(1,flnm1,'OLD') ! open .phs file

c        open output file
         strn=token1(nset)  ! nset-th token
         l1=istrln(strn)
c        write(6,*) 'token=',strn(1:l1)
c        write(6,*) 'data set=',strn(1:l1)
         read(strn,*) n         ! set number for nset-th token
         write(6,*) 'data set=',n
c        stop
         flnmn=flnm3(1:ln3)//'_'//strn(1:l1)//'.hkl'
         call openfile(3,flnmn,'UNKNOWN')

c     find a line begening with 'set number'
 10      continue
         read(1,'(a)',end=20) str ! read one line from .phs file
         call gettoken(str,token,ntk)
         i=istrln(token(1))
         j=istrln(token(2))
         if(token(1)(1:i).eq.'set'.and.token(2)(1:j).eq.'number') then
c           write(6,*) token(1),' ',token(2),' ',token(3)
            read(token(3),*) m
            if(n.eq.m) then
               go to 11
            end if
         end if
         go to 10

 11      continue  ! 'set number n' line is found
c        write(6,*) 'n=',n,' m=',m
         write(frmt,'(a,i1,a)') '(',idm,'i4,2f10.5,f10.5)'
         write(frmt1,'(a,i1,a)') '(',idm,'i4,3f12.4,f12.4)'

 22      continue
            read(1,'(a)',end=21) str     ! read hkl, fo, fc, iph
            call gettoken(str,token,ntk)
            j=istrln(token(1))
            if(token(1)(1:j).ne.'set') then
               read(str,*) (hkl(k),k=1,idm),fo,fc,iph,sg ! read from str
               write(3,frmt1) (hkl(j),j=1,idm),fo,fc,float(iph),sg
               go to 22
            else
               go to 21  ! end of specified data set
            end if
 21      continue

         close(1)        
c         hkl(1)=999
c         write(3,frmt1) hkl(1),(0,j=2,idm),0.,0.,0.,0.
         close(3)
      end do
      stop
 20   continue
      write(6,*) 'can not find data set', n
      stop
      end

      function icomp(h,hr,idm)  ! return 1 if h=hr else 0
      integer h(*),hr(*)
c     call getidm(idm)
      do i=1,idm
         if(h(i)-hr(i).ne.0) then
            icomp = 0
            return
         end if
      end do
      icomp = 1
      return
      end

      subroutine gettoken(str,token,ntk)
c     str : string including several tokens
c     token(i) : i-th token
c     ntk : number of tokens
      character*(*) str,token(*)
      integer j1(100),j2(100)
      lstr=len(str)
      ntk=0
      i1=1
 100  continue
      do i=i1,lstr
         if(str(i:i).ne.' ') then
            ntk=ntk+1
                                ! find first character of the ntk-th token
            j1(ntk)=i
            do j=i+1,lstr
               if(str(j:j).eq.' ') then
                                ! end of the ntk-th token
                  j2(ntk)=j-1
                  i1=j
                  go to 100
               end if
            end do
         end if
      end do
      do n=1,ntk
         token(n)=str(j1(n):j2(n))
      end do
      return
      end

      function istrln(c)
      character*(*) c
      l=len(c)
      do i=1,l
         if(c(i:i).eq.'!') then
            l1=i-1         ! before !
            go to 10
         end if
      end do
      l1=l
 10   continue
      do i=l1,1,-1
         if(c(i:i).ne.' ') then
            istrln=i
            return
         end if
      end do
      istrln=0
      return
      end

      subroutine openfile(iun,flnm,st)
      integer iun
      character*(*) flnm,st

      lflnm=istrln(flnm)
      lst=istrln(st)
      open (unit=iun,file=flnm(1:lflnm),status=st(1:lst),err=910)
      go to 810
 910  write(6,*) 'can''t open ',flnm(1:lflnm)
      call exit(1)
 810  continue
      return
      end

      subroutine tounitcell(h)  ! dummy function to use math
      integer h(*)
      return
      end
