      function getsc()
      common /csc/ sc
      getsc=sc
      return
      end

      subroutine symstflde(foi,sgi,hkli,nind,fmax)
c     generate equivalent reflections for Fourier map etc.
      real foi(*),sgi(*)
      integer hkli(6,*)
      include 'nrmax.inc'
      include 'iref.inc'

      integer irefd(6,nrmax)
      integer hd(6),hr(6),hi(6)
      integer ng(6)
      integer heq(6,120)
      common /csc/ sc

      call getidm(idm)
      call getng(ng)
      call getnsymo(nsymo)
      call geticent(icent)
      write(6,'(a,i3,a,i2)') 'nsymo',nsymo,' icent',icent
      write(6,*) 'nind in symstflde',nind
      nn=0
      ni=0
      sc=0
      fmax=0
      nskip=0
      do j=1,nind               !  independent reflections
c     generation of equivalent reflections
c     call wtvctri('hkli=',hkli(1,j),idm)
         if(iskip(hkli(1,j)).eq.1) then
            nskip=nskip+1
            go to 20
         end if
         call vcpyi(hkli(1,j),hi,6) ! *****2002.04.18
         neq=0
         do ns=1,nsymo          ! order of ns and ic loop is essential
            do ic=0,1           ! Laue symmetry is assumed
               call gethr(hi,hr,ns,ic)
                                ! indices in primitive cell for centered latt.
c     call ctoph(hr)   ! centerd to primitive transformation
               if(iequiv(hr,heq,neq).eq.0) then ! new equivalent reflection
                  nn=nn+1
                  if(ns.eq.1.and.ic.eq.0) then
                     ni=ni+1
                     iindx(j)=nn  ! indices for independent reflection
                  end if
                  if(nn.gt.nrmax) then
                     write(6,*) 'nn=',nn,' nrmax=',nrmax
                     call quit('nn > nrmax')
                  end if
                  fobs(nn)=foi(j)
                  fcal(nn)=foi(j)
                  sig(nn)=sgi(j)
                  iphas(nn)=0.0
c                 write(6,*) 'hr=',hr
                  call ctoph(hr) ! centerd to primitive transformation
                  call cpyhkl(hr,iref(1,nn))
                                !  write(6,'(6i3,f12.6)') hr,ar(ii)
                  sc=sc+fobs(nn)
               end if
            end do
         end do
         fmax=max(fmax,foi(j))
 20      continue
      end do
      write(6,*) 'nn=',nn
      if(nskip.ne.0) then
         write(6,*) nskip,' independent reflections are not used'
      end if

      nref=nn
      nrefi=ni
      sc=sc/float(nn)           ! average structure factor
c     sc=fmax                   ! maximum structure factor
      do i=1,nn
         fcal(i)=fcal(i)/sc
         fobs(i)=fobs(i)/sc
         sig(i)=sig(i)/sc
      end do
      fmax=fmax/sc
      return
      end

      integer function getcphase(cn) ! get phase of a complex number
      complex cn
      ang=atan3(aimag(cn),real(cn))
      getcphase=todeg(ang)           ! -180 <= getcphase <=180
      return
      end

      integer function getphase(ip) ! random phase angle in degree
c     ip : seed for random number
c     generate random phase between -180 and 180 degree
      call geticent(icent)
      r=ranp(ip)-0.5            ! -0.5<=r<=0.5
      iph=ifix(r*360.0)         ! -180<=iph<=180
      if(icent.eq.1) then       ! generate pi or 0
         if(iph.ge.-90.and.iph.lt.90) then
            iph=0
         else
            iph=180
         end if
      end if
      getphase=iph
      return
      end

      integer function getiphr(iph,hkli,ns,ic)
c     iph : phase of independent reflection
c     getiphr : return phase for its equivalent reflection
      integer hkli(*)
      integer getrediph
      phd=getyt(hkli,ns,0)      ! phase due to non primitive translation
      phd=mod(phd,1.0)          ! -1<=phd<=1
      iphd=phd*360              ! -360 <= iphd <= 360
c     write(6,*) 'iphd=',iphd
      iphr=iph-iphd
      if(ic.eq.1) then
         iphr=-iphr
      end if
      iphr=getrediph(iphr)      ! -180<=iphr<=180
      getiphr=iphr              ! phase for the reflection
      return
      end

      integer function getrediph(iphr)      ! -180<=iphr<=180
      iphr=mod(iphr,360)        ! -360<=iphr<=360
      if(iphr.gt.180) then
         getrediph=iphr-360
      else if(iphr.lt.-180) then
         getrediph=iphr+360
      else
         getrediph=iphr
      end if
      return
      end

      subroutine setphaseset(hkli,iphi,nind) ! set phase for memlde
      integer hkli(6,*),iphi(*)
      include 'equiv.inc'
      nn=0
      np=0
      do i=1,nind               ! number of independent reflections
c     generation of phase for equivalent reflections
         iph=iphi(i)            ! set given phase for independent reflection
c     write(6,*) 'iph=',iph
         call setequivph(hkli(1,i),iph,nn,np) ! set phase for equivalent refl.
      end do
      return
      end

      subroutine setrphaseset(hkli,nind,ip)  ! set random phase set
      integer hkli(6,*)
      call setrphaseset2(hkli,nind,ip) ! set random phase
c     call setrphaseset1(hkli,nind,ip) ! set random phase
      return
      end

c     this version should give phases fulfilling space group symmetry
c     and fixed point of the map should be equal to that given
c     by the setting of the space group used.
      subroutine setrphaseset2(hkli,nind,ip)  ! set random phase
      integer hkli(6,*)
      include 'equiv.inc'
      include 'nrmax.inc'
      integer getphase
      nn=0
      np=0
      do i=1,nind               ! number of independent reflections
c     generation of phase for equivalent reflections
         iph=getphase(ip)       ! get random phase angle in degree
c     write(6,*) 'iph=',iph
         call setequivph(hkli(1,i),iph,nn,np)  ! set phase for equivalent refl.
c     this calculates neq,cexpn etc.
      end do
      call setnref(nn)          ! set total reflections for memlde
      return
      end

      integer function getfphase(i) ! get given phase angle in degree      
      include 'nrmax.inc'
      include 'newphs.inc'
      getfphase=newphas(i)
      return
      end

      subroutine setfphase(i,iphase) ! get given phase angle in degree      
      include 'nrmax.inc'
      include 'newphs.inc'
      newphas(i)=iphase
      return
      end

      subroutine setgphaseset(hkli,nind,ip)  ! set given phase
      integer hkli(6,*)
      include 'equiv.inc'
      include 'nrmax.inc'
      integer getfphase
      nn=0
      np=0
      do i=1,nind               ! number of independent reflections
c     generation of phase for equivalent reflections
         iph=getfphase(i)       ! get given phase angle in degree
c     write(6,*) 'iph=',iph
         call setequivph(hkli(1,i),iph,nn,np)  ! set phase for equivalent refl.
c     this calculates neq,cexpn etc.
      end do
      call setnref(nn)          ! set total reflections for memlde
      return
      end

c     ***** do not use this at the moment
      subroutine setphfix(hkli,nind,ip) ! set fixed phases for fixing origin
      integer hkli(6,*)
      include 'equiv.inc'
      include 'nrmax.inc'
      integer getiphfix
      call getidm(idm)
      nn=0
      np=0
      do i=1,idm                ! number of independent reflections
c     generation of phase for equivalent reflections
         iph=getiphfix(i)      ! get random phase angle in degree
c     write(6,*) 'iph=',iph
         call setequivph(hkli(1,i),iph,nn,np)  ! set phase for equivalent refl.
c     this calculates neq,cexpn etc.
      end do
c     call setnref(nn)          ! set total reflections for memlde
      return
      end

      subroutine setnref(nn)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      nref=nn
      return
      end

      integer function getnref()
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      getnref=nref
      return
      end

      subroutine getiref(i,h)
      integer h(6)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyi(iref(1,i),h,6)
      return
      end

      integer function getiphas(i)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      getiphas=iphas(i)
      return
      end

      subroutine setiphas(i,iph)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      iphas(i)=iph
      return
      end

      subroutine chkphas(x0,nind)
      real x0(6,*)
      integer h(6)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
c     any combinations of x0(j,1) and x0(j,2) should be checked
      do i=1,nind
         ii=iindx(i)            ! index for independent reflection in iphas
         iph=iphas(ii)
         call vcpyi(iref(1,ii),h,idm) ! h: hkl for i-th reflection
         idph=mod(iph-vinpir(h,x0(1,j),idm)*360,360.0)
         write(6,*) 'idph=',idph
      end do
      return
      end

      subroutine gethmin(hmin,jph,nind)
      integer hmin(*),jph(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      integer h(6)
      integer iflag(6)
      logical isZeroh,isZerov,isFreecmp
      call getidm(idm)

      do j=1,idm
         if(isFreecmp(j)) then
            iflag(j)=1
         else
            iflag(j)=0
         end if
         hmin(j)=99999
      end do

      do i=1,nind
         ii=iindx(i)            ! index for independent reflection in iphas
         iph=iphas(ii)          ! phase angle of i-th reflection in degree 
         call vcpyi(iref(1,ii),h,idm) ! h: hkl for i-th reflection
         do j=1,idm
            if(isFreecmp(j)) then
               if(isZeroh(j,h,idm)) then
c     only j-th element is non zero
                  if(abs(h(j)).lt.abs(hmin(j))) then
                     hmin(j)=h(j) ! minimum hkl 
                     jph(j)=iph ! phase
                     iflag(j)=0
                  end if
               end if
            end if
         end do
      end do

      do i=1,idm
         if(.not.isFreecmp(j)) then
            hmin(j)=1
         end if
      end do

      if(.not.isZerov(iflag,idm)) then
         call quit('cannt determin hmin')
      end if
      return
      end

      subroutine getx1(x1,idm,hmin,jph)
      real x1(6,*)
      integer hmin(*),jph(*)
      logical isFreecmp
c     write(6,*) 'isFreecmp=',(isFreecmp(j),j=1,idm)
      do j=1,idm
         if(isFreecmp(j)) then
c           write(6,*) 'j,isFreecmp(j)',j,isFreecmp(j)
            ph=float(jph(j))/360.0 ! -0.5 < ph < 0.5
c           write(6,*) 'ph=',ph,' jph=',jph(j)
            hi=1.0/float(hmin(j))
            x1(j,1)=mod(ph*hi,1.)
            x1(j,2)=mod((ph-0.5)*hi,1.)
         else
c           write(6,*) 'j,isFreecmp(j)',j,isFreecmp(j)
            x1(j,1)=0
            x1(j,2)=0
         end if
      end do
      call reducx(x1(1,1),idm)
      call reducx(x1(1,2),idm)
      return
      end

      subroutine reducx(x,idm)   ! reduce -0.5 < x <= 0.5
      real x(*)
      do i=1,idm
         if(x(i).gt.0.5) then
            x(i)=x(i)-1
         else if(x(i).le.-0.5) then
            x(i)=x(i)+1
         end if
      end do
      return
      end

      subroutine getx2(x1,l,hmin,x2,idm)
      real x1(*),x2(*)
      integer l(*),hmin(*)
      do i=1,idm
         x2(i)=x1(i)+float(l(i))/hmin(i)
      end do
      return
      end

      function reducph(ph)   ! return -0.5 <= ph<= 0.5
      ph1=mod(ph,1.0)
      if(ph1.lt.-0.5) then
         ph1=ph1+1
      else if(ph1.gt.0.5) then
         ph1=ph1-1
      end if
      reducph=ph1
      return
      end

      subroutine getcenter(x0,nind)
      real x0(6)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      integer h(6),hmin(6),jph(6)
      integer iflag(6)
      logical isFreecmp
      real x1(6,2)
      real x2(6)
      real xd(6)
      integer hm(6),l(6),h1,h2,h3,h4,h5,h6
      integer ic1(8),ic2(8),ic3(8)
      data ic1 /1,2,1,1,1,2,2,2/
      data ic2 /1,1,2,1,2,1,2,2/
      data ic3 /1,1,1,2,2,2,1,2/
      pi2=2*getpi()
      call getidm(idm)
c     iphase should be exp(2pi i h.x0) if centrosymmetric
c     exp(2pi i h.x0)=exp(2pi hx)exp(2pi ky)exp(2pi lz) etc.
c     exclude h=k=0 reflection if any
c     choose k=l=0 reflections for determining x
c     choose l=h=0 reflections for determining y
c     choose h=k=0 reflections for determining z
c     ph=iphas/360
c     sin(2pi (ph-hx))=0 means hx=ph (mod 1) or hx=ph-0.5 (mod 1)
c     there are two possibilities for x,y,z

c     x=(ph+j)/h or (ph-0.5+j)/h, (j=-h+1,..,h-1)
c     return x1=(ph)/h and (ph-0.5)/h

      call gethmin(hmin,jph,nind)  ! get hmin,jph
      call wtvctrif('hmin=',hmin,idm,'(6i4)')
      call wtvctrif('jph=',jph,idm,'(6i4)')

c     write(6,*) 'isFreecmp=',(isFreecmp(j),j=1,idm)
c     choose correc x0

      do j=1,3
         hm(j)=abs(hmin(j))-1
      end do

      call getx1(x1,idm,hmin,jph)
      call wtvctrrf('x1=',x1(1,1),idm,'(6f10.5)')
      call wtvctrrf('x1=',x1(1,2),idm,'(6f10.5)')

      do h1=-hm(1),hm(1)
         l(1)=h1
         do h2=-hm(2),hm(2)
            l(2)=h2
            do h3=-hm(3),hm(3)
               l(3)=h3
               do k=1,8         ! 8 combinations
                  xd(1)=x1(1,ic1(k))
                  xd(2)=x1(2,ic2(k))
                  xd(3)=x1(3,ic3(k))
c               do k1=-5,5
c               do k2=-5,5
c               do k3=-5,5
c                  xd(1)=k1/10.0
c                  xd(2)=k2/10.0
c                  xd(3)=k3/10.0
c                 call wtvctrrf('xd=',xd,idm,'(6f10.5)')
                  call getx2(xd,l,hmin,x2,idm)
c                 call wtvctrrf('x2=',x2,idm,'(6f10.5)')
                  sinc=0        ! average sine component
                  do i=1,nind
                     ii=iindx(i) ! index for independent reflection in iphas
                     iph=iphas(ii)
                     pho=float(iph)/360 ! phase angle -0.5<=pho<=0.5
                     call vcpyi(iref(1,ii),h,idm) ! h: hkl for i-th reflection
                     phc=vinpir(h,x2,idm) 
                     phc=reducph(phc) ! -0.5<=phc<=0.5
c                    phoc=pho-phc
                     phoc=pho+phc
                     sinci=sin(pi2*phoc)
c                    write(6,*) 'phoc,sinci=',phoc,sinci
                     sinc=sinc+abs(sinci)
c                    write(6,*) 'phoc,sinc=',phoc,sinc
                  end do
                  write(6,*) 'nind,sinc=',nind,sinc
                  sinc=sinc/nind
                  if(sinc.le.0.01) then
                     call vcpyr(x2,x0,idm)
                     go to 100
                  end if
               end do
c               end do
c               end do
            end do
         end do
      end do
      call quit('no solution in getcenter')
      return
 100  continue
      call wtvctrrf('x0=',x0,idm,'(6f10.5)')
      return
      end

      logical function isZerov(h,idm)  ! return true if h is zero vector
      integer h(*)
      isZerov=.false.
      do k=1,idm
         if(h(k).ne.0) then
            return
         end if
      end do
      isZerov=.true.      
      return
      end

      logical function isZeroh(j,h,idm)  ! h is zero except for j-th component
      integer h(*)
      isZeroh=.false.
      do k=1,idm
         if(k.ne.j.and.h(k).ne.0) then
            return
         end if
      end do
      if(h(j).eq.0) then
         return
      end if
      isZeroh=.true.
      return
      end

      subroutine getiphasall(iph)
      integer iph(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyi(iphas,iph,nref)
      return
      end

      subroutine setiphasall(iph)
      integer iph(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyi(iph,iphas,nref)
      return
      end

c      integer function getiphic(i)
c      include 'equiv.inc'
c      include 'nrmax.inc'
c      include 'iref.inc'
c      getiphic=iphic(i)
c      return
c      end

      function getfobsi(i)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      getfobsi=fobs(i)
      return
      end

      subroutine setfobsi(i,fo)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      fobs(i)=fo
      return
      end

      function getfcali(i)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      getfcali=fcal(i)
      return
      end

      subroutine setfcali(i,fc)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      fcal(i)=fc
      return
      end
      
      subroutine getfobsall(fobsd)
      real fobsd(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyr(fobs,fobsd,nref)
      return
      end

      subroutine setfcalall(fcald)
      real fcald(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyr(fcald,fcal,nref)
      return
      end

      subroutine getfcalall(fcald)
      real fcald(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyr(fcal,fcald,nref)
      return
      end

      subroutine setfobsall(fobsd)
      real fobsd(*)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      call vcpyr(fobsd,fobs,nref)
      return
      end

      subroutine setequivph(hkli,iph,nn,np)
c     set phase for equivalent refl.
c     i    : i-th independent reflection
c     hkli : its indices
c     iph  : its phase angle in degree
c     integer hkli(6,*)
      integer hkli(6)
      include 'equiv.inc'
      include 'nrmax.inc'
      include 'iref.inc'
      integer hd(6),hr(6),hi(6)
      integer ng(6)
      real tt(6,60)
      complex cphase
      integer getiphr,getcphase
      call getng(ng)
      call getidm(idm)
      call getnsymo(nsymo)
      call geticent(icent)
      call getnpt(tt)
      if(iskip(hkli).eq.1) then
         return
      end if
c     write(6,'(a,i3,a,i2)') 'nsymo',nsymo
      neq=0
      call zerovi(nn1,120)      ! zero vector
      do ns=1,nsymo             ! order of ns and ic loop is essential
         iphr=getiphr(iph,hkli,ns,0) ! phase for equivalent refl.
         call gethr(hkli,hr,ns,0) 
         call ctoph(hr)         ! indices in primitive cell
         cphase=cexp(torad(float(iphr))*(0.0,1.0))
         do ic=0,1
            if(ic.eq.1) then
               cphase=conjg(cphase) ! complex conjugate
               call vnegatei(hr,6)
            end if
c     if hr is equivalent to n-th refl of heq return n else 0
            n1=iequiv(hr,heq,neq)
            if(n1.eq.0) then  ! independent (k-star)
               nn=nn+1
               nn1(neq)=1
               cexpn(neq)=cphase
               if(nn.gt.nrmax) then ! new reflection
                  call quit('nn > nrmax')
               end if
            else
               nn1(n1)=nn1(n1)+1
               cexpn(n1)=cexpn(n1)+cphase ! sum for average
            end if
         end do
      end do

c     ****** new ****
      call getnsymo(nsymo)
      if(neq.eq.0.or.nn1(1).eq.0) then
         call quit('neq = 0 or nn1 = 0')
      end if
c     write(6,'(a,(20i4))') 'neq,nn1',neq,(nn1(j),j=1,neq)
      do ns=1,neq               ! average several equivalent reflections
         if(nn1(ns)*neq.ne.nsymo*2) then
            write(6,*) 'strange nn1, nn1,neq,nsymo',nn1(ns),
     *           neq,nsymo
         end if
         cexpn(ns)=cexpn(ns)/nn1(ns) ! average
         iphas(np+ns)=getcphase(cexpn(ns)) ! set iphase
      end do
      np=nn                     ! previous nn
      return
      end

c     this version should give phases fulfilling space group symmetry
c     and fixed point of the map should be equal to that given
c     by the setting of the space group used.
      subroutine setrphaseset1(hkli,nind,ip)  ! get random phase set
      integer hkli(6,*)
      include 'nrmax.inc'
      include 'iref.inc'
      include 'equiv.inc'
      integer hd(6),hr(6),hi(6)
      integer ng(6)
      real tt(6,60)
      complex cphase
      integer getphase,getcphase,getiphr

      call getng(ng)
      call getidm(idm)
      call getnsymo(nsymo)
      call geticent(icent)
      call getnpt(tt)
c     write(6,'(a,i3,a,i2)') 'nsymo',nsymo
      nn=0
      np=0
      do i=1,nind               ! number of independent reflections
c     generation of phase for equivalent reflections
         iph=getphase(ip)       ! get random phase angle in degree
         neq=0
         call zerovi(nn1,120)  ! zero vector
         do ns=1,nsymo
            iphr=getiphr(iph,hkli(1,i),ns,0)
            do ic=0,1           ! Laue symmetry is assumed
               call gethr(hkli(1,i),hr,ns,ic) 
               call ctoph(hr)   ! indices in primitive cell
c     if hr is equivalent to n-th refl of heq return n else 0
               n1=iequiv(hr,heq,neq)
               if(ic.eq.1) then
                  iphr=-iphr      ! complex conjugate
               end if
               cphase=cexp(torad(float(iphr))*(0.0,1.0))
               if(n1.eq.0) then  ! equivalent
                  nn=nn+1
                  nn1(neq)=1
                  cexpn(neq)=cphase
                  if(nn.gt.nrmax) then ! new reflection
                     call quit('nn > nrmax')
                  end if
               else
                  nn1(n1)=nn1(n1)+1
                  cexpn(n1)=cexpn(n1)+cphase ! sum for average
               end if
            end do
         end do

c     ****** new ****
         if(neq.eq.0.or.nn1(1).eq.0) then
            call quit('neq = 0 or nn1 = 0')
         end if
c        write(6,'(a,(20i4))') 'neq,nn1',neq,(nn1(j),j=1,neq)
         do ns=1,neq            ! average several equivalent reflections
            if(nn1(ns)*neq.ne.nsymo*2) then
               write(6,*) 'strange nn1, nn1,neq,nsymo',nn1(ns),
     *              neq,nsymo
            end if
            cexpn(ns)=cexpn(ns)/nn1(ns) ! average
            iphas(np+ns)=getcphase(cexpn(ns))
         end do
         np=nn   ! previous nn
      end do
      return
      end

      subroutine setrphaseset0(hkli,nind,ip)  ! set random phase set
      integer hkli(6,*)
      include 'nrmax.inc'
      include 'iref.inc'
      integer hd(6),hr(6),hi(6)
      integer ng(6)
      integer heq(6,120)
      real tt(6,60)
      integer getphase,getiphr

      call getng(ng)
      call getidm(idm)
      call getnsymo(nsymo)
      call geticent(icent)
      call getnpt(tt)
c     write(6,'(a,i3,a,i2)') 'nsymo',nsymo
      nn=0
      do i=1,nind
c        generation of phase for equivalent reflections
         iph=getphase(ip)  ! get random phase angle in degree
         neq=0
         do ns=1,nsymo
            iphr=getiphr(iph,hkli(1,i),ns,0)
            do ic=0,1           ! Laue symmetry is assumed
               call gethr(hkli(1,i),hr,ns,ic) 
               call ctoph(hr)   ! indices in primitive cell
               if(iequiv(hr,heq,neq).eq.0) then  ! non equivalent
                  nn=nn+1
                  if(nn.gt.nrmax) then ! new reflection
                     call quit('nn > nrmax')
                  end if
                  if(ic.eq.0) then
                     iphas(nn)=mod(iphr+360,360)                 
                  else
                     iphas(nn)=mod(-iphr+360,360) ! complex conjugate
                  end if
c                 write(6,*) 'iphas(nn)=',iphas(nn)
               end if
            end do
         end do
      end do
      return
      end
