c
c            occupation domain of the decagonal quasicrystal
c
c      (1) title
c      (2) a,c,eps1,eps2,isys
c          eps1:
c          eps2:
c          isys: 1:cubic, 2:hexagonal, 3:pentagonal
c      (3) na, ne
c          na: number of atoms   (*****na<=30******)
c          ne: number of elements  (***ne<=10******)
c      (4) no,symb,ien,ish,nev,be,bi,ramin,ramax,p (*)
c         no: atom number
c         symb: site symbol
c         ien: center symbol to be ploted (see (11)) (1 <= ien <= 5)
c         ish: for a,b,c,d,e atoms in the generalized penrose
c            for circle give 6,
c            for other atom shape give 0 and e1,e2,e3 in (6)
c         nev: number of edge vectors   (2 <= ne <= 11)
c             for ish=1,2,3,4,5 ne=3
c         be: isotropic temperature factor in external space
c         bi: isotropic temperature factor in internal space
c         ramin: minimum atom radius in internal space
c         ramax: minimum atom radius in internal space
c         p    : occupation probability
c            ***************notice***************
c          the empty domain is the inverse of the occupied domain
c
c      (5) x(1)-x(6): coordinate of atom in 5D
c          xe(1)-xe(6),u shift vector in ve and magnitude  (6D coordinates)
c          xi(1)-xi(6),v shift vector in vi and magnitude  (6D coordinates)
c        ******* if(ish.gt.0) skip (6) ****
c      (6) ej 
c          ej:  edge vectors of a polygon for occ. domain (6D coordinates)
c               repeat (6) ne times
c                ***************notice****************
c               the internal components of consecutive ej are regarded as
c               the consecutive edge vectors of the polygon defining
c               the occupation domain
c                ***************notice***************
c               the empty domain is the inverse of the occupied domain
c
c       ******** repeat (4)-(6) na times
c      (7) nsymo,icent,brv
c          nsymo: number of generators in symmetry operations
c          icent: give 1 for centrosymmetric
c                 otherwise give 0
c          brv  : 'P','i','f' bravais lattice
c      (8) 'symmetry operator'        header  and
c      (9)  symmetry operator in the I.T. format
c              x,y,z,t,u,v etc.      
c         ***** repeat (8) nsymo times
      program dcagdom
      parameter (nemax=10)
      real dm(6,6)
      integer q5(6),qm1(6),qm2(6)
      real xy(3)
      real x(6,30),mpl(30),be(30),bi(30),ra(30),rb(30),p(30)
      real ei(6,11,30),vi(11,30),ni(0:5,22,30)
      integer iski(0:120,30)
      integer ien(30),ish(30),nev(30),isk(0:120,30),irs(0:120,30)
      character*72 title
      integer col1,col2,col3
      real xy(3)
      common cs(5),sn(5)
      common /ceps/ epsd
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cskip/ iskip
      common /cgetq/ dr(6,6),sds(6,6),dq(6,6),al,cl
      real nr
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10)
      real td(6)
      data td/6*0./
      data dr/    -.6910, 0.9511, 0.0   ,-1.8090, 0.5878, 0.,
     *           -1.8090, 0.5878, 0.0   , -.6910, -.9511, 0.,
     *           -1.8090, -.5878, 0.0   , -.6910, 0.9511, 0.,
     *            -.6910, -.9511, 0.0   ,-1.8090, -.5878, 0.,
     *            0.0   , 0.0   , 1.0   , 0.0   , 0.0   , 0.,
     *            0.0   , 0.0   , 0.0   , 0.0   , 0.0   , 1./
      data dq/    0.3090, 0.9511, 0.0   , -.8090, 0.5878, 0.,
     *            -.8090, 0.5878, 0.0   , 0.3090, -.9511, 0.,
     *            -.8090, -.5878, 0.0   , 0.3090, 0.9511, 0.,
     *            0.3090, -.9511, 0.0   , -.8090, -.5878, 0.,
     *            0.0   , 0.0   , 1.0   , 0.0   , 0.0   , 0.,
     *            0.0   , 0.0   , 0.0   , 0.0   , 0.0   , 1./
      data sds/   1.,     0.,     0.,     0.,     0.,     0.,
     *            0.,     1.,     0.,     0.,     0.,     0.,
     *            0.,     0.,     1.,     0.,     0.,     0.,
     *            0.,     0.,     0.,     1.,     0.,     0.,
     *            0.,     0.,     0.,     0.,     1.,     0.,
     *            0.,     0.,     0.,     0.,     0.,     1./
      data eps/0.01/
      data eps1/0.0001/
      data q5/0,0,0,0,1,0/
      data qm1/1,0,0,-1,0,0/
      data qm2/1,0,0,0,0,0/
      data dm/36*0/
      data pi2/6.28318/
      call setinp(5)
      call setout(6)
      sctmdl=0
c      read(5,'(a)') title
      call freadc('title=',1,title,1)
      write(6,'(1h ,a)') title
c      read(5,'(4f8.5,i3)') al,cl,e1,e2,isys
      call freadr('a=',1,al,1)
      call freadr('c=',1,cl,0)
      call freadr('eps1=',1,e1,0)
      call freadr('eps2=',1,e2,0)
      call freadi('isys=',1,isys,0)
      write(6,'(1h ,4(a,f8.5),a,i3)') 'al=',al,' cl=',cl,' eps1=',
     *              e1,' eps2=',e2, ' isys=',isys
      dm(1,1)=1
      dm(2,2)=1
      dm(3,3)=1
      dm(4,4)=1+e1
      dm(5,5)=1+e1
      dm(6,6)=1+e2
c      read(5,'(i3,f8.5)') na,ne
      call freadi('na=',1,na,1)
      call freadi('ne=',1,ne,0)
c     call freadr('gamma=',1,gamma,0)
      write(6,'(1h ,a,2i3)') 'na,ne ',na,ne
      call rdap(na,ien,ish,nev,be,bi,ra,rb,p,x,ei,vi)
      call rdsymo(na,brv)
      call sitesy(na,mpl,x,isk,irs)
      call invisk(na,isk,iski)
      call getni(na,nev,ei,ni,irs)
      do 50 i=1,5
          cs(i)=cos(pi2*i/5)
          sn(i)=sin(pi2*i/5)
 50   continue
      write(6,*) 'ldev col1 col2 col3 shftx shfty ?'
      read(5,*) ldev,col1,col2,col3,shftx,shfty
      amag=4
      call orient(2)
      call plots(20.,10.,ldev)
      call newpen(4)
      ifil=0
      shftx=shftx*amag
      shfty=shfty*amag
      xy(1)=0
      xy(2)=0
      rw=amag
      rc=0.01
      call pentgn(rw,col1,ifil,1,ldev)
      call circle(0.,360.,rc,xy,col1)
      call plot(shftx,shfty,-3)
      rw=1.618*amag
      call pentgn(rw,col1,ifil,-1,ldev)
      call circle(0.,360.,rc,xy,col1)
      call plot(shftx,shfty,-3)
      rw=1.618*amag
      call pentgn(rw,col1,ifil,1,ldev)
      call circle(0.,360.,rc,xy,col1)
      call plot(shftx,shfty,-3)
      rw=amag
      call pentgn(rw,col1,ifil,-1,ldev)
      call circle(0.,360.,rc,xy,col1)
      call plote('end of plot')
      if(ldev.eq.1) then
          call getzap()
      end if
      stop
      end

      subroutine pentgn(r,col,ifil,isg,ldev)
      real r
      integer col,ifil,isg,ldev
      real x(8),y(8)
      common cs(5),sn(5)
      data pi2/6.28318/
      call fillarea(ifil)
      if(ldev.eq.3) then
          call fillcolor(20*col+9)
          call newpen(col)
      else
          call fillcolor(col)
          call newpen(3)
      end if
      do 61 i=1,5
          x(i)=isg*cs(i)*r
          y(i)=isg*sn(i)*r
 61   continue
      x(6)=x(1)
      y(6)=y(1)
      x(7)=0.
      y(7)=0.
      x(8)=1.
      y(8)=1.
      call plylin(x,y,6,1,0,0)
      return
      end

      function ifskip(q)
      real q(*)
      data eps/0.001/
      ifskip=1
      if(q(3).lt.-eps) return
      if(q(2).lt.-eps) return
      if(-.3090*q(1)+0.9511*q(2).gt.eps) return
      ifskip=0
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      do 10 i=1,nx
 10   ip(i)=i
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(x(i).lt.xt) then
        i=i+1
        go to 3
      endif
    4 if(xt.lt.x(j)) then
        j=j-1
        go to 4
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        i=i+1
        j=j-1
        go to 3
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine getqi(h,q)
      integer h(*)
      real q(*)
      real dq
      common /cgetq/ dq(6,6),al,cl
      data sqrt5 /2.23606/
      do 100 i=1,6
           q(i)=0.
           do 101 j=1,6
           if(j.le.4) then
                q(i)=q(i)+dq(j,i)*h(j)/sqrt5
           else
                q(i)=q(i)+dq(j,i)*h(j)
           end if
 101       continue
      if(i.le.2) q(i)=q(i)/al
      if(i.eq.3) q(i)=q(i)/cl
 100  continue
      return
      end

      subroutine freadi(prfx,n,var,nl)
      integer var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue

          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      subroutine freadr(prfx,n,var,nl)
      real var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
c           read(inpu,'(a)') buf
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
          write(iout,'(2a)') prfx,' not found'
          call quit(' ')
      return
      end

      subroutine freadc(prfx,n,var,nl)
      character*(*) var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      lval=len(var)
      if(nl.eq.1) then
c           read(inpu,'(a)') buf
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp+1:256),'''')
          if(ipd1.gt.0) then
              jp=ipd1+jp+1
          else
              jp=256
          end if
c         jp: beginning of the next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i)(1:lval),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      function istrln(c)
      character*(*) c
      l=len(c)
      do 10 i=l,1,-1
      if(c(i:i).ne.' ') then
          istrln=i
          return
      end if
 10   continue
      istrln=0
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      call exit()
      end

      subroutine invisk(na,isk,iski)
      integer isk(0:120,*),iski(0:120,*),rr(6,6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer iord(60)
      write(6,*) 'inverse operator for each atom'
      call ordr(r,iord,nsymo,6)
      do 100 n=1,na
      iski(0,n)=isk(0,n)
          do 200 i=1,isk(0,n)
          nsy=isk(i,n)
          if(iord(nsy).eq.1.or.iord(nsy).eq.2) then
              iski(i,n)=nsy
          else
              do 300 j=1,nsymo
              if(iord(nsy).ne.iord(j)) go to 300
              call mtmpli(r(1,1,nsy),r(1,1,j),rr)
              if(identm(rr).eq.1) then
                  iski(i,n)=j
                  go to 200
              end if
 300          continue
              call quit('error in invisk')
          end if
 200      continue
      write(6,*) 'atom',n,'  ',(iski(j,n),j=1,isk(0,n))
 100  continue
      return
      end

      function identm(rr)
      integer rr(6,6)
c      if rr is identity matrix identm=1 else 0
      identm=0
      do 10 i=1,6
      do 10 j=1,6
      if(i.eq.j) then
           if(rr(i,i).ne.1) return
      else
           if(rr(i,j).ne.0) return
      end if
 10   continue
      identm=1
      return
      end
