c
c     write domain of the decagonal quasilattice
c
      real nr,ang(10),wx(2),wy(2),wz(2),wa(2),wb(2),wc(2),wd(2)
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10),xx(10,10),yy(10,10)
      integer ns(10),st(20),cent(6),a(6),b(6),c(6),d(6)
      integer h,k,l,m
      data cent/0,1,1,1,-4,1/
      data a/0,0,0,0,-1,1/
      data b/0,1,0,0,-1,0/
      data c/0,0,1,0,-1,0/
      data d/0,0,0,1,-1,0/

      write(6,*) 'gamma ldev'
      read(5,*) gamma,ldev
      if(ldev.eq.0) ldev=1
      call plots(15.,10.,ldev)
      call getwx(cent,wx)
      call getwx(a,wa)
      call getwx(b,wb)
      call getwx(c,wc)
      call getwx(d,wd)
      do 110 h=-1,1
      do 110 k=-1,1
      do 110 l=-1,1
      do 110 m=-1,1
          if(h.eq.0.and.k.eq.0.and.l.eq.0.and.m.eq.0) then
               call newpen(3)
          else
               call newpen(1)
          end if
          wy(1)=(h*wa(1)+k*wb(1)+l*wc(1)+m*wd(1))*5
          wy(2)=(h*wa(2)+k*wb(2)+l*wc(2)+m*wd(2))*5
      do 100 i=1,5
          call intsec(gamma,i,np)
c          write(6,*) (xx(j,i),yy(j,i),j=1,np)
          do 150 j=1,np
          ang(j)=atan0(xx(j,i),yy(j,i))
 150      continue
          call qsort(ang,st,ns,np)
          do 200 jj=1,np
          j=ns(jj)
           wz(1)=xx(j,i)+wx(1)*i+wy(1)
           wz(2)=yy(j,i)+wx(2)*i+wy(2)
          if(jj.eq.1) then
               call plot(wz(1),wz(2),3)
          else
               call plot(wz(1),wz(2),2)
          end if
          if(jj.eq.np) then
               j=ns(1)
               wz(1)=xx(j,i)+wx(1)*i+wy(1)
               wz(2)=yy(j,i)+wx(2)*i+wy(2)
               call plot(wz(1),wz(2),2)
          end if
 200      continue
 100  continue
 110  continue
      call plote('end of plot')
      stop
      end
c
c     find intersection of rhombic icosahedron
c
      subroutine intsec(gamma,ish,np)
      dimension a(3,3),b(3),ipvt(3),indx(3,2),pvt(3)
      real an(10),bn(10),cn(10),qd(6)
      real ff(20),aa(20),bb(20),cc(20),ct(20)
      real zz(10),ax(10),bx(10)
      real nr
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10),xx(10,10),yy(10,10)
      real cnt,tau
      integer nx(6,10)
      data nx/1,1,0,0,0,0,  1,0,1,0,0,0,  1,0,0,1,0,0,
     *        1,0,0,0,1,0,  1,0,0,0,0,1,  0,1,1,0,0,0,
     *        0,0,1,1,0,0,  0,0,0,1,1,0,  0,0,0,0,1,1,
     *        0,1,0,0,0,1/
      data mp/5/, nbf/10/, eps/0.0001/, eps1/0.0002/
      data cnt/0.5/, tau/1.618/, rat/1.3763/, sqrt5/2.23606/
      wt(x1,x2,x3,h1,h2,h3,f)=h1*x1+h2*x2+h3*x3-f
c
c          polyhedral boundary
c          nbf: number of boundary planes
c          direction cos aa,bb,cc
      do 130 i=1,nbf
           call getqp(nx(1,i),qd)
           absa=sqrt(qd(1)**2+qd(2)**2+qd(3)**2)
           an(i)=qd(1)/absa
           bn(i)=qd(2)/absa
           cn(i)=qd(3)/absa
 130  continue

      ua=-sqrt5/2
      ub= sqrt5/2
      du=ub-ua
c     x: x-coordinate used in the gauss integral
            zzz=(gamma+ish-3)/5
            zzz=mod(zzz,1.)
            if(zzz.gt.0.5) then
                 zzz=zzz-1
            else if(zzz.lt.-0.5) then
                 zzz=zzz+1
            end if
c     **** -0.5<=zzz<=0.5****
            zz(ish)=du*zzz
c      find x,y coordinates at given z
           do 100 i=1,nbf
                aa(i)=an(i)
                bb(i)=bn(i)
                cc(i)=cn(i)
                ff(i)=rat
                ct(i)=-cnt
 100       continue
           do 110 i=nbf+1,nbf*2
                aa(i)=-an(i-nbf)
                bb(i)=-bn(i-nbf)
                cc(i)=-cn(i-nbf)
                ff(i)=rat
                ct(i)= cnt
 110       continue
      np=0
      do 200 i=1,nbf*2-1
c     plane normal to z-axis
      if(abs(1.0-abs(cc(i))).lt.eps) go to 200
           do 210 j=i+1,nbf*2
           if(abs(1.0-abs(cc(j))).lt.eps) go to 210
c     plane normal to z-axis
           if(abs(1.0-abs(aa(i)*aa(j)
     *               +bb(i)*bb(j)+cc(i)*cc(j))).lt.eps)
     *                        go to 210
c     plane i and plane j are parallel
c      a11*x+a12*y=b1    line1
c      a21*x+a22*y=b2    line2
           if(abs(aa(i)*bb(j)-aa(j)*bb(i)).lt.eps) go to 210
c      two lines are parallel  (det=0)
           a(1,1)=aa(i)
           a(1,2)=bb(i)
           a(2,1)=aa(j)
           a(2,2)=bb(j)
           b(1)=ff(i)-cc(i)*(zz(ish)-ct(i))
           b(2)=ff(j)-cc(j)*(zz(ish)-ct(j))
           call matinv(a,3,2,b,1,det,ipvt,indx,pvt)
c          b: x,y coordinates of the vertex of polyhedron
c                  on the plane passes at a given z
c          remove vertex outside the polyhedron
           do 220 l=1,nbf*2
           if(wt(b(1),b(2),zz(ish)-ct(l),
     *          aa(l),bb(l),cc(l),ff(l)) .gt. eps) go to 210
 220       continue
c          xx(np,ish),yy(np,ish): coord. of vertex at ish-th section
c          remove multiple points
           iskp=0
           do 300 k=1,np
           if(abs(xx(k,ish)-b(1)).lt.eps1
     *                  .and. abs(yy(k,ish)-b(2)).lt.eps1) then
                iskp=1
                go to 301
           end if
 300       continue
 301       continue
           if(iskp.eq.0) then
                np=np+1
                if(np.le.10) then
                     xx(np,ish)=b(1)
                     yy(np,ish)=b(2)
                else
                     write(6,'(1h ,a)') 'veteces more than 10'
                     stop
                end if
           end if
 210       continue
 200  continue
      call normal(ax,bx,fx(1,ish),xx(1,ish),yy(1,ish),np)
      nps(ish)=np
      do 400 i=1,np
           qd(1)=0
           qd(2)=0
           qd(3)=0
           qd(4)=-ax(i)
           qd(5)=-bx(i)
           qd(6)=0
           call qtox(qd,nr(1,i,ish))
 400  continue
      return
      end

      subroutine normal(ax,bx,fx,xx,yy,np)
      real ax(*),bx(*),fx(*),xx(*),yy(*)
      real ang(10),st(20)
      integer ns(10)
      data pi/3.141592/
      do 100 i=1,np
      ang(i)=atan0(yy(i),xx(i))
 100  continue
c     rearrange ds in ascending order of dd
      call qsort(ang,st,ns,np)
      do 200 i=1,np
             if(i.lt.np) then
                  j=ns(i+1)
             else
                  j=ns(1)
             end if
             k=ns(i)
             dy=yy(j)-yy(k)
             dx=xx(j)-xx(k)
             absd=sqrt(dx**2+dy**2)
             xn=dx/absd
             yn=dy/absd
c      grd: edge gradient
             grd=atan0(dy,dx)
c      ax,bx: direction cos of normal to edge
             grd=grd-pi/2
             ax(i)=cos(grd)
             bx(i)=sin(grd)
c      fx: length of normal
             fx(i)=ax(i)*xx(k)+bx(i)*yy(k)
 200  continue
      return
      end

      subroutine getqp(h,q)
      integer h(*)
      real q(*),qd(6),dr(6,6),d(6,6),sds(6,6)
      data  d /   0.,     0.,     1.,     0.,     0.,      1.,
     *            -.7236, 0.5257, 0.4472, -.2764, -.8507, -.4472,
     *            -.7236, -.5257, 0.4472, -.2764, 0.8507, -.4472,
     *            0.2764, -.8507, 0.4472, 0.7236, -.5257, -.4472,
     *            0.8944, 0.,     0.4472, -.8944, 0.,     -.4472,
     *            0.2764, 0.8507, 0.4472, 0.7236, 0.5257, -.4472/
      data sds/ 1., 0., 0., 0., 0., 0.,
     *          0., 1., 0., 0., 0., 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 1., 0., 0.,
     *          0., 0., 0., 0., 1., 0.,
     *          0., 0., 0., 0., 0., 1./
      call mcpy(d,dr)
      call trnsp(dr)
      do 200 i=1,6
           qd(i)=0.
           do 201 j=1,6
                qd(i)=qd(i)+sds(j,i)*h(j)
 201       continue
 200  continue
      do 100 i=1,6
           q(i)=0.
           do 101 j=1,6
                q(i)=q(i)+dr(j,i)*qd(j)
 101       continue
 100  continue
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
           amax=0.0
           do 105 j=1,n
           if(ipivot(j).ne.1) then
                do 100 k=1,n
                if(ipivot(k)-1) 80,100,740
  80            if(abs(amax).lt.abs(a(j,k))) then
                     irow=j
                     icolum=k
                     amax=a(j,k)
                end if
 100            continue
           end if
 105       continue
           ipivot(icolum)=ipivot(icolum)+1
           if(irow.ne.icolum) then
                determ=-determ
                do 200 l=1,n
                swap=a(irow,l)
                a(irow,l)=a(icolum,l)
 200            a(icolum,l)=swap
                if(m.ne.0) then
                     swap=b(irow)
                     b(irow)=b(icolum)
                     b(icolum)=swap
                end if
           end if
 260       index(i,1)=irow
           index(i,2)=icolum
           pivot(i)=a(icolum,icolum)
           determ=determ*pivot(i)
           a(icolum,icolum)=1.0
           do 350 l=1,n
 350       a(icolum,l)=a(icolum,l)/pivot(i)
           if(m.ne.0) b(icolum)=b(icolum)/pivot(i)
 380       do 550 l1=1,n
           if(l1.ne.icolum) then
               t=a(l1,icolum)
                a(l1,icolum)=0.0
                do 450 l=1,n
 450            a(l1,l)=a(l1,l)-a(icolum,l)*t
                if(m.ne.0) b(l1)=b(l1)-b(icolum)*t
           end if
 550       continue
 555  continue
      do 710 i=1,n
           l=n+1-i
           if(index(l,1).ne.index(l,2)) then
                jrow=index(l,1)
                jcolum=index(l,2)
                do 700  k=1,n
                swap=a(k,jrow)
                a(k,jrow)=a(k,jcolum)
 700            a(k,jcolum)=swap
           end if
 710  continue
 740  continue
      return
      end

      subroutine qtox(qd,q)
      real qd(*),q(*)
      common /cgetq/ dr(6,6),sds(6,6),dq(6,6),al,cl,er(6,6)
      data sqrt5/2.23606/
      do 200 i=1,6
      if(i.le.2) qd(i)=qd(i)/al
      if(i.eq.3) qd(i)=qd(i)/cl
 200  continue
      do 100 i=1,6
           q(i)=0.
           do 101 j=1,6
                q(i)=q(i)+er(j,i)*qd(j)
 101       continue
 100  continue
      do 300 i=1,6
      if(i.le.4) q(i)=q(i)*sqrt5/2
 300  continue
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      do 10 i=1,nx
 10   ip(i)=i
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(x(i).lt.xt) then
        i=i+1
        go to 3
      endif
    4 if(xt.lt.x(j)) then
        j=j-1
        go to 4
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        i=i+1
        j=j-1
        go to 3
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end


      subroutine trnsp(sm)
      real smd(6,6),sm(6,6)
      do 100 i=1,6
      do 100 j=1,6
           smd(i,j)=sm(j,i)
 100  continue
      do 110 i=1,6
      do 110 j=1,6
           sm(i,j)=smd(i,j)
 110  continue
      return
      end

      subroutine mcpy(s1,s2)
      real s1(6,6),s2(6,6)
      do 100 i=1,6
      do 100 j=1,6
      s2(i,j)=s1(i,j)
 100  continue
      return
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do 100 i=1,6
      do 100 j=1,6
           c(i,j)=0.
           do 200 k=1,6
                c(i,j)=c(i,j)+a(i,k)*b(k,j)
 200       continue
 100  continue
      return
      end

      function atan0(y,x)
      data pi/3.141592/, eps/0.00001/
      if(abs(x).lt.eps) then
           if(y.gt.0) then
              atan0=pi/2
           else
              atan0=-pi/2
           end if
      else if(abs(y).lt.0) then
              atan0=0.
      else
              atan0=atan2(y,x)
      end if
      return
      end

      subroutine getwx(cent,wx)
      integer cent(*)
      real wx(*),x(6)
      call getqp(cent,x)
      wx(1)=x(1)/5
      wx(2)=x(2)/5
      return
      end

      subroutine rdap(na,ien,ish,ne,be,bi,ramin,ramax,p,s,x,ei,vi)
      character*6 atom
      common /cwflag/ iwflag(6)
      common /cltc/ atom(30)
      real x(6,*),be(*),bi(*),ramin(*),ramax(*),p(*),s(*),vi(11,*)
      integer ien(*),ish(*),ne(*)
      real ei(6,11,*)
      real fi(6,11),ej(6,11),xe(6),xi(6),xd(6),q(6)
      real e1(6),e2(6)
c
      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(6,301) na
         write(6,'(1h ,a)')
     *      'no,symbol,ien,ish,be,bi,ramin,ramax,p,s / x'
      end if
      do 90 i=1,na
           read(5,*) ik,atom(i),ien(i),ish(i),ne(i),
     *         be(i),bi(i),ramin(i),ramax(i),p(i),s(i)
           if(ne(i).gt.11) call quit('**** ne > 11****')
c           read(5,*) (x(j,i),j=1,6)
           call freadr('x=',6,x(1,i),1)
           call freadr('xe=',6,xe,1)
           call freadr('u=',1,u,0)
           call freadr('xi=',6,xi,1)
           call freadr('v=',1,v,0)
           if(ish(i).eq.0) then
                do 95 k=1,ne(i)
c               read(5,*) (ej(j,k),j=1,6)
                call freadr('ej=',6,ej(1,k),1)
                call tr6to5(ej(1,k),fi(1,k))
 95             continue
           else if(ish(i).gt.0.and.ish(i).le.5) then
c               transform into 4-D coordinate system	
                ii=ish(i)
                ne(i)=2
                call pentdm(e1,e2,ii)
                call tr6to5(e1,fi(1,1))
                call tr6to5(e2,fi(1,2))
           end if
           if(iwflag(3).eq.1) then
                 write(6,302) ik,atom(i),ien(i),ish(i),ne(i),
     *           be(i),bi(i),ramin(i),ramax(i),p(i),s(i)
                 write(6,303) 'x =', (x(j,i),j=1,6)
                 write(6,303) 'xe=', (xe(j),j=1,6),'u=',u
                 write(6,303) 'xi=', (xi(j),j=1,6),'v=',v
                 do 321 k=1,ne(i)
                 write(6,303) 'ej=',(fi(j,k),j=1,6)
 321             continue
           end if
c     remove internal components of xe
           call tr6to5(xe,xd)
           call getqe(xd,q)
           q(4)=0
           q(5)=0
           q(6)=0
           call qtox(q,xe)
           xe(5)=0.
           xe(6)=0.
c     remove external components of xi
           call tr6to5(xi,xd)
           call getqe(xd,q)
           q(1)=0
           q(2)=0
           q(3)=0
           call qtox(q,xi)
           xe(5)=0.
           xi(6)=0.
           do 20 j=1,6
               x(j,i)=x(j,i)+u*xe(j)+v*xi(j)
 20        continue
           do 96 j=1,ne(i)
           call getqe(fi(1,j),ei(1,j,i))
 96        continue
           do 120 j=1,ne(i)-1
           vi(j,i)=abs(ei(4,j,i)*ei(5,j+1,i)
     *                  -ei(5,j,i)*ei(4,j+1,i))
 120       continue
           write(6,*) (vi(j,i),j=1,ne(i)-1)
 90   continue
 11   continue
      if(iwflag(3).eq.1) then
           write(6,300)
      end if
 102  format(i2,a,3i2,6f8.5/6f8.5)
 300  format(1h )
 301  format(1h ,'na=',i3)
 302  format(1h ,i4,2x,a,2x,3i2,2x,6f8.5/1h ,6f8.5,3i3)
 303  format(1h ,a,6f8.5,2x,a,f8.5)
      return
      end

      subroutine getni(na,ne,ei,ni,irs)
      real ei(6,11,*),ni(0:5,22,*)
      integer ne(*),irs(0:120,*)
      real cent(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      data eps/0.00001/
      do 90 i=1,na
c         unit vector normal to ei(i)
          do 911 j=1,ne(i)
              absei=sqrt(ei(4,j,i)**2+ei(5,j,i)**2)
              ni(0,j,i)=absei
              ni(4,j,i)= ei(5,j,i)/absei
              ni(5,j,i)=-ei(4,j,i)/absei
 911      continue
c         unit vector normal to ei(i+1)-ei(i)
          do 93 j=1,ne(i)-1
              i0=j
              i1=j+1
              j0=j+ne(i)
              absei=sqrt((ei(4,i1,i)-ei(4,i0,i))**2+
     *                   (ei(5,i1,i)-ei(5,i0,i))**2)
              if(absei.gt.eps) then
              ni(0,j0,i)=absei
              ni(4,j0,i)= (ei(5,i1,i)-ei(5,i0,i))/absei
              ni(5,j0,i)=-(ei(4,i1,i)-ei(4,i0,i))/absei
              else
                  do 95 k=4,5
                  ni(k,j0,i)=0.
 95               continue
                  ni(0,j0,i)=0.
              end if
              do 200 k=4,5
              cent(k)=(ei(k,i1,i)+ei(k,i0,i))/2
 200          continue
              if(vinp(cent(4),ni(4,j0,i),3).gt.0.) then
                  sig=1.
              else
                  sig=-1.
                  write(6,*) 'sign in getni is negative'
              end if
              do 210 k=4,5
              ni(k,j0,i)=ni(k,j0,i)*sig
 210          continue
 93           continue
 91       continue
 90   continue
      return
      end

      subroutine invisk(na,isk,iski)
      integer isk(0:120,*),iski(0:120,*),rr(6,6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      write(6,*) 'reciprocal operator for each atom'
      do 100 n=1,na
      iski(0,n)=isk(0,n)
          do 200 i=1,isk(0,n)
          nsy=isk(i,n)
              do 300 j=1,nsymo
              call mtmpli(r(1,1,nsy),r(1,1,j),rr)
              if(identm(rr).eq.1) then
                  iski(i,n)=j
                  go to 200
              end if
 300          continue
          call quit('error in invisk')
 200      continue
      write(6,*) 'atom',n,'  ',(iski(j,n),j=1,isk(0,n))
 100  continue
      return
      end

      function identm(rr)
      integer rr(6,6)
c      if rr is identity matrix identm=1 else 0
      identm=0
      do 10 i=1,6
      do 10 j=1,6
      if(i.eq.j) then
           if(rr(i,i).ne.1) return
      else
           if(rr(i,j).ne.0) return
      end if
 10   continue
      identm=1
      return
      end
