c
c             occupation domain of the decagonal quasicrystal
c
c                         input data
c
c      (0) inpm
c         inpm=0 separatel file (standard input, flnm1 and flnm2)
c             =1 standard input only
c      (1) title
c      (2) a,c,eps1,eps2,isys,ieqs,ists,ixrst
c          eps1:
c          eps2:
c          isys: 1: icosahedral 2: icosahedral 3:decagonal 4:octagonal
c               -3: pentagonal (not inplemented)
c               1,2 is not inplemented in the program
c          ieqs: 0,1 equivalent position is generated (0) or not (1)
c          ists: 0 true site symmetry operators are used
c                1 fictitious site symmetry operators are used for all atoms
c          ixrst: 1 shift of the domain center given by x is neglected
c      (3) na, npod, ne, jsyv
c          na: number of atoms   (*****na<=190******)
c          npod : number of predefined occupation domains  (<=namax=190)
c          ne: number of element (1 for Al, 2 for Mg etc.) which is
c                  used to paint occupation domains with specified
c                   colors  (see (12))
c          jsyv: 1: x, xe1, xe2, xe3, xi are transformed by isyv-th
c                symmetry operator
c                jsyv !=0,1 all the coordinates above are transformed by
c                      jsyv-th symmetry operator  (isyv=jsyv for all atoms)

c     ******** if inpm=0 skip (4) ******
c     (4) flnm1
c         flnm1 : filename which gives the following items
c     

c     ******** if inpm=1 skip (01)-(07) ******
c#############################################################################
c      (01) nsymo,icent,brv
c          nsymo: number of generators in symmetry operations
c          icent: give 1 for centrosymmetric
c                 otherwise give 0
c          brv  : 'p','i','f' 's' 'c' bravais lattice
c                  s in icosahedral  ==> face-centered superlattice
c                  s in decagonal    ==> Edagawa type superlattice
c                  s translates x,ej,xi in the normal lattice into those
c                                   in superlattice
c                  in decagonal case, s also translates sym. op in normal
c                     lattice into those in superlattice
c                  c P_2c for color symmetry
c          **************************************************************
c          when brv='s',  give x,xe1,xe2,xe3,xi,ej in the fundamental cell.
c          they are transformed into those of the supercell in the program.
c          **************************************************************
c     (02) 'symmetry operator'        header  and
c     (03)  symmetry operator in the I.T. format: x,y,z,t,u,v etc.
c            ***** repeat (03) nsymo times
c     (04) n,ne0,itype,str
c         n    : serial number for the guide to the eye
c         nej0 :number of edge vectors for predefined occupation domain (<=nemax=20)
c         itype  :  1 domain with icosahedral, degagonal or octagonal symmetry
c                   2 domain with other symmetry
c                  -1 domain with icosahedral, degagonal or octagonal symmetry for test
c                  -2 domain with other symmetry for test
c         str  : string for comments
c     (05) ej  : edge vectors of their internal components or principal axes
c         ej(1)-ej(6)
c               repeat (5) ne0 times
c     (06) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a tetrahedron
c                           (for isys=3,4,5)
c     (07) iaslct(1-(nsymo+icent*nsymo)) (80i1)
c           1:selected, 0:skipped **na times
c       ******** repeat (04)-(07) npod times
c ###########################################################################

c     ******** if inpm=0 skip (5) ******
c     (5) flnm2
c         flnm2 : filename which gives the following items

c     ******** if inpm=1 skip (01)-(08) ******
c ############################################################################
c     (01) no,symb,ien,ish,nej,be,bi,ramin,ramax,p, s1, s2 (*)
c         no: atom number
c         symb: site symbol
c         ien: element number
c         ish: for polygon give 0 and e1,e2,e3 in (6)
c         nej: number of edge vectors   (2 <= ne <= 11)
c             for ish=1,2,3,4,5 ne=3
c         be: isotropic temperature factor in external space
c         bi: isotropic temperature factor in internal space
c         ramin: minimum atom radius in internal space
c         ramax: minimum atom radius in internal space
c         p    : occupation probability
c         s1   : partial occupation probability
c         s2   : partial occupation probability
c            ***************notice***************
c          the empty domain is the inverse of the occupied domain
c       ****** for colored atom give xi(6)=1 (normal color)
c                      or -1 (inverse color)********
c       ****** colored atom should be black (icol=0) or white (icol=10) ****
c       ******** colored symmetry is only available for polygonal cases ******
c         
c         isyd, isyv (isyv: if jsyv=1)
c         isyd: additional symmetry operator for predefined ej
c         isyv: symmetry operator for coordinate transformation
c       ******** repeat (01) na times
c      (02) x(1)-x(6): coordinate of atom in 5D or 6D
c      (03) xe1(1)-xe1(6),u1 shift vector in ve and magnitude  (6D coordinates)
c      (04) xe2(1)-xe2(6),u2 shift vector in ve and magnitude  (6D coordinates)
c      (05) xe3(1)-xe3(6),u3 shift vector in ve and magnitude  (6D coordinates)
c               *********** xe1-xe3 are not normalized **********
c      (06) xi(1)-xi(6),v shift vector in vi and magnitude  (6D coordinates)

c       ******** if ish > 0 or ish = -2 skip (07) (08) *****
c      (07) ej 
c          ej:  edge vectors of a polygon for occ. domain (6D coordinates)
c               repeat (07) ne times
c                ***************notice****************
c               the internal components of consecutive ej are regarded as
c               the consecutive edge vectors of the polygon defining
c               the occupation domain
c                ***************notice***************
c               the empty domain is the inverse of the occupied domain
*****************************************************************************
c       for isys=3 or 5 (decagonal and dodecagonal cases)  
c       xe1,xe2,xe3,xi,ej are 6D or 7D expressions are used
c       while x is 5D expression
*****************************************************************************
c      (08) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a tetrahedron
c                           (for isys=3,4,5)
c       ******** repeat (01)-(08) na times
c ############################################################################

c      (6) ldev ng amag
c           ldev 1: B/W  2: color printer
c           ng  number of graph
c           amag magnification
c      (7) icolor : colors for ne elements ( ne <=50 )
c      (8) iorn:  orientation  1: portrait 2: landscape
c
c      (9) jaslct  (80i1)
c            if j-th column is 1 or 2, j-th occupation domain is drawn
c              1 : no side edge
c              2 : including side edge
c           
c      (10) shftx shfty iodc inum ifill ifrm
c           shftx, shfty: translation before drawing occupation domain
c                         of each atom
c           iodc:
c                 1 use specified occpation domain center given in flnm1
c                 0 use occupation domain center given in (5)
c           inum: occupaiton domain number mode
c                 0 no number
c                 1 numbering occupation domain number
c                 2 numbering independent occupation domain number
c                -1 numbering occupation domain number and corner number
c           ifill 1 fill the occupation domain with a color specified by icolor
c                 0 do not fill
c           ifrm  1 for overwrite the frame for ifill=1
c           ***********if itrns=0 skip (11)************
c      (11) xodc: coordinates of occupation domain center
c          ****** repeat (9-11) ng times******
      common /cwflag/ iwflag(6)
      common cs(5),sn(5)
      include 'polygn.inc'
      real q(6),rx(6),rx0(6),q0(6),xd(6)
      real mpld(namax)
      real ni(0:6,4,nemax,namax)
      real shftx(namax),shfty(namax)
      integer isk(0:120,namax),irs(0:120,namax)
      integer iskd(0:120,namax),irsd(0:120,namax)
      real x(6,namax),mpl(namax),xi0(6,namax)
      common /cxmpl/ x,mpl,xi0

c     be,bi -> be0,bi0, p -> p0, ei -> ej  nev -> nej
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd1/ ramin00(namax),ramax00(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cislct0/ iaslct0(120,namax)
      common /ccolor/ icolor(namax),raplt(nemax)
      common /cxodc/ iodc,inum,xodc(6)

      character(72) title,flnm1,flnm2
      character(3) text
      character brv
      character dummy
      common /cisym/ ieqs,ists,ixrst
      common /ceps/ epsd
c      integer r
c      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cskip/ iskip
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real x00(6,namax)
      real nr
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10)
      integer rcomp
      integer isyv(namax)
      common /cisyv/ isyv
      integer jaslctnew(namax)
      integer expnsic,getna0
c      read(5,'(a)') title
      call setinp(5)
      call setout(6)

      call freadi('inpm=',1,inpm,1)
      write(6,*) 'inpm=',inpm

      call freadc('title=',1,title,1)
      write(6,'(a)') title
c      read(5,'(4f8.5,i3)') al,cl,e1,e2,isys,ieqs,ists,ixrst
      call freadr('a=',1,al,1)
      call freadr('c=',1,cl,0)
      call freadr('eps1=',1,e1,0)
      call freadr('eps2=',1,e2,0)
      call freadi('isys=',1,isys,0)
      call freadi('ieqs=',1,ieqs,0)
      call freadi('ists=',1,ists,0)
      call freadi('ixrst=',1,ixrst,0)
      if(isys.eq.1.or.isys.eq.2) then
         call quit('invalid isys, isys=3,4')
      end if
      write(6,'(4(a,f8.5),3(a,i3))') 'al=',al,' cl=',cl,' eps1=',
     *   e1,' eps2=',e2, ' isys=',isys,' ieqs=',ieqs,' ists=',ists,
     *   ' ixrst=', ixrst
      if(ieqs.ne.0.and.ieqs.ne.1) call quit('ieqs should be 0 or 1')
      if(ists.ne.0.and.ists.ne.1) call quit('ists should be 0 or 1')
      am=al
      call setsys(isys)
      call setalamcl()
      call setd()
      call setdei()
      call freadi('na=',1,na,1)
      call freadi('npod=',1,npod,0)
      call freadi('ne=',1,ne,0)
      call freadi('jsyv=',1,jsyv,0)
      write(6,'(a,2i3)') 'na,npod ',na,npod,' jsyv=',jsyv
      iwflag(3)=1

      if(inpm.eq.0) then
         call freadc('flnm1=',1,flnm1,1)
         lfn1=istrln(flnm1)
         call freadc('flnm2=',1,flnm2,1)
         lfn2=istrln(flnm2)

         write(6,*) 'flnm1=',flnm1(1:lfn1)
         write(6,*) 'flnm2=',flnm2(1:lfn2)


         open(unit=7,file=flnm1(1:lfn1),status='OLD',err=300)
         call setinp(7)
      end if
      call setout(6)
      call rdsymo(na,brv)
      call setbrv(brv)
      call setmpltbl()          ! set multiplication table for symm. ops.
      call rdpod(npod)          ! read occupation domain data
      call setnpod(npod)
      call chkcolsym(npod)      ! check color symmetry in site symmetry ops.
      if(inpm.eq.0) then
         open(unit=8,file=flnm2(1:lfn2),status='OLD',err=301)
         call setinp(8)
      end if
      call setout(6)
      call rdap(na,jsyv)        ! read positions for independent ODs
c     this generate independent ODs of superstructure from those for normal
c     structure if brv='s'
c     then coordinate system has been changed to that of super cell
      call setinp(5)
      call setout(6)

      call setx(na)           ! set real OD position
      call tosupersymo()      ! load superstructure symmetry operators
      call sitesy(na,mpl,x,isk,irs) ! site symmetry of each domain center
      call sitesy(na,mpld,x0,iskd,irsd) ! site symmetry of the center

c      write(6,*) 'after sitesy'
      call getnsymo(nsymo,icent) ! get nsymo,icentd
      do j=1,na
         if(ish(j).eq.0) then
            do i=1,nsymo*(icent+1)
               iaslct(i,j)=0
            end do
            do i=1,irs(0,j)
               id=irs(i,j)
               iaslct(id,j)=1
            end do
         else if(ish(j).gt.0) then
            call vcpyi(iaslct0(1,ish(j)),iaslct(1,j),nsymo*(1+icent))
c           write(6,'(80i1)') (iaslct(k,j),k=1,nsymo*(1+icent))
         end if
      end do

c      write(6,*) 'after na loop'

c     replace site symmetry operator with fictitious one
      write(6,*) 'site symmetry operator'
      do n=1,na
         if(ish(n).gt.0) then
            irs0=0
            do i=1,nsymo*(1+icent)
               if(iaslct(i,n).eq.1) then
                  irs0=irs0+1
                  irs(irs0,n)=i ! fictitious site symmetry operator
               end if
            end do
            irs(0,n)=irs0
         end if
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',n,(irs(j,n),j=1,irs(0,n))
      end do

c     get plane normal
      call getnid(na,ni)
      if(ixrst.eq.1) then
         do i=1,na
            do j=1,6
               x(j,i)=x(j,i)-x0(j,i)
               x00(j,i)=x0(j,i)
               x0(j,i)=0
            end do
         end do
      end if

      call vivold(na,mpl,isk,irs)

c     read(5,*) ldev,amag,ng
      call freadi('ldev=',1,ldev,1)
      call freadi('ng=',1,ng,0)
      call freadr('amag=',1,amag,0)
      write(6,*) 'ldev=',ldev,' ng=',ng,' amag=',amag
      call freadiv('icolor=',ne,icolor,1)
      write(6,'(a,30i3/(30i3))') 'icolor=',(icolor(j),j=1,ne)
      call freadi('iorn=',1,iorn,1)
      write(6,*) 'iorn=',iorn
      call orient(iorn)
      call plots(0.,0.,ldev)
      call newpen(3)

      na0=getna0()
      ifil=0
      do nn=1,ng
c        read(5,'(80i1)') (jaslct(j),j=1,na)
         read(5,'(80i1)') (jaslct(j),j=1,na0)
         call gennewjaslct(jaslct,jaslctnew,na0)
         call vcpyi(jaslctnew,jaslct,na)
         call freadr('shftx=',1,shftx(nn),1)
         call freadr('shfty=',1,shfty(nn),0)
         call freadi('iodc=',1,iodc,0)
         call freadi('inum=',1,inum,0)
         call freadi('ifill=',1,ifill,0)
         call freadi('ifrm=',1,ifrm,0)
         write(6,'(2(a,f10.5),4(a,i3))')
     *        'shftx=',shftx(nn),' shfty=',shfty(nn),
     *        ' iodc=',iodc,' inum=',inum, ' ifill=',ifill,
     *        ' ifrm=',ifrm
         if(iodc.eq.1) then
            call freadrv('xodc=',6,xodc,1)
            write(6,'(a,6f10.6)') 'xodc=', xodc
         end if
         call plot(shftx(nn),shfty(nn),-3)
         do n=1,na
c     call wtvctrr('ej=',ej(1,1,n),6)
            call setjaslct(n)   ! set current jaslct for polyg
            if(jaslct(n).eq.1.or.jaslct(n).eq.2) then
               if(iodc.eq.1) then
                  call wtisk(n,x00,xodc,iskd,isk)
               end if
               call getnseice(ieqs,isk(0,n),mpl(n),nse,ice)
               call getqe(x0(1,n),q0)
               do icnt=0,ice
                  do  nsd=1,nse
                     nsy=isk(nsd,n)
                     nst=expnsic(nsy,icnt)
c     shift origin at the center of OD
                     call plot(q0(4)*amag,q0(5)*amag,-3)
                     if(incsy(nst,irsd(0,n)).eq.1) then
c                    if(incsy(nst,irs(0,n)).eq.1) then
                        call vsub(x(1,n),x0(1,n),xd,6)
                        call getrx(xd,rx,nsy,icnt)
                        call getrx(x00(1,n),rx0,nsy,icnt)
                        do k=1,6
                           rx(k)=rx(k)+x0(k,n)
                        end do
                        call getqe(rx,q)
                        call plot(q(4)*amag,q(5)*amag,-3)
c     write number
                        call drwnum(n,text,inum,nsd,icnt)
c     write OD
                        call drwpoly(n,ifrm,ifill,nsy,icnt,rx0,amag,irs)
c     reset origin shift
                        call plot(-q(4)*amag,-q(5)*amag,-3)
                     end if
                     call plot(-q0(4)*amag,-q0(5)*amag,-3)
                  end do
               end do
            end if
         end do
      end do
      call plote('end of plot')
      stop

 300  continue
      write(6,*) 'can not open ',flnm1(1:lfn1)
      stop
 301  continue
      write(6,*) 'can not open ',flnm2(1:lfn2)
      stop
      end

      subroutine gennewjaslct(jaslct,jaslctnew,na0)
      include 'polygn.inc'
      integer jaslct(namax),jaslctnew(namax)
      integer nas(namax),nae(namax)
      common /cnase/ nas,nae
      do i=1,na0
         do j=nas(i),nae(i)
            jaslctnew(j)=jaslct(i)
         end do
      end do
      return
      end

c           call getnseice(ieqs,isk(0,n),mpl(n),nse,ice)
      subroutine getnseice(ieqs,isk,mpl,nse,ice)
      integer isk(0:*)
      real mpl
      call getnsymo(nsymo,icent) ! get nsymo,icentd
      if(ieqs.eq.0) then
         nse=isk(0)
         if(icent.eq.1) then
            if(mpl.lt.0.51) then
               ice=0
            else 
               ice=1
            end if
         else
            ice=0
         end if
      else if(ieqs.eq.1) then
         nse=1
         ice=0
      end if
      return
      end

      subroutine wtisk(n,x00,xodc,iskd,isk)
      real x00(6,*)
      real xodc(*)
      integer iskd(0:120,*),isk(0:120,*)
      real rx(6)
      do ns=1,iskd(0,n)
         call rednsic(iskd(ns,n),nsy,icnt)
         call getrx(x00(1,n),rx,nsy,icnt)
         if(rcomp(rx,xodc).eq.1) then
            write(6,'(2(a,i3))') 'n=',n,' ismtr=',isk(ns,n)
         end if
      end do
      return
      end

      subroutine setx(na)     ! set real OD position
      do n=1,na
         call setxn(n)
      end do
      return
      end

      subroutine setxn(n)     ! set real OD position
      include 'polygn.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real x(6,namax),mpl(namax),xi0(6,namax)
      common /cxmpl/ x,mpl,xi0

      do j=1,6
         x(j,n)=x0(j,n)+u01(n)*xe1(j,n)+u02(n)*xe2(j,n)+
     *        u03(n)*xe3(j,n)+v0(n)*xi(j,n)
      end do
      return
      end

      subroutine getx(n,xn)     ! set real OD position
      real xn(*)
      include 'polygn.inc'
      real x(6,namax),mpl(namax),xi0(6,namax)
      common /cxmpl/ x,mpl,xi0
      call vcpyr(x(1,n),xn,6)
      return
      end

c     draw polygons
      subroutine drwpoly(n,ifrm,ifill,nsy,icnt,rx0,amag,irs)
      real rx0(*)
      integer irs(0:120,*)
      include 'polygn.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /ccolor/ icolor(namax),raplt(nemax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
c     write(6,*) 'ifrm,ifill,amag,nsy,icnt',ifrm,ifill,amag,nsy,icnt
c     write(6,*) 'irs(0,n)=',irs(0,n)
      if(ifrm.eq.1.and.ifill.eq.1) then
c     first write filled OD and then frame (boundary)
         call polyg(ej(1,1,n),nej(n),nth(n),isyd(n),
     *        mej(1,1,n),rb(n),irs(0,n),amag,nsy,icnt,
     *        icolor(ien(n)),ifill,0,rx0(6))
         call polyg(ej(1,1,n),nej(n),nth(n),isyd(n),
     *        mej(1,1,n),rb(n),irs(0,n),amag,nsy,icnt,
     *        0,0,ifrm,rx0(6))
      else if(ifrm.eq.1.or.ifill.eq.0) then ! only frame
         call polyg(ej(1,1,n),nej(n),nth(n),isyd(n),
     *        mej(1,1,n),rb(n),irs(0,n),amag,nsy,icnt,
     *        0,0,ifrm,rx0(6))
      else if(ifrm.eq.0.and.ifill.eq.1) then ! no frame
         call polyg(ej(1,1,n),nej(n),nth(n),isyd(n),
     *        mej(1,1,n),rb(n),irs(0,n),amag,nsy,icnt,
     *        icolor(ien(n)),ifill,ifrm,rx0(6))
      end if
      return
      end

c     draw numbers
      subroutine drwnum(n,text,inum,nsd,icnt)
      character(*) text
      if(abs(inum).eq.1) then
         if(n.le.9) then
            write(text,fmt='(i1)') n
            nchr=1
         else if(n.le.99) then
            write(text,fmt='(i2)') n
            nchr=2
         else if(n.le.999) then
            write(text,fmt='(i3)') n
            nchr=3
         end if
         write(6,'(a,i3)') 'atom=',n
         call csymbol(0.,-.1,0.2,text,0.,nchr)
      else if(inum.eq.2) then
         if(nsd.eq.1.and.icnt.eq.0) then
            if(n.le.9) then
               write(text,fmt='(i1)') n
               nchr=1
            else if(n.le.99) then
               write(text,fmt='(i2)') n
               nchr=2
            else if(n.le.999) then
               write(text,fmt='(i3)') n
               nchr=3
            end if
            write(6,'(a,i3)') 'atom=',n
            call csymbol(0.,-.1,0.2,text,0.,nchr)
         end if
      end if      
      return
      end

      subroutine setjaslct(n)  ! set current jaslct
      include 'polygn.inc'
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cjaslctn/ jaslctn
      jaslctn=jaslct(n)
      return
      end

      integer function getjaslct()  ! get current jaslct for polyg
      include 'polygn.inc'
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cjaslctn/ jaslctn
      getjaslct=jaslctn
      return
      end


      function incsy(nsy,irs)
      integer irs(0:120)
      do i=1,irs(0)
         if(irs(i).eq.nsy) then
            incsy=1
            return
         end if
      end do
      incsy=0
      return
      end

      subroutine polyg(ej,nej,nth,isyd,mej,ra,irs,amag,nsy0,
     *     icnt0,icol,ifill,ifrm,rx6)
c      plot polygons defined by ej and sitesymmetry operators
      real ej(6,*),ra
      integer nej,nth,mej(3,*),irs(0:*)
      parameter (nx=300)
      real ejd(6),xi(6),rx(6)
      real xd(6),xe(6),x1(nx),x2(nx),y1(nx),y2(nx)
      real xw(100), yw(100)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cxodc/ iodc,inum,xodc(6)
      character(3) text
      integer getwcol,getjaslct
      real td(6)
      data td/6*0.0/
c     e(1,i)-e(5,i) : i-th edge vector defining a primitive of a polygon
c       polygon is given by the primitive and site symmetry operations
c     e(1,i)-e(3,i) external components
c     e(4,i),e(5,i) internal components
c     irs(0): number of site symmetry operators
c     rx6=1 normal color -1 inverse color 0 gray (colorless)
      jaslctn=getjaslct()
c     write(6,*) 'jaslctn=',jaslctn
      if(ifill.eq.0) then
         call fillarea(0)
      else if(ifill.eq.1) then
         call fillarea(1)
      else
         call quit('invalid ifill, it should be 0 or 1')
      end if
      call setcol(icol)
      call geta(al,am)
c      polyg=1
      if(ra.le.0) return
      ix=0
      iw=0
      do nsd=1,irs(0)
          nsy=irs(nsd)
c          if(nsd.eq.1.and.nsy.ne.1) call quit('stop in polyg')
          do i=1,nth
             i1=mej(1,i)
             i2=mej(2,i)
             ix=ix+1
             if(ix.gt.nx) call quit('ix > nx')
             call getxy(ej(1,i1),x1(ix),y1(ix),nsy,isyd,amag,ra,
     *            nsy0,icnt0)
             call getxy(ej(1,i2),x2(ix),y2(ix),nsy,isyd,amag,ra,
     *            nsy0,icnt0)

             if(inum.eq.-1) then
                nw=i1+(nsd-1)*nth
                call tr5to6e(rx,xd)
c               write(6,'(a,i2,a,6f10.6)') 'num=',nw,' ej=',xd
                call gettext(nw,text)
                nchr=1
                xx=x1(ix)*0.8
                yy=y1(ix)*0.8
                call csymbol(xx,yy-0.1,0.2,text,0.,nchr)
             end if

             x3=0
             y3=0
             if(ifrm.eq.1) then
                call setcol(icol)
                call draw(x1(ix),y1(ix),x2(ix),y2(ix))
                if(jaslctn.eq.2) then
                   if(nsd.eq.1.or.nsd.eq.irs(0)) then
                      call draw(x1(ix),y1(ix),x3,y3)
                      call draw(x2(ix),y2(ix),x3,y3)                   
                   end if
                end if
             else if(ifill.eq.1) then
                xw(1)=x1(ix)
                yw(1)=y1(ix)
                xw(2)=x2(ix)
                yw(2)=y2(ix)
                xw(3)=0
                yw(3)=0
                iw=3
                xw(iw+1)=0.
                yw(iw+1)=0.
                xw(iw+2)=1.
                yw(iw+2)=1.
                call fillarea(1)
                icold=getwcol(rx6,icol)
                call setcol(icold)
                call plylin(xw,yw,iw,1,0,0)
             end if
          end do
       end do
c     if(ifrm.eq.1) then
c     call setcol(0)
c     call draw(x1(ix),y1(ix),x2(ix),y2(ix))
c     end if
      return
      end

      subroutine gettext(nw,text)
      character(*) text
      if(nw.le.9) then
         write(text,fmt='(i1)') nw
      else if(nw.le.99) then
         write(text,fmt='(i2)') nw
      else if(nw.le.999) then
         write(text,fmt='(i3)') nw
      end if
      return
      end

      subroutine getxy(ej,x1,y1,nsy,isyd,amag,ra,nsy0,icnt0)
      real ej(*)
      real xi(6),xd(6),xe(6),rx(6),ejd(6)
      call rednsic(nsy,ns,ic)
      call rednsic(isyd,isd,icd)
      call getxe(ej,xi)
      call getrx(xi,xd,ns,ic)
      call getrx(xd,xe,isd,icd)
      call getrx(xe,rx,nsy0,icnt0)
      call getqe(rx,ejd)
      x1=ejd(4)*ra*amag
      y1=ejd(5)*ra*amag
      return
      end

      integer function getwcol(rx6,icol)
      if(rx6.eq.0.) then
         icold=icol
      else if(rx6.gt.0.99.and.rx6.le.1.01) then
         icold=icol
      else if(rx6.gt.-1.01.and.rx6.lt.-0.99) then
         if(icol.eq.0) then
            icold=10
         else if(icol.eq.10) then
            icold=0
         end if
      end if
      getwcol=icold
      return
      end

      subroutine getang(xw,yw,ang,iw)
      real xw(*),yw(*),ang(*)
      do i=1,iw
         ang(i)=atan2(yw(i),xw(i))
      end do
      return
      end

      subroutine replc(xw,yw,np,iw)
      real xw(*),yw(*)
      integer np(*)
      real xd(100),yd(100)
      do i=1,iw
         xd(i)=xw(i)
         yd(i)=yw(i)
      end do
      do ii=1,iw
         i=np(ii)
         xw(ii)=xd(i)
         yw(ii)=yd(i)
      end do
      return
      end 

      subroutine getnid(na,ni)  ! calculate plane normal
c     parameter (namax=160,nemax=12)
      include 'polygn.inc'
      real ni(0:6,4,nemax,*)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *     mej(3,nemax,namax)
      real cent(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real td(6)
      data eps/0.00001/, td/6*0./
      do i=1,na
c     unit vector normal to ej(i)
         do j=1,nth(i)
            j1=mej(1,j,i)
            j2=mej(2,j,i)
            if(j1.gt.nej(i)) then
               call quit('j1 > ne')
            else if (j2.gt.nej(i)) then
               call quit('j2 > ne')
            end if
            absej=sqrt(ej(4,j1,i)**2+ej(5,j1,i)**2)
            ni(0,1,j,i)=absej
            ni(4,1,j,i)= ej(5,j1,i)/absej
            ni(5,1,j,i)=-ej(4,j1,i)/absej
            absej=sqrt(ej(4,j2,i)**2+ej(5,j2,i)**2)
            ni(0,2,j,i)=absej
            ni(4,2,j,i)= ej(5,j2,i)/absej
            ni(5,2,j,i)=-ej(4,j2,i)/absej
         end do
c     unit vector normal to ej(j2)-ej(j1)
         do j=1,nth(i)
            j1=mej(1,j,i)
            j2=mej(2,j,i)
            absej=sqrt((ej(4,j2,i)-ej(4,j1,i))**2+
     *           (ej(5,j2,i)-ej(5,j1,i))**2)
            if(absej.gt.eps) then
               ni(0,3,j,i)=absej
               ni(4,3,j,i)= (ej(5,j2,i)-ej(5,j1,i))/absej
               ni(5,3,j,i)=-(ej(4,j2,i)-ej(4,j1,i))/absej
            else
               do k=4,5
                  ni(k,3,j,i)=0.
               end do
               ni(0,3,j,i)=0.
            end if
            do l=1,3
               if(l.le.2) then
                  jj=mej(l,j,i)
                  do k=4,5
                     cent(k)=ej(k,jj,i)-(ej(k,j1,i)+ej(k,j2,i))/2
                  end do
               else if(l.eq.3) then
                  do k=4,5
                     cent(k)=(ej(k,j2,i)+ej(k,j1,i))/2
                  end do
               end if
               if(vinp(cent(4),ni(4,l,j,i),2).gt.0.) then
                  sig=1.
               else
                  sig=-1.
               end if
               do k=4,5
                  ni(k,l,j,i)=ni(k,l,j,i)*sig
               end do
            end do
         end do
      end do
      return
      end

      subroutine rdap(na,jsyv)  ! read OD coordinates
      include 'polygn.inc'
      common /cwflag/ iwflag(6)
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd1/ ramin00(namax),ramax00(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)

      real fj(7,nemax)
      common /cfj/ fj
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      common /cxed/xe1d,xe2d,xe3d,xid
      integer isyv(namax)
      common /cisyv/ isyv

      real q(6),xd(7),yd(6),xe(6)
      character brv
      integer nas(namax),nae(namax)
      common /cnase/ nas,nae
      call getsys(isys)
      call getbrv(brv)
c     call geta(al,am)
      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(6, '(a,i3)') 'na=',na
         write(6,'(2a)')
     *        'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *        '       s1      s2'
      end if
      call setnd(isys)
      call getinp(inpu)
      na0=na                    ! save original na
      call setna0(na0)
      i=0
      do ii=1,na
         i=i+1
         call rdstrinf(inpu,i,jsyv)  ! read data for one OD append
         call setx0xi0(x0(1,i),xi(1,i))  ! for genej
         call setxsxis(x0(1,i),xi(1,i))  ! for genej
c     generate possible independent OD
         nas(ii)=i
         call genej(i)          ! increase i in superstructures
         nae(ii)=i
      end do

      na=i                      ! new na for super structures
      do i=1,na
c     remove internal and external components in xe and xi
c     xi are still 6D coordinates for decagonal
         if(nej(i).le.0) then
            write(6,*) 'i,nej(i)=',i,nej(i)
            call quit('invalid nej')
         end if
c        call wtej(i,jsyv)      ! write ej
         if(isys.eq.3.and.brv.eq.'s') then ! transformation for super str.
            call xtoxs(i,x0,xi) ! cell transformation of x0 and xi
                                ! xi is 6D rep
            call ejtoejs(ej(1,1,i),nej(i)) ! 5D vector
            call celltr6(xe1(1,i),1) ! transformation in 6D representation
            call celltr6(xe2(1,i),1)
            call celltr6(xe3(1,i),1)
            call wtatmln(i)  ! print atom line
            call wtxexi(i)   ! print xe1,xe2,xe2,xi
            call wtisyd(i)   ! print isyd
c           call wtej0(i)    ! print ej for check
         end if
         call getxexi(i)        ! get external and internal comp. of
c     xe1,xe2,xe3 and xi. now they are 6D vectors
      end do
      return
      end

      subroutine setna0(na)
      common /cna0/ na0
      na0=na
      return
      end

      integer function getna0()
      common /cna0/ na0
      getna0=na0
      return
      end

      subroutine wtatmln(i)  ! write one line
      include 'polygn.inc'
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
c     write(6,*) 'i in wtatmln=',i
      iln=istrln(atom(i))
      write(6,302) i,'''',atom(i)(1:iln),'''',ien(i),ish(i),
     *     nej(i),be0(i),bi0(i),ra(i),rb(i),p0(i),s0(1,i),s0(2,i)
      write(6,303) 'x=  ', (x0(j,i),j=1,6)
      return
 302  format(i4,2x,3a,3i3,2x,7f8.5)
 303  format(a,7f9.5,2x,a,f8.5)
      end

      subroutine calcx(x0,v0,xi,x)
c     x0 5D rep
c     xi 6D rep
      real x0(6),xi(7),x(6),xi5(6)
      real vxi00(6)
c      call wtvctrrf('x0=',x0,6,'(6f10.5)')
c      call wtvctrrf('xi=',xi,6,'(6f10.5)')
      call redcoord(xi,xi5)     ! coordinate in minimal dimension
      call vscaler(xi5,v0,vxi00,6)
      call vadd(x0,vxi00,x,6)
c     call wtvctrrf('x =',x,6,'(6f10.5)')
      return
      end

      subroutine genej(i)
c     generate ej and x0 etc for superstructures
c     using site symmetries of normal and super structures
      include 'polygn.inc'
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real x(6,namax),mpl(namax),xi0(6,namax)
      common /cxmpl/ x,mpl,xi0
      integer isk0(0:120),irs0(0:120)  ! for original center coordinates
      integer isk1(0:120),irs1(0:120)  ! for superstr. center coordinates
      integer isk(0:120),irs(0:120)
      real x00(6),xi00(6),x0d(6)
      real xs0(6),xis0(6),xsd(6)
      integer iaslct0(120),iaslct1(120),iaslct(120)
      real fj(7,nemax)
      common /cfj/ fj
      character brv
      integer getncst,getcosrep
c     get site symmetry of x0 (large OD center)
      call getsys(isys)
      call getbrv(brv)
      if(brv.ne.'s'.or.isys.ne.3) then
         call wtatmln(i)        ! print atom line
         call wtxexi(i)         ! print xe1,xe2,xe2,xi
         call wtisyd(i)
         call setrotej(fj,i,i,1) ! copy fj to ej
         return
      end if
      call getx0xi0(x00,xi00)  ! x0 anc xi for original cell
      call getxsxis(xs0,xis0)  ! x0 anc xi for super cell
c     call calcx(x00,v0(i),xi00,x0d) ! x0d : x in original cell
      call calcx(xs0,v0(i),xis0,xsd) ! xsd : x in superstructure cell
c      call wtvctrrf('x00=',x00,6,'(6f10.5)')
c      call wtvctrrf('xs0=',xs0,6,'(6f10.5)')
c      call wtvctrrf('xsd=',xsd,6,'(6f10.5)')
c     calculate site symmetry operations before and after transformation
c     call sitesy0_s(1,mpl,x0d,isk0,irs0) ! site symmetry group for x0d
      call sitesy0_s(1,mpl,x00,isk0,irs0) ! site symmetry grp for center of OD
      call sitesy1_s(1,mpl,xs0,isk1,irs1) ! site symmetry group for xs0
c      call sitesy1_s(1,mpl,xsd,isk,irs) ! site symmetry group for x
c     call sitesy_s(1,mpl,x(1,i),isk,irs) ! site symmetry group for x
c     write(6,*) 'irs0(0),irs(0)=',irs0(0),irs(0)
      call setiaslct(iaslct0,irs0)  ! set iaslct0 
c     call setiaslct(iaslct,irs)
      call setiaslct(iaslct1,irs1)  ! set iaslct1
c     call gcoset1(iaslct0,iaslct,i)
      call gcoset1(iaslct0,iaslct1,i)
c     generate xi for equivalent ODs
c     write(6,*) 'getncst(i)=',getncst(i)

      do n=1,getncst(i)         ! number of cosets
         nst=getcosrep(n,i)     ! site symmetry operator number
c        write(6,*) 'i,nst in genej=',i,nst
         inew=i+n-1
         if(inew.gt.namax) then
            write(6,*) 'n,namax=',inew,namax
            call quit('n > namax')
         end if
         nej(inew)=nej(i)
c        write(6,*) 'i,inew=',i,inew
         call cpyatmln(i,inew,nst) ! rotated xe1 etc.
         call setxn(inew)
         call setej(fj,i,inew) ! set rotated ej
c         call wtatmln(inew)     ! print atom line
c         call wtxexi(inew)      ! print xe1,xe2,xe2,xi
c         call wtisyd(inew)      ! print isyd
      end do
      i=inew                    ! increase i
      return
      end

      subroutine setej(fj,i,inew)
      real fj(7,*)
      include 'polygn.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      do j=1,nej(i)
c         call trnsf6(fj(1,j),ej(1,j,inew),nst)
         call vcpyr(fj(1,j),ej(1,j,inew),6)
         call prjftoq(ej(1,j,inew)) ! projection fj to q
         nth(inew)=nth(i)
         nej(inew)=nej(i)
         call vcpyi(mej(1,j,i),mej(1,j,inew),3)
      end do
c     call wtvctrrf('fj=',fj(1,j),7,'(7f10.5)')
      return
      end

      subroutine setrotej(fj,i,inew,nst)
      real fj(7,*)
      include 'polygn.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      do j=1,nej(i)
         call trnsf6(fj(1,j),ej(1,j,inew),nst)
         call prjftoq(ej(1,j,inew)) ! projection fj to q
         nth(inew)=nth(i)
         nej(inew)=nej(i)
         call vcpyi(mej(1,j,i),mej(1,j,inew),3)
      end do
c     call wtvctrrf('fj=',fj(1,j),7,'(7f10.5)')
      return
      end

      integer function getisydnew(i,nst)
      include 'polygn.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      integer mpltblv,getinvop
      character brv
      call getbrv(brv)
         getisydnew=mpltblv(nst,isyd(i)) ! isyd for inew-th OD
      return
      end

      subroutine cpyatmln(i,inew,nst)
      include 'polygn.inc'
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real xe10(6),xe20(6),xe30(6),xi00(6)
      integer getisydnew
      call vcpyr(xi(1,i),xi(1,inew),6)
      call vcpyr(x0(1,i),x0(1,inew),6) ! x0 should be the same ?
      call trnsf6(xe1(1,i),xe1(1,inew),nst)
      call trnsf6(xe2(1,i),xe2(1,inew),nst)
      call trnsf6(xe3(1,i),xe3(1,inew),nst)
      call trnsf6(xi(1,i),xi(1,inew),nst)
      atom(inew)=atom(i)
      isyd(inew)=getisydnew(i,nst)
      ien(inew)=ien(i)
      ish(inew)=ish(i)
      u01(inew)=u01(i)
      u02(inew)=u02(i)
      u03(inew)=u03(i)
      v0(inew)=v0(i)
      ra(inew)=ra(i)
      rb(inew)=rb(i)
      p0(inew)=p0(i)
      s0(1,inew)=s0(1,i)
      s0(2,inew)=s0(2,i)
      return
      end

      subroutine  trnsf5(x0,x,nst) ! transform 5D rep. vector by symmetry op.
      real x0(*),x(*)
      call rednsic(nst,ns,ic)
      call getrx(x0,x,ns,ic)    ! get rotated x0
      return
      end

      subroutine  trnsf6(xi0,xi,nst) ! transform 6D rep. vector by symmetry op.
      real xi0(*),xi(*)
      real xd(6),xe(6)         
      call rednsic(nst,ns,ic)   ! get ns and ic from nst
      call tr6to5e(xi0,xd)      ! xi for independent OD
      call getrx(xd,xe,ns,ic)   ! get rotated xi
      call tr5to6e(xe,xi)
      return
      end

      subroutine wtej0(i)       ! write ej0
      include 'polygn.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real fj(7),gj(7)
      do j=1,nej(i)
         call getxe(ej(1,j,i),fj)
         call tr5to6e(fj,gj)
         call wtvctrrf('ej=',gj,6,'(6f10.5)')
      end do
      return
      end

      subroutine wtej(i,jsyv)   ! write ej
      include 'polygn.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      integer isyv(namax)
      common /cisyv/ isyv
      real fj(7,nemax)
      common /cfj/ fj
      integer getish,getisyd
      call getsys(isys)
c     write(6,*) 'isys,ish(i),nej(i)=',isys,ish(i),nej(i)
      if(getish(i).eq.0) then
         call wtej0(i)
         if(isys.le.2) then
            write(6,'(a,120i3)') 'nth=',nth(i),
     *           ((mej(k,j,i),k=1,3),j=1,nth(i))
         else
            write(6,'(a,120i3)') 'nth=',nth(i),
     *           ((mej(k,j,i),k=1,2),j=1,nth(i))
         end if
      else if(getish(i).gt.0) then
         if(jsyv.ge.1) then
            write(6,'(a,i4,a,i4)') 'isyd=',getisyd(i),' isyv=',isyv(i)
         else
            write(6,'(a,i4)') 'isyd=',getisyd(i)
         end if
         call wtej0(i)  ! for check
      else if(getish(i).eq.-1) then
         call wtej0(i)
      else
         write(6,*) 'i,getish(i)=',i,getish(i)
         call quit('invalid ish(i)')
      end if
      return
      end

      subroutine setnd(isys)
      common /cnd/ nd
      if(isys.ne.5) then
         nd=6
      else
         nd=7
      end if
      return
      end
      
      integer function getnd()
      common /cnd/ nd
      getnd=nd
      return
      end

      integer function getish(i)
      include 'polygn.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getish=ish(i)
      return
      end

      integer function getisyd(i)
      include 'polygn.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getisyd=isyd(i)
      return
      end

      subroutine wtisyd(i)  ! write isyd
      include 'polygn.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      write(6,'(a,i4)') 'isyd=',isyd(i)
      return
      end

      subroutine wtxexi(i)
      include 'polygn.inc'
c      real xe1d(7),xe2d(7),xe3d(7),xid(7)
c      common /cxed/xe1d,xe2d,xe3d,xid
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      integer getnd
      nd=getnd()
      call getsys(isys)
      if(isys.ne.5) then
         write(6,306) 'xe1=', (xe1(j,i),j=1,nd),'u1=',u01(i)
         write(6,306) 'xe2=', (xe2(j,i),j=1,nd),'u2=',u02(i)
         write(6,306) 'xe3=', (xe3(j,i),j=1,nd),'u3=',u03(i)
         write(6,306) 'xi= ', (xi(j,i),j=1,nd),'v= ',v0(i)
      else
         write(6,303) 'xe1=', (xe1(j,i),j=1,nd),'u1=',u01(i)
         write(6,303) 'xe2=', (xe2(j,i),j=1,nd),'u2=',u02(i)
         write(6,303) 'xe3=', (xe3(j,i),j=1,nd),'u3=',u03(i)
         write(6,303) 'xi= ', (xi(j,i),j=1,nd),'v= ',v0(i)
      end if
 303  format(a,7f9.5,2x,a,f9.5)
 306  format(a,6f9.5,2x,a,f9.5)
      return
      end

      subroutine redcoord(x,rx) ! coordinate in minimul dimension
      real x(6),rx(6)
      call getsys(isys)
      if(isys.le.2) then        ! icosahedral 
         call vcpyr(x,rx,6)
      else if(isys.eq.3.or.isys.eq.-3) then ! decagonal
         call tr6to5e(x,rx)     ! rx : 5D coordinates
      else if(isys.eq.4) then   ! octagonal
         call vcpyr(x,rx,6)
      else if(isys.eq.5) then   ! dodecagonal
         call tr7to5e(x,rx)     ! rx : 5D coordinates
      end if
      return
      end

      subroutine getx6q(xd,q)   ! get q vector from 6D representation xd
      real xd(7),q(6)
      real yd(6)
c     call wtvctrrf('xd=',xd,6,'(6f10.5)')
      call redcoord(xd,yd)      ! coordinate in minimul dimension
      call getqe0(yd,q)         ! can not use getqe0 before reading a,c
      return
      end

      subroutine getxe6(xd)     ! external part of xd in 6D coordinate system
      real xd(7)
      real yd(7),q(6)
c     remove internal components
      call getx6q(xd,q)         ! get q vector from 6D representation xd
      q(4)=0
      q(5)=0
      q(6)=0
c     call getxe(q,yd)
      call getxe0(q,yd)         ! 5D vector
      call tr5to6e(yd,xd)           ! 6D rep.
c     call wtvctrrf('xe=',xd,6,'(6f10.5)')
      return
      end

      subroutine getxi6(xd)     ! internal part of xd in 6D coordinate system
      real xd(7)
      real yd(7),q(6)
      call getx6q(xd,q)         ! get q vector from 6D representation xd
c     remove external components
      q(1)=0
      q(2)=0
      q(3)=0
c     convert q to x
      call getxe0(q,yd)         ! 5D representation
      call tr5to6e(yd,xd)        ! 6D rep.
c     call wtvctrrf('xi=',xd,6,'(6f10.5)')
      return
      end

      subroutine prjftoq(xd)    ! internal part of xd in 6D coordinate system
      real xd(6),q(6)
      call getx6q(xd,q) ! get q vector from 6D representation xd
c     remove external components
      q(1)=0
      q(2)=0
      q(3)=0
      call scalea(q)
      call vcpyr(q,xd,6)
      return
      end

      subroutine savexexi(i)
      include 'polygn.inc'
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      common /cxed/xe1d,xe2d,xe3d,xid
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real q(6),xd(7),yd(6),xe(6)
      call vcpyr(xe1d,xe1(1,i),6)  ! 6D rep
      call vcpyr(xe2d,xe2(1,i),6)
      call vcpyr(xe3d,xe3(1,i),6)
      call vcpyr(xid,xi(1,i),6)    ! 6D rep
      return
      end

      subroutine getxexi(i)
c     take external and internal components of xe1,xe2,xe3,xi
      include 'polygn.inc'
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      common /cxed/xe1d,xe2d,xe3d,xid
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real q(6),xd(7),yd(6),xe(6)
      call getxe6(xe1(1,i))     ! external part of xe in 6D coordinate system
      call getxe6(xe2(1,i))
      call getxe6(xe3(1,i))
      call getxi6(xi(1,i))      ! internal part of xi in 6D coordinate system
      return
      end

      subroutine rdstrinf(inpu,i,jsyv)  ! get one OD information at i-th pos.
      include 'polygn.inc'
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      common /cxed/xe1d,xe2d,xe3d,xid
      real x(6,namax),mpl(namax),xi0(6,namax)
      common /cxmpl/ x,mpl,xi0

      integer isyv(namax)
      common /cisyv/ isyv
      real fj(7,nemax)
      common /cfj/ fj
      integer getnd
      character brv
      call getbrv(brv)
      call getsys(isys)
      nd=getnd()
c     nd=6
      read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *     be0(i),bi0(i),ra(i),rb(i),p0(i),s0(1,i),s0(2,i)
      if(nej(i).gt.nemax) call quit('ne > nemax')
      call freadrv('x=',6,x0(1,i),1)
      call freadrv('xe1=',nd,xe1d,1)
      call freadr('u1=',1,u01(i),0)
      call freadrv('xe2=',nd,xe2d,1)
      call freadr('u2=',1,u02(i),0)
      call freadrv('xe3=',nd,xe3d,1)
      call freadr('u3=',1,u03(i),0)
      call freadrv('xi=',nd,xid,1)
      call freadr('v=',1,v0(i),0)
c     call wtvctrr('xid=',xid,nd)
      if(ish(i).eq.-1.or.ish(i).eq.0) then
         do j=1,nej(i)
            call freadrv('ej=',nd,fj(1,j),1)
         end do
      else if(ish(i).gt.0) then
         nej(i)=nej0(ish(i))
         do j=1,nej(i)
c           call wtvctrrf('ej0=',ej0(1,j,ish(i)),7,'(7f10.5)')
            call vcpyr(ej0(1,j,ish(i)),fj(1,j),7) ! copy ej0 to fj
         end do
      end if
      if(nej(i).lt.0) then
         write(6,*) 'i,nej(i),nej0(i)=',i,nej(i),nej0(i)
         call quit('invalid nej(i)')
      end if

      if(ish(i).ge.0) then
         if(ish(i).eq.0) then
            call freadi('nth=',1,nth(i),1)
            isyd(i)=1
            if(nth(i).gt.nemax) call quit('nth > nemax')
            call rdmej(mej(1,1,i),nth(i))
            if(jsyv.eq.1) then
               call freadi('isyv=',1,isyv(i),1)
            else if(jsyv.ne.0) then
               isyv(i)=jsyv
            end if
         else
            call freadi('isyd=',1,isyd(i),1)
            if(jsyv.eq.1) then
               call freadi('isyv=',1,isyv(i),0)
            else if(jsyv.ne.0) then
               isyv(i)=jsyv
            end if
c           write(6,*) 'ish(i),nth0(ish(i)) ',ish(i),nth0(ish(i))
            
            nth(i)=nth0(ish(i))
            do j=1,nth(i)
               if(isys.le.2) then
                  call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),3)
               else
                  call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),2)
               end if
            end do
         end if
      end if
      if(jsyv.ge.1) then        ! coordinate transformation
         call coordtr(x0(1,i),xe1d,xe2d,xe3d,xid,isyv(i))
      end if
      call savexexi(i)  ! save xe1,xe2,xe3,xi
      return
      end

      subroutine setx0xi0(x0,xi0)
      real x0(6),xi0(7)
      common /cx00/ x00(6),xi00(7)
      call vcpyr(x0,x00,6)
      call vcpyr(xi0,xi00,6)
      return
      end

      subroutine getx0xi0(x0,xi0)
      real x0(6),xi0(7)
      common /cx00/ x00(6),xi00(7)
      call vcpyr(x00,x0,6)
      call vcpyr(xi00,xi0,6)
      return
      end

      subroutine setxsxis(x0,xi0) ! set coordinates in super structure
      real x0(6),xi0(7)
      common /cxs0/ xs0(6),xis0(7)
      call vcpyr(x0,xs0,6)
      call vcpyr(xi0,xis0,6)
      call celltr(xs0,1)        ! 5D rep for decagonal
      call celltr6(xis0,1)      ! 6D rep for decagonal
      return
      end

      subroutine getxsxis(xs,xis) ! for genej
      real xs(6),xis(7)
      common /cxs0/ xs0(6),xis0(7)
      call vcpyr(xs0,xs,6)
      call vcpyr(xis0,xis,6)
      return
      end

      subroutine rdmej(mej,nth)  ! read mej
      integer mej(3,*)
      call getsys(isys)
      do j=1,nth
         if(isys.le.2) then
            call freadiv(' ',3,mej(1,j),0)
         else
            call freadiv(' ',2,mej(1,j),0)
         end if
      end do
      return
      end

      subroutine trnsf5rep(x0,ns) ! transform 6D rep. vector by symmetry op.
      real x0(6)
      real xd(6)
      call trnsf5(x0,xd,ns)
      call vcpyr(xd,x0,6)   ! copy back xd to x0
      return
      end

      subroutine trnsf6rep(x0,ns) ! transform 6D rep. vector by symmetry op.
      real x0(6)
      real xd(6)
      call trnsf6(x0,xd,ns)
      call vcpyr(xd,x0,6)   ! copy back xd to x0
      return
      end

      subroutine coordtr(x0,xe1d,xe2d,xe3d,xid,isyv)
      real x0(*),xe1d(*),xe2d(*),xe3d(*),xid(*)
      call trnsf5rep(x0,isyv) ! transform 5D rep. vector by symmetry op.
c     transf6 lose a color information
      call trnsf6rep(xe1d,isyv) ! transform 6D rep. vector by symmetry op.
      call trnsf6rep(xe2d,isyv) ! transform 6D rep. vector by symmetry op.
      call trnsf6rep(xe3d,isyv) ! transform 6D rep. vector by symmetry op.
      call trnsf6rep(xid,isyv) ! transform 6D rep. vector by symmetry op.
      return
      end

      subroutine quit(str)
      character(*) str
      write(6,*) str
      call exit()
      end

      function atan0(y,x)
      data pi/3.141592/, eps/0.00001/
      if(abs(x).lt.eps) then
           if(y.gt.0) then
              atan0=pi/2
           else
              atan0=-pi/2
           end if
      else
              atan0=atan2(y,x)
      end if
      return
      end

      function atan01(y,x)
      data pi/3.141592/, eps/0.00001/
      atan=atan0(y,x)
      if(x.lt.0) then
          if(y.ge.0) then
              atan01=atan+pi
          else
              atan01=atan-pi
          end if
      else
          atan01=atan
      end if
      return
      end

      subroutine ejtoejs(ej,nej)  ! coordinate transformation for super str.
      real ej(6,*)
      real xd(6),xf(6)
      do j=1,nej
         call getxe0(ej(1,j),xd) ! get 5D coordinates
         call celltr(xd,1)      ! cell transformation
         call getqe0(xd,ej(1,j)) ! write back to ej
      end do
      return
      end

      subroutine xtoxs(i,x0,xi)
c     coordinate transformation for super str. only for decagonal
c      parameter (nemax=12)
      include 'polygn.inc'
      real x0(6,*),xi(6,*)
      real xf(6)
      real xd(6)
c     write(6,*) 'atom=',i
      call celltr(x0(1,i),1)
c     call celltr(xi(1,i),1)
      call celltr6(xi(1,i),1)
c     write(6,'(a,6f10.6)') 'x0=',(x0(j,i),j=1,6)
      return
      end

      subroutine getqi0(h,q) ! no phason distortion
      integer h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call mtmplirmno(h,dq,q,1,6,6)
      call invscalea(q)
      return
      end

      subroutine getqi(h,q) ! with phason distortion
      integer h(*)
      real q(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call mtmplirmno(h,dq,qd,1,6,6)
      call mtmplrmno(qd,di,q,1,6,6)
      call invscalea(q)
      return
      end

      subroutine getqe0(h,q)  ! no phason a=1
c     q space component of 
      real h(*),q(*)
      real dr,dq,de,di
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call mtmplmnor(dr,h,q,6,6,1)
      return
      end

      subroutine setalamcl()   ! dalamcl : diagonal part of alamcl
      real dr,dq,de,di
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real dalamcl(6),rdalamcl(6)
c     for dihedral
      do i=1,2
         dalamcl(i)=al
         rdalamcl(i)=1.0/al
      end do
      dalamcl(3)=cl
      rdalamcl(3)=1.0/cl
      do i=4,5
         dalamcl(i)=am
         rdalamcl(i)=1.0/am
      end do
      call dagmtrxr(dalamcl,alamcl,6)  ! get diagonal matrix with dalamcl
      call dagmtrxr(rdalamcl,ralamcl,6)  ! get diagonal matrix with rdalamcl
      call wtmtrxrf('alamcl',alamcl,6,'(6f10.5)')
      call wtmtrxrf('ralamcl',ralamcl,6,'(6f10.5)')
      return
      end

      subroutine scalea(q)
      real q(6)
      real dr,dq,de,di
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real q1(6)
      call mtmplmnor(alamcl,q,q1,6,6,1)
      call vcpyr(q1,q,6)
      return
      end

      subroutine invscalea(q)
      real q(6)
      real dr,dq,de,di
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real q1(6)
      call mtmplmnor(ralamcl,q,q1,6,6,1)
      call vcpyr(q1,q,6)
      return
      end

      subroutine getqe(x,q)  ! no phason
      real x(6),q(6)
      call getqe0(x,q)
      call scalea(q)
      return
      end

      subroutine getqed(x,q)   ! q space component under phason
      real x(6),q(6)
      real qd(6)
      real dr,dq,de,di
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call getqe(x,qd)
c     phason distortion in real space
      call mtmplmnor(de,qd,q,6,6,1)  ! add distortion
      return
      end

      subroutine getxe(q,x)
      real q(*),x(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call vcpyr(q,qd,6)
      call invscalea(qd)
      call mtmplrmno(dq,qd,x,6,6,1)
      return
      end

      subroutine getxe0(q,x)
      real q(*),x(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call vcpyr(q,qd,6)
      call mtmplrmno(dq,qd,x,6,6,1)
      return
      end

      subroutine setd()
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
c     common /cisys/ isys
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      dimension ipv(6),ind(6,2),piv(6),b(6),dtmp(6,6)
      common /cgetd/ det
      save icount
      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.618034,tav=-tau)
      parameter (sqr2=1.41421, sqr3=1.73205, tqr3=-sqr3)
      parameter (t1=0.70710678, t2=-0.70710678)
      parameter (u1=0.8660254, u2=-u1) 
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *          c2sr, s2sr, ct, c4sr, s1sr, cu,
     *          c2sr, s3sr, ct, c4sr, s4sr, cu,
     *          c1sr, s4sr, ct, c3sr, s2sr, cu,
     *          sr,   0.,   ct, su,   0.,   cu,
     *          c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *          tau, 0.,  1.,  -1,  0.,  tau,
     *          tau, 0., -1.,  -1., 0.,  tav,
     *          0.,  1., tav,   0., tau, 1.,
     *          -1., tau, 0.,  tav, -1., 0.,
     *          0.,  1., tau,   0., tau, -1./
c      for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *          c2, s2, 0., c1, s4, 0.,
     *          c2, s3, 0., c1, s1, 0.,
     *          c1, s4, 0., c2, s3, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *          t1, t1, 0., t2, t1, 0.,
     *          0., 1., 0., 0.,-1., 0.,
     *          t2, t1, 0., t1, t1, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./
c     for dodecagonal
      data d4/  1., 0., 0., 1., 0., 0.,
     *          u1, 0.5, 0., u2, 0.5, 0.,
     *          0.5, u1, 0., 0.5, u2, 0.,
     *          0., 1.,  0., 0., 1.,  0.,
     *          0., 0.,  1., 0., 0.,  0.,
     *          0., 0.,  0., 0., 0.,  1./
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c        initialize
         do i=1,6
            do j=1,6
 3             d0(i,j)=d0(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,6
 4             d1(i,j)=d1(i,j)/sqrt(1+tau**2)/2
            end do
         end do
         do i=1,6
            do j=1,4
 5             d2(i,j)=d2(i,j)/sqrt(5.)
            end do
         end do
         do i=1,6
            do j=1,4
 6             d3(i,j)=d3(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,4
 7             d4(i,j)=d4(i,j)/sqrt(2.)
            end do
         end do
         call trnsp(d0)
         call trnsp(d1)
         call trnsp(d2)
         call trnsp(d3)
         call trnsp(d4)
      end if

      call getsys(isys)
      if(isys.eq.1) then
          call mcpy(d0,dq)
      else if(isys.eq.2) then
          call mcpy(d1,dq)
      else if(isys.eq.3) then
          call mcpy(d2,dq)
      else if(isys.eq.4) then
          call mcpy(d3,dq)
      else if(isys.eq.5) then
          call mcpy(d4,dq)
      else
          call quit('wrong isys')
      end if
      call mcpy(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
c        orthogonality check
      if(icount.eq.1) then
         write(6,*) 'dr'
         do i=1,6
            write(6,'(6f9.5)') (dr(i,j),j=1,6)
         end do
         write(6,*) 'dq'
         do i=1,6
            write(6,'(6f9.5)') (dq(i,j),j=1,6)
         end do
         do i=1,6
            do j=1,6
               dtmp(i,j)=0
               do k=1,6
                  dtmp(i,j)=dtmp(i,j)+dq(i,k)*dr(k,j)
               end do
            end do
         end do
         write(6,*) 'dq*dr'
         do i=1,6
            write(6,'(6f9.5)') (dtmp(i,j),j=1,6)
         end do
      end if
      return
      end

      subroutine setdei()
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3)
      common /cphonn/ bmij1(3,3)
      real fij1(3,3),fij2(3,3),fij3(3,3),fij4(3,3),fij5(3,3),fij6(3,3)
      integer q50(6,6),q30(6,10),q20(6,15),q10d0(6),q2d0(6),qmd0(6)
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15),q10d(6),q2d(6),qmd(6)
      real ctoh(6,6),htoc(6,6),ded(6,6)
      dimension ipv(6),ind(6,2),piv(6),b(6)
      real wmij2(3,3),wmij3(3,3),wmij4(3,3)
      save icount
      data icount /0/
c     for pentagonal D5 and decagonal
      data fij1 /0,0,0,0,0,0,0,0,1/
      data fij2 /1,0,0,0,0,0,0,0,0/
      data fij3 /0,0,0,0,1,0,0,0,0/
c     for cubic T and trigonal 
      data fij4 /1,0,0,0,1,0,0,0,1/
      data fij5 /0,0,0,0,0,0,0,0,1/
      data fij6 /1,0,0,0,1,0,0,0,0/
      data ctoh /0.0,     -0.816496, 0.816496, 0., 0., 0.,
     *           0.816496,-0.816496, 0.0,      0., 0., 0.,
     *           0.577350, 0.577350, 0.577350, 0., 0., 0.,
     *           0., 0., 0., 0.0,     -0.816496, 0.816496,
     *           0., 0., 0., 0.816496,-0.816496, 0.0,
     *           0., 0., 0., 0.577350, 0.577350, 0.577350/
      data q50/1,0,0,0,0,0,    ! 1
     *         0,1,0,0,0,0,    ! 2
     *         0,0,1,0,0,0,    ! 3
     *         0,0,0,1,0,0,    ! 4
     *         0,0,0,0,1,0,    ! 5
     *         0,0,0,0,0,1/    ! 6
      data q30/1,1,1,0,0,0,    ! 1
     *         1,0,1,1,0,0,    ! 2
     *         1,0,0,1,1,0,    ! 3
     *         1,0,0,0,1,1,    ! 4
     *         1,1,0,0,0,1,    ! 5  3-fold axis in cubic approximant
     *         0,1,1,0,-1,0,   ! 6
     *         0,0,1,1,0,-1,   ! 7
     *         0,-1,0,1,1,0,   ! 8
     *         0,0,-1,0,1,1,   ! 9
     *         0,1,0,-1,0,1/   ! 10
      data q20/1,1,0,0,0,0,    ! 1
     *         1,0,1,0,0,0,    ! 2
     *         1,0,0,1,0,0,    ! 3
     *         1,0,0,0,1,0,    ! 4  y-axis in cubic approximant
     *         1,0,0,0,0,1,    ! 5
     *         0,1,1,0,0,0,    ! 6  x-axis in cubic approximant
     *         0,0,1,1,0,0,    ! 7
     *         0,0,0,1,1,0,    ! 8
     *         0,0,0,0,1,1,    ! 9
     *         0,1,0,0,0,1,    ! 10
     *         0,1,0,0,-1,0,   ! 11
     *         0,0,1,0,0,-1,   ! 12
     *         0,-1,0,1,0,0,   ! 13
     *         0,0,-1,0,1,0,   ! 14  normal to 3-fold axis in cubic apprx.
     *         0,0,0,-1,0,1/   ! 15  z-axis in cubic approximant
      data q10d0 /0,0,0,0,1,0/
      data q2d0  /1,1,1,1,0,0/
      data qmd0  /1,0,0,-1,0,0/
      icount=icount+1
      if(icount.eq.1) then
         call trnsp(ctoh)
         call mcpy(ctoh,htoc)
         call matinv(htoc,6,6,b,0,det,ipv,ind,piv)
         call getsys(isys)
         do 41 i=1,6
            call getqi0(q50(1,i),q5p(1,i))
            call norml(q5p(1,i),3)
            call norml(q5p(4,i),3)
 41      continue
         do 42 i=1,10
            call getqi0(q30(1,i),q3p(1,i))
            call norml(q3p(1,i),3)
            call norml(q3p(4,i),3)
 42      continue
         do 43 i=1,15
            call getqi0(q20(1,i),q2p(1,i))
            call norml(q2p(1,i),3)
            call norml(q2p(4,i),3)
 43      continue
         call getqi0(q10d0,q10d)
         call norml(q10d(1),3)
         call norml(q10d(4),3)
         call getqi0(qmd0,qmd)
         call norml(qmd(1),3)
         call norml(qmd(4),3)
         call getqi0(q2d0,q2d)
         call norml(q2d(1),3)
         call norml(q2d(4),3)
         if(isys.eq.1) then
c          Y. Ishii, Phys Rev. B39 (1989) 11862
c          D5 distortion
            call mcpyr3(fij1,amij1)
            call mcpyr3(fij2,amij2)
            call mcpyr3(fij3,amij3)
            call mcpyr3(fij1,bmij1)
         else if(isys.eq.2) then
c          T distortion  : eps1
            call mcpyr3(fij4,amij1)
c          D3 phason distortion : eps2
            call mcpyr3(fij5,amij2)
            call mcpyr3(fij6,amij3)
c          D3 phonon distortion : eps4
            call mcpyr3(fij5,bmij1)
            call getwmij(amij2,wmij2,ctoh,htoc)
            call getwmij(amij3,wmij3,ctoh,htoc)
            call getwmij(bmij1,wmij4,ctoh,htoc)
c         else if(isys.eq.3) then
         else if(isys.ge.3) then
c          orthorhombic phason strain
            call mcpyr3(fij1,amij1)
            call mcpyr3(fij2,amij2)
            call mcpyr3(fij3,amij3)
         end if
         write(6,*) 'amij1='
         write(6,'(3f9.5)') ((amij1(i,j),j=1,3),i=1,3)
         if(isys.eq.2) then
            write(6,*) 'amij2='
            write(6,'(3f9.5)') ((wmij2(i,j),j=1,3),i=1,3)
            write(6,*) 'amij3='
            write(6,'(3f9.5)') ((wmij3(i,j),j=1,3),i=1,3)
            write(6,*) 'bmij1='
            write(6,'(3f9.5)') ((wmij4(i,j),j=1,3),i=1,3)
         else
            write(6,*) 'amij2='
            write(6,'(3f9.5)') ((amij2(i,j),j=1,3),i=1,3)
            write(6,*) 'amij3='
            write(6,'(3f9.5)') ((amij3(i,j),j=1,3),i=1,3)
            write(6,*) 'bmij1='
            write(6,'(3f9.5)') ((bmij1(i,j),j=1,3),i=1,3)
         end if
      end if
      if(isys.ne.2) then
         do i=1,6
            de(i,i)=1
            di(i,i)=1
         end do
         do i=4,6
            do j=1,3
               de(i,j)=eps1*amij1(i-3,j)+eps2*amij2(i-3,j)+
     *                 eps3*amij3(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps4*bmij1(i,j)
            end do
         end do
      else if(isys.eq.2) then
         do i=1,6
            de(i,i)=1
         end do
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps4*bmij1(i,j)
            end do
         end do
         call mtmpl(de,ctoh,ded)
         call mtmpl(htoc,ded,de)
         do i=4,6
            do j=1,3
               de(i,j)=de(i,j)+eps1*amij1(i-3,j)
            end do
         end do         
      end if
      call mcpy(de,di)
      call matinv(di,6,6,b,0,det,ipv,ind,piv)
      write(6,*) 'deformation matrix de'
      do 407 i=1,6
      write(6,'(6f8.4)') (de(i,j),j=1,6)
 407  continue
      write(6,*) 'deformation matrix di'
      do 408 i=1,6
      write(6,'(6f8.4)') (di(i,j),j=1,6)
 408  continue
      return
      end

      subroutine getwmij(amij,wmij,ctoh,htoc)
      real amij(3,3),wmij(3,3),ctoh(6,6),htoc(6,6),tmp(6,6)
      do i=1,3
         do j=1,3
            tmp(i,j)=0
            do k=1,3
               tmp(i,j)=tmp(i,j)+amij(i,k)*ctoh(k,j)
            end do
         end do
      end do
      do i=1,3
         do j=1,3
            wmij(i,j)=0
            do k=1,3
               wmij(i,j)=wmij(i,j)+htoc(i,k)*tmp(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mcpy(s1,s2)
      real s1(6,6)
      real s2(6,6)
      do 100 i=1,6
         do 110 j=1,6
            s2(i,j)=s1(i,j)
 110     continue
 100  continue
      return
      end


      function ivicmp(h,hr,n)
      integer h(*),hr(*)
      ivicmp=0
      do 50 i=1,n
      if(h(i).ne.hr(i)) return
 50   continue
      ivicmp=1
      return
      end

      function ivrcmp(x,y,n,eps)
      real x(*),y(*)
      ivrcmp=0
      do 50 i=1,n
      if(abs(x(i)-y(i)).gt.eps) return
 50   continue
      ivrcmp=1
      return
      end

c*********************************
      subroutine trcs(x,y,n1,n2,n3)
      dimension x(*),y(*),n1(*),n2(*),n3(*)
      real n1,n2,n3
c*****transformation of coordinate systems********************
c     x: coordinates in primary system
c     y: coordinates in plotter system
c        y(1),y(2) are x and y coordinates in plotter system
      y(1)= (n1(1)*x(1)+n1(2)*x(2)+n1(3)*x(3))
      y(2)= (n2(1)*x(1)+n2(2)*x(2)+n2(3)*x(3))
      y(3)= (n3(1)*x(1)+n3(2)*x(2)+n3(3)*x(3))
      return
      end

      function ifskip(q)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      data eps/0.001/
      call getsys(isys)
      ifskip=1
      if(q(3).lt.-eps) return
      if(q(2).lt.-eps) return
      if(isys.eq.1) then
          if(-.3090*q(1)+0.9511*q(2).gt.eps) return
      else if(isys.eq.2) then
          if(-.5878*q(1)+0.8090*q(2).gt.eps) return
      else
          call quit('invalid isys')
      end if
      ifskip=0
      return
      end

      subroutine intsec(gamma,ish)
      dimension a(3,3),b(3),ipvt(3),indx(3,2),pvt(3)
      real an(10),bn(10),cn(10),qd(6)
      real ff(20),aa(20),bb(20),cc(20),ct(20)
      real xx(10,10),yy(10,10),zz(10),ax(10),bx(10)
      real nr
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10)
      real cnt,tau
      integer nx(6,10)
      data nx/1,1,0,0,0,0,  1,0,1,0,0,0,  1,0,0,1,0,0,
     *        1,0,0,0,1,0,  1,0,0,0,0,1,  0,1,1,0,0,0,
     *        0,0,1,1,0,0,  0,0,0,1,1,0,  0,0,0,0,1,1,
     *        0,1,0,0,0,1/
      data mp/5/, nbf/10/, eps/0.0001/, eps1/0.0002/
      data cnt/0.5/, tau/1.618/, rat/1.3763/
      wt(x1,x2,x3,h1,h2,h3,f)=h1*x1+h2*x2+h3*x3-f
c
c          polyhedral boundary
c          nbf: number of boundary planes
c          direction cos aa,bb,cc
      do 130 i=1,nbf
         call getqp(nx(1,i),qd)
         absa=sqrt(qd(1)**2+qd(2)**2+qd(3)**2)
         an(i)=qd(1)/absa
         bn(i)=qd(2)/absa
         cn(i)=qd(3)/absa
 130  continue
      ua=-(tau-cnt)*(1+gamma*2)
      ub= (tau-cnt)*(1-gamma*2)
      du=ub-ua
c     x: x-coordinate used in the gauss integral
      zz(ish)=ua+du*ish/mp
c     find x,y coordinates at given z
      do 100 i=1,nbf
         aa(i)=an(i)
         bb(i)=bn(i)
         cc(i)=cn(i)
         ff(i)=rat
         ct(i)=-cnt
 100  continue
      do 110 i=nbf+1,nbf*2
         aa(i)=-an(i-nbf)
         bb(i)=-bn(i-nbf)
         cc(i)=-cn(i-nbf)
         ff(i)=rat
         ct(i)= cnt
 110  continue
      np=0
      do 200 i=1,nbf*2-1
c     plane normal to z-axis
      if(abs(1.0-abs(cc(i))).lt.eps) go to 200
           do 210 j=i+1,nbf*2
           if(abs(1.0-abs(cc(j))).lt.eps) go to 210
c     plane normal to z-axis
           if(abs(1.0-abs(aa(i)*aa(j)
     *               +bb(i)*bb(j)+cc(i)*cc(j))).lt.eps)
     *                        go to 210
c     plane i and plane j are parallel
c      a11*x+a12*y=b1    line1
c      a21*x+a22*y=b2    line2
           if(abs(aa(i)*bb(j)-aa(j)*bb(i)).lt.eps) go to 210
c      two lines are parallel  (det=0)
           a(1,1)=aa(i)
           a(1,2)=bb(i)
           a(2,1)=aa(j)
           a(2,2)=bb(j)
           b(1)=ff(i)-cc(i)*(zz(ish)-ct(i))
           b(2)=ff(j)-cc(j)*(zz(ish)-ct(j))
           call matinv(a,3,2,b,1,det,ipvt,indx,pvt)
c          b: x,y coordinates of the vertex of polyhedron
c                  on the plane passes at a given z
c          remove vertex outside the polyhedron
           do 220 l=1,nbf*2
           if(wt(b(1),b(2),zz(ish)-ct(l),
     *          aa(l),bb(l),cc(l),ff(l)) .gt. eps) go to 210
 220       continue
c          xx(np,ish),yy(np,ish): coord. of vertex at ish-th section
c          remove multiple points
           iskp=0
           do 300 k=1,np
           if(abs(xx(k,ish)-b(1)).lt.eps1
     *                  .and. abs(yy(k,ish)-b(2)).lt.eps1) then
                iskp=1
                go to 301
           end if
 300       continue
 301       continue
           if(iskp.eq.0) then
                np=np+1
                if(np.le.10) then
                     xx(np,ish)=b(1)
                     yy(np,ish)=b(2)
                else
                     write(6,'(a)') 'vertices more than 10'
                     stop
                end if
           end if
 210       continue
 200  continue
      if(np.gt.0.and.np.le.10) then
          call normal(ax,bx,fx(1,ish),xx(1,ish),yy(1,ish),np)
      end if
      nps(ish)=np
      do 400 i=1,np
           qd(1)=0
           qd(2)=0
           qd(3)=0
           qd(4)=-ax(i)
           qd(5)=-bx(i)
           qd(6)=0
c******    call qtox(qd,nr(1,i,ish))
           call getxe(qd,nr(1,i,ish))
 400  continue
      return
      end

      subroutine normal(ax,bx,fx,xx,yy,np)
      real ax(*),bx(*),fx(*),xx(*),yy(*)
      real ang(10)
      integer ns(10),st(20)
      data pi/3.141592/
      do 100 i=1,np
      ang(i)=atan0(yy(i),xx(i))
 100  continue
c     rearrange ds in ascending order of dd
      call qsort(ang,st,ns,np)
      do 200 i=1,np
             if(i.lt.np) then
                  j=ns(i+1)
             else
                  j=ns(1)
             end if
             k=ns(i)
             dy=yy(j)-yy(k)
             dx=xx(j)-xx(k)
             absd=sqrt(dx**2+dy**2)
             xn=dx/absd
             yn=dy/absd
c      grd: edge gradient
             grd=atan0(dy,dx)
c      ax,bx: direction cos of normal to edge
             grd=grd-pi/2
             ax(i)=cos(grd)
             bx(i)=sin(grd)
c      fx: length of normal
             fx(i)=ax(i)*xx(k)+bx(i)*yy(k)
 200  continue
      return
      end

      subroutine getqp(h,q)
      integer h(*)
      real q(*),qd(6),dr(6,6),d(6,6),sds(6,6)
      data  d /   0.,     0.,     1.,     0.,     0.,      1.,
     *            -.7236, 0.5257, 0.4472, -.2764, -.8507, -.4472,
     *            -.7236, -.5257, 0.4472, -.2764, 0.8507, -.4472,
     *            0.2764, -.8507, 0.4472, 0.7236, -.5257, -.4472,
     *            0.8944, 0.,     0.4472, -.8944, 0.,     -.4472,
     *            0.2764, 0.8507, 0.4472, 0.7236, 0.5257, -.4472/
      data sds/ 1., 0., 0., 0., 0., 0.,
     *          0., 1., 0., 0., 0., 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 1., 0., 0.,
     *          0., 0., 0., 0., 1., 0.,
     *          0., 0., 0., 0., 0., 1./
      call mcpy(d,dr)
      call trnsp(dr)
      do i=1,6
         qd(i)=0.
         do j=1,6
            qd(i)=qd(i)+sds(j,i)*h(j)
         end do
      end do
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+dr(j,i)*qd(j)
         end do
      end do
      return
      end

      subroutine vivold(na,mpl,isk,irs)
      integer isk(0:120,*),irs(0:120,*)
      real mpl(*)
c      parameter (namax=160,nemax=12)
      include 'polygn.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc2/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      real vn(namax)
      real vi(nemax,namax), po(3)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      data pi/3.141592/, eps/0.0001/, ras/1./, sqrt5/2.23606/

****************
      call geta(al,am)
      call getc(cl)
c      write(6,*) 'partial occupation probabilities'
      write(6,*) 'al,am,cl',al,am,cl
      do n=1,na
c*****     ej: edge vectors of triangle in vi
c          vi: area of the triangle with edges ej
c*****     ish(n)      : 0: triangle 1: ellips 2: circle
         if(ish(n).ge.0) then
c     triangle
c           write(6,*) 'nth(n) ',nth(n)
            vn(n)=0
            do j=1,nth(n)
               k1=mej(1,j,n)
               k2=mej(2,j,n)
c              write(6,*) 'nth,k1,k2 ',nth,k1,k2
               vi(j,n)=
     *              abs(ej(4,k1,n)*ej(5,k2,n)-ej(5,k1,n)*ej(4,k2,n))
               vn(n)=vn(n)+
     *              vi(j,n)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (ramax(n)**2-ramin(n)**2)/2
            end do
c     write(6,*) 'vn,isk,irs=',vn(n),isk(0,n),irs(0,n)
         else if(ish(n).eq.-1) then
c     ellips
            r1=vabs(ej(4,1,n),2)
            r2=vabs(ej(4,2,n),2)
            si=pi*r1*r2*(2/sqrt5)**2
            vn(n)=si*mpl(n)*isk(0,n)*(ramax(n)**2-ramin(n)**2)*al**2
         else if(ish(n).eq.-2) then
c     circle
c     si=pi*(2/sqrt5)**2
            si=pi*ras**2*al**2
            vn(n)=si*mpl(n)*isk(0,n)*(ramax(n)**2-ramin(n)**2)
         else 
            call quit('invalid ish')
         end if
         
         vn(n)=vn(n)/al**2
         
      end do
c     if(icent.eq.1) then
      if(abs(icent).eq.1) then
         do n=1,na
            vn(n)=vn(n)*2
         end do
      else
         do n=1,na
            vn(n)=vn(n)
         end do
      end if
      vt=0
      do n=1,na
         vt=vt+vn(n)*p(n)
      end do
      write(6,*) 'volume of the occupation domain',vt,'(a**2)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*p(n),n=1,na)
      call getdet(det)  ! volume of the unit cell in reciprocal space (a**-4)
      write(6,*) 'al,cl,det,vt=',al,cl,det,vt
      write(6,'(a,f12.6,a,f12.6,a)') 'point density=', vt*abs(det),
     *     '(a**-2*cl**-1) = ', vt*abs(det)/(al**2*cl), '(A**-3)'
      return
      end

      subroutine getdet(det0)
      common /cgetd/ det
      det0=det
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end

      subroutine setapprx(iapprx0)
      common /capprx/ iapprx
      iapprx=iapprx0
      return
      end

      integer function getapprx()
      common /capprx/ iapprx
      getapprx=iapprx
      return
      end

      subroutine getni3(e1,e2,e3,e4,n1,dst)
      real e1(*),e2(*),e3(*),e4(*),n1(*),dst
      real d0(3),d1(3),d2(3)
      real vinp,dst1,dst2
      real eps0
      common /ceps0/ eps0

      call vsub(e1,e2,d1,3)
      call vsub(e3,e2,d2,3)
c     n1 : vector product of d1 and d2
      n1(1)=d1(2)*d2(3)-d1(3)*d2(2)
      n1(2)=d1(3)*d2(1)-d1(1)*d2(3)
      n1(3)=d1(1)*d2(2)-d1(2)*d2(1)

      ! normalize
      dst1=sqrt(n1(1)**2+n1(2)**2+n1(3)**2)
      if(dst1.le.eps0) then
         do i=1,3
            n1(i)=0
         end do
         d=0
      else
         do i=1,3
            n1(i)=n1(i)/dst1   ! normalization
         end do
      end if

      call vsub(e1,e4,d0,3)
      dst2=vinp(n1,d0,3)
      if(dst2.lt.0) then    ! take outward normal
         do i=1,3
            n1(i)=-n1(i)
         end do
      end if
      dst=vinp(n1,e1,3)
      return
      end
