c
c     equivalent symmetry operator with different origin choice
c                      for i-Al-Mg-Zn Pa3
c
c      (0 eps1  ! cubic distortion
c      (1) x0    ! new origin coordinates
c      (2) nsymo,icent,brv
c      (3) symmetry operator (header)
c      (4) symmetry operator in the format of IT (x,y,z,t,u,v etc)
c          ***** repeat (4) nsymo times ******      
c
      integer r(6,6)
      real t(6),td(6),tt(6)
      real rei(6,6),tei(6)
      real x0(6) ! origin shift
      character*31 coord
      character brv
      integer getnsym,geticnt
      integer d1,d2
      isys=2                       ! for  icosahedral cubic phason
      call setsys(isys)
      inp=5
      iout=6
      call setinp(inp)   ! for fread
      call setout(iout)   ! for fread
      call freadr('eps1=',1,eps1,1)
      isys=2              ! for cubic phason
      call setsys(isys)
      eps2=0
      eps3=0
      eps4=0
      eps5=0
      eps6=0
      call seteps(eps1,eps2,eps3,eps4,eps5,eps6)
      call setd()     ! set bases vectors of q space
      call setdei()   ! set phason strain
      call freadr('x0=',6,x0,1)
      call wtvctrrf('x0=',x0,6,'(6f10.5)')
      na=1
      call rdsymo(na,brv)
      call setsymei()      ! set symmetry operator in q space
      nsymo=getnsym()
      icent=geticnt()
      write(6,*) 'nsymo=',nsymo,' icent=',icent
      do ns=1,nsymo
         call gettd(x0,td,ns,ic)
         call getrotmtrx(ns,r)
         call getnptrns(ns,t)
         call getsymei(ns,rei,tei)  ! get ns-th symmetry operator in q space
         do ic=0,0
            call gettd(x0,td,ns,ic)
         end do
         call vsum(t,td,tt,6)
         call wtmtrxrf('rei=',rei,6,'(6f10.5)')
         call wtvctrrf('tei=',tei,6,'(6f10.5)')
c         call wtmtrxif('r=',r,6,'(6i3)')
c         call wtvctrrf('t=',t,6,'(6f10.5)')
c         call wtvctrrf('td=',td,6,'(6f10.5)')
c         call wtvctrrf('tt=',tt,6,'(6f10.5)')
         d1=3
         d2=3
         call encode(r,tt,coord,d1,d2)
         len=istrln(coord)
         write(6,'(i3,1x,a)') ns,coord(1:len)
      end do
      stop
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      stop
      return
      end

      subroutine getshfto(shft)
      real shft(6)
      common /cshfto/ shifto(6)
      call vcpyr(shifto,shft,6)
      return
      end

      subroutine setshfto(shft)
      real shft(6)
      common /cshfto/ shifto(6)
      call vcpyr(shft,shifto,6)
      return
      end

      subroutine getq23(q2,q3)  ! dummy subroutine for use of lattice
      real q2(*),q3(*)
      return
      end
