      subroutine rdlc()
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real dalamcl(6),rdalamcl(6)
      real eps0
      common /ceps0/ eps0
      common /cisym/ ieqs,ists,mode
c     read(5,'(3f8.5,i3)') al,eps1,eps2,eps3,isys,eps0,ists,mode,itst
      call freadr('a=',1,al,1)
      call freadr('eps1=',1,eps1,0)
      call freadr('eps2=',1,eps2,0)
      call freadr('eps3=',1,eps3,0)
      call freadi('isys=',1,isys,0)
      call freadr('eps0=',1,eps0,0)
      call freadi('ists=',1,ists,0)
      call freadi('mode=',1,mode,0)
      call freadi('itst=',1,itst,0)
      call setitst(itst)
      write(6,'(4(a,f8.5),a,i3,a,f8.5,3(a,i3))')
     *     'al=',al,'  eps1=',eps1,
     *     ' eps2=',eps2,' eps3=',eps3,' isys=',isys,' eps0=',eps0,
     *     ' ists=',ists,' mode=', mode, ' itst=',itst
      call setsys(isys)
      if(ists.ne.0.and.ists.ne.1) then
         write(6,*) 'ists=',ists
         call quit('ists should be 0 or 1')
      end if
      if(abs(itst).gt.7) then
         write(6,*) 'itst=',itst
         call quit('itst should be 0 to 7')
      end if
**********************
      am=al  ! important because of the definition of phason matrix
**********************
      do i=1,3
         dalamcl(i)=al
         rdalamcl(i)=1.0/al
      end do
      do i=4,6
         dalamcl(i)=am
         rdalamcl(i)=1.0/am
      end do
c     dalamcl : diagonal part of alamcl
      call dagmtrxr(dalamcl,alamcl,6)  ! get diagonal matrix with dalamcl
      call dagmtrxr(rdalamcl,ralamcl,6)  ! get diagonal matrix with rdalamcl
      call wtmtrxrf('alamcl',alamcl,6,'(6f10.5)')
      call wtmtrxrf('ralamcl',ralamcl,6,'(6f10.5)')
      return
      end

      subroutine getde(ded)
      real ded(6,6)
c     q space coordinate of diffraction vector h (unit lattice const.)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mcpyr6(de,ded)
      return
      end

      subroutine getdi(did)
      real ded(6,6)
c     q space coordinate of diffraction vector h (unit lattice const.)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mcpyr6(di,did)
      return
      end

      subroutine getqi0(h,q)   ! no phason  a=1
c     q space coordinate of diffraction vector h (unit lattice const.)
      integer h(*)
      real q(*)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplmnoir(h,dq,q,1,6,6)
      return
      end

      subroutine getqi(h,q)   ! under phason
c     q space coordinate of diffraction vector h
      integer h(*)
      real q(*)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      real qd(6),q1(6)
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      call getsys(isys)
      call getqi0(h,qd)
      call mtmplmnor(qd,di,q1,1,6,6)
      call mtmplmnor(ralamcl,q1,q,6,6,1)
      return
      end

      subroutine getqe0(h,q)  ! no phason a=1
c     q space component of 
      real h(*),q(*)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      call mtmplmnor(dr,h,q,6,6,1)
      return
      end

      subroutine scalea(q)
      real q(6)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      real q1(6)
      call mtmplmnor(alamcl,q,q1,6,6,1)
      call vcpyr(q1,q,6)
      return
      end

      subroutine getqe(x,q)  ! no phason
      real x(6),q(6)
      call getqe0(x,q)
      call scalea(q)
      return
      end

      subroutine getqed(x,q)   ! q space component under phason
      real x(6),q(6)
      real qd(6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getqe(x,qd)
c     phason distortion in real space
      call mtmplmnor(de,qd,q,6,6,1)  ! add distortion
      return
      end

      subroutine rmvdst(x,x0)  ! remove phason distortion
      real x(*),x0(*)
      real qd(6),q(6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplmnor(dr,x,qd,6,6,1)
      call mtmplmnor(de,qd,q,6,6,1) ! undistorted q
      call mtmplmnor(dq,q,x0,6,6,1)
      return
      end

      subroutine adddst(x0,x)
      real x0(*),x(*)
      real qd(6),q(6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplmnor(dr,x0,q,6,6,1)
      call mtmplmnor(di,q,qd,6,6,1)  ! distorted q
      call mtmplmnor(dq,qd,x,6,6,1)  ! distorted x
      return
      end

      subroutine getxe(q,x)   ! undistorted
      real q(*),x(*)
      real qd(6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      real alamcl,ralamcl
      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
      call mtmplmnor(ralamcl,q,qd,6,6,1) ! scale
      call mtmplmnor(dq,qd,x,6,6,1)
      return
      end

      subroutine getxed(q,x)  ! distorted 
      real q(*),x(*)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real qd(6)
      save ncount
      data ncount /0/
      if(ncount.eq.0) then
         write(6,*) '****************************'
         write(6,*) 'caution : unchecked getxed is used !'
         write(6,*) '****************************'
      end if
      ncount=ncount+1
c     call getxe(q,x)    ! original
      call mtmplmnor(di,q,qd,6,6,1) ! remove distortion
      call getxe(qd,x)          ! undistorted x
      return
      end

c      subroutine qtox0(q,x)   ! no phason
c      real q(*),x(*)
c      real dr,dq,de,di
c      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
cc      real al,am,cl,eps1,eps2,eps3,eps4
cc      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
c      call mtmplmnor(dq,q,x,6,6,1)
c      return
c      end

c      subroutine qtox(q,x)   ! get q to x before distortion
c      real q(*),x(*)
c      real dr,dq,de,di
c      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
c      real alamcl,ralamcl
c      common /csclmtrx/ alamcl(6,6),ralamcl(6,6)
c      real xd(6),qd(6)
cc     phason distortion in real space
c      call mtmplmnor(di,q,qd,6,6,1)      ! remove distortion
c      call mtmplmnor(alamcl,qd,q1,6,6,1) ! scale
c      call qtox0(q1,x)                   ! q to x
c      return
c      end

      subroutine setd()
      include 'impr8.inc'
      real d0,d1,d2,d3
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),isys

      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4

      real det
      common /cgetd/ det

      integer ipv(6),ind(6,2)
      real piv(6),b(6)
      real sr,ct,su,cu,c1,c2,c3,c4,s1,s2,s3,s4,c1sr,c2sr,c3sr,c4sr
      real s1sr,s2sr,s3sr,s4sr,tau,sqr2,sqr3,tqr3,t1,t2
      real dd(6,6)

      save icount
      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.61803399,tav=-tau)
      parameter (sqr2=1.41421356, sqr3=1.7320508, tqr3=-sqr3)
      parameter (t1=0.7070678, t2=-t1)
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *          c2sr, s2sr, ct, c4sr, s1sr, cu,
     *          c2sr, s3sr, ct, c4sr, s4sr, cu,
     *          c1sr, s4sr, ct, c3sr, s2sr, cu,
     *          sr,   0.,   ct, su,   0.,   cu,
     *          c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *          tau, 0.,  1.,  -1,  0.,  tau,
     *          tau, 0., -1.,  -1., 0.,  tav,
     *          0.,  1., tav,   0., tau, 1.,
     *          -1., tau, 0.,  tav, -1., 0.,
     *          0.,  1., tau,   0., tau, -1./
c      for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *          c2, s2, 0., c1, s4, 0.,
     *          c2, s3, 0., c1, s1, 0.,
     *          c1, s4, 0., c2, s3, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *          t1, t1, 0., t2, t1, 0.,
     *          0., 1., 0., 0.,-1., 0.,
     *          t2, t1, 0., t1, t1, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c        initialize
         call sclmtrx(d0,0.5,6)
         call sclmtrx(d1,1.0/sqrt(1+tau**2)/2,6)
         do i=1,6
            do j=1,4  ! important
               d2(i,j)=d2(i,j)/sqrt(5.)
            end do
         end do
         do i=1,6
            do j=1,4  ! important
               d3(i,j)=d3(i,j)/2
            end do
         end do
         call trnsp(d0)
         call trnsp(d1)
         call trnsp(d2)
         call trnsp(d3)
      end if
      if(isys.eq.1) then
          call mcpyr6(d0,dq)
      else if(isys.eq.2) then
          call mcpyr6(d1,dq)
      else if(isys.eq.3.or.isys.eq.4) then
          call mcpyr6(d2,dq)
      else if(isys.eq.5) then
          call mcpyr6(d3,dq)
      else
          call quit('wrong isys')
      end if
      call mcpyr6(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
      call mtmplr(dq,dr,dd,6)
      call wtmtrxrf('dr=',dr,6,'(6f8.4)')
      call wtmtrxrf('dq=',dq,6,'(6f8.4)')
      call wtmtrxrf('dd=',dd,6,'(6f8.4)')
      return
      end

      subroutine setdei()   ! set phason distortion
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3),
     *      amij4(3,3),amij5(3,3)
      common /cphonn/ bmij1(3,3)
      real fij1(3,3),fij2(3,3),fij3(3,3),fij4(3,3),fij5(3,3),fij6(3,3)
      real fij7(3,3),fij8(3,3)
      real b(6)
      integer q50(6,6),q30(6,10),q20(6,15)
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15)
      real ctoh(6,6),htoc(6,6),ded(6,6)
      integer getisys
c     for pentagonal D5
      data fij1 /0,0,0,0,0,0,0,0,1/
      data fij2 /1,0,0,0,0,0,0,0,0/
      data fij3 /0,0,0,0,1,0,0,0,0/
c     for cubic T and trigonal 
      data fij4 /1,0,0,0,1,0,0,0,1/
      data fij5 /0,0,0,0,0,0,0,0,1/
      data fij6 /1,0,0,0,1,0,0,0,0/
c     for monoclinic distortion for dihedral quasicrystals
      data fij7 /0,0,0,1,0,0,0,0,0/
      data fij8 /0,1,0,0,0,0,0,0,0/
      data ctoh /0.0,     -0.816496, 0.816496, 0., 0., 0.,
     *           0.816496,-0.816496, 0.0,      0., 0., 0.,
     *           0.577350, 0.577350, 0.577350, 0., 0., 0.,
     *           0., 0., 0., 0.0,     -0.816496, 0.816496,
     *           0., 0., 0., 0.816496,-0.816496, 0.0,
     *           0., 0., 0., 0.577350, 0.577350, 0.577350/
      data q50/1,0,0,0,0,0,    ! 1
     *         0,1,0,0,0,0,    ! 2
     *         0,0,1,0,0,0,    ! 3
     *         0,0,0,1,0,0,    ! 4
     *         0,0,0,0,1,0,    ! 5 z-axis in isys=3,4
     *         0,0,0,0,0,1/    ! 6
      data q30/1,1,1,0,0,0,    ! 1
     *         1,0,1,1,0,0,    ! 2
     *         1,0,0,1,1,0,    ! 3
     *         1,0,0,0,1,1,    ! 4
     *         1,1,0,0,0,1,    ! 5
     *         0,1,1,0,-1,0,   ! 6
     *         0,0,1,1,0,-1,   ! 7
     *         0,-1,0,1,1,0,   ! 8
     *         0,0,-1,0,1,1,   ! 9
     *         0,1,0,-1,0,1/   ! 10
      data q20/1,1,0,0,0,0,    ! 1
     *         1,0,1,0,0,0,    ! 2
     *         1,0,0,1,0,0,    ! 3
     *         1,0,0,0,1,0,    ! 4  y-axis in cubic approximant
     *         1,0,0,0,0,1,    ! 5
     *         0,1,1,0,0,0,    ! 6  x-axis in cubic approximant
     *         0,0,1,1,0,0,    ! 7
     *         0,0,0,1,1,0,    ! 8
     *         0,0,0,0,1,1,    ! 9
     *         0,1,0,0,0,1,    ! 10
     *         0,1,0,0,-1,0,   ! 11
     *         0,0,1,0,0,-1,   ! 12
     *         0,-1,0,1,0,0,   ! 13
     *         0,0,-1,0,1,0,   ! 14
     *         0,0,0,-1,0,1/   ! 15  z-axis in cubic approximant

c     cubic 3 fold axis => 1 1 1 -1 1 1

      call trnsp(ctoh)
      call mcpyr6(ctoh,htoc)   ! cubic to trigonal
c      call matinv(htoc,6,6,b,0,det,ipv,ind,piv)
      call matinv6(htoc,b,0,det)
      isys=getisys()
      do i=1,6
         call getqi0(q50(1,i),q5p(1,i))
         call norml(q5p(1,i),3)
         call norml(q5p(4,i),3)
      end do
      do i=1,10
         call getqi0(q30(1,i),q3p(1,i))
         call norml(q3p(1,i),3)
         call norml(q3p(4,i),3)
      end do
      do i=1,15
         call getqi0(q20(1,i),q2p(1,i))
         call norml(q2p(1,i),3)
         call norml(q2p(4,i),3)
      end do
      if(isys.eq.1) then
c          Y. Ishii, Phys Rev. B39 (1989) 11862
c          D5 distortion
         call mcpyr3(fij1,amij1)
         call mcpyr3(fij2,amij2)
         call mcpyr3(fij3,amij3)
         call mcpyr3(fij7,amij4)
         call mcpyr3(fij8,amij5)
         call mcpyr3(fij1,bmij1)
      else if(isys.eq.2) then
c          cubic distortion     : eps1
         call mcpyr3(fij4,amij1)
c          D2 phason distortion : eps2
         call mcpyr3(fij5,amij2)
c          D2 phason distortion : eps3
         call mcpyr3(fij6,amij3)
c          D2 phonon distortion : eps6
         call mcpyr3(fij5,bmij1)
      else if(isys.eq.3.or.isys.eq.4.or.isys.eq.5) then
c       ortho and monocli phason strain for dihedral cases
         call mcpyr3(fij1,amij1)
         call mcpyr3(fij2,amij2)
         call mcpyr3(fij3,amij3)
         call mcpyr3(fij7,amij4)
         call mcpyr3(fij8,amij5)
         call mcpyr3(fij1,bmij1)
      end if
      call wtmtrxrf('amij1=',amij1,3,'(3f9.5)')
      call wtmtrxrf('amij2=',amij2,3,'(3f9.5)')
      call wtmtrxrf('amij3=',amij3,3,'(3f9.5)')
      call wtmtrxrf('amij4=',amij4,3,'(3f9.5)')
      call wtmtrxrf('amij5=',amij5,3,'(3f9.5)')
      call wtmtrxrf('bmij1=',bmij1,3,'(3f9.5)')
      call unitmtrxr(de,6)
      call unitmtrxr(di,6)
      eps5=0
      eps6=0
      if(isys.eq.1) then
         do i=4,6
            do j=1,3
               de(i,j)=eps1*amij1(i-3,j)+eps2*amij2(i-3,j)+
     *                 eps3*amij3(i-3,j)+eps4*amij4(i-3,j)+
     *                 eps5*amij5(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps6*bmij1(i,j)
            end do
         end do
      else if(isys.eq.2) then
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)
            end do
         end do
c         do i=1,3
c            do j=1,3
c               de(i,j)=de(i,j)+eps6*bmij1(i,j)
c            end do
c         end do
*************necessary for trigonal distortion************
c         call mtmplr6(de,ctoh,ded)
c         call mtmplr6(htoc,ded,de)
**********************************************************
         do i=4,6
            do j=1,3
               de(i,j)=de(i,j)+eps1*amij1(i-3,j)
            end do
         end do         
      else if(isys.eq.3.or.isys.eq.4.or.isys.eq.5) then
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)+
     *                 eps4*amij4(i-3,j)+eps5*amij5(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps6*bmij1(i,j)
            end do
         end do
      end if
      call mcpyr6(de,di)
c      call matinv(di,6,6,b,0,det,ipv,ind,piv)
      call matinv6(di,b,0,det)
      call wtmtrxrf('deformation matrix de',de,6,'(6f10.5)')
      call wtmtrxrf('deformation matrix di',di,6,'(6f10.5)')
      return
      end

      subroutine getprjm0(prj)  ! n1,n2,n3 for viewing transformation
      real prj(3,3)
      real n1,n2,n3
      common /clmt2/ n1(6),n2(6),n3(6)
      do j=1,3
         prj(1,j)=n1(j+3)
         prj(2,j)=n2(j+3)
         prj(3,j)=n3(j+3)
      end do
      return
      end

      subroutine setprjm0(icase)  ! n1,n2,n3 for viewing transformation
      include 'impr8.inc'
      integer icase
      real n1,n2,n3
      common /clmt2/ n1(6),n2(6),n3(6)

      integer q5p(6),q3p(6),q2x(6),q2y(6),q2z(6)
      integer q2p(6),q2d(6),qmd(6)
      real q50(6,6),q5(6,6)
      real q3(6,4)
      real q2(6,3)
      real q20(6,3),q30(6,4)
      real n3x
      integer qc(6),qm(6),qc1(6),qc2(6),qc3(6)
c      real omtrx(3,3),umtrx(3,3)
      data q5p/1,0,0,0,0,0/
      data q3p/1,1,1,0,0,0/
      data q2x/0,1,0,0,-1,0/
      data q2y/0,0,1,1,0,0/
      data q2z/1,0,0,0,0,1/
      data qmd/0,0,0,1,-2,1/
      data q2d/0,0,0,-1,0,1/
      data qc1/0,1,1,0,0,0/
      data qc2/1,0,0,0,1,0/
      data qc3/0,0,0,-1,0,1/
      data q50/1,0,0,0,0,0,
     *     0,1,0,0,0,0,
     *     0,0,1,0,0,0,
     *     0,0,0,1,0,0,
     *     0,0,0,0,1,0,
     *     0,0,0,0,0,1/
      data q30/1,1,0,0,0,1,
     *     1,0,0,0,0,0,
     *     0,1,0,0,0,0,
     *     0,0,0,0,0,1/
      data q20/0,1,1,0,0,0,
     *     1,0,0,0,1,0,
     *     0,0,0,-1,0,1/

      call getsys(isys)
      call vcpyi(q2x,q2p,6)
      call vcpyi(q2y,qc,6)
      call vcpyi(q2x,qm,6)

      if(icase.eq.1) then
c     projection along 5-fold axis
         write(6,'(a)') '5-fold axis'
         call getqi0(q5p,n3)   ! z-axis
         call getqi0(q2x,n2)   ! y-axis
      else if(icase.eq.2) then
c     projection along 3-fold axis
         write(6,'(a)') '3-fold axis'
         call getqi0(q3p,n3)
         call getqi0(q2d,n2)
      else if(icase.eq.3) then
c     projection along 2-fold axis
         write(6,'(a)') '2-fold axis'
         call getqi0(q2p,n3)
         call getqi0(qc,n2)
c     call getqi0(q2z,n3)
c     call getqi0(q2y,n2)
      else if(icase.eq.4) then
c     projection along axis normal to mirror plane
         write(6,'(a)') 'normal to mh'
         call getqi0(qm,n3)
         call getqi0(qc,n2)
      else if(icase.eq.5) then
c     projection along (0001-21)
         call getqi0(qmd,n3)
         call getqi0(q5p,n2)
         write(6,'(a)') 'along (0001-21)'
      else if(icase.eq.6) then
c     projection along (0001-21)
         call getqi0(qc3,n3)
         call getqi0(qc2,n2)
         write(6,'(a)') 'cubic crystal'
      end if

c*****unitvectors in the projection plane (n1,n2)********************
c     normalization of n3
      call norml(n3(1),3)   ! normalize in external space
      call norml(n3(4),3)   ! normalize in internal space

c     projection of y-axis onto the projection plane
c      n3x=vinp(n3(1),n2(1),3)
c      do i=1,3
c         n2(i)=n2(i)-n3x*n3(i)
c      end do
c      n3x=vinp(n3(4),n2(4),3)
c      do i=4,6
c         n2(i)=n2(i)-n3x*n3(i)
c      end do
      
c     normalization of n2
      call norml(n2(1),3)
      call norml(n2(4),3)
c     calculation of n1
      call vprd(n2(1),n3(1),n1(1))  ! vector product
      call vprd(n2(4),n3(4),n1(4))  ! vector product
      call wtvctrrf('n1(4)=',n1(4),3,'(3f10.5)')
      call wtvctrrf('n2(4)=',n2(4),3,'(3f10.5)')
      call wtvctrrf('n3(4)=',n3(4),3,'(3f10.5)')
      
c      call vcpyr(n1(4),omtrx(1,1),3)
c      call vcpyr(n2(4),omtrx(1,2),3)
c      call vcpyr(n3(4),omtrx(1,3),3)
c      do i=1,3
c         do j=1,3
c            umtrx(i,j)=0
c            do k=1,3
c               umtrx(i,j)=umtrx(i,j)+omtrx(i,k)*omtrx(j,k)
c            end do
c         end do
c      end do
c      call wtmtrxrf('omtrx',omtrx,3,'(3f10.5)')
c      call wtmtrxrf('umtrx',umtrx,3,'(3f10.5)')
c      write(6,*) 'vinpn1n2=',vinp(n1(4),n2(4),3)
c      write(6,*) 'vinpn2n3=',vinp(n2(4),n3(4),3)
c      write(6,*) 'vinpn1n3=',vinp(n1(4),n3(4),3)
      return
      end

      subroutine celltr(x,mode)  ! 6d to 5d in decagonal s to f in icos.
      include 'impr8.inc'
      real x(*)
      real xd(6),trm1(6,6),trm2(6,6)
      save trm1,trm2
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      call getsys(isys)
      if(isys.le.2) then
         call sclvctr(x,0.5,6)
      else if(isys.eq.3) then
         if(mode.eq.1) then
c     transformation of coordinates
            call mtmplmnor(trm1,x,xd,6,6,1)
            call sclvctr(xd,0.2,6)
            call vcpyr(xd,x,6)
         else if(mode.eq.-1) then
            call mtmplmnor(trm2,x,xd,6,6,1)
            call vcpyr(xd,x,6)
         else if(mode.eq.2) then
c     transformation of hkl indices
            call mtmplmnor(x,trm2,xd,1,6,6)
            call vcpyr(xd,x,6)
         else if(mode.eq.-2) then
            call mtmplmnor(x,trm2,xd,1,6,6)
            call sclvctr(xd,0.2,6)
            call vcpyr(xd,x,6)
         else
            call quit('invalid mode in celltr')
         end if
      end if
      return
      end

      subroutine getsmtrx(sd)  ! get similarity transformation matrix
      real sd(6,6)
      common /csmtrm/ s(6,6)
      call mcpyr6(s,sd)
      return
      end

      subroutine smtrx(h,hd,ind)  ! similarity transformation
      real h(*),hd(*)
      real ht(6)
      common /csmtrm/ s(6,6)
      integer getisys
      isys=getisys()
c     call wtmtrxr('s',s,6)
      nend=ind
c     similarity transformation for decagonal and icosahedral
      call vcpyr(h,ht,6)
      if(ind.eq.0) then
         call vcpyr(ht,hd,6)
      else if(ind.gt.0) then
c        ext ==> tau  int ==> tau**-1
         do n=1,nend
            call mtmplmnor(ht,s,hd,1,6,6)
            if(n.ne.nend) call vcpyr(hd,ht,6)
         end do
         if(isys.le.2) then
            do j=1,6
               hd(j)=hd(j)/2**nend
            end do
         end if
         return
      else if(ind.lt.0) then
c        ext ==> tau**-1  int ==> tau
          do n=1,-nend
             call mtmplmnor(ht,s,hd,1,6,6)
             if(n.ne.-nend) call vcpyr(hd,ht,6)
          end do
          if(isys.le.2) then
              do j=1,6
                 hd(j)=hd(j)/2**abs(nend)
              end do
          end if
          return
      end if
      end

      subroutine setsmtrm(ind)
      common /csmtrm/ s(6,6)
      real s0(6,6),t0(6,6),s1(6,6),t1(6,6),s2(6,6),t2(6,6)
      real s3(6,6),t3(6,6)
      integer getisys
*************icosahedral f or i*************
      data s0/ 1, 1, 1, 1, 1, 1,
     *         1, 1, 1,-1,-1, 1,
     *         1, 1, 1, 1,-1,-1,
     *         1,-1, 1, 1, 1,-1,
     *         1,-1,-1, 1, 1, 1,
     *         1, 1,-1,-1, 1, 1/
      data t0/-1, 1, 1, 1, 1, 1,
     *         1,-1, 1,-1,-1, 1,
     *         1, 1,-1, 1,-1,-1,
     *         1,-1, 1,-1, 1,-1,
     *         1,-1,-1, 1,-1, 1,
     *         1, 1,-1,-1, 1,-1/
***************decagonal*********************
      data s1/ 0, 0,-1,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1,-1, 0, 0, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t1/-1, 0,-1,-1, 0, 0,
     *         1, 0, 1, 0, 0, 0,
     *         0, 1, 0, 1, 0, 0,
     *        -1,-1, 0,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************octagonal*********************
      data s2/ 1, 1, 0,-1, 0, 0,
     *         1, 1, 1, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *        -1, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t2/-1, 1, 0,-1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *         0, 1,-1, 1, 0, 0,
     *        -1, 0, 1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
***************dodecagonal*********************
      data s3/ 1, 0, 0,-1, 0, 0,
     *         1, 1, 0, 0, 0, 0,
     *         0, 1, 1, 1, 0, 0,
     *         0, 0, 1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      data t3/ 0, 1, -1, 1, 0, 0,
     *         0, 0, 1, -1, 0, 0,
     *         1,-1, 1, 0, 0, 0,
     *        -1, 1,-1, 1, 0, 0,
     *         0, 0, 0, 0, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      data s3/ 2, 1, 0,-1, 0, 0,
c     *         2, 2, 1, 0, 0, 0,
c     *         0, 1, 2, 2, 0, 0,
c     *        -1, 0, 1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
c      data t3/ 2,-1, 0, 1, 0, 0,
c     *        -2, 2,-1, 0, 0, 0,
c     *         0,-1, 2,-2, 0, 0,
c     *         1, 0,-1, 2, 0, 0,
c     *         0, 0, 0, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 1/
      isys=getisys()
      if(isys.le.2) then
         if(ind.gt.0) then
            call mcpyr6(s0,s)
         else if(ind.lt.0) then
            call mcpyr6(t0,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.3) then
         if(ind.gt.0) then
            call mcpyr6(s1,s)
         else if(ind.lt.0) then
            call mcpyr6(t1,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.4) then
         if(ind.gt.0) then
            call mcpyr6(s2,s)
         else if(ind.lt.0) then
            call mcpyr6(t2,s)
         else
            call unitmtrxr(s,6)
         end if
      else if(isys.eq.5) then
         if(ind.gt.0) then
            call mcpyr6(s3,s)
         else if(ind.lt.0) then
            call mcpyr6(t3,s)
         else
            call unitmtrxr(s,6)
         end if
      end if
c      write(6,*) 'isys=',isys,' ind=',ind
c      write(6,*) '*******************'
c      call wtmtrxrf('s1',s1,6,'(6f10.5)')
c      call wtmtrxrf('s2',s2,6,'(6f10.5)')
c      call wtmtrxrf('s3',s3,6,'(6f10.5)')
c      call wtmtrxrf('t1',t1,6,'(6f10.5)')
c      call wtmtrxrf('t2',t2,6,'(6f10.5)')
c      call wtmtrxrf('t3',t3,6,'(6f10.5)')
       call wtmtrxrf('s',s,6,'(6f10.5)')
c      write(6,*) '*******************'
c      stop
      return
      end
