c
c      calculation of small occupation domains under phason
c
      subroutine rescale(rmin,rmax,v)  ! for reshaping of OD for approximants
      data tau3 /4.236067/  ! tau cube
      integer getapprx
      if(getapprx().eq.0) then
         rmin=rmin*tau3
         rmax=rmax*tau3
         v=v*tau3
      end if
      return
      end

      subroutine getqedrs(x,q)  ! for reshaping of OD for approximants
      real x(6),q(6)
      integer getapprx
c     write(6,*) 'getapprx()',getapprx()
      if(getapprx().eq.0) then
         call reshape(x,q)
      else
         call getqed(x,q)
      end if
c      call wtvctrrf('x=',x,6,'(6f10.5)')
c      call wtvctrrf('q=',q,6,'(6f10.5)')
      return
      end

      subroutine setapprx(iapprx0)
      common /capprx/ iapprx
      iapprx=iapprx0
      return
      end

      integer function getapprx()
      common /capprx/ iapprx
      getapprx=iapprx
      return
      end

      subroutine reshape(x,q)  ! choose version
      real x(6),q(6)
c     call reshape0(x,q)
      call reshape1(x,q)
c     call reshape2(x,q)
      return
      end

      subroutine reshape0(x,q)   ! x: a 6D edge vector or xi
      real x(6),q(6)
      common /csmtrm1/ s1(6,6),s2(6,6)
      real xd(6),xi(6)
      data tau3 /4.236067/  ! tau cube
      call mtmplmnor(s1,x,xd,6,6,1) ! similarity transformation
                                !  ext tau^-3 int tau^3
      call prjint(xd,xi)        !  projection into internal space
                                !  introduce phason strain
      call getqed(x,q)
      return
      end

      subroutine reshape1(x,q)   ! x: a 6D edge vector or xi
      real x(6),q(6)
      common /csmtrm2/ sresh(6,6)
      real xd(6),xi(6)
      data tau3 /4.236067/  ! tau cube
      call mtmplmnor(sresh,x,q,6,6,1)    ! similarity transformation
      return
      end

      subroutine reshape2(x,q)  ! only for cubic phason
      real x(6),q(6)
      real de(6,6),qd(6)
      data tau3 /4.236067/  ! tau cube
      call getde(de)
      call getqe(x,qd) ! no phason
c     phason distortion in real space
      call mtmplmnor(de,qd,q,6,6,1)  ! add distortion
      return
      end

      subroutine intreshape()
      common /csmtrm0/ s0(6,6)
      data s0 /  2,-1,-1,-1,-1,-1,
     *          -1, 2,-1, 1, 1,-1,
     *          -1,-1, 2,-1, 1, 1,
     *          -1, 1,-1, 2,-1, 1,
     *          -1, 1, 1,-1, 2,-1,
     *          -1,-1, 1, 1,-1, 2/  ! symmetry matrix
c     call intreshape0()
      call intreshape1()
      return
      end

      subroutine intreshape0()   ! initialization of reshape matrix s1 and s2
      real m2(6,6),m2i(6,6)
      real m3(6,6)
      real x(6),q0(6),q(6)
      common /csmtrm0/ s0(6,6)
      common /csmtrm1/ s1(6,6),s2(6,6)
c     s1,s2 : transformation matrix of edge vectors of small
c     OD for cluster models
c     first s2 should be apply for 6D edge vectors
c     and after projecting into internal space
c     s2 should be apply
c     they can be used as edge vectors under linear phason for cluster models
      real unt(6,6),s(6,6),s_3(6,6),s1_3(6,6)
      real b(6),v1(6),v2(6),xi(6),x_i(6,6),y_i(6,6),vi(6)
      call wtmtrxrf('s0=',s0,6,'(6f10.4)')
      call mtcpyr(s0,s1,6)
      call getm2(s0,m2)     ! m2=s0^2
      call wtmtrxrf('m2=',m2,6,'(6f10.4)')
      call mcpyr6(m2,m2i)
      call matinv6(m2i,b,0,det)
      call mcpyr6(m2i,s2)

      do i=1,6
         call getrowmtrxr(s1,vi,6,i) ! get i-th row
         call getqed(vi,qi)     ! get q-space component
         call zerov(qi,3)       ! remove external components
         call setrowmtrxr(qi,x_i,6,i)! set i-th row of x_i
c     call getqed(s1(1,i),x_i(1,i),6)  ! s1: symmetric matrix
c     call zerov(x_i(1,i),3)  ! remove external comp.
c     call wtvctrrf('x_i=',x_i(1,i),6,'(6f10.5)')
      end do      
      call trnsp6(x_i)            ! EQ. (5)
      call mtmplr(m2i,x_i,y_i,6)  ! Eq. (7)
      do i=1,6
         call getrowmtrxr(y_i,q,6,i)
         call wtvctrrf('y_i=',q,6,'(6f10.5)')         
      end do
c  *******  for check ******      
c      call getsmtrx(s)
c      call mtcube6(s,s_3)
c      call sclmtrx(s_3,0.125,6)
c      call matinv6(s_3,b,0,det)      
c      call wtmtrxrf('s_3=',s_3,6,'(6f10.4)')      
c      call mtcube6(s1,s1_3)
c      call wtmtrxrf('s1_3=',s1_3,6,'(6f10.4)')      

c      call mtmplr(m2,m2i,unt,6)
c      call wtmtrxrf('m2i=',m2i,6,'(6f10.4)')      
c      call wtmtrxrf('unt2=',unt,6,'(6f10.4)')
c      call mtmplr(m2i,m1i,m3,6)
c      call wtmtrxrf('m3=',m3,6,'(6f10.4)')
c      do i=1,6
c         call getrowmtrxr(m3,x,6,i)
c         call wtvctrrf('x=',x,6,'(6f10.5)')
c         call getqed(x,q)
c         write(6,*) 'qe,qi=',vabs(q,3),vabs(q(4),3)
c      end do

c     stop
      return
      end

      subroutine intreshape1()   ! initialization of reshape matrix s1 and s2
      common /csmtrm2/ sresh(6,6)  ! reshape transformation matrix
      real m2(6,6),m2i(6,6),m20(6,6)
      real q(6),q0(6),y0(6),y(6)
      common /csmtrm0/ s0(6,6)
      real s1(6,6),s1_2(6,6)
      data tau3 /4.236067/  ! tau cube
      real vi(6),qi(6)
      real b(6),x_i(6,6),diag(6)
      call mtcpyr(s0,s1,6)
      call wtmtrxrf('s1=',s1,6,'(6f10.4)')
      do i=1,6
         call getrowmtrxr(s1,vi,6,i) ! get i-th row
         call getqed(vi,qi)     ! get q-space component
         call zerov(qi,3)       ! remove external components
         call setrowmtrxr(qi,x_i,6,i)! set i-th row of x_i
      end do      
      call wtmtrxrf('x_i=',x_i,6,'(6f10.5)')
      call trnsp6(x_i)
      write(6,*) 'after tronsposition'
      call wtmtrxrf('x_i=',x_i,6,'(6f10.5)')

      call mtmplr(s1,s1,m2i,6)
      call matinv6(m2i,b,0,det)
      call mtmplr(x_i,m2i,sresh,6)
      call wtmtrxrf('sresh=',sresh,6,'(6f10.4)')
c     for check
      call wtmtrxrf('m2i=',m2i,6,'(6f10.4)')
      do i=1,6
         call zerov(y,6)
         y(i)=1
         call reshape(y,q)
         call wtvctrrf('q =',q,6,'(6f10.4)')      
         write(6,*) 'vabs(q )=',vabs(q,6)
      end do
      return
      end

      subroutine getm2(s1,m2)  ! model dependent
      real s1(6,6),m2(6,6)
      call mtmplr(s1,s1,m2,6)
      return
      end
