c     programe threed
c     initialise vertex and facet counts.
      common /counts/ nov,ntv,nof,last
      nov=0
      nof=0
      last=0
c     constract and draw scene.
      call scene()
      stop
      end

      subroutine scene()
c     construct scene of one stellar body in setup position
      real s(4,4),t(4,4),u(4,4)
      common /eyepos/ ex,ey,ez,dx,dy,dz,q(4,4)
      common /ceps0/ eps0
      real*4 shiftx,shifty
      common /cdev/ ldev,shiftx,shifty,linw,klin,jcol

      ldev=1
      eps0=0.000001

      call plots(0.,0.,ldev)
      shiftx=10.
      shifty=15.
      call plot(shiftx,shifty,-3)

      call tran3(0.,0.,0.,s)
      call scale3(0.5,0.5,0.5,t)
      call mult3(s,t,u)
      call hollow(u)

      call tran3(0.,0.,0.,s)
      call scale3(1.,1.,1.,t)
      call mult3(s,t,u)
      call star(u,5.)

      write(6,*) ' type mode d and (dx,dy,dz)'
      read(5,*) mode,d,dx,dy,dz
      absd=sqrt(dx**2+dy**2+dz**2)
      dx=dx/absd
      dy=dy/absd
      dz=dz/absd
      ex=-dx*d
      ey=-dy*d
      ez=-dz*d
      call look3
      call observ
      if(mode.eq.0) then
         call drawit0
      else if(mode.eq.1) then
         call drawit1
      else 
         write(6,*) 'mode should be 0 or 1'
         stop
      end if
      call plote('end of plot')
      return
      end

      subroutine hollow(p1)
c     to place hollowed cube in actual position.
c     p1 is matrix that moves hollow cube into position.
c     p2 is matrix that moves each component prism into an actual
c     position which is setup for the hollow cube.
c     p=p1xp2 places component into actual position for final scene.
c
      real p(4,4),a(4,4),b(4,4),p1(4,4),p2(4,4)
      common /cubsto/ xc(8),yc(8),zc(8),ifc(6,4)

c     setup the 8 corner cubes.
      do i=1,8
c         write(6,'(a,3f10.5)') 'xc,yc,zc=', xc(i),yc(i),zc(i)
         call tran3(4*xc(i),4*yc(i),4*zc(i),p2)
         call mult3(p1,p2,p)
         call cube(p)
      end do
c      return
c     setup the 12 rectangular prisms which join corner cubes.
      do i=1,4
         call scale3(3.,1.,1.,a)
         call tran3(0.,4*yc(i),4*zc(i),b)
         call mult3(a,b,p2)
         call mult3(p1,p2,p)
         call cube(p)

         call scale3(1.,3.,1.,a)
         call tran3(4*yc(i),0.,4*zc(i),b)
         call mult3(a,b,p2)
         call mult3(p1,p2,p)
         call cube(p)

         call scale3(1.,1.,3.,a)
         call tran3(4*zc(i),4*yc(i),0.,b)
         call mult3(a,b,p2)
         call mult3(p1,p2,p)
         call cube(p)
      end do
      return
      end

      subroutine star(p,d)
c     stelar boky in actual position.
      parameter (maxv=400,maxf=400,maxif=2000)
      real p(4,4),xs(6),ys(6),zs(6)
      common /counts/ nov,ntv,nof,last
      common /actual/ xa(maxv),ya(maxv),za(maxv)
      common /atrib/ nfac(maxf),icol(maxf),nsup(maxf),lsup(maxf)
      common /facets/ istart(maxf),isiz(maxf),ifac(maxf)
      common /cubsto/ xc(8),yc(8),zc(8),ifc(6,4)
c     data for stellar points. must be scaled by d.
      data xs/ 1.,0.,0.,0.,0.,-1./
      data ys/ 0.,1.,0.,0.,-1.,0./
      data zs/ 0.,0.,1.,-1.,0.,0./

c     for each side of a cube, update data base with 4 new facets.
      do i=1,6
c     go round the edges of each cube facet.
         iv1=ifc(i,4)+nov
         do j=1,4
            iv2=ifc(i,j)+nov
c     add a triangular facet to data base.
            nof=nof+1
            ifac(last+1)=iv1
            ifac(last+2)=iv2
            ifac(last+3)=nov+8+i
            istart(nof)=last
            isiz(nof)=3
            last=last+isiz(nof)
            icol(nof)=5
            nfac(nof)=nof
            nsup(nof)=0
            lsup(nof)=0
            iv1=iv2
         end do
      end do
c     update vertex data base with 8 cube corners in actual position.
      do i=1,8
         nov=nov+1
         xa(nov)=p(1,1)*xc(i)+p(1,2)*yc(i)+p(1,3)*zc(i)+p(1,4)
         ya(nov)=p(2,1)*xc(i)+p(2,2)*yc(i)+p(2,3)*zc(i)+p(2,4)
         za(nov)=p(3,1)*xc(i)+p(3,2)*yc(i)+p(3,3)*zc(i)+p(3,4)
      end do
c     update vertex data base with 6 stellar points in actual position.
      do i=1,6
         nov=nov+1
         xa(nov)=d*(p(1,1)*xs(i)+p(1,2)*ys(i)+p(1,3)*zs(i))+p(1,4)
         ya(nov)=d*(p(2,1)*xs(i)+p(2,2)*ys(i)+p(2,3)*zs(i))+p(2,4)
         za(nov)=d*(p(3,1)*xs(i)+p(3,2)*ys(i)+p(3,3)*zs(i))+p(3,4)
      end do
      return
      end

      subroutine vcpyr()
      return
      end

      subroutine vsub()
      return
      end

      subroutine quit()
      return
      end

      subroutine getrxyz()
      return
      end

      subroutine vinp()
      return
      end

      subroutine vcpyi()
      return
      end

      subroutine vrcpy()
      return
      end

