      subroutine savexyh(no,xy,h,n)
      real xy(*),h(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      ns(no)=n                  ! atom No.
      call vcpyr(xy,xs(1,no),3)
      call vcpyr(h,hs(1,no),6)
      ds(no)=xy(3)              ! depth
      return
      end

      subroutine getdt(dtd)
      real dtd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      call vcpyr(dt,dtd,nos)
      return
      end

      subroutine getds(dsd)
      real dsd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      call vcpyr(ds,dsd,nos)
      return
      end

      subroutine getxs(xsd)  ! 3D coordinates
      real xsd(3,*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      do i=1,nos
         call vcpyr(xs(1,i),xsd(1,i),3)
      end do
      return
      end

      subroutine getuixy(uixyd)  ! 3D u11,u22,u33,u23,u31,u12 in plotter system
      real uixyd(6,*)
      include 'qcstrc.inc'
      common /cifatm/ ifatms(nmax),vol(nmax),nss(nmax),hrs(6,nmax),
     *     dst(nmax),uixy(6,nmax)
      common /cnos/ nos
      real bixy(6),bixyp(6)
      real bijxy(3,3),bijxyp(3,3)
      do i=1,nos
c     call vcpyr(uixy(1,i),uixyd(1,i),6)
c         call wtvctrrf('uixy',uixy(1,i),6,'(6f10.5)')
         call getuixytobi(uixy(1,i),bixy) ! translate ui to bi
c         call wtvctrrf('bixy',bixy,6,'(6f10.5)')
         call getuitouij(bixy,bijxy) ! translate bi to bij
c         call wtmtrxrf('bijxy',bijxy,3,'(3f10.5)')

         call anisotplt(bijxy,bijxyp) ! uixy in plotter system

c         call wtmtrxrf('bijxyp',bijxyp,3,'(3f10.5)')
         call getuijtoui(bijxyp,bixyp) ! bi in q coordinate system
c         call wtvctrrf('bixyp',bixyp,6,'(6f10.5)')
         call getbitouixy(bixyp,uixyd(1,i)) ! ui in plotter system
c         call wtvctrrf('uixyd',uixyd(1,i),6,'(6f10.5)')
      end do
c     call wtmtrxrf('uixyd',uijxyd(1,1),3,'(3f10.5)')  ! for test
      return
      end

      subroutine gettrns(hsd)  ! translation vector
      real hsd(6,*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      do i=1,nos
         call vcpyr(hs(1,i),hsd(1,i),6)
      end do
      return
      end

      subroutine getms(msd)  ! color
      real msd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      call vcpyi(ms,msd,nos)
      return
      end

      subroutine getns(nsd)  ! symmetry operation number
      real nsd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      call vcpyi(ns,nsd,nos)
      return
      end

      integer function select(no,xy,h,icol,id,isl2,nsl2,imax,nl2)
      real xy(*),h(*)
      integer id
      integer isl2(imax+1,imax+1,*),nsl2(imax+1,*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /cnos/ nos
      real hr(6)
      common /cifatm/ ifatms(nmax),vol(nmax),nss(nmax),hrs(6,nmax),
     *     dst(nmax),uixy(6,nmax)
                                ! for distance
      integer getifatm,expnsic,getodn
      data eps /0.001/

      n=getodn()                ! OD number
c     write(6,*) 'getodn()=',getodn()
c      write(6,*) 'xy=',(xy(j),j=1,3)
      call getihik(xy,ih,ik)
c      write(6,*) 'ih,ik=',ih,ik
      select=0
      do ihk=1,nsl2(ih,ik)
         i=isl2(ih,ik,ihk)
c        write(6,*) 'i=',i
         if(id.eq.2) then       ! dimension 2
            if(abs(xs(1,i)-xy(1)).lt.eps.and.abs(xs(2,i)-xy(2)).lt.
     *           eps.and.n.eq.ns(i)) then
               return
            end if
         else                   ! dimension 3
            if(abs(xs(1,i)-xy(1)).lt.eps.and.abs(xs(2,i)-xy(2)).lt.
     *           eps.and.abs(xs(3,i)-xy(3)).lt.eps.and.n.eq.ns(i))
     *           then
               return
            end if
         end if
      end do
      select=1
      no=no+1
      ifatms(no)=getifatm()
      vol(no)=getvol()
      ms(no)=icol
      dst(no)=vabs(xy,3)        ! distance from some point
      call getnsic(ns1,ic)      ! current symmetry operator number and icent
      nss(no)=expnsic(ns1,ic)   ! symmetry operator number
      call geths(hr)            ! additional translation vector
      call vcpyr(hr,hrs(1,no),6) ! save translation vector
      call savexyh(no,xy,h,n)
      call getuixynr(n,uixy(1,no))  ! save rotated uixy
      nsl2(ih,ik)=nsl2(ih,ik)+1
      nn=nsl2(ih,ik)
      if(nn.le.nl2) then
         isl2(ih,ik,nn)=no
      else
         write(6,*) 'nn > nl2 : nn,nl2,ih,ik=',nn,nl2,ih,ik
         stop
      end if
      nos=no
      return
      end

      subroutine wtxyzbp(no,nsd)
      integer nsd(*)
      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      common /csave2/ ms(nmax),ns(nmax)
      common /csave3/ uixy(6,nmax),bexy(nmax)
      character*50 frmt1
      real pocc(3)
      integer getitempf
      itempf=getitempf()
      frmt1='(i5,i5,1x,12f10.5)'
      do ii=1,no
         i=nsd(ii)
         icol=ms(i)
         if(job.eq.1) then
            call getoccn(icol,pocc)
            if(itempf.eq.1) then
               write(6,frmt1) ii,icol,(xs(j,i),j=1,3),(uixy(j,i),j=1,6),
     *              (pocc(j),j=1,3)
               write(3,frmt1) ii,icol,(xs(j,i),j=1,3),(uixy(j,i),j=1,6),
     *              (pocc(j),j=1,3)
            else
               write(6,frmt1) ii,icol,(xs(j,i),j=1,3),
     *              (pocc(j),j=1,3)
               write(3,frmt1) ii,icol,(xs(j,i),j=1,3),
     *              (pocc(j),j=1,3)
            end if
         else
            write(6,frmt1) ii,ns(i),(xs(j,i),j=1,3)
            write(3,frmt1) ii,ns(i),(xs(j,i),j=1,3)
         end if
      end do
      return
      end

      subroutine rmvatm(xs1,ds1,hs1,ms1,ns1,no1,uixy1,
     *                  xs2,ds2,hs2,ms2,ns2,no2,uixy2,no)
      real xs1(3,*),xs2(3,*)
      real ds1(*),ds2(*)
      real hs1(6,*),hs2(6,*)
      real uixy1(6,*),uixy2(6,*)
      integer ms1(*),ms2(*),ns1(*),ns2(*)

      include 'qcstrc.inc'
      common /csave1/ dt(nmax),ds(nmax),xs(3,nmax),hs(6,nmax)
      common /csave2/ ms(nmax),ns(nmax)
      common /csave3/ uixy(6,nmax),bexy(nmax)
      common /cnpart/ ncp, npart(namax),iatm(0:namax,namax)
c     remove xs2 from xs1 and save into xs

      no=0
      do i=1,no1
         do j=1,no2
            if(ivcomp(xs1(1,i),xs2(1,j)).eq.1) then
               do k=1,ncp
                  if(ns1(i).eq.iatm(0,k)) then
                     do l=1,npart(k)
                        if(iatm(l,k).eq.ns2(j)) then
                           write(6,*) 'atom removed=',(xs1(m,i),m=1,3)
                           go to 100
                        end if
                     end do
                  end if
               end do
            end if
         end do
         no=no+1
         call vcpyr(xs1(1,i),xs(1,no),3)
         call vcpyr(ds1(i),ds(no),1)
         call vcpyr(hs1(1,i),hs(1,no),6)
         call vcpyr(uixy1(1,i),uixy(1,no),6)
         ms(no)=ms1(i)
         ns(no)=ns1(i)
 100     continue
      end do
      return
      end
