      subroutine getqi0(h,q)
      integer h(*)
      real q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+h(j)*dq(j,i)
         end do
      end do
      return
      end

      subroutine getqi(h,q)
      integer h(*)
      real q(*)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call getsys(isys)
      call getqi0(h,q)
      do i=1,6
         if(isys.le.2) then
            if(i.le.3) then
               q(i)=q(i)/al
            else
               q(i)=q(i)/am
            end if
         else
            if(i.le.2) then
               q(i)=q(i)/al
            else if(i.eq.3) then
               q(i)=q(i)/cl
            else if(i.le.5) then
               q(i)=q(i)/am
            else
               q(i)=0
            end if
         end if          
      end do
      return
      end

      subroutine getqid(h,q)
      integer h(*)
      real q(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)

      call getsys(isys)
      call getqi(h,qd)
c     phason distortion in reciprocal space
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+qd(j)*di(j,i)
         end do
      end do
      return
      end

      subroutine getqe0(h,q)
      real h(*),q(*)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+dr(i,j)*h(j)
         end do
      end do
      return
      end

      subroutine getqe(h,q)
      real h(*),q(*)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      call getsys(isys)
      call getqe0(h,q)
      do i=1,6
         if(isys.le.2) then
            if(i.le.3) then
               q(i)=q(i)*al
            else
               q(i)=q(i)*am
            end if
         else
            if(i.le.2) then
               q(i)=q(i)*al
            else if(i.eq.3) then
               q(i)=q(i)*cl
            else if(i.le.5) then 
               q(i)=q(i)*am
            else
               q(i)=0
            end if
         end if
      end do
      return
      end

      subroutine getqed(h,q)
      real h(*),q(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)

      call getsys(isys)
      call getqe(h,qd)
c     phason distortion in real space
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+de(i,j)*qd(j)
         end do
      end do
      return
      end

      subroutine getxe(q,x)
      real q(*),x(*)
      real qd(6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6

      call getsys(isys)
      do i=1,6
         if(isys.le.2) then
            if(i.le.3) then
               qd(i)=q(i)/al
            else
               qd(i)=q(i)/am
            end if
         else
            if(i.le.2) then
               qd(i)=q(i)/al
            else if(i.eq.3) then
               qd(i)=q(i)/cl
            else if(i.le.5) then
               qd(i)=q(i)/am
            else
               qd(i)=0
            end if
         end if
      end do
      do i=1,6
         x(i)=0.
         do j=1,6
            x(i)=x(i)+dq(i,j)*qd(j)
         end do
      end do
      return
      end


      subroutine seta(ald)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      al=ald
      return
      end

      subroutine geta(ald)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      ald=al
      return
      end

      subroutine setc(cld)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      cl=cld
      return
      end

      subroutine getc(cld)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      cld=cl
      return
      end

      subroutine setam(brv)
      character brv
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      if(brv.eq.'p'.or.brv.eq.'c') then
         am=1
      else if(brv.eq.'f'.or.brv.eq.'i'.or.brv.eq.'s') then
         am=2
      else
         call quit('strange brv')
      end if
      return
      end

      subroutine getam(amd)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      amd=am
      return
      end

      subroutine seteps(eps1d,eps2d,eps3d,eps4d,eps5d,eps6d)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      eps1=eps1d
      eps2=eps2d
      eps3=eps3d
      eps4=eps4d
      eps5=eps5d
      eps6=eps6d
      call getsys(isys)
      if(isys.le.2) then
          write(6,*) 'a=',al,
     *      '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *      ' eps5=',eps5,' eps6=',eps6
      else 
          write(6,*) ' a=',al,' c=',cl,
     *      '  eps1=',eps1,' eps2=',eps2,' eps3=',eps3,' eps4=',eps4,
     *      ' eps5=',eps5,' eps6=',eps6
      end if
      return
      end

      subroutine geteps(eps1d,eps2d,eps3d,eps4d,eps5d,eps6d)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      eps1d=eps1
      eps2d=eps2
      eps3d=eps3
      eps4d=eps4
      eps5d=eps5
      eps6d=eps6
      return
      end

      subroutine getabc(gab,abccos)
      real abccos(6),gab(3,3)
      abccos(1)=sqrt(gab(1,1))
      abccos(2)=sqrt(gab(2,2))
      abccos(3)=sqrt(gab(3,3))
      abccos(4)=gab(2,3)/(abccos(2)*abccos(3))
      abccos(5)=gab(1,3)/(abccos(1)*abccos(3))
      abccos(6)=gab(1,2)/(abccos(1)*abccos(2))
      return
      end

      subroutine gets2(s2)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
c      s2: 6*6 matrix  :   dg11*/da*,d11*/db*..  dg11*/d(cosa*)...
      real s2(6,6)
      do i=1,6
         do j=1,6
            s2(i,j)=0
         end do
      end do
      as=sqrt(gabn(1,1))
      bs=sqrt(gabn(2,2))
      cs=sqrt(gabn(3,3))
      cas=gabn(2,3)/(bs*cs)
      cbs=gabn(1,3)/(as*cs)
      ccs=gabn(1,2)/(as*bs)
      sas=sqrt(1-cas**2)
      sbs=sqrt(1-cbs**2)
      scs=sqrt(1-ccs**2)
      s2(1,1)=2*as
      s2(2,2)=2*bs
      s2(3,3)=2*cs
      s2(4,2)=cs*cas
      s2(4,3)=bs*cas
      s2(4,4)=bs*cs
      s2(5,1)=cs*cbs
      s2(5,3)=as*cbs
      s2(5,5)=as*cs
      s2(6,1)=bs*ccs
      s2(6,2)=as*ccs
      s2(6,6)=as*bs
      return
      end

      subroutine simtr(s1,m,n,sg)
      real s1(6,6),sg(6,6),wk(6,6)
c          s1*sg*s1t  s1t: transpose matrix of s1
c       n,m.le.6
c       s1: m by n matrix sg: n by n matrix
c       sg is replaced by s1*sg*s1t

      do i=1,m
         do j=1,n
            wk(i,j)=0
            do k=1,n
               wk(i,j)=wk(i,j)+s1(i,k)*sg(k,j)
            end do
         end do
      end do
c     wk: m by n matrix
      do i=1,m
         do j=1,m
            sg(i,j)=0
            do k=1,n
               sg(i,j)=sg(i,j)+wk(i,k)*s1(j,k)
            end do
         end do
      end do
      return
      end

      function vabsx(x,n)
      real x(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      vabsx=vabs1(x,n,gab)
      return
      end

      function vabsh(x,n)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      real x(*)
      vabsh=vabs1(x,n,gabn)
      return
      end

      function vabs1(x,n,gab)
      real x(*),gab(n,*)
      vabs1=0
      do i=1,n
         do j=1,n
            vabs1=vabs1+x(i)*gab(i,j)*x(j)
         end do
      end do
      vabs1=sqrt(vabs1)
      return
      end

      function vinp1(x,y,n,gab)
c*****inner product of x,y with metric tensor gab
      dimension x(*),y(*),gab(n,*)
      vinp1=0
      do i=1,n
         do j=1,n
            vinp1=vinp1+x(i)*gab(i,j)*y(j)
         end do
      end do
      return
      end

      subroutine getgij()
c     get metric tensor
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
c     common /extcr0/ a0,c0
      real bb(3),piv(3)
      integer ipiv(3),indx(3*2)
      real bx(3,6)
      call getsys(isys)
c      call geta(a0,am)
      call geta(a0)
      call getam(am)
      call getc(c0)
c      write(6,*) 'a0=',a0,'c0=',c0
      if(isys .le.2) then
         gabx(1,1)=a0
         gabx(1,2)=0.0
         gabx(1,3)=0.0
         gabx(2,1)=0.0
         gabx(2,2)=a0
         gabx(2,3)=0.0
         gabx(3,1)=0.0
         gabx(3,2)=0.0
         gabx(3,3)=a0
      else 
         gabx(1,1)=a0
         gabx(1,2)=0.0
         gabx(1,3)=0.0
         gabx(2,1)=0.0
         gabx(2,2)=a0
         gabx(2,3)=0.0
         gabx(3,1)=0.0
         gabx(3,2)=0.0
         gabx(3,3)=c0
      end if
      do i=1,3
         do j=1,3
            gaby(i,j)=gabx(i,j)
         end do
         write(6,*) (gaby(i,j),j=1,3) 
      end do
      call matinv(gaby,3,3,bb,0,det,ipiv,indx,piv)
      return
      end

      subroutine xxx(r)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      dimension rr(3),r(3)
      do i=1,3
         rr(i)=0.0
         do j=1,3
            rr(i)=rr(i)+gabx(i,j)*r(j)
         end do
      end do
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine yyy(r)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      dimension rr(3),r(3)
      do i=1,3
         rr(i)=0.0
         do j=1,3
            rr(i)=rr(i)+r(j)*gaby(j,i)
         end do
      end do
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      integer function iforthg(abccos) ! if orthogonal lattice 1 else 0
      real abccos(*)
      data eps /0.000001/
      iforthg=1
      if(abs(abccos(4)).ge.eps.or.abs(abccos(5)).ge.eps.or.
     *     abs(abccos(6)).ge.eps) then
         iforthg=0
      end if
      return
      end

      subroutine calgab(q1,q2,q3,gab)  ! calculation of metric tensor
      real q1(*),q2(*),q3(*),gab(3,3)
      gab(1,1)=vinpr(q1,q1,3)
      gab(2,2)=vinpr(q2,q2,3)
      gab(3,3)=vinpr(q3,q3,3)
      gab(1,2)=vinpr(q1,q2,3)
      gab(2,1)=vinpr(q1,q2,3)
      gab(2,3)=vinpr(q2,q3,3)
      gab(3,2)=vinpr(q2,q3,3)
      gab(3,1)=vinpr(q3,q1,3)
      gab(1,3)=vinpr(q3,q1,3)
c      write(6,'(a,3f8.4)') 'q1,q2,q3=',vabs(q1,3),vabs(q2,3),
c     *     vabs(q3,3)
c      write(6,'(a,9f8.4)') 'gab=',gab(1,1),gab(2,2),gab(3,3),
c     *     gab(2,3),gab(1,3),gab(1,2)
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
      data ntrc/1,2,32,1,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0.or.ltype.eq.1) then
         ntrc0=1
         ltyped=1
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc1(i,j)
            end do
         end do
      else if(ltype.eq.2) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc2(i,j)
            end do
         end do
      else if(ltype.eq.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc3(i,j)
            end do
         end do
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc3(i,j)
               end do
            end do
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         end if
      else if(ltype.eq.5) then
         ntrc0=2
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc5(i,j)
            end do
         end do
      end if
      return
      end

      subroutine gettrc1(ltype,trc0,ntrc0)
c      this is equivalent to gettrc but does not work in f2c
      real trc0(6,*)
      integer ntrc(5)
      real trc(6,32,5)
      data ntrc/1,2,32,1,2/
      data (trc(i,1,1),i=1,6) /6*0.0/
      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc(i,j,3),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc(i,1,4),i=1,6) /6*0.0/
      data ((trc(i,j,5),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0) then
         ntrc0=1
         ltyped=1
      else if(ltype.le.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
         end if
      else if(ltype.eq.5) then
c         ntrc0=ntrc(ltype)
         ntrc0=2
         ltyped=ltype
      end if
      do j=1,ntrc0
         do i=1,6
            trc0(i,j)=trc(i,j,ltyped)
         end do
      end do
      return
      end

      subroutine getltcs(ad,bd,cd,cosad,cosbd,coscd)
      common /cltprm/ as,bs,cs,cosas,cosbs,coscs
      ad=as
      bd=bs
      cd=cs
      cosad=cosas
      cosbd=cosbs
      coscd=coscs
      return
      end

      subroutine setltcs(ad,bd,cd,cosad,cosbd,coscd)
      common /cltprm/ as,bs,cs,cosas,cosbs,coscs
      as=ad
      bs=bd
      cs=cd
      cosas=cosad
      cosbs=cosbd
      coscs=coscd
      return
      end

      subroutine calu1(icase,as,bs,cs,cosas,cosbs,coscs,u1)
      real u1(3,3)  ! first 3x3 part of u matrix
      sinas=sqrt(1.-cosas**2)
      sinbs=sqrt(1.-cosbs**2)
      sincs=sqrt(1.-coscs**2)
      d=sqrt(1.0-cosas**2-cosbs**2-coscs**2+2.0*cosas*cosbs*coscs)
      if(icase.eq.1) then
         u1(1,1)=as
         u1(1,2)=0.0
         u1(1,3)=0.0
         u1(2,1)=bs*coscs
         u1(2,2)=bs*sincs
         u1(2,3)=0.0
         u1(3,1)=cs*cosbs
         u1(3,2)=cs*(cosas-cosbs*coscs)/sincs
         u1(3,3)=cs*d/sincs
      else if(icase.eq.2) then
         u1(2,2)=bs
         u1(2,3)=0.0
         u1(2,1)=0.0
         u1(3,2)=cs*cosas
         u1(3,3)=cs*sinas
         u1(3,1)=0.0
         u1(1,2)=as*coscs
         u1(1,3)=as*(cosbs-coscs*cosas)/sinas
         u1(1,1)=as*d/sinas
      else if(icase.eq.3) then
         u1(3,3)=cs
         u1(3,1)=0.0
         u1(3,2)=0.0
         u1(1,3)=as*cosbs
         u1(1,1)=as*sinbs
         u1(1,2)=0.0
         u1(2,3)=bs*cosas
         u1(2,1)=bs*(coscs-cosas*cosbs)/sinbs
         u1(2,2)=bs*d/sinbs
      else
         write(6,*) 'icase=',icase
         call quit('icase should be 1,2 or 3')
      end if
      return
      end

      subroutine getdr(drd)
      real drd(6,6)
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetd/ det
      call mcpyr6(dr,drd)
      return
      end

      subroutine setd()
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
      common /cisys/ isys

      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
c     common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6

      dimension ipv(6),ind(6,2),piv(6),b(6),dtmp(6,6)
      common /cgetd/ det
      save icount
      parameter (sr=0.894427191,ct=0.447213596)
      parameter (su=-sr,cu=-ct)
      parameter (c1=0.309016994,c2=-0.809016994)
      parameter (c3=-c2,c4=-c1)
      parameter (s1=0.951056516,s2=0.587785252)
      parameter (s3=-s2,s4=-s1)
      parameter (c1sr=c1*sr,c2sr=c2*sr,c3sr=c3*sr,c4sr=c4*sr)
      parameter (s1sr=s1*sr,s2sr=s2*sr,s3sr=s3*sr,s4sr=s4*sr)
      parameter (tau=1.618034,tav=-tau)
      parameter (sqr2=1.41421, sqr3=1.73205, tqr3=-sqr3)
      parameter (t1=0.70710678, t2=-0.70710678)
      parameter (u1=0.8660254, u2=-u1) 
      data  d0/ 0.,   0.,   1., 0.,   0.,   1.,
     *          c2sr, s2sr, ct, c4sr, s1sr, cu,
     *          c2sr, s3sr, ct, c4sr, s4sr, cu,
     *          c1sr, s4sr, ct, c3sr, s2sr, cu,
     *          sr,   0.,   ct, su,   0.,   cu,
     *          c1sr, s1sr, ct, c3sr, s3sr, cu/
c     for cubic and trigonal
      data  d1/ 1., tau,  0.,  tau, -1., 0.,
     *          tau, 0.,  1.,  -1,  0.,  tau,
     *          tau, 0., -1.,  -1., 0.,  tav,
     *          0.,  1., tav,   0., tau, 1.,
     *          -1., tau, 0.,  tav, -1., 0.,
     *          0.,  1., tau,   0., tau, -1./
c      for decagonal  (******reciprocal lattice*******)
      data d2/  c1, s1, 0., c2, s2, 0.,
     *          c2, s2, 0., c1, s4, 0.,
     *          c2, s3, 0., c1, s1, 0.,
     *          c1, s4, 0., c2, s3, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./       
c     for octagonal
      data d3/  1., 0., 0., 1., 0., 0.,
     *          t1, t1, 0., t2, t1, 0.,
     *          0., 1., 0., 0.,-1., 0.,
     *          t2, t1, 0., t1, t1, 0.,
     *          0., 0., 1., 0., 0., 0.,
     *          0., 0., 0., 0., 0., 1./
c     for dodecagonal
      data d4/  1., 0., 0., 1., 0., 0.,
     *          u1, 0.5, 0., u2, 0.5, 0.,
     *          0.5, u1, 0., 0.5, u2, 0.,
     *          0., 1.,  0., 0., 1.,  0.,
     *          0., 0.,  1., 0., 0.,  0.,
     *          0., 0.,  0., 0., 0.,  1./
      data icount /0/
      icount=icount+1
      if(icount.eq.1) then
c        initialize
         do i=1,6
            do j=1,6
               d0(i,j)=d0(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,6
               d1(i,j)=d1(i,j)/sqrt(1+tau**2)/2
            end do
         end do
         do i=1,6
            do j=1,4
               d2(i,j)=d2(i,j)/sqrt(5.)
            end do
         end do
         do i=1,6
            do j=1,4
               d3(i,j)=d3(i,j)/2
            end do
         end do
         do i=1,6
            do j=1,4
               d4(i,j)=d4(i,j)/sqrt(2.)
            end do
         end do
c     d4(i,j)=d4(i,j)/2
         call mtrnspr6(d0)
         call mtrnspr6(d1)
         call mtrnspr6(d2)
         call mtrnspr6(d3)
         call mtrnspr6(d4)
      end if
      if(isys.eq.1) then
          call mcpyr6(d0,dq)
      else if(isys.eq.2) then
          call mcpyr6(d1,dq)
      else if(isys.eq.3) then
          call mcpyr6(d2,dq)
      else if(isys.eq.4) then
          call mcpyr6(d3,dq)
      else if(isys.eq.5) then
          call mcpyr6(d4,dq)
      else
          call quit('wrong isys')
      end if
      call mcpyr6(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
c        orthogonality check
      if(icount.eq.1) then
         write(6,*) 'dr'
         do i=1,6
            write(6,'(6f9.5)') (dr(i,j),j=1,6)
         end do
         write(6,*) 'dq'
         do i=1,6
            write(6,'(6f9.5)') (dq(i,j),j=1,6)
         end do
         do i=1,6
            do j=1,6
               dtmp(i,j)=0
               do k=1,6
                  dtmp(i,j)=dtmp(i,j)+dq(i,k)*dr(k,j)
               end do
            end do
         end do
         write(6,*) 'dq*dr'
         do i=1,6
            write(6,'(6f9.5)') (dtmp(i,j),j=1,6)
         end do
      end if
      return
      end

      subroutine setdei()
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
c     common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6

      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3),
     *      amij4(3,3),amij5(3,3)
      common /cphonn/ bmij1(3,3)
      real fij1(3,3),fij2(3,3),fij3(3,3),fij4(3,3),fij5(3,3),fij6(3,3)
      real fij7(3,3),fij8(3,3)
      integer q50(6,6),q30(6,10),q20(6,15)
      integer q10d0(6),q2d0(6),qmd0(6)
      integer q8d1(6),q2d1(6),qmd1(6)
      integer q12d2(6),q2d2(6),qmd2(6)
      common /cprjax/ q5p(6,6),q3p(6,10),q2p(6,15),q10d(6),q2d(6),qmd(6)
      real ctoh(6,6),htoc(6,6),ded(6,6)
      dimension ipv(6),ind(6,2),piv(6),b(6)
      real wmij2(3,3),wmij3(3,3),wmij4(3,3)
      save icount
      data icount /0/
c     for pentagonal D5 and decagonal
      data fij1 /0,0,0,0,0,0,0,0,1/
      data fij2 /1,0,0,0,0,0,0,0,0/
      data fij3 /0,0,0,0,1,0,0,0,0/
c     for cubic T and trigonal 
      data fij4 /1,0,0,0,1,0,0,0,1/
      data fij5 /0,0,0,0,0,0,0,0,1/
      data fij6 /1,0,0,0,1,0,0,0,0/
c     for monoclinic distortion for dihedral quasicrystals
      data fij7 /0,0,0,1,0,0,0,0,0/
      data fij8 /0,1,0,0,0,0,0,0,0/
      data ctoh /0.0,     -0.816496, 0.816496, 0., 0., 0.,
     *           0.816496,-0.816496, 0.0,      0., 0., 0.,
     *           0.577350, 0.577350, 0.577350, 0., 0., 0.,
     *           0., 0., 0., 0.0,     -0.816496, 0.816496,
     *           0., 0., 0., 0.816496,-0.816496, 0.0,
     *           0., 0., 0., 0.577350, 0.577350, 0.577350/
      data q50/1,0,0,0,0,0,    ! 1
     *         0,1,0,0,0,0,    ! 2
     *         0,0,1,0,0,0,    ! 3
     *         0,0,0,1,0,0,    ! 4
     *         0,0,0,0,1,0,    ! 5
     *         0,0,0,0,0,1/    ! 6
      data q30/1,1,1,0,0,0,    ! 1
     *         1,0,1,1,0,0,    ! 2
     *         1,0,0,1,1,0,    ! 3
     *         1,0,0,0,1,1,    ! 4
     *         1,1,0,0,0,1,    ! 5  3-fold axis in cubic approximant
     *         0,1,1,0,-1,0,   ! 6
     *         0,0,1,1,0,-1,   ! 7
     *         0,-1,0,1,1,0,   ! 8
     *         0,0,-1,0,1,1,   ! 9
     *         0,1,0,-1,0,1/   ! 10
      data q20/1,1,0,0,0,0,    ! 1
     *         1,0,1,0,0,0,    ! 2
     *         1,0,0,1,0,0,    ! 3
     *         1,0,0,0,1,0,    ! 4  y-axis in cubic approximant
     *         1,0,0,0,0,1,    ! 5
     *         0,1,1,0,0,0,    ! 6  x-axis in cubic approximant
     *         0,0,1,1,0,0,    ! 7
     *         0,0,0,1,1,0,    ! 8
     *         0,0,0,0,1,1,    ! 9
     *         0,1,0,0,0,1,    ! 10
     *         0,1,0,0,-1,0,   ! 11
     *         0,0,1,0,0,-1,   ! 12
     *         0,-1,0,1,0,0,   ! 13
     *         0,0,-1,0,1,0,   ! 14  normal to 3-fold axis in cubic apprx.
     *         0,0,0,-1,0,1/   ! 15  z-axis in cubic approximant
      data q10d0 /0,0,0,0,1,0/
      data q2d0  /1,1,1,1,0,0/
      data qmd0  /1,0,0,-1,0,0/
      data q8d1 /0,0,0,0,1,0/
      data q2d1  /1,0,0,0,0,0/
      data qmd1  /1,1,0,0,0,0/
      data q12d2 /0,0,0,0,1,0/
      data q2d2  /1,0,0,0,0,0/
      data qmd2  /1,1,0,0,0,0/
      icount=icount+1
      call getsys(isys)
      if(icount.eq.1) then
         call mtrnspr6(ctoh)
         call mcpyr6(ctoh,htoc)
         call matinv(htoc,6,6,b,0,det,ipv,ind,piv)
         if(isys.le.2) then
            do i=1,6
               call getqi0(q50(1,i),q5p(1,i))
               call norml(q5p(1,i),3)
               call norml(q5p(4,i),3)
            end do
            do i=1,10
               call getqi0(q30(1,i),q3p(1,i))
               call norml(q3p(1,i),3)
               call norml(q3p(4,i),3)
            end do
            do i=1,15
               call getqi0(q20(1,i),q2p(1,i))
               call norml(q2p(1,i),3)
               call norml(q2p(4,i),3)
            end do
            if(isys.eq.3) then
               call getqi0(q10d0,q10d)
               call getqi0(qmd0,qmd)
               call getqi0(q2d0,q2d)
            else if(isys.eq.4) then
               call getqi0(q8d1,q10d)
               call getqi0(qmd1,qmd)
               call getqi0(q2d1,q2d)
            else if(isys.eq.5) then
               call getqi0(q12d2,q10d)
               call getqi0(qmd2,qmd)
               call getqi0(q2d2,q2d)
            end if

            call norml(q10d(1),3)
            call norml(q10d(4),3)
            call norml(qmd(1),3)
            call norml(qmd(4),3)
            call norml(q2d(1),3)
            call norml(q2d(4),3)
         end if
         if(isys.eq.1) then
c          Y. Ishii, Phys Rev. B39 (1989) 11862
c          D5 distortion
            call mcpy3(fij1,amij1)
            call mcpy3(fij2,amij2)
            call mcpy3(fij3,amij3)
            call mcpy3(fij7,amij4)
            call mcpy3(fij8,amij5)
            call mcpy3(fij1,bmij1)
         else if(isys.eq.2) then
c          T distortion  : eps1
            call mcpy3(fij4,amij1)
c          D3 phason distortion : eps2
            call mcpy3(fij5,amij2)
            call mcpy3(fij6,amij3)
c          D3 phonon distortion : eps6
            call mcpy3(fij5,bmij1)
         else if(isys.ge.3) then
c          orthorhombic phason strain
            call mcpy3(fij1,amij1)
            call mcpy3(fij2,amij2)
            call mcpy3(fij3,amij3)
            call mcpy3(fij7,amij4)
            call mcpy3(fij8,amij5)
            call mcpy3(fij1,bmij1)
         end if
         write(6,*) 'amij1='
         write(6,'(3f9.5)') ((amij1(i,j),j=1,3),i=1,3)
         write(6,*) 'amij2='
         write(6,'(3f9.5)') ((amij2(i,j),j=1,3),i=1,3)
         write(6,*) 'amij3='
         write(6,'(3f9.5)') ((amij3(i,j),j=1,3),i=1,3)
         write(6,*) 'amij4='
         write(6,'(3f9.5)') ((amij4(i,j),j=1,3),i=1,3)
         write(6,*) 'amij5='
         write(6,'(3f9.5)') ((amij5(i,j),j=1,3),i=1,3)
         write(6,*) 'bmij1='
         write(6,'(3f9.5)') ((bmij1(i,j),j=1,3),i=1,3)
c         if(isys.eq.2) then
c            call getwmij(amij2,wmij2,ctoh,htoc)
c            call getwmij(amij3,wmij3,ctoh,htoc)
c            call getwmij(bmij1,wmij4,ctoh,htoc)
c            write(6,*) 'amij2='
c            write(6,'(3f9.5)') ((wmij2(i,j),j=1,3),i=1,3)
c            write(6,*) 'amij3='
c            write(6,'(3f9.5)') ((wmij3(i,j),j=1,3),i=1,3)
c            write(6,*) 'bmij1='
c            write(6,'(3f9.5)') ((wmij4(i,j),j=1,3),i=1,3)
c         else
c            write(6,*) 'amij2='
c            write(6,'(3f9.5)') ((amij2(i,j),j=1,3),i=1,3)
c            write(6,*) 'amij3='
c            write(6,'(3f9.5)') ((amij3(i,j),j=1,3),i=1,3)
c            write(6,*) 'bmij1='
c            write(6,'(3f9.5)') ((bmij1(i,j),j=1,3),i=1,3)
c         end if
      end if
c      do i=1,6
c         do j=1,6
c            de(i,j)=0
c         end do
c      end do
      call zeromtrxr(de,6)
      do i=1,6
         de(i,i)=1
      end do
      call geteps(eps1,eps2,eps3,eps4,eps5,eps6)
      if(isys.eq.1) then
         do i=4,6
            do j=1,3
               de(i,j)=eps1*amij1(i-3,j)+eps2*amij2(i-3,j)+
     *                 eps3*amij3(i-3,j)+eps4*amij4(i-3,j)+
     *                 eps5*amij5(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps6*bmij1(i,j)
            end do
         end do
      else if(isys.eq.2) then
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)
            end do
         end do
c         do i=1,3
c            do j=1,3
c               de(i,j)=de(i,j)+eps6*bmij1(i,j)
c            end do
c         end do
c         call mtmpl(de,ctoh,ded)
c         call mtmpl(htoc,ded,de)
         do i=4,6
            do j=1,3
               de(i,j)=de(i,j)+eps1*amij1(i-3,j)
            end do
         end do         
      else
         do i=4,6
            do j=1,3
               de(i,j)=eps2*amij2(i-3,j)+eps3*amij3(i-3,j)+
     *                 eps4*amij4(i-3,j)+eps5*amij5(i-3,j)
            end do
         end do
         do i=1,3
            do j=1,3
               de(i,j)=de(i,j)+eps6*bmij1(i,j)
            end do
         end do
      end if
      call mcpyr6(de,di)
      call matinv(di,6,6,b,0,det,ipv,ind,piv)
      write(6,*) 'deformation matrix de'
      do i=1,6
         write(6,'(6f8.4)') (de(i,j),j=1,6)
      end do
      write(6,*) 'deformation matrix di'
      do i=1,6
         write(6,'(6f8.4)') (di(i,j),j=1,6)
      end do
      return
      end

      subroutine celltr(x,mode)
      real x(*)
      real xd(6),trm1(6,6),trm2(6,6),trm3(6,6),trm4(6,6)
      save trm1,trm2,trm3,trm4
c       for decagonal
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
c        for dodecagonal
      data trm3 /0, 1, 0,-1,0,0,
     *           2, 0, 1, 0,0,0,
     *           0, 1, 0, 2,0,0,
     *          -1, 0, 1, 0,0,0,
     *           0, 0, 0, 0,3,0,
     *           0, 0, 0, 0,0,3/
      data trm4 /0, 1, 0,-1,0,0,
     *           2, 0, 1, 0,0,0,
     *           0, 1, 0, 2,0,0,
     *          -1, 0, 1, 0,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
c      data trm3 /0, 2, 0,-1,0,0,
c     *           1, 0, 1, 0,0,0,
c     *           0, 1, 0, 1,0,0,
c     *          -1, 0, 2, 0,0,0,
c     *           0, 0, 0, 0,3,0,
c     *           0, 0, 0, 0,0,3/
c      data trm4 /0, 2, 0,-1,0,0,
c     *           1, 0, 1, 0,0,0,
c     *           0, 1, 0, 1,0,0,
c     *          -1, 0, 2, 0,0,0,
c     *           0, 0, 0, 0,1,0,
c     *           0, 0, 0, 0,0,1/
      call getsys(isys)
      if(isys.le.2) then
         do i=1,6
            x(i)=x(i)/2
         end do
      else if(isys.eq.3) then
         if(mode.eq.1) then
c           transformation of coordinates
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+trm1(i,j)*x(j)/5
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.-1) then
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+trm2(i,j)*x(j)
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.2) then
c           transformation of hkl indices
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+x(j)*trm2(j,i)
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.-2) then
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+x(j)*trm1(j,i)/5
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else
            call quit('invalid mode in celltr')
         end if
      else if(isys.eq.5) then
         if(mode.eq.1) then
c           transformation of coordinates
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+trm3(i,j)*x(j)/3
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.-1) then
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+trm4(i,j)*x(j)
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.2) then
c           transformation of hkl indices
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+x(j)*trm4(j,i)
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else if(mode.eq.-2) then
            do i=1,6
               xd(i)=0
               do j=1,6
                  xd(i)=xd(i)+x(j)*trm3(j,i)/3
               end do
            end do
            do i=1,6
               x(i)=xd(i)
            end do
         else
            call quit('invalid mode in celltr')
         end if
      end if
      return
      end

      integer function getisys()
      common /cisys/ isys
      getisys=isys
      return
      end            

      subroutine getsys(isysd)
      common /cisys/ isys
      isysd=isys
      return
      end            

      subroutine setsys(isysd)
      common /cisys/ isys
      isys=isysd
      return
      end            
