      subroutine  caluiv(ub,pt,ui,v,as,bs,cs,cosas,cosbs,coscs)
c     ub : ub matrix
c     pt : transformation matrix of d* necessary for decagonal 
c          superstructure and icosahedral f-centered lattice
c     ui  : phonon-phason matrix
c     v  : orientation matrix
c     as : lattice constant in reciprocal space
c     cs : lattice constant in reciprocal space
c     get approximate values for  phonon-phason matrix u
c     orientation matrix v and lattice constants as, cs from ub matrix
      real ub(6,3),ui(6,3),v(3,3),pt(6,6)
      real u1(3,3),uv(6,3),vd(3,3),ubd(6,3)
      real dq(6,6),dr(6,6)
      real b(3),piv(3)
      real ub1(3),ub2(3),ub3(3)
      integer ip(3),indx(6)
      real x(3),z(3),xc(3)
      data pi /3.141592/

      f=180.0/pi
      call getsys(isys)
      call getnvec(nvec)
c      write(6,*) 'isys=',isys,' ndm=',ndm
      call getdr(dr)  ! get transformation matrix M^-1

c      write(6,*) 'dr='
c      do i=1,6
c         write(6,'(6f10.5)') (dr(i,j),j=1,6)
c      end do

c      write(6,*) 'ub='
c      do i=1,6
c         write(6,'(6f10.5)') (ub(i,j),j=1,3)
c      end do

      if(isys.le.2.and.nvec.lt.6) then
c        estimate other vectors by rotation around d1*
         z(1)=ub(1,1)
         z(2)=ub(1,2)
         z(3)=ub(1,3)
         do i=1,6-nvec
            x(1)=ub(nvec,1) ! last vector
            x(2)=ub(nvec,2)
            x(3)=ub(nvec,3)
            deg=72.0*i
            call rotate(x,z,deg) ! rotation of x around z by deg
            do j=1,3
               ub(nvec+i,j)=x(j)
            end do
         end do
         nvec=6
         do i=2,5
            do j=1,3
               ub1(j)=ub(1,j)
               ub2(j)=ub(i,j)
               ub3(j)=ub(i+1,j)
            end do
         end do
         det=determ3(ub1,ub2,ub3)
         if(det.lt.0) then
            write(6,*) 'determinant for ',1,i,i+1,' negative'
            stop
         end if
      else if(isys.ge.3.and.nvec.lt.5) then
c        estimate other vectors by rotation around dnvec*
         ub(5,1)=ub(nvec,1)
         ub(5,2)=ub(nvec,2)
         ub(5,3)=ub(nvec,3)
         z(1)=ub(5,1)
         z(2)=ub(5,2)
         z(3)=ub(5,3)
         if(isys.eq.3) then
            deg0=72.0
         else if(isys.eq.4) then
            deg0=45.0
         else if(isys.eq.5) then
            deg0=30.0
         end if
         do i=1,5-nvec
            x(1)=ub(nvec-1,1)
            x(2)=ub(nvec-1,2)
            x(3)=ub(nvec-1,3)
            deg=deg0*i
            call rotate(x,z,deg) ! rotation of x around z by deg
            do j=1,3
               ub(nvec+i-1,j)=x(j)
            end do
         end do
         nvec=5
         do i=1,3
            do j=1,3
               ub1(j)=ub(i,j)
               ub2(j)=ub(i+1,j)
               ub3(j)=ub(5,j)
            end do
         end do
         det=determ3(ub1,ub2,ub3)
         if(det.lt.0) then
            write(6,*) 'determinant for ',i,i+1,5,' negative'
            stop
         end if
      end if

      call mcpymn(ub,ubd,6,3)
      call mtmltijk(pt,ubd,ub,6,6,3)

      do i=1,nvec
         do j=1,3
            uv(i,j)=0
            do k=1,nvec
               uv(i,j)=uv(i,j)+dr(i,k)*ub(k,j)
            end do
         end do
      end do

      do i=nvec+1,6
         do j=1,3
            uv(i,j)=0
         end do
      end do
      
c      write(6,*) 'uv='
c      do i=1,6
c         write(6,*) (uv(i,j),j=1,3)
c      end do

c
c     uv in ideal quasicrystal and ideal orientation
c        as 0  0         as 0  0 
c        0  as 0         0  as 0
c        0  0  as        0  0  cs
c        0  0  0         0  0  0
c        0  0  0         0  0  0
c        0  0  0         0  0  0
c      orientation matrix symmetrize the first 3x3 part of ui
c      Euler angles are obtained from orientation matrix
c      
c      since cosas, cosbs, coscs is nearly zero  ui will be given as follows


      as=sqrt(uv(1,1)**2+uv(1,2)**2+uv(1,3)**2)
      bs=sqrt(uv(2,1)**2+uv(2,2)**2+uv(2,3)**2)
      cs=sqrt(uv(3,1)**2+uv(3,2)**2+uv(3,3)**2)
      coscs=(uv(1,1)*uv(2,1)+uv(1,2)*uv(2,2)+uv(1,3)*uv(2,3))/as/bs
      cosas=(uv(2,1)*uv(3,1)+uv(2,2)*uv(3,2)+uv(2,3)*uv(3,3))/bs/cs
      cosbs=(uv(3,1)*uv(1,1)+uv(3,2)*uv(1,2)+uv(3,3)*uv(1,3))/cs/as
      sinas=sqrt(1-cosas**2)
      sinbs=sqrt(1-cosbs**2)
      sincs=sqrt(1-coscs**2)


c      write(6,*) 'a*=',as
c      write(6,*) 'b*=',bs
c      write(6,*) 'c*=',cs
c      write(6,*) 'alpha*=',acos(cosas)*f,' cosa*=',cosas
c      write(6,*) 'beta* =',acos(cosbs)*f,' cosb*=',cosbs
c      write(6,*) 'gamma*=',acos(coscs)*f,' cosc*=',coscs

      call calu1(1,as,bs,cs,cosas,cosbs,coscs,u1)

c      write(6,*) 'u1='
c      do i=1,3
c         write(6,*) (u1(i,j),j=1,3)
c      end do

c     get orientation matrix v
      call calv(u1,uv,v)        ! v=u1^(-1)uv  orientation matrix

c      write(6,*) 'uv='
c      do i=1,6
c         write(6,*) (uv(i,j),j=1,3)
c      end do

c      write(6,*) 'v='
c      do i=1,3
c         write(6,*) (v(i,j),j=1,3)
c      end do

c     get ui matrix
      call mcpyr3(v,vd)
      call matinv(vd,3,3,b,0,det,ip,indx,piv)

c      write(6,*) 'vd='
c      do i=1,3
c        write(6,*) (vd(i,j),j=1,3)
c      end do

      do i=1,6
         do j=1,3
            ui(i,j)=0
            do k=1,3
               ui(i,j)=ui(i,j)+uv(i,k)*vd(k,j)
            end do
         end do
      end do

      call setnvec(nvec)
c      write(6,*) 'ui='
c      do i=1,6
c         write(6,*) (ui(i,j),j=1,3)
c      end do
      return
      end

      subroutine calv(u1,ub,v)
      real u1(3,3),ub(6,3),v(3,3)
      real vd(3,3),b(3),piv(3)
      integer ip(3),indx(6)
      call matinv(u1,3,3,b,0,det,ip,indx,piv)
      if(det.lt.0) then
         write(6,*) 'determinant of 3x3 part of ub matrix is negative'
         write(6,*) 'change the direction of one axis'
         stop
      end if
      do i=1,3
         do j=1,3
            vd(i,j)=ub(i,j)
         end do
      end do
      call mtmlt(u1,vd,v,3)
      return
      end

      subroutine seteuang1(euang)
      real euang(3)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call vcpyr(euang,euang1,3)
      return
      end

      subroutine geteuang1(euang)
      real euang(3)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call vcpyr(euang1,euang,3)
      return
      end

      subroutine caleuang(v,euang)
      real v(3,3),euang(3)
      real vd(3,3)
      real pm(2)
      data pm /1.,-1./
      data pi /3.14159265/

      theta=acos(v(3,3))        ! v(3,3)= cos(theta)
      phi=atan3(v(3,1),-v(3,2)) ! v(3,1)= sin(theta)sin(phi)
                                ! v(3,2)=-sin(theta)cos(phi)
      psi=atan3(v(1,3),v(2,3))  ! v(1,3)= sin(psi)sin(theta)
                                ! v(2,3)= cos(psi)sin(theta)
      f=180/pi
      do i=1,2
         do j=1,2
            do k=1,2
               call setomtr(phi*pm(i),theta*pm(j),psi*pm(k),vd)
               if(iomtrx(v,vd).eq.1) then
                  euang(1)=phi
                  euang(2)=theta
                  euang(3)=psi
                  return
               end if
            end do
         end do
      end do
      write(6,*) 'left hand oordinate system ?'
      call quit('can not determin orientation matrix')
      return
      end

      function iomtrx(o1,o2)
      real o1(3,3),o2(3,3)
c     data eps /0.0001/
      data eps /0.001/
      iomtrx=0
      do i=1,3
         do j=1,3
            if(abs(o1(i,j)-o2(i,j)).gt.eps) return
         end do
      end do
      iomtrx=1
      return
      end
