      subroutine pnf(ids,ijnlc,ny,pf1,pf2,pf3,ij,m,delt)
                                ! penalty functions and their derivatives
      real m(*),delt(*)
      include 'qcdiff.inc'
      real md, deltd   ! normal matrix and vector for each data set
      common /cnmmtrx/ md(nxprm*(nxprm+1)/2),deltd(nxprm)
      common /cpnf/ grad1,grad2,grad3,bmin
      common /cpnf2/ ipnf1,ipnf2,ipnf3
      integer ips(0:nxprm)
      call getips(ips,ny)
      write(6,*) '**** ipnf1,ipnf2,ipnf3=',ipnf1,ipnf2,ipnf3
c     write(6,*) 'ny in pnf=',ny
      call resetmd(md,deltd,ijnlc)
      if(ipnf1 .ge. 1) then
         call pnf1(pf1,deltd,md,ips,ny)
      else
         pf1=0
      end if
      if(ipnf2 .eq. 1) then
         call pnf2(pf2,deltd,md,ips,ny)
      else
         pf2=0
      end if
      if(ipnf3 .eq. 1) then
         call pnf3(pf3,deltd,md,ips,ny)
      else
         pf3=0
      end if
      if(ipnf1 .eq. 1.or.ipnf2 .eq. 1.or.ipnf3 .eq. 1) then
         id0=0
         nlc0=0
         call insert(deltd,md,delt,m,id0,ij) ! id=0 for penalty function
      end if
      return
      end

c     penalty function for temperature factors
      subroutine pnf3(f3,g,m,ips,ny)
      real g(*),m(*)
      integer ips(0:*)
      include 'qcdiff.inc'
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cpnf/ grad1,grad2,grad3,bmin
      real dbdx
      real bea,bec
      integer getna,getitempfi
      na=getna()
c***********************************************************************
c      f3: value of the penalty function
c      m: the normal matrix
c      g: the right hand side of the normal equation
c***********************************************************************

c     penalty function for be,b1,bi,u11,u22,u33
      f3=0.
      do jk=1,na
         if(getitempfi(jk).eq.0) then
            fc=1
            f3=f3+getf3(be(jk),4,4,jk,ny,ips,g,m,fc) ! for be
            bia=be(jk)+b1(jk)
            f3=f3+getf3(bia,4,5,jk,ny,ips,g,m,fc) ! for be+b1
            f3=f3+getf3(bi(jk),6,6,jk,ny,ips,g,m,fc) ! for bi
         else
c     b0=bi(jk)-bmin
c     f3=f3+getf3(b0,6,6,jk,ny,ips,g,m) ! for bi
            fc1=getebt(1,jk)
            fc2=getebt(2,jk)
            fc3=getebt(3,jk)
            ob1=ui(1,jk)*fc1-bmin ! offset bmin
            ob2=ui(2,jk)*fc2-bmin ! offset bmin
            ob3=ui(3,jk)*fc3-bmin ! offset bmin
c           write(6,*) 'ob1,ob2,ob3=',ob1,ob2,ob3
            f3=f3+getf3(ob1,13,13,jk,ny,ips,g,m,fc1) ! for u11
            f3=f3+getf3(ob2,14,14,jk,ny,ips,g,m,fc2) ! for u22
            f3=f3+getf3(ob3,15,15,jk,ny,ips,g,m,fc3) ! for u33
         end if
      end do
      f3=sqrt(f3)
c     write(6,*) 'f3=',f3
      return
      end

      function getwghtb(jk)
      common /cpnf/ grad1,grad2,grad3,bmin
      integer getna
      na=getna()
      getwghtb=grad3/na
      return

c      if(getitempfi(jk).eq.0) then
c         getwghtb=grad3/na
c      else
c         wghtb=grad3/na
c        getwghtb=(8*pi**2)*grad3/na
c      end if
c     write(6,*) 'jk,wghtb',jk,wghtb
      return
      end

      function getf3(bea,is1,is2,jk,ny,ips,g,m,fc)   ! penalty function for temp. fact.
      integer ips(0:*)
      real g(*),m(*)
      common /cpnf/ grad1,grad2,grad3,bmin
      include 'qcdiff.inc'
      real gl(nxprm)
      integer getitempfi
      data pi /3.141592/
      call zerov(gl,ny)
      n0=0
      l=0
      wghtb=getwghtb(jk)
      gk=getgkb(bea,sgn)
      do ld=1,ny
         dbdx=getdbdx(n0,l,ld,ips,jk,is1,is2)*fc
         call getgl1(gl,l,dbdx,sgn)
         call getgm(gk,gl,wghtb,g,m,l)
      end do
      getf3=gk*gk*wghtb
c     call wttangmtrxr('normal matrix',m,ny)  ! write trianguler matrix
      return
      end

      subroutine getgl1(gl,l,dpdx,sgn)
      real gl(*)
      if(l.gt.0) then
         gl(l)=dpdx*sgn
      end if
      return
      end

      function getdbdx(n0,l,ld,ips,jk,is1,is2)
      integer ips(0:*)
      include 'qcdiff.inc'
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      getdbdx=0
      dbdx=0
      if(ips(ld) .eq. 1) then
         l=l+1
         do k=1,jz(ld)
            nn=n0+k
            ii=ja(1,nn)
            jj=ja(2,nn)
            if(ii .eq. jk.and.jj .ge. is1.and.jj.le.is2) then
               dbdx=dbdx+ea(nn)
            end if
         end do
      end if
      n0=n0+jz(ld)
      getdbdx=dbdx
      return
      end

      function getgkb(bea,sgn)  ! bound one side
      getgkb=0
      if(bea .lt.0) then
         gk=(-bea)
         sgn=-1
      else
         gk=0
         sgn=0
      end if
      getgkb=gk
      return
      end

      subroutine getgm(gk,gl,wght,g,m,l)
      real gk,gl(*),g(*),m(*)
      common /cpnf/ grad1,grad2,grad3,bmin
      include 'qcdiff.inc'
      if(l .gt.0) then
         g(l)=g(l)-gl(l)*gk*wght
         do j=1,l
            jl=j+l*(l-1)/2
            m(jl)=m(jl)+gl(j)*gl(l)*wght
         end do
      end if
      return
      end

c     penalty function for chemical compositions
      subroutine pnf2(f2,g,m,ips,ny)
      real g(*),m(*)
      integer ips(0:*)
      include 'qcdiff.inc'
      common /cpnf/ grad1,grad2,grad3,bmin
      parameter (nemx=nemax*3)
      real gl(nxprm)
c***********************************************************************
c      f2: value of the penalty function
c      m: the normal matrix
c      g: the right hand side of the normal equation
c***********************************************************************
      f2=0.
      wght1=grad2/3
c     penalty function for chemical composition
      do n=1,3
        gk= getgkc(n,sgn)
**************atp/p****************
        call zerov(gl,ny)
         n0=0
         l=0
         do ld=1,ny
            call getgl2(gl,n,n0,l,ld,ips,7,1,sgn)
            call getgm(gk,gl,wght1,g,m,l)
         end do
**************atp/s1****************
         n0=0
         l=0
         do ld=1,ny
            call getgl2(gl,n,n0,l,ld,ips,8,2,sgn)
            call getgm(gk,gl,wght1,g,m,l)
         end do
**************atp/s2****************
         n0=0
         l=0
         do ld=1,ny
            call getgl2(gl,n,n0,l,ld,ips,9,3,sgn)
            call getgm(gk,gl,wght1,g,m,l)
         end do
         f2=f2+gk*gk*wght1
      end do
      f2=sqrt(f2)
      return
      end

      subroutine setatp0(atpd)
      real atpd(3)
      include 'qcdiff.inc'
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      call vcpyr(atpd,atp0,3)
      return
      end

      function getgkc(n,sgn)
      include 'qcdiff.inc'
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      if(atp(n)-atp0(n) .gt.0) then
         gk=atp(n)-atp0(n)
         sgn=1
      else if(atp(n)-atp0(n) .lt.0) then
         gk=atp0(n)-atp(n)
         sgn=-1
      else
         gk=0
         sgn=0
      end if
      getgkc=gk
      return
      end

      subroutine getgl2(gl,n,n0,l,ld,ips,is1,is2,sgn)
      real gl(*)
      integer ips(0:*)
      include 'qcdiff.inc'
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      if(ips(ld) .eq. 1) then
         l=l+1
         gl(l)=0
         do k=1,jz(ld)
            nn=n0+k
            ii=ja(1,nn)
            jj=ja(2,nn)
            if(jj .eq. is1) then
               gl(l)=gl(l)+datpdp(n,is2,ii)*ea(nn)*sgn
            end if
         end do
c        write(6,*) 'l,gl(l)=',l,gl(l)
      end if
      n0=n0+jz(ld)
      return
      end

c     penalty function for occupation probabilities
      subroutine pnf1(f1,g,m,ips,ny)
      real g(*),m(*)
      integer ips(0:*)
      include 'qcdiff.inc'
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      integer getna
      na=getna()
c      write(6,*) 'ny in pnf1=',ny
c***********************************************************************
c      f1: value of the penalty function
c      m: the normal matrix
c      g: the right hand side of the normal equation
c***********************************************************************
c     penalty function for p,s1,s2
      f1=0.
      do jk=1,na
         sgn0=calcsgn0(jk)
         call setsgn0(sgn0)
         f1=f1+getf1(p(jk),7,7,jk,ny,ips,g,m) ! penalty function for p
         call setsgn0(1.0)
         f1=f1+getf1(s(1,jk),8,8,jk,ny,ips,g,m) ! penalty function for s1
         f1=f1+getf1(s(2,jk),9,9,jk,ny,ips,g,m) ! penalty function for s2
         f1=f1+getf1(s(1,jk)+s(2,jk),8,9,jk,ny,ips,g,m) ! penalty function for s1+s2
      end do
      f1=sqrt(f1)
      return
      end

      function calcsgn0(jk)
      include 'qcdiff.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      if(p0(jk).ne.0) then
         calcsgn0=sign(1.,p0(jk))
      else
         calcsgn0=1.
      end if
      return
      end

      subroutine setsgn0(sgn0)
      common /sgn0/ sgn0d
      sgn0d=sgn0
      return
      end

      function getsgn0()
      common /sgn0/ sgn0d
      getsgn0=sgn0d
      return
      end
      
      function getf1(pors,is1,is2,jk,ny,ips,g,m)   ! penalty function for 
      integer ips(0:*)
      real g(*),m(*)
      common /cpnf/ grad1,grad2,grad3,bmin
      include 'qcdiff.inc'
      real gl(nxprm)
      integer getna
      na=getna()
c      write(6,*) 'ny in getf1=',ny
      sgn0=getsgn0()
      wghtp=grad1/na
      n0=0
      l=0
      call zerov(gl,ny)
      gk=getgkp(pors,sgn0,sgn)
c     write(6,*) 'gk,sgn0,sgn,wght',gk,sgn0,sgn,wghtp
      do ld=1,ny
         dpdx=getdpdx(n0,l,ld,ips,jk,is1,is2)
         call getgl1(gl,l,dpdx,sgn)
         call getgm(gk,gl,wghtp,g,m,l)
      end do
      getf1=gk*gk*wghtp
c     call wttangmtrxr('normal matrix',m,ny)  ! write trianguler matrix
      return
      end

      function getgkp(p,sgn0,sgn)   ! bound both sides
      if(p*sgn0.lt.0) then
         gk=(-p*sgn0)
         sgn=-1
      else if(p*sgn0.gt.1) then
         gk=(p*sgn0-1)
         sgn=1
      else
         gk=0
         sgn=0
      end if
      getgkp=gk
      return
      end

      function getdpdx(n0,l,ld,ips,jk,is1,is2)
      integer ips(0:*)
      getdpdx=getdbdx(n0,l,ld,ips,jk,is1,is2)
      return
      end

