c
c
c              A program for QUASicrystal Elementary Refiniment
c                                QUASER91
c
c                copyright (c) Dec. 1991  by Akiji Yamamoto
c
c                       input data instruction
c
c  *************************Notice****************************
c
c    the site symmetry of each atom is calculated by using
c        x0, u1, u2, u3, v in (4) without using parameters
c                    z given in (12)
c
c  **********************************************************
c
c        ******data for simulation are inserted here******
c        (00) job,ids,mthd,...,isys,ihkg,hmax
c             job : 0 refinement
c                   1 simulation 
c                   2 plot experimantal data
c             ids : number of data sets for ofserved intensity
c                *****ids<=2 in the present version*****
c             mthd: 0 powder,
c                   1 single crystal for the first and second
c                         (if any) data sets
c             isys: 1:icosahedral 2: icosahedral
c                   3:decagonal 4:octagonal, 5: dodecagonal
c                (1: icosahedral with pentaglnal phason distortion)
c                (2: icosahedral with cubic phason distortion)
c           ihkg: generate hkl for ihkg=1 else read from hkl file
c           hmax: maximum indices for generating hkl

c          ***********************************************
c                     for powder method
c          ***********************************************
c          ****if(mthd = 1) skip (01)-(020)***************
c        if mthd=0 for both data sets repeat (01)-(015) twice
c        (01) ih: preferred orientation axis hkl
c        (02) xray,backgr,wavl
c                xray=mo,ag,cu,ni,co,fe,cr,tn or tf
c                 ****tn: thermal neutron or syncrotron xray****
c                 ****tf: time of flight neutron*****
c                backgr=0,1 for Legendre and Legendre+amorphous compo.
c             if xray=tn,  wavl    (wave length of neutron)
c        (03)    qmin,qmax,qint,istep,nrange,ixax,iyax,ilp,rmaxi,nst,alpha :
c                qmin,qmax: minimum and maximum 2-theta angle (deg)
c                        for xray=  mo,ag,cu,ni,co,fe,cr,tn
c                or (diffraction vector)*2*pi (inverse angstrome)
c                        for xray=tf (see 01)
c                qint: interval of observed data
c                         (degree or inverse angstrome)
c             *****qint is meaningless for xray=tf and job=0****
c                istep: read input intensity with the step of istep
c                nrange: number of used ranges : 0 means all the range
c                        (0<=nrange<=nrmax=20)
c                ixax: 1 x-axis=2-theta 0: xaxis=2*pi*q (q:diffraction vector)
c                iyax: 1 linear scale 2 log scale for y-axis
c                ilp : 0 no lp-correction for hkl generation in single 
c                                                 crystal method
c                      1 lp-correction for diffractometer
c                     -1 lp-correction for diffractometer
c                        with auto-divergence slit (G=sin(theta))
c                      2 lpg-correction for Guinier diffractometer
c                      3 lpg-correction for KEK SOR diffractometer (Toraya)
c                      4 lp-correction for thermal neutron (no polarization)
c                rmaxi:  maximum radius of diffraction vector in vi
c                         default 1   (rmaxi<=1)
c                nst  :  order of similarity transformation for generating
c                        hkl indices
c                alpha: incident angle for ilp=3
c                    (default -1 for icosahrdral f and i lattice)
c                    (default -2 for decagonal lattice)
c               ******  if(nrange.ne.0) *******
c        (04)               (usrmn,usrmx)
c                usrmn: beginning of used range in degree (default qmin)
c                usrmx: end of used range in degree       (default qmax)
c                 *****repeat (031) nrange times****
c        (05)    thbm, fi
c                thbm: bragg angle of monochrometor (deg)
c                fi  : angle between the normal to the specimen
c                      plane and the primary beam in Guinier method (deg)
c        (06)    lenx,leny,vscl,delta
c                lenx, leny: length of x and y axes
c                vscl: vertical scale
c                delta: interval of x axis scale
c        (07)   pb: scale and background parameters (pb(0)-pb(12))
c         if xray .ne. tf
c           (08)  as: asymmetry parameter
c           (09)  uv: u and v of the theta dependence of hwhm
c                  effective hwhm (1 or 2) is
c                  hwhm*sqr(u*(tan(theta)-w)**2+v*(tan(theta)-w)+1)
c           (010)   gamma : ratio of gauss components
c           (011)   hwhm (half width at half maximum) of gauss and
c                   lorentz functions and their changes proportional
c                   to q-perp
c         else if xray .eq. tf
c           (08)  sij  (s11,s12,s21,s22,)
c           (09)  gij  (g11,g12,g13,g2)
c           (010)  ri   (r1,r2)
c        (012)  pg    : extinction parameter
c        (013)  sgm :absorption corrction parameter
c              (assuming transmission geometry for Guinier
c               and cylinder for thermal neutron or syncrotron X-ray)
c                    ***** for the latter sgm=mu*R ****
c               for ilp != 2, or 3, absorption correction is neglected
c        (014)   prefered orientation parameters p1,p2
c        if xray .ne. tf
c            (015)  zps,c1
c                   zsp : zero point shift
c                   c1  : factor for wave length
c                         this is necessary for combined use of
c                         x-ray and neutron etc because of
c                         the slight deviation of wave length
c                         from the given value 
c        else
c            (015)  c0,c1,c2
c                   c0 : zero point shift for q
c                   c1 : factor for 1
c                   c2 : non linear correction for q
c                   calculated q is c0+c1*q+c2*q**2
c
c        (015') bia  : overall bi
c        (016)   flnm0: input io data file name   (a)
c                        ****file format****
c                    intensity         (f12.6) for X-ray
c                    intensity 2-theta (2f12.6) for thermal neutron
c                    intensity Q       (2f12.6) for TOF neutron
c
c        (017) lgr : m35,10/mmm,-5m,8/mmm,12/mmm
c                laue group (number of equivalent positions)
c              m35(120),10/mmm(40),-5m(20),8/mmm(32),12/mmm
c                       10/m is not included yet
c
c              for P-10m2=P-102m lgr=10/mmm, for 5m lgr=-5m etc.
c
c        (018)  riccut
c              riccut: if I/Imax < riccut, it is dropped in the calculation
c                                         of the powder pattern
c                         (default 0.001)
c        (018)   ldev  1: BW 2: color
c        (019)   nlp: (number of lattice parameters <=4)
c        (020)   constraint condition for lattice parameters
c                i,cf,ic,[i,cf,ic.....]  (5(i2,f9.5,a1))
c                i=1: a i=2: c i=3: eps1 i=4:eps2 
c                i=5: eps3, i=6: eps4, i=7: eps5, i=8: eps6 
c               ****** repeat (020) nlp times ******
c         ****(01)-(020) are needed only when methd=0 (powder method)***
c
c          *******************************************
c          ****** for the single crystal method*******
c          *******************************************
c            ************skip (01)-(02) if ihkg=0**********
c        (01)    qmin,qmax,rmaxi,nst:
c                qmin,qmax: minimum and maximum 2-theta angle (deg)
c                        for xray=  mo,ag,cu,ni,co,fe,cr,tn
c                or (diffraction vector)*2*pi (inverse angstrome)
c                        for xray=tf (see 01)
c                rmaxi:  maximum radius of diffraction vector in vi
c                         default 1   (rmaxi<=1)
c                nst  :  order of similarity transformation for generating
c                        hkl indices
c             
c        (02) lgr : m35,10/mmm,-5m,8/mmm,12/mmm
c                laue group (number of equivalent positions)
c              m35(120),10/mmm(40),-5m(20),8/mmm(32),12/mmm
c                       10/m is not included yet
c
c              for P-10m2=P-102m lgr=10/mmm, for 5m lgr=-5m etc.
c
c            ************skip (03)-(04) if ihkg=1**********
c        (03) fnsig,fminc, wg0, nst, itrv, isext, imthd, mu
c          fnsig : fo > fnsig*sigma(f) is used in the refinement
c          fminc, wg0: abs(fc) < fmin  weight wg0 is used and asterisked
c                      asterisked reflections are removed in 
c                      conventional R factor calculations but
c                      are used in Rw factor calculations
c          nst : number of similarity transformations
c                nst < 0  ext. scale decrease
c                nst > 0  ext. scale increase
c          itrv   =0 for no transformation
c                  1 transform to the superstructure indexing in decagonal sys.
c          isext=1 or -1 secondary extinction correction for x-ray or neutron
c                   correlation function in the manual is used
c          isext=2 or -2 secondary extinction correction for x-ray or neutron
c                   for anisotropic extinction correction in dihedral cases
c     (isext=2 or -2 secondary extinction correction for x-ray or neutron)
c     (              correlation function in Kawamura and Kato (Acta Cryst.))
c                        A39 (1983) 305 is used
c          if isext !=0 then  specify imthd
c              imthd=0  4-circle diffractometer bisecting method
c              imthd=1  Weissenberg method 
c          mu  : mu angle for Weissenberg method (if imthd !=0)
c        (04) iorf format for h1,h2,.. aiobs,weight(or sig) and iavrg
c          iorf  0 aiobs=Iobs  1 aiobs=Fobs
c          iavrg 0 no average 1 averageing equivalent refl. after reading
c        (05)  scl, ads, (adsa), ama
c           scl : scale for number of syngle crystal data
c             ( if isext !=0 )
c           ads : extinction parameter                                *
c           adsa: anitotropic extinction parameter(only for isext=+-2)*
c           ama : extinction parameter                                *
c        (06) bia : overall bi
c        ************* if isext=0 skip (07)-(011)*************
c ***********data for absorption and extinction corrections*************
c *       the bisecting position (omega=0) is assumed                  *
c *        (busing et al. 1967, acta cryst. 22, 475.)                  *
c *     (07) nbf,mp,mq,mr,icm                                         *
c *        nbf: number of equations designating boundary conditions    *
c *           nbf = 1  ellipsoidal crystal                             *
c *              ellipsoidal crystals                                  *
c *              (x/aa)**2+(y/bb)**2+(z/cc)**2=ff**2     nbf=1         *
c *           nbf = -1 cylindorical crystal                            *
c *              (x/aa)**2+(y/bb)**2=ff**2  -cc <=z<=cc  nbf=-1        *
c *      polyhedral crystals                                           *
c *           nbf >=4  polyhedral crystal                              *
c *                 aa*x+bb*y+cc*z=ff                    nbf>=4        * 
c *       mp,mq,mr: number of divisions along x,y,z axes in integral   *
c *       icm: 0 ub matrix, 1 u matris or 2 itsu Euler angles (see 031)*
c *               ((cm(i,j),j=1,3),i=1,3)                              *
c *              (hx,hy,hz)=(h,k,l)*cm      ub matrix (icm=0)          *
c *               hx,hy,hz:  rectangular coordinates in instrument     *
c *                            system (in inverse angstrome)           *
c *               (hx,hy,hz)=(hx',hy',hz')*cm  u matrix (icm=1)        *
c *                hx',hy',hz': rectangular coordinates fixed in       *
c *                    a crystal (in inverse angstrome)                *
c *       euang1: Euler angle for crystal orien.  (icm=2)              *
c *             mp*mq*mr<=1000 ******related common variables          *
c *              common /extcr2/ ex,ey,ez,wxyz                         *
c *     (08)  aa,bb,cc,ff                                             *
c *      boundary cond.                                                *
c *              ellipsoidal crystals                                  *
c *              (x/aa)**2+(y/bb)**2+(z/cc)**2=ff**2     nbf=1         *
c *      cylindorical crystals                                         *
c *              (x/aa)**2+(y/bb)**2=ff**2  -cc <=z<=cc  nbf=-1        *
c *      polyhedral crystals                                           *
c *              or aa*x+bb*y+cc*z=ff                    nbf>=4        * 
c        *******************************************************
c *            (x,y,z in mm, and ff must be positive)                  *
c        *******************************************************
c *              repeat (27) by abs(nbf) times                         *
c *                                                                    *
c *     (09) wv,abc0,bth,amag,a0,c0                                   *
c *       wv: wave length in 10**-8 cm                                 *
c *       abc0: linear absorption coefficient in mm**-1                *
c *       bth: bragg angle for monochrometer in degree                 *
c *          (if monochrometer is not used  bth=0)                     *
c *       amag: magnification of calculated structure factors          *
c *       if(icm = 0) then                                             *
c *          a0,c0: lattice constants used for the data correction and *
c *              for the cell orientation matrix                       *
c *                                                                    *
c *     (010) cm (icm=0 or 1) or euang1 (icm=2)                        *
c *       cm:   cell orientation matrix     (ub or u matrix)           *
c *             cubic system with a0 is used for icosahedral           *
c *             tetragonal system with a0, c0 is used for polyhedral   *
c *             quasicrystals                                          *
c *             ((cm(i,j),j=1,3),i=1,3)                                *
c *          if(icm.eq.0)   cm : ub matrix                             *
c *                (hx,hy,hz)=(h,k,l)cm                                *
c *                where (h,k,l) are real indices of a reflection      *
c *                hx,hy,hz:  rectangular coord. in instrument system  *
c *               (phi-axis system in 4-circle) (in inverse angstrome) *
c *          if(icm.ne.1)  cm : u matrix                               *
c *               (hx,hy,hz)=(x,y,z)*cm                                *
c *               x,y,z: rectangular coordinates fixed in a crystal    *
c *               (in inverse angstrome)                               *
c *                 where z axis is parallel to z-axis                 *
c *                 y axis is in y-z plane and normal to hz' axis      *
c *                 x axis is normal to hz' and hy' axes               *
c *          if(icm.eq.3) euang1 : Euler angle making u matrix         *
c *              (euang1= phi, theta, psi in degree)                   *
c *                                                                    *
c *     (011) om                                                       *
c *       om: the transformation matrix from instrument system to      *
c *           the system describing the boundary conditions            *
c *              ((om(i,j),j=1,3),i=1,3)                               *
c *                                                                    *
c **********************************************************************
c         **********repeat (01-020) or (01-011) ids times*********

c        (022) flnm1:file name for hkl mpl file (for powder)
c         or
c        (012) flnm1 : file name for hkl-fo sigma file (for single crystal)
c           ***** repeat (022) or (012) ids times *****

c     (0) flnm2 : file name for parameter file
c
c     (0) inpm
c         inpm=0 separatel file (standard input, flnm3 and flnm4)
c             =1 standard input only
c     (1) title
c     (2) a,(c),eps1,eps2,eps3,eps4,eps5,eps6
c         a: lattice papameter
c         c: lattice papameter for 2-dimensional quasicrystal
c           eps1:  pentagonal phason distortion (isys=1)
c                  cubic phason distortion  (isys=2)
c           eps2: orthorhombic phason distortion 1 (1,1 element) (isys=1,3..)
c                 trigonal phason distortion (isys=2)
c           eps3: orthorhombic phason distortion 2 (2,2 element) (isys=1,3..)
c                 trigonal phason distortion 1 (isys=2)
c           eps4: monoclinic phason distortion 3 (1,2 element) (isys=1,3..)
c           eps5: monoclinic phason distortion 4 (2,1 element) (isys=1,3..)
c           eps6: phonon distortion (along z-axis isys=1,3..)
c                 trigonal phonon distortion 2 (isys=2)
c    ****trigonal phason eps2 and eps3 in isys=2 include cubic phason****
c    ****therefore eps1 should be fixed at zero in the trigonal case****
c             ****** the phason matrix used is
c                 obtained by fortran program lphason.f
c                 but this is the transpose of U in
c                 Acta Cryst A52 509 (1996)
c             ******************************************
c     (3) na, npod
c         na: number of atoms    (<=namax=160)
c         npod : number of predefined occupation domains  (<=namax=50)

c     ******** if inpm=1 skip (4) ******
c     (4) flnm3
c         flnm3 : filename which gives the following items
c     

c     ******** if inpm=0 skip (01)-(07) ******
c ######################.pod file################################
c     (01) nsymo,icent,brv,itwin
c         nsymo: number of generators in symmetry operations
c         icent: give 1 for centrosymmetryc
c                give 0 otherwise
c          brv : bravais lattce p, i, f, s, c
c                 s : superlattice for decagonal quasicrystal
c                 c : color symmetry for decagonal lattice with P_2c
c              ****** see (11) ******
c     (02) 'symmetry operator'        header  and
c     (03) symmetry operator in the format of I.T.
c             for example x,y,z,t,u,v; x+1/2,y,z+1/2,t,u,v etc.
c              ********    repeat (03) nsymo times
c          *****if itwin=0 skip (04)-(05)******
c     (04) 'twin operator' header and
c     (05) symmetry operator in the format of I.T.
c             for example x,y,z,t,u,v; x+1/2,y,z+1/2,t,u,v etc.
c     (04) n, nej0, itype, str
c         n    : serial number for the guide to the eye
c         nej0 :number of edge vectors for predefined occupation domain (<=nemax=5)
c         itype  :  1 domain with icosahedral, degagonal, octagonal or dodecagonal symmetry
c                   2 domain with other symmetry
c                  -1 domain with icosahedral, degagonal or octagonal symmetry for test
c                  -2 domain with other symmetry for test
c                    negative itype is faster than positive one but
c                    two calculations should give the same result (please test)
c         str  : string for comments
c     (05) ej  : edge vectors of their internal components or principal axes
c         ej(1)-ej(6)
c               repeat (05) ne times
c     (06) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a rhombus
c                           (for isys=3,4,5)
c     (07) iaslct(1-(nsymo+icent*nsymo)) (60i1)
c           flags for pseudo-site symmetry operator
c       ******** repeat (04)-(07) npod times

c     ******** if inpm=1 skip (5) ******
c     (5) flnm4
c         flnm4 : filename which gives the following items

c     ******** if inpm=0 skip (01)-(08) ******

c #####################.atm file###########################
c     (06) no,symb,ien,ish,ne,be,bi,rmin,rmax,p,s1,s2  (*)
c         no: atom number
c         symb: site symbol
c         ien: scattering facter table used
c         ish >0:  ish-th predefined occupation domain
c         for icosahedral case
c             ish=0 other polyhedron
c             ish=-1: ellipsoid
c             ish=-2: sphere   ( rmax: the radius of the sphere )
c         for dihedral case
c             ish=0 triangle
c             ish=-1: ellips
c             ish=-2: circle   ( rmax: the radius of the sphere )
c         ne : number of edge vectors for ish=0    (<=nemax=7)
c              number of principal axes (=2 or 3) for ish=1
c              consequtive three vectors are regarded as the edge vectors 
c              of a tetrahedron defining the occupation domain (ish=0)
c         be: isotropic temperature factor in external space
c         bi: isotropic temperature factor in internal space
c    ******     for decagonal case    *****
c         be: isotropic temperature factor in the plane normal to 10
c         bi: isotropic temperature factor in internal space
c    
c         ramin :  scale for unoccupied tetrahedron or rhombohedron
c         ramax :  scale for occupied tetrahedron or rhombohedron
c            if ish=2 ramax=1 means shere with radius of 1.4325 (ca)
c            (radius of the shere equivalent to unit triacontahedron
c                    creating the 3d penrose pattern)
c         p     : occupation probability
c         s1    : percentage of first component
c         s2    : percentage of second component
c         (** one site is assumed to be occupied by three atoms**)
c            ***************notice***************
c          the empty domain is the inverse of the occupied domain
c       ****** for colored atom give xi(6)=1 (normal color)
c                      or -1 (inverse color)********
c       ****** colored atom should be black (icol=0) or white (icol=10) ****
c       ******** colored symmetry is only available for polygonal cases ******
c     (07) x
c     (08) xe1, u1
c     (09) xe2, u2
c     (010) xe3, u3
c     (011) xi, v
c         x(1)-x(6): coordinate of atom in 5D (decag, octag) 6D (ico, dodec)
c         xe1(1)-xe1(6) etc. or xe1(1)-xe1(7) etc. (dodec only)
c              direction of the shift along the external space
c             in 6D (decag, octag, ico) and 7D (dodec) coordinate system
c              ********* these are normalized in the program ********
c           ********* so that u1, u2, u3 are shifts in angstrome ********
c         xi(1)-xi(6):  shift along the internal space
c              in 6D (decag, octag, ico) and 7D (dodec) coordinate system
c         u1,u2,u3,v: their amplitudes 
c     (012) isyd 
c              symmetry operator number for rotating small o.d.
c              defined in .pod file

c       ******** if ish > 0 or ish = -2 skip (013) (014) *****
c     (013) ej  : edge vectors of their internal components or principal axes
c         ej(1)-ej(6)
c               for ish=-1 radii for 3 principal axis is given by abs(ej)*rmax
c               repeat (07) ne times
c     (014) nth, (mej(1),mej(2),,),... nth times
c          nth: number of tetrahedra
c          mej: a triplet of vector numbers specifying a tetrahedron
c                           (for isys=1,2)
c          mej: a pair of vector numbers specifying a tetrahedron
c                           (for isys=3,4,5)
c            ******** repeat (06)-(014) na times
c #####################end of .atm file###########################

c
c     (6) ne,xorn,iand,inpd,iel, ..., atp
c         ne: number of atomic-scattering-factor tables
c         xorn: 'x' for X-ray 'n' for neutron
c         iand: give 1 when the anomalous dispersion correction is
c               made, otherwise give 0.
c         inpd: give 0 for atomic scattering table in a program 
c               give 1 when coefficients of 4-exponential-function
c                  approximation of the atomic scattering factors
c               give 2 for atomic scattering table is given
c         iel: three chemical species for the scattering fact. tbl.
c         atp: chemical composition of the sample (eg. 0.7 0.13 0.17 etc.)
c     (7) 'scattering factor'  (header)
c     (7') scattering factor given by
c          atom symbol like 'Na'    for inpd=0  ('Vc' for the vacancy)
c            **** if inpd=0 and iand=1 followed by f' and f" ****

c          (a(i),b(i),i=1,4),c  (*) for inpd=1 (4 Gaussian approximation)
c          (asct(i),i=1,35) (*)     for inpd=2 (table with interval of 0.05)
c
c  **********        if(iand=0 or inpd=0 skip (8)
c     (8) real and imaginary parts of anom. disp. cor.  (*)
c
c  ********    repeat (6)-(8) ne*ids times
c     (9)  itempf   : 0 for isotropic 1 for anisotropic temperature factor
c          for itempf=1
c          xe1,xe2,xe3 are used to describe anisotropic temperature factor
c          however if xe1 and xe2 are orthogonal then third axis orthogonal
c          to them are used neglecting specified xe3. in this case
c          zero vector xe3 can be specified if it is not necessary
c          as a shift vector
c               
c     (10) nx number of variable parameters
c     (11) z,jz,(ja1(j),ja2(j),ea(j),j=1,jz)
c          z  : independent parameter
c          jz : number of terms related with z
c          ja1: atom number
c          ja2: 1-12 : u1,u2,u3,be,b1,bi,p,s1,s2,v,ramin,ramax
c          ea : coefficient
c               u,v,etc. = z*ea
c           *******repeat (11) nx times********
c          ******** if job !=0 skip (12)-(14)*****
c     (12) iwf, fct  (if f table necessary, iwf=1 otherwise iwf=0
c             fct: magnification of f in the f table
c     (13) istdv icont ifunc iwght a1 a2 
c          istdv: =1 standard deviations are calculated
c                 =0 no standard deviations are calculated
c          icont: =1 parameters saved in disc are used
c                 =0 parameters specified in data cards are used
c                         time
c          ifunc: =1 sin cos exp functions are used
c                 =0 sin cos exp tables are used to save the computing
c
c             for single crystal method
c          iwght: =0 given weight is used for single crystal data
c                 =1 unit weignt is used  for single crystal data
c                 =2 weight=1/(sigmaf**2) is used for single crystal data
c                    provided that third column in (022) is sigma
c                 =3 weight=1/(sigmaf'**2) is used for single crystal data
c                    provided that third column in (022) is sigma
c                    and sigmaf'=sqrt(sigmaf**2+a1*F+(a2*f)**2)
c                a1 and a2 are the measur for minimum relative error
c                so that rough value of a1 and a2 will be 0.01 or so)
c           *********************
c           a1,a2    coefficients for sigmaf' (necessary only when iwght=3)
c           *********************
c             for powder method
c          iwght: =0 1/yo    is used for powder data (conventional weight)
c                 =1 1/yo**2 is used for powder data (proposed by Toraya)
c                 =2 1/yo**3 is used for powder data (proposed by Toraya)
c                  indices to different lattice constant coordinate system
c     (14) nrblk
c          nrblk: number of refinement blocks
c     (15) maxc eps dmpf aydm alph
c          maxc: maximum cycles of the least squars refinement (maxc>=0)
c          eps: if r factor difference < eps then stop
c          dmpf: damping factor (standard value is about 0.2)
c          aydm: cutoff radius of diffraction vector in angstrome**-1
c             (if aydm=0 default value aydm=5 is used)
c          alph: refinement minimizes modified weighted r-factor with
c               weight factor exp(-alph*(y/2)**2)*w, where y is the
c               reflection vector in the reciprocal space and w is the
c               weight factor specified by wght
c               alph=0: normal weight factor
c            ******* in the present version alph does not work ******
c     (16) ipnf1 ipnf2,ipnf3,ipreset,isreset
c          ipnf1: 1 for the use of penaltyfunction on p,s1,s2
c          ipnf2: 1 for the use of penaltyfunction on chemical composition
c          ipnf3: 1 for the use of penalty function on be, bi, b1
c          ipreset: 1 for resetting p at zero or 1 if
c                 it is less than 0.03 or greater than 0.97
c          isreset: 1 for resetting s1 and/or s2 at zero or 1 if
c                 they are less than 0.03 or greater than 0.97
c
c     (17) grad1,grad2,grad3
c          grad1, grad2, and/or grad3 if ipnf1, ipnf2 and/or ipnf3 is 1
c               ****** if itempf= skip (18) *****
c     (18) itempfi   (80i1)   (temperature factor selection for each OD)
c          0 for isotropic 1 for anisotropic temperature factors
c     (19) parameter selection flags for structural parameters (80i1)
c          if i-th parameter is refined, give 1 at i-th column
c          otherwise give 0
c     (20)  selection flags for scale, extinction parameters (mthd=1)
c              or profile parameters  (mthd=0) (80i1)
c***********repeat (15)-(18) nrblk times*********************
c
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      integer ih(6)
      common /cwflag/ iwflag(7)
      common /atomp2/ y(3,3)
      character*6 lgr
      integer hm,getiwg
      character*80 flnm0,flnm1,flnm2
      common /cquit/ startt
      integer hmax
      integer mthd(idsmax)
      integer getmthd
      data pi/3.141592/

c      startt=secnds(0.0)
      fact=pi/180
      iwflag(3)=1
      iwflag(4)=1
      iwflag(5)=1
      iwflag(6)=3
      call setinp(5)
      call setout(6)
c      read(5,*) job,ids,mthd
      call freadis('job=',1,job,1)
      call freadis('ids=',1,ids,0)
      call freadia('mthd=',ids,mthd,0)
      write(6,*) 'job=',job,' ids=',ids,' mthd=',(mthd(id),id=1,ids)
      do id=1,ids
         call setmthd(id,mthd(id))
      end do
      if(ids.gt.idsmax) call quit('ids > idsmax')
      call setnfil(ids)
      call freadis('isys=',1,isys,0)
      call freadis('ihkg=',1,ihkg,0)
      call freadis('hmax=',1,hmax,0)
      write(6,*) 'isys=',isys,' ihkg=',ihkg,' hmax=',hmax
      call setsys(isys)
      call sethkg(ihkg)
      call sethmax(hmax)
      ipowder=0
***********
      do id=1,ids
         if(getmthd(id).eq.0) then ! powder method
            ipowder=ipowder+1
            call rdpwdata(id)
         else if(getmthd(id).eq.1) then ! single crystal method
            call rdscdata(id)
         end if
      end do

**************if powder read once*************
*********for powder method*****************
      if(ipowder.gt.0) then
         call rdpwdata1()
      else                      ! single crystal
         if(ihkg.eq.1) then 
            call freadcs('lgr=',1,lgr,1)
            write(6,*) 'lgr=',lgr
            call setlgr(lgr,iset)
         end if
      end if
      
      write(6,*) 'ids=',ids
      do id=1,ids
         call freadcs('flnm1=',1,flnm1,1)
         call setflnm1(flnm1,id)
         lfn1=istrln(flnm1)
         write(6,'(2a)') 'flnm1=',flnm1(1:lfn1)
      end do

c     write(6,*) 'ids=',ids
      call freadcs('flnm2=',1,flnm2,1)
      call setflnm2(flnm2,1)
      lfn2=istrln(flnm2)
      write(6,'(2a)') 'flnm2=',flnm2(1:lfn2)
      call fls()                !********* least squares program*****
      call quit(' ')
      stop
      end

      function ihdchk(h)
      integer h(*)
      call getsys(isys)
      if(isys.le.2) then
         do i=1,6
            if(h(i).ne.0) then
               ihdchk=0
               return
            end if
         end do
      else if(isys.ge.3) then
         do i=1,5
            if(h(i).ne.0) then
               ihdchk=0
               return
            end if
         end do
      end if
      ihdchk=1
      return
      end

      subroutine rdscdata(id)    ! input data for single crystals
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *     istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      integer ih(6)
      integer gethkg
      data pi/3.141592/

      ihkg=gethkg()
      if(ihkg.eq.1) then
         call freadrs('qmin=',1,qmin(id),1)
         call freadrs('qmax=',1,qmax(id),0)
         call freadrs('rmaxi=',1,rmaxi,0)
         call freadis('nst=',1,nstp,0)
         write(6,*) 'qmin=',qmin(id),' qmax=',qmax(id),
     *        ' rmaxi=',rmaxi, ' nst=',nstp
      else if(ihkg.eq.0) then
         call rdiob0(iwght,id)
      end if
      return
      end

      subroutine rdpwdata1()    ! input data for powder
      include 'qcdiff.inc'
      common /criccut/ riccut
      common /ctorms0/ job,ids
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      integer ih(6)
      common /cwflag/ iwflag(7)
      common /atomp2/ y(3,3)
      character*6 lgr
      integer hm,getiwg
      character*80 flnm0,flnm1,flnm2
      common /cquit/ startt
      integer hmax
      character*2 wxr(11),xray(idsmax)
      real wl(11),wl1(11),wl2(11)
      data pi/3.141592/

c     read(5,'(a)') lgr,iset
      call freadcs('lgr=',1,lgr,1)
      write(6,*) 'lgr=',lgr
      call setlgr(lgr,iset)
      iwg=getiwg()
c     read(5,*) riccut
      call freadrs('riccut=',1,riccut,1)
      if(riccut.eq.0) riccut=0.001
      write(6,*) 'riccut=',riccut
c     read(5,*) ldev
      call freadis('ldev=',1,ldev,1)
      write(6,*) 'ldev=',ldev
c     read(5,*) nlp
      call freadis('nlp=',1,nlp,1)
      write(6,*) 'nlp=',nlp
      do i=1,nlp
         read(5,'(5(i2,f9.4,a1))') (il(j,i),cl(j,i),icn(j,i),j=1,1)
         ntl(i)=1
         write(6,'(5(i2,f9.4,a1))') (il(j,i),cl(j,i),icn(j,i),
     *        j=1,ntl(i))
      end do
      return
      end

      subroutine rdpwdata(id)   ! input data for powder
c     data for powder method
      include 'qcdiff.inc'
      real lenx,leny,hscl,vscl
c      complex fc
c      integer hklm
c      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
c     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl)
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *     rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /criccut/ riccut
      common /ctorms0/ job,ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      common /ctorms3/ hwhm(4,idsmax),gamma(idsmax),uvw(2,idsmax),
     *           sgm(idsmax),p1(idsmax),p2(idsmax),as(idsmax)
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      common /crange/ usrmn(nrmax,idsmax),usrmx(nrmax,idsmax)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:9,idsmax),pg(idsmax)
      integer ih(6)
      common /cwflag/ iwflag(7)
      character*6 lgr
      integer hm,getiwg
      integer hd
      common /cpref/ hd(6,120),iequiv,pop
      character*80 flnm0,flnm1,flnm2
      common /cquit/ startt
      integer hmax
      character*2 wxr(11),xray(idsmax)
      real wl(11),wl1(11),wl2(11)
      integer gethkg
      data pi/3.141592/

      ihkg=gethkg()
c     read(5,*) ih(1),ih(2),ih(3),ih(4),ih(5),ih(6)
      call freadia('ih=',6,hd(1,1),1)
      write(6,*) 'ih=',(hd(j,1),j=1,6)
c     read(5,'(a)') xray,backgr,wavl
      call freadcs('xray=',1,xray(id),1)
      call freadis('backgr=',1,ibkgr,0)
      if(xray(id).eq.'tn') then
c     read(5,*) wavl(1,id)
         call freadrs('wavl=',1,wavl(1,id),0)
      end if
      call initiwl(id,xray)
      call setxray(id,xray)
      if(xray(id).ne.'tn'.and.xray(id).ne.'tf') then
         call setwl1(xray)
         call getwl(wl0,wavl(1,id),wavl(2,id))
      else if(xray(id).eq.'tn') then
         call setwl2(wavl(1,id))
         call getwl(wl0,wavl(1,id),wavl(2,id))
      end if
      if(xray(id).eq.'tn') then
         write(6,*) 'xray=',xray(id),' backgr=',ibkgr,
     *        ' wavl=',wavl(1,id)
      else if(xray(id).eq.'tf') then
         write(6,*) 'xray=',xray(id),' backgr=',ibkgr
      else
         write(6,*) 'xray=',xray(id),' backgr=',ibkgr,
     *        ' wavl=',wavl(1,id),wavl(2,id)
      end if
      call setbgr(id,ibkgr)
c     read(5,*) qmin,qmax,qint,istep(id),nrange,ixax,ilp
      call freadrs('qmin=',1,qmin(id),1)
      call freadrs('qmax=',1,qmax(id),0)
      call freadrs('qint=',1,qint,0)
      call freadis('istep=',1,istep(id),0)
      call freadis('nrange=',1,nrange(id),0)
      call freadis('ixax=',1,ixax(id),0)
      call freadis('iyax=',1,iyax(id),0)
      call freadis('ilp=',1,ilp(id),0)
      call freadrs('rmaxi=',1,rmaxi,0)
      call freadis('nst=',1,nstp,0)
      if(ilp(id).eq.3) then
         call freadrs('alpha=',1,alpha(id),0)
      end if
      if(istep(id).le.0) istep(id)=1
      write(6,*) 'qmin=',qmin(id),' qmax=',qmax(id),' qint=',qint,
     *     ' istep=',istep(id),' nrange=',nrange(id),
     *     ' ixax=',ixax(id),' iyax=',iyax(id),' ilp=',ilp(id),
     *     ' rmaxi=',rmaxi, ' nst=',nstp
      qint=qint*istep(id)
      if(nrange(id).gt.nrmax) call quit('nrange > nrmax')
      if(ilp(id).ne.0.and.abs(ilp(id)).ne.1.and.
     *     ilp(id).ne.2.and.ilp(id).ne.3.and.ilp(id).ne.4) then
         call quit('ilp should be 0, 1, -1, 2, 3 or 4')
      end if
      if(xray(id).eq.'tf'.and.ixax(id).eq.1) then
         call quit('ixax should be 0')
      end if
      if(iyax(id).le.0.or.iyax(id).ge.3) then
         call quit('iyax should be 1/2 for linier/log scale')
      end if
      if(rmaxi.eq.0.) rmaxi=1.
      dq(id)=qint

c     read(5,*) (usrmn(i),usrmx(i),i=1,nrange)
      do i=1,nrange(id)
         call freadrs('usrmn=',1,usrmn(i,id),1)
         call freadrs('usrmx=',1,usrmx(i,id),0)
      end do
      if(nrange(id).eq.0) then
         usrmn(1,id)=qmin(id)
         usrmx(1,id)=qmax(id)
         nrange(id)=1
      else
         do i=1,nrange(id)
            if(usrmn(i,id).le.qmin(id)) then
               usrmn(i,id)=qmin(id)
            end if
            if(usrmx(i,id).gt.qmax(id).or.usrmx(i,id).eq.0.) then
               usrmx(i,id)=qmax(id)
            end if
         end do
      end if
      write(6,*) 'usrmn,usrmx',
     *     (usrmn(i,id),usrmx(i,id),i=1,nrange(id))
      if(iwl(id).le.10.or.job.eq.1) then
         ndata(id)=(qmax(id)-qmin(id))/qint+1.001
         if(ndata(id).gt.nmax) call quit('ndata>nmax')
      end if
c     read(5,*) thbm,fi
      call freadrs('thbm=',1,thbmd(id),1)
      if(ilp(id).eq.2) then
         call freadrs('fi=',1,fid(id),0)
      end if
      if(ilp(id).ne.2) then
         write(6,*) 'thbm=',thbmd(id)
      else
         write(6,*) 'thbm=',thbmd(id),' fi=',fid(id)
      end if
c     thbm, fi in radian
      fact=pi/180
      thbmd(id)=thbmd(id)*fact
      fid(id)=fid(id)*fact
c     read(5,*) lenx,leny,vscl,delta
      call freadrs('lenx=',1,lenx(id),1)
      call freadrs('leny=',1,leny(id),0)
      call freadrs('vscl=',1,vscl(id),0)
      call freadrs('delta=',1,delta(id),0)
      write(6,*) 'lenx,leny,vscl,delta',lenx(id),
     *     leny(id),vscl(id),delta(id)
      hscl(id)=1
c     read(5,*) (pb(j),j=0,6)
c     call freadra('pb=',7,pb(0,id),1)
      call freadra('pb=',13,pb(0,id),1)
      if(ibkgr.eq.1) then
         do n=8,12,2
            if(pb(n,id).eq.0) then
               call quit('pb(2n+1) n>6 should be +')
            end if
         end do
      end if
      if(xray(id).ne.'tf') then
c     read(5,*) as(id)
         call freadrs('as=',1,as(id),1)
c     read(5,*) uvw
         call freadra('uv=',2,uvw(1,id),1)
c     read(5,*) gamma(id)
         call freadrs('gamma=',1,gamma(id),1)
c     read(5,*) hwhm(id)
c     call freadra('hwhm=',2,hwhm(1,id),1)
         call freadra('hwhm=',4,hwhm(1,id),1)
      else
         call freadra('sij=',4,pp(0,id),1)
         call freadra('gij=',4,pp(4,id),1)
         call freadra('ri=',2,pp(8,id),1)
      end if
c     read(5,*) pg(id)
      call freadrs('pg=',1,pg(id),1)
      call freadrs('sgm=',1,sgm(id),1)
c     read(5,*) p1,p2
      call freadrs('p1=',1,p1(id),1)
      call freadrs('p2=',1,p2(id),0)
      if(xray(id).ne.'tf') then
c     read(5,*) zps(id)
         call freadrs('zps=',1,zps(1,id),1)
         if(xray(id).eq.'tn') then
            call freadrs('c1=',1,cp(1,id),1)
         else
            cp(1,id)=1.0
         end if
         call freadrs('bia=',1,biar,1)
         call setbia(id,biar)
c     call freadrs('zps1=',1,zps(2,id),0)
c     write(6,*) 'pb=',(pb(j,id),j=0,6)
         write(6,*) 'pb=',(pb(j,id),j=0,12)
         write(6,*) 'as=',as(id)
         write(6,*) 'uv=',(uvw(j,id),j=1,2)
         write(6,*) 'gamma=',gamma(id)
c     write(6,*) 'hwhm=',(hwhm(j,id),j=1,2)
         write(6,*) 'hwhm=',(hwhm(j,id),j=1,4)
         write(6,*) 'pg=',pg(id)
         write(6,*) 'sgm=',sgm(id)
         write(6,*) 'p1=',p1(id),' p2=',p2(id)
c     write(6,*) 'zps=',zps(1,id),' zps1=',zps(2,id)
         write(6,*) 'zps=',zps(1,id)
         if(xray(id).eq.'tn') then               
            write(6,*) 'c1=',1,cp(1,id)
         end if
         write(6,*) 'bia=',biar
      else
         call freadrs('c0=',1,cp(0,id),1)
         call freadrs('c1=',1,cp(1,id),0)
         call freadrs('c2=',1,cp(2,id),0)
         call freadrs('bia=',1,biar,1)
         call setbia(id,biar)
c     write(6,*) 'pb=',(pb(j,id),j=0,6)
         write(6,*) 'pb=',(pb(j,id),j=0,12)
         write(6,*) 'pp=',(pp(j,id),j=0,9)
         write(6,*) 'pg=',pg(id)
         write(6,*) 'sgm=',sgm(id)
         write(6,*) 'p1=',p1(id),' p2=',p2(id)
         write(6,*) 'cp=',(cp(j,id),j=0,2)
         write(6,*) 'bia=',biar
      end if
      call freadcs('flnm0=',1,flnm0,1) ! hkl-ic file
      call setflnm0(flnm0,id)
      lfn0=istrln(flnm0)
      write(6,'(2a)') 'flnm0=',flnm0(1:lfn0)
      return
      end

      subroutine getnst(nst)
      include 'qcdiff.inc'
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *     rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      nst=nstp
      return
      end

      subroutine getilp(ilpd,id)
      include 'qcdiff.inc'
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *     rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      ilpd=ilp(id)
      return
      end

      subroutine quit(str)
      character*(*) str
      common /cquit/ startt
      write(6,*) str
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
c      elapst=secnds(startt)
c      write(6,*) '**************elapse-time ',elapst,
c     *     ' sec ****************'
      stop
      end

      function isaveh(ih,hklm,qmn,qmx,mpl,qks,n)
      include 'qcdiff.inc'
      integer ih(*),hklm(6,*),mpl(*)
      integer hs(6,120)
      real qks(*),hh(3)
      integer getidm,getndm
      common /atomp2/ y(3,3)
      nde=getndm()
      idm=getidm()
      isaveh=0
      if(ih(1).eq.0.and.ih(2).eq.0.and.ih(3).eq.0.and.
     *   ih(4).eq.0.and.ih(5).eq.0.and.ih(6).eq.0) return
      do j=1,3
         hh(j)=ih(j)
         do i=1,nde
            hh(j)=hh(j)+y(j,i)*ih(i+3)
         end do
      end do
      qk=vabsh(hh,3)
      if(qk.lt.qmn.or.qk.gt.qmx) return
      if(irefcd(ih).eq.0) return
c      write(6,*) 'ih=',(ih(i),i=1,idm)
      n=n+1

      call vcpyr(ih,hklm(1,n),idm)
c      do i=1,idm
c         hklm(i,n)=ih(i)
c      end do
      call zerovi(hklm(idm+1,n),6-idm)
c      do i=idm+1,6
c         hklm(i,n)=0
c      end do
      mpl(n)=multpl(hklm(1,n),hs)
      qks(n)=qk
      if(n.gt.nhkl) then
            call quit('***n > nhkl***')
      end if
      return
      end

      function irefcd(ih)    !  remove reflections violating extinction rules 
      common /extcr/ nextnc,icef(7,60)
c     common /cdim/ idm,nde
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer ih(*),hr(6)
      complex ff
      integer getidm
      data pi2/6.28318/, eps/0.0001/
c     remove reflections violating extinction rules 
c        due to bravais type
      idm=getidm()
      irefcd=0
      do i=1,nextnc
         iii=0
         do j=1,idm
            iii=iii+icef(j,i)*ih(j)
         end do
         if(mod(iii,icef(idm+1,i)).ne.0) return
      end do
c     remove reflections violating extinction rules due to screw and glide
      ff=0
      nn=0
      do ic=0,icent
         do ns=1,nsymo
            call gethr(ih,hr,rr,ns,ic)
            if(icomp(ih,hr).ne.1) go to 20
c     symmetry operator leaving diffraction vector invariant
            xx=0
            if(ic.eq.0) then
               do i=1,idm
                  xx=xx+ih(i)*tt(i,ns)
               end do
            else
               do i=1,idm
                  xx=xx-ih(i)*tt(i,ns)
               end do
            end if
            ff=ff+cmplx(cos(pi2*xx),sin(pi2*xx))
            nn=nn+1
 20         continue
         end do
      end do
c     factor of structure factor
      ff=ff/nn
      if(abs(ff).le.eps) return
      irefcd=1
      return
      end

      subroutine getih(ih,h1,h2,h3,h4,h5,h6)
      integer ih(*),h1,h2,h3,h4,h5,h6
      ih(1)=h1
      ih(2)=h2
      ih(3)=h3
      ih(4)=h4
      ih(5)=h5
      ih(6)=h6
      return
      end

      subroutine vtbar(x,y,dy)
c     x,y,dy: x,y coordinates and length of vertical var in cm
      call plot(x,y-dy/2,3)      
      call plot(x,y+dy/2,2)      
      return
      end

      subroutine setbgr(id,ibkgr)
      include 'qcdiff.inc'
      common /cbackgr/ ibackgr(idsmax)
      ibackgr(id)=ibkgr
      return
      end

      subroutine getbgr(id,ibkgr)
      include 'qcdiff.inc'
      common /cbackgr/ ibackgr(idsmax)
      ibkgr=ibackgr(id)
      return
      end

      subroutine initiwl(id,xray)
      character*2 xray
      include 'qcdiff.inc'
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *     rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      character*2 wxr(11)
      data wxr/'ag','mo','nb','zn','cu','ni','co','fe','cr','tn','tf'/
      do i=1,10
         if(xray.eq.wxr(i)) then
            iwl(id)=i
            return
         end if
      end do
      call quit('invalid xray')
      return
      end

      subroutine setwl1(xray)   ! set wave length for specified xray
      character*2 xray
      common /cwl0/ wl0,wl1,wl2
      character*2 wxr(11)
      common /cwl/ wlka(11), wlka1(11), wlka2(11)
      data wlka/0.56083,0.7107,0.7476,1.4364,1.5418,1.6591,1.7902,
     *     1.9373,2.2909,2*0./
      data wlka1/0.55936,0.709300,0.74615,1.435155,1.540562,1.657910,
     *     1.788965,1.936042,2.289700,2*0.0/
      data wlka2/0.56377,0.713590,0.75040,1.439000,1.544390,1.661747,
     *     1.792850,1.939980,2.293606,2*0./
      data wxr/'ag','mo','nb','zn','cu','ni','co','fe','cr','tn','tf'/
      do i=1,10
         if(xray.eq.wxr(i)) then
            wl0=wlka(i)
            wl1=wlka1(i)
            wl2=wlka2(i)
            return
         end if
      end do
      call quit('invalid xray')
      return
      end

      subroutine setwl2(wl)
      common /cwl0/ wl0,wl1,wl2
      wl0=wl
      wl1=wl
      wl2=wl
      return
      end

      subroutine getwl(wl0d,wl1d,wl2d)
      common /cwl0/ wl0,wl1,wl2
      wl0d=wl0
      wl1d=wl1
      wl2d=wl2
      return
      end

      subroutine setlgr(lgr,iset)
      character*6 lgrp(5),lgr
      common /ciwg/iwg
      data lgrp/'m35','10/mmm','-5m','8/mmm','12/mmm'/
      iwg=0
      n=istrln(lgr)
      do i=1,5
         if(lgr(1:n).eq.lgrp(i)(1:n)) then
            write(6,*) 'lgrp(i)=',lgrp(i)(1:n)
            iwg=i
         end if
      end do
      if(iwg.eq.0) call quit('invalid laue group')
      return
      end

      integer function getiwg()
      common /ciwg/iwg
      getiwg=iwg
      return
      end

      subroutine sethkg(ihkgd)
      common /cihkg/ ihkg
      ihkg=ihkgd
      return
      end

      integer function gethkg()
      common /cihkg/ ihkg
      gethkg=ihkg
      return
      end

