      subroutine setnonstrprm(id)      ! set profile parameters or scale factors
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      integer getmthd
      mthd=getmthd(id)
      if(mthd .eq. 0) then      ! powder
         call setnonstrprm0(id)
      else
         call setnonstrprm1(id)
      end if
      return
      end

      subroutine setnonstrprm0(id)    ! set profile parameters for rietveld method
      include 'qcdiff.inc'
      common /ctodrw0/ usrmnt(nrmax),usrmxt(nrmax)
      common /ctodrw1/ qmint,qmaxt,dqt,istept,ndatat,iwgt,mmaxt(3),
     *     wavlt(2),jbt,ibkgrt
      common /ctodrw3/ hwhmt(4),gammat,uvwt(2),p1t,p2t,ast,sgmt
      real lenxt,lenyt
      common /ctodrw4/ lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt
      common /ctodrw6/ cpt(0:2),ppt(0:9),pgt
      common /ctodrw7/ iwlt,ixaxt,ilpt,alphat,iyaxt
      common /ctodrw8/ iptt(0:38),nlct
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /ctodrw10/ biat

      common /ctorms0/ job,ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      common /ctorms3/ hwhm(4,idsmax),gamma(idsmax),uvw(2,idsmax),
     *           sgm(idsmax),p1(idsmax),p2(idsmax),as(idsmax)
      real lenx,leny
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:9,idsmax),pg(idsmax)

      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /crange/ usrmn(nrmax,idsmax),usrmx(nrmax,idsmax)
      integer geti0,getiwl,getnpf

c     powder
      qmint=qmin(id)
      qmaxt=qmax(id)
      dqt=dq(id)
      istept=istep(id)
      ndatat=ndata(id)
      if(getiwl(id) .le.10) then ! xray or thermal neutron
         wavlt(1)=wavl(1,id)
         wavlt(2)=wavl(2,id)
         hwhmt(1)=hwhm(1,id)
         hwhmt(2)=hwhm(2,id)
         hwhmt(3)=hwhm(3,id)
         hwhmt(4)=hwhm(4,id)
         gammat=gamma(id)
         uvwt(1)=uvw(1,id)
         uvwt(2)=uvw(2,id)
         p1t=p1(id)
         p2t=p2(id)
         ast=as(id)
         zpst(1)=zps(1,id)
         cpt(1)=cp(1,id)
      else                      ! TOF neutron
         call vcpyr(pp(0,id),ppt,10)
c         do i=0,9
c            ppt(i)=pp(i,id)
c         end do
         cpt(0)=cp(0,id)
         cpt(1)=cp(1,id)
         cpt(2)=cp(2,id)
      end if
      biat=getbia(id)           ! add bia

      jbt=job
      call getbgr(id,ibkgr)
      ibkgrt=ibkgr
      pgt=pg(id)
      sgmt=sgm(id)
      lenxt=lenx(id)
      lenyt=leny(id)
      hsclt=hscl(id)
      vsclt=vscl(id)
      deltat=delta(id)
      ldevt=ldev
      nrangt=nrange(id)
      iwlt=getiwl(id)
      ixaxt=ixax(id)
      ilpt=ilp(id)
      alphat=alpha(id)
      iyaxt=iyax(id)
c     skip parameters related with the previous data set
      i0=geti0(id-1)
      call vcpyi(ipt(i0),iptt,getnpf(id))
      call vcpyr(usrmn(1,id),usrmnt,nrangt)
c      do i=1,nrangt
c         usrmnt(i)=usrmn(i,id)
c         usrmxt(i)=usrmx(i,id)
c      end do
      
      i0=geti0(ids) 
c     write(6,*) '***i0=',i0
c************lattice parameters common for powder data sets
      call vcpyi(ipt(i0),iptt(getnpf(id)),nlp)
      nlct=nlc
c     background parameters or scale and extinction parameters
      call vcpyr(pb(0,id),pbt,13)
      return
      end

      subroutine setnonstrprm1(id)    ! set scale parameters for single crystals
      include 'qcdiff.inc'
      common /ctodrw8/ iptt(0:38),nlct
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /ctodrw10/ biat
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /cipt/ ipt(0:40*idsmax),nlc
      integer geti0,getiwl,getnpf

c     skip parameters related with the previous data set
      i0=geti0(id-1)
c     scale and extinction parameters
c     write(6,*) 'i0=',i0
      call vcpyi(ipt(i0),iptt,getnpf(id))
      call vcpyr(pb(0,id),pbt,getnpf(id)-1)  ! scale and extinction
c     overall temperature parameter
      biat=getbia(id)   ! last one is bia
c     write(6,*) '*****id,biat',id,biat
      return
      end

      integer function geti0(id)
      include 'qcdiff.inc'
      integer getnpf
      i0=0
      do j=1,id
         i0=i0+getnpf(j)
      end do
      geti0=i0
      return
      end

      subroutine savenonstrprm(id)
c     set profile parameters or scale factors
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      integer getmthd
      mthd=getmthd(id)
      if(mthd.eq.0) then
         call savenonstrprm0(id)
      else
         call savenonstrprm1(id)
      end if
      return
      end

      subroutine savenonstrprm0(id)
c     set profile parameters and overall phason temperature factors
      include 'qcdiff.inc'
      common /ctodrw0/ usrmnt(nrmax),usrmxt(nrmax)
      common /ctodrw1/ qmint,qmaxt,dqt,istept,ndatat,iwgt,mmaxt(3),
     *     wavlt(2),jbt,ibkgrt
      common /ctodrw3/ hwhmt(4),gammat,uvwt(2),p1t,p2t,ast,sgmt
      real lenxt,lenyt
      common /ctodrw4/ lenxt,lenyt,hsclt,vsclt,deltat,ldevt,nrangt
      common /ctodrw6/ cpt(0:2),ppt(0:9),pgt
      common /ctodrw7/ iwlt,ixaxt,ilpt,alphat,iyaxt
      common /ctodrw8/ iptt(0:38),nlct
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /ctodrw10/ biat
      common /ctorms0/ job,ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      common /ctorms3/ hwhm(4,idsmax),gamma(idsmax),uvw(2,idsmax),
     *           sgm(idsmax),p1(idsmax),p2(idsmax),as(idsmax)
      real lenx,leny
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:9,idsmax),pg(idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /crange/ usrmn(nrmax,idsmax),usrmx(nrmax,idsmax)
      integer getiwl,getnpf
      
c     powder
      qmin(id)=qmint
      qmax(id)=qmaxt
      dq(id)=dqt
      istep(id)=istept
      ndata(id)=ndatat
      if(getiwl(id) .le.10) then ! xray or thermal neutron
         wavl(1,id)=wavlt(1)
         wavl(2,id)=wavlt(2)
         hwhm(1,id)=hwhmt(1)
         hwhm(2,id)=hwhmt(2)
         hwhm(3,id)=hwhmt(3)
         hwhm(4,id)=hwhmt(4)
         gamma(id)=gammat
         uvw(1,id)=uvwt(1)
         uvw(2,id)=uvwt(2)
         p1(id)=p1t
         p2(id)=p2t
         as(id)=ast
         zps(1,id)=zpst(1)
         cp(1,id)=cpt(1)
      else                      ! TOF neutron
         cp(0,id)=cpt(0)
         cp(1,id)=cpt(1)
         cp(2,id)=cpt(2)
         call vcpyr(ppt,pp(0,id),10)
c         do i=0,9
c            pp(i,id)=ppt(i)
c         end do
      end if
      job=jbt
      pg(id)=pgt
      sgm(id)=sgmt
      lenx(id)=lenxt
      leny(id)=lenyt
      hscl(id)=hsclt
      vscl(id)=vsclt
      delta(id)=deltat
      ldev=ldevt
      nrange(id)=nrangt
      call setiwl(id,iwlt)
      ixax(id)=ixaxt
      iyax(id)=iyaxt
      ilp(id)=ilpt
      nlc=nlct
      call vcpyr(pbt(0),pb(0,id),13)     ! scale and background
      call setbia(id,biat)
      return
      end

      subroutine savenonstrprm1(id) 
c     set scale factors and oveall phason temperature factors
      include 'qcdiff.inc'
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      common /ctodrw10/ biat
      common /ctorms0/ job,ids
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      integer getiwl,getnpf
c     single crystal
      call vcpyr(pbt(0),pb(0,id),getnpf(id)-1)
      call setbia(id,biat)   ! last one is bia
      return
      end

      subroutine getipp(ids,npp,ipt,ipp)
      integer npp(0:*),ipt(0:*),ipp(0:*)
c      write(6,'(a,30i2)') 'ipt in getipp=',(ipt(j),j=0,npp(ids)-1)
      ipp(0)=0
      l=0
      do jd=1,ids
         ipp(jd)=0
         do k=npp(jd-1)+1,npp(jd)
            if(ipt(k-1).eq.1) then ! ipt starts from 0 so k-1 is needed
               l=l+1
               if(l.gt.npp(jd-1).and.l.le.npp(jd)) then
                  ipp(jd)=ipp(jd)+1
               end if
            end if
         end do
         ipp(jd)=ipp(jd-1)+ipp(jd)
      end do
      return
      end

      subroutine wtcycle(ncycle)
      write(6,*) '**********************'
      write(6,209) ncycle
      write(6,*) '**********************'
 209  format(1h ,'cycle',i3)
      return
      end

      integer function calcij(ips,ny)   ! number of independent parameters
      integer ips(0:*)
      ij=0
      do j=1,ny
         if(ips(j).ne.0) then
            ij=ij+1
         end if
      end do
      calcij=ij
      return
      end

      integer function calcnlc(ipt,nz)
      integer ipt(0:*)
      nlc=0
      do j=0,nz
         if(ipt(j).ne.0) then
            nlc=nlc+1
         end if
      end do
      calcnlc=nlc
      return
      end

      subroutine rdxfile(x,nt,ncycle,icont) ! read parameter file
      real x(*)
      if(ncycle .eq. 1) then
         if(icont .eq. 1) then
            rewind 4
            read(4,212) (x(j),j=1,nt) ! read param. from disk
         end if
      end if
      return
 212  format(8e14.6)      
      end

      subroutine wtxfile(x,nt)
      real x(*)
      rewind 4
      write(4,212) (x(j),j=1,nt) ! save parameters for interrupt
      return
 212  format(8e14.6)      
      end

      subroutine initdf(df,ncycle,nt)  ! init difference
      real df(*)
      if(ncycle.eq.1) then
         call zerov(df,nt)
      end if
      return
      end

      integer function getistop(nn,iz,maxc,nrblk,ijnlc)
c     stop conditions
      if((nn.eq.maxc.and.iz.eq.nrblk).or.ijnlc .eq. 0) then
         istop=1
      else
         istop=0
      end if
      getistop=istop
      return
      end

      integer function getnfcal()
      common /cnfcal/ nfcal, nref
      getnfcal=nfcal
      return
      end

      integer function getnref()
      common /cnfcal/ nfcal, nref
      getnref=nref
      return
      end

      subroutine setnref(nrefd)
      common /cnfcal/ nfcal, nref
      nref=nrefd
      return
      end

      subroutine chkijnlc(ijnlc,iz)
      include 'qcdiff.inc'
      if(ijnlc .gt.nxprm) then
         write(6,213) iz,ijnlc
         call quit('number of parameters .gt. nxprm')
      end if
      return
 213  format(1h ,'number of variable parameters exceeded nxprm'/1h ,
     *                    'nrblk=',i2,3x,i5,1x,'parameters')
      end

      subroutine setiwj(iw,ny,nz)  ! for wtx
      character*4 iw(*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      do j=1,ny
         iw(j)=' '
         if(ips(j) .eq. 0) iw(j)='*'
      end do
      do j=0,nz
         iw(ny+j+1)=' '
         if(ipt(j) .eq. 0) then
            iw(ny+j+1)='*'
         end if
      end do
      return
      end

      subroutine fls()     ! full matrix least-squares method
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /cwflag/ iwflag(7)
      common /caydm/ aydm,alp,ifunc
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      character*80 flnm0,flnm1,flnm2
      common /crfn/ eps,dmpf,maxc
      include 'rfact.inc'
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      real md, deltd   ! normal matrix and vector for each data set
      common /cnmmtrx/ md(nxprm*(nxprm+1)/2),deltd(nxprm)

      real m(nxprm*(nxprm+1)/2),delt(nxprm) ! normal matrix and vector for total data
      real x(nxprm),y(nxprm),z(nxprm),de(nxprm),df(nxprm)

      real sg(6,6)
      real*8 ro
      integer gethkg
      character*4 iw(nxprm)
      integer getiwl,getnpf,getnpfx,getnpfn,getnz,getipwd
      integer calcij, calcnlc, getistop, getnfcal
      integer getitwin,getitempf,getisxt,getipreset,getisreset
      data pi/3.141592/


      sctmdl=-2             ! one site is occupied by three atoms
      call setsctmdl(sctmdl)
      call qcdff1()         ! read necessary information for structure factors
      call rdintl(x,ny)     ! read structural parameters from input data
                            ! and get number of structural parameters ny
      call rdmtrt(x(ny+1))  ! get other parameters from input data
c     default value
c      if(mthd.eq.1 .and. rmaxi .eq. 0) then
c         rmaxi=1.0
c         write(6,*) 'rmaxi=', rmaxi
c      end if

*******************************
c     
c     full matrix least squars method
c     
c******************************

c     initialization
c
      ro=10.0d0
      totalo=10.0
      alc=0.1
      ncycle=0

      do id=1,ids
         isext=getisxt(id)
         call initextc(id,isext) ! initialize extinction parameters
      end do
      itempf=getitempf()      ! itempf is common for all datasets
      if(itempf.eq.1) then
c        calculation of transformation coeff. for aniso temp. fac.
         call btouij(na)
c        call setb10(na)      ! set equivalent ui
         call setui0(na)      ! set equivalent ui
      else
         call setitempfi0()   ! use isotropic temp. fac. for all atoms
      end if
      call geta(al)
      call getc(cl)
      call setac(al,cl)         ! set lattice constants for extcor

      call getflnm2(flnm2,1)    ! get file name for independent parameter file
      write(6,*) 'flnm2=',flnm2
      
      if(job .eq. 0) then       ! structure refinement
         call freadis('iwf=',1,iwf,1)
         call freadrs('fct=',1,fct,0)
         if(iwflag(3) .eq. 1) then
            write(6,217) iwf,fct
         end if
         ie=1
         call freadis('istdv=',1,istdv,1)
         call freadis('icont=',1,icont,0)
         call freadis('iwght=',1,iwght,0)
         write(6,'(3(a,i3))')
     *        'istdv=',istdv,' icont=',icont,' iwght=',iwght
         if(iwght.eq.3) then
            call freadrs('a1=',1,a1,0)            
            call freadrs('a2=',1,a2,0)            
            call seta1a2(a1,a2)
            write(6,'(2(a,f10.5))') 'a1=',a1,' a2=',a2
         else
            a1=0
            a2=0
            call seta1a2(a1,a2)
         end if
c        ifinc=1
         ifunc=1
      else
         iwf=1
         icont=0
         ifunc=1
         iwght=1
         istdv=0
      end if
      if(icont.eq.0) then
         call openfile(4,flnm2,'UNKNOWN') ! parameter file
      else
         call openfile(4,flnm2,'OLD') ! parameter file
      end if
      call setwght(iwght)

c     nx:  upper limit of the total number of parameters
c     ny : number of structural parameters treated in qcdiff
c     nz+1 : number of other parameters (including extinction param.)
c     nt=ny+nz+1 : total number of parameters
c     nlp: number of lattice parameters including phason strain
c     parameters eps1,eps2,eps3,eps4,eps5,eps6

      call setnpf(ids)  ! set number of profile or scale parameters
      nz=getnz(ids)     ! number of profile or scale&extinction parameters
      if(getipwd(ids) .eq. 1) nz=nz+nlp
      nz=nz-1
      nt=ny+nz+1     ! total number of parameters

      if(job .eq. 0) then
c        read the number of blocks (block diagonal least squars method)
         call freadis('nrblk=',1,nrblk,1)
         write(6,*) 'nrblk=',nrblk
      else 
         nrblk=1
         write(6,*) 'nrblk=',nrblk
      end if
c     call setdei()             ! set phason strain

      do iz=1,nrblk             ! block loop
         call rdrfncnd(ny,nz)   ! read refinement conditions
         call resetips0(ny)     ! copy ips0 to ips and reset some tmp. prm.
         ij=calcij(ips,ny)      ! get number of refined structural parameters
         nlc=calcnlc(ipt,nz)    ! get number of refined prof./scale parameters
         ijnlc=ij+nlc           ! total number of refined parameters
c     check whether ij exceeds nxprm or not
         call chkijnlc(ijnlc,iz)
         call setiwj(iw,ny,nz) ! set iw for wtx

         do nn=0,maxc   ! least squars loop
            ncycle=ncycle+1
            call resetmd(m,delt,ijnlc) ! initialize normal matrix etc.
            call rdxfile(x,nt,ncycle,icont) ! read independent parameter file
            call initdf(df,ncycle,nt) ! initialize df vector
            call setxbp(x,ny)   ! set structural parameters
            if(getipreset().eq.1.or.getisreset().eq.1) then
               call resetips1(x,ny) ! copy ips0 to ips and reset some tmp. prm.
               ij=calcij(ips,ny) ! get number of refined structural parameters
               ijnlc=ij+nlc     ! total number of refined parameters
               call setxbp(x,ny) ! set structural parameters
            end if
            call settmp2x(x,ny) ! set x for equivalent tempf
            call setltcc(x(ny+1)) ! set other parameters
c           call resetips(df,ny)    ! reset ips for OD with p=0     
            call wtcycle(ncycle) ! printout cycles
            call wtprm(x,df,ny)  ! write parameters
            call initrfct()      ! initialize total rfactors
            ntdata=0
            sa2=0
            is=0
            istop=getistop(nn,iz,maxc,nrblk,ijnlc) ! stop flag
            do id=1,ids
               call setid(id)   ! set data set number 
c     set atomic scattering factor for eadh data set (xray or neutron)
               call setasf(id)  ! set atomic scattering factor for id-th data
c              call wtasf(6)     ! for check only
c     printout occupation damain volumes and point density
               isext=getisxt(id) ! for extinction correction
c     if(abs(isext).eq.1.or.abs(isext).eq.2) then
               if(isext.ne.0) then
                  call getgij()
                  call setextc(id) ! set extinction parameters
               end if
               call getnrmmtrx(id,m,delt,ij,ijnlc,ny) ! get normal matrix
c              call wttangmtrxr('****m',m,ijnlc)
c     save profile parameters or scale factors (because its id-dependent)
c     call savenonstrprm(id) 

               if(iz.eq.1.and.nn.eq.0) then ! set scale factors
                  call setpb01(id,x(ny+1))
               end if
               if(istop .eq. 1) then
                  call fout(id,iwf) !  output structure factors
               end if
            end do    ! id loop

            call pnf(ids,ijnlc,ny,pf1,pf2,pf3,ij,m,delt)  ! penalty functions
c            call wttangmtrxr('****m1',m,ijnlc)
            if(job.ne.0) then
               call quit(' ')
            end if
            call wtrfact(chisqr) ! printout r-factors
            call vcpyr(x,y,nt)  ! save parameters (x -> y)
            rwpo=rwpa
            totalo=total
c           calculations of new parameters or standard deviations
            if(ijnlc .eq. 0) go to 60   ! no refined parameters. break do loop

c           solve the normal equation
            call getrfncnd(istop,istdv,iq,dmp) ! get iq and dmp
c     call wttangmtrxr('normal matrix',m,ijnlc)
            call chlsk(m,delt,de,ijnlc,iq,ising,iret,dmp,df) ! solv normal equation
c           call wtvctrr('****de=',de,ijnlc)
            call sngprm(ising,iret,ips,ipt,ny,nz) ! printout singular parameter number if any
            call corrm(m,delt,ijnlc) ! printout correlation matrix if necessary
            call vcpyr(y,x,nt)  ! restore parameters

            if(istop .eq. 0 .or. istdv .eq. 0) then
               call getnewprm(x,de,ips,ipt,ny,nz) ! get new parameters
               call vsubr(x,y,df,nt) ! calculate differences (x-y)
               call wtxfile(x,nt) ! save parameters to file
            end if
            if(istop .eq. 1) go to 60
         end do  ! *************** end of least squars loop
      end do     ! *************** end of block loop

 60   continue

      call wtxfile(x,nt)  ! save final parameters to file

      if(istop .eq. 1.and.istdv .eq. 1 .and. ijnlc .gt.0) then
c     fstdv : chisquare per is reflections
         fstdv=chisqr*is/ntdata
         call calcstdv(z,m,nt,is,fstdv,ij,ny,nz)
      end if

      if(istop .eq. 1 .and. istdv .ne. 1) then
c     ***** starting point of the next cycle
         if(iwflag(4) .ge.1.and.iwflag(4) .le.4.or.
     *        iwflag(5) .ge.1.and.iwflag(5) .le.3) then
            write(6,('(a)')) 'next cycle'
         end if
      end if

c     *******
      if(istdv.ne.1) then
         call setxbp(x,ny)      ! set structural parameters
         call wtprm(x,df,ny)    ! write final parameters
      end if

c   *****output standard dev. of independent parameters
      if(istdv .eq. 1.and.ijnlc .gt.0) then
         ll=ij*(ij+1)/2
         nsk=0
         do id=0,nz-nlp
            if(ipt(id) .eq. 1) nsk=nsk+1
         end do
c     nsk: number of variable profile parameters excluding lattice param.
         do id=ij+1,ijnlc
            do jd=1,id
               ll=ll+1
               ii=id-ij-nsk
               jj=jd-ij-nsk
               if(ii .ge.1.and.ii .le.6.and.jj .ge.1.and.jj .le.6) then
                  sg(ii,jj)=fstdv*m(ll)/(is-ij-nlc)
                  sg(jj,ii)=sg(ii,jj)
               end if
            end do
         end do
         if(iwflag(6) .eq. 1.or.iwflag(6) .eq. 3) then
            write(6,203)
            call wtx(z,nt,iw,ids)
         end if

         if(iwflag(6) .eq. 2.or.iwflag(6) .eq. 3) then
            call setxbp(y,ny)   ! set structural parameters
            call wtprm(y,z,ny)  ! write parameters and std. dv.
         end if
      end if
      return
 101  format(i3)
 102  format(6i4)
 103  format(8f10.6)
 105  format(i3,f12.6)
 203  format(1h ,'standard deviation')
 207  format(1h ,'final fourier amplitudes  ',2a)
 208  format(1h ,'final fourier amplitudes and their stdv ',2a)
 211  format(1h ,'independent parametes (fixed parameters asterisked)')
 212  format(8e14.6)
 214  format(1h ,'difference')
 215  format(1h ,'damping factor  .gt.10       dmp=',f10.4)
 216  format(1h ,'initial fourier amplitudes  ',2a)
 217  format(1h ,'iwf=',i3,2x,'fct=',f12.6)
 218  format(1h ,'fourier amplitudes ',2a)
 219  format(1h ,'differences of fourier amplitudes ',2a)
      end

      subroutine initrfct()  ! initialize total rfactors
      include 'qcdiff.inc'
      include 'rfact.inc'
      rwpa2=0
      rwpta2=0
      rwp02=0
      call zerovr(rwp,idsmax)
      call zerovr(rwpt,idsmax)
      call zerovr(s,idsmax)
      call zerovr(rw0,idsmax)
      return
      end

      subroutine getrminmax0(id,rmine,rmaxe)  ! for powder
      include 'qcdiff.inc'
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      integer getiwl,getnpf,getnpfx,getnpfn,getipwd
      data pi/3.141592/
      thbm=thbmd(id)
      fi=fid(id)
      awl=(2*wavl(1,id)+wavl(2,id))/3
c     generate reflection indices
      if(ixax(id) .eq. 0.and.getiwl(id) .eq. 11) then
c     diffraction vector Q
         rmine=qmin(id)/(pi*2)
         rmaxe=qmax(id)/(pi*2)
      else if(ixax(id) .eq. 1.or.iwl(id) .le.10) then
c     2-theta in degree
         rmine=2*sin(pi*qmin(id)/360)/wavl(1,id)
         rmaxe=2*sin(pi*qmax(id)/360)/wavl(1,id)
      else
         call quit('invalid ixax')
      end if 
      return
      end

      subroutine getrminmax(id,rmine,rmaxe)
      include 'qcdiff.inc'
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      data pi/3.141592/
      rmine=qmin(id)/(pi*2)
      rmaxe=qmax(id)/(pi*2)
      return
      end

      subroutine rdpwint(id)
      include 'qcdiff.inc'
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      character*80 flnm0
      call getflnm0(flnm0,id)
      call openfile(2,flnm0,'OLD')
      call rdyo(istep(id),ndata(id)) ! read intensity
      if(getndata(id) .gt.nmax) then
         call quit('ndata .gt. nmax')
      end if
      close(unit=2)
      return
      end
      
      integer function getndata0(id)
      include 'qcdiff.inc'
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     * istep(idsmax),ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax)
      getndata0=ndata(id)
      return
      end

      subroutine getnrmmtrx(id,m,delt,ij,ijnlc,ny)
c     get normal matrix for id-th data set
      real m(*),delt(*)
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /caydm/ aydm,alp,ifunc
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      character*80 flnm1,flnm2
      include 'rfact.inc'
      common /cnfcal/ nfcal, nref
      real md, deltd  ! normal matrix and vector for each data set
      common /cnmmtrx/ md(nxprm*(nxprm+1)/2),deltd(nxprm)

      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax)

      real x(nxprm),y(nxprm),z(nxprm),de(nxprm),df(nxprm)
      integer hs(6,nhkl),mpls(nhkl)
      real qs(nhkl)
      real*8 ro
      integer q
      character*4 iw(nxprm)
      integer getiwl,getnpf,getnpfx,getnpfn,getipwd,getndata0
      integer getitwin,gethkg,getmthd
      data pi/3.141592/

      call getwght(iwght)
      mthd=getmthd(id)
      if(mthd .eq. 0) then  ! powder
         call getflnm1(flnm1,id) ! get file name for powder data
         call openfile(1,flnm1,'UNKNOWN') ! for hkl-fc
         if(job.ne.2) then
            call getrminmax0(id,rmine,rmaxe)
            call setsmtrm(nstp)  ! set order of similarity transformations
            call genhkl(hs,mpls,qs,nfcal,rmine,rmaxe,rmaxi)  ! generate hkl
         end if
         call setnonstrprm(id)                ! set profile parameters
         call qcdff2(nfcal,hs,mpls,ny) ! structure factor calculations

         call rdhkl0(nfcal,nref)
         call setnref(nref)
         if(job .eq. 0.or.job .eq. 2) then
            call rdpwint(id)  ! read powder intensity
         end if

         call resetmd(md,deltd,ijnlc) ! reset md, deltd
c     normal matrix calculation for powder method
         call drwpdf(nref,md,deltd,rwp(id),rwpt(id),s(id))
         sa2=sa2+s(id)**2
         ntdata=ntdata+getndata0(id)
         close(unit=1)
      else if(mthd .eq. 1) then ! single crystal
         call getflnm1(flnm1,id)  ! get file name for hkl and fo sig
         call openfile(3,flnm1,'OLD')  ! for hkl fo
         ihkg=gethkg()

         if(job.eq.1.and.ihkg.eq.1) then
            call getrminmax(id,rmine,rmaxe)
            write(6,*) 'rmine,rmaxe,rmaxi=',rmine,rmaxe,rmaxi
            call genhkl(hs,mpls,qs,nfcal,rmine,rmaxe,rmaxi)
            call sethkl(hs,nfcal) ! for single crystal hkl
         else
            call rdiob2(iwght,hs,nfcal,id) ! copy input
         end if
         call setnonstrprm(id)  ! set scale and extinction parameters
         call qcdff2(nfcal,hs,mpls,ny) ! structure factor calculations
         call resetmd(md,deltd,ijnlc)  ! reset md, deltd
c     normal matrix calculation for single crystal method
         call mtbld(nfcal,md,deltd,rwp(id),rw0(id),rwpt(id),id)
c     call wttangmtrxr('md',md,ijnlc)
c     call wttangdiagr('md diagonal term',md,ijnlc)
         ntdata=ntdata+nfcal
         close(unit=3)
      else
         call quit('invalid mthd')
      end if
      call insert(deltd,md,delt,m,id,ij)  ! insert deltd,md into m and delt
c     call wttangmtrxr('m',m,ijnlc)
c     call wttangdiagr('m diagonal term',m,ijnlc)
      is=is+nfcal
      rwpa2=rwpa2+rwp(id)**2
      rwp02=rwp02+rw0(id)**2
      rwpta2=rwpta2+rwpt(id)**2
      return
      end

      subroutine wtrfact(chisqr)  ! printout r-factors
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      include 'rfact.inc'
      integer getmthd
      chisqr=rwpa2+pf1**2+pf2**2+pf3**2
      rwpa=sqrt(rwpa2/ids)
      rwp0=sqrt(rwp02/ids)
      rwpta=sqrt(rwpta2/ids)
      total=sqrt(chisqr)
      sa=sqrt(sa2)
      write(6,'(a)') '******************************'
      mthd=getmthd(1)
      if(mthd .eq. 0) then
         write(6,2011) ncycle,rwpa,rwpta,pf1,pf2,pf3,total
      else if(mthd .eq. 1) then
         write(6,2012) ncycle,rwpa,rwp0,rwpta,pf1,pf2,pf3,total
      end if

      do id=1,ids
         mthd=getmthd(id)
         if(mthd .eq. 0) then
            write(6,'(1h ,a,i2,2(a,f7.4,2x))')
     *           'data set',id,' rwp=',rwp(id),'s=  ',s(id)
         else
            write(6,'(1h ,a,i2,3(a,f7.4,2x))')
     *           'data set',id,' rw=',rwp(id),'rw0=',rw0(id),
     *           'r=',rwpt(id)
         end if
      end do

      write(6,'(a)') '******************************'
      write(6,'(a)') ' '
      return
 2011 format(1h ,'cycle ',i3,2x,'rwp=',f7.4,2x,'rwpt=',f7.4,
     *    2x,'pf1=',f7.4,2x,'pf2=',f7.4,2x,'pf3=',f7.4,2x,
     *    'sqrt(rwp**2+pf1**2+pf2**2+pf3**2)=',f9.6)
 2012 format(1h ,'cycle ',i3,2x,'rw=',f7.4,2x,'rw0=',f7.4,2x,'r=',f7.4,
     *    2x,'pf1=',f7.4,2x,'pf2=',f7.4,2x,'pf3=',f7.4,2x,
     *    'sqrt(rw**2+pf1**2+pf2**2+pf3**2)=',f9.6)
      end

      subroutine fout(id,iwf)
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      character brv
      integer getnfcal, getnref
      integer getmthd
      call getbrv(brv)      ! get bravais lattice
c     *****   output structure factors
      if(iwf .eq. 1) then
         if(getmthd(id) .eq. 0) then  ! powder
            nref=getnref()
            call fout0(nref,brv)
         else                   ! single crystal
            nfcal=getnfcal()
            call fout1(nfcal,brv,id)
         end if
      end if
      return
      end

      subroutine wtvol(id)    ! printout occupation domain volumes
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax)
      integer getid
      call getsys(isys)
c     id=getid()
      if(id.eq.1) then
         if((isys .eq. 1.or.isys .eq. 2)) then
            call vivoli(na,mpl,isk,irs)
         else if(isys .ge.3.or.isys .le.5) then
            call vivold(na,mpl,isk,irs)
         else
            call quit('invalid isys')
         end if
      end if
      return
      end

      integer function getipwd(ids)
      integer getmthd
      ipwd=0
      do id=1,ids
         if(getmthd(id) .eq. 0) then
            ipwd=1
         end if
      end do
      getipwd=ipwd
      return
      end

      integer function getnz(ids)
      include 'qcdiff.inc'
      integer getmthd,getnpf,getisxt
c     calculatuion of nz
      nz=0
      do id=1,ids
         if(getmthd(id) .eq. 0) then
            nz=nz+getnpf(id)
         else
            nz=nz+getnpf(id)
            isext=getisxt(id)
         end if
      end do
      getnz=nz
      return
      end

      subroutine resetmd(md,deltd,ij)  ! initialize normal matrix and vector
      real md(*),deltd(*)
      call zerov(deltd,ij)
      call zerov(md,ij*(ij+1)/2)
      return
      end

      subroutine initindtrn() ! index transformation matrix
      common /indtr/ indtr1(6,6),indtr2(6,6),indtr3(6,6),indtr4(6,6)
      data indtr1/1,0,0,1,0,0,
     *            0,1,0,0,1,0,
     *            0,0,1,0,0,1,
     *            -1,0,0,1,0,0,
     *            0,1,0,0,-1,0,
     *            0,0,-1,0,0,1/
      data indtr2/1,0,0,-1,0,0,
     *            0,1,0,0,1,0,
     *            0,0,1,0,0,-1,
     *            1,0,0,1,0,0,
     *            0,1,0,0,-1,0,
     *            0,0,1,0,0,1/
      data indtr4/1,0,0,0,0,0,
     *            0,1,0,0,0,0,
     *            0,0,0,0,0,1,
     *            0,0,0,0,1,0,
     *            0,0,1,0,0,0,
     *            0,0,0,-1,0,0/
      data indtr3/1,0,0,0,0,0,
     *            0,1,0,0,0,0,
     *            0,0,0,0,1,0,
     *            0,0,0,0,0,-1,
     *            0,0,0,1,0,0,
     *            0,0,1,0,0,0/
      return
      end

      subroutine indtrn(h,hd,job)
      integer h(*),hd(*),ht(6)
      common /indtr/ indtr1(6,6),indtr2(6,6),indtr3(6,6),indtr4(6,6)
c        6d indices by Cahn n1,n2,n3,n4,n5,n6
c        correspond to      h2,h3,h4,h5,h6,h1  by Elser or Janssen
      if(job .eq. 1) then
c     Cahn cubic indices to Cahn 6d indices
         call gethr(h,hd,indtr1,1,0)
         do i=1,6
            hd(i)=hd(i)/2
         end do
c     Cahn 6d indices to Elser 6d indices
         call gethr(ht,hd,indtr3,1,0)
      else if(job .eq. 2) then
c     Cahn 6d indices to Elser 6d indices
         do i=5,1,-1
            hd(i+1)=h(i)
         end do
         hd(1)=h(6)
      else if(job .eq. -1) then
c     Elser 6d indices to Cahn 6d indices
         call gethr(h,ht,indtr4,1,0)
c     Cahn 6d indices to Cahn cubic indices
         call gethr(ht,hd,indtr2,1,0)
      else if(job .eq. -2) then
c     Elser 6d indices to Cahn 6d indices
         call gethr(h,hd,indtr4,1,0)
      end if
      return
      end

      subroutine fout0(nfcal,brv) ! printout fo fc etc for rietveld method
c     fo list for powder method
      character brv
      include 'qcdiff.inc'
      include 'hklmf.inc'
      integer ns(nhkl),st(nhkl,2)
      real qkd(nhkl)
      integer hd(6),ht(6)
      integer getidm
      character*(80) frmt
      data pi2/ 6.28318/

      call initindtrn()
      call vcpyr(qk,qkd,nfcal)
      call qsort(qkd,st,ns,nfcal)

      idm=getidm()
      write(6,'(3a)') '  indices           mpl',
     *     '     fc      ic/lp     2-theta        Q',
     *     '         q         d        N   M'
      do ii=1,nfcal
         i=ns(ii)
         call indtrn(hklm(1,i),hd,-1)
         n=hd(1)**2+hd(2)**2+hd(3)**2+hd(4)**2+hd(5)**2+hd(6)**2
         m=hd(2)**2+hd(4)**2+hd(6)**2+
     *        2*(hd(1)*hd(2)+hd(3)*hd(4)+hd(5)*hd(6))
         aic=fmpl(i)*abs(fc(i))**2/10000
         if(brv .eq. 'f'.or.brv .eq. 'i') then
            n=n/4
            m=m/4
         end if
         call getfrmt0(frmt,idm)
         write(6,frmt) (hklm(j,i),j=1,idm),fmpl(i),
     *        abs(fc(i)),aic,theta0(i),qk(i)*pi2,qk(i),1/qk(i),n,m

      end do
      return
      end

      subroutine getfrmt0(frmt,idm)
      character*(*) frmt
      if(idm.eq.5) then
         frmt='(5i4,i4,6f11.5,2i4)'
      else if(idm.eq.6) then
         frmt='(6i4,i4,6f11.5,2i4)'
      else
         write(6,*) 'idm=',idm
         call quit('invalid idm')
      end if
      return
      end

      subroutine getfrmt1(frmt,idm)
      character*(*) frmt
      if(idm.eq.5) then
         frmt='(5i4,4x,2f11.5,a,f7.1,f11.5,3f11.5,2f9.5)'
      else if(idm.eq.6) then
         frmt='(6i4,   2f11.5,a,f7.1,f11.5,3f11.5,2f9.5)'
      else
         write(6,*) 'idm=',idm
         call quit('invalid idm')
      end if
      return
      end

      subroutine initsds()
      call initsmdsm()
      call initssdss()
      return
      end

      subroutine initsmdsm()
      common /csmdsm/sm,dsm,swm,swm0,dswm,dswm0,nm
      sm=0
      dsm=0
      swm=0
      swm0=0
      dswm=0
      dswm0=0
      nm=0
      return
      end

      subroutine initssdss()
      common /cssdss/ss,dss,sws,sws0,dsws,dsws0,ns
      ss=0
      dss=0
      sws=0
      sws0=0
      dsws=0
      dsws0=0
      ns=0
      return
      end

      subroutine initstdst()
      common /cstdst/ nt,dst,dswt,dswt0,sd,swd,swd0
      nt=0
      dst=0
      dswt=0
      dswt0=0
      sd=0
      swd=0
      swd0=0
      return
      end

      subroutine calsmdsm(i,fow,dfoc) ! for main reflections
      common /csmdsm/sm,dsm,swm,swm0,dswm,dswm0,nm
      include 'qcdiff.inc'
      include 'hklmf.inc'
      nm=nm+1
      sm=sm+fow
      swm=swm+wg(i)*fow**2
      swm0=swm0+fow**2
      dsm=dsm+abs(dfoc)
      dswm=dswm+wg(i)*dfoc**2
      dswm0=dswm0+dfoc**2
      return
      end

      subroutine calssdss(i,fow,dfoc) ! for satellite reflections
      common /cssdss/ss,dss,sws,sws0,dsws,dsws0,ns
      include 'qcdiff.inc'
      include 'hklmf.inc'
      ns=ns+1
      ss=ss+fow
      sws=sws+wg(i)*fow**2
      sws0=sws0+fow**2
      dss=dss+abs(dfoc)
      dsws=dsws+wg(i)*dfoc**2
      dsws0=dsws0+dfoc**2
      return
      end

      subroutine calstdst(i,fow,dfoc)
      common /cstdst/ nt,dst,dswt,dswt0,sd,swd,swd0
      include 'qcdiff.inc'
      include 'hklmf.inc'
      nt=nt+1
      sd=sd+fow 
      swd=swd+wg(i)*fow**2 
      swd0=swd0+fow**2 
      dst=dst+abs(dfoc)
      dswt=dswt+wg(i)*dfoc**2
      dswt0=dswt0+dfoc**2
      return
      end

      subroutine fout1(nfcal,brv,id)
c     printout fo fc etc. for single crystal method
c     fo fc list for single crystal method
      character brv,star
      include 'qcdiff.inc'
      common /cstdst/ nt,dst,dswt,dswt0,sd,swd,swd0
      common /csmdsm/sm,dsm,swm,swm0,dswm,dswm0,nm
      common /cssdss/ss,dss,sws,sws0,dsws,dsws0,ns
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      include 'hklmf.inc'
      character*80 fmt
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *     inp(idsmax),iorf(idsmax),fmt(idsmax)
      integer nd(nhkl),st(nhkl,2)
      real qkd(nhkl),q(6),qi(nhkl)
      real fod(nhkl)
      integer getisxt,getidm
      character*(80) frmt
      data pi /3.141592/

      call getnsyic(nsymo,icent)
      isext=getisxt(id)
      call initsds()
      call getsys(isys)

      do i=1,nfcal
c        call getqi0(hklm(1,i),q)  ! Oct. 1 2001
         call getqi(hklm(1,i),q)
         if(isys .le.2) then
            qk(i)=vabs(q,3)
            qi(i)=vabs(q(4),3)
         else
            qk(i)=vabs(q,3)
            qi(i)=vabs(q(4),2)
         end if
         qkd(i)=abs(fc(i))
      end do

      call qsort(qkd,st,nd,nfcal)

      write(6,'(3a)') '        indices            |fo|       |fc|',
     *    '       angl       df        qe         qi',
     *     '         ext       r'
      idm=getidm()
      call getfrmt1(frmt,idm)
      scale=pb(0,id)
      nastrm=0
      nastrs=0
c     do ii=1,nfcal
      do ii=nfcal,1,-1
         i=nd(ii)
         fcr=real(fc(i))
         fci=aimag(fc(i))
         absfc=abs(fc(i))
         ang=atan3(fci,fcr)*180/pi
         fow=fo(i)/scale
         if(isext .eq. 0) then
            dfoc =fow-abs(fc(i))
            dfocd=dfoc
            exti=1.
         else
            dfoc =fow-abs(fc(i))*ext(i)
            dfocd =fow/ext(i)-abs(fc(i))
            exti=ext(i)
         end if
         if(fow.ne.0) then
            ri=abs(dfoc)/fow
         else
            ri=0
         end if
         if(isatel(hklm(1,i),brv) .eq. 0) then
            if(abs(fc(i)) .lt.fminc(id)) then
               star='*'
               nastrm=nastrm+1
            else
               call calsmdsm(i,fow,dfoc)
               star=' '
            end if
         else
            if(abs(fc(i)) .lt.fminc(id)) then
               star='*'
               nastrs=nastrs+1
            else
               call calssdss(i,fow,dfoc)               
               star=' '
            end if
         end if
         write(6,frmt) (hklm(j,i),j=1,idm),fow/exti,absfc,
     *        star,ang,dfocd,qk(i),qi(i),exti,ri
      end do
      if(sm .eq. 0) sm=1
      if(swm .eq. 0) swm=1
      if(swm0.eq. 0) swm0=1
      if(ss .eq. 0) ss=1
      if(sws .eq. 0) sws=1
      if(sws0.eq. 0) sws0=1
      if(brv.ne.'p')  then      ! for super structure
         write(6,'(2(3(a,f5.3),2(a,i4),a))')
     *        'Rw=', sqrt(dswm/swm),' Rw0=',sqrt(dswm0/swm0),
     *        ' R=',dsm/sm,' for',nm,
     *        ' main refl. excluding',nastrm,' asterisked refl.',
     *        ' Rw=', sqrt(dsws/sws),' Rw0=',sqrt(dsws0/sws0),
     *        ' R=',dss/ss,' for',ns,
     *        ' satelite refl. excluding',nastrs,' asterisked refl.'
      else                      ! for normal structure
         write(6,'(2(3(a,f5.3),2(a,i4),a))')
     *        'Rw=', sqrt(dswm/swm),' Rw0=',sqrt(dswm0/swm0),
     *        ' R=',dsm/sm,' for',nm,
     *        ' reflections excluding',nastrm,' asterisked refl.'
      end if
c     if(nfcal .gt.60) then
      call vcpyr(fo,fod,nfcal)
      call qsort(fod,st,nd,nfcal)
      kkmax=(nfcal-nastrm-nastrs)/100
      do kkk=1,kkmax
         call initsds()
         call initstdst()
         jj=0
c     do ii=nfcal,nfcal-60+1,-1
         do ii=nfcal,1,-1
c     jj=nfcal-ii+1       ! jj=1,2,3,...,nfcal
            i=nd(ii)
            if(abs(fc(i)) .gt.fminc(id)) then
               jj=jj+1
               if(jj .le.kkk*100) then
                  fow=fo(i)/scale
                  if(isext .eq. 0) then
                     dfoc =fow-abs(fc(i))
                  else
                     dfoc =fow-abs(fc(i))*ext(i)
                  end if
                  call calstdst(i,fow,dfoc)
                  if(isatel(hklm(1,i),brv) .eq. 0) then
                     call calsmdsm(i,fow,dfoc)
                  else
                     call calssdss(i,fow,dfoc)
                  end if
               end if
            end if
         end do
         if(sm .eq. 0) sm=1
         if(swm .eq. 0) swm=1
         if(swm0.eq. 0) swm0=1
         if(ss .eq. 0) ss=1
         if(sws .eq. 0) sws=1
         if(sws0.eq. 0) sws0=1
         if(swd .eq. 0) swd=1
         if(swd0.eq. 0) swd0=1
         write(6,'(3(a,f5.3),a,i4,a)') 'Rw=',sqrt(dswt/swd),
     *        ' Rw0=',sqrt(dswt0/swd0),' R=',
     *        dst/sd,' R for strongest',kkk*100,' reflections'
         if(brv .ne. 'p') then
            write(6,'(2(3(a,f5.3),a,i4,a))')
     *           'Rw=', sqrt(dswm/swm),' Rw0=',sqrt(dswm0/swm0),
     *           ' R=',dsm/sm,' for',nm,
     *           ' main reflections',
     *           ' Rw=', sqrt(dsws/sws),' Rw0=',sqrt(dsws0/sws0),
     *           ' R=',dss/ss,' for',ns,
     *           ' satelite reflections'
         else
            write(6,'(2(3(a,f5.3),a,i4,a))')
     *           'Rw=', sqrt(dswm/swm),' Rw0=',sqrt(dswm0/swm0),
     *           ' R=',dsm/sm,' for',nm,
     *           ' reflections'
         end if
      end do
      call shellrf(nfcal,scale,isext)  ! printout r-factor in each shell
c     end if
      return
      end

      subroutine shellrf(nfcal,scale,isext)  ! printout r-factor in each shell
c     fo fc list for single crystal method
      include 'qcdiff.inc'
      include 'hklmf.inc'
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer nd(nhkl),st(nhkl,2)
      real qkd(nhkl),q(6),qi(nhkl)

      call vcpyr(qk,qkd,nfcal)
      call qsort(qkd,st,nd,nfcal)

      call initshell0()
      do j=1,nfcal
         i=nd(j)
         if(isext.eq.0) then
            fow=fo(i)/scale
         else
            fow=fo(i)/scale/ext(i)
         end if
         dfoc=fow-abs(fc(i))
c         write(6,*) 'fow,dfoc,fo,fc',fow,dfoc,fo(i),abs(fc(i))
         call shell0(qk(i),1.0,dfoc,fow)    ! for R
c        call shell1(qk(i),wg(i),dfoc,fow)   ! for Rw
      end do      
      call wtshell()
      return
      end

      subroutine initshell0()
      real dfshellr(20),sfshellr(20),rshellr(20),dft,sft
      integer nshellr(20)
      common /cshell0/ dfshellr,sfshellr,rshellr,nshellr,dft,sft
      call zerov(dfshellr,20)
      call zerov(sfshellr,20)
      call zerovi(nshellr,20)
c      do ish=1,20
c         dfshellr(ish)=0
c         sfshellr(ish)=0
c         nshellr(ish)=0
c      end do
      dft=0
      sft=0
      return
      end

c           call shell0(qk(i),1.0,dfoc,fow)    ! for R
      subroutine shell0(absq,whgtd,df,fo)
      real dfshellr(20),sfshellr(20),rshellr(20),dft,sft
      integer nshellr(20)
      common /cshell0/ dfshellr,sfshellr,rshellr,nshellr,dft,sft
      do ish=1,20
         if(absq.gt.0.1*(ish-1).and.absq.le.0.1*ish) then
            dfshellr(ish)=dfshellr(ish)+abs(df)
            sfshellr(ish)=sfshellr(ish)+abs(fo)
            nshellr(ish) =nshellr(ish)+1
         end if
      end do
      return
      end

      subroutine wtshell()
      real dfshellr(20),sfshellr(20),rshellr(20),dft,sft
      integer nshellr(20)
      common /cshell0/ dfshellr,sfshellr,rshellr,nshellr,dft,sft
!     common /crshell/ real rshellr(20)

      do ish=1,20
         if(sfshellr(ish).gt.0) then
            rshellr(ish)=dfshellr(ish)/sfshellr(ish)
c            write(6,*) 'rshell,dfshell,sfshell=',
c     *           rshellr(ish),dfshellr(ish),sfshellr(ish)
         else
            rshellr(ish)=0
         end if
      end do

      write(6,*) 'Rshell and Sum_I of shells with 0.1 A**(-1) interval'
      write(6,*) 'qmax(1/A)  Resol.(A)   Rshell         Sum_Fo'

      do ish=1,20
         write(6,'(f8.5,f10.2,2x,f10.5,f15.1)') ish*0.1,10.0/ish,
     *        rshellr(ish),sfshellr(ish)
      end do
      return
      end

      function isatel(h,brv)
      integer h(*)
      character brv
      integer hp(6)
      integer sp(4,4)
      data sp /0, 2, 0,-1,
     *         1, 0, 1, 0,
     *         0, 1, 0, 1,
     *        -1, 0, 2, 0/
      if(brv .eq. 'p') then
         isatel=0
         return
      else if(brv .eq. 'f') then
c        face-centered lattice in icosahedral cases
c        h(j) is all even or all odd
         if(mod(h(1),2) .eq. 0) then
             isatel=0
         else
             isatel=1
         end if
         return
      else if(brv .eq. 'i') then
c          body-centered lattice in icosahedral and octagonal cases
c        ism is even or odd
         ism=h(1)+h(2)+h(3)+h(4)+h(5)+h(6)
         if(mod(ism,2) .eq. 0) then
             isatel=0
         else
             isatel=1
         end if
         return             
      else if(brv .eq. 's') then
c         satellite reflections in primitive bases
         call getsys(isys)
         if(isys .eq. 3) then
c           ism mod 5 is zero or not
            ism=h(1)+h(2)+h(3)+h(4)
            if(mod(ism,5) .eq. 0) then
               isatel=0
            else
               isatel=1
            end if
            return
         else if(isys .eq. 5) then
c           ism1 mod 3 is zero or not
c           ism2 mod 3 is zero or not
c            ism1=h(1)+h(3)+h(5)
c            ism2=h(2)+h(4)+h(6)

c            do i=1,4
c               hp(i)=0
c               do j=1,4
c                  hp(i)=hp(i)+sp(i,j)*h(j)
c               end do
c            end do
            call mtmplimno(sp,h,hp,4,4,1)

            if(mod(hp(1),3) .eq. 0.and.mod(hp(2),3) .eq. 0.and.
     *         mod(hp(3),3) .eq. 0.and.mod(hp(4),3) .eq. 0.) then
               isatel=0
            else
               isatel=1
            end if
            return
         else if(isys .le.2) then
c           h(j) is all even or all odd (f-center)
            if(mod(h(1),2) .eq. 0) then
               isatel=0
            else
               isatel=1
            end if
            return   
         end if          
      else
         isatel=0
         return
      end if
      isatel=0
      return
      end

      subroutine corrm(m,d,n)
      real m(*),d(*)
      common /cwflag/ iwflag(7)
      real mtrxrdiag
      if(iwflag(7) .eq. 0) then ! write correlation matrix
         return
      end if
      k=0
      do i=1,n
c        d(i)=sqrt(m(i*(i+1)/2))
         d(i)=sqrt(mtrxrdiag(m,i)) ! sqrt of diagonal term of trianguler matrix
      end do

      do i=1,n
         do j=1,i
            k=k+1
            m(k)=m(k)/(d(i)*d(j))
         end do
      end do

      call wttangmtrxr_f(' ',m,n,'20f6.2')
c      do i=1,n
c         write(6,'(1h ,20f6.2)') (m(i*(i-1)/2+j),j=1,i)
c      end do
      return
      end

      subroutine rdmtrt(x)
      real x(*)
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /ctorms3/ hwhm(4,idsmax),gamma(idsmax),uvw(2,idsmax),
     *           sgm(idsmax),p1(idsmax),p2(idsmax),as(idsmax)
      common /ctorms6/ cp(0:2,idsmax),pp(0:9,idsmax),pg(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /atomp2/ y(3,3)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cd(5,15),icn(5,15)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getiwl,getisxt,getmthd

      l=0
      do id=1,ids
         isext=abs(getisxt(id))
         if(getmthd(id) .eq. 1) then    ! single crystal
            if(isext.eq.1) then ! isotropic extinction corrections
               do i=0,2
                  l=l+1
                  x(l)=pb(i,id)
               end do
            else if(isext.eq.2) then ! anisotropic extinction corrections
               do i=0,3
                  l=l+1
                  x(l)=pb(i,id)
               end do
            else                ! no extinction corrections
               l=l+1
               x(l)=pb(0,id)
            end if
            l=l+1
            x(l)=getbia(id)     ! overall temperature factor
         else                   ! powder
            if(getiwl(id).le.10) then  ! xray or thermal neutron
               do i=0,25
                  l=l+1
                  if(i .ge.0.and.i .le.12) then
                     x(l)= pb(i,id)
                  else if(i .eq. 13) then
                     x(l)=as(id)
                  else if(i .ge.14.and.i .le.15) then
                     x(l)=uvw(i-13,id)
                  else if(i .eq. 16) then
                     x(l)=gamma(id)
                     if(gamma(id) .lt.0) x(l)=0
                     if(gamma(id) .gt.1) x(l)=1
                  else if(i .ge.17.and.i .le.20) then
                     x(l)=hwhm(i-16,id)
                     if(hwhm(i-16,id) .lt.0) x(l)=0
                  else if(i .eq. 21) then
                     x(l)=pg(id)
                  else if(i .eq. 22) then
                     x(l)=sgm(id)
                  else if(i .eq. 23) then
                     x(l)=p1(id)
                  else if(i .eq. 24) then
                     x(l)=p2(id)
                  else if(i .eq. 25) then
                     x(l)=zps(1,id)
                  end if
               end do
               if(getiwl(id).eq.10) then ! xray or thermal neutron
                  l=l+1
                  x(l)=cp(1,id)
               end if
            else                ! TOF neutron
               do i=0,12
                  l=l+1
                  x(l)= pb(i,id)
               end do
               do i=0,9
                  l=l+1
                  x(l)=pp(i,id)
               end do
               l=l+1
               x(l)=pg(id)
               l=l+1
               x(l)=sgm(id)
               l=l+1
               x(l)=p1(id)
               l=l+1
               x(l)=p2(id)
               do i=0,2
                  l=l+1
                  x(l)=cp(i,id)
               end do
            end if
            l=l+1
            x(l)=getbia(id)   ! overall phason temperature factor
            if(id.eq.ids) then
c               write(6,'(10f10.5)') (x(i),i=1,27*ids)
            end if
         end if
      end do
      do l1=1,nlp
          l=l+1
          do l2=1,1
             l0=il(l2,l1)
             if(l0 .eq. 1) then
                x(l)=al/cd(1,l1)
             else if(l0 .eq. 2) then
                x(l)=cl/cd(1,l1)
             else if(l0 .eq. 3) then
                x(l)=eps1/cd(1,l1)
             else if(l0 .eq. 4) then
                x(l)=eps2/cd(1,l1)
             else if(l0 .eq. 5) then
                x(l)=eps3/cd(1,l1)
             else if(l0 .eq. 6) then
                x(l)=eps4/cd(1,l1)
             else if(l0 .eq. 7) then
                x(l)=eps5/cd(1,l1)
             else if(l0 .eq. 8) then
                x(l)=eps6/cd(1,l1)
             end if
          end do
       end do
      return
      end


      subroutine wtprm(x,df,ny)
      real x(*),df(*)
      call prmtbl(df,ny)        ! write structural parameters
      call wtltcc(x(ny+1),df(ny+1)) ! write other parameters
      call wtvol(1) 
      return
      end


      subroutine getwx(wx,i,df,ny)
      character*6 wx(*)
      real df(*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      integer idf(18)
      nwx=18
      do j=1,nwx
         wx(j)='(----)'
         idf(j)=0
      end do
      n0=0
      do l=1,ny
         if(ips(l) .eq. 1) then
            do k=1,jz(l)
               n=n0+k
               ii=ja(1,n)
               j=ja(2,n)
               if(ii .eq. i) then
                  if(j.le.10) then
                     idf(j)=idf(j)+df(l)*ea(n)*100
                     write(wx(j),'(a,i4,a)') '(',idf(j),')'
                  else
                     idf(j)=idf(j)+df(l)*ea(n)*10000
                     write(wx(j),'(a,i4,a)') '(',idf(j),')'
                  end if
               end if
            end do
         end if
         n0=n0+jz(l)
      end do
      return
      end

      subroutine setltcc(x)     ! set lattice and profile parameters
      real x(*)
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /ctorms3/ hwhm(4,idsmax),gamma(idsmax),uvw(2,idsmax),
     *           sgm(idsmax),p1(idsmax),p2(idsmax),as(idsmax)
      common /ctorms6/ cp(0:2,idsmax),pp(0:9,idsmax),pg(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /atomp2/ y(3,3)
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cd(5,15),icn(5,15)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      integer nl0(15)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getiwl,getisxt,getmthd

      l=0
      do id=1,ids
         if(getmthd(id) .eq. 0) then ! powder 
            if(getiwl(id).le.10) then
               do i=0,12        ! scale and background parameters
                  l=l+1
                  pb(i,id)=x(l) ! l=1-13
               end do
               do i=13,25
                  l=l+1
                  if(i .eq. 13) then
                     as(id)=x(l)
                     if(as(id) .lt.0) as(id)=0
                  else if(i .ge.14.and.i .le.15) then
                     uvw(i-13,id)=x(l)
                  else if(i .eq. 16) then
                     gamma(id)=x(l)
                     if(gamma(id) .lt.0) gamma(id)=0
                     if(gamma(id) .gt.1) gamma(id)=1
                  else if(i .ge.17.and.i .le.20) then
                     hwhm(i-16,id)=x(l)
                     if(hwhm(1,id) .lt.0) hwhm(1,id)=0
                     if(hwhm(2,id) .lt.0) hwhm(2,id)=0
                  else if(i .eq. 21) then
                     pg(id)=x(l)
                  else if(i .eq. 22) then
                     sgm(id)=x(l)
                  else if(i .eq. 23) then
                     p1(id)=x(l)
                  else if(i .eq. 24) then
                     p2(id)=x(l)
                  else if(i .eq. 25) then
                     zps(1,id)=x(l)
                  end if
               end do
               if(getiwl(id).eq.10) then ! add c1
                  l=l+1
                  cp(1,id)=x(l)
               end if
               l=l+1
               call setbia(id,x(l))
            else
               do i=0,12        ! scale and background parameters
                  l=l+1
                  pb(i,id)=x(l)
               end do
               do i=0,9         ! profile parameters
                  l=l+1
                  pp(i,id)=x(l)
               end do
               pg(id)=x(l+1)    ! extinction parameter
               sgm(id)=x(l+2)   ! absorption parameter
               p1(id)=x(l+3)    ! preferred orientation parameters
               p2(id)=x(l+4)
               l=l+4
               do i=0,2
                  l=l+1
                  cp(i,id)=x(l) ! 0-th, 1-st and 2-nd order scaling factors
               end do
               l=l+1
               call setbia(id,x(l)) ! add bia
            end if
         else                   ! single crystal
            isext=abs(getisxt(id))
            if(isext.eq.1) then   
               pb(0,id)=x(l+1)  ! scale
               pb(1,id)=x(l+2)  ! extinction parameter 1
               pb(2,id)=x(l+3)  ! extinction parameter 2
               linc=3
               l=l+linc
            else if(isext.eq.2) then   
               pb(0,id)=x(l+1)  ! scale
               pb(1,id)=x(l+2)  ! extinction parameter 1
               pb(2,id)=x(l+3)  ! extinction parameter 2
               pb(3,id)=x(l+4)  ! extinction parameter 3
               linc=4
               l=l+linc
            else
               pb(0,id)=x(l+1)  ! scale
               linc=1
               l=l+linc
            end if
            l=l+1
            call setbia(id,x(l)) ! add bia
c           write(6,*) 'id,pb in setltcc=',id,(pb(j,id),j=0,linc-1)
         end if
      end do
      
      do j=1,15
         nl0(j)=0
      end do
      
      do l1=1,nlp               ! lattice parameters
         l=l+1
         do l2=1,1
            l0=il(l2,l1)
            nl0(l0)=nl0(l0)+1
            if(l0 .eq. 1) then
               al=x(l)*cd(l2,l1)
            else if(l0 .eq. 2) then
               cl=x(l)*cd(l2,l1)
            else if(l0 .eq. 3) then
               eps1=x(l)*cd(l2,l1)
            else if(l0 .eq. 4) then
               eps2=x(l)*cd(l2,l1)
            else if(l0 .eq. 5) then
               eps3=x(l)*cd(l2,l1)
            else if(l0 .eq. 6) then
               eps4=x(l)*cd(l2,l1)
            else if(l0 .eq. 7) then
               eps5=x(l)*cd(l2,l1)
            else if(l0 .eq. 8) then
               eps6=x(l)*cd(l2,l1)
            end if
         end do
      end do
      return
      end

      subroutine wtltcc(x,df)
      real x(0:*),df(0:*)
c     real x(*),df(*)
      include 'qcdiff.inc'
      common /ctorms0/ job,ids
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /atomp2/ y(3,3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cd(5,15),icn(5,15)
      character*4 wx(0:50)
      character*4 wabc(8)
      integer ig(8),iabc(8)
      integer nl0(15)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      integer getiwl,getnpf,getisxt,getmthd
      save ao,co,eps1o,eps2o,eps3o,eps4o,eps5o,eps6o,ic
      data ic/0/

c      write(6,'(10f10.5)')  (x(i-1),i=1,27*ids)
      iwc=0
      j0=0
      do id=1,ids
         if(getmthd(id) .eq. 0) then    ! powder method
            iwc=1
            if(ids .gt.1) then
               write(6,*) ' data set',id
            end if
            do i=0,getnpf(id)-1
               if(ipt(j0+i) .eq. 1) then
                  idf=df(j0+i)*100000
                  write(wx(i),'(i4)') idf
               else
                  wx(i)='----'
               end if
            end do
            write(6,'(1h ,a,f10.5,3a,6(f9.5,3a)/1h ,19x,6(f9.5,3a))')
     *           'pb=', (x(j0+j),'(',wx(j),')',j=0,12)
            j1=j0+12
c            write(6,*) 'j0,j1=',j0,j1
            if(getiwl(id) .le.10) then  ! xray or thermal neutron
               write(6,'(1h ,a,f8.5,3a)') 'as   =',x(j1+1),'(',
     *              wx(13),')'
               
               write(6,'(1h ,a,2(f8.5,3a))') 'u,v  =',(x(j1+j),
     *              '(',wx(j+12),')',j=2,3)
               write(6,'(1h ,a,f8.5,3a)') 'gamma=',x(j1+4),'(',
     *              wx(16),')'
               write(6,'(1h ,a,4(f8.5,3a))') 'hwhm =',
     *              (x(j1+j),'(',wx(j+12),')',j=5,8)
               write(6,'(1h ,a,f8.5,3a)') 'pg   =',x(j1+9),'(',
     *              wx(21),')'
               write(6,'(1h ,a,f8.5,3a)') 'sgm  =',x(j1+10),'(',
     *              wx(22),')'
               write(6,'(1h ,a,2(f8.5,3a))') 'p1,p2=',
     *              (x(j1+j),'(',wx(j+12),')',j=11,12)
               write(6,'(1h ,a,f8.5,3a)') 'zps  =',x(j1+13),'(',
     *              wx(25),')'
               j0=j0+25
               if(getiwl(id).eq.10) then
                  write(6,'(1h ,a,f8.5,3a)') 'c1   =',x(j1+14),'(',
     *                 wx(26),')'
                  j0=j0+1
               end if
            else                      ! TOF neutron
               write(6,'(1h ,a,4(f8.5,3a))') 'sij=',(x(j1+j),
     *              '(',wx(j+12),')',j=1,4)
               write(6,'(1h ,a,4(f8.5,3a))') 'gij=',(x(j1+j),
     *              '(',wx(j+12),')',j=5,8)
               write(6,'(1h ,a,2(f8.5,3a))') 'ri =',(x(j1+j),
     *              '(',wx(j+12),')',j=9,10)
               write(6,'(1h ,a,f8.5,3a)') 'pg =',x(j1+11),'(',
     *              wx(12+11),')'
               write(6,'(1h ,a,f8.5,3a)') 'sgm  =',x(j1+12),
     *              '(',wx(12+12),')'
               write(6,'(1h ,a,2(f8.5,3a))') 'pi =',
     *              (x(j1+j),'(',wx(j+12),')',j=13,14)
               write(6,'(1h ,a,3(f8.5,3a))') 'cp =',
     *              (x(j1+j),'(',wx(j+12),')',j=15,17)
               j0=j0+29
            end if
                                ! overall phason temperature factor
            j0=j0+1
            if(ipt(j0) .eq. 1) then
               idf=df(j0)*100000
               write(wx(0),'(i4)') idf
            else
               wx(0)='----'
            end if
            write(6,'(3(a,f10.5,3a))') ' bia=',x(j0),'(',wx(0),')'
            j0=j0+1
         else if(getmthd(id) .eq. 1) then    ! single crystal method
            if(ids .gt.1) then
               write(6,*) ' data set',id
            end if
            isext=abs(getisxt(id))
            write(6,*) 'id,isext in wtltcc',id,isext
            if(isext.eq. 0) then         ! no extinction correction
               if(ipt(j0) .eq. 1) then
                  idf=df(j0)*100000
                  write(wx(0),'(i4)') idf
               else
                  wx(0)='----'
               end if
               write(6,'(3(a,f10.5,3a))') ' scl=',x(j0),'(',wx(0),')'
               j0=j0+1
               ! overall temperature factor
               if(ipt(j0) .eq. 1) then
                  idf=df(j0)*100000
                  write(wx(0),'(i4)') idf
               else
                  wx(0)='----'
               end if
               write(6,'(3(a,f10.5,3a))') ' bia=',x(j0),'(',wx(0),')'
               j0=j0+1
            else if(isext.eq.1) then  ! isotropic extinction correction
               do i=0,2
                  if(ipt(j0+i) .eq. 1) then
                     idf=df(j0+i)*100000
                     write(wx(i),'(i4)') idf
                  else
                     wx(i)='----'
                  end if
               end do
               write(6,'(3(a,f10.5,3a))') ' scl=',x(j0),'(',wx(0),')',
     *              ' ads=',x(j0+1),'(',wx(1),')',' ama=',x(j0+2),
     *              '(',wx(2),')'

               j0=j0+3
               ! overall temperature factor
               if(ipt(j0) .eq. 1) then
                  idf=df(j0)*100000
                  write(wx(0),'(i4)') idf
               else
                  wx(0)='----'
               end if
               write(6,'(3(a,f10.5,3a))') ' bia=',x(j0),'(',wx(0),')'
               j0=j0+1
            else if(isext.eq.2) then  ! anisotropic extinction correction
               do i=0,3
                  if(ipt(j0+i) .eq. 1) then
                     idf=df(j0+i)*100000
                     write(wx(i),'(i4)') idf
                  else
                     wx(i)='----'
                  end if
               end do
               write(6,'(4(a,f10.5,3a))') ' scl=',x(j0),'(',wx(0),')',
     *              ' ads=',x(j0+1),'(',wx(1),')',' adsa=',x(j0+2),
     *              '(',wx(2),')',' ama=',x(j0+3),'(',wx(3),')'

               j0=j0+4
               ! overall temperature factor
               if(ipt(j0) .eq. 1) then
                  idf=df(j0)*100000
                  write(wx(0),'(i4)') idf
               else
                  wx(0)='----'
               end if
               write(6,'(3(a,f10.5,3a))') ' bia=',x(j0),'(',wx(0),')'
               j0=j0+1
            end if
         else
            call quit('invalid mthd')
         end if
      end do

      ic=ic+1
      if(ic .eq. 1) then
          ao=al
          co=cl
          eps1o=eps1
          eps2o=eps2
          eps3o=eps3
          eps4o=eps4
          eps5o=eps5
          eps6o=eps6
      end if
      iabc(1)=(al-ao)*10000
      iabc(2)=(cl-co)*10000
      iabc(3)=(eps1-eps1o)*100000
      iabc(4)=(eps2-eps2o)*100000
      iabc(5)=(eps3-eps3o)*100000
      iabc(6)=(eps4-eps4o)*100000
      iabc(7)=(eps5-eps5o)*100000
      iabc(8)=(eps6-eps6o)*100000
      do i=1,8
         ig(i)=0
      end do

c     l=j0-1
c      write(6,*) 'nlp in wtltcc=',nlp
c      write(6,*) 'j0,ipt(j0+1) in wtltcc=',j0,ipt(j0+1)
      do l1=1,nlp   ! l1-th independent lattice parameter
         do l2=1,ntl(l1)
            l0=il(l2,l1)
            if(l0.lt.1.or.l0.gt.8) then
               call quit('invalid lattice parameter selection')
            end if
            nl0(l0)=nl0(l0)+1
            if(l0.le.8.and.ipt(j0+l1-1).eq.1) then
               ig(l0)=1
            end if
         end do
      end do

      do i=1,8
         if(ig(i) .eq. 1) then
            write(wabc(i),'(i4)') iabc(i)
         else
            wabc(i)='----'
         end if
      end do
      call getsys(isys)
      if(iwc .eq. 1) then
          write(6,*) ' lattice parameters'
          if(isys .le.2) then
              write(6,'(1h ,3(a,f9.4,3a))') 'a =',al,'(',wabc(1),')'
          else
              write(6,'(1h ,3(a,f9.4,3a))') 'a =',al,'(',wabc(1),')',
     *        ' c =',cl,'(',wabc(2),')'
          end if
          write(6,'(1h ,6(a,f9.5,3a))') 'eps1=',eps1,'(',wabc(3),')',
     *     ' eps2=',eps2,'(',wabc(4),')',' eps3=',eps3,'(',wabc(5),')',
     *     ' eps4=',eps4,'(',wabc(6),')',' eps5=',eps5,'(',wabc(7),')',
     *     ' eps6=',eps6,'(',wabc(8),')'
      end if
      ao=al
      co=cl
      eps1o=eps1
      eps2o=eps2
      eps3o=eps3
      eps4o=eps4
      eps5o=eps5
      eps6o=eps6
      return
      end

      subroutine wtx(x,nx,iw,ids)
      dimension x(*),iw(*)
      real k(14)
      common /const/ pai2,jk(14)
      include 'qcdiff.inc'
c     common /ctorms0/ job,ids
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
c      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
c     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      integer getiwl,getmthd
      character*4 no,iw
      data no/'#'/

      ie=jk(14)+1

c      do i=1,14
c         k(i)=jk(i)
c      end do
      call vcpyir(jk,k,14)  ! copy integer vector to real vector

      do i=1,14,2
         if(k(i).gt.k(i+1)) then
            k(i)=0
            k(i+1)=0
         end if
      end do
      write(6,204) 1,ie

      do id=1,ids
         if(getmthd(id) .eq. 0) then
            if(getiwl(id) .le.10) then
               write(6,'(1h ,(2(a,i3)))')
     *              'scale(',ie,
     *              ') backgr.(',ie+1,'-',ie+12,
     *              ') assym.(',ie+13,
     *              ') u,v(',ie+14,'-',ie+15,
     *              ') gamma(',ie+16,
     *              ') hwhm (',ie+17,'-',ie+20,
     *              ') pg(',ie+21,
     *              ') sgm(',ie+22,
     *              ') p1,p2(',ie+23,'-',ie+24,
     *              ') z.p.s.(',ie+25,')',
     *              ') c1.(',ie+26,')',
     *              ') bia(',ie+27,')'
               ie=ie+26
            else if(getiwl(id) .eq. 11) then
               write(6,'(1h ,(2(a,i3)))')
     *              'scale(',ie,
     *              ') backgr.(',ie+1,'-',ie+12,
     *              ') pp(',ie+13,'-',ie+22,
     *              ') pg(',ie+23,
     *              ') sgm(',ie+24,
     *              ') p1,p2(',ie+25,'-',ie+26,
     *              ') cp(',ie+27,'-',ie+28,')',
     *              ') bia(',ie+29,'-',ie+29,')'
               ie=ie+30
            end if
         end if
      end do
      write(6,'(2(a,i3),a)') 'latt.p.(',nx-nlp+1,'-',nx,')'
      write(6,205) (no,i,x(i),iw(i),i=1,nx)
      write(6,203)
 203  format(1h )
 204  format(1h ,'structural parameters(',i3,'-',i3,')')
 205  format((1h ,8(a1,i3,1x,f8.4,a1,1x)))
      return
      end

      subroutine setid(idd)
      common /cid/ id
      id=idd
      return
      end

      integer function getid()
      common /cid/ id
      getid=id
      return
      end

      subroutine setpt(itrv)
      integer p0(6,6),p1(6,6),p2(6,6)
      common /cpt/ pt(6,6)
      data p0/1, 0, 0, 0, 0, 0, 
     *        0, 1, 0, 0, 0, 0, 
     *        0, 0, 1, 0, 0, 0, 
     *        0, 0, 0, 1, 0, 0, 
     *        0, 0, 0, 0, 1, 0,
     *        0, 0, 0, 0, 0, 1/
      data p1/3, 1, -1, 2, 0, 0,
     *       -2, 1, -1,-3,  0, 0,
     *        3, 1,  4, 2,  0, 0,
     *       -2, 1, -1, 2,  0, 0,
     *        0, 0,  0, 0,  5, 0,
     *        0, 0,  0, 0,  0, 5/
      data p2/ 1, 0, 0, -1, 0, 0, 
     *         1, 2, 1,  1, 0, 0, 
     *        -1, 0, 1,  0, 0, 0, 
     *         0, -1, 0, 1, 0, 0, 
     *         0,  0, 0, 0, 1, 0, 
     *         0,  0, 0, 0, 0, 1/
c        p1 should be divided by 5 after transformation

      call mtrnspi6(p1)   ! take transpose
      call mtrnspi6(p2)   ! take transpose
      call getsys(isys)

      if(itrv .eq. 0) then
         call mcpyir6(p0,pt)
      else if(isys .eq. 3.and.itrv .eq. 1) then
         call mcpyir6(p2,pt)
      else
         call quit('invalid itrv')
      end if
      return
      end

      subroutine trvh(jh)
      integer jh(6)
      integer pt
      common /cpt/ pt(6,6)
      integer ih(6)
      do i=1,6
         call mtmplimno(jh,pt,ih,1,6,6)
c         ih(i)=0
c         do j=1,6
c            ih(i)=ih(i)+jh(j)*pt(j,i)
c         end do
      end do
      call vcpyi(ih,jh,6)
c      do i=1,6
c         jh(i)=ih(i)
c      end do
      return
      end

      subroutine getpt(ptd)
      real ptd(6,6)
      integer pt
      common /cpt/ pt(6,6)
      call mcpyir6(pt,ptd)
      return
      end

      subroutine geta1a2(a1d,a2d)
      common /ca1a2/ a1,a2
      a1d=a1
      a2d=a2
      return
      end

      subroutine seta1a2(a1d,a2d)
      common /ca1a2/ a1,a2
      a1=a1d
      a2=a2d
      return
      end

      subroutine rdiob0(iwght,id)
      common /cwflag/ iwflag(7)
      integer hm
      include 'qcdiff.inc'
      character*80 fmt,flnm1
      common /ctorms0/ job,ids
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *     inp(idsmax),iorf(idsmax),fmt(idsmax)
      common /chkln/ iex(6),hm(6,idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      real mu
      common /citrv/ itrv(idsmax)
      integer getisxt,getmthd

      call getinp(inpu)
      call getout(iout)
c     read(inpu,105) fnsig,fminc,wg0,hm,nst
      call freadrs('fnsig=',1,fnsig(id),1)
      call freadrs('fminc=',1,fminc(id),0)
      call freadrs('wg0=',1,wg0(id),0)
c     call freadia('hm=',6,hm(1,id),0)
      call freadis('nst=',1,nst(id),0)
      call freadis('itrv=',1,itrv(id),0)
      call freadis('isext=',1,isext,0)
      if(isext.ne.0) then
         call freadis('imthd=',1,imthd,0)   ! 4-circle (0) or weissen (1)
         call setimthd(id,imthd)
         if(getmthd(id) .eq. 1) then
            call freadrs('mu=',1,mu,0)
            call setmu(id,mu)            
         end if
      else
         call setimthd(id,0)
         call setmu(id,0.0)            
      end if
      call setisxt(id,isext)
c      if(id.eq.2) then
c         stop
c      end if

      call setpt(itrv(1))
      if(iwflag(3) .eq. 1) then
         write(iout,201) fnsig(id),fminc(id),wg0(id),nst(id),itrv(id),
     *        isext
      end if
c     read(inpu,100) fmt
      call freadis('iorf=',1,iorf(id),1)
      call freadcs('format=',1,fmt(id),0)
      call freadis('iavrg=',1,iavrg,0)
      call setiavrg(id,iavrg)
      write(iout,*) 'iorf=',iorf(id),' format=', fmt(id),
     *     'iavrg=',iavrg

      call freadrs('scl=',1,pb(0,id),1)
      if(abs(isext).eq.1) then
         call freadrs('ads=',1,pb(1,id),0)
         call freadrs('ama=',1,pb(2,id),0)
      else if(abs(isext).eq.2) then
         call freadrs('ads=',1,pb(1,id),0)
         call freadrs('adsa=',1,pb(2,id),0)
         call freadrs('ama=',1,pb(3,id),0)
      end if
      call freadrs('bia=',1,biar,1)
      call setbia(id,biar)
c     data for secondary extinction corrections
      call rdextc(isext)
      call saveextc(id)
c     isx=getisxt(id)
c     call freadcs('flnm1=',1,flnm1,1)
c     call setflnm1(flnm1,id)
c     lfn1=istrln(flnm1)
c     write(6,'(2a)') 'flnm1=',flnm1(1:lfn1)
c     return
 201  format(1h ,'fnsig=',f10.5,' fminc=',f12.6,' wg0=',f12.6,
     *     ' nst=',i2,' itrv=',i2,' isext=',i2)
 202  format(1h ,'format=',a)
      end

      integer function getiorf(id)
      include 'qcdiff.inc'
      common /cwflag/ iwflag(7)
      integer ih(6),jh(6)
      character*80 fmt
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *     inp(idsmax),iorf(idsmax),fmt(idsmax)
      getiorf=iorf(id)
      return
      end

      subroutine rdiob2(iwght,hs,nrefl,id) ! copy input
      integer hs(6,*)
      include 'qcdiff.inc'
      common /cwflag/ iwflag(7)
      integer ih(6),jh(6)
      common /caydm/ aydm,alp,ifunc
      character*80 fmt
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *     inp(idsmax),iorf(idsmax),fmt(idsmax)
      common /citrv/ itrv(idsmax)
      integer hm
      common /chkln/ iex(6),hm(6,idsmax)
      include 'hklmf.inc'
      integer getidm,getiavrg

      common /cim/ im(20)
      character brv
      integer ncycle(20)
      character*50 frmt
      real q(6)
      save ncycle
      data ncycle /0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/
c    *************** this does not work for ids>1****************
c      ncycle(id)=ncycle(id)+1
c      if(ncycle(id).gt.1) then
c         return
c      end if
      call setsmtrm(nst(id))
      idm=getidm()
      call getinp(inpu)
      call getout(iout)
      call getsys(isys)
      i=0
      iw1=0

      rewind 3
      i=0
      nrefl=0
      ntotal=0
      nrejct=0
 10   continue
*********************Oct, 26, 2000
      read(3,fmt(id),end=11)    (ih(j),j=1,idm),aiobs,rwg
      if(ih(1) .eq. 999) go to 11

c     if(rwg.eq.0) then
c        if(iwght.eq.2) then
c           write(6,*) 'ih=',(ih(j),j=1,idm),aiobs,rwg
c     call quit('sigm=0 is not allowed for iwght=2')
c        end if
c     end if

      ntotal=ntotal+1
      i=i+1
      call getfosgf(aiobs,rwg,fobs,sigm,iorf(id)) ! get fobs, sigmf
      fns=fnsig(id)
      iext=iextnct(ih)          ! flag for rejected reflections
      call getfrmthklfs(idm,frmt)
      if(iext .eq. 1) then
         nrejct=nrejct+1
         write(6,frmt) 'rejected by extinction rule ',
     *        (ih(j),j=1,idm), fobs,sigm
         go to 10
      end if

      call smtrh(ih,jh,nst(id))
      if(isys .eq. 5) then
         call trvh(jh)
      end if

      isgm=iorf(id)
      iscut=isgmcut(fobs,sigm,fns,isgm,iwght)
      iqcut=iaymcut(ih,aydm)
      if(iscut.eq.0.and.iqcut.eq.0) then
         nrefl=nrefl+1
         if(nrefl .gt.nhkl) call quit('nrefl .gt. nhkl')
         call vcpyi(jh,hklm(1,nrefl),6)
         fo(nrefl)=fobs
         sigmf(nrefl)=sigm
      end if
      go to 10
 11   continue
      if(iwflag(3) .eq. 1) then
         write(iout,'(a,i2)') 'data set', id
         write(iout,'(a,i8)') 'number of total reflections      ',
     *        ntotal
         write(iout,'(a,i8)') 'number of rejected reflections   ',
     *        nrejct
         write(iout,'(a,i8)') 'number of reflections >=sgn*sigma',
     *        nrefl
      end if
      im(id)=nrefl  ! number of reflections in id-th data set
      iavrg=getiavrg(id)
      if(iavrg.eq.1) then
         isgn=iorf(id)
c         write(6,*) 'isgn=',isgn,' iwght=',iwght
c         write(6,*) 'fnsig=',fns,' nrefl=',nrefl
c        iweq=1  ! print out hkl for equivalent reflections
         iweq=0  ! do not print out hkl for equivalent reflections
         call setiweq(iweq)
         call average(nrefl,fns,isgn)
      end if
      do i=1,nrefl
         call vcpyi(hklm(1,i),hs(1,i),6)
         call getqi(hklm(1,i),q)
         expa=exp(-alp*vabs(q,3))  ! dumping factor for weight
c        write(6,*) 'expa=',expa
         wg(i)=wghtf(fo(i),sigmf(i),iwght,fminc(id),sigmf(i),wg0(id),
     *        expa)
      end do
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i4)
      end

      function iaymcut(ih,aydm)  ! cut against diffraction vector
      integer ih(*)
      real q(6)
      integer getidm
      idm=getidm()
      call getqi(ih,q)
      absq=vabs(q,3) ! external comp. of diffraction vector
      if(absq.gt.aydm) then
         iaymcut=1
      else
         iaymcut=0
      end if
      return
      end

      function isgmcut(fobs,sigmf,sgn,isgm,iwght)
      isgmcut=0
      if(isgm.eq.0) then  ! sigmi cut
c     if(iwght.eq.2) then
c         sgni=sgn*((fobs+sigmf)**2-fobs**2)
         sgni=sgn*sigmf*2*fobs
         if(fobs**2.ge.sgni) then
            return
         end if
c     end if
      else if(isgm.eq.1) then ! sigmf cut
c     if(iwght.eq.2) then
            if(fobs.ge.sgn*sigmf) then
               return
            end if
c     end if
      else
         write(6,*) 'isgm=',isgm
         call quit('invalid isgm in isgmcut')
      end if
      isgmcut=1
      return
      end
  
      subroutine rdiob1(iwght,nrefl,id)  ! old version
      include 'qcdiff.inc'
      common /caydm/ aydm,alp,ifunc
      common /cwflag/ iwflag(7)
      integer ih(6),jh(6)
      character*80 fmt
      common /cfmt/ fnsig(idsmax),fminc(idsmax),wg0(idsmax),nst(idsmax),
     *     inp(idsmax),iorf(idsmax),fmt(idsmax)
      common /citrv/ itrv(idsmax)
      integer hm
      common /chkln/ iex(6),hm(6,idsmax)
      integer getidm
      real q(6)
      character*50 frmt
      call getinp(inpu)
      call getout(iout)
      call getsys(isys)
      idm=getidm()
      call setsmtrm(nst(id))
      i=0
      iw1=0
      rewind 3
      i=0
      nrefl=0
 10   continue
      read(3,fmt(id),end=11)    (ih(j),j=1,6),aiobs,rwg
      if(ih(1) .eq. 999) go to 11

      i=i+1
      call getfosgf(aiobs,rwg,fo,sigmf,iorf(id)) ! get fo and sigmf

      iext=iextnct(ih)
      call getfrmthklfs(idm,frmt)
      if(iext .eq. 1) then
         write(6,frmt) 'rejected by extinction rule ',
     *        (ih(j),j=1,idm),fo,sigmf
         go to 10
      end if

      fns=fnsig(id)
      if(iwght.ne.2.or.(iwght.eq.2.and.fo.gt.fns*rwg)) then
         call smtrh(ih,jh,nst(id))
         if(isys .eq. 5) then
            call trvh(jh)
         end if
         nrefl=nrefl+1
         if(nrefl .gt.nhkl) call quit('nrefl .gt. nhkl')
         call getqi(i,q)
         expa=exp(-alp*vabs(q,3))
         wght=wghtf(fo,sigmf,iwght,fminc(id),sigmf,wg0(id),expa)
         write(91,'(6i4,2e13.6)') jh,fobs,wght
      end if
      go to 10
 11   continue
      if(iwflag(3) .eq. 1) then
         write(iout,200) i,nrefl
      end if
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i4)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5)
      end

      subroutine getfrmthklfs(idm,frmt)
      character*(*) frmt
      if(idm.eq.3) then
         frmt='(a,3i4,2f12.4)'
      else if(idm.eq.4) then
         frmt='(a,4i4,2f12.4)'
      else if(idm.eq.5) then
         frmt='(a,5i4,2f12.4)'
      else if(idm.eq.6) then
         frmt='(a,6i4,2f12.4)'
      end if
      return
      end

c      subroutine sethkl(hs,nrefl)
      subroutine sethkl(hs,nref)
      integer hs(6,*)
      include 'qcdiff.inc'
      include 'hklmf.inc'
      do i=1,nref
         call vcpyi(hs(1,i),hklm(1,i),6)         
      end do
      return
      end

      subroutine getfosgf(aiobs,rwg,fobs,sigm,iorf)
      if(iorf .eq. 0) then
         fobs=sqrt(aiobs)     ! aiobs=Iobs
         sigm=sqrt(aiobs+rwg)-sqrt(aiobs)
      else if(iorf .eq. 1) then
         fobs=aiobs           ! aiobs=Fobs
         sigm=rwg
      else
         call quit('invalid iorf. it should be 0 or 1.')
      end if
      return
      end

      function iextnct(h)
      integer h(*)
      common /cskip/ iskip,ltype
      complex pi2
      integer hr(6)
      complex ff
      real trc(6,32)
      real tt(6,60)
      integer getidm
      data pi2/(0.,6.28318)/
      data eps /0.01/

      call getnsyic(nsymo,icent)
      call gettrc(ltype,trc,ntrc)
      call gettr(tt)
      call getsys(isys)
      idm=getidm()

c     extinction due to centering translations
      if(ntrc .gt. 0) then
c         do i=1,nctr
         do i=1,ntrc
            ff=cexp(pi2*vinpir(h,trc(1,i),idm))
            if(abs(ff-1.0).gt.eps) then
               iextnct = 1
               return
            end if
         end do
      end if
c     extinction due to screw axes or glide planes
      do i=2,nsymo
        do j=0,icent
c           call gethr(h,hr,rr,i,j)
            call gethr0(h,hr,i,j)
            if(icomp(h,hr) .eq. 1) then
               ff=cexp(pi2*vinpir(h,tt(1,i),idm))
c              if(abs(1.0+ff) .lt. eps) then
               if(abs(ff-1.0) .gt. eps) then
                  iextnct = 1
                  return
               end if
            end if
         end do
      end do
      iextnct = 0
      return
      end

      subroutine cylnd(x,y,z,rx,ry,iskip)
      real x,y,z,rx,ry
      integer iskip, mthd
      real mu,nu
      common /ccylnd/ r,s
c     x : x  in cartesian coordinate of the diffraction vector
c     y : y  in cartesian coordinate
c     z : z  in cartesian coordinate
c     rx: angle  in cylindorical coordinate
c     ry: radius in cylindorical coordinate

c     r: effective radius for the layer
c     s: effective radius for the zero layer
c     nu: nu angle
      data eps/0.000001/
c
      call getcmthd(mthd)       ! get current method
      call getmu(mu)            ! get current mu
      rx=atan3(y,x)             ! -pi .lt. rx .le. pi  (x is parallel to X-ray)
      ry=sqrt(x**2+y**2)        ! radius 
      if(mthd .eq. 1) then        ! equi-inclination setting
         if(abs(z/2) .gt.1-eps) then
            iskip=1
            return
         end if
c        mu is calculated
         nu=asin(z/2)
         mu=nu
         r=cos(mu)
         s=cos(mu)
      else if(mthd .eq. 2.or.mthd .eq. 3) then ! inclined-beam setting
c        mu is given 
         if(abs(z-sin(mu)) .gt.1-eps) then
            iskip=2
            return
         end if         
         nu=asin(z-sin(mu))
         r=cos(nu)
         s=cos(mu)
      end if
      if(ry .lt.abs(s-r)+eps) then
         iskip=3
         return
      else if(ry .gt.s+r-eps) then
         iskip=4
         return
      end if
      iskip=0
      return
      end

      subroutine weis2(rx,ry,z,sx,sy,sz,rota,icond)
      real rx,ry,z,sx(2),sy(2),sz(2),rota(2)
      integer icond
c     phi angle calculation in diffraction condition
c       for a given diffraction vector there two positions or none
c       in the Weissenberg method.
c       if no solution icond=-1 else 0
c       
c     transformation of rx, ry into px, py
c     rx: angle in cylindorical coordinate
c     ry: radius in cylindorical coordinate (in 1/lambda)
c     z:  z-coordinate
c     r : radius of circle at z on Evald shpere
c         (z : z coordinate of cylindorical coordinate)
c     s : radius of circle at z=0 on Evald shpere
c             return values for two positions
c     sx,sy,sz: normal vector of the outward x-ray (diffracted beam)
c     rota: rotation angle in the diffraction condition
c
      real mu,phi,arg1,arg2,px,py,r,s
      data eps/0.000001/
      data pi /3.1415926/
      data pi2/6.2831853/
c     arg : angle on the film in radian

      call getrs(r,s)
      call getmu(mu)
c      call getrotm(rotmin,rotmax)
      icond=-1
      if(z .gt.1-eps) then
         return
      end if

      arg1=(r**2+s**2-ry**2)/(2*r*s)   ! r**2+s**2-2*r*s*cos(arg)=ry**2
      if(arg1 .lt.1-eps) then 
         phi=acos(arg1)      ! 0 .le. phi .le. pi
      else
         phi=0               ! no solution
         return
      end if

      arg2=(ry**2+s**2-r**2)/(2*ry*s)  ! ry**2+s**2-2*ry*s*cos(arg)=r**2
      if(arg2 .lt.1-eps) then
         rxd=acos(arg2)      ! 0 .le. rxd .le. pi
      else
         rxd=0.              ! no diffraction condition exists
         return
      end if
      px=pi-rxd     ! +px, -px : angles under the relection conditions
c                   ! from x-axis   (0 .lt. px .lt. pi)

c     first position
      sx(1)=r*cos(phi)   ! unit vector on a circle with radius r
      sy(1)=r*sin(phi)
      sz(1)=z-sin(mu)    ! z=sin(mu)+sin(nu) and sz=sin(nu)

      rota(1)=mod(px-rx,pi2)  ! sample rotation angle for the first position
c      if(rota(1) .gt.rotmax.and.rota(1)-pi2 .lt.rotmax) then
c         rota(1)=rota(1)-pi2
c      else if(rota(1) .lt.rotmin) then
c         rota(1)=rota(1)+pi2
c      end if

c     second position
      sx(2)=r*cos(phi)
      sy(2)=-r*sin(phi)
      sz(2)=z-sin(mu)

      rota(2)=mod(-px-rx,pi2)  ! sample rotation angle for the second position
c      if(rota(2) .gt.rotmax.and.rota(2)-pi2 .lt.rotmax) then
c         rota(2)=rota(2)-pi2
c      else if(rota(2) .lt.rotmin) then
c         rota(2)=rota(2)+pi2
c      end if
      icond=0
      return
      end

      subroutine setrs(r1,s1)
      common /ccylnd/ r,s
      r=r1
      s=s1
      return
      end

      subroutine getrs(r1,s1)
      common /ccylnd/ r,s
      r1=r
      s1=s
      return
      end

      subroutine setomt(phi,theta,psi)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call setomtr(phi,theta,psi,omtrx1)
      return
      end

      subroutine getomt(omtrx)
      real omtrx(3,3)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call mcpymn(omtrx1,omtrx,3,3)
      return
      end

c      subroutine getui(uid)
c      real uid(6,3)
c      common /cui/ ui(6,3)
c      do i=1,6
c         do j=1,3
c            uid(i,j)=ui(i,j)
c         end do
c      end do
c      return
c      end

      subroutine setomtr(phi,theta,psi,omtrx)
      real omtrx(3,3)
      omtrx(1,1)= cos(psi)*cos(phi)-cos(theta)*sin(phi)*sin(psi)
      omtrx(1,2)= cos(psi)*sin(phi)+cos(theta)*cos(phi)*sin(psi)
      omtrx(1,3)= sin(psi)*sin(theta)
      omtrx(2,1)=-sin(psi)*cos(phi)-cos(theta)*sin(phi)*cos(psi)
      omtrx(2,2)=-sin(psi)*sin(phi)+cos(theta)*cos(phi)*cos(psi)
      omtrx(2,3)= cos(psi)*sin(theta)
      omtrx(3,1)= sin(theta)*sin(phi)
      omtrx(3,2)=-sin(theta)*cos(phi)
      omtrx(3,3)= cos(theta)
      return
      end

      subroutine openfile(iun,flnm,st)
      integer iun
      character*(*) flnm,st

      lflnm=istrln(flnm)
      lst=istrln(st)
      open (unit=iun,file=flnm(1:lflnm),status=st(1:lst),err=910)
      go to 810
 910  write(6,*) 'can''t open ',flnm(1:lflnm)
      call exit(1)
 810  continue
      return
      end

      subroutine setflnm0(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm)
      flnm0(id)=flnm(1:lflnm)
      return
      end

      subroutine setflnm1(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm)
      flnm1(id)=flnm(1:lflnm)
      return
      end

      subroutine setflnm2(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm)
      flnm2(id)=flnm(1:lflnm)
      return
      end

      subroutine getflnm0(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm0(id))
      flnm=flnm0(id)(1:lflnm)
      return
      end

      subroutine getflnm1(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm0(id))
      flnm=flnm1(id)(1:lflnm)
      return
      end

      subroutine getflnm2(flnm,id)
      character*(*) flnm
      include 'qcdiff.inc'
      character*80 flnm0,flnm1,flnm2
      common /ctorms7 /flnm0(idsmax),flnm1(idsmax),flnm2(idsmax)
      lflnm=istrln(flnm0(id))
      flnm=flnm2(id)(1:lflnm)
      return
      end

      subroutine setpb01(id,x1) ! set scale factor
      real x1(*)
      common /ctodrw9/ pbt(0:12), dpbt(0:12), zpst(2)
      character*2 xray
      integer getmthd,geti0
      k=geti0(id-1)
      k=k+1
      x1(k)=pbt(0)              ! set scale
c     write(6,*) 'k,pbt(0)',k,pbt(0)
      if(getmthd(id).eq.0) then ! powder
         k=k+1
         x1(k)=pbt(1)         ! set average background for powder
      end if
      return
      end

      integer function getiwl(id)
      include 'qcdiff.inc'
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /cyo/ yo(nmax+2),qint(nmax+2)
      getiwl=iwl(id)
      return
      end

      subroutine setiwl(id,iwld)
      include 'qcdiff.inc'
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              rmaxi,nstp,fid(idsmax),alpha(idsmax),iyax(idsmax)
      common /cyo/ yo(nmax+2),qint(nmax+2)
      iwl(id)=iwld
      return
      end

      integer function getnpf(id)
      integer getiwl,getnpfx,getnpfn,getisxt,getmthd
      if(getmthd(id) .eq. 0) then   ! powder
         if(getiwl(id).le.10) then
            getnpf=getnpfx(id)
         else
            getnpf=getnpfn(id)
         end if
      else                      ! single crystal
         isext=abs(getisxt(id))
         if(isext.eq.0) then
            getnpf=2             ! scl bia
         else if(isext.eq.1) then
            getnpf=4             ! scal dms dma bia
         else if(isext.eq.2) then
            getnpf=5             ! scal dms dmsd dma bia
         end if
      end if
c      write(6,*) 'getnpf=',getnpf
c      stop
      return
      end

      subroutine setnpf(ids)
      integer getiwl
      do id=1,ids
         write(6,*) 'id,getiwl(id)=',id,getiwl(id)
         call setnpfx(id)   ! structural parameters
         call setnpfn(id)   ! profile parameters
c         write(6,*) 'id=',id,' getnpfx(id)=',getnpfx(id)
c         write(6,*) 'id=',id,' getnpfn(id)=',getnpfn(id)
c         write(6,*) 'id=',id,' getnpf(id)=',getnpf(id)
      end do
      return
      end

      subroutine setnpfx(id)
      include 'qcdiff.inc'
      common /cnpfxn/ npfx(idsmax), npfn(idsmax)
      integer getiwl
      if(getiwl(id).le.9) then
         npfx(id)=26+1    ! (bia is added)
      else if(getiwl(id).eq.10) then
         npfx(id)=27+1    ! (extra c1 and bia are included)
      end if
      return
      end

      integer function getnpfx(id)
      include 'qcdiff.inc'
      common /cnpfxn/ npfx(idsmax), npfn(idsmax)
      getnpfx=npfx(id)
      return
      end

      subroutine setnpfn(id)
      include 'qcdiff.inc'
      common /cnpfxn/ npfx(idsmax), npfn(idsmax)
      npfn(id)=30+1   ! (bia is added)
      return
      end

      integer function getnpfn(id)
      include 'qcdiff.inc'
      common /cnpfxn/ npfx(idsmax), npfn(idsmax)
      getnpfn=npfn(id)
      return
      end

      subroutine setxray(id,xrayd)
      character*2 xrayd
      include 'qcdiff.inc'
      character*2 xray
      common /cxray/ xray(idsmax)
      xray(id)=xrayd
      return
      end

      subroutine getxray(id,xrayd)
      integer id
      character*2 xrayd
      include 'qcdiff.inc'
      character*2 xray
      common /cxray/ xray(idsmax)
      xrayd=xray(id)
      return
      end
