      subroutine qcdff1()  ! read necessary information for structure factors
      character brv
      include 'qcdiff.inc'
      integer hsmax,hkmax
      parameter (hsmax=nhkl,hkmax=nhkl)
      common /ctorms0/ job,ids
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      real x(6,namax)
      character*72 title
      integer pcol
      common /cpcol/ pcol
      integer icase,inumb
      real amag,rdiff,shiftx,shifty,vel
      common /cplt/ icase,inumb,iplot,idiff,amag,rdiff,shiftx,shifty,
     *                                        vel,wmin

      common /cislct/ iaslct(120,namax),jaslct(120,namax)
      integer iaslct0(120)
      common /ceps/ eps
      common /bgn1/ ilm(3),icorc(3),pxj(100,3),hj(100,3)

      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /ccol/ icol
      
      integer iaslct1(120,namax)  ! flags for site symmetry operators

      integer sctmdl,getsctmdl,getish
      integer hmax
      integer hd
      common /cpref/ hd(6,120),iequiv,pop
      integer ih(6)
      integer getnsymo,geticent

      character*50 dummy
      character*72 flnm3,flnm4
      integer getmthd
      data ilm1/5/,ilm2/5/,ilm3/5/,ic1/1/,ic2/1/,ic3/1/
      data pi /3.141592/
      data de/36*0./, di/36*0./
c     initialize
      ilm(1)=ilm1
      ilm(2)=ilm2
      ilm(3)=ilm3
      icorc(1)=ic1
      icorc(2)=ic2
      icorc(3)=ic3
      pcol=1
      icol=10
c
      call setinp(5)
      call setout(6)

      call freadis('inpm=',1,inpm,1)
      call getsys(isys)

c      read(5,'(a)') title
      call freadcs('title=',1,title,1)
      write(6,'(1h ,a)') title
c     read(5,'(3f8.5,i3)') al,(cl),eps1,eps2,eps3,eps4,eps5,eps6
      call freadrs('a=',1,al,1)
      call seta(al)
      if(isys.ge.3) then
          call freadrs('c=',1,cl,0)
          call setc(cl)
      end if
      call freadrs('eps1=',1,eps1,0)
      call freadrs('eps2=',1,eps2,0)
      call freadrs('eps3=',1,eps3,0)
      call freadrs('eps4=',1,eps4,0)
      call freadrs('eps5=',1,eps5,0)
      call freadrs('eps6=',1,eps6,0)
      call seteps(eps1,eps2,eps3,eps4,eps5,eps6)
      call setsmtr(ismtr)
      call setsys(isys)
      call setd()         ! set lattice data for quasicrystals
      call setdei()       ! set phason strain

      call setprjop0()   ! calculate projection operator
      call setprjop()    ! calculate projection operator

      call getnst(nst)    ! get order of similarity transformation
      call setsmtrm(nst)  ! set similarity transformation matrix
      do id=1,ids
         if(getmthd(id).eq.0.and.ihdchk(hd(1,1)).eq.1) then
            write(6,*) '*****id,mthd(id)=',id,getmthd(id)
            call quit('ih invalid under specified isys')
         end if
      end do
c     read(5,'(i3)') na
      call freadis('na=',1,na,1)
      call freadis('npod=',1,npod,0)
      if(na.gt.namax) call quit('na > namax')
      if(npod.gt.namax) call quit('npod > namax')

      if(inpm.eq.0) then
         call freadcs('flnm3=',1,flnm3,1)
         call freadcs('flnm4=',1,flnm4,1)
         lfn3=istrln(flnm3)
         lfn4=istrln(flnm4)
         write(6,*) 'flnm3=',flnm3(1:lfn3)
         write(6,*) 'flnm4=',flnm4(1:lfn4)
         call openfile(7,flnm3,'OLD')
         call setinp(7)
      end if
      call setout(6)
      call rdsymo(na,brv)
      call setbrv(brv)
      call rdpod(npod)          ! read .pod file
      call setnpod(npod)

      call setam(brv)           ! set lattice constant in internal space

      if(inpm.eq.0) then
         call openfile(8,flnm4,'OLD')
         call setinp(8)
      end if
      call setout(6)
      call rdap(na)       ! read .atm file
      call setinp(5)
      call setout(6)
      sctmdl=getsctmdl()
      do id=1,ids
         call rdasf()
         call saveasf(id)
      end do
c     transformation of x0,xe,xi, and ej for superstructures if necessary
c     the following two are dummy for brv != 'p'
      call xtoxs(na)
      call rtors()
      
      idm=6   ! temporary
      nde=3   ! temporary
      do i=1,na
         call getx(x(1,i),i)
         write(6,'(a,6f10.5)') 'x=',(x(j,i),j=1,6)
      end do
      call sitesy(na,mpl,x,isk,irs)
c     isk : symmetry operator No. generating equivalent positions
c     irs : site symmetry operator No.
      call invsymo()


      nsymo=getnsymo()
      icent=geticent()
      do n=1,na
         ishn=getish(n)      ! OD number
         if(ishn.gt.0) then
            call getiaslct0(iaslct0,ishn)
            call vcpyi(iaslct0,iaslct(1,n),nsymo*(icent+1))
c            write(6,*) 'atom=',n,' POD=',ishn
c            write(6,'(60i1)') (iaslct0(j),j=1,120)
c            write(6,'(60i1)') (iaslct(j,n),j=1,120)
         end if
      end do

*************************************************************
c      do j=1,npod
c         call gcoset0(iaslct1,j) ! coset number for all R
c      end do
      call getiaslct1(na,iaslct1,irs)
      do j=1,na
         call gcoset1(iaslct1,j) ! coset number for all R
      end do
*************************************************************

      call getprmmtrx()         ! get permutation matrix
      call resetirs(iaslct)     ! replace irs given by iaslct
      call vcpyi(hd(1,1),ih,6)
      iequiv=multpl(ih,hd)
      iplot=2
      icase=1
      iout=0
      idiff=0
      return
      end

      subroutine getiaslct1(na,iaslct1,irs)
      integer iaslct1(120,*)  ! flags for site symmetry operators
      integer irs(0:120,*)
      do n=1,na
c        write(6,*) 'n,irs(0,n)=',n,irs(0,n)
         call zerovi(iaslct1(1,n),120)
         do i=1,irs(0,n)
            j=irs(i,n)
            if(j.le.0.or.j.gt.120) then
               write(6,*) 'atom No., irs=',n,j
               call quit('strange irs in getiaslct1')
            end if
            iaslct1(j,n)=1
         end do
      end do
      return
      end

      subroutine rdintl(z,nx)  ! read independent structural parameters
      real z(*)
      include 'qcdiff.inc'
      common /const/ pai2,jk(14)
      common /ctorms0/ job,ids
c     common /cbackg/ pb(0:12,idsmax), dpb(0:12,idsmax), zps(2,idsmax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
c          z(*)    : independent parameter
c          jz(*) : number of corrlated parameters
c          ja(1,*) : atom number
c          ja(2,*) : u1,u2,u3,be,b1,bi,p,s1,s2,v,ramin,ramax, for 1-12
c                    u11,u22,u33,u23,u31,u12 for 13-18
c          ea(*)   : coefficient

      call freadis('itempf=',1,itempf,1)   ! for temperature factor
      call setitempf(itempf)
      call freadis('nx=',1,nx,1)
      write(6,*) ' independent structural parameters'
      if(nx.ne.0) then
          jk(1)=1
          jk(14)=nx
      else
          jk(1)=0
          jk(14)=0
      end if
      l=0
      do i=1,nx
          call freadrs('z=',1,z(i),1)
          call freadis('jz=',1,jz(i),0)
          if(jz(i).gt.jzm) call quit('jz > jzm')
          do j=1,jz(i)
          call freadis(' ',1,ja(1,l+j),0)
          call freadis(' ',1,ja(2,l+j),0)
          call freadrs(' ',1,ea(l+j),0)
       end do
       write(6,'(1h ,a,i3,1x,f8.4,5(2i3,f8.4)/(12x,5(2i3,f8.4)))')
     *          '#',i,z(i),((ja(j,l+k),j=1,2),ea(l+k),k=1,jz(i))
      l=l+jz(i)
      if(l.gt.namax*10) call quit('nzc > namax*10')
      end do
      return
      end

      subroutine qcdff2(nh,hs,mpls,ny)   ! structure factor calculations
      integer hs(6,*),mpls(*)
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      integer h(6)
      integer hsmax,hkmax
      parameter (hsmax=nhkl,hkmax=nhkl)
      common /ctorms0/ job,ids
      complex dfdxx(18*namax)
      complex dfdbia
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl)
      common /cstrc8/ ads,ama
      real q(6)
      complex f,fn(namax)
      common /cpcol/ pcol
      common /ceps/ eps
      common /ccol/ icol
      common /csimul/ dfdx(nxprm,nhkl),nxx  ! derivetives for ind. parameters
      common /cdfdbi/ dfdbi(nhkl)  ! defiverives for phason temperature factor
      data pi /3.141592/
      fact=pi/180

c
c     q(1)-q(3) ve components of diffraction vector
c     q(4)-q(6) vi components of diffraction vector
c
      call getsys(isys)
      do ih=1,nh
         call vcpyi(hs(1,ih),h,6)
         call getqi(h,q)
         qd=vabs(q,3)
c     structure factor for non distorted case
         call stfc(h,f,fn,dfdxx,q,ny,dfdbia)
         fc(ih)=f
c        write(6,*) 'f=',f
c        fmpl(ih)=mpls(ih)
         qk(ih)=qd
         call vcpyi(h,hklm(1,ih),6)
         do j=1,nxx
            dfdx(j,ih)=real(dfdxx(j)*conjg(f))/abs(f)
         end do
         dfdbi(ih)=real(dfdbia*conjg(f))/abs(f)
      end do
      close(unit=1)
      return
      end

      function iextnk(h,brv)
      integer h(*)
      character brv
      call getsys(isys)
      if(brv.eq.'p') then
          iextnk=0
          return
      else if(brv.eq.'i') then
          if(mod(h(1)+h(2)+h(3)+h(4)+h(5)+h(6),2).ne.0) then
              iextnk=1
              return
          else
              iextnk=0
          end if
      else if(brv.eq.'f'.or.(isys.le.2.and.brv.eq.'s')) then
          mh1=iabs(mod(h(1),2))
          do i=2,6
             mhi=iabs(mod(h(i),2))
             if(mhi.ne.mh1) then
                 iextnk=1
                 return
             end if
          end do
          iextnk=0
          return
      else
          iextnk=0
          return
      end if
      end

      subroutine getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
      data eps /0.001/
      call getsys(isys)
      if(isys.le.2) then
c         boundary condition for icosahedral system
          xmax0=eps
          ymax0=eps
          zmax0=rmaxe
          xmin0=-rmaxe
          ymin0=-rmaxe
          zmin0=-eps
          return
      else if(isys.eq.3) then
c         boundary condition for decagonal or pentagonal system
          xmax0=eps
          ymax0=eps
          zmax0=rmaxe
          xmin0=-rmaxe
          ymin0=-rmaxe
          zmin0=-eps
      else if(isys.eq.4) then
c         boundary condition for octagonal system
          xmax0=eps
          ymax0=eps
          zmax0=rmaxe
          xmin0=-rmaxe
          ymin0=-rmaxe
          zmin0=-eps
      else if(isys.eq.5) then
c         boundary condition for dodecagonal system
          xmax0=eps
          ymax0=eps
          zmax0=rmaxe
          xmin0=-rmaxe
          ymin0=-rmaxe
          zmin0=-eps
      end if
      end

      subroutine getwmij(amij,wmij,ctoh,htoc)
      real amij(3,3),wmij(3,3),ctoh(6,6),htoc(6,6),tmp(6,6)
      do i=1,3
         do j=1,3
            tmp(i,j)=0
            do k=1,3
               tmp(i,j)=tmp(i,j)+amij(i,k)*ctoh(k,j)
            end do
         end do
      end do
      do i=1,3
         do j=1,3
            wmij(i,j)=0
            do k=1,3
               wmij(i,j)=wmij(i,j)+htoc(i,k)*tmp(k,j)
            end do
         end do
      end do
      return
      end

      subroutine getdet(det0)
      common /cgetd/ det
      det0=det
      return
      end

      subroutine genhkl(hk,mpl,qk,no,rmine,rmaxe,rmaxi)
      integer hk(6,*),mpl(*)
      real qk(*)
      character brv
      call getsys(isys)
      call getbrv(brv)      ! get bravais lattice
      if(isys.le.2) then
         call genhki0(hk,mpl,qk,no,rmine,rmaxe,rmaxi,brv)
      else
         call genhkd0(hk,mpl,qk,no,rmine,rmaxe,rmaxi,brv)
      end if
      return
      end

       subroutine gethkl(nn,mm,hmax,hkl,idm)  ! get hkl from 1 <= nn <= nt
       integer mm(0:idm),hmax(0:idm-1)
c      integer hkl(*)
       integer hkl(0:*)
       do k=0,idm-1
          hkl(k) = mod(nn,mm(k+1))/mm(k)-hmax(k)
       end do
                ! write(6,'(6(i3,1x))') (hkl(k),k=0,5)
       return
       end
 
       subroutine getmm(mm,hmax,nt,idm)  ! mm for -hmax <= h <=hmax etc.
       integer mm(0:idm), hmax(0:idm-1)
       mm(0) = 1
       nt=1
       do i=0,idm-1
          nt = nt*(2*hmax(i)+1)
          mm(i+1) = mm(i)*(2*hmax(i)+1)
       end do
       return
       end

      subroutine genhki0(hk,mpl,qk,no,rmine,rmaxe0,rmaxi0,brv)
c     independent hkl and multiplicity for dihedral case
c       decagonal, pentagonal, octagonal quasicrystals
      integer hk(6,*),mpl(*)
      real qk(*)
      integer h,k,l,m,n,o,hmax
      integer hi(6),hd(6),h6,h6max,hs(6,120)
      real q(6)
      character brv
      parameter (ngm=6)
      include 'qcdiff.inc'
c      parameter (kkm=nhkl)
c      parameter (hkmax=nhkl)
      parameter (kkm=4000)
      parameter (hkmax=6000)
      parameter (ncm=(ngm*(ngm-1)*(ngm-2))/6)
      integer ht(6),gethkg
      integer ihmax(6),mm(7),hid(6)
      data eps/0.0001/
      data ht/2,1,1,1,1,1/

********************
      ihkg=gethkg()
      if(ihkg.eq.0) then
         rewind 1
         no=1
 111     continue
         read(1,'(1h ,6i3,i5,f12.6)',end=112)
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         no=no+1
         go to 111
 112     continue
         no=no-1
         return
      end if
********************

c     generation of hklm
      no=0
      call geta(al)
      call getam(am)
      rmaxe=rmaxe0

      call getsys(isys)
c      if(isys.le.2) then
c         tau=(1.+sqrt(5.))/2.
c      else
c         call quit('invalid isys')
c      end if
      call getnst(nst)
c      rmaxi=rmaxi0/am/tau**nst

c      rmaxi=rmaxi0/am
      rmaxi=rmaxi0

      call getbrv(brv)
      call gethmax(hmax)
      call getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
c     write(6,*) 'hmax=',hmax
      if(brv.eq.'p') then
         ihdm=1
      else
         ihdm=0
      end if

      do i=1,6
         ihmax(i)=hmax
      end do

      call getmm(mm,ihmax,nt,6)      
      nn=0
      do n=1,nt
         call gethkl(n,mm,ihmax,hid,6) ! get hkl from 1 <= n <= nt
         do ieo=1,2             ! for F lattice
            if(ieo.eq.1) then
                                ! all even
               hi(1)=hid(1)*2
               hi(2)=hid(2)*2
               hi(3)=hid(3)*2
               hi(4)=hid(4)*2
               hi(5)=hid(5)*2
               hi(6)=hid(6)*2
            else if(ieo.eq.2) then
                                ! all odd
               hi(1)=hid(1)*2+1
               hi(2)=hid(2)*2+1
               hi(3)=hid(3)*2+1
               hi(4)=hid(4)*2+1
               hi(5)=hid(5)*2+1
               hi(6)=hid(6)*2+1
            end if
            call smtrh(hi,hd,nst) ! original indices
            iskp=0
            if(brv.eq.'p') then
               do ind=1,6
                  if(mod(hd(ind),2).ne.0) then
                     iskp=1
                     go to 820
                  end if
               end do
c     all even 
               do ind=1,6
                  hd(ind)=hd(ind)/2 ! indices for P
               end do
            end if

            if(brv.eq.'i') then
               iparity=0
               do ind=1,6
                  iparity=iparity+hd(ind)
               end do
               iparity=mod(iparity,2)
c     remove odd parity reflections
               if(iparity.ne.0) then
                  iskp=1
                  go to 820
               end if
            end if

c     check extinction rule again                       
            if(iextnk(hd,brv).eq.1) then
               iskp=1
               go to 820
            end if

c     call getqi0(hd,q)
            call getqi(hd,q)
            if(ifskip(q).eq.0) then
               qe=vabs(q,3)
               qi=vabs(q(4),3)
               if(qe.lt.rmine.or.qe.gt.rmaxe) go to 820
               nn=nn+1
               if(qi.gt.rmaxi) go to 820
               no=no+1
               call vcpyi(hd,hk(1,no),6)
c               do i=1,6
c                  hk(i,no)=hd(i)
c               end do
               mpl(no)=multpl(hd,hs)
               qk(no)=qe
               write(1,'(1h ,6i3,i5,f12.6)')
     *              (hk(i,no),i=1,6),mpl(no),qk(no)
               if(no.ge.hkmax) then
                  call quit('***** no >= hkmax *****')
               end if
            end if
 820        continue
         end do
 106     continue
      end do
      write(6,*) 'number of independent reflections generated=',nn
      write(6,*) 'number of independent reflections used=',no
      return
      end

      function iprty(h)
      integer h(*)
      ip=0
      do i=1,6
         ip=ip+h(i)
      end do
      iprty=abs(mod(ip,2))
      return
      end

      subroutine genhki(hk,mpl,qk,no,rmine,rmaxe0,rmaxi0,brv)
c     independent hkl and multiplicity for icosahedral case
      integer hk(6,*),mpl(*)
      real qk(*)
      integer h(6),hd(6),hs(6,120)
      real q(6),q0(6)
      character brv
      include 'qcdiff.inc'
      parameter (mmax=100000)
c      parameter (kkm=nhkl)
c      parameter (hkmax=nhkl)
      parameter (kkm=4000)
      parameter (hkmax=6000)
      parameter (ngm=6)
      parameter (nl2=1000)
      parameter (imax=1000)
      integer kk(ngm+1,kkm)
      integer kj(ngm+1,mmax)
      integer l2(imax,nl2),nelm(imax)
      integer ki(ngm),ind(2*ngm)
      integer ict(6,2),gethkg
      save ict
      data ind/2,1,4,3,6,5,8,7,10,9,12,11/
      data pi /3.14159265/, tau /1.618034/
      data ict /0,0,0,0,0,0,1,1,1,1,1,1/
********************
      ihkg=gethkg()
      if(ihkg.eq.0) then
         rewind 1
         no=1
 111     continue
         read(1,'(1h ,6i3,i5,f12.6)',end=112)
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         no=no+1
         go to 111
 112     continue
         no=no-1
         return
      end if
      call getsys(isys)
      call setsys(1)
      call setd()
      call intskp()
      call getnst(nst)
      ng=6
      call geta(al)
      call getam(am)
      rmaxe=rmaxe0
      rmaxi=rmaxi0/am
      call getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
      dz=(zmax0-zmin0)/imax
      no=0
*****************
      rmxe2=(rmaxe*tau**(-nst*3))**2
*****************
c     initialize
      do i=1,ng
         kj(i,1)=0
      end do
      do i=1,mmax
         kj(ng+1,i)=0
      end do
c     first atom
      l1=1
      do j=1,ng+1
         kj(j,1)=0
      end do
c     call getqi0(kj(1,1),q)
      call getqi(kj(1,1),q)
      il=(q(3)-zmin0)/dz+1

************ main loop **********
 800  continue
      do jj=1,l1
         do i=1,ng
            hd(i)=kj(i,jj)
         end do
**************
         call smtrh(hd,h,nst*3)
**************
         if(iextnk(h,brv).eq.1) go to 820
c         call getqi0(h,q)
         call getqi(h,q)
         qe=sqrt(q(1)**2+q(2)**2+q(3)**2)
         if(ifskip(q).eq.0) then
            if(qe.ge.rmine.and.qe.le.rmaxe.and.
     *           ifatom(q,0.,rmaxi,0).eq.0)  then
               no=no+1
               call vcpyi(h,hk(1,no),6)
c               do i=1,6
c                  hk(i,no)=h(i)
c               end do
c              write(6,*) 'h,hd',h,hd
               mpl(no)=multpl(h,hs)
               qk(no)=qe
               write(1,'(1h ,6i3,i5,f12.6)')
     *              (hk(i,no),i=1,6),mpl(no),qk(no)
               if(no.ge.hkmax) then
                  call quit('***** no >= hkmax *****')
               end if
            end if
         end if
 820     continue
      end do
c        search outer reflections in the a-b plane
      l=l1
      do i=1,l
         do j=1,ng+1
            kk(j,i)=kj(j,i)
            kj(j,i)=0
         end do
      end do
      do i=1,imax
         nelm(i)=0
         l2(i,1)=0
      end do

      l1=0
      do jj=1,l
         ns=-1
c     check ng*2 directions
         do ii=1,ng*2
            ns=-ns
c     bit operation
            iq=iand(kk(ng+1,jj),2**ind(ii))-2**ind(ii)
            if(iq.ge.0) then
c     inner direction
               go to 675
            end if
            i0=int((ii-1)/2)+1
c     i0=1,1,2,2,3,3, etc
c     internal component of the new lattice vector
c     is within the domain?
            do i=1,ng
               ki(i)=kk(i,jj)
               if(i.eq.i0) ki(i)=ki(i)+ns
            end do
c            call getqi0(ki,q0)
            call getqi(ki,q0)
c     bm= 1.0 for reciprocal lattice
            qe2=q0(1)**2+q0(2)**2+q0(3)**2
            if(qe2.gt.rmxe2) go to 675
****************
            call smtrh(ki,hd,nst*3)
c            call getqi0(hd,q)
            call getqi(hd,q)
            if(ifskip(q).eq.1) go to 675
            il=(q(3)-zmin0)/dz+1
****************
            if(il.le.0.or.il.gt.imax) go to 675
            if(ifatom(q0,0.,0.5/am,1).eq.1) go to 675  ! unit triacontahedron
c     check old or new
            do jd=1,nelm(il)
               j=l2(il,jd)
               do i=1,ng
                  if(kj(i,j).ne.ki(i)) go to 710
               end do
c     save direction
               kj(ng+1,j)=ior(kj(ng+1,j),2**ii)
               go to 675
 710           continue
            end do
c     *****************************************
c     save new lattice point
            if(l1.ge.kkm) then
               call quit('l1 > kkm')
            end if
            l1=l1+1
            if(l1.gt.kkm) then
               call quit('l1 > kkm')
            end if
            nelm(il)=nelm(il)+1
            nn=nelm(il)
            if(nn.gt.nl2) then
               write(6,*) 'il,nn',il,nn
               call quit('lack of l2 array')
            end if
            l2(il,nn)=l1
            do i=1,ng
               kj(i,l1)=ki(i)
            end do
c     save direction
            kj(ng+1,l1)=ior(kj(ng+1,l1),2**ii)
 675        continue
         end do
      end do
      if(l1.ge.1) go to 800

 999  continue
 107  continue
      call setsys(isys)
      call setd()
      return
      end

      subroutine genhkit(hk,mpl,qk,no,rmine,rmaxe0,rmaxi0,brv)
c     independent hkl and multiplicity for icosahedral case
      integer hk(6,*),mpl(*)
      real qk(*)
      integer h(6),hd(6),hs(6,120)
      real q(6),q0(6)
      character brv
      include 'qcdiff.inc'
      parameter (mmax=100000)
c      parameter (kkm=nhkl)
c      parameter (hkmax=nhkl)
      parameter (kkm=4000)
      parameter (hkmax=6000)
      parameter (ngm=6)
      parameter (nl2=1000)
      parameter (imax=1000)
      integer kk(ngm+1,kkm)
      integer kj(ngm+1,mmax)
      integer l2(imax,nl2),nelm(imax)
      integer ki(ngm),ind(2*ngm)
      integer ict(6,2),gethkg
      save ict
      data ind/2,1,4,3,6,5,8,7,10,9,12,11/
      data pi /3.14159265/, tau /1.618034/
      data ict /0,0,0,0,0,0,1,1,1,1,1,1/
********************
      ihkg=gethkg()
      if(ihkg.eq.0) then
         rewind 1
         no=1
 111     continue
         read(1,'(1h ,6i3,i5,f12.6)',end=112)
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         no=no+1
         go to 111
 112     continue
         no=no-1
         return
      end if
      call getsys(isys)
      call setsys(1)
      call setd()
      call intskp()
      call getnst(nst)
      ng=6
      call geta(al)
      call getam(am)
      rmaxe=rmaxe0
      rmaxi=rmaxi0/am
      call getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
      dx=(xmax0-xmin0)/imax
      dy=(ymax0-ymin0)/imax
      dz=(zmax0-zmin0)/imax
      no=0
*****************
      rmxe2=(rmaxe*tau**(-nst*3))**2
*****************
c     initialize
      do i=1,ng
         kj(i,1)=0
      end do
      do i=1,mmax
         kj(ng+1,i)=0
      end do
c     first atom
      l1=1
c     ls=1
      lso=0
      do j=1,ng+1
         kj(j,1)=0
      end do
      do il=1,imax
         nelm(il)=0
         do jd=1,nl2
            l2(il,jd)=0
         end do
      end do
c      call getqi0(kj(1,1),q)
      call getqi(kj(1,1),q)
      il=(q(3)-zmin0)/dz+1
c      nelm(il)=1
c      l2(il)=1

************ main loop **********
 800  continue
      do jj=1,l1
         do i=1,ng
            hd(i)=kj(i,jj+lso)
         end do
**************
         call smtrh(hd,h,nst*3)
**************
c        if(iextnk(h,brv).eq.1) go to 820
         if(brv.eq.'p') then
c            call getqi0(h,q)
            call getqi(h,q)
            if(ifskip(q).eq.0) then
               qe=sqrt(q(1)**2+q(2)**2+q(3)**2)
               if(qe.ge.rmine.and.qe.le.rmaxe.and.
     *              ifatom(q,0.,rmaxi,0).eq.0)  then
                  no=no+1
                  call vcpyi(h,hk(1,no),6)
c                  do i=1,6
c                     hk(i,no)=h(i)
c                  end do
                  mpl(no)=multpl(h,hs)
                  qk(no)=qe
               end if
            end if
         else if(brv.eq.'f') then
            do jf=0,1
               do i=1,6
                  hd(i)=h(i)*2+ict(i,jf)
               end do
c               call getqi0(hd,q)
               call getqi(hd,q)
               if(ifskip(q).eq.0) then
                  qe=sqrt(q(1)**2+q(2)**2+q(3)**2)
                  if(qe.ge.rmine.and.qe.le.rmaxe.and.
     *                 ifatom(q,0.,rmaxi,0).eq.0)  then
                     no=no+1
                     call vcpyi(hd,hk(1,no),6)
c                    do i=1,6
c                       hk(i,no)=hd(i)
c                    end do
                     mpl(no)=multpl(hd,hs)
                     qk(no)=qe
                  end if
               end if
            end do
         end if
         write(1,'(1h ,6i3,i5,f12.6)')
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         if(no.ge.hkmax) then
            call quit('***** no >= hkmax *****')
         end if
      end do
c        search outer reflections in the a-b plane
      l=l1
      do i=1,l
         do j=1,ng+1
            kk(j,i)=kj(j,i+lso)
            kj(j,i)=0
         end do
      end do

      l1=0
      do jj=1,l
         ns=-1
c     check ng*2 directions
         do ii=1,ng*2
            ns=-ns
c     bit operation
            iq=iand(kk(ng+1,jj),2**ind(ii))-2**ind(ii)
            if(iq.ge.0) then
c     inner direction
               go to 675
            end if
            i0=int((ii-1)/2)+1
c     i0=1,1,2,2,3,3, etc
c     internal component of the new lattice vector
c     is within the domain?
            do i=1,ng
               ki(i)=kk(i,jj)
               if(i.eq.i0) ki(i)=ki(i)+ns
            end do
c            call getqi0(ki,q0)
            call getqi(ki,q0)
            if(brv.eq.'f') then
               q0(1)=q0(1)*2
               q0(2)=q0(2)*2
               q0(3)=q0(3)*2
            end if
c     bm= 1.0 for reciprocal lattice
            qe2=q0(1)**2+q0(2)**2+q0(3)**2
            if(qe2.gt.rmxe2) go to 675
****************
            call smtrh(ki,hd,nst*3)
c            call getqi0(hd,q)
            call getqi(hd,q)
            if(brv.eq.'f') then
               q(1)=q(1)*2
               q(2)=q(2)*2
               q(3)=q(3)*2
            end if
            if(ifskip(q).eq.1) go to 675
            il=(q(3)-zmin0)/dz+1
****************
            if(il.le.0.or.il.gt.imax) go to 675
            if(ifatom(q0,0.,0.5/am,1).eq.1) go to 675  ! unit triacontahedron
c     check old or new
            do jd=1,nelm(il)
               j=l2(il,jd)
               do i=1,ng
                  if(kj(i,j).ne.ki(i)) go to 710
               end do
c     save direction
               kj(ng+1,j)=ior(kj(ng+1,j),2**ii)
               go to 675
 710           continue
            end do
c     *****************************************
c     save new lattice point
            if(l1.ge.kkm) then
               call quit('l1 > kkm')
            end if
            l1=l1+1
c           ls=ls+1
            nelm(il)=nelm(il)+1
            nn=nelm(il)
c            if(ls.gt.mmax) then
c               call quit('ls > mmax')
c            end if
            if(nn.gt.nl2) then
               write(6,*) 'il,nn',il,nn
               call quit('lack of l2 array')
            end if
c           l2(il,nn)=ls
            l2(il,nn)=l1
            do i=1,ng
c              kj(i,ls)=ki(i)
               kj(i,l1)=ki(i)
            end do
c     save direction
c           kj(ng+1,ls)=ior(kj(ng+1,ls),2**ii)
            kj(ng+1,l1)=ior(kj(ng+1,l1),2**ii)
 675        continue
         end do
      end do
c      lso=lso+l
      if(l1.ge.1) go to 800

 999  continue
 107  continue
      call setsys(isys)
      call setd()
      return
      end

      subroutine genhkd0(hk,mpl,qk,no,rmine,rmaxe0,rmaxi0,brv)
c     independent hkl and multiplicity for dihedral case
c       decagonal, pentagonal, octagonal quasicrystals
      integer hk(6,*),mpl(*)
      real qk(*)
      integer h,k,l,m,n,hmax
      integer hi(6),hd(6),h6,h6max,hs(6,120),gethkg
      real q(6)
      character brv
      parameter (ngm=6)
      include 'qcdiff.inc'
      parameter (kkm=4000)
      parameter (hkmax=6000)
      parameter (ncm=(ngm*(ngm-1)*(ngm-2))/6)
      integer mm(5),ihmax(4),hid(4)
      data eps/0.0001/
********************
      ihkg=gethkg()
      if(ihkg.eq.0) then
         rewind 1
         no=1
 111     continue
         read(1,'(1h ,6i3,i5,f12.6)',end=112)
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         no=no+1
         go to 111
 112     continue
         no=no-1
         return
      end if
********************
      nn=0
      no=0
      call geta(al)
      call getam(am)
      call getc(cl)
      rmaxe=rmaxe0
      call getsys(isys)
c      if(isys.eq.3) then
c         tau=(1.+sqrt(5.))/2.
c      else if(isys.eq.4) then
c         tau=1.+sqrt(2.)
c      else if(isys.eq.5) then
c         tau=2.+sqrt(3.)
c      else
c         call quit('invalid isys')
c      end if
      call getnst(nst)
c      rmaxi=rmaxi0/am/tau**nst

      rmaxi=rmaxi0/am

c      write(6,*) 'rmaxi0,am=',rmaxi0,am
c      stop

      call gethmax(hmax)
      call getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)

      lmax=zmax0*cl+1
      do i=1,4
         ihmax(i)=hmax
      end do
      call getmm(mm,ihmax,nt,6)      

      do m=1,nt
         call gethkl(m,mm,ihmax,hid,4) ! get hkl from 1 <= n <= nt
         do n=0,lmax
            do ii=1,4
               hi(ii)=hid(ii)
            end do
            hi(5)=n
            hi(6)=0
            call smtrh(hi,hd,nst) ! original indices
            if(iextnk(hd,brv).eq.1) go to 820
c     call getqi0(hd,q)
            call getqi(hd,q)
            if(ifskip(q).eq.0) then
               qe=sqrt(q(1)**2+q(2)**2+q(3)**2)
               qi=sqrt(q(4)**2+q(5)**2)
               if(qe.lt.rmine.or.qe.gt.rmaxe) go to 820
               nn=nn+1
               if(qi.gt.rmaxi) go to 820
c     write(6,*) 'rmaxi,qi=',rmaxi,qi
               no=no+1
               call vcpyi(hd,hk(1,no),6)
c               do i=1,6
c                  hk(i,no)=hd(i)
c               end do
               mpl(no)=multpl(hd,hs)
               qk(no)=qe
               write(1,'(1h ,6i3,i5,f12.6)')
     *              (hk(i,no),i=1,6),mpl(no),qk(no)
               if(no.ge.nhkl) then
                  write(6,*) '***** no >= nhkl *****'
                  go to 830
               end if
            end if
 820        continue
         end do
      end do
 830  continue
      write(6,*) 'number of reflections generated=',nn,
     *     ' number with qi < rmaxi', no
      return
      end

      subroutine genhkd(hk,mpl,qk,no,rmine,rmaxe0,rmaxi0,brv)
c     independent hkl and multiplicity for dihedral case
c       decagonal, pentagonal, octagonal quasicrystals
      integer hk(6,*),mpl(*)
      real qk(*)
      integer h(6),hd(7),h6,h6max,hs(6,120)
      real q(6)
      character brv
      parameter (ngm=6)
      include 'qcdiff.inc'
c      parameter (kkm=nhkl)
c      parameter (hkmax=nhkl)
      parameter (kkm=4000)
      parameter (hkmax=6000)
      parameter (ncm=(ngm*(ngm-1)*(ngm-2))/6)
      real x(ncm),y(2*ngm+1,ncm),z(ngm-2,ngm),zs(ngm-1,ncm)
      integer kk(ngm+1,kkm),kj(ngm+1,kkm),l2(ngm,kkm),nelm(ngm)
      dimension ind(2*ngm),g(ngm),zx(2,ngm),k(ngm)
      dimension zd(ngm-3,ngm-3),ip(ngm-3),vw(ngm-3)
      dimension x00(2),x0(ngm),z0(ngm-2),jh(ngm)
      dimension indx((ngm-3),2),pvt(ngm-3)
      integer gethkg
      data ind/2,1,4,3,6,5,8,7,10,9,12,11/
      data eps/0.0001/,jh/1,3,5,7,11,13/
      data sqrt5/2.236067/, tau/1.618034/
********************
      ihkg=gethkg()
      if(ihkg.eq.0) then
         rewind 1
         no=1
 111     continue
         read(1,'(1h ,6i3,i5,f12.6)',end=112)
     *        (hk(i,no),i=1,6),mpl(no),qk(no)
         no=no+1
         go to 111
 112     continue
         no=no-1
         return
      end if
      call getsys(isys)
      call getnst(nst)
      if(isys.eq.3) then
          ng=5
      else if(isys.eq.4) then
          ng=4
      else if(isys.eq.6) then
          ng=6
      end if
      call geta(al)
      call getam(am)
      call getc(cl)
      rmaxe=rmaxe0
      rmaxi=rmaxi0/am
      call getlim(rmaxe,xmin0,xmax0,ymin0,ymax0,zmin0,zmax0)
      no=0
************************************
      rmxe2=(rmaxe*tau**(-nst))**2
************************************
c     nc: ng!/(ng-3)!3!
      nc=(ng*(ng-1)*(ng-2))/6
c     nc=4,10,20 for ng=4,5,6
      kisu=mod(ng,2)
      p=(1+kisu)*3.14159265/ng
c     amgn=0.3
c     basis vectors for two-dimensional rep. in ext. sp.
      do i=1,ng
         zx(1,i)=cos(p*(i-1))
         zx(2,i)=sin(p*(i-1))
      end do

c     z(1,i),z(2,i) etc.:basis vectors for two-dimensional rep. in int. sp.
      do j=1,ng-3,2
         if(kisu.eq.1) then
c     j0=2,3,4,5  for j=1,3,5,7
            j0=(j+3)/2
         else
c     j0=3,5,7,9  for j=1,3,5,7
            j0=j+2
         end if
         do i=1,ng
            z(j,i)  =cos(p*(i-1)*j0)
            z(j+1,i)=sin(p*(i-1)*j0)
         end do
      end do
c     if ng=odd basis vector for one-dimensional rep. in int. sp.
      if(kisu.eq.1) then
         do i=1,ng
            z(ng-2,i)=1.
         end do
      end if

c     initialize
      do i=1,ng
         kj(i,1)=0
      end do
      do i=1,kkm
         kj(ng+1,i)=0
      end do
c     x00: external components of g
      do i=1,2
         x00(i)=0
         do j=1,ng
            x00(i)=x00(i)+zx(i,j)*g(j)
         end do
      end do
c     g: specify section
c     x0: internal components of g
      do i=1,ng-2
         x0(i)=0
         do j=1,ng
            x0(i)=x0(i)+z(i,j)*g(j)
         end do
      end do
c     domain boundary in internal space
      ij=1
      do j1=1,ng-2
         do j2=j1+1,ng-1
            do j3=j2+1,ng
              do i=1,ng-2
                  jj=1
                  do j=1,ng-2
                     if(i.eq.j) go to 360
                     ja=1
                     do jk=1,ng
                        if(jk.eq.j1.or.jk.eq.j2.or.jk.eq.j3) then
c     jk is parallel to one of three
                           go to 370
                        end if
                        zd(jj,ja)=z(j,jk)
                        ja=ja+1
 370                    continue
                     end do
                     jj=jj+1
 360                 continue
                  end do
                  if(ng.eq.4) then
                     s=zd(1,1)
                  else
c     s: determinant of matrix zd
                     call matinv(zd,ngm-3,ng-3,vw,0,s,ip,indx,pvt)
                  end if
                  zs(i,ij)=(-1)**(i+1)*s
               end do
               ij=ij+1
            end do
         end do
      end do
c     zs: vector normal to the boundary plane/line
c     nc*2: number of boundary planes/lines
c       nc*2=8,20,60 for ng=4,5,6
      do ij=1,nc
         a=0.
         do j=1,ng
            b=vinpr(z(1,j),zs(1,ij),ng-2)
            a=a+abs(b)
         end do
         zs(ng-1,ij)=a/2
      end do
c     zs(ng-1,*): distance to the boundary

      ns=-1
      do i=1,ng*2
         ns=-ns
         do ij=1,nc
            in=int((i-1)/2)+1
            s=vinpr(z(1,in),zs(1,ij),ng-2)
            y(i,ij)=ns*s
         end do
      end do
c     y(i,j): inner product of the i-th unit and
c             j-th normal vectors to the boundary
c     first atom
      l1=1
      do j=1,ng+1
         kj(j,1)=0
      end do

************ main loop **********
      h6max=zmax0*cl+1
 800  continue
      do jj=1,l1
         do h6=0,h6max
            do i=1,ng
               hd(i)=kj(i,jj)
            end do
            hd(ng+1)=h6
            if(isys.eq.3) then
               call tr6to5i(hd,h)
            else if(isys.eq.5) then
               call tr7to5i(hd,h)
            else
               call vcpyi(hd,h,6)
            end if
            call vcpyi(h,hd,6)
***************
            call smtrh(hd,h,nst)
***************
            if(iextnk(h,brv).eq.1) go to 820
c     call getqi0(h,q)
            call getqi(h,q)
            if(ifskip(q).eq.0) then
               qe=vabs(q,3)
               if(qe.lt.rmine.or.qe.gt.rmaxe) go to 820
               if(ifatom(q,0.,rmaxi,0).eq.1) go to 820
               no=no+1
               call vcpyi(h,hk(1,no),6)
c               do i=1,6
c                  hk(i,no)=h(i)
c               end do
               mpl(no)=multpl(h,hs)
               qk(no)=qe
               write(1,'(1h ,6i3,i5,f12.6)')
     *              (hk(i,no),i=1,6),mpl(no),qk(no)
               if(no.ge.hkmax) then
                  call quit('***** no >= hkmax *****')
               end if
            end if
 820        continue
         end do
      end do
c        search outer reflections in the a-b plane
      l=l1
      do i=1,l
         do j=1,ng+1
            kk(j,i)=kj(j,i)
            kj(j,i)=0
         end do
      end do
      do i=1,ng
         nelm(i)=0
         l2(i,1)=0
      end do

      l1=0
      do jj=1,l
         azx=-x00(1)
         azy=-x00(2)
         do i=1,ng-2
            z0(i)=-x0(i)
         end do

         do i=1,ng
c          external components of old lattice vector
c          azx=azx+zx(1,i)*kk(i,jj)
c          azy=azy+zx(2,i)*kk(i,jj)
            do j=1,ng-2
c          internal components of old lattice vector
               z0(j)=z0(j)+z(j,i)*kk(i,jj)
            end do
         end do
         do i=1,nc
            x(i)=vinpr(zs(1,i),z0,ng-2)
         end do

         ns=-1
c     check ng*2 directions
         do ii=1,ng*2
            ns=-ns
c     bit operation
            iq=iand(kk(ng+1,jj),2**ind(ii))-2**ind(ii)
            if(iq.ge.0) then
c     inner direction
               go to 675
            end if
            i0=int((ii-1)/2)+1
c     i0=1,1,2,2,3,3, etc
c     internal component of the new lattice vector
c     is within the domain?
            do ij=1,nc
               if(abs(y(ii,ij)+x(ij)).gt.zs(ng-1,ij)+eps) go to 675
            end do
c     new lattice point
            ih=0
            do i=1,ng
               k(i)=kk(i,jj)
               if(i.eq.i0) k(i)=k(i)+ns
               ih=ih+abs(k(i))*jh(i)
            end do
            k(ng+1)=0
            if(isys.eq.3) then
               call tr6to5i(k,hd)
            else if(isys.eq.5) then
               call tr7to5i(k,hd)
            else
               call vcpyi(k,hd,6)
            end if
c            call getqi0(hd,q)
            call getqi(hd,q)
            if(ifskip(q).eq.1) go to 675
            qe2=q(1)**2+q(2)**2
****************
            if(qe2.gt.rmxe2) go to 675
****************
            ih=mod(ih,ng)+1
c     check old or new
            do jd=1,nelm(ih)
               j=l2(ih,jd)
               do i=1,ng
                  if(kj(i,j).ne.k(i)) go to 710
               end do
c     save direction
               kj(ng+1,j)=ior(kj(ng+1,j),2**ii)
               go to 675
 710           continue
            end do
c     *****************************************
c     save new lattice point
            if(l1.ge.kkm) then
               call quit('l1 > kkm')
            end if
            l1=l1+1
            if(l1.gt.kkm) then
               call quit('l1 > kkm')
            end if
            nelm(ih)=nelm(ih)+1
            nn=nelm(ih)
            if(nn.gt.kkm) then
               write(6,*) 'ih,nn',ih,nn
               call quit('lack of l2 array')
            end if
            l2(ih,nn)=l1
            do i=1,ng
               kj(i,l1)=k(i)
            end do
c     save direction
            kj(ng+1,l1)=ior(kj(ng+1,l1),2**ii)
 675        continue
         end do
      end do
 671  continue
      if(l1.ge.1) go to 800
************ end of main loop **********
      return
      end

      subroutine genhko(imax1,imax2,hk,mpl,qk,nh,rmaxe,rmaxi)
      return
      end

      subroutine savexc(xc,xold,ndiff)
      real xc(*),xold(3,*)
      xold(1,ndiff)=xc(1)
      xold(2,ndiff)=xc(2)
      xold(3,ndiff)=xc(3)
      return
      end

      subroutine savehr(hr,hold,ndiff)
      integer hr(*),hold(6,*)
      do i=1,6
         hold(i,ndiff)=hr(i)
      end do
      return
      end
      
      subroutine stfc(h,f,fn,dfdxx,q,ny,dfdbia) ! structure factor calculations
      real q(*)
      complex f,fn(*),dfdxx(*),dfdbia
      integer ih,h(*),ny
      call getsys(isys)      
      if(isys.le.2) then  ! icosahedral quasicrystals
         call stfci(h,f,fn,dfdxx,q,ny,dfdbia)
      else                ! dihedral quasicrystals
         call stfcd(h,f,fn,dfdxx,q,ny,dfdbia)
      end if
      return
      end

      subroutine stfci(h,f,fn,dfdxx,q,ny,dfdbia)
c     structure factor for icosahedral quasicrystals
      integer h(*)
      complex f,fn(*),dfdxx(*),dfdbia
      real q(*)
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex f0
      real xi(6)
      common /ctodrw10/ biat
      real e1e2(6)

      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer prmtbl
      common /cprmtbl/ prmtbl(120,namax)
      common /csimul/ dfdx(nxprm,nhkl),nxx

      complex pi2,cexhrt,cexpf
      complex ascf1,ascf2,ascf3,ascft
      complex f00s(120,namax),df00dr1s(120,namax),df00dr2s(120,namax)
      common /ctype/ ityp(-2:namax)
      complex f0s(120),df0dr1s(120),df0dr2s(120)

      complex dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      common /ccmplx1/ dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      complex dfcdp,dfcdb(9),dfcds1,dfcds2,fct,phsn
      common /ccmplx2/ dfcdp,dfcdb,dfcds1,dfcds2,fct,phsn

      complex df0dr1,df0dr2
      common /ccmplx0/ df0dr1,df0dr2

      real vi(nemax,namax)
      real t(6)
      real qr(6)      ! q vector after symmetry operation
      integer jtyp(-2:namax)
      integer hr(6),hri(6)
      real b2(9)                ! temperature b2(1)=be b2(2)=b1,b2(3)=bi b2(3)=u11, ... b2(9)=u12
      real dtmpf(9)             ! derivative of debye waller factor by tmp factors
      integer getnsymo,geticent,getish,getnxx
      data pi/3.141592/, eps/0.00001/
      data pi2/(0.0,6.28318)/

      idm=6
      icent=geticent()
      nsymo=getnsymo()
      call geta(al)
      call getam(am)
      unitvoli=am**3
      call gettr(t)
      qd=vabs(q,3)
      qe1=vabs(q,2)
      qe2=q(3)
c     absqe: length of diffraction vector in angstrom**-1
c     absqi: length of diffraction vector in angstrom**-1
      absqe=qd
      f=(0.,0.)
      call zerovc(dfdxx,ny)
      dfdbia=(0.0,0.0)
      call getnpod(npod)
      call zerovi(jtyp,npod+2)

      ihdm=0
      do ihd=0,ihdm         
         do n=1,na
c     ****** vi: volume of rhombohedron with edge vecotrs e1,e2,e3
            ishn=getish(n)
            jtyp(ishn)=jtyp(ishn)+1
            call getvii(n,vi(1,n))
            if(ishn.gt.0) then
*********************************** A. Yamamoto Apr. 24, 2003
c               do nsc=1,ncst(ishn)
c                  ns=cosrep(nsc,ishn) ! nsi=isymo(cosrep(nsc,ishn))
***********************************
               do nsc=1,ncst(n)
                  ns=cosrep(nsc,n) ! nsi=isymo(cosrep(nsc,ishn))
                  call gethr0(h,hr,ns,0) ! call gethr0(h,hr,nsi,0)
                  if(ityp(ishn).gt.0) then
                     f0s(nsc)=f0(n,irs,isymo,hr,
     *                    df0dr1s(nsc),df0dr2s(nsc))/unitvoli
                  else if(ityp(ishn).lt.0.and.jtyp(ishn).eq.1) then
                     f00s(nsc,ishn)=f0(n,irs,isymo,hr,
     *                    df00dr1s(nsc,ishn),df00dr2s(nsc,ishn))/
     *                    unitvoli
                  end if
               end do
            end if
            call getascf123(n,absqe,ascf1,ascf2,ascf3)

            ascft=(1-s(1,n)-s(2,n))*ascf1+s(1,n)*ascf2
     *           +s(2,n)*ascf3
            
c     b2 : isotropic and anisotropic temperature factors
            b2(1)=be(n)
            b2(2)=b1(n)
            b2(3)=bi(n)
            call vcpyr(ui(1,n),b2(4),6)
            
            fn(n)=(0.0,0.0)
            do j=1,isk(0,n)     ! equivalent sites
               ns=isk(j,n)      ! nsi=isymo(ns)
               call gethr0(h,hr,ns,0) !  call gethr0(h,hri,nsi,0)
               tmpf=gettmpf(n,hr,b2,biat,dtmpf) ! Debey-Waller fact.
               call gettrns(ns,t)
               hrx=vinpir(hr,x(1,n),idm)
               ht =vinpir(h,t,idm)
               cexhrt=cexpf(pi2*(hrx+ht))
               fct=mpl(n)*p(n)*ascft*tmpf
               dfcdp=mpl(n)*ascft*tmpf
               dfcds1=mpl(n)*p(n)*(-ascf1+ascf2)*tmpf
               dfcds2=mpl(n)*p(n)*(-ascf1+ascf3)*tmpf
               
               do k=1,9         ! derivatives of fct with respect to b(k)
                  dfcdb(k)=mpl(n)*p(n)*ascft*dtmpf(k) ! iso & aniso phonon temp. 
               end do
               
               if(ishn.gt.0) then ! polyhedral OD
                  if(ityp(ishn).gt.0) then
c                     nsd=coset(ns,ishn)
                     nsd=coset(ns,n)
                     phsn=cexhrt*f0s(nsd)
                     df0dr1=df0dr1s(nsd)
                     df0dr2=df0dr2s(nsd)
                  else if(ityp(ishn).lt.0) then
c                     iii=coset(ns,ishn)
                     iii=coset(ns,n)
                     nsd=prmtbl(iii,n) ! nsd=prmtbl(ns,n) ! nsd=prmtbl(j,n)
                     if(nsd.le.0) then
                        write(6,*) 'iii=',iii,' nsd=',nds,' ns=',ns
                        call quit(' ')
                     end if
                     phsn=cexhrt*f00s(nsd,ishn)
                     df0dr1=df00dr1s(nsd,ishn)
                     df0dr2=df00dr2s(nsd,ishn)
c     write(6,*) 'n,isk,nsd=',n,ns,nsd
                  end if
               else             ! spherical OD
                  phsn=cexhrt*f0(n,irs,isymo,hr,df0dr1,
     *                 df0dr2)/unitvoli
               end if
               dfdbia=dfdbia+dfcdb(3)*phsn ! for bia
               call gethrx123(n,hr,fct11,fct12,fct13)
               call getxi(xi,n)
               fct2=vinpir(hr,xi,idm)
               dphdxe1=pi2*phsn*fct11
               dphdxe2=pi2*phsn*fct12
               dphdxe3=pi2*phsn*fct13
               dphdxi=pi2*phsn*fct2
               dphdr1=df0dr1*cexhrt/unitvoli
               dphdr2=df0dr2*cexhrt/unitvoli
               fn(n)=fn(n)+phsn*fct
               call getdfdxx(n,ny,dfdxx)
            end do
            f=f+fn(n)
         end do
      end do

      nxx=getnxx(ny)
      if(icent.eq.1) then
         f=real(f)*2
         do n=1,na
            fn(n)=fn(n)*2
         end do
         do j=1,nxx
            dfdxx(j)=real(dfdxx(j))*2
         end do
      end if
      return
      end

      subroutine getdfdxx(n,ny,dfdxx)
      complex dfdxx(*)
      complex dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      common /ccmplx1/ dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      complex dfcdp,dfcdb(9),dfcds1,dfcds2,fct,phsn
      common /ccmplx2/ dfcdp,dfcdb,dfcds1,dfcds2,fct,phsn
      include 'qcdiff.inc'
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      integer ips(0:nxprm)
      call getips(ips,ny)
c      call wtvctri('****ips in getdfdxx=',ips,ny+1)
c      write(6,*) 'dfcdb=',dfcdb(1),dfcdb(2)
      n0=0
      l=0
      do ld=1,ny
         if(ips(ld).eq.1) then
            l=l+1
            do k=1,jz(ld)
               nn=n0+k
               ii=ja(1,nn)
               jj=ja(2,nn)
               if(ii.eq.n) then
                  if(jj.eq.1) then
c     u1      displacement along external space
                     dfdxx(l)=dfdxx(l)+dphdxe1*fct*ea(nn)
                  else if(jj.eq.2) then
c     u2     displacement along external space
                     dfdxx(l)=dfdxx(l)+dphdxe2*fct*ea(nn)
                  else if(jj.eq.3) then
c     u3     displacement along external space
                     dfdxx(l)=dfdxx(l)+dphdxe3*fct*ea(nn)
                  else if(jj.eq.4) then
c     be     temperature factor
                     dfdxx(l)=dfdxx(l)+dfcdb(1)*phsn*ea(nn)
                  else if(jj.eq.5) then
c     b1     temperature factor
                     dfdxx(l)=dfdxx(l)+dfcdb(2)*phsn*ea(nn)
                  else if(jj.eq.6) then
c     bi     temperature factor
                     dfdxx(l)=dfdxx(l)+dfcdb(3)*phsn*ea(nn)
                  else if(jj.eq.7) then
c     p      occupation probability
                     dfdxx(l)=dfdxx(l)+dfcdp*phsn*ea(nn)
                  else if(jj.eq.8) then
c     s1     
                     dfdxx(l)=dfdxx(l)+dfcds1*phsn*ea(nn)
                  else if(jj.eq.9) then
c     s2
                     dfdxx(l)=dfdxx(l)+dfcds2*phsn*ea(nn)
                  else if(jj.eq.10) then
c     v      displacement along internal space
                     dfdxx(l)=dfdxx(l)+dphdxi*fct*ea(nn)
                  else if(jj.eq.11) then
c     rimin
                     dfdxx(l)=dfdxx(l)+dphdr1*fct*ea(nn)
                  else if(jj.eq.12) then
c     rimax
                     dfdxx(l)=dfdxx(l)+dphdr2*fct*ea(nn)
                  else if(jj.ge.13.and.jj.le.18) then 
c     ui(i)   anisotropic temperature factor
                     dfdxx(l)=dfdxx(l)+dfcdb(jj-9)*phsn*ea(nn)
                  end if
               end if
            end do
         end if
         n0=n0+jz(ld)
      end do
      return
      end

      subroutine stfcd(h,f,fn,dfdxx,q,ny,dfdbia)
c     structure factor for dihedral quasicrystals
      integer h(*)
      complex f,fn(*),dfdxx(*),dfdbia
      real q(*)
      real mpl
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex f0
      real xi(6)
      common /ctodrw10/ biat
      real e1e2(6)

      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer prmtbl
      common /cprmtbl/ prmtbl(120,namax)
      common /csimul/ dfdx(nxprm,nhkl),nxx

      complex pi2,cexhrt,cexpf
      complex ascf1,ascf2,ascf3,ascft
      complex f00s(120,namax),df00dr1s(120,namax),df00dr2s(120,namax)
      common /ctype/ ityp(-2:namax)
      complex f0s(120),df0dr1s(120),df0dr2s(120)

      complex dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      common /ccmplx1/ dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      complex dfcdp,dfcdb(9),dfcds1,dfcds2,fct,phsn
      common /ccmplx2/ dfcdp,dfcdb,dfcds1,dfcds2,fct,phsn

      complex df0dr1,df0dr2
      common /ccmplx0/ df0dr1,df0dr2

      real vi(nemax,namax)
      real t(6)
c      real qr(6)
      integer jtyp(-2:namax)
      integer hr(6),hri(6)
      real b2(9)                ! temperature b2(1)=be b2(2)=b1,b2(3)=bi b2(3)=u11, ... b2(9)=u12
      real dtmpf(9)             ! derivative of debye waller factor by tmp factors
      character brv
      integer getnsymo,geticent,getish,getnxx
      data pi/3.141592/, eps/0.00001/
      data pi2/(0.0,6.28318)/

      idm=5
      icent=geticent()
      nsymo=getnsymo()
      qd=vabs(q,3)
      call geta(al)
      call getam(am)
      unitvoli=am**2
      call getc(cl)
      call getbrv(brv)
c     absqe: length of diffraction vector in angstrom**-1
c     absqi: length of diffraction vector in angstrom**-1
      absqe=qd
      f=(0.,0.)
      call zerovc(dfdxx,ny)
      dfdbia=(0.0,0.0)
      call getnpod(npod)
      call zerovi(jtyp,npod+2)

      if(brv.eq.'c') then
         ihdm=1                 ! antisymmetric centering
      else
         ihdm=0
      end if
      do ihd=0,ihdm         
         do n=1,na
c     ****** vi: volume of rhombohedron with edge vecotrs e1,e2
            ishn=getish(n)
            jtyp(ishn)=jtyp(ishn)+1
            call getvid(n,vi(1,n))
            if(ishn.gt.0) then
**************************************************
c               do nsc=1,ncst(ishn)
c                  ns=cosrep(nsc,ishn) ! nsi=isymo(cosrep(nsc,ishn))
**************************************************
               do nsc=1,ncst(n)
                  ns=cosrep(nsc,n) ! nsi=isymo(cosrep(nsc,ishn))
                  call gethr0(h,hr,ns,0) !   call gethr0(h,hr,nsi,0)
                  if(ityp(ishn).gt.0) then
                     f0s(nsc)=f0(n,irs,isymo,hr,
     *                    df0dr1s(nsc),df0dr2s(nsc))/unitvoli
                  else if(ityp(ishn).lt.0.and.jtyp(ishn).eq.1) then
                     f00s(nsc,ishn)=f0(n,irs,isymo,hr,
     *                    df00dr1s(nsc,ishn),df00dr2s(nsc,ishn))/
     *                    unitvoli
                  end if
               end do
            end if
            call getascf123(n,absqe,ascf1,ascf2,ascf3)

            ascft=(1-s(1,n)-s(2,n))*ascf1+s(1,n)*ascf2
     *           +s(2,n)*ascf3
            ascfu=s(1,n)*ascf1+(1-s(1,n)-s(2,n))*ascf2
     *           +s(2,n)*ascf3

            b2(1)=be(n)
            b2(2)=b1(n)
            b2(3)=bi(n)
            call vcpyr(ui(1,n),b2(4),6)

            fn(n)=(0.0,0.0)
            do j=1,isk(0,n)     ! equivalent sites
               ns=isk(j,n)      ! nsi=isymo(ns)
               call gethr0(h,hr,ns,0) ! call gethr0(h,hri,nsi,0)
               tmpf=gettmpf(n,hr,b2,biat,dtmpf) ! Debey-Waller fact.
               call ifcolor(x(1,6),n,ns,tmpf,dtmpf,t,ihd,ascft,ascfu)
               hrx=vinpir(hr,x(1,n),idm)
               ht =vinpir(h,t,idm)
               cexhrt=cexpf(pi2*(hrx+ht))
               fct=mpl(n)*p(n)*ascft*tmpf
               dfcdp=mpl(n)*ascft*tmpf
               dfcds1=mpl(n)*p(n)*(-ascf1+ascf2)*tmpf
               dfcds2=mpl(n)*p(n)*(-ascf1+ascf3)*tmpf

               do k=1,9         ! derivatives of fct with respect to b(k)
                  dfcdb(k)=mpl(n)*p(n)*ascft*dtmpf(k) ! iso & aniso phonon temp. 
               end do

               if(ishn.gt.0) then ! polyhedral OD
                  if(ityp(ishn).gt.0) then
c                     nsd=coset(ns,ishn)
                     nsd=coset(ns,n)
                     phsn=cexhrt*f0s(nsd)
                     df0dr1=df0dr1s(nsd)
                     df0dr2=df0dr2s(nsd)
                  else if(ityp(ishn).lt.0) then
c                     iii=coset(ns,ishn)
                     iii=coset(ns,n)
                     nsd=prmtbl(iii,n) ! nsd=prmtbl(ns,n) ! nsd=prmtbl(j,n)
                     if(nsd.le.0) then
                        write(6,*) 'iii=',iii,' nsd=',nds,' ns=',ns
                        call quit(' ')
                     end if
                     phsn=cexhrt*f00s(nsd,ishn)
                     df0dr1=df00dr1s(nsd,ishn)
                     df0dr2=df00dr2s(nsd,ishn)
                  end if
               else
                  phsn=cexhrt*f0(n,irs,isymo,hr,df0dr1,
     *                 df0dr2)/unitvoli
               end if
               dfdbia=dfdbia+dfcdb(3)*phsn ! for bia
               call gethrx123(n,hr,fct11,fct12,fct13)
               call getxi(xi,n)
               fct2=vinpir(hr,xi,idm)
               dphdxe1=pi2*phsn*fct11
               dphdxe2=pi2*phsn*fct12
               dphdxe3=pi2*phsn*fct13
               dphdxi=pi2*phsn*fct2
               dfhdr1=df0dr1*cexhrt/unitvoli
               dfhdr2=df0dr2*cexhrt/unitvoli
               fn(n)=fn(n)+phsn*fct
               call ifcolor1(x(6,n),n,fn(n))
               call getdfdxx(n,ny,dfdxx)
            end do               
            f=f+fn(n)
         end do
      end do
      
      nxx=getnxx(ny)
      if(icent.eq.1) then
         f=real(f)*2
         do n=1,na
            fn(n)=fn(n)*2
         end do
         do j=1,nxx
            dfdxx(j)=real(dfdxx(j))*2
         end do
      end if
      return
      end

      subroutine ifcolor1(x,n,fn)
      complex fn
      complex df0dr1,df0dr2
      common /ccmplx0/ df0dr1,df0dr2
      complex dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      common /ccmplx1/ dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      integer geticent
      icent=geticent()
      if(icent.eq.-1.and.x.eq.0.) then
c     contribution of a pair of atoms related by -1'
         dphdxe1=2*real(dphdxe1)
         dphdxe2=2*real(dphdxe2)
         dphdxe3=2*real(dphdxe3)
         dphdxi=2*real(dphdxi)
         dphdr1=2*real(df0dr1)
         dphdr2=2*real(df0dr2)
         fn=2*real(fn)
      end if
      return
      end

      subroutine ifcolor(x,n,ns,tmpf,dtmpf,tr,ihd,ascft,ascfu)
      real x
      real dtmpf(*),tr(*)
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex dfcdp,dfcdb(9),dfcds1,dfcds2,fct,phsn
      common /ccmplx2/ dfcdp,dfcdb,dfcds1,dfcds2,fct,phsn
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call getascf123(n,absqe,ascf1,ascf2,ascf3)
      if(x.eq.0) then
         fct=mpl(n)*p(n)*ascft*tmpf
         dfcdp=mpl(n)*ascft*tmpf
         dfcds1=mpl(n)*p(n)*(-ascf1+ascf2)*tmpf
         dfcds2=mpl(n)*p(n)*(-ascf1+ascf3)*tmpf
         do k=1,9
            dfcdb(k)=mpl(n)*p(n)*ascft*dtmpf(k) ! iso,aniso phonon temp.
         end do
      else if(x.ne.0) then
         if(icent.eq.-1.and.ns.gt.nsymo) then
c     combination of antisymmetric inversion and given operation
            if(ihd.eq.1) then
               rx6=r(6,6,ns)    ! antisymmetric centering
            else
               rx6=-r(6,6,ns)   ! include antisymmetry operator
            end if
         else
            if(ihd.eq.1) then
               rx6=-r(6,6,ns)   ! antisymmetric centering
            else
               rx6=r(6,6,ns)    ! include antisymmetry operator
            end if
         end if
         if(rx6.eq.-1) then
            fct=mpl(n)*p(n)*ascfu*tmpf
            dfcdp=mpl(n)*ascfu*tmpf
            dfcds1=mpl(n)*p(n)*( ascf1-ascf2)*tmpf
            dfcds2=mpl(n)*p(n)*(-ascf2+ascf3)*tmpf
            do k=1,9
               dfcdb(k)=mpl(n)*p(n)*ascfu*dtmpf(k)
            end do
         else if(rx6.eq.1) then
            fct=mpl(n)*p(n)*ascft*tmpf
            dfcdp=mpl(n)*ascft*tmpf
            dfcds1=mpl(n)*p(n)*(-ascf1+ascf2)*tmpf
            dfcds2=mpl(n)*p(n)*(-ascf1+ascf3)*tmpf
            do k=1,9
               dfcdb(k)=mpl(n)*p(n)*ascft*dtmpf(k)
            end do
         end if
      end if
      do kx=1,6
         tr(kx)=t(kx,ns)
      end do
      if(ihd.eq.1) then
         tr(5)=tr(5)+0.5        ! antisymmetric centering
      end if
      return
      end

      function fq1i(hr,ej,rmax,dfqdr)
c       fourier integral of an ellipsoid with principal axes ej
      integer hr(6)
      real ej(6,*)
      real q1,q2,q3,q(6)
      complex dfqdr
      data pi2/6.28318/, eps/0.001/
c
      pi4=2*pi2
c      call getqi0(hr,q)
      call getqi(hr,q)
      call geta(am)
      call getam(am)
      r1=vabs(ej(4,1),3)/am
      r2=vabs(ej(4,2),3)/am
      r3=vabs(ej(4,3),3)/am
      q1=vinpr(q(4),ej(4,1),3)*pi2*rmax/r1**2
      q2=vinpr(q(4),ej(4,2),3)*pi2*rmax/r2**2
      q3=vinpr(q(4),ej(4,3),3)*pi2*rmax/r3**2
      qi=sqrt(q1**2+q2**2+q3**2)
      vr=pi4*r1*r2*r3*rmax**3/3
      if(qi.lt.eps) then
           fq1i=vr
      else
           fq1i=3*vr*(sin(qi)-qi*cos(qi))/qi**3
c          dfqdqi=3*vr*(cos(qi)-cos(qi)+qi*sin(qi))/qi**3-3/qi*fq1i
           dfqdqi=3*vr*sin(qi)/qi**2-3/qi*fq1i
           dfqdr=dfqdqi*qi/rmax+3/rmax*fq1i
      end if
      return
      end

      function fq2i(hr,rmax,dfqdr)
c        fourier integral of a sphere
      integer hr(*)
      real q(6)
      complex dfqdr
c      data pi2/6.28318/, eps/0.001/, ras/1.4325/
      data pi2/6.28318/, eps/0.001/, ras/1./
      v=2*pi2*ras**3/3
c
c      call getqi0(hr,q)
      call getqi(hr,q)
      call geta(al)
      call getam(am)
      rmaxd=rmax*am
      vr=v*rmaxd**3
      absq=sqrt(q(4)**2+q(5)**2+q(6)**2)
      qi=pi2*absq*ras*rmaxd
      dqidr=pi2*absq*ras    ! = qi/rmaxd
      if(qi.gt.eps) then
           fq2i=3*vr*(sin(qi)-qi*cos(qi))/qi**3
c          dfqdqi=3*vr*(cos(qi)-cos(qi)+qi*sin(qi))*dqidr*am/qi**3
c                 -3*fq2i/qi*dqidr*am     +3*fq2i/rmaxd*am
           dfqdqi=3*vr*sin(qi)/qi**2-3*fq2i/qi
           dfqdr=(dfqdqi*dqidr+3/rmaxd*fq2i)*am
      else
           fq2i=vr
c          dfqdq=3*vr/qi-3*vr/qi + O(qi) => 0
c           dfqdr=(3/rmaxd*fq2i)*am
           dfqdr=(3*v*rmaxd**2)*am
      end if
      return
      end
c

      function fq1d(h,ej,rmax,dfqdr)
c       Fourier integral of an ellipse with principal axie ej
      integer h(*)
      real ej(6,*)
      real rmax,q(6)
      real*8 besj1,qi
      complex dfqdr
c      data pi/3.141592/, eps/0.0001/, ras/0.8700/, sqrt5/2.23606/
      data pi/3.141592/, eps/0.0001/, ras/1./, sqrt5/2.23606/
c        ellips
      pi2=2*pi
c      call getqi0(h,q)
      call getqi(h,q)
      call geta(am)
      call getam(am)
      r1=vabs(ej(4,1),2)/am
      r2=vabs(ej(4,2),2)/am
      q1=vinpr(q(4),ej(4,1),2)*pi2*rmax/r1**2
      q2=vinpr(q(4),ej(4,2),2)*pi2*rmax/r2**2
      absq=sqrt(q1**2+q2**2)
c     s=pi*r1*r2*(rmax*2/sqrt5)**2
c     qi=pi2*absq*ras*rmax*2/sqrt5
      s=pi*r1*r2*rmax**2
      qi=pi2*absq*ras*rmax
      if(qi.gt.eps) then
          fq1d=2*s*besj1(qi)/qi
      else
          fq1d=s
      end if
*************not correct******************
          dfdqi=1
          dfqdr=(1,0)
*******************************
      return
      end

      function fq2d(h,rmax,dfqdr)
c       Fourier integral of a circle
      integer h(*)
      real rmax,q(6)
c     real*8 besj0,besj1,besj2,besjn,qi
      complex dfqdr
c      data pi/3.141592/, eps/0.0001/, ras/0.8700/, sqrt5/2.23606/
      data pi/3.141592/, eps/0.0001/, ras/1./, sqrt5/2.23606/
c        circle
      pi2=2*pi
      call getsys(isys)
      call geta(am)
      call getam(am)
      rmaxd=rmax*am
c      call getqi0(h,q)
      call getqi(h,q)
      absqi=vabs(q(4),2)
      s=pi*(rmaxd*ras)**2
      qi=pi2*absqi*ras*rmaxd
      dqidrm=qi/rmax
      if(qi.gt.eps) then
c          (s/qi) -- rmax
c          besj2(qi) -> qi/2
c          dbesj(n,qi)/dqi=(bes(n-1,qi)-bes(n+1,qi))/2
          fq2d=2*s*besj1(qi)/qi                       ! -> s
          dbedqi=(2*s/qi)*(besj0(qi)-besjn(2,qi))/2   ! -> s/qi
c         dbedqi=(2*s/qi)*(besj0(qi)-besj2(qi))/2   ! -> s/qi
          dfqdr=cmplx(fq2d/rmax+dbedqi*dqidrm,0.0)    ! -> 2*s/rmax
      else
          fq2d=s
          dfqdr=cmplx(2*s/rmax,0.0)
      end if
      return
      end

      subroutine setsmtr(ismtr)
      common /csmtr/ ismtrd
      ismtrd=ismtr
      return
      end

      subroutine getsmtr(ismtr)
      common /csmtr/ ismtrd
      ismtr=ismtrd
      return
      end

      subroutine sethmax(ihmax)
      common /chmax/ ihmaxd
      ihmaxd=ihmax
      return
      end

      subroutine gethmax(ihmax)
      common /chmax/ ihmaxd
      ihmax=ihmaxd
      return
      end

