      integer function getisreset()
      common /cpsreset/ ipreset,isreset
      getisreset=isreset
      return
      end

      integer function getipreset()
      common /cpsreset/ ipreset,isreset
      getipreset=ipreset
      return
      end

      subroutine rdrfncnd(ny,nz)  ! read refinement conditions
      common /caydm/ aydm,alp,ifunc
      common /crfn/ eps,dmpf,maxc
      common /cpnf/ grad1,grad2,grad3,bmin
      common /cpnf2/ ipnf1,ipnf2,ipnf3
      common /cpsreset/ ipreset,isreset
      include 'qcdiff.inc'
      common /cips0/ ips0(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cwflag/ iwflag(7)
      common /ctorms0/ job,ids
      integer itempfi(namax)
      integer getitempf,getna

      call freadis('maxc=',1,maxc,1)
c     read(5,103) eps,dmpf,aydm,alph
      call freadrs('eps=',1,eps,0)
      call freadrs('dmpf=',1,dmpf,0)
      call freadrs('aydm=',1,aydm,0)
      call freadrs('alph=',1,alp,0)
      if(aydm .eq. 0.0) aydm=5.0
c      if(alp.gt.0) then
c         call quit('alph > 0 does not work in this version')
c      end if
      call freadis('ipnf1=',1,ipnf1,1)
      call freadis('ipnf2=',1,ipnf2,0)
      call freadis('ipnf3=',1,ipnf3,0)
      call freadis('ipreset=',1,ipreset,0)
      call freadis('isreset=',1,isreset,0)
      if(ipnf1.lt.0.or.ipnf1.gt.1) then
         call quit('ipnf1 should be 0 or 1')
      end if
      if(ipnf2.lt.0.or.ipnf2.gt.1) then
         call quit('ipnf2 should be 0 or 1')
      end if
      if(ipnf3.lt.0.or.ipnf3.gt.1) then
         call quit('ipnf3 should be 0 or 1')
      end if
      if(ipreset.lt.0.or.ipreset.gt.1) then
         call quit('ipreset should be 0 or 1')
      end if
      if(isreset.lt.0.or.isreset.gt.1) then
         call quit('isreset should be 0 or 1')
      end if
      grad1=0
      grad2=0
      grad3=0
      if(ipnf1.eq.1.or.ipnf1.eq.1.or.ipnf3.eq.1) then
         call freadrs('grad1=',1,grad1,1)
         call freadrs('grad2=',1,grad2,0)
         call freadrs('grad3=',1,grad3,0)
         call freadrs('bmin=',1,bmin,0)
      end if

      itempf=getitempf()
      na=getna()
      if(itempf.eq.1) then
         read(5,'(80i1)') (itempfi(j),j=1,na)
      else
         call zerovi(itempfi,na)
      end if
      call setitempfi(itempfi)

      if(iwflag(3) .eq. 1) then
         write(6,261) maxc,eps,dmpf,aydm,alp
         write(6,262) ipnf1,ipnf2,ipnf3,ipreset,isreset
         write(6,263) grad1,grad2,grad3,bmin
      end if

      if(job .eq. 0) then
         read(5,104) (ips0(k),k=1,ny)
         read(5,104) (ipt(k),k=0,nz)
c     added on Jan. 30 2002
      else 
         do i=1,ny
            ips0(i)=0
         end do
         do i=0,nz
            ipt(i)=0
         end do
      end if
      return
 104  format(80i1)
 261  format(1h , 'maximum cycles', 3x,i3,5x,' eps=',2x,f9.6,2x,
     *     ' dmpf=',2x,f7.4,2x,' aydm=',2x,f7.4,2x,' alp=',f7.4)
 262  format(1h ,' ipnf1=',i1,' ipnf2=',i1,' ipnf3=',i1,
     *    ' ipreset=',i1,' isreset=',i1)
 263  format(1h ,' grad1=',f7.4,' grad2=',f7.4,' grad3=',f7.4,
     *    ' bmin=',f7.4)
      end

      subroutine  getrfncnd(istop,istdv,iq,dmp)   ! get iq and dmp
      common /crfn/ eps,dmpf,maxc
      if(istop .eq. 1. and. istdv .eq. 1) then
         iq=1
         dmp=0.0
      else
         iq=0
         dmp=dmpf
      end if
      return
      end

      subroutine getips(ipsd,ny)
      integer ipsd(0:*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      call vcpyi(ips,ipsd,ny+1)   ! including (0)
      return
      end

      integer function getnxx(ny)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
c     count the number of structural parameters nxx
      l=0
      do ld=1,ny
         if(ips(ld).eq.1) then
            l=l+1
         end if
      end do
      getnxx=l
      return
      end

      subroutine getnpp(ids,npp) 
c     insert profile parameters for each data set
      integer npp(0:*)
      integer getnpf
      npp(0)=0
      do jd=1,ids
         npp(jd)=npp(jd-1)+getnpf(jd)
      end do
      return
      end

      subroutine insert(deltd,md,delt,m,id,ij)  ! choose version
      real deltd(*),md(*),delt(*),m(*)
c     call insert0(deltd,md,delt,m,id,ij)  ! old version
      call insert1(deltd,md,delt,m,id,ij)  ! new version
      return
      end

      subroutine insert0(deltd,md,delt,m,id,ij)
c     insert normal matrix for profile parameters of id-th data set
c     for powder method
c     or scale factor extinction parameters of id-th data set
c     for single crystal method
      real deltd(*),md(*),delt(*),m(*)
      include 'qcdiff.inc'
      common /cipt/ ipt(0:40*idsmax),nlc
      common /ctorms0/ job,ids
      integer npp(0:idsmax),ipp(0:idsmax)
c     ij  : number of refined structural parameters
c     nlc : number of refined profile parameters including
c           lattice parameters and scales
c     npp : address in independent profile parameters including bia
c            (for single crystal scale,ads,adm,bia)
c     ipp : address in refined profile parameters including bia
c
      call getnpp(ids,npp)
      call getipp(ids,npp,ipt,ipp)
      ipp0=ij                   ! end of structural parameter
      ipp1=ipp(id-1)            ! end of non-str parameter for (id-1)-th data set
      ipp2=ipp(id)              ! end of non-str parameter for id-th data set
      ipp3=ipp(ids)             ! end of non-str parameter excluding lattice constants

c      write(6,*) 'ij,nlc',ij,nlc
c      write(6,*) 'npp,ipp',(npp(j),j=1,ids),(ipp(j),j=1,ids)
      ijnlc=ij+nlc

      k=0
      do i=1,ijnlc
         j0=i*(i-1)/2
         jd=i-ij
         if(ifaccept(jd,ipp0,ipp1,ipp2,ipp3).eq.1) then
            k=k+1
            delt(i)=delt(i)+deltd(k)
            l=0
            k0=k*(k-1)/2
            do j=1,i
               jk=j0+j
               je=j-ij
               if(ifaccept(je,ipp0,ipp1,ipp2,ipp3).eq.1) then               
                  l=l+1
                  lk=k0+l
                  m(jk)=m(jk)+md(lk)
               end if
            end do
         end if
      end do
c     call wtvctrr('delt',delt,ijnlc)
c     call wttangdiagr('m diagonal term',m,ijnlc)
      return
      end

      subroutine insert1(deltd,md,delt,m,id,ij)
c     insert normal matrix for profile parameters of id-th data set
c     for powder method
c     or scale factor extinction parameters of id-th data set
c     for single crystal method
c     independent phason temperature factor for each data set
      real deltd(*),md(*),delt(*),m(*)
      include 'qcdiff.inc'
      common /cipt/ ipt(0:40*idsmax),nlc
      common /ctorms0/ job,ids
      integer npp(0:idsmax),ipp(0:idsmax)
      integer getmthd
c     ij  : number of refined structural parameters
c     nlc : number of refined profile parameters including
c           lattice parameters and scales
c     npp : address in independent profile parameters including bia
c            (for single crystal scale,ads,adm,bia)
c     ipp : address in refined profile parameters including bia
c
      call vaddr(m,md,m,ij*(ij+1)/2) ! copy structural parameter part
      call vaddr(delt,deltd,delt,ij) ! copy structural parameter part
      if(id.eq.0) then          ! for penalty function
         return
      else if(id.gt.0) then     ! for structure factor calculation
         mthd=getmthd(id)
         call getnpp(ids,npp)
         call getipp(ids,npp,ipt,ipp)
c        write(6,*) 'ij,nlc',ij,nlc
c        write(6,*) 'npp,ipp',(npp(j),j=1,ids),(ipp(j),j=1,ids)
      else
         write(6,*) 'id=',id
         call quit('invalid id in insert')
      end if
      ipp0=ij                   ! end of structural parameter
      ipp1=ipp(id-1)+ij         ! end of non-str parameter for (id-1)-th data set
      ipp2=ipp(id)+ij           ! end of non-str parameter for id-th data set
      ipp3=ipp(ids)+ij          ! end of non-str parameter excluding lattice constants
      ijnlc=ij+nlc              ! nlc : number of refined nonstructural parameters
      k=ij
      do i=ij+1,ijnlc           ! i-th line
         j0=i*(i-1)/2           ! offset in triangular matrix m
         if(ifaccept(i,ipp0,ipp1,ipp2,ipp3).eq.1) then
            k=k+1
            k0=k*(k-1)/2
            delt(i)=delt(i)+deltd(k)
            l=0
            do j=1,i
               jk=j0+j
               if(ifaccept(j,ipp0,ipp1,ipp2,ipp3).eq.1) then
                  l=l+1
                  lk=k0+l
                  m(jk)=m(jk)+md(lk)
               end if
            end do
         end if
      end do
c      call wtvctrr('delt',delt,ijnlc)
      nid=ipp(id)-ipp(id-1)
c      call wttangmtrxr('md in insert',md,ij+nid)
c      call wttangmtrxr('m in insert',m,ijnlc)
      write(6,*) ' '
      return
      end

      subroutine insert2(deltd,md,delt,m,id,ij)
c     insert normal matrix for profile parameters of id-th data set
c     for powder method
c     or scale factor extinction parameters of id-th data set
c     for single crystal method
c     common phason temperature factor version
      real deltd(*),md(*),delt(*),m(*)
      include 'qcdiff.inc'
      common /cipt/ ipt(0:40*idsmax),nlc
      common /ctorms0/ job,ids
      integer npp(0:idsmax),ipp(0:idsmax)
      integer getmthd
c     ij  : number of refined structural parameters
c     nlc : number of refined profile parameters including
c           lattice parameters and scales
c     npp : address in independent profile parameters including bia
c            (for single crystal scale,ads,adm,bia)
c     ipp : address in refined profile parameters including bia
c
      call vaddr(m,md,m,ij*(ij+1)/2) ! copy structural parameter part
      call vaddr(delt,deltd,delt,ij) ! copy structural parameter part
      if(id.eq.0) then          ! for penalty function
         return
      else if(id.gt.0) then     ! for structure factor calculation
         mthd=getmthd(id)
         call getnpp(ids,npp)
         call getipp(ids,npp,ipt,ipp)
c        write(6,*) 'ij,nlc',ij,nlc
c        write(6,*) 'npp,ipp',(npp(j),j=1,ids),(ipp(j),j=1,ids)
      else
         write(6,*) 'id=',id
         call quit('invalid id in insert')
      end if
      ipp0=ij                   ! end of structural parameter
      ipp1=ipp(id-1)+ij         ! end of non-str parameter for (id-1)-th data set
      ipp2=ipp(id)+ij           ! end of non-str parameter for id-th data set
      ipp3=ipp(ids)+ij          ! end of non-str parameter excluding lattice constants
      ijnlc=ij+nlc              ! nlc : number of refined nonstructural parameters
      k=ij
      do i=ij+1,ijnlc           ! i-th line
         j0=i*(i-1)/2           ! offset in triangular matrix m
         if(ifaccept(i,ipp0,ipp1,ipp2,ipp3).eq.1) then
            k=k+1
            k0=k*(k-1)/2
            delt(i)=delt(i)+deltd(k)
            l=0
            do j=1,i
               jk=j0+j
               if(ifaccept(j,ipp0,ipp1,ipp2,ipp3).eq.1) then
                  l=l+1
                  lk=k0+l
                  m(jk)=m(jk)+md(lk)
               end if
            end do
         end if
      end do
c      call wtvctrr('delt',delt,ijnlc)
      nid=ipp(id)-ipp(id-1)
c      call wttangmtrxr('md in insert',md,ij+nid)
c      call wttangmtrxr('m in insert',m,ijnlc)
      write(6,*) ' '
      return
      end
      
      integer function ifaccept(j,ipp0,ipp1,ipp2,ipp3)
      if(j.le.ipp0.or.(j.gt.ipp1.and.j.le.ipp2).or.
     *     j.gt.ipp3) then
         ifaccept=1
      else
         ifaccept=0
      end if
      return
      end

      subroutine calcstdv(z,m,nt,is,fstdv,ij,ny,nz) ! standard deviations
      real z(*),m(*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      real mtrxrdiag
c     calculate standard deviations
      call zerov(z,nt)
c      do j=1,nt
c         z(j)=0.0
c      end do

      k=0
c      kk=0
      do j=1,ny
         if(ips(j) .eq. 1) then
            k=k+1
            z(j)=sqrt(fstdv*mtrxrdiag(m,k)/(is-ij-nlc))
         end if
      end do

      do j0=0,nz
         j=j0+ny+1
         if(ipt(j0) .eq. 1) then
            k=k+1
            z(j)=sqrt(fstdv*mtrxrdiag(m,k)/(is-ij-nlc))
         end if
      end do
      return
      end

      subroutine getnewprm(x,de,ips,ipt,ny,nz)  ! get new parameters
      real x(*),de(*)
      integer ips(0:*),ipt(0:*)
      k=0
      do j=1,ny
         if(ips(j) .eq. 1) then
            k=k+1
            x(j)=x(j)+de(k)
         end if
      end do

      do j0=0,nz
         j=j0+ny+1
         if(ipt(j0) .eq. 1) then
            k=k+1
            x(j)=x(j)+de(k)
         end if
      end do
      return
      end

      subroutine sngprm(ising,iret,ips,ipt,ny,nz)
c     printour singular parameter No.
      integer ips(0:*),ipt(0:*)
      if(ising .eq. 0) then 
         return
      end if
      k=0
      do j=1,ny
         if(ips(j) .eq. 1) then
            k=k+1
            if(k .eq. iret) then
               write(6,*) j,'th structural parameter',
     *              ' is singular'
               call wtvctrif('ips=',ips(1),ny,'(50i2)')
               call quit(' ')
            end if
         end if
      end do
      
      do j0=0,nz
         j=j0+ny+1
         if(ipt(j0) .eq. 1) then
            k=k+1
            if(k .eq. iret) then
               write(6,*) j0+1,'th non structural parameter',
     *              ' is singular'
               call wtvctrif('ipt=',ipt,nz+1,'(50i2)')
               call quit(' ')
            end if
         end if
      end do
      return
      end
