      subroutine stfcd(h,f,fn,dfdxx,q,ny,dfdbia)
c     structure factor for dihedral quasicrystals
      integer h(*)
      complex f,fn(*),dfdxx(*),dfdbia
      real q(*)
      real mpl
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex f0
      real xi(6)
      common /ctodrw10/ biat
      real e1e2(6)

      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer prmtbl
      common /cprmtbl/ prmtbl(120,namax)
      common /csimul/ dfdx(nxprm,nhkl),nxx

      complex pi2,cexhrt,cexpf
      complex ascf1,ascf2,ascf3,ascft
      complex f00s(120,namax),df00dr1s(120,namax),df00dr2s(120,namax)
      common /ctype/ ityp(-2:namax)
      complex f0s(120),df0dr1s(120),df0dr2s(120)

      complex dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      common /ccmplx1/ dphdxe1,dphdxe2,dphdxe3,dphdxi,dphdr1,dphdr2
      complex dfcdp,dfcdb(9),dfcds1,dfcds2,fct,phsn
      common /ccmplx2/ dfcdp,dfcdb,dfcds1,dfcds2,fct,phsn

      complex df0dr1,df0dr2
      common /ccmplx0/ df0dr1,df0dr2

      real vi(nemax,namax)
      real t(6)
c      real qr(6)
      integer jtyp(-2:namax)
      integer hr(6),hri(6)
      real b2(9)                ! temperature b2(1)=be b2(2)=b1,b2(3)=bi b2(3)=u11, ... b2(9)=u12
      real dtmpf(9)             ! derivative of debye waller factor by tmp factors
      character brv
      integer getnsymo,geticent,getish,getnxx
      data pi/3.141592/, eps/0.00001/
      data pi2/(0.0,6.28318)/

      idm=5
      icent=geticent()
      nsymo=getnsymo()
      qd=vabs(q,3)
      call geta(al)
      call getam(am)
      unitvoli=am**2
      call getc(cl)
      call getbrv(brv)
c     absqe: length of diffraction vector in angstrom**-1
      absqe=qd
      f=(0.,0.)
      call zerovc(dfdxx,ny)
      dfdbia=(0.0,0.0)
      call getnpod(npod)
      call zerovi(jtyp,npod+2)

      if(brv.eq.'c') then
         ihdm=1                 ! antisymmetric centering
      else
         ihdm=0
      end if
      do ihd=0,ihdm         
         do n=1,na
c     ****** vi: volume of rhombohedron with edge vecotrs e1,e2
            ishn=getish(n)
            jtyp(ishn)=jtyp(ishn)+1
            call getvid(n,vi(1,n))
            if(ishn.gt.0) then
c               do nsc=1,ncst(ishn)
c                 ns=cosrep(nsc,ishn) ! nsi=isymo(cosrep(nsc,ishn))
               do nsc=1,ncst(n)
                  ns=cosrep(nsc,n) ! nsi=isymo(cosrep(nsc,ishn))
                  call gethr0(h,hr,ns,0) !   call gethr0(h,hr,nsi,0)
                  if(ityp(ishn).gt.0) then
                     f0s(nsc)=f0(n,vi,irs,isymo,hr,
     *                    df0dr1s(nsc),df0dr2s(nsc))/unitvoli
                  else if(ityp(ishn).lt.0.and.jtyp(ishn).eq.1) then
                     f00s(nsc,ishn)=f0(n,vi,irs,isymo,hr,
     *                    df00dr1s(nsc,ishn),df00dr2s(nsc,ishn))/unitvoli
                  end if
               end do
            end if
            call getascf123(n,absqe,ascf1,ascf2,ascf3)
            ascft=(1-s(1,n)-s(2,n))*ascf1+s(1,n)*ascf2
     *           +s(2,n)*ascf3
            ascfu=s(1,n)*ascf1+(1-s(1,n)-s(2,n))*ascf2
     *           +s(2,n)*ascf3

            b2(1)=be(n)
            b2(2)=b1(n)
            b2(3)=bi(n)
            call vcpyr(ui(1,n),b2(4),6)

            fn(n)=(0.0,0.0)
            do j=1,isk(0,n)     ! equivalent sites
               ns=isk(j,n)      ! nsi=isymo(ns)
               call gethr0(h,hr,ns,0) ! call gethr0(h,hri,nsi,0)
               tmpf=gettmpf(n,hr,b2,biat,dtmpf) ! Debey-Waller fact.
               call ifcolor(x(1,6),n,ns,tmpf,dtmpf,t,ihd)
               hrx=vinpir(hr,x(1,n),idm)
               ht =vinpir(h,t,idm)
               cexhrt=cexpf(pi2*(hrx+ht))
               fct=mpl(n)*p(n)*ascft*tmpf
               dfcdp=mpl(n)*ascft*tmpf
               dfcds1=mpl(n)*p(n)*(-ascf1+ascf2)*tmpf
               dfcds2=mpl(n)*p(n)*(-ascf1+ascf3)*tmpf

               do k=1,9         ! derivatives of fct with respect to b(k)
                  dfcdb(k)=mpl(n)*p(n)*ascft*dtmpf(k) ! iso & aniso phonon temp. 
               end do
c              write(6,*) 'dfcdb=',dfcdb(1),dfcdb(2)
c              write(6,*) 'ishn=',ishn,'ityp(ishn)=',ityp(ishn)
               
               if(ishn.gt.0) then           ! polygonal OD
                  if(ityp(ishn).gt.0) then
c                    nsd=coset(ns,ishn)
                     nsd=coset(ns,n)
                     phsn=cexhrt*f0s(nsd)
                     df0dr1=df0dr1s(nsd)
                     df0dr2=df0dr2s(nsd)
                  else if(ityp(ishn).lt.0) then
c                     iii=coset(ns,ishn)
                     iii=coset(ns,n)
                     nsd=prmtbl(iii,n) ! nsd=prmtbl(ns,n) ! nsd=prmtbl(j,n)
                     write(6,*) 'iii=',iii,' nsd=',nds,' ns=',ns
                     stop
                     phsn=cexhrt*f00s(nsd,ishn)
                     df0dr1=df00dr1s(nsd,ishn)
                     df0dr2=df00dr2s(nsd,ishn)
                  end if
               else
                  phsn=cexhrt*f0(n,vi,irs,isymo,hr,df0dr1,
     *                 df0dr2)/unitvoli
               end if
               write(6,*) 'phsn=',phsn
               dfdbia=dfdbia+dfcdb(3)*phsn ! for bia
               call gethrx123(n,hr,fct11,fct12,fct13)
               call getxi(xi,n)
               fct2=vinpir(hr,xi,idm)
               dphdxe1=pi2*phsn*fct11
               dphdxe2=pi2*phsn*fct12
               dphdxe3=pi2*phsn*fct13
               dphdxi=pi2*phsn*fct2
               df0dr1=df0dr1*cexhrt/unitvoli
               df0dr2=df0dr2*cexhrt/unitvoli
               fn(n)=fn(n)+phsn*fct
               call ifcolor1(x(6,n),n,fn(n))
               call getdfdxx(n,ny,dfdxx)
            end do               
            f=f+fn(n)
         end do
      end do
      
      nxx=getnxx(ny)
      if(icent.eq.1) then
         f=real(f)*2
         do n=1,na
            fn(n)=fn(n)*2
         end do
         do j=1,nxx
            dfdxx(j)=real(dfdxx(j))*2
         end do
      end if
      return
      end
