c
c     ****** calculate symmetry operators with specified origin shifts
c     
c     ************input data
c
c     (0) isys
c     (1) nsymo,icent,brv
c         nsymo: number of generators in symmetry operations
c         icent: give 1 for centrosymmetryc
c                give 0 otherwise
c          brv : bravais lattce p, i, f, s, c
c                 s : superlattice for decagonal quasicrystal
c                 c : color symmetry for decagonal lattice with P_2c
c              ****** see (11) ******
c     (2) 'symmetry operator'        header  and
c     (3) symmetry operator in the format of I.T.
c             for example x,y,z,t,u,v; x+1/2,y,z+1/2,t,u,v etc.
c              ********    repeat (03) nsymo times
c     (4) x0 : origin shift
c      
      character(20) xstr(6)
      real x0(6)
      character brv
      common /cwflag/ iwflag(6)
      iwflag(3)=1
      call setinp(5)
      call setout(6)
      call freadis('isys=',1,isys,1)
      call rdsymo(1,brv)
      call setbrv(brv)
      call freadra('x0=',6,x0,1)
      write(6,'(a,6f10.5)') 'x0=',(x0(j),j=1,6)
      call orgshft(x0)
      stop
      end

      subroutine orgshft(x0)
      real x0(6)
c     calculate symmetry operators with origin shift x0
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer r1(6,6),ri(6,6),rd(6,6,120)
      real x1(6),t1(6),td(6,120)
      call zeromtrxi(ri,6)
      call zeromtrxi(r1,6)
      do i=1,6
         r1(i,i)=1
         ri(i,i)=-1
      end do
c     {E|x0}R{E|-x0}={E|x0}{R|t-Rx0}={R|t-Rx0+x0}
c         write(6,'(a,6f10.5)') 'x0=',x0
      do j=0,1
         do i=1,nsymo
            if(j.eq.0) then
               call mtmpli6(r1,r(1,1,i),rd(1,1,i))
               call mtmplirmno(rd(1,1,i),x0,x1,6,6,1) ! get x1=Rx0
               call vsubr(x0,x1,t1,6)
               call vaddr(t(1,i),t1,td(1,i),6)
            else 
               call mtmpli6(ri,r(1,1,i),rd(1,1,i+nsymo))
               call mtmplirmno(rd(1,1,i+nsymo),x0,x1,6,6,1) ! get x1=Rx0
               call vsubr(x0,x1,t1,6)
               call vaddr(t(1,i),t1,td(1,i+nsymo),6)
            end if
         end do
      end do
      if(icent.eq.0) then
         call wtsymo(rd,td,nsymo,6)
      else
         call wtsymo(rd,td,nsymo*2,6)
      end if
      return
      end

      subroutine quit(str)
      character(*) str
      write(6,*) str
      return
      end


      
