c
c     occupation domain class
c
      subroutine reshape(x,q)
      real x(6),q(6)
      call reshape0(x,q)
c     call reshape1(x,q)
      return
      end

      subroutine intreshape()
      common /csmtrm0/ s0(6,6)
      data s0 /  2,-1,-1,-1,-1,-1,
     *          -1, 2,-1, 1, 1,-1,
     *          -1,-1, 2,-1, 1, 1,
     *          -1, 1,-1, 2,-1, 1,
     *          -1, 1, 1,-1, 2,-1,
     *          -1,-1, 1, 1,-1, 2/  ! symmetry matrix
      call intreshape0()
c     call intreshape1()
      return
      end

      subroutine reshape1(x,q)   ! x: a 6D edge vector or xi
      real x(6),q(6)
      common /csmtrm2/ sresh(6,6)
      real xd(6),xi(6)
      data tau3 /4.236067/  ! tau cube
      call mtmplmnor(sresh,x,q,6,6,1)    ! similarity transformation
c     call sclvctr(q,tau3,6)    ! magnify by tau3 
      return
      end

      subroutine intreshape1()   ! initialization of reshape matrix s1 and s2
      common /csmtrm2/ sresh(6,6)  ! reshape transformation matrix
      real m2(6,6),m2i(6,6),m20(6,6)
      real q(6),q0(6),y0(6),y(6)
      common /csmtrm0/ s0(6,6)
      real s1(6,6),s1_2(6,6)
      data tau3 /4.236067/  ! tau cube
      real vi(6),qi(6)
      real b(6),x_i(6,6)
      call mcpyr(s0,s1,6)
      call wtmtrxrf('s1=',s1,6,'(6f10.4)')
      call getm2(s1,m2)
      call wtmtrxrf('m2=',m2,6,'(6f10.4)')
      call mcpyr(m2,m2i,6)
      call matinv6(m2i,b,0,det)
      write(6,*) 'det=',det
      call wtmtrxrf('m2i=',m2i,6,'(6f10.4)')
      do i=1,6
         call getrowmtrxr(s1,vi,6,i) ! get i-th row
         call getqed(vi,qi)     ! get q-space component
         call zerov(qi,3)       ! remove external components
         call setrowmtrxr(qi,x_i,6,i)! set i-th row of x_i
      end do      
      call wtmtrxrf('x_i=',x_i,6,'(6f10.5)')
      call trnspr(x_i,6)
      write(6,*) 'after tronsposition'
      call wtmtrxrf('x_i=',x_i,6,'(6f10.5)')
      call mtmplr(x_i,m2i,sresh,6)
      call wtmtrxrf('sresh=',sresh,6,'(6f10.4)')
c     for check
      do i=1,6
         write(6,*) 'vabs(s1(1,i)',vabs(s1(1,i),6)
         write(6,*) 'vabs(m2(1,i)',vabs(m2(1,i),6)
      end do
      call mtmplr(s1,s1,s1_2,6)
      call wtmtrxrf('s1^2=',s1_2,6,'(6f10.5)')
      do i=1,6
         call zerov(y,6)
         y(i)=1
         call reshape(y,q)
         call wtvctrrf('q =',q,6,'(6f10.4)')      
         write(6,*) 'vabs(q )=',vabs(q,6)
         call getrowmtrxr(s1,y,6,i) ! get i-th row
         call getqed(y,q0)
         call wtvctrrf('q0=',q0,6,'(6f10.4)')      
         write(6,*) 'vabs(q0)=',vabs(q0(4),3)         
      end do
      return
      end

      subroutine getm2(s1,m2)  ! model dependent
      real s1(6,6),m2(6,6)
      call mtmplr(s1,s1,m2,6)
      return
      end

      subroutine reshape0(x,q)   ! x: a 6D edge vector or xi
      real x(6),q(6)
      common /csmtrm1/ s1(6,6),s2(6,6)
      real xd(6),xi(6)
      data tau3 /4.236067/  ! tau cube

      call mtmplmnor(s1,x,xd,6,6,1) ! similarity transformation
                                !  ext tau^-3 int tau^3
      call prjint(xd,xi)        !  projection into internal space
                                !  introduce phason strain
c     call wtvctrrf('xi=',xi,6,'(6f10.5)')
c      call mtmplmnor(s2,xi,x,6,6,1)  ! reshaped edge vectors for small OD
c                                ! (ext tau^6) int tau^-6
c      call sclvctr(x,tau3,6)    ! magnify by tau^3 
      call getqed(x,q)
      call sclvctr(q,1.0/tau3**2,6) ! approximation
      return
      end

      subroutine intreshape0()   ! initialization of reshape matrix s1 and s2
      real m2(6,6),m2i(6,6)
      real m3(6,6)
      real x(6),q0(6),q(6)
      common /csmtrm0/ s0(6,6)
      common /csmtrm1/ s1(6,6),s2(6,6)
c     s1,s2 : transformation matrix of edge vectors of small
c     OD for cluster models
c     first s2 should be apply for 6D edge vectors
c     and after projecting into internal space
c     s2 should be apply
c     they can be used as edge vectors under linear phason for cluster models
      real unt(6,6),s(6,6),s_3(6,6),s1_3(6,6)
      real b(6),v1(6),v2(6),xi(6),x_i(6,6),y_i(6,6)
      call wtmtrxrf('s0=',s0,6,'(6f10.4)')
      call mcpyr(s0,s1,6)
      call getm2(s0,m2)     ! m2=s0^2
      call wtmtrxrf('m2=',m2,6,'(6f10.4)')
      call mcpyr(m2,m2i,6)
      call matinv6(m2i,b,0,det)
      call mcpyr(m2i,s2,6)

      do i=1,6
         call getqed(s1(1,i),x_i(1,i))  ! s1: symmetric matrix
         call zerov(x_i(1,i),3)  ! remove external comp.
         call wtvctrrf('x_i=',x_i(1,i),6,'(6f10.5)')
      end do      
      call trnspr(x_i,6)            ! EQ. (5)
      call mtmplr(m2i,x_i,y_i,6)  ! Eq. (7)
      do i=1,6
         call getrowmtrxr(y_i,q,6,i)
         call wtvctrrf('y_i=',q,6,'(6f10.5)')         
      end do
c  *******  for check ******      
c      call getsmtrx(s)
c      call mtcube6(s,s_3)
c      call sclmtrx(s_3,0.125,6)
c      call matinv6(s_3,b,0,det)      
c      call wtmtrxrf('s_3=',s_3,6,'(6f10.4)')      
c      call mtcube6(s1,s1_3)
c      call wtmtrxrf('s1_3=',s1_3,6,'(6f10.4)')      

c      call mtmplr(m2,m2i,unt,6)
c      call wtmtrxrf('m2i=',m2i,6,'(6f10.4)')      
c      call wtmtrxrf('unt2=',unt,6,'(6f10.4)')
c      call mtmplr(m2i,m1i,m3,6)
c      call wtmtrxrf('m3=',m3,6,'(6f10.4)')
c      do i=1,6
c         call getrowmtrxr(m3,x,6,i)
c         call wtvctrrf('x=',x,6,'(6f10.5)')
c         call getqed(x,q)
c         write(6,*) 'qe,qi=',vabs(q,3),vabs(q(4),3)
c      end do

c     stop
      return
      end

      subroutine setjsimod(jsimod0)
      common /copd4/ jsimod
      jsimod=jsimod0
      return
      end

      integer function getjsimod()
      common /copd4/ jsimod
      getjsimod=jsimod
      return
      end

      subroutine chkcolsym(npod)
c     check whether color symmetry operators are included in the site
c     symmetry operators used or not, since the present version
c     does not allow color symmetry operators for them
      include 'qcstrc.inc'
      common /cislct0/ iaslct0(120,namax)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call getsys(isys)
      if(isys.ne.3) then ! if not decagonal return
         return
      end if
c     for decagonal system only
      do i=1,npod
         do j=1,nsymo*(icent+1)
            call rednsic(j,ns,ic)
            if(iaslct0(j,i).eq.1) then
               if(ic.eq.0.and.r(6,6,ns).eq.-1) then
                  write(6,*) 'symmetry operator no.',j,' in od no.',i
                  call quit('is a color symmetry inhibited')
               end if
            end if
         end do
      end do
      return
      end

      subroutine rdpod(npod)  ! read occupation domain data
      include 'qcstrc.inc'
      common /cwflag/ iwflag(6)
      common /copd1/ ramin00(namax),ramax00(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /ctype/ ityp(namax)
      common /cislct0/ iaslct0(120,namax)
      common /copd4/ jsimod
      character(30) str
      real fj(7,nemax)
      real ejd(6)
      integer getisys,getnsym,geticnt
      isys=getisys()
      call getinp(inpu)
      call getout(iout)
c     call setsmtrm(jsimod)  ! set simirality transformation matrix

      iwflag(3)=1
      if(isys.ne.5) then
         nd=6
      else
         nd=7
      end if

      do i=1,npod
         read(inpu,*) n, nej0(i), ityp(i), str
         do j=1,nej0(i)
            call freadra('ej=',nd,ej0(1,j,i),1)
         end do
         if(iwflag(3).eq.1) then
            write(6,302) n, nej0(i)
         end if
         do j=1,nej0(i)
            write(6,303) 'ej=', (ej0(k,j,i),k=1,nd)
c           call smtrx(ej0(1,j,i),ejd,jsimod)  ! similarity transformation
c           call vcpyr(ejd,ej0(1,j,i),6)
         end do
         call freadi('nth=',1,nth0(i),1)
         if(nth0(i).gt.nemax) call quit('nth > nemax')
         do j=1,nth0(i)
            if(isys.le.2) then
               call freadia(' ',3,mej0(1,j,i),0)
            else
               call freadia(' ',2,mej0(1,j,i),0)
            end if
         end do
         if(isys.le.2) then
            write(6,304) ('(',(mej0(k,j,i),k=1,3),j=1,nth0(i))
         else
            write(6,305) ('(',(mej0(k,j,i),k=1,2),j=1,nth0(i))
         end if
         icent=geticnt()
         nsymo=getnsym()
         read(inpu,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
         write(iout,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
      end do
 300  format(' ')
 301  format(' ','na=',i3)
 302  format(' ',i2,2x,i2)
 303  format(' ',a,7f8.5,2x,a,f8.5)
 304  format(' ','(e1,e2,e3)=',8(a,i2,',',i2,',',i2,')')/
     *                (' ',11x,8(a,i2,',',i2,',',i2,')')))
 305  format(' ','(e1,e2)=',10(a,i2,',',i2,')')/
     *              (' ',8x,10(a,i2,',',i2,')')))
      return
      end

      subroutine getfjd3(fj1,fj2,fj3) ! vector under linear phason
      real fj1(*),fj2(*),fj3(*)
      real xd1(6),xd2(6),xd3(6)
      call vcpyr(fj1,xd1,6)
      call vcpyr(fj2,xd2,6)
      call vcpyr(fj3,xd3,6)
      call getqed(xd1,fj1)   ! cartesian coordinates under linear phason
      call getqed(xd2,fj2)
      call getqed(xd3,fj3)
      return
      end

      subroutine getfjd2(fj1,fj2) ! vector under linear phason
      real fj1(*),fj2(*)
      real xd1(6),xd2(6)
      call vcpyr(fj1,xd1,6)
      call vcpyr(fj2,xd2,6)
      call getqed(xd1,fj1)   ! cartesian coordinates under l. phason
      call getqed(xd2,fj2)
      return
      end

      subroutine getnii1(ej1,ej2,ej3,ni,sig)  ! for icosahedral
c     get normal (ni) to the plane of a tetrahedron defined by ej1,ej2,ej3
      include 'qcstrc.inc'
      real ni(0:6,*),ej1(*),ej2(*),ej3(*)
      real cent(6),ejl(6)
      data eps/0.00001/
c     unit vector along ej and
c     normal to the boundary plane defined by ej2 and et3 
      call pnrml1(ej2,ej1,ni(0,1))
      call pnrml1(ej3,ej2,ni(0,2))
      call pnrml1(ej1,ej3,ni(0,3))
c     normal to the plane throug ej(j1) ej(j2) ej(j3)
      call pnrml2(ej1,ej2,ej3,ni(0,4))
      do l=1,3
         if(l.eq.1) then
            call vcpyr(ej1,ejl,6)
         else if(l.eq.2) then
            call vcpyr(ej2,ejl,6)
         else if(l.eq.3) then
            call vcpyr(ej3,ejl,6)
         end if
         do k=4,6
            cent(k)=ejl(k)-(ej1(k)+ej2(k)+ej3(k))/3
         end do
         if(vinpr(cent(4),ni(4,l),3).gt.0.) then
            sig=1.
         else
            sig=-1.
         end if
         do k=4,6           ! Dec. 25, 1977
            ni(k,l)=ni(k,l)*sig
         end do
      end do
c     write(6,*) 'ni(1)=',(ni(jj,1,j,i),jj=4,6)
c     write(6,*) 'ni(2)=',(ni(jj,2,j,i),jj=4,6)
c     write(6,*) 'ni(3)=',(ni(jj,3,j,i),jj=4,6)
c     write(6,*) 'ni(4)=',(ni(jj,4,j,i),jj=4,6)
      return
      end

      subroutine getnid1(ej10,ej20,ni,sig)  ! for dihedral
      include 'qcstrc.inc'
      real ej10(*),ej20(*),ni(0:6,4)
      real esub(6)
      real cent(6)
      integer getnth,getna
      data eps/0.00001/
      absej=vabs(ej10(4),2)
      ni(0,1)=absej
      ni(4,1)= ej10(5)/absej
      ni(5,1)=-ej10(4)/absej
      absej=vabs(ej20(4),2)
      ni(0,2)=absej
      ni(4,2)= ej20(5)/absej
      ni(5,2)=-ej20(4)/absej
c     unit vector normal to ej(j2)-ej(j1)
      call vsubr(ej20,ej10,esub,6)
      absej=vabs(esub(4),2)
      if(absej.gt.eps) then
         ni(0,3)=absej
         ni(4,3)= esub(5)/absej
         ni(5,3)=-esub(4)/absej
      else
         do k=4,5
            ni(k,3)=0.
         end do
         ni(0,3)=0.
      end if
      do l=1,3
         if(l.eq.1) then
            do k=4,5
               cent(k)=ej10(k)-(ej10(k)+ej20(k))/2
            end do
         else if(l.eq.2) then
            do k=4,5
               cent(k)=ej20(k)-(ej10(k)+ej20(k))/2
            end do
         else if(l.eq.3) then
            do k=4,5
               cent(k)=(ej20(k)+ej10(k))/2
            end do
         end if
         if(vinpr(cent(4),ni(4,l),2).gt.0.) then
            sig=1.
         else
            sig=-1.
         end if
         do k=4,5
            ni(k,l)=ni(k,l)*sig
         end do
      end do
      return
      end

      subroutine getnid(na,ni)  ! set rimax for dihedral
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,*)
      real ej10(6),ej20(6)
      real cent(6)
      integer getnth
      data eps/0.00001/
      do i=1,na
         nth=getnth(i)
c        write(6,*) 'i,nth=',i,nth
         if(nth.eq.0) then
            write(6,*) 'i,nth(i)=',i,nth
            call quit('nth=0 in getnid')
         end if

         do j=1,nth
            call getej12(i,j,ej10,ej20)
            call getnid1(ej10,ej20,ni(0,1,j,i),sig)
            ri=abs(vinpr(ej10(4),ni(4,3,j,i),2))*getramax0(i)
            rj=max(vabs(ej10(4),2),vabs(ej20(4),2))*getramax0(i)
            if(j.eq.1) then
               call setrimin(i,ri)
               call setrimax(i,rj)
            else
               rimind=min(getrimin(i),ri)
               rimaxd=max(getrimax(i),rj)
               call setrimin(i,rimind)
               call setrimax(i,rimaxd)
            end if
         end do
         write(6,'(a,i3,2(a,f10.5))') 'atom=',i,' rimin=',getrimin(i),
     *        ' rimax=',getrimax(i)
         write(6,'(a,i3,2(a,f10.5))') 'atom=',i,' ramin=',getramin0(i),
     *        ' ramax=',getramax0(i)
      end do
      return
      end

      subroutine getityp(itypd)
      integer itypd(*)
      include 'qcstrc.inc'
      common /ctype/ ityp(namax)
      integer getnpod
      npod= getnpod()
      do i=1,npod
         itypd(i)=ityp(i)
      end do
      return
      end

      integer function getitypn(n)
      include 'qcstrc.inc'
      common /ctype/ ityp(namax)
c     n : predefined occupation domain number
      getitypn=ityp(n)
      return
      end

      subroutine setnpod(npodd)
      common /cnapod/ na, npod
      npod=npodd
      return
      end

      integer function getnpod()
      common /cnapod/ na, npod
      getnpod=npod
      return
      end

      function getfacti(brv)
      character brv
      integer getisys
      isys=getisys()
      if(brv.eq.'p') then
         fact=1
      else if(isys.le.2.and.(brv.eq.'f'.or.brv.eq.'s')) then
         fact=32
      else if(brv.eq.'i') then
         fact=2
      else if(brv.eq.'g') then
         fact=1
      else
         call quit('invalid brv in vivoli')
      end if
      getfacti=fact
      return
      end

      function getfactd(brv)
      character brv
      integer getisys
      isys=getisys()
      if(brv.eq.'p'.or.brv.eq.'s') then
         fact=1
      else if(brv.eq.'i') then
         fact=2
      else if(brv.eq.'c') then
         fact=2
      else
         call quit('invalid brv in vivold')
      end if
      getfactd=fact
      return
      end

      subroutine vivoli(na)
c      volume of each occupation domain
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      real ej1(6),ej2(6),ej3(6)
      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      real vn(namax)
      real vi(nemax,namax)
      real e1e2(6), po(3)
      character brv
      integer hr(6)
      integer geticnt,getisys,getien,getish,getnth
c      data pi2/6.28318/, eps/0.001/, ras/1.4325/
      data pi2/6.28318/, eps/0.001/, ras/1./
      data hr/0,0,0,0,0,0/

      pi4=2*pi2
      call getbrv(brv)
      isys=getisys()
****************
      atp(1)=0
      atp(2)=0
      atp(3)=0
      call geta(al,am)
c      write(6,*) 'partial occupation probabilities'
c      write(6,*) '         p(1)  p(2)  p(3)'
      do n=1,na
c     ****** vi: volume of rhombohedron with edge vecotrs e1,e2,e3
         if(getish(n).ge.0) then
c           tetrahedron
            vn(n)=0
            nth=getnth(n)
            do j=1,nth
               call getej123(n,j,ej1,ej2,ej3)
               call vprdr(ej1(4),ej2(4),e1e2(4))
               vi(j,n)=abs(vinpr(e1e2(4),ej3(4),3))
               vn(n)=vn(n)+
     *              vi(j,n)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (getramax(n)**3-getramin(n)**3)/6
            end do
         else if(getish(n).eq.-1) then
c           ellipsoid
            call getej123(n,j,ej1,ej2,ej3)
            r1=vabs(ej1(4),3)
            r2=vabs(ej2(4),3)
            r3=vabs(ej3(4),3)
            vn(n)=pi4*r1*r2*r3*mpl(n)*isk(0,n)*
     *           (getramax(n)**3-getramin(n)**3)*am**3/3
         else if(getish(n).eq.-2) then
c           sphare
            v=pi4*ras**3*am**3/3
            vn(n)=v*mpl(n)*isk(0,n)*(getramax(n)**3-getramin(n)**3)
         else 
            call quit('invalid ish')
         end if
         call getatpi(n,atp,iel,vn)

**************************
         vn(n)=vn(n)/am**3  ! independent of am
**************************

      end do
      icent=geticnt()
      if(icent.eq.1) then
         do n=1,na
            vn(n)=vn(n)*2
         end do
         atp(1)=atp(1)*2
         atp(2)=atp(2)*2
         atp(3)=atp(3)*2
      else
         do n=1,na
            vn(n)=vn(n)
         end do
         atp(1)=atp(1)
         atp(2)=atp(2)
         atp(3)=atp(3)
      end if
      vt=0
      do n=1,na
         vt=vt+vn(n)*getp(n)
      end do
      fact=getfacti(brv)
      write(6,*) 'volume of the occupation domain',vt,'(a**3)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*getp(n),n=1,na)
      tatp=atp(1)+atp(2)+atp(3)
      atp(1)=atp(1)/tatp
      atp(2)=atp(2)/tatp
      atp(3)=atp(3)/tatp
      call getdet(det)

c      write(6,*) 'det,am,brv,fact=',det,am,brv,fact
      write(6,'(a,3f12.6,a,f12.6,a,a,f12.6,a)')
     *     ' chemical composition',atp(1),atp(2),atp(3),
     *     '  point density=', vt*abs(det)*fact, '(a**-3)',
     *     ' = ',vt*abs(det)*fact/al**3,'(A**-3)'
      return
      end

      subroutine vivold(na)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      character brv
      real ej1(6),ej2(6)
      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      real vn(namax)
      real vi(nemax,namax), po(3)

      integer geticnt,getisys,getien,getish,getnth
c     data pi/3.141592/, eps/0.0001/, ras/0.8700/, sqrt5/2.23606/
      data pi/3.141592/, eps/0.0001/, ras/1./, sqrt5/2.23606/

      call getbrv(brv)
****************
      atp(1)=0
      atp(2)=0
      atp(3)=0
      call geta(al,am)
      call getc(cl)
c      write(6,*) 'partial occupation probabilities'
c      write(6,*) '         p(1)  p(2)  p(3)'
      do n=1,na
c*****ej: edge vectors of triangle in vi
c     vi: area of the triangle with edges ej
c*****ish(n)      : 0: triangle 1: ellips 2: circle
         if(getish(n).ge.0) then
c     triangle
            vn(n)=0
            nth=getnth(n)
            do j=1,nth
               call getej12(n,j,ej1,ej2)
               vi(j,n)=abs(ej1(4)*ej2(5)-ej1(5)*ej2(4))
               vn(n)=vn(n)+
     *              vi(j,n)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (getramax(n)**2-getramin(n)**2)/2
            end do
c     write(6,*) 'vn,isk,irs=',vn(n),isk(0,n),irs(0,n)
         else if(getish(n).eq.-1) then
c     ellips
            call getej12(n,j,ej1,ej2)
            r1=vabs(ej1(4),2)
            r2=vabs(ej2(4),2)
            si=pi*r1*r2*(2/sqrt5)**2
            vn(n)=si*mpl(n)*isk(0,n)*
     *           (getramax(n)**2-getramin(n)**2)*am**2
         else if(getish(n).eq.-2) then
c     circle
c     si=pi*(2/sqrt5)**2
            si=pi*ras**2*al**2
            vn(n)=si*mpl(n)*isk(0,n)*
     *           (getramax(n)**2-getramin(n)**2*am**2)
         else 
            call quit('invalid ish')
         end if
         call getatpd(n,atp,iel,vn)
c     write(6,'(a,i3,3f7.3)') 'atom=',n,po(1),po(2),po(3)
******************
         vn(n)=vn(n)/al**2
******************
      end do
      icent=geticnt()
      if(icent.eq.1) then
         do n=1,na
            vn(n)=vn(n)*2
         end do
         atp(1)=atp(1)*2
         atp(2)=atp(2)*2
         atp(3)=atp(3)*2
      else

      end if
      vt=0
      do n=1,na
         vt=vt+vn(n)*getp(n)
      end do
      fact=getfactd(brv)
      write(6,*) 'volume of the occupation domain',vt*fact,'(a**2)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*getp(n)*fact,n=1,na)
      tatp=atp(1)+atp(2)+atp(3)
      atp(1)=atp(1)/tatp
      atp(2)=atp(2)/tatp
      atp(3)=atp(3)/tatp
      call getdet(det)  ! volume of the unit cell in reciprocal space (a**-4)
      write(6,'(a,3f12.6,a,f12.6,a,a,f12.6,a)')
     *   ' chemical composition',atp(1),
     *     atp(2),atp(3),'  point density=', vt*abs(det)*fact,
     *     '(a**-2*cl**-1)', ' = ',vt*abs(det)*fact/(al**2*cl),'(A**-3)'
c     write(6,*) 'f000=',f000
      return
      end

      subroutine getatpi(n,atp,iel,vn)
      real atp(3)
      integer iel(3,*)
      real vn(*)
      logical isone
      integer getien
      ie=getien(n)
      i1=iel(1,ie)
      i2=iel(2,ie)
      i3=iel(3,ie)
      if(i1.gt.3.or.i2.gt.3.or.i3.gt.3) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in vivoli')
      end if
      if(i1.lt.1.or.i2.lt.1.or.i3.lt.1) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in vivoli')
      end if
      call gets1s2(n,s1,s2)
      pn=getp(n)
      call geta(a,am)
      atp(i1)=atp(i1)+vn(n)*(1-s1-s2)*pn/am**3
      atp(i2)=atp(i2)+vn(n)*s1*pn/am**3
      atp(i3)=atp(i3)+vn(n)*s2*pn/am**3
      return
      end
      
      subroutine getatpd(n,atp,iel,vn)
      real atp(3)
      integer iel(3,*)
      real vn(*)
      logical isone
      integer getien
      ie=getien(n)
      i1=iel(1,ie)
      i2=iel(2,ie)
      i3=iel(3,ie)
      if(i1.gt.3.or.i2.gt.3.or.i3.gt.3) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in vivold')
      end if
      if(i1.lt.1.or.i2.lt.1.or.i3.lt.1) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in vivold')
      end if
      call gets1s2(n,s1,s2)
      x6=getx6(n)
      pn=getp(n)
      call geta(a,al)
      if(x6.eq.0) then          ! gray atom
         atp(i1)=atp(i1)+vn(n)*(1-s1-s2)*pn/al**2
         atp(i2)=atp(i2)+vn(n)*s1*pn/al**2
         atp(i3)=atp(i3)+vn(n)*s2*pn/al**2
      else if(isone(x6)) then   ! for colored atom
         atp(i1)=atp(i1)+vn(n)*(1-s1-s2)*pn/al**2/2
         atp(i2)=atp(i2)+vn(n)*(1-s1-s2)*pn/al**2/2
         atp(i2)=atp(i2)+vn(n)*s1*pn/al**2/2
         atp(i1)=atp(i1)+vn(n)*s1*pn/al**2/2
         atp(i3)=atp(i3)+vn(n)*s2*pn/al**2
      else if(isone(-x6)) then  ! for colored atom
         atp(i1)=atp(i1)+vn(n)*(s1-s2)*pn/al**2/2
         atp(i2)=atp(i2)+vn(n)*(s1-s2)*pn/al**2/2
         atp(i2)=atp(i2)+vn(n)*(1-s1)*pn/al**2/2
         atp(i1)=atp(i1)+vn(n)*(1-s1)*pn/al**2/2
         atp(i3)=atp(i3)+vn(n)*(s2)*pn/al**2
      else
         write(6,*) 'x6=',x6
         call quit('x6 should be 0,-1,or 1')
      end if
      return
      end

      logical function isone(x6)
      real x6
      if(x6.gt.0.99.and.x6.lt.1.01) then
         isone=.true.
      else
         isone=.false.
      end if
      return
      end
