c
c     symmetry class
c
      subroutine getrotmtrx(n,r)   ! get rotation matrix r for n-th symm. op.
      integer r(6,6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      if(n.gt.nsymo.or.n.le.0) then
         write(6,*) 'n=',n
         call quit('invalid n')
      end if
      call mcpyi6(rr(1,1,n),r)
      return
      end

      subroutine getrsymop(n,r)   ! get rotation matrix r for n-th symm. op.
      real r(6,6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      if(n.gt.nsymo.or.n.le.0) then
         write(6,*) 'n=',n
         call quit('invalid n')
      end if
      call mcpyir6(rr(1,1,n),r)
      return
      end

      subroutine getnptrns(n,t)    ! get nonprimitive translation t for n-th symm. op.
      real t(6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      if(n.gt.nsymo.or.n.le.0) then
         write(6,*) 'n=',n
         call quit('invalid n')
      end if
      call vcpyr(tt(1,n),t,6)
      return
      end

      subroutine gettd(x0,td,ns,ic) ! additional translation due to origin shift x0
      real x0(*)                ! origin shift
      real td(*)
      real rx0(6)
c     call getrx(x0,rx0,ns,ic)  ! rotate and translate vector rx0 by ns,ic
      call getrx0(x0,rx0,ns,ic) ! rotate vector rx0 by ns,ic
      call vsubr(rx0,x0,td,6)   ! td=rx0-x0
c      write(6,*) 'ns,ic=',ns,ic
c      call wtvctrr('x0=',x0,6)
c      call wtvctrr('td=',td,6)
      return
      end

      subroutine rdsymo(na,brv)
      common /cwflag/ iwflag(6)
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer rh
      common /grpd/ rh(6,6,60),th(6,60),ig
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character(30) coord
      character cltd(6)
      data cltd/'p','i','f','s','c','g'/      
c     initialization
      call getinp(inpu)
      call getout(iout)
c     write symmetry operators
      iwflag(3)=1
      ige=1
c
c      read(5,100) nsymo,icent,brv
      call freadi('nsymo=',1,nsymo,1)
      call freadi('icent=',1,icent,0)
      call freadc('brv=',1,brv,0)
      if(brv.eq.'g') then
         call freadi('ig=',1,ig,0)
      end if
      nde=3
      icom=0
c
      write(iout,210) nsymo,icent,brv
      do i=1,6
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do

      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if

      idm=nde+3
c      read(inpu,*) 'symmetry operator'
      call freadr('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call symdecode(coord,rr(1,1,k),tt(1,k))
      end do

      if(iwflag(3).eq.1) then
           if(icent.eq.1.or.icent.eq.-1) then
                 write(iout,2022)
           else
                 write(iout,2021)
           end if
           if(ige.eq.1) then
                write(iout,201) 'generating elements'
           end if
           write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
          call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
         call ordr(rr,imps,nsymo,idm)
         do i=1,nsymo
            call vcpyr(tt(1,i),tg(1,i),6)
            call mcpyi6(rr(1,1,i),rg(1,1,i))
         end do
         impt=1
         call zerovr(tt(1,1),6)
         call unitmtrxi(rr(1,1,1),6)
         do ns=1,nsymo
            imp=imps(ns)
c     modified to include the pure translation
            if(imp.eq.1) then
               if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *              .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *              imp=2
            end if
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
               end do
            end do
            impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,'(1h )')
            call wtsymo(rr,tt,nsymo,idm)
         end if
      end if
      if(brv.eq.'g') then
c        call getgrpd(rh,th,ig)
c        read(inpu,*) 'hull element'
         call freadr('hull element',0,dummy,1)
         do k=1,ig
            read(inpu,'(a)') coord
            call symdecode(coord,rh(1,1,k),th(1,k))
         end do
      end if
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if
      return
 201  format(' ',a)
 2021 format(' ','symmetry operation',10x,'noncentrosymmetric')
 2022 format(' ','symmetry operation',10x,'centrosymmetric')
 207  format(' ','symmetry operators generated by generating elements')
 210  format(' ','nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 231  format(' ','extinction rules for general reflections'/' ',
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         call mcpyi6(re(1,1,i),r)
         call mcpyi6(r,b)
         do j=1,13
c    check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
               end do
            end do
            imps(i)=j
            go to 10
c     a=r
 15         continue
            call mcpyi6(r,a)
c     r=a*b   ==> r=r*re
            call mtmpli6(a,b,r)
         end do
 10      continue
      end do
      do i=1,nsymo
         if(imps(i).ge.13) then
            ierror=1
            go to 21
         else
            ierror=0
         end if
      end do
 21   continue
      if(ierror.eq.1) then
           write(iout,'(''error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character(3) wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,*)
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(i.eq.idm) write(iout,'(' ')')
c 31   continue
      return
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character(3) wtt(6,*)
      real rt(8)
      character(3) wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=tt(j,i)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
c     write(6,*) 'm1,m2,m3=',m1,m2,m3
      call mtmplmnoir(r1(1,1,m1),t2(1,m2),t2(1,m3),6,6,1)
      call vsumr(t2(1,m3),t1(1,m1),t2(1,m3),6)
      call mtmpli(r1(1,1,m1),r2(1,1,m2),r2(1,1,m3),6)
      return
      end

      subroutine geticistp0(icentd,istep)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer getisys
      isys=getisys()
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent
            istep=icent
         end if
      end if
c     write(6,*) 'icentd,istep=',icentd,istep
      return
      end

      subroutine sitesy0(x,isk,irs,mpl)  ! site symmetry of the position x
      real x(*)
      integer isk(0:120),irs(0:120)
      real mpl
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call geticistp0(icentd,istep)
c     write(6,*) 'icentd,istep=',icentd,istep
      nsym=0
      nrx=1
      isk(nrx)=1
c     call wtvctrr('x=',x,6)
      call savex(x,rxs(1,nrx))
      do ic=0,icentd,istep
         do ns=1,nsymo
            call getrx(x,rx,ns,ic)
c     call wtvctrr('rx=',rx,6)
            do irx=1,nrx
               ircomp=rcomp(rx,rxs(1,irx))
c     write(6,*) 'ircomp=',ircomp
               if(ircomp.eq.1) go to 120
            end do
c     site symmetry operator
            nrx=nrx+1
            call savex(rx,rxs(1,nrx))
            if(ic.eq.0) then
               isk(nrx)=ns
            else
               isk(nrx)=ns+nsymo
            end if
 120        continue
c     symmetry operator generating equivalent positions
            if(rcomp(rx,x).eq.1) then
               nsym=nsym+1
               if(ic.eq.0) then
                  irs(nsym)=ns
               else
                  irs(nsym)=ns+nsymo
               end if
            end if
         end do
      end do
      isk(0)=nrx
      irs(0)=nsym
      mpl=1
c     if(icent.eq.1) then
      if(icent.eq.1.or.icent.eq.-1) then
c     compress symmetry element > nsymo
         n=0
         do j=1,isk(0)
            if(isk(j).gt.nsymo) go to 201
            n=n+1
         end do
 201     continue
c     n: number of equivalent positions generated by given operators
c     isk(0): number of equivalent positions generated by given
c     symmetry operators and inversion
         mpl=float(isk(0))/(float(n)*2)
         isk(0)=n
      end if
      return
      end

      subroutine sitesy1(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      integer getisys
      isys=getisys()

      call geticistp0(icentd,istep)
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do ic=0,icent
         do ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      call vcpyr(rx,rxs,idm)
      return
      end


      subroutine getrx0(x,rx,ns,ic)  ! just rotate 6D vector
      real x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer getisys
      isys=getisys()
      call mtmplmnoir(rr(1,1,ns),x,rx,6,6,1)
      if(isys.le.2) then
         if(ic.eq.1) then
            call vnegater(rx,6)
         end if
      else
         do i=1,6
            if(ic.eq.1.or.ic.eq.-1) then
               call vnegater(rx,5)
            end if
            if(ic.eq.-1) then
               rx(6)=-rx(6)
            end if
         end do
      end if
      return
      end

      subroutine getrx(x,rx,ns,ic)  ! rotate and translate 6D vector
      real x(*),rx(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer getisys
      isys=getisys()
      call mtmplmnoir(rr(1,1,ns),x,rx,6,6,1) ! rotation
      if(isys.le.2) then        ! icosahedral
         call vsumr(rx,tt(1,ns),rx,6) ! translation
         if(ic.eq.1) then
            call vnegater(rx,6)  
         end if
      else                      ! dihedral
         call vsumr(rx,tt(1,ns),rx,5) ! translation
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)
         end if
      end if
      return
      end

      subroutine gethrx(x,rx,ns,ic) ! transformation by groupoid hull
      real x(*),rx(*)
      integer rh
      common /grpd/ rh(6,6,60),th(6,60),ig
      integer getisys
      real ry(6)
      isys=getisys()
      if(isys.le.2) then
         call mtmplmnoir(rh(1,1,ns),x,rx,6,6,1)  ! rotate by hull
         call vsumr(rx,th(1,ns),rx,6)            ! translate by hull
         if(ic.eq.1) then
            call vnegater(rx,6)
         end if
      else
         call mtmplmnoir(rh(1,1,ns),x,rx,6,6,1)  ! rotate
         call vsumr(rx,th(1,ns),rx,5)            ! translate
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)
         end if
      end if
      return
      end

      subroutine gethul(rhd,thd,igd)
      integer rhd(6,6,*)
      real thd(6,*)
      integer rh
      common /grpd/ rh(6,6,60),th(6,60),ig
      do k=1,ig
         call mcpyi6(rh(1,1,k),rhd(1,1,k))
         call vcpyr(th(1,k),thd(1,k),6)
      end do
      igd=ig
      return
      end

      subroutine gethr(h,hr,ns,icnt)
      integer h(*),hr(*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call mtmplmnoi(h,rr(1,1,ns),hr,1,6,6)
      if(icnt.eq.1.or.icnt.eq.-1) then
         call vnegatei(hr,6)
      end if
      return
      end

      integer function rcomp(x,rx)  ! if two vectors x and rx is the same
                                    ! return 1 else 0
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      common /cdim/ idm,nde
      real trc(6,32)
      character brv
      data eps/0.00001/
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call getbrv(brv)
      call gettrc(brv,trc,ntrc)
c     write(6,*) 'idm=',idm,' ntrc=',ntrc
c      call wtvctrr('x=',x,6)
c      call wtvctrr('xr=',rx,6)
      rcomp=0
      do j=1,ntrc
c         call wtvctrr('trc=',trc(1,j),6)
         do i=1,idm
            xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.1-eps) then
               xx=abs(xx-1)
            else if(xx.lt.-1+eps) then
               xx=abs(xx+1)
            end if
            if(xx.gt.eps) go to 110
         end do
         rcomp=1
         return
 110     continue
      end do
      return
      end

      subroutine getsymo(r,t,n)
      integer r(6,6)
      real t(6)
      common /cwflag/ iwflag(6)
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character(30) coord
c     character cltd(6)
      call mcpyi6(rr(1,1,n),r)
      call vcpyr(tt(1,n),t,6)
      return
      end

      integer function getnsym()
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      getnsym=nsymo
      return
      end

      integer function geticnt()
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      geticnt=icent
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      integer r1(6,6,*)
      integer r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character(31) z1(60),bl,coord
      character(3) ntr(7)
      integer cp
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write centering translations *********
c      if(ncnt.gt.1) then
c      do 50 i=1,ncnt
c      do j=1,31     
c      z1(i)(j:j)=' '
c      end do
c      cp=0
c      if(i.eq.1) then
c           z1(1)(1:1)='('
c           cp=1
c      end if
c      do 51 j=1,d3
c          do 52 k=1,7
c          if(abs(rtr(k)-cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+3)=ntr(k)
c               cp=cp+3
c               go to 51
c          end if
c 52       continue
c          if(abs(cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+1)='0'
c               cp=cp+1
c          end if
c 51   continue
c      if(i.lt.ncnt) then
c           z1(i)(cp+1:cp+1)=';'
c           cp=cp+1
c      else
c           z1(i)(cp+1:cp+1)=')'
c           cp=cp+1
c      end if
c      ip(i)=cp
c 50   continue
c      write(iout,'(' ',6a)') (z1(i)(1:ip(i)),i=1,ncnt)
c      end if
      do ii=1,nsymo
         call getnptr(t1(1,ii),d1,d2)  ! get non primitive translation
         call symencode(r1(1,1,ii),t1(1,ii),z1(ii),d1,d2)
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *     ii=1,nsymo)
      return
      end

      subroutine symdecode(coord,r,t)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6)
      real t(6)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
      call zerovr(t,6)
      call zeromtrxi(r,6)
      do j=1,6
c        rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k)=1
                  else
                     r(j,k)=-1
                  endif
               endif
            endif
         end do
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j)=-t(j) 
         endif
      end do
c     call wtvctrrf('**t=',t,6,'(6f10.5)')
      end

      subroutine getrotstr(r,xyzd)
      integer r(*)
      character(6) xyzd
      character xyz(6)
      data xyz/'x','y','z','t','u','v'/
      do i=1,6
         if(r(i).gt.0) then
            xyzd='+'//xyz(i)
         else if(r(i).lt.0) then
            xyzd='-'//xyz(i)
         end if
      end do
      return
      end

      subroutine getnptr(t,d1,d2)  ! get non-primitive translation
      real t(*)
      integer d1,d2,d3
      eps=0.00001
      d3=d1+d2
      do i=1,d3
         t(i)=mod(t(i),1.)
         if(t(i).lt.-eps) then
            t(i)=t(i)+1
         else if(t(i).gt.1.0-eps) then
            t(i)=t(i)-1
         end if
      end do
      return
      end

      subroutine symencode(r,t,coord,d1,d2)
c     matrix rep. of symmetry operation into I.T format
      integer r(6,6)
      real t(6)
      character coord*(*)
      integer d1,d2
      real eps,rtr(7)
      common /cdim/ idm,nde
c     character trn(6)*20,xyz(6)*2
      character trn(6)*20,xyz(6)
c        for (d2+d1) dimensional case
      character(31) z1
      character(3) ntr(7)
      integer lenc,ip(16),cp
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/

      integer d3
      character(3) wtt(6,60)
      character(2) str
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      eps=0.00001
      d3=d1+d2

      do i=1,31
         z1(i:i)=' '
         coord(i:i)=' '
      end do

      cp=1
      do i=1,d3
         do k=1,7
            if(abs(t(i)-rtr(k)).le.eps) then
               z1(cp:cp+2)=ntr(k)
               cp=cp+3
               go to 132
            end if
         end do
         do k=1,9
            if(abs(t(i)-k).le.eps) then
               write(str,'(i1)') k
               z1(cp:cp)=str(1:1)
               cp=cp+1
               go to 132
            else if(abs(t(i)+k).le.eps) then
               write(str,'(i2)') -k
               z1(cp:cp+1)=str(1:2)
               cp=cp+2
               go to 132
            end if
         end do
 132     continue
         do j=1,d3
            if(j.le.d2) then
               k=j
            else
               k=j+(3-d2)
            end if
            if(r(i,j).eq.1) then
               if(cp.eq.1) then
                  z1(cp:cp)=xyz(k)
                  cp=cp+1
               else if(z1(cp-1:cp-1).eq.',') then
                  z1(cp:cp)=xyz(k)
                  cp=cp+1
               else
                  z1(cp:cp+1)='+'//xyz(k)
                  cp=cp+2
               end if
            else if(r(i,j).eq.-1) then
               z1(cp:cp+1)='-'//xyz(k)
               cp=cp+2
            end if
            if(j.eq.d3) then
               if(i.ne.d3) then
                  z1(cp:cp)=','
                  cp=cp+1
               else
                  z1(cp:cp)=';'
                  cp=cp+1
               end if
            end if
         end do
      end do
      lenc=istrln(z1)
      if(lenc.gt.31) then
         call quit('lenc > 31')
      end if
      coord(1:lenc)=z1(1:lenc)
      return
      end

      subroutine setnsic(ns,ic)
      common /cnsic/ nsc,icc     ! current symmetry operator
      nsc=ns
      icc=ic
      return
      end

      subroutine getnsic(ns,ic)
      common /cnsic/ nsc,icc     ! current symmetry operator
      ns=nsc
      ic=icc
      return
      end

      subroutine rednsic(nsd,ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(nsd.gt.nsymo) then
         ns=nsd-nsymo
         ic=1
      else
         ns=nsd
         ic=0
      end if
      return
      end

      integer function expnsic(ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(ic.eq.0) then
         expnsic=ns
      else
         expnsic=ns+nsymo
      end if
      return
      end

      subroutine getrx2(x,ry,nsy,icnt)  ! rotation arround shifto
      real x(*),ry(*)
      real rx(6),td(6),shifto(6)
      call getshfto(shifto)     ! shift vector
      call gettd(shifto,td,nsy,icnt) ! extra translation td
      call getrx(x,rx,nsy,icnt) ! site equivalent to x
      call vsumr(rx,td,ry,6)    ! rx+td
      return
      end

      subroutine getrx1i(x,rx,ns) ! just rotate q vector
      real x(*),rx(*)
      call rednsic(ns,nsd,icd)      
      call getrx0i(x,rx,nsd,icd)
      return
      end

      subroutine getrx0i(x,rx,ns,ic)  ! just rotate q
      real x(*),rx(*)
      common /symext/ rei(6,6,60),tei(6,60)
      integer getisys
      isys=getisys()
      call mtmplmnor(rei(1,1,ns),x,rx,6,6,1) ! multiply rotation op. in q space
      if(isys.le.2) then
         if(ic.eq.1) then
            call vnegater(rx,6)
         end if
      else
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)            
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)
         end if
      end if
      absrx=vabs(rx,6)
      if(absrx.eq.0) then
c         write(6,*) 'ns=',ns
c         write(6,*) 'ic=',ic
c         call wtrmtrx6('rei',rei(1,1,ns))
c         call wtrvct6('x',x)
c         call wtrvct6('rx',rx)
c        stop
      end if
      return
      end

      subroutine getsymei(ns,r,t)   ! get symmetry ns-th operator in q space
      real r(6,6),t(6)
      common /symext/ rei(6,6,60),tei(6,60)
      common /symext1/ re(3,3,60),te(3,60)
      common /symext2/ ri(3,3,60),ti(3,60)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      integer getnsym
      call mcpyr(rei(1,1,ns),r,6)
      call vcpyr(tei(1,ns),t,6)
      return
      end

      subroutine setsymei()   ! set symmetry operator in q space
      common /symext/ rei(6,6,60),tei(6,60)
      common /symext1/ re(3,3,60),te(3,60)
      common /symext2/ ri(3,3,60),ti(3,60)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      integer getnsym
      real r(6,6),rd(6,6)
      real ret(3,3),rit(3,3),er(3,3),ei(3,3)
      nsymo=getnsym()
c     write(6,*) '****nsymo=',nsymo
      do n=1,nsymo
         call getrsymop(n,r)
c         call wtrmtrx6('r',r)
         call mtmplr6(r,dq,rd)
         call mtmplr6(dr,rd,rei(1,1,n))
c        call wtrmtrx6('rei',rei(1,1,n))
         call vcpyr(tei(1,n),te(1,n),3)
         call vcpyr(tei(4,n),ti(1,n),3)
         do i=1,3
            do j=1,3
               re(i,j,n)=rei(i,j,n)
            end do
         end do
         do i=1,3
            do j=1,3
               ri(i,j,n)=rei(i+3,j+3,n)
            end do
         end do
         call mcpyr(re,ret,3)
         call mcpyr(ri,rit,3)
         call trnspr3(ret)
         call trnspr3(rit)
         call mtmplr(ret,re,er,3)
         call mtmplr(rit,ri,ei,3)
c         call wtrmtrx3('re',re(1,1,n))
c         call wtrmtrx3('ri',ri(1,1,n))
c         call wtrmtrx3('er',er)
c         call wtrmtrx3('ei',ei)
      end do
      return
      end

      subroutine trhtole(yd)  ! 7d to 6d or 6d to 5d if possible
      real yd(*)
      real xd(7)
      integer getisys
      isys=getisys()
c      call wtvctrr('yd1=',yd,6)
      if(isys.le.2) then
         return
      else if(isys.eq.3) then
         call vcpyr(yd,xd,6)
         call tr6to5e(xd,yd)
      else if(isys.eq.4) then
                                !     do nothing
      else if(isys.eq.5) then
         call vcpyr(yd,xd,7)
         call tr7to5e(xd,yd)
      end if
c      call wtvctrr('yd2=',yd,6)
      return
      end

      subroutine tr6to5e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 1, 0,
     *        -1, 4,-1,-1, 1, 0,
     *        -1,-1, 4,-1, 1, 0,
     *        -1,-1,-1, 4, 1, 0,
     *        -1,-1,-1,-1, 1, 0,
     *         0, 0, 0, 0, 0, 1/
c      call wtvctrr('ei=',ei,6)
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
             do k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)/5
          end do
         else if (j.eq.5) then
             fi(5)=ei(6)
             fi(6)=0
         end if
      end do
c      call wtvctrr('fi=',fi,6)
      return
      end

      subroutine tr6to5i(ei,fi)
      integer fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1,0,0,0,-1,0,
     *         0,1,0,0,-1,0,
     *         0,0,1,0,-1,0,
     *         0,0,0,1,-1,0,
     *         1,1,1,1, 1,0,
     *         0,0,0,0, 0,1/
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
            do k=1,5
               fi(j)=fi(j)+sd(k,j)*ei(k)
            end do
         else if (j.eq.5) then
            fi(5)=ei(6)
            fi(6)=0
         end if
      end do
      return
      end

      subroutine tr5to6e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1,0,0,0,-1,0,
     *         0,1,0,0,-1,0,
     *         0,0,1,0,-1,0,
     *         0,0,0,1,-1,0,
     *         0,0,0,0, 0,1,
     *         0,0,0,0, 0,0/
      call mtmplmnoir(sd,ei,fi,6,6,1)
c      do j=1,6
c         fi(j)=0.
c         do k=1,5
c             fi(j)=fi(j)+sd(j,k)*ei(k)
c          end do
c      end do
      return
      end

      subroutine tr7to5e(ei,fi)
c       for dodecagonal      
      real fi(*),ei(*)
      integer sd(7,7)
      data sd / 0, 1, 0, 0, 0,-1, 0,
     *          1, 0, 1, 0, 0, 0, 0,
     *          0, 1, 0, 1, 0, 0, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/
c      data sd/ 2, 0, 1, 0,-1, 0, 0,
c     *         0, 2, 0, 1, 0,-1, 0,
c     *         1, 0, 2, 0, 1, 0, 0,
c     *         0, 1, 0, 2, 0, 1, 0,
c     *         1, 0,-1, 0, 1, 0, 0,
c     *         0, 1, 0,-1, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 0, 1/
c      do 12 j=1,7
      do 12 j=1,6
         fi(j)=0.
         if(j.le.4) then
             do 13 k=1,6
             fi(j)=fi(j)+sd(k,j)*ei(k)
c            fi(j)=fi(j)+sd(k,j)*ei(k)/3
 13          continue
         else if (j.eq.5) then
             fi(5)=ei(7)
             fi(6)=0
         end if
 12   continue
      return
      end

      subroutine tr7to5i(ei,fi)
c       for dodecagonal      
      integer fi(*),ei(*)
      integer sd(7,7)
      data sd / 1, 0, 0, 0,-1, 0, 0,
     *          0, 1, 0, 0, 0,-1, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          0, 0, 0, 1, 0, 1, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/     
c      do 12 j=1,7
      do 12 j=1,6
         fi(j)=0.
         if(j.le.4) then
         do 13 k=1,6
            fi(j)=fi(j)+sd(k,j)*ei(k)
 13      continue
         else if (j.eq.5) then
             fi(5)=ei(7)
             fi(6)=0
         end if
 12   continue
      return
      end

      subroutine rtors(brv)
c     transformation of symmetry operators
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      real rc(6,6),rd(6,6),td(6)
      integer trm2
      common /ctrm/ trm1(6,6),trm2(6,6)
      common /cinnn/ innn
      do in=1,innn
         do ns=1,nsymo
            call mtmplri6(trm1,rr(1,1,ns),rc)
            call mtmplmnor(trm1,tt(1,ns),td,6,6,1)
            call mtmplri6(rc,trm2,rd)
            do i=1,6
               do j=1,6
                  rr(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
               end do
               tt(i,ns)=mod(td(i),1.)
            end do
         end do
      end do
      call wtsmop(rr,tt,nsymo,3,3)
      return
      end

      subroutine rstor(brv)
c     transformation of symmetry operators
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer rc(6,6)
      real rd(6,6),td(6)
      integer trm2
      common /ctrm/ trm1(6,6),trm2(6,6)
      common /cinnn/ innn
      do in=1,innn
         do ns=1,nsymo
            call mtmpli6(trm2,rr(1,1,ns),rc)            
            call mtmplmnoir(trm2,tt(1,ns),td,6,6,1)
            call mtmplir6(rc,trm1,rd)            
            do i=1,6
               do j=1,6
                  rr(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
               end do
               tt(i,ns)=mod(td(i),1.)
            end do
         end do
      end do
      call wtsmop(rr,tt,nsymo,3,3)
      return
      end

      subroutine setiski()
      common /ciski/ iski(0:120)
      integer rd(6,6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      iski(0)=nsymo
      do i=1,nsymo
         do j=1,nsymo
            call mtmpli6(rr(1,1,i),rr(1,1,j),rd)
            if(identm(rd).eq.1) then
               iski(i)=j
               go to 200
            end if
         end do
         call quit('error in invisk')
 200     continue
      end do
      do i=1,nsymo
         iski(i+nsymo)=iski(i)+nsymo
      end do
      write(6,*) 'inverse operators'
      write(6,'(a,20i3/(5x,20i3))') 'iski=',
     *     (iski(j),j=1,nsymo*(1+abs(icent)))
      return
      end

      subroutine getiski(iskid)
      integer iskid(0:120)
      common /ciski/ iski(0:120)
      integer getnsym,geticnt
      nsymo=getnsym()
      icent=geticnt()
c     do i=0,nsymo*(1+icent)
      do i=0,nsymo*(1+abs(icent))
         iskid(i)=iski(i)
      end do
      return
      end

      subroutine gettrq(trq,itc) ! q space component of itc-th non-primitiv translation
      real trq(*)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      call getqed(trc(1,itc),trq) ! under phason
      return
      end

      subroutine addhrryi(hr,ry,rx,itc)  ! for icosahedral
      real hr(*),ry(*),rx(*)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      real rz(6)
      character brv
      call getbrv(brv)
c      if(brv.eq.'p'.or.brv.eq.'f'.or.brv.eq.'s') then
      if(brv.eq.'p') then
         call vsumr(hr,ry,rx,6)
      else if(brv.eq.'f'.or.brv.eq.'s') then
         call vsumr(hr,ry,rz,6)
         call vsumr(rz,trc(1,itc),rx,6)
c         call wtvctrr('trc(1,itc)=',trc(1,itc),6)
c         call wtvctrr('rx=',rx,6)
      else if(brv.eq.'g') then
         call gethrx(ry,rx,itc,0)  ! ????
         call vsumr(rx,hr,rz,6)
         call vsumr(rz,trc(1,itc),rx,6)
      end if
      return
      end

      subroutine addhrryd(hr,ry,rx,itc,ihd)  ! for dihedral
      real hr(*),ry(*),rx(*)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      real rz(6)      
      character brv
      call getbrv(brv)
      if(brv.eq.'p') then
         call vsumr(ry,hr,rx,6)
      else if(brv.eq.'s') then
         call vsumr(ry,hr,rx,6)
      else if(brv.eq.'c') then
         call vsumr(ry,hr,rx,6)
         if(ihd.eq.1) then
            rx(5)=rx(5)+0.5     ! antisymmetric centering
            rx(6)=-rx(6)        ! antisymmetric centering
         end if
      else if(brv.eq.'f') then
         call vsumr(ry,hr,rx,6)
      else if(brv.eq.'g') then
         call gethrx(ry,rz,itc,0)
         call vsumr(rz,hr,rx,6)
      end if
      return
      end

      integer function mpltblv(i,j)
      common /cmpltbl/ mpltbl(120,120)
      mpltblv=mpltbl(i,j)
      return
      end

      subroutine setmpltbl()    ! set multiplication table for symm. op.
      common /cmpltbl/ mpltbl(120,120)
      integer rd(6,6)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do i=1,nsymo
         do j=1,nsymo
            call mtmpli6(rr(1,1,i),rr(1,1,j),rd)
            mpltbl(i,j)=identm1(rd)
         end do
      end do
      if(icent.eq.1) then
         do i=1,nsymo
            do j=1,nsymo
               mpltbl(i,j+nsymo)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j+nsymo)=mpltbl(i,j)
            end do
         end do
      end if
      write(6,*) 'multiplication table of symmetry operators'
      do i=1,nsymo
         write(6,'(60i3)')
     *        (mpltbl(i,j),j=1,nsymo)
      end do
      return
      end

      function identm(rr)
      integer rr(6,6)
c      if rr is identity matrix identm=1 else 0
      identm=0
      do i=1,6
         do j=1,6
            if(i.eq.j) then
               if(rr(i,i).ne.1) return
            else
               if(rr(i,j).ne.0) return
            end if
         end do
      end do
      identm=1
      return
      end
            
      function identm1(rr)
      integer rr(6,6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
c     if rr is identity matrix identm=1 else 0
      identm1=0
      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(rr(i,j).ne.r(i,j,ns)) goto 10
            end do
         end do
         identm1=ns
         return
 10      continue
      end do

      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(-rr(i,j).ne.r(i,j,ns)) goto 20
            end do
         end do
         identm1=ns+nsymo
         return
 20      continue
      end do
      return
      end
