      subroutine setitempfi(itempfid)
      integer itempfid(*)
      include 'qcstrc.inc'
      common /citempfi/ itempfi(namax)
      integer getna
      na=getna()
      call vcpyi(itempfid,itempfi,na)
      return
      end

      subroutine setitempfi0()
      include 'qcstrc.inc'
      common /citempfi/ itempfi(namax)
      integer getna
      na=getna()
      call zerovi(itempfi,na)
      return
      end

      integer function getitempfi(n)
      include 'qcstrc.inc'
      common /citempfi/ itempfi(namax)
      getitempfi=itempfi(n)
      return
      end

      integer function getitempf()         ! get itempf
      integer pcol,dspmdl,tmpmdl,sctmdl
      common /jobctl/ sctmdl,itempf,itwin,iphfl,volr(48)
      getitempf=itempf
      return
      end

      subroutine setitempf(itempfd)
      integer pcol,dspmdl,tmpmdl,sctmdl
      common /jobctl/ sctmdl,itempf,itwin,iphfl,volr(48)
      itempf=itempfd
      return
      end

      subroutine setbia(id,biad)   ! overall random phason temperature factors
      include 'qcstrc.inc'
      common /cbia/ bia(idsmax)
c     write(6,*) 'id,setbia=',id,biad
      bia(id)=biad
      return
      end

      function getbia(id)   ! overall random phason temperature factors
      include 'qcstrc.inc'
      common /cbia/ bia(idsmax)
      getbia=bia(id)
      return
      end

      function gettmpf(n,hr,b,biat,dtmpf)  ! calculate Debye-Waller factors
      real q(6)
      ! b(1) isotropic temperature factor
      ! b(2) anisotropic phason temperature factor for dihedral
      ! b(3) isotropic phason temperature factor *** not used
      ! b(4)-b(9) anisotropic thermal parameters
      ! biat overall phason temperature factor
      ! n QD number
      real qe,qi,b(*),biat,dtmpf(*)
      integer hr(*)
      integer getitempfi
      itempf=getitempfi(n)  ! temperature factor for n-th atom
      call getqi(hr,q)
      call getsys(isys)
      if(isys.le.2) then
         qe=vabs(q,3)
         qi=vabs(q(4),3)
      else
         qe=vabs(q,3)
         qi=vabs(q(4),2)
      end if
      q12=q(1)**2+q(2)**2-q(3)**2
      if(itempf.eq.0) then
         t1=exp(-(b(3)+biat)*qi**2/4) ! phason Debye-Waller factor
         tmpf=exp(-b(1)*qe**2/4-b(2)*q12/4)*t1
                                ! isotropic phonon  Debye-Waller factor
         dtmpf(1)=-qe**2/4*tmpf
         dtmpf(2)=-q12/4*tmpf
         dtmpf(3)=-qi**2/4*tmpf
      else
         t1=exp(-(b(3)+biat)*qi**2/4) ! phason Debye-Waller factor
         tmpf=ansdwf(n,hr,b(4),dtmpf(4))*t1
                                ! anisotropic phonon Debye-Waller factor
         dtmpf(3)=-qi**2/4*tmpf
         do j=4,9
            dtmpf(j)=dtmpf(j)*t1
         end do
      end if
      gettmpf=tmpf
      return
      end

      subroutine getuixynr(n,uixy) ! get uixy for n-th OD and rotate
      real uixy(*)
      call getuixyn(n,uixy)    ! get ui in external space
c      call wtvctrrf('uixy in getuixynr=',uixy,6,'(6f10.5)')
      call getnsic(ns,ic)      ! current symmetry operator
c      write(6,*) 'ns,ic=',ns,ic
      call getruirt(uixy,ns,ic) ! rotated uij in external space
c      call wtvctrrf('uixy after rotation=',uixy,6,'(6f10.5)')
      return
      end

      subroutine setuixy(na)
      include 'qcstrc.inc'
      common /cuinxy/ uixy(6,namax)
      real uixyd(6)
      write(6,*) 'enter setuixy'
      do n=1,na
c         call getuixyn0(n,uixyd)  ! calculate uixy for independent OD
c         write(6,*) 'after getuixyn0'
c         write(6,*) 'uixyd=',uixyd
c         call wtvctrrf('uixy in setuixy=',uixyd,6,'(6f10.5)')
         call vcpyr(uixyd,uixy(1,n),6)
      end do
      return
      end

      subroutine getuixyn(n,uixyd)
      real uixyd(*)
      include 'qcstrc.inc'
      common /cuinxy/ uixy(6,namax)
      call vcpyr(uixy(1,n),uixyd,6)
      return
      end

      subroutine getuixyn0(n,uixy)
      real uixy(6)
c     temperature factor for independent OD in cubic coordinate

c     this give ui of n-th OD in cubic coordinate system
c     from ui in xe1,xe2,xe3 axis coordinate system which is used
c     in the structure factor calculation
c     xe1,xe2,xe3 : axies coordinates of shift and anisotropic temperature
c     factor for n-th OD. in the refinement program, indivisual
c     coordinate system is used because the principal axes of anisotropic
c     temperature factor is usually along 5-fold or 3-fold axes while
c     axes in cubic coordinate system are along 2-fold axes.
      real ui0(6),uij0(3,3)
      real bi0(6),bij0(3,3),bijxy(3,3)
      real bijxyp(3,3),bixyp(6)
      call getui(n,ui0)
      call getuitobi(n,ui0,bi0)   ! translate ui to bi
      call getuitouij(bi0,bij0)   ! translate bi to bij
      call wtvctrrf('ui0=',ui0,6,'(6f10.5)')
      call wtvctrrf('bi0=',bi0,6,'(6f10.5)')
      call wtmtrxrf('bij0',bij0,3,'(3f10.5)')  ! for test
      call anisotmp(n,bij0,bijxy)   ! transformation of ui to ui in q system
      call wtmtrxrf('bijxy',bijxy,3,'(3f10.5)')  ! for test
      call getuijtoui(bijxy,bixy)  ! bi in q coordinate system
c      write(6,*) 'bixy=',bixy
c      call zerov(uixy,6)
      call getbitouixy(bixy,uixy)  ! ui in q coordinate system
      call wtvctrrf('uixy',uixy,6,'(6f10.5)')  ! for test
      write(6,*) 'after getbitouixy'
c     ui   : anisotropic temperature factor in xe1,xe2,xe3 axis system
c     uixy : ui in the external space coordinate system (q system)
c     uixyp : ui in the plotter coordinate system
      return
      end

      subroutine anisotplt(bijxy,bijxyp)
c     transformation uixy in q system into that in plotter system
      common /corntm/ orntm(3,3) ! orientation matrix for uijxy
      real bijxy(3,3),bijxyp(3,3)
c     call wtmtrxrf('orntm',orntm,3,'(3f10.5)')
      call getrbijrt(orntm,bijxy,bijxyp)  ! get bij in plotter coordinate system
      return
      end

      subroutine getrbijrt(r,bijxy,bijxyp)  ! get bij in plotter coordinate system
      real r(3,3),bijxy(3,3),bijxyp(3,3)
      real bijxyrt(3,3)
      real rt(3,3)
c      call wtmtrxrf('r',r,3,'(3f10.5)')
      call mcpyr(r,rt,3)          ! copy r into rt
      call trnspr3(rt)             ! take transpose
c      call wtmtrxrf('rt',rt,3,'(3f10.5)')
      call mtmplr3(bijxy,rt,bijxyrt) ! calculate transformed anisotropic tempf.
c      call wtmtrxrf('bijxyrt',bijxyrt,3,'(3f10.5)')
      call mtmplr3(r,bijxyrt,bijxyp) ! bij in q coordinate system
c      call wtmtrxrf('bijxyp',bijxyp,3,'(3f10.5)')
      return
      end
      
      subroutine anisotmp(n,bij0,bijxy) ! anisotropic temperature fact.
      real bij0(3,3),bijxy(3,3)
c     this transforms
c     anisotropic temp. fact. ui0 determined in the coordinate
c     system with axes xe1,xe2,xe3 into that of common coordinate system
c     (q coordinate system)
c     xe1,xe2,xe3 are coordinates of axes in the common coordinate system
      real qt(3,3)              ! transpose matrix of Q (Sakurai p233,239)
      real q1(6),q2(6),q3(6)
      real gab(3,3)
      call getqe123(n,q1,q2,q3)  ! get axes used in anso tmp. factor
      if(ifzerovr(q1,3).eq.1.or.ifzerovr(q2,3).eq.1.and.
     *     ifzerovr(q3,1).eq.1) then
         call zerovr(q1,3)
         call zerovr(q2,3)
         call zerovr(q3,3)
         q1(1)=1
         q2(2)=1
         q3(3)=1
      end if
c     call wtvctrrf('q1=',q1,3,'(3f10.5)')
c     call wtvctrrf('q2=',q2,3,'(3f10.5)')
c     call wtvctrrf('q3=',q3,3,'(3f10.5)')
      call getqt(q1,q2,q3,qt)
      call calgab(q1,q2,q3,gab)   ! for test
      call wtmtrxrf('gab',gab,3,'(3f10.5)')  ! for test
      call getqtbijq(qt,bij0,bijxy)
      return
      end

      subroutine getqt(q1,q2,q3,qt)
      real q1(*),q2(*),q3(*),qt(3,3)
      call vcpyr(q1,qt(1,1),3)
      call vcpyr(q2,qt(1,2),3)
      call vcpyr(q3,qt(1,3),3)
      return
      end

      subroutine getqtbijq(qt,bij0,bijxy)  ! get bij in q coordinate system
      real qt(3,3),bij0(3,3),bijxy(3,3)
      real bij0q(3,3)
      real q(3,3)                 ! matrix Q (Sakurai p233)
      real qtq(3,3)
      call mcpyr(qt,q,3)          ! copy qt into q
      call trnspr3(q)             ! take transpose
      call mtmplr3(qt,q,qtq)
      call mtmplr3(bij0,q,bij0q) ! calculate transformed anisotropic tempf.
      call mtmplr3(qt,bij0q,bijxy) ! bij in q coordinate system

c      call wtmtrxrf('qt',qt,3,'(3f10.5)')
c      call wtmtrxrf('q',q,3,'(3f10.5)')
c      call wtmtrxrf('qtq',qtq,3,'(3f10.5)')
c      call wtmtrxrf('bij0',bij0,3,'(3f10.5)')
c      call wtmtrxrf('bij0q',bij0q,3,'(3f10.5)')
c      call wtmtrxrf('bijxy',bijxy,3,'(3f10.5)')
      return
      end

      subroutine getbitouixy(bi,uixy)
      real bi,uixy(*)
      data pi /3.141592/
      do i=1,6
         uixy(i)=bi/(2*pi**2)  ! bi to uixy
      end do
      return
      end

      subroutine getuixytobi(uixy,bi)
      real uixy(*),bi(*)
      data pi /3.141592/
      do i=1,6
         bi(i)=uixy(i)*(2*pi**2)  ! uixy to bixy
      end do
      return
      end

      function ansdwf(id,hr,b,dtmpf) ! anisotoropic DW factor
      integer hr(*)
      real b(*),dtmpf(*)        ! b(1)-b(6) : u11,u22,u33..,u12
      include 'qcstrc.inc'
      integer id ! occupation domain number
      real qr(6)
      call getf123(id,hr,q1,q2,q3)
      ansdwf=ansdwf0(id,q1,q2,q3,b,dtmpf)
      return
      end

      function ansdwf0(id,q1,q2,q3,ui,dtmpf) ! anisotoropic DW factor
      real ui(*),dtmpf(*)
      include 'qcstrc.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      real ec(6)
      call vcpyr(ect(1,id),ec,6)
      sum=-ui(1)*q1*q1*ec(1)-ui(2)*q2*q2*ec(2)-ui(3)*q3*q3*ec(3)
     *     -2*(ui(4)*q2*q3*ec(4)+ui(5)*q1*q3*ec(5)+ui(6)*q1*q2*ec(6))
      tmpf=exp(sum)
c     derivatives of ansdwf with respect to ui(1),..,ui(6)
      dtmpf(1)=-q1*q1*ec(1)*tmpf  ! dansdwf/dq1 etc
      dtmpf(2)=-q2*q2*ec(2)*tmpf
      dtmpf(3)=-q3*q3*ec(3)*tmpf
      dtmpf(4)=-2*q2*q3*ec(4)*tmpf
      dtmpf(5)=-2*q1*q3*ec(5)*tmpf
      dtmpf(6)=-2*q1*q2*ec(6)*tmpf
      ansdwf0=tmpf
      return
      end

      function getbeq(n,ui)
      real ui(*)
c     ui(1): u11, ui(2): u22, ... ui(6): u12
      include 'qcstrc.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      getbeq=0
      do i=1,3
         getbeq=getbeq+ui(i)*ebt(i,n)
      end do
      do i=4,6
         getbeq=getbeq+ui(i)*ebt(i,n)*2
      end do
      return
      end

      subroutine getuijtoui(uij,ui)
      real uij(3,3),ui(6)
      ui(1)=uij(1,1)
      ui(2)=uij(2,2)
      ui(3)=uij(3,3)
      ui(4)=uij(2,3)
      ui(5)=uij(3,1)
      ui(6)=uij(1,2)
      return
      end

      subroutine getuitouij(ui,uij)
      real ui(6),uij(3,3)
      uij(1,1)=ui(1)
      uij(2,2)=ui(2)
      uij(3,3)=ui(3)
      uij(2,3)=ui(4)
      uij(3,2)=ui(4)
      uij(3,1)=ui(5)
      uij(1,3)=ui(5)
      uij(1,2)=ui(6)
      uij(2,1)=ui(6)
c      do i=1,3
c         write(6,*) (uij(i,j),j=1,3)
c      end do
      return
      end

      subroutine getbtoui(n,be,ui) ! iso B into uij
      real ui(*)
      include 'qcstrc.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      do i=1,6
         ui(i)=eat(i,n)*be
      end do
      return
      end

      subroutine getbtobi(n,be,bi) ! iso B into uij
      real bi(*)
      include 'qcstrc.inc'
      common /cedt/ edt(6,namax),eet(6,namax),eft(6,namax)
      do i=1,6
         bi(i)=edt(i,n)*be
      end do
      return
      end

      subroutine getbitoui(n,bi,ui) ! bij into uij
      real bi(*),ui(*)
      include 'qcstrc.inc'
      common /cedt/ edt(6,namax),eet(6,namax),eft(6,namax)
      do i=1,6
         ui(i)=eet(i,n)*bi(i)
      end do
      return
      end

      subroutine getuitobi(n,ui,bi) ! uij to bij
      real ui(*),bi(*)
      include 'qcstrc.inc'
      common /cedt/ edt(6,namax),eet(6,namax),eft(6,namax)
      do i=1,6
         bi(i)=eft(i,n)*ui(i)
      end do
      return
      end

      subroutine getqe123(n,q1,q2,q3)  ! get axes used in anso tmp. factor
      real q1(*),q2(*),q3(*)
      real xe1(6),xe2(6),xe3(6)
      integer getitempf
      data eps /0.00001/
c     write(6,*) '********',n,'**********'
      if(getitempf().eq.0) then
         return
      end if
      call getxe123(n,xe1,xe2,xe3) ! get xe1,xe2,xe3 for n-th OD
c      if(ifzerovr(xe1,3).eq.1.or.
c     *     ifzerovr(xe2,3).eq.1.or.ifzerovr(xe2,3).eq.1) then
c         write(6,*) 'For OD No. ',n
c         write(6,*) 'non zero xe1 xe2 xe3 should be given',
c     *        ' for aniso temp. fac.'
c         call quit('n')
c      end if
      call getqe(xe1,q1)
      call getqe(xe2,q2)
      call getqe(xe3,q3)
      if(abs(vinpr(q1,q2,3)).lt.eps) then ! orthogonal
         call vprdr(q1,q2,q3)   ! q3 : vector product of q1 and q2
         call norml(q3,3)       ! normalize q3 to make sure
         call zerovr(q3(4),3)   ! q3(4),q3(5),a3(6)=0
      else
         call getqe(xe3,q3)
      end if
      return
      end

      integer function iftwozerov(q1,q2,q3)
      real q1(3),q2(3),q3(3)
      iftwozerov=0
      nzero=0
      if(ifzerovr(q1,3).eq.1) then
         nzero=nzero+1
      end if
      if(ifzerovr(q2,3).eq.1) then
         nzero=nzero+1
      end if
      if(ifzerovr(q3,3).eq.1) then
         nzero=nzero+1
      end if
      if(nzero.ge.2) then
         iftwozerov=1
      end if
      return
      end

      subroutine btouij(na)   ! calculation of transformation coeff.
      include 'qcstrc.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      common /cedt/ edt(6,namax),eet(6,namax),eft(6,namax)
      real xe1(6),xe2(6),xe3(6)
      real gab(3,3,namax)   ! metric tensor for each domain
      real gabn(3,3,namax)  ! reciprocal metric tensor for each domain
      real b(3)             ! for matinv

      integer j1(6),j2(6)
      real q1(6),q2(6),q3(6)
      real abccosd(6),abccosr(6)  ! lattice const. in direct and reciprocal sp.
      data j1/1,2,3,2,3,1/, j2/1,2,3,3,1,2/
      data pi /3.141592/
      data eps /0.000001/

c     eat for anisotropic temperature factor
      nonorth=0
      do n=1,na
         call getqe123(n,q1,q2,q3)  ! get axes used in anso tmp. factor
         if(iftwozerov(q1,q2,q3).eq.1) then
            call unitmtrxr(gab(1,1,n),3) ! get unit matrix
         else
            call calgab(q1,q2,q3,gab(1,1,n)) ! cal. metric tensor gab
         end if
c        call calgab(q1,q2,q3,gab(1,1,n))  ! cal. metric tensor gab
         call mcpyr(gab(1,1,n),gabn(1,1,n),3)
         call matinv3(gabn(1,1,n),b,0,det)
         if(det.lt.eps) then
            write(6,*) 'In OD No. ',n
            call quit('1 or 2 vectors are not independent')
         end if
                                ! metric tensor for n-th OD
         call getabc(gab(1,1,n),abccosd)
         call getabc(gabn(1,1,n),abccosr)
c         call wtmtrxrf('gab',gab(1,1,n),3,'(3f10.5)')
c         call wtmtrxrf('gabn',gabn(1,1,n),3,'(3f10.5)')
         if(iforthg(abccosd).eq.0) then
            nonorth=nonorth+1
            if(nonorth.eq.1) then
               write(6,'(2a)') 'non-orthogonal axes used in',
     *              ' anisotropic temp. fac.'
            end if
            fct=180.0/pi
            write(6,'(a,i3,6f7.2)') 'OD No,alpha,beta,gamma=',n,
     *           acos(abccosd(4))*fct,acos(abccosd(5))*fct,
     *           acos(abccosd(6))*fct
         end if
      end do

      do n=1,na 
         do j=1,6
            k=j1(j)
            l=j2(j)
            gkk=gabn(k,k,n)
            gll=gabn(l,l,n)
            ect(j,n)=(8*pi**2)*sqrt(gkk*gll)       ! factor
            eat(j,n)=gabn(k,l,n)/ect(j,n)/4          ! b to ui
            ebt(j,n)=4.0/3*gab(k,l,n)*ect(j,n)       ! ui to b
            edt(j,n)=gabn(k,l,n)/4                   ! b to bi
            eet(j,n)=1.0/(2*pi**2*sqrt(gkk*gll))     ! bi to ui
            eft(j,n)=2*pi**2*sqrt(gkk*gll)           ! ui to bi
         end do
c         call wtvctrrf('eet=',eet(1,n),6,'(6f10.5)')
c         call wtvctrrf('eft=',eft(1,n),6,'(6f10.5)')
      end do
      return 
      end

      subroutine checkxe123(n)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      if(ifzerovr(xe1(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe1 should not be zero vector for aniso temp f.')
      end if
      if(ifzerovr(xe2(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe2 should not be zero vector for aniso temp f.')
      end if
      if(ifzerovr(xe3(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe3 should not be zero vector for aniso temp f.')
      end if
      return
      end
      
      subroutine getq123(n,q,q1,q2,q3)
      real q(*)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call checkxe123(n)
      call getqe(xe1(1,n),x1)
      call getqe(xe2(1,n),x2)
      call getqe(xe3(1,n),x3)
      q1=vinpr(q,x1,3)
      q2=vinpr(q,x2,3)
      q3=vinpr(q,x3,3)
c     write(6,*) 'q1,q2,q3 in getq123',q1,q2,q3
      return
      end 

      subroutine getf123(n,hr,q1,q2,q3)  ! for temperature factor
      integer hr(*)
      call checkxe123(n)
      call gethrx123(n,hr,q1,q2,q3)
c      write(6,*) 'q1,q2,q3 in getf123',q1,q2,q3
      return
      end 

      subroutine gethrx123(n,hr,q1,q2,q3)
      integer hr(*)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real qr(6),qe1(6)
      q1=vinpir(hr,xe1(1,n),6)
      q2=vinpir(hr,xe2(1,n),6)
      q3=vinpir(hr,xe3(1,n),6)
c      write(6,*) 'hr=',(hr(j),j=1,6)
c      write(6,*) 'xe1=',(xe1(j,n),j=1,6)
      call getqi(hr,qr)
c      write(6,*) 'qr=',(qr(j),j=1,6)
      call getqe(xe1(1,n),qe1)
c      write(6,*) 'qe1=',(qe1(j),j=1,6)
      return
      end 

      subroutine getruirt(uixy,ns,ic)  ! aniso tempf for rotated atoms
      real uixy(*)  ! ui in the common orthogonal system (q system)
c     rotation of anisotropic temp. fact. uij in physical space
c     symmetric tensor does not depend on inversion
c     rotation matrix depends on OD in this case
      common /symext1/ re(3,3,60),te(3,60)
c     Sakurai P 241, eq (5.5-7)
      real uij(3,3),m1(3,3),ret(3,3)
      call mcpyr(re(1,1,ns),ret,3)
      call trnspr3(ret)
c     uij times rei transpose
c      call wtvctrrf('uixy=',uixy,6,'(6f10.5)')
      call getuitouij(uixy,uij)   ! get uij from ui
      call mtmplr3(uij,ret,m1)
c      call wtmtrxrf('ret',ret,3,'(3f10.5)')
c      call wtmtrxrf('uij',uij,3,'(3f10.5)')
c      call wtmtrxrf('m1',m1,3,'(3f10.5)')
c     uij= ret*uij*re 
      call mtmplr3(re(1,1,ns),m1,uij)
c      call wtmtrxrf('uij',uij,3,'(3f10.5)')
      call getuijtoui(uij,uixy)   ! get ui from uij
c      call wtvctrrf('uixy',uixy,6,'(6f10.5)')
      return
      end

