c
c
c
c       fast Fourier transformation by Y. Onoda
c
c
c
c
      subroutine rftr
      common /adt/iw,in,ad(1024,2),cd(2048),s(1024),nd,md,t0,t1,cf,
     1apm,bpm,attl(60),asmpl,adat,ancl,aprg,xt,xf,dxf,xh,dxh,pw,pgn,
     2mat,bw,tvn,tsp,trl,lirc,lfrc,nip,nut,ifn,iq,flninp,flnout
      common /prm0/yad1(512),yad2(512),yad3(512),yad4(512),yprm(2),
     1yatl
      character*1 attl
      character*4 pgn
      character*8 aprg,ancl
      character*12 adat,flninp,flnout
      character*13 yad1,yad2,yad3,yad4
      character*20 asmpl
      character*120 yprm,yatl
      real*8 pn,s,w1,w2
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   nd; data point  nd=iw                                    c
c   md; bit number                                           c
c   fs; x-axis full scale   fs=1000.0/(2*ts) khz             c
c   ( nyquist's sampling theorem :  n = 2*fs*t, t=n*ts )     c
c   ts; sampling interval  (microsec)                        c
c   resolution;  df(hz) = 1/(ts*iw)                          c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      iq=1
c=================  input fft parameter  ===================
   99 write(*,100)
  100 format(/1h ,20(1h=),'  fft menu  ',20(1h=),/1h ,
     1'normal fft, exponential factor = -1.0  ',10(1h-),'  1',/1h ,
     3'normal fft, variable exponential filter  ',8(1h-),'  2',/1h ,
     5'menu no. = ',\)
      read(*,1) ip
    1 format(i1)
      ss=1.0
      if(ip.ne.1) go to 101
      cf=-1.0
      go to 105
  101 write(*,103)
  103 format(1h ,'input exponential filter (f10.0)',/1h ,5x,
     1'cf>0.0; s/n decreases, but resolution increases.',/1h ,5x,
     2'cf<0.0; s/n increases, but resolution decreases.',/1h ,
     3'cf = ',\)
      read(*,5) cf
    5 format(f10.0)
  105 continue
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ss=1.0; normal ft.   ss=-1.0; inverse ft             c
c     cf; exponential filter                               c
c         +; s/n decreases but resolution increses         c
c         -; s/n increases but resolution decreases        c
c         usually cf=-1.0                                  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      n=iw
      n2=iw/2
      n4=n2/2
      n41=n4-1
      pn=2.0d0*3.1415926535898d0/n
      an2=float(n2)
      write(*,106)
  106 format(/1h ,5(1h=),2x,'fft calculation has started ',
     1'  wait for 8 sec.  ',5(1h=))
c ==========  exponential filter  ==========
      asum=0.0
      bsum=0.0
      ncn=n2-224
      do 10 i=1,200
      asum=asum+ad(ncn+i,1)
      bsum=bsum+ad(ncn+i,2)
   10 continue
      asum=asum/200.
      bsum=bsum/200.
      do 12 i=1,n2
      ad(i,1)=ad(i,1)-asum
      ad(i,2)=ad(i,2)-bsum
   12 continue
      cf=-1.0
      n16=n/16
      anw=float(n16)
      do 14 i=1,n2
      ac=cf*float(i)/an2
      efl=exp(ac)
      ad(i,1)=ad(i,1)*efl
      ad(i,2)=ad(i,2)*efl
      n26=n2-n16
      if(i.le.n26) go to 14
      n2i=n2-i
      pc=float(n2i)/anw
      ad(i,1)=ad(i,1)*pc
      ad(i,2)=ad(i,2)*pc
   14 continue
      do 16 i=1,n2
      l1=2*i-1
      l2=l1+1
      cd(l1)=ad(i,1)
      cd(l2)=ad(i,2)
   16 continue
c ===========  calculation of trigonometric functions  ==========
      write(*,107)
  107 format(1h ,'calculation of trigonometric functions')
      do 18 i=1,n41
      s(i)=dsin(pn*i)
   18 continue
c ==========  fourier transformation  ==========
      write(*,108)
  108 format(1h ,'fourier transformation')
      do 20 j=1,n2
      ad(j,1)=cd(j)+cd(j+n2)
      ad(j,2)=cd(j)-cd(j+n2)
   20 continue
      do 30 j=1,n2
      cd(2*j-1)=ad(j,1)
      cd(2*j)=ad(j,2)
   30 continue
      nps=n4
      m2s1=1
      do 110 l=1,10
      m2s=2*m2s1
      m2s11=m2s1-1
      do 50 j=1,nps
      j1=m2s*(j-1)+1
      j2=j1+m2s1
      j3=j1+n2
      j4=j3+m2s1
      ad(j1,1)=cd(j1)+cd(j3)
      ad(j1,2)=cd(j1)-cd(j3)
      ad(j2,1)=cd(j2)
      ad(j2,2)=cd(j4)
      if(l.eq.1) go to 50
      do 40 k=1,m2s11
      w1=cd(j3+k)
      w2=cd(j4+k)
      v1=s(n4-nps*k)*w1-s(nps*k)*w2
      v2=s(nps*k)*w1+s(n4-nps*k)*w2
      ad(j1+k,1)=cd(j1+k)+v1
      ad(j1+m2s-k,1)=cd(j1+k)-v1
      ad(j1+k,2)=v2+cd(j2+k)
      ad(j1+m2s-k,2)=v2-cd(j2+k)
   40 continue
   50 continue
      do 70 j=1,nps
      j1=m2s*(j-1)
      j2=2*j1
      j3=j2+m2s
      do 60 k=1,m2s
      cd(j2+k)=ad(j1+k,1)
      cd(j3+k)=ad(j1+k,2)
   60 continue
   70 continue
      if(nps.eq.1) go to 120
      m2s1=m2s
      npsv=nps/2
      nps=npsv
  110 continue
  120 continue
      write(*,116)
  116 format(/1h ,5(1h=),2x,'fft calculation terminated  ',5(1h=))
      return
      end

      subroutine cftr
      common /adt/iw,in,ad(1024,2),cc(1024),cs(512),nd,md,t0,t1,cf,
     1apm,bpm,attl(60),asmpl,adat,ancl,aprg,xt,xf,dxf,xh,dxh,pw,pgn,
     2mat,bw,tvn,tsp,trl,lirc,lfrc,nip,nut,ifn,iq,flninp,flnout
      common /prm0/yad1(512),yad2(512),yad3(512),yad4(512),yprm(2),
     1yatl
      complex cc,w1,w2,cb(1024)
      complex*16 cs,pn,ccc
      character*1 attl
      character*4 pgn
      character*8 aprg,ancl
      character*12 adat,flninp,flnout
      character*13 yad1,yad2,yad3,yad4
      character*20 asmpl
      character*120 yprm,yatl
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   nd; data point  nd=iw                                    c
c   md; bit number                                           c
c   fs; x-axis full scale   fs=1000.0/(2*ts) khz             c
c   (nyquist's sampling theorem :  n = 2*fs*t,  t=n*ts )     c
c   ts; sampling interval  (microsec)                        c
c   resolution;  df(hz) = 1/(ts*iw)                          c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c=================  input fft parameter  ===================
      iq=2
   99 write(*,100)
  100 format(/1h ,20(1h=),'  fft menu  ',20(1h=),/1h ,
     1'normal fft, exponential factor = -1.0  ',10(1h-),'  1',/1h ,
     3'normal fft, variable exponential filter  ',8(1h-),'  2',/1h ,
     5'menu no. = ',\)
      read(*,1) ip
    1 format(i1)
      ss=1.0
      if(ip.ne.1) go to 101
      cf=-1.0
      go to 105
  101 write(*,103)
  103 format(1h ,'input exponential filter (f10.0)',/1h ,5x,
     1'cf>0.0; s/n decreases, but resolution increases.',/1h ,5x,
     2'cf<0.0; s/n increases, but resolution decreases.',/1h ,
     3'cf = ',\)
      read(*,5) cf
    5 format(f10.0)
  105 continue
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ss=1.0; normal ft.   ss=-1.0; inverse ft             c
c     cf; exponential filter                               c
c         +; s/n decreases but resolution increses         c
c         -; s/n increases but resolution decreases        c
c         usually cf=-1.0                                  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      n=iw/2
      n2=n/2
      n4=n2/2
      n41=n4-1
      pn=dcmplx(0.0d0,-2.0d0*3.1415926535898d0/n)
      an2=float(n)
      write(*,106)
  106 format(/1h ,5(1h=),2x,'fft calculation has started ',
     1'  wait for 8 sec.  ',5(1h=))
      asum=0.0
      bsum=0.0
      ncn=n2-224
      do 10 i=1,200
      asum=asum+ad(ncn+i,1)
      bsum=bsum+ad(ncn+i,2)
   10 continue
      asum=asum/200.
      bsum=bsum/200.
      do 12 i=1,n2
      ad(i,1)=ad(i,1)-asum
      ad(i,2)=ad(i,2)-bsum
   12 continue
c ==========  exponential filter  ==========
      cf=-1.0
      iw2=iw/2
      n16=iw/16
      anw=float(n16)
      do 14 i=1,iw2
      ac=cf*float(i)/an2
      efl=exp(ac)
      ad(i,1)=ad(i,1)*efl
      ad(i,2)=ad(i,2)*efl
      n26=n2-n16
      if(i.le.n26) go to 14
      n2i=n2-i
      pc=float(n2i)/anw
      ad(i,1)=ad(i,1)*pc
      ad(i,2)=ad(i,2)*pc
   14 continue
      do 15 i=1,n
      cc(i)=cmplx(ad(i,1),ad(i,2))
   15 continue
c ===========  calculation of trigonometric functions  ==========
      write(*,107)
  107 format(1h ,'calculation of trigonometric functions')
      do 18 i=1,n2
      cs(i)=cdexp(pn*(i-1))
   18 continue
c ==========  fourier transformation  ==========
      write(*,108)
  108 format(1h ,'fourier transformation')
      ls=1
      ll=2
      ln=n2
      do 120 l=1,12
      lnh=ln/2
      lsj=0
      llj=0
      do 20 j=1,ln
      w1=cc(lsj+1)
      w2=cc(lsj+n2+1)
      cb(llj+1)=w1+w2
      cb(llj+ls+1)=w1-w2
      lsj=lsj+ls
      llj=llj+ll
   20 continue
      if(ls.eq.1) go to 50
      lnk=ln
      do 40 k=2,ls
      ccc=cs(lnk+1)
      lsj=0
      llj=0
      do 30 j=1,ln
      w1=cc(lsj+k)
      w2=cc(lsj+n2+k)*ccc
      cb(llj+k)   =w1+w2
      cb(llj+ls+k)=w1-w2
      lsj=lsj+ls
      llj=llj+ll
   30 continue
      lnk=lnk+ln
   40 continue
   50 continue
      ls=ls+ls
      ll=ll+ll
      ln=lnh
      if(ln.eq.0) go to 130
      do 60 i=1,n
      cc(i)=cb(i)
   60 continue
  120 continue
  130 continue
      write(*,116)
  116 format(/1h ,5(1h=),2x,'fft calculation terminated  ',5(1h=))
      do 140 i=1,n
      ad(i,1)=real(cb(i))
      ad(i,2)=aimag(cb(i))
  140 continue
      return
      end
